	.module context_icc.c
	.area text(rom, con, rel)
	.even
_NutThreadEntry:
; /*
;  * Copyright (C) 2001-2005 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  */
; 
; /*
;  * $Log: context_icc.c,v $
;  * Revision 1.3  2005/10/04 05:17:15  hwmaier
;  * Added support for separating stack and conventional heap as required by AT09CAN128 MCUs
;  *
;  * Revision 1.2  2005/08/02 17:46:46  haraldkipp
;  * Major API documentation update.
;  *
;  * Revision 1.1  2005/07/26 18:10:49  haraldkipp
;  * Moved from os/thread.c
;  *
;  * Revision 1.2  2005/07/14 08:55:57  freckle
;  * Rewrote CS in NutThreadCreate
;  *
;  * Revision 1.1  2005/05/27 17:17:31  drsung
;  * Moved the file
;  *
;  * Revision 1.6  2005/04/30 16:42:42  chaac
;  * Fixed bug in handling of NUTDEBUG. Added include for cfg/os.h. If NUTDEBUG
;  * is defined in NutConf, it will make effect where it is used.
;  *
;  * Revision 1.5  2005/02/16 19:55:18  haraldkipp
;  * Ready-to-run queue handling removed from interrupt context.
;  * Avoid AVRGCC prologue and epilogue code. Thanks to Pete Allinson.
;  *
;  * Revision 1.4  2005/02/10 07:06:48  hwmaier
;  * Changes to incorporate support for AT90CAN128 CPU
;  *
;  * Revision 1.3  2004/09/22 08:15:56  haraldkipp
;  * Speparate IRQ stack configurable
;  *
;  * Revision 1.2  2004/04/25 17:06:17  drsung
;  * Separate IRQ stack now compatible with nested interrupts.
;  *
;  * Revision 1.1  2004/03/16 16:48:46  haraldkipp
;  * Added Jan Dubiec's H8/300 port.
;  *
;  * Revision 1.2  2004/02/18 16:32:48  drsung
;  * Bugfix in NutThreadCreate. Thanks to Mike Cornelius.
;  *
;  * Revision 1.1  2004/02/01 18:49:48  haraldkipp
;  * Added CPU family support
;  *
;  */
; 
; #include <cfg/os.h>
; #include <cfg/memory.h>
; 
; #include <string.h>
; 
; #include <sys/atom.h>
; #include <sys/heap.h>
; #include <sys/thread.h>
; 
; /*!
;  * \addtogroup xgNutArchAvrOsContextIcc
;  */
; /*@{*/
; 
; /*!
;  * \brief ICC AVR context switch frame layout.
;  *
;  * This is the layout of the stack after a thread's context has been
;  * switched-out.
;  */
; typedef struct {
;     u_char csf_r29;
;     u_char csf_r28;
;     u_char csf_r23;
;     u_char csf_r22;
;     u_char csf_r21;
;     u_char csf_r20;
;     u_char csf_r15;
;     u_char csf_r14;
;     u_char csf_r13;
;     u_char csf_r12;
;     u_char csf_r11;
;     u_char csf_r10;
;     u_char csf_pchi;
;     u_char csf_pclo;
; } SWITCHFRAME;
; 
; /*!
;  * \brief Thread entry frame layout.
;  *
;  * This is the stack layout being build to enter a new thread.
;  */
; typedef struct {
;     u_char cef_arghi;
;     u_char cef_arglo;
;     /*!
;      * \brief ImageCraft software stack.
;      */
;     u_char cef_yhi;
;     u_char cef_ylo;
;     u_char cef_rampz;
;     u_char cef_sreg;
;     u_char cef_r1;
;     u_char cef_pchi;
;     u_char cef_pclo;
; } ENTERFRAME;
; 
; 
; /*
;  * This code is executed when entering a thread.
;  */
; static void NutThreadEntry(void)
; {
;     asm("pop r17");             // first parameter for ICC
	pop r17
;     asm("pop r16");
	pop r16
;     asm("pop r29");             // SW-Stack; Y-Register
	pop r29
;     asm("pop r28");
	pop r28
;     asm("pop r0");              // r0 = _tmp_reg_
	pop r0
;     asm("out 0x3B, r0");        // RAMPZ; replace with define later
	out 0x3B, r0
;     asm("pop r0");
	pop r0
;     asm("pop r1");              // r1 = _zero_reg_
	pop r1
;     asm("out 0x3F, r0");        // SREG; replace with define later
	out 0x3F, r0
;     asm("reti");
	reti
L3:
	.dbline 0 ; func end
	ret
;              j -> R18
;              i -> R16
	.even
_NutThreadSwitch::
; }
; 
; /*!
;  * \brief Switch to another thread.
;  *
;  * Stop the current thread, saving its context. Then start the
;  * one with the highest priority, which is ready to run.
;  *
;  * Application programs typically do not call this function.
;  *
;  * \note CPU interrupts must be disabled before calling this function.
;  *
;  */
; void NutThreadSwitch(void)
; {
;     /*
;      * Save all CPU registers.
;      */
;     register u_char i = 0;
	clr R16
;     register u_char j = 0;
	clr R18
; 
;     asm("push r10");
	push r10
;     asm("push r11");
	push r11
;     asm("push r12");
	push r12
;     asm("push r13");
	push r13
;     asm("push r14");
	push r14
;     asm("push r15");
	push r15
;     asm("push r20");
	push r20
;     asm("push r21");
	push r21
;     asm("push r22");
	push r22
;     asm("push r23");
	push r23
;     asm("push r28");
	push r28
;     asm("push r29");
	push r29
;     asm("in %i, $3D");          // SPL
	in R16, $3D
;     asm("in %j, $3E");          // SPH
	in R18, $3E
; 
;     runningThread->td_sp = (((u_short) j) << 8) & 0xFF00 | (i & 0xFF);
	mov R24,R16
	clr R25
	andi R25,0
	mov R30,R18
	clr R31
	mov R31,R30
	clr R30
	andi R30,0
	movw R2,R30
	or R2,R24
	or R3,R25
	lds R30,_runningThread
	lds R31,_runningThread+1
	std z+15,R3
	std z+14,R2
; 
;     /*
;      * This defines a global label, which may be called
;      * as an entry point into this function.
;      */
;     asm(".globl thread_start");
	.globl thread_start
;     asm("thread_start:");
	thread_start:
; 
;     /*
;      * Reload CPU registers from the thread in front
;      * of the run queue.
;      */
;     runningThread = runQueue;
	lds R2,_runQueue
	lds R3,_runQueue+1
	sts _runningThread+1,R3
	sts _runningThread,R2
;     runningThread->td_state = TDS_RUNNING;
	ldi R24,1
	lds R30,_runningThread
	lds R31,_runningThread+1
	std z+13,R24
; 
;     i = (u_char) (runningThread->td_sp & 0xFF);
	lds R30,_runningThread
	lds R31,_runningThread+1
	ldd R16,z+14
	andi R17,0
;     j = (u_char) ((runningThread->td_sp >> 8) & 0xFF);
	ldd R18,z+14
	ldd R19,z+15
	mov R18,R19
	clr R19
	andi R19,0
; 
;     asm("out $3D, %i");         // SPL
	out $3D, R16
;     asm("out $3E, %j");         // SPH
	out $3E, R18
;     asm("pop r29");
	pop r29
;     asm("pop r28");
	pop r28
;     asm("pop r23");
	pop r23
;     asm("pop r22");
	pop r22
;     asm("pop r21");
	pop r21
;     asm("pop r20");
	pop r20
;     asm("pop r15");
	pop r15
;     asm("pop r14");
	pop r14
;     asm("pop r13");
	pop r13
;     asm("pop r12");
	pop r12
;     asm("pop r11");
	pop r11
;     asm("pop r10");
	pop r10
L4:
	.dbline 0 ; func end
	ret
;           yreg -> R14,R15
;             sf -> R22,R23
;          paddr -> y+2
;      threadMem -> R14,R15
;             ef -> R12,R13
;             td -> R20,R21
;      stackSize -> R20,R21
;            arg -> y+14
;             fn -> R12,R13
;           name -> R10,R11
	.even
_NutThreadCreate::
	xcall push_xgsetF0FC
	movw R12,R18
	movw R10,R16
	sbiw R28,4
	ldd R20,y+16
	ldd R21,y+17
; }
; 
; /*!
;  * \brief Create a new thread.
;  *
;  * If the current thread's priority is lower or equal than the default
;  * priority (64), then the current thread is stopped and the new one
;  * is started.
;  *
;  * \param name      String containing the symbolic name of the new thread,
;  *                  up to 8 characters long.
;  * \param fn        The thread's entry point, typically created by the
;  *                  THREAD macro.
;  * \param arg       Argument pointer passed to the new thread.
;  * \param stackSize Number of bytes of the stack space allocated for
;  *                  the new thread.
;  *
;  * \return Pointer to the NUTTHREADINFO structure or 0 to indicate an
;  *         error.
;  */
; HANDLE NutThreadCreate(u_char * name, void (*fn) (void *), void *arg, size_t stackSize)
; {
;     u_char *threadMem;
;     SWITCHFRAME *sf;
;     ENTERFRAME *ef;
;     NUTTHREADINFO *td;
;     u_short yreg;
; 
;     const u_short *paddr;
;     paddr = (const u_short *) fn;       // *KU* fn doesn't contain the entry address
	std y+3,R13
	std y+2,R12
;     // of the thread!
;     /*
;      * Allocate stack and thread info structure in one block.
;      */
; #if defined (NUTMEM_STACKHEAP) /* Stack resides in internal memory */
;     if ((threadMem = NutStackAlloc(stackSize + sizeof(NUTTHREADINFO))) == 0) {
; #else
;     if ((threadMem = NutHeapAlloc(stackSize + sizeof(NUTTHREADINFO))) == 0) {
	movw R16,R20
	subi R16,233  ; offset = 23
	sbci R17,255
	xcall _NutHeapAlloc
	movw R14,R16
	tst R14
	brne L6
	tst R15
	brne L6
X0:
; #endif
;         return 0;
	clr R16
	clr R17
	xjmp L5
L6:
;     }
; 
;     td = (NUTTHREADINFO *) (threadMem + stackSize);
	add R20,R14
	adc R21,R15
;     ef = (ENTERFRAME *) ((u_short) td - sizeof(ENTERFRAME));
	movw R24,R20
	sbiw R24,9
	movw R12,R24
;     sf = (SWITCHFRAME *) ((u_short) ef - sizeof(SWITCHFRAME));
	movw R22,R24
	subi R22,14
	sbci R23,0
; 
; 
;     memcpy(td->td_name, name, sizeof(td->td_name) - 1);
	ldi R24,8
	ldi R25,0
	std y+1,R25
	std y+0,R24
	movw R18,R10
	movw R16,R20
	subi R16,252  ; offset = 4
	sbci R17,255
	xcall _memcpy
;     td->td_name[sizeof(td->td_name) - 1] = 0;
	ldi R24,4
	ldi R25,0
	adiw R24,8
	movw R30,R20
	add R30,R24
	adc R31,R25
	clr R2
	std z+0,R2
;     td->td_sp = (u_short) sf - 1;
	movw R24,R22
	sbiw R24,1
	movw R30,R20
	std z+15,R25
	std z+14,R24
;     td->td_memory = threadMem;
	std z+18,R15
	std z+17,R14
;     *((u_long *) threadMem) = DEADBEEF;
	ldi R24,239
	ldi R25,190
	ldi R26,173
	ldi R27,222
	movw R30,R14
	std z+0,R24
	std z+1,R25
	std z+2,R26
	std z+3,R27
;     *((u_long *) (threadMem + 4)) = DEADBEEF;
	ldi R24,239
	ldi R25,190
	ldi R26,173
	ldi R27,222
	std z+4,R24
	std z+5,R25
	std z+6,R26
	std z+7,R27
;     *((u_long *) (threadMem + 8)) = DEADBEEF;
	ldi R24,239
	ldi R25,190
	ldi R26,173
	ldi R27,222
	std z+8,R24
	std z+9,R25
	std z+10,R26
	std z+11,R27
;     *((u_long *) (threadMem + 12)) = DEADBEEF;
	ldi R24,239
	ldi R25,190
	ldi R26,173
	ldi R27,222
	std z+12,R24
	std z+13,R25
	std z+14,R26
	std z+15,R27
;     td->td_priority = 64;
	ldi R24,64
	movw R30,R20
	std z+16,R24
; 
;     /*
;      * Setup entry frame to simulate C function entry.
;      */
;     ef->cef_pchi = (u_char) (*paddr >> 8);
	ldd R30,y+2
	ldd R31,y+3
	lpm R2,Z+
	lpm R3,Z
	mov R2,R3
	clr R3
	movw R30,R12
	std z+7,R2
;     ef->cef_pclo = (u_char) (*paddr & 0xff);
	ldd R30,y+2
	ldd R31,y+3
	lpm R24,Z+
	lpm R25,Z
	andi R25,0
	movw R30,R12
	std z+8,R24
;     ef->cef_sreg = 0x80;
	ldi R24,128
	std z+5,R24
;     ef->cef_rampz = 0;
	clr R2
	std z+4,R2
;     ef->cef_r1 = 0;
	std z+6,R2
; 
;     ef->cef_arglo = (u_char) (((u_short) arg) & 0xff);
	ldd R24,y+14
	ldd R25,y+15
	andi R25,0
	std z+1,R24
;     ef->cef_arghi = (u_char) (((u_short) arg) >> 8);
	ldd R2,y+14
	ldd R3,y+15
	mov R2,R3
	clr R3
	std z+0,R2
; 
;     yreg = td->td_sp - 40;
	movw R30,R20
	ldd R24,z+14
	ldd R25,z+15
	sbiw R24,40
	movw R14,R24
;     ef->cef_yhi = (u_char) (yreg >> 8);
	movw R2,R24
	mov R2,R3
	clr R3
	movw R30,R12
	std z+2,R2
;     ef->cef_ylo = (u_char) (yreg & 0xFF);
	andi R25,0
	std z+3,R24
; 
;     paddr = (const u_short *) NutThreadEntry;
	ldi R24,<PL_NutThreadEntry
	ldi R25,>PL_NutThreadEntry
	std y+3,R25
	std y+2,R24
;     sf->csf_pchi = (u_char) (*paddr >> 8);
	movw R30,R24
	lpm R2,Z+
	lpm R3,Z
	mov R2,R3
	clr R3
	movw R30,R22
	std z+12,R2
;     sf->csf_pclo = (u_char) (*paddr & 0xff);
	movw R30,R24
	lpm R24,Z+
	lpm R25,Z
	andi R25,0
	movw R30,R22
	std z+13,R24
; 
;     /*
;      * Insert into the thread list and the run queue.
;      */
; 
;     td->td_next = nutThreadList;
	lds R2,_nutThreadList
	lds R3,_nutThreadList+1
	movw R30,R20
	std z+1,R3
	std z+0,R2
;     nutThreadList = td;
	sts _nutThreadList+1,R21
	sts _nutThreadList,R20
;     td->td_state = TDS_READY;
	ldi R24,2
	std z+13,R24
;     td->td_timer = 0;
	clr R2
	clr R3
	std z+20,R3
	std z+19,R2
;     td->td_queue = 0;
	std z+22,R3
	std z+21,R2
; #ifdef NUTDEBUG
;     if (__os_trf)
;         fprintf(__os_trs, "Cre<%04x>", (uptr_t) td);
; #endif
; 
;     NutThreadAddPriQueue(td, (NUTTHREADINFO **) & runQueue);
	ldi R18,<_runQueue
	ldi R19,>_runQueue
	movw R16,R30
	xcall _NutThreadAddPriQueue
; 
; #ifdef NUTDEBUG
;     if (__os_trf) {
;         NutDumpThreadList(__os_trs);
;         //NutDumpThreadQueue(__os_trs, runQueue);
;     }
; #endif
; 
;     /*
;      * If no thread is active, switch to new thread.
;      */
;     if (runningThread == 0) {
	lds R2,_runningThread
	lds R3,_runningThread+1
	tst R2
	brne L8
	tst R3
	brne L8
X1:
;         NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
;         asm("rjmp thread_start");
	rjmp thread_start
;         /* we will never come back here .. */
;     }
L8:
; 
;     /*
;      * If current context is not in front of
;      * the run queue (highest priority), then
;      * switch to the thread in front.
;      */
;     if (runningThread != runQueue) {
	lds R2,_runQueue
	lds R3,_runQueue+1
	lds R4,_runningThread
	lds R5,_runningThread+1
	cp R4,R2
	cpc R5,R3
	breq L10
X2:
;         runningThread->td_state = TDS_READY;
	ldi R24,2
	movw R30,R4
	std z+13,R24
; #ifdef NUTDEBUG
;         if (__os_trf)
;             fprintf(__os_trs, "New<%04x %04x>", (uptr_t) runningThread, (uptr_t) runQueue);
; #endif
;         NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
;         NutThreadSwitch();
	xcall _NutThreadSwitch
;         NutExitCritical();
	pop R0
	out 0x3F, R0
	
;     }
L10:
; 
;     return td;
	movw R16,R20
L5:
	.dbline 0 ; func end
	adiw R28,4
	xjmp pop_xgsetF0FC
; }
; 
; /*@}*/
	.area func_lit
PL_NutThreadEntry:	.word `_NutThreadEntry
