	.module debug1.c
	.area text(rom, con, rel)
;           conf -> y+8
;            req -> R10,R11
;            dev -> R12,R13
	.even
_DebugIOCtl:
	xcall push_xgsetF03C
	movw R10,R18
	movw R12,R16
; /*
;  * Copyright (C) 2001-2003 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  */
; 
; /*
;  * $Log: debug1.c,v $
;  * Revision 1.3  2005/10/17 08:46:53  hwmaier
;  * Setting baudrate function changed: For CPUs w/ 12 and 16 MHz xtal double rate mode is now used (only if set by NUT_CPU_FREQ)
;  *
;  * Revision 1.2  2005/08/02 17:46:45  haraldkipp
;  * Major API documentation update.
;  *
;  * Revision 1.1  2005/07/26 18:02:27  haraldkipp
;  * Moved from dev.
;  *
;  * Revision 1.3  2005/02/06 16:36:59  haraldkipp
;  * Fixes ICCAVR V7 baudrate miscalculation.
;  *
;  * Revision 1.2  2004/02/25 16:19:10  haraldkipp
;  * Support baudrate settings
;  *
;  * Revision 1.1.1.1  2003/05/09 14:40:37  haraldkipp
;  * Initial using 3.2.1
;  *
;  * Revision 1.2  2003/05/06 18:29:49  harald
;  * ICCAVR port
;  *
;  * Revision 1.1  2003/04/07 12:15:27  harald
;  * First release
;  *
;  */
; 
; #include <dev/debug.h>
; 
; /*!
;  * \addtogroup xgDevDebugAvr
;  */
; /*@{*/
; 
; #ifdef __AVR_ENHANCED__
; 
; #include <cfg/os.h>
; #include <sys/timer.h>
; #include <sys/device.h>
; #include <sys/file.h>
; 
; static NUTFILE dbgfile;
; 
; static int DebugIOCtl(NUTDEVICE * dev, int req, void *conf)
; {
;     if(req == UART_SETSPEED) {
	movw R24,R10
	cpi R24,1
	ldi R30,1
	cpc R25,R30
	breq X1
	xjmp L2
X1:
X0:
; #if defined(__AVR_ENHANCED__) && ((NUT_CPU_FREQ == 12000000) || (NUT_CPU_FREQ == 16000000))
;         /* On enhanced MCUs we use double rate mode, so we can use 115200 bps
;         * with 12.0 and 16.0 crystals.
;         */
;         sbi(UCSR1A, U2X1);
;         outb(UBRR1L, (u_char) ((((2UL * NutGetCpuClock()) / (*((u_long *)conf) * 8UL)) + 1UL) / 2UL) - 1UL);
; #else
;         outb(UBRR1L, (u_char) ((((2UL * NutGetCpuClock()) / (*((u_long *)conf) * 16UL)) + 1UL) / 2UL) - 1UL);
	xcall _NutGetCpuClock
	movw R2,R16
	movw R4,R18
	ldd R30,y+8
	ldd R31,y+9
	ldd R6,z+0
	ldd R7,z+1
	ldd R8,z+2
	ldd R9,z+3
	ldi R20,16
	ldi R21,0
	ldi R22,0
	ldi R23,0
	st -y,R9
	st -y,R8
	st -y,R7
	st -y,R6
	movw R16,R20
	movw R18,R22
	xcall empy32u
	movw R6,R16
	movw R8,R18
	ldi R20,2
	ldi R21,0
	ldi R22,0
	ldi R23,0
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	movw R16,R20
	movw R18,R22
	xcall empy32u
	st -y,R9
	st -y,R8
	st -y,R7
	st -y,R6
	xcall div32u
	movw R2,R16
	movw R4,R18
	ldi R20,1
	ldi R21,0
	ldi R22,0
	ldi R23,0
	add R2,R20
	adc R3,R21
	adc R4,R22
	adc R5,R23
	lsr R5
	ror R4
	ror R3
	ror R2
	clr R3
	clr R4
	clr R5
	ldi R20,1
	ldi R21,0
	ldi R22,0
	ldi R23,0
	sub R2,R20
	sbc R3,R21
	sbc R4,R22
	sbc R5,R23
	sts 153,R2
; #endif
;         return 0;
	clr R16
	clr R17
	xjmp L1
L2:
;     }
;     return -1;
	ldi R16,-1
	ldi R17,-1
L1:
	.dbline 0 ; func end
	xjmp pop_xgsetF03C
;            dev -> R16,R17
	.even
_DebugInit:
; }
; 
; static int DebugInit(NUTDEVICE * dev)
; {
;     /* Note: Default baudrate has been set in nutinit.c */
;     UCSR1B = BV(RXEN) | BV(TXEN);
	ldi R24,24
	sts 154,R24
;     return 0;
	clr R16
	clr R17
L4:
	.dbline 0 ; func end
	ret
;             ch -> R20
	.even
_DebugPut:
	st -y,R20
	st -y,R21
	mov R20,R16
; }
; 
; static void DebugPut(char ch)
; {
L6:
;     while((UCSR1A & BV(UDRE)) == 0);
L7:
	lds R2,155
	sbrs R2,5
	rjmp L6
X2:
;     UDR1 = ch;
	sts 156,R20
;     if(ch == '\n')
	cpi R20,10
	brne L9
X3:
;         DebugPut('\r');
	ldi R16,13
	xcall _DebugPut
L9:
L5:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
;             cp -> R12,R13
;              c -> R20,R21
;            len -> R10,R11
;         buffer -> R12,R13
;             fp -> R14,R15
	.even
_DebugWrite:
	xcall push_xgset30FC
	movw R12,R18
	movw R14,R16
	ldd R10,y+8
	ldd R11,y+9
; }
; 
; static int DebugWrite(NUTFILE * fp, CONST void *buffer, int len)
; {
;     int c = len;
	movw R20,R10
;     CONST char *cp = buffer;
	xjmp L13
L12:
; 
;     while(c--)
;         DebugPut(*cp++);
	movw R30,R12
	ld R16,Z+
	movw R12,R30
	xcall _DebugPut
L13:
	movw R2,R20
	subi R20,1
	sbci R21,0
	tst R2
	brne L12
	tst R3
	brne L12
X4:
;     return len;
	movw R16,R10
L11:
	.dbline 0 ; func end
	xjmp pop_xgset30FC
;              c -> R22,R23
;             cp -> R20,R21
;            len -> R10,R11
;         buffer -> R12,R13
;             fp -> R14,R15
	.even
_DebugWrite_P:
	xcall push_xgsetF0FC
	movw R12,R18
	movw R14,R16
	ldd R10,y+10
	ldd R11,y+11
; }
; 
; static int DebugWrite_P(NUTFILE * fp, PGM_P buffer, int len)
; {
;     int c = len;
	movw R22,R10
;     PGM_P cp = buffer;
	movw R20,R12
	xjmp L17
L16:
; 
;     while(c--) {
;         DebugPut(PRG_RDB(cp));
	movw R30,R20
	lpm R16,Z
	xcall _DebugPut
;         cp++;
	subi R20,255  ; offset = 1
	sbci R21,255
;     }
L17:
	movw R2,R22
	subi R22,1
	sbci R23,0
	tst R2
	brne L16
	tst R3
	brne L16
X5:
;     return len;
	movw R16,R10
L15:
	.dbline 0 ; func end
	xjmp pop_xgsetF0FC
;            acc -> y+2
;           mode -> y+0
;           name -> R18,R19
;            dev -> R16,R17
	.even
_DebugOpen:
; }
; 
; static NUTFILE *DebugOpen(NUTDEVICE * dev, CONST char *name, int mode, int acc)
; {
;     dbgfile.nf_next = 0;
	clr R2
	clr R3
	sts _dbgfile+1,R3
	sts _dbgfile,R2
;     dbgfile.nf_dev = dev;
	sts _dbgfile+2+1,R17
	sts _dbgfile+2,R16
;     dbgfile.nf_fcb = 0;
	sts _dbgfile+4+1,R3
	sts _dbgfile+4,R2
; 
;     return &dbgfile;
	ldi R16,<_dbgfile
	ldi R17,>_dbgfile
L19:
	.dbline 0 ; func end
	ret
;             fp -> R16,R17
	.even
_DebugClose:
; }
; 
; /*!
;  * \brief Close a device or file.
;  */
; static int DebugClose(NUTFILE * fp)
; {
;     return 0;
	clr R16
	clr R17
L22:
	.dbline 0 ; func end
	ret
	.area data(ram, con, rel)
_devDebug1::
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.blkb 2
	.area idata
	.byte 'u,'a
	.area data(ram, con, rel)
	.blkb 2
	.area idata
	.byte 'r,'t
	.area data(ram, con, rel)
	.blkb 2
	.area idata
	.byte 49,0
	.area data(ram, con, rel)
	.blkb 2
	.area idata
	.byte 0,0
	.area data(ram, con, rel)
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.blkw 1
	.area idata
	.word PL_DebugInit
	.area data(ram, con, rel)
	.blkw 1
	.area idata
	.word PL_DebugIOCtl
	.area data(ram, con, rel)
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.blkw 1
	.area idata
	.word PL_DebugWrite
	.area data(ram, con, rel)
	.blkw 1
	.area idata
	.word PL_DebugWrite_P
	.area data(ram, con, rel)
	.blkw 1
	.area idata
	.word PL_DebugOpen
	.area data(ram, con, rel)
	.blkw 1
	.area idata
	.word PL_DebugClose
	.area data(ram, con, rel)
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.area bss(ram, con, rel)
_dbgfile:
	.blkb 6
; }
; 
; /*!
;  * \brief UART 1 Device information structure.
;  */
; NUTDEVICE devDebug1 = {
;     0,                          /*!< Pointer to next device. */
;     {'u', 'a', 'r', 't', '1', 0, 0, 0, 0},      /*!< Unique device name. */
;     0,                          /*!< Type of device. */
;     0,                          /*!< Base address. */
;     0,                          /*!< First interrupt number. */
;     0,                          /*!< Interface control block. */
;     0,                          /*!< Driver control block. */
;     DebugInit,                  /*!< Driver initialization routine. */
;     DebugIOCtl,                 /*!< Driver specific control function. */
;     0,
;     DebugWrite,
;     DebugWrite_P,
;     DebugOpen,
;     DebugClose,
;     0
; };
; 
; #endif
; 
; /*@}*/
	.area func_lit
PL_DebugClose:	.word `_DebugClose
PL_DebugOpen:	.word `_DebugOpen
PL_DebugWrite_P:	.word `_DebugWrite_P
PL_DebugWrite:	.word `_DebugWrite
PL_DebugIOCtl:	.word `_DebugIOCtl
PL_DebugInit:	.word `_DebugInit
