	.module ide.c
	.area data(ram, con, rel)
_gbIntStatus:
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
_gbCFMountStatus:
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
_pUserMountFunc:
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
_pUserUnMountFunc:
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.area text(rom, con, rel)
	.even
_Wait400ns:
; /****************************************************************************
; *  This file is part of the AVRIDE device driver.
; *
; *  Copyright (c) 2002-2003 by Michael Fischer. All rights reserved.
; *
; *  Redistribution and use in source and binary forms, with or without
; *  modification, are permitted provided that the following conditions
; *  are met:
; *
; *  1. Redistributions of source code must retain the above copyright
; *     notice, this list of conditions and the following disclaimer.
; *  2. Redistributions in binary form must reproduce the above copyright
; *     notice, this list of conditions and the following disclaimer in the
; *     documentation and/or other materials provided with the distribution.
; *  3. Neither the name of the author nor the names of its contributors may
; *     be used to endorse or promote products derived from this software
; *     without specific prior written permission.
; *
; *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
; *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
; *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
; *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
; *  THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
; *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
; *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
; *  OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
; *  AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
; *  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
; *  THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
; *  SUCH DAMAGE.
; *
; ****************************************************************************
; *  History:
; *
; *  14.12.02  mifi   First Version
; *  29.12.02  mifi   Support CF-Card too .
; *  01.01.03  mifi   Add support for IDELock, IDEFree.
; *  08.01.03  mifi   Now support several modes, like:
; *                   IDE_HARDDISK           16bit 14.7456Mhz / 2 wait states
; *                   IDE_HARDDISK_7MHZ      16bit  7.3728Mhz / 2 wait states
; *                   IDE_COMPACT_FLASH      16bit 14.7456Mhz / 2 wait states
; *                   MEM_8BIT_COMPACT_FLASH  8bit 14.7456Mhz / 2 wait states
; *  18.01.03  mifi   Change Licence from GPL to BSD.
; *  25.01.03  mifi   Fix the bug in ClearEvent.
; *                   Change IDEInit and add "AutoMount", "AutoUnMount"
; *                   callback function. With these functions we are
; *                   independent from the FileSystem.
; *                   Now support changing of the CF-Card in a running system.
; *  19.06.03  mifi   Change IDEInit, if the BaseAddress is 0, we use the
; *                   default address IDE_BASE_ADDRESS. Now we can use the
; *                   address 0 in FAT.C and hide the ide stuff.
; *  24.06.03  mifi   Enable the IDE Reset pin with DDRD = 0x20,
; *                   add some stuff to detect PACKET device.
; *  25.06.03  mifi   Fix overflow with IDE_MAX_SUPPORTED_DEVICE
; *  29.06.03  mifi   First ATAPI-Version
; ****************************************************************************/
; #define __IDE_C__
; 
; #include <stddef.h>
; #include <string.h>
; 
; #include <sys/timer.h>
; #include <sys/thread.h>
; #include <sys/event.h>
; #include <sys/atom.h>
; #include <sys/heap.h>
; #include <dev/irqreg.h>
; 
; #include <dev/ide.h>
; #include <dev/idep.h>
; #include <fs/typedefs.h>
; 
; #define HIBYTE(_x) (BYTE)((_x >> 8) & 0x00FF)
; #define LOBYTE(_x) (BYTE)(_x & 0x00FF)
; 
; /*==========================================================*/
; /*  DEFINE: All Structures and Common Constants             */
; /*==========================================================*/
; //
; // Here are some important values.
; // Change these values if you change the hardware.
; //
; #define IDE_IRQ                 INT7
; #define IDE_INT_RISING_EDGE     0xC0
; 
; #define CF_IRQ                  INT6
; #define CF_INT_SENS_MASK        0x30
; #define CF_INT_FALLING_EDGE     0x20
; #define CF_INT_RISING_EDGE      0x30
; 
; /************************************************/
; #define IDE_MAX_SUPPORTED_DEVICE        1
; 
; #define CF_AVAILABLE            0
; #define CF_NOT_AVAILABLE        1
; 
; #define INITTIMEOUT             10000
; #define DISKTIMEOUT             10000
; #define CONTROLLERTIMEOUT       200
; #define ATAPITIMEOUT            5000
; 
; #define IDEIn(x)                pIDE[x]
; #define IDEOut(x,y)             pIDE[x] = y
; 
; //
; // Drive Flags
; //
; #define IDE_SUPPORT_LBA             0x0001
; #define IDE_SUPPORT_LBA48           0x0002
; #define IDE_SUPPORT_PACKET          0x0004
; //
; // Device shall assert INTRQ when DRQ
; // is set to one after receiving PACKET.
; //
; #define IDE_SUPPORT_INTRQ_PACKET    0x0008
; 
; #define IDE_CDROM_DEVICE            0x1000
; #define IDE_ZIP_DEVICE              0x2000
; 
; #define IDE_READ_ONLY               0x4000
; #define IDE_READY                   0x8000
; 
; //
; // Identify packet device
; // config word[0] bit masks
; //
; #define ATAPI_CFG_12_BYTE_MSK       0x0003
; #define ATAPI_CFG_INTRQ             0x0060
; #define ATAPI_CFG_REM_MEDIUM        0x0080
; #define ATAPI_CFG_DEVICE            0x1F00
; #define ATAPI_CFG_ATAPI             0xC000
; 
; #define ATAPI_IS_12_BYTE            0x0000
; #define ATAPI_USE_INTRQ             0x0020
; #define ATAPI_IS_DIRECT_ACCESS      0x0000
; #define ATAPI_IS_CDROM              0x0500
; #define ATAPI_IS_PACKET             0x8000
; 
; 
; typedef struct _drive {
;     //
;     // Interface values
;     //
;     WORD wFlags;
;     BYTE bIDEMode;
;     BYTE bDevice;
; 
; #if (IDE_SUPPORT_CHS == 1)
;     //
;     // CHS values
;     //
;     WORD wCylinders;
;     WORD wHeads;
;     WORD wSectorsPerTrack;
;     DWORD dwOneSide;
; #endif
; 
;     //
;     // LBA value
;     //
;     DWORD dwTotalSectors;
; 
;     WORD wSectorSize;
; } DRIVE, *LPDRIVE;
; 
; /*==========================================================*/
; /*  DEFINE: Prototypes                                      */
; /*==========================================================*/
; 
; /*==========================================================*/
; /*  DEFINE: Definition of all local Data                    */
; /*==========================================================*/
; static HANDLE hIDEEvent;
; static volatile BYTE *pIDE;
; static volatile BYTE gbIntStatus = 0;
; 
; static DRIVE sDrive[IDE_MAX_SUPPORTED_DEVICE];
; 
; static HANDLE hIDESemaphore;
; static HANDLE hCFChangeInt;
; static BYTE gbCFMountStatus = 0;
; 
; static IDE_MOUNT_FUNC *pUserMountFunc = NULL;
; static IDE_MOUNT_FUNC *pUserUnMountFunc = NULL;
; 
; #if (IDE_SUPPORT_ATAPI == 1)
; //
; // ATAPI stuff
; //
; static BYTE aATAPICmd[12];
; 
; #define ATAPI_CMD(_x) {                       \
;   memset(aATAPICmd, 0x00, sizeof(aATAPICmd)); \
;   aATAPICmd[0] = _x;                          \
; }
; 
; #define CLEAR_ATAPI_CMD()   memset(aATAPICmd, 0x00, sizeof(aATAPICmd));
; #endif
; 
; /*==========================================================*/
; /*  DEFINE: Definition of all local Procedures              */
; /*==========================================================*/
; /************************************************************/
; /*  Wait400ns                                               */
; /************************************************************/
; static void Wait400ns(void)
; {
;     //
;     // Wait at least 400ns, with 14.7456Mhz we need
;     // 8 nop's for 500ns
;     //
;     COMPRESS_DISABLE;
	.nocc_start
;     _NOP();
	nop
;     _NOP();
	nop
;     _NOP();
	nop
;     _NOP();
	nop
;     _NOP();
	nop
;     _NOP();
	nop
;     _NOP();
	nop
;     _NOP();
	nop
;     COMPRESS_REENABLE;
	.nocc_end
L3:
	.dbline 0 ; func end
	ret
	.even
_IDELock::
	sbiw R28,2
; }
; 
; /************************************************************/
; /*  IDELock                                                 */
; /************************************************************/
; void IDELock(void)
; {
;     NutEventWait(&hIDESemaphore, 0);
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+0,R26
	std y+1,R27
	movw R18,R24
	ldi R16,<_hIDESemaphore
	ldi R17,>_hIDESemaphore
	xcall _NutEventWait
L4:
	.dbline 0 ; func end
	adiw R28,2
	ret
	.even
_IDEFree::
; }
; 
; /************************************************************/
; /*  IDEFree                                                 */
; /************************************************************/
; void IDEFree(void)
; {
;     NutEventPost(&hIDESemaphore);
	ldi R16,<_hIDESemaphore
	ldi R17,>_hIDESemaphore
	xcall _NutEventPost
L5:
	.dbline 0 ; func end
	ret
	.even
_IDESemaInit::
; }
; 
; /************************************************************/
; /*  IDESemaInit                                             */
; /************************************************************/
; void IDESemaInit(void)
; {
;     NutEventPost(&hIDESemaphore);
	ldi R16,<_hIDESemaphore
	ldi R17,>_hIDESemaphore
	xcall _NutEventPost
L6:
	.dbline 0 ; func end
	ret
;         pDrive -> R20,R21
	.even
_HardwareReset:
	st -y,R20
	st -y,R21
	movw R20,R16
; }
; 
; /************************************************************/
; /*  HardwareReset                                           */
; /************************************************************/
; static void HardwareReset(DRIVE * pDrive)
; {
;     if (pDrive->bIDEMode == MEM_8BIT_COMPACT_FLASH) {
	movw R30,R20
	ldd R24,z+2
	cpi R24,3
	brne L8
X0:
;         //
;         // Set Reset
;         //
;         PORTD |= 0x20;
	sbi 0x12,5
;         _NOP();
	nop
; 
;         NutSleep(1000);
	ldi R16,232
	ldi R17,3
	ldi R18,0
	ldi R19,0
	xcall _NutSleep
; 
;         //
;         // Remove Reset
;         //
;         PORTD &= ~0x20;
	cbi 0x12,5
;         _NOP();
	nop
; 
;         NutSleep(1000);
	ldi R16,232
	ldi R17,3
	ldi R18,0
	ldi R19,0
	xcall _NutSleep
;     } else {                    /* HD */
	xjmp L9
L8:
;         //
;         // Set RESET
;         //
;         PORTD &= ~0x20;
	cbi 0x12,5
;         _NOP();
	nop
; 
;         NutSleep(1000);
	ldi R16,232
	ldi R17,3
	ldi R18,0
	ldi R19,0
	xcall _NutSleep
; 
;         //
;         // Remove RESET
;         //
;         PORTD |= 0x20;
	sbi 0x12,5
;         _NOP();
	nop
; 
;         if (pDrive->bIDEMode == IDE_COMPACT_FLASH) {
	movw R30,R20
	ldd R24,z+2
	cpi R24,2
	brne L10
X1:
;             NutSleep(1000);
	ldi R16,232
	ldi R17,3
	ldi R18,0
	ldi R19,0
	xcall _NutSleep
;         } else {
	xjmp L11
L10:
;             //
;             // It can takes up to 10 seconds (2.5-Inch drive)
;             // from reset high to NOT busy.
;             // Take a look in the drive manual "Reset timings"
;             //
;             NutSleep(10000);
	ldi R16,16
	ldi R17,39
	ldi R18,0
	ldi R19,0
	xcall _NutSleep
;         }
L11:
;     }
L9:
L7:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
;              p -> R10,R11
	.even
_CFInterrupt:
	st -y,R10
	st -y,R11
	movw R10,R16
; }
; 
; /************************************************************/
; /*  CFInterrupt                                             */
; /************************************************************/
; static void CFInterrupt(void *p)
; {
;     p = p;
; 
;     NutEventPostFromIrq(&hCFChangeInt);
	ldi R16,<_hCFChangeInt
	ldi R17,>_hCFChangeInt
	xcall _NutEventPostFromIrq
L12:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
;              p -> R10,R11
	.even
_IDEInterrupt:
	st -y,R10
	st -y,R11
	movw R10,R16
; }
; 
; /************************************************************/
; /*  IDEInterrupt                                            */
; /************************************************************/
; static void IDEInterrupt(void *p)
; {
;     p = p;
; 
;     gbIntStatus = IDEIn(STATUS_REG);
	lds R30,_pIDE
	lds R31,_pIDE+1
	ldd R2,z+7
	sts _gbIntStatus,R2
; 
;     NutEventPostFromIrq(&hIDEEvent);
	ldi R16,<_hIDEEvent
	ldi R17,>_hIDEEvent
	xcall _NutEventPostFromIrq
L13:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
;         pEvent -> R16,R17
	.even
_ClearEvent:
; }
; 
; /************************************************************/
; /*  ClearEvent                                              */
; /************************************************************/
; static void ClearEvent(HANDLE * pEvent)
; {
;     NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
; 
;     *pEvent = 0;
	clr R2
	clr R3
	movw R30,R16
	std z+1,R3
	std z+0,R2
; 
;     NutExitCritical();
	pop R0
	out 0x3F, R0
	
L14:
	.dbline 0 ; func end
	ret
;       nTimeout -> R22,R23
;         nError -> R20,R21
;      dwTimeout -> y+6
	.even
_WaitForInterrupt:
	xcall push_arg4
	xcall push_xgsetF000
	sbiw R28,2
; }
; 
; /************************************************************/
; /*  WaitForInterrupt                                        */
; /*                                                          */
; /*  Return: IDE_OK, IDE_ERROR                               */
; /************************************************************/
; static int WaitForInterrupt(DWORD dwTimeout)
; {
;     int nError;
;     int nTimeout;
; 
;     nError = IDE_OK;
	clr R20
	clr R21
; 
;     nTimeout = NutEventWait(&hIDEEvent, dwTimeout);
	ldd R2,y+6
	ldd R3,y+7
	ldd R4,y+8
	ldd R5,y+9
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldi R16,<_hIDEEvent
	ldi R17,>_hIDEEvent
	xcall _NutEventWait
	movw R22,R16
;     if (nTimeout == -1) {
	cpi R16,255
	ldi R30,255
	cpc R17,R30
	brne L16
X2:
;         nError = IDE_ERROR;
	ldi R20,1
;     }
L16:
; 
;     return (nError);
	movw R16,R20
L15:
	.dbline 0 ; func end
	adiw R28,2
	xcall pop_xgsetF000
	adiw R28,4
	ret
;         nError -> R10,R11
;        bStatus -> R12
;      dwTimeout -> y+8
	.even
_WaitDRQ:
	xcall push_arg4
	xcall push_xgsetF03C
; }
; 
; #if ((IDE_SUPPORT_WRITE == 1) || (IDE_SUPPORT_ATAPI == 1))
; /************************************************************/
; /*  WaitDRQ                                                 */
; /*                                                          */
; /*  Return: IDE_OK, IDE_ERROR                               */
; /************************************************************/
; static int WaitDRQ(DWORD dwTimeout)
; {
;     int nError;
;     BYTE bStatus;
; 
;     nError = IDE_OK;
	clr R10
	clr R11
; 
;     bStatus = IDEIn(STATUS_REG);
	lds R30,_pIDE
	lds R31,_pIDE+1
	ldd R12,z+7
;     if ((bStatus & (STATUS_BUSY | STATUS_DATA_REQUEST)) != STATUS_DATA_REQUEST) {
	mov R24,R12
	andi R24,136
	cpi R24,8
	brne X6
	xjmp L19
X6:
X3:
; 
;         dwTimeout = (DWORD) (((dwTimeout * 10UL) / 625UL) + 1UL);
	ldd R2,y+8
	ldd R3,y+9
	ldd R4,y+10
	ldd R5,y+11
	ldi R20,10
	ldi R21,0
	ldi R22,0
	ldi R23,0
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	movw R16,R20
	movw R18,R22
	xcall empy32u
	ldi R20,113
	ldi R21,2
	ldi R22,0
	ldi R23,0
	st -y,R23
	st -y,R22
	st -y,R21
	st -y,R20
	xcall div32u
	movw R2,R16
	movw R4,R18
	ldi R20,1
	ldi R21,0
	ldi R22,0
	ldi R23,0
	add R2,R20
	adc R3,R21
	adc R4,R22
	adc R5,R23
	std y+8,R2
	std y+9,R3
	std y+10,R4
	std y+11,R5
;         dwTimeout += NutGetTickCount();
	xcall _NutGetTickCount
	ldd R2,y+8
	ldd R3,y+9
	ldd R4,y+10
	ldd R5,y+11
	add R2,R16
	adc R3,R17
	adc R4,R18
	adc R5,R19
	std y+8,R2
	std y+9,R3
	std y+10,R4
	std y+11,R5
; 
;         bStatus = IDEIn(STATUS_REG);
	lds R30,_pIDE
	lds R31,_pIDE+1
	ldd R12,z+7
	xjmp L22
L21:
;         while ((bStatus & (STATUS_BUSY | STATUS_DATA_REQUEST)) != STATUS_DATA_REQUEST) {
;             if (NutGetTickCount() > dwTimeout) {
	xcall _NutGetTickCount
	ldd R2,y+8
	ldd R3,y+9
	ldd R4,y+10
	ldd R5,y+11
	cp R2,R16
	cpc R3,R17
	cpc R4,R18
	cpc R5,R19
	brsh L24
X4:
;                 nError = IDE_ERROR;
	ldi R24,1
	ldi R25,0
	movw R10,R24
;                 break;
	xjmp L23
L24:
;             }
;             bStatus = IDEIn(STATUS_REG);
	lds R30,_pIDE
	lds R31,_pIDE+1
	ldd R12,z+7
;         }
L22:
	mov R24,R12
	andi R24,136
	cpi R24,8
	brne L21
X5:
L23:
; 
;     }
L19:
; 
;     return (nError);
	movw R16,R10
L18:
	.dbline 0 ; func end
	xcall pop_xgsetF03C
	adiw R28,4
	ret
;         nError -> R10,R11
;        bStatus -> R12
;      dwTimeout -> y+8
	.even
_WaitNotBusy:
	xcall push_arg4
	xcall push_xgsetF03C
; }
; #endif
; 
; /************************************************************/
; /*  WaitNotBusy  (see ATAPI-4 r17 p223 9.6)                 */
; /*                                                          */
; /*  Return: IDE_OK, IDE_ERROR                               */
; /************************************************************/
; static int WaitNotBusy(DWORD dwTimeout)
; {
;     int nError;
;     BYTE bStatus;
; 
;     nError = IDE_OK;
	clr R10
	clr R11
; 
;     bStatus = IDEIn(STATUS_REG);
	lds R30,_pIDE
	lds R31,_pIDE+1
	ldd R12,z+7
;     if (bStatus & (STATUS_BUSY | STATUS_DATA_REQUEST)) {
	mov R24,R12
	andi R24,136
	brne X10
	xjmp L27
X10:
X7:
; 
;         dwTimeout = ((dwTimeout * 10) / 625) + 1;
	ldd R2,y+8
	ldd R3,y+9
	ldd R4,y+10
	ldd R5,y+11
	ldi R20,10
	ldi R21,0
	ldi R22,0
	ldi R23,0
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	movw R16,R20
	movw R18,R22
	xcall empy32u
	ldi R20,113
	ldi R21,2
	ldi R22,0
	ldi R23,0
	st -y,R23
	st -y,R22
	st -y,R21
	st -y,R20
	xcall div32u
	movw R2,R16
	movw R4,R18
	ldi R20,1
	ldi R21,0
	ldi R22,0
	ldi R23,0
	add R2,R20
	adc R3,R21
	adc R4,R22
	adc R5,R23
	std y+8,R2
	std y+9,R3
	std y+10,R4
	std y+11,R5
;         dwTimeout += NutGetTickCount();
	xcall _NutGetTickCount
	ldd R2,y+8
	ldd R3,y+9
	ldd R4,y+10
	ldd R5,y+11
	add R2,R16
	adc R3,R17
	adc R4,R18
	adc R5,R19
	std y+8,R2
	std y+9,R3
	std y+10,R4
	std y+11,R5
; 
;         bStatus = IDEIn(STATUS_REG);
	lds R30,_pIDE
	lds R31,_pIDE+1
	ldd R12,z+7
	xjmp L30
L29:
;         while (bStatus & (STATUS_BUSY | STATUS_DATA_REQUEST)) {
;             if (NutGetTickCount() > dwTimeout) {
	xcall _NutGetTickCount
	ldd R2,y+8
	ldd R3,y+9
	ldd R4,y+10
	ldd R5,y+11
	cp R2,R16
	cpc R3,R17
	cpc R4,R18
	cpc R5,R19
	brsh L32
X8:
;                 nError = IDE_BUSY;
	ldi R24,4
	ldi R25,0
	movw R10,R24
;                 break;
	xjmp L31
L32:
;             }
;             bStatus = IDEIn(STATUS_REG);
	lds R30,_pIDE
	lds R31,_pIDE+1
	ldd R12,z+7
;         }
L30:
	mov R24,R12
	andi R24,136
	brne L29
X9:
L31:
; 
;     }
L27:
; 
;     return (nError);
	movw R16,R10
L26:
	.dbline 0 ; func end
	xcall pop_xgsetF03C
	adiw R28,4
	ret
;         nError -> R20,R21
;         bDummy -> R12
;       nTimeout -> R22,R23
;        bStatus -> R10
;        bDevice -> R22
	.even
_SelectDevice:
	xcall push_xgsetF03C
	mov R22,R16
; }
; 
; /************************************************************/
; /*  SelectDevice  (see ATAPI-4 r17 p223 9.6)                */
; /*                                                          */
; /*  Return: IDE_OK, IDE_ERROR                               */
; /************************************************************/
; static int SelectDevice(BYTE bDevice)
; {
;     int nError;
;     int nTimeout;
;     BYTE bStatus;
;     BYTE bDummy;
; 
;     nError = IDE_OK;
	clr R20
	clr R21
; 
;     if (WaitNotBusy(CONTROLLERTIMEOUT) == IDE_OK) {
	ldi R16,200
	ldi R17,0
	ldi R18,0
	ldi R19,0
	xcall _WaitNotBusy
	cpi R16,0
	cpc R16,R17
	brne L35
X11:
; 
;         IDEOut(DISK_HEAD_REG, 0xA0 + (bDevice << 4));
	mov R24,R22
	andi R24,#0x0F
	swap R24
	subi R24,96    ; addi 160
	lds R30,_pIDE
	lds R31,_pIDE+1
	std z+6,R24
; 
;         Wait400ns();
	xcall _Wait400ns
; 
;         nError = WaitNotBusy(CONTROLLERTIMEOUT);
	ldi R16,200
	ldi R17,0
	ldi R18,0
	ldi R19,0
	xcall _WaitNotBusy
	movw R20,R16
;     } else {
	xjmp L36
L35:
;         nError = IDE_BUSY;
	ldi R20,4
	ldi R21,0
;     }
L36:
; 
;     if (nError != IDE_OK) {
	cpi R20,0
	cpc R20,R21
	breq L37
X12:
;         //
;         // Test for special case, data available.
;         // If data available, read the data!!
;         //
;         bStatus = IDEIn(STATUS_REG);
	lds R30,_pIDE
	lds R31,_pIDE+1
	ldd R10,z+7
;         if (bStatus & STATUS_DATA_REQUEST) {
	sbrs R10,3
	rjmp L39
X13:
; 
;             nTimeout = 512;
	ldi R22,512
	ldi R23,2
	xjmp L42
L41:
;             while ((bStatus & STATUS_DATA_REQUEST) && (nTimeout)) {
;                 bDummy = IDEIn(DATA_READ_REG_LOW);
	lds R30,_pIDE
	lds R31,_pIDE+1
	subi R30,0  ; addi 768
	sbci R31,253
	ldd R12,z+0
	subi R30,0
	sbci R31,3
;                 bDummy = IDEIn(DATA_READ_REG_LOW);
	subi R30,0  ; addi 768
	sbci R31,253
	ldd R12,z+0
	subi R30,0
	sbci R31,3
;                 bStatus = IDEIn(STATUS_REG);
	ldd R10,z+7
;                 nTimeout--;
	subi R22,1
	sbci R23,0
;             }
L42:
	sbrs R10,3
	rjmp L44
X14:
	cpi R22,0
	cpc R22,R23
	brne L41
X15:
L44:
;         }
L39:
;     }
L37:
; 
;     return (nError);
	movw R16,R20
L34:
	.dbline 0 ; func end
	xjmp pop_xgsetF03C
;        bStatus -> R10
;              y -> R10,R11
;         bDummy -> R14
;    wSectorSize -> R12,R13
;        bDevice -> R10
;         nError -> R20,R21
;              x -> R22,R23
;     pReadCount -> y+12
;  pSectorBuffer -> y+10
;         pDrive -> R22,R23
	.even
_ATAPISendCommand:
	st -y,r19
	st -y,r18
	xcall push_xgsetF0FC
	movw R22,R16
; }
; 
; #if (IDE_SUPPORT_ATAPI == 1)
; /************************************************************/
; /*  ATAPISendCommand                                        */
; /*                                                          */
; /*  Return: IDE_OK, IDE_ERROR                               */
; /************************************************************/
; static int ATAPISendCommand(LPDRIVE pDrive, BYTE * pSectorBuffer, WORD * pReadCount)
; {
;     int nError;
;     BYTE bStatus;
;     BYTE bDevice;
;     WORD x, y;
;     BYTE bDummy;
;     WORD wSectorSize;
; 
;     nError = IDE_ERROR;
	ldi R20,1
	ldi R21,0
;     bDummy = 0;
	clr R14
;     bDevice = pDrive->bDevice;
	movw R30,R22
	ldd R10,z+3
;     wSectorSize = pDrive->wSectorSize;
	ldd R12,z+8
	ldd R13,z+9
; 
;     *pReadCount = 0;
	clr R2
	clr R3
	ldd R30,y+12
	ldd R31,y+13
	std z+1,R3
	std z+0,R2
; 
;     if (SelectDevice(bDevice) == IDE_OK) {
	mov R16,R10
	xcall _SelectDevice
	cpi R16,0
	cpc R16,R17
	breq X29
	xjmp L46
X29:
X16:
; 
;         ClearEvent(&hIDEEvent);
	ldi R16,<_hIDEEvent
	ldi R17,>_hIDEEvent
	xcall _ClearEvent
; 
;         if (WaitNotBusy(ATAPITIMEOUT) == IDE_OK) {
	ldi R16,136
	ldi R17,19
	ldi R18,0
	ldi R19,0
	xcall _WaitNotBusy
	cpi R16,0
	cpc R16,R17
	breq X30
	xjmp L48
X30:
X17:
; 
;             IDEOut(FEATURE_REG, 0x00);
	clr R2
	lds R30,_pIDE
	lds R31,_pIDE+1
	std z+1,R2
;             IDEOut(SECTOR_COUNT_REG, 0x00);
	lds R30,_pIDE
	lds R31,_pIDE+1
	std z+2,R2
;             IDEOut(SECTOR_REG, 0x00);
	lds R30,_pIDE
	lds R31,_pIDE+1
	std z+3,R2
;             IDEOut(CYLINDER_LOW_REG, LOBYTE(wSectorSize));
	movw R24,R12
	andi R25,0
	lds R30,_pIDE
	lds R31,_pIDE+1
	std z+4,R24
;             IDEOut(CYLINDER_HIGH_REG, HIBYTE(wSectorSize));
	movw R24,R12
	mov R24,R25
	clr R25
	andi R25,0
	lds R30,_pIDE
	lds R31,_pIDE+1
	std z+5,R24
;             IDEOut(COMMAND_REG, 0xA0);
	ldi R24,160
	lds R30,_pIDE
	lds R31,_pIDE+1
	std z+7,R24
; 
;             if (pDrive->wFlags & IDE_SUPPORT_INTRQ_PACKET) {
	movw R30,R22
	ldd R2,z+0
	ldd R3,z+1
	sbrs R2,3
	rjmp L50
X18:
;                 nError = WaitForInterrupt(ATAPITIMEOUT);
	ldi R16,136
	ldi R17,19
	ldi R18,0
	ldi R19,0
	xcall _WaitForInterrupt
	movw R10,R16
	movw R20,R10
;                 if (nError == IDE_OK) {
	cpi R16,0
	cpc R16,R17
	brne L51
X19:
;                     ClearEvent(&hIDEEvent);
	ldi R16,<_hIDEEvent
	ldi R17,>_hIDEEvent
	xcall _ClearEvent
;                 }
;             } else {
	xjmp L51
L50:
;                 nError = WaitDRQ(ATAPITIMEOUT);
	ldi R16,136
	ldi R17,19
	ldi R18,0
	ldi R19,0
	xcall _WaitDRQ
	movw R10,R16
	movw R20,R10
;             }
L51:
; 
;             if (nError == IDE_OK) {
	cpi R20,0
	cpc R20,R21
	breq X31
	xjmp L54
X31:
X20:
;                 for (x = 0; x < 12; x = x + 2) {
	clr R22
	clr R23
	xjmp L59
L56:
;                     IDEOut(DATA_WRITE_REG_HIGH, aATAPICmd[x + 1]);
	ldi R24,<_aATAPICmd
	ldi R25,>_aATAPICmd
	movw R30,R22
	adiw R30,1
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	lds R30,_pIDE
	lds R31,_pIDE+1
	subi R30,0  ; addi 512
	sbci R31,254
	std z+0,R2
;                     IDEOut(DATA_WRITE_REG_LOW, aATAPICmd[x]);
	movw R30,R22
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	lds R30,_pIDE
	lds R31,_pIDE+1
	subi R30,0  ; addi 256
	sbci R31,255
	std z+0,R2
;                 }
L57:
	subi R22,254  ; offset = 2
	sbci R23,255
L59:
	cpi R22,12
	ldi R30,0
	cpc R23,R30
	brlo L56
X21:
; 
;                 if (WaitForInterrupt(ATAPITIMEOUT) == IDE_OK) {
	ldi R16,136
	ldi R17,19
	ldi R18,0
	ldi R19,0
	xcall _WaitForInterrupt
	movw R10,R16
	cpi R16,0
	cpc R16,R17
	breq X32
	xjmp L60
X32:
X22:
;                     if (gbIntStatus & STATUS_ERROR) {
	lds R2,_gbIntStatus
	sbrs R2,0
	rjmp L62
X23:
;                         nError = IDE_ERROR;
	ldi R20,1
	ldi R21,0
;                     } else {
	xjmp L63
L62:
;                         nError = IDE_OK;
	clr R20
	clr R21
; 
;                         if (gbIntStatus & STATUS_DATA_REQUEST) {
	lds R2,_gbIntStatus
	sbrs R2,3
	rjmp L64
X24:
; 
;                             Wait400ns();
	xcall _Wait400ns
; 
;                             y = IDEIn(CYLINDER_HIGH_REG) << 8;
	lds R30,_pIDE
	lds R31,_pIDE+1
	ldd R10,z+5
	clr R11
	mov R11,R10
	clr R10
;                             y |= IDEIn(CYLINDER_LOW_REG);
	ldd R2,z+4
	clr R3
	or R10,R2
	or R11,R3
; 
;                             if (y > wSectorSize) {
	cp R12,R10
	cpc R13,R11
	brsh L66
X25:
;                                 y = wSectorSize;
	movw R10,R12
;                             }
L66:
; 
;                             if (pSectorBuffer != NULL) {
	ldd R0,y+10
	ldd R1,y+11
	tst R0
	brne X26
	tst R1
	breq L68
X26:
;                                 for (x = 0; x < y; x = x + 2) {
	clr R22
	clr R23
	xjmp L73
L70:
;                                     pSectorBuffer[x] = pIDE[DATA_READ_REG_LOW];
	movw R30,R22
	ldd R0,y+10
	ldd R1,y+11
	add R30,R0
	adc R31,R1
	lds R26,_pIDE
	lds R27,_pIDE+1
	subi R26,0  ; offset = 768
	sbci R27,253
	ld R2,x
	std z+0,R2
;                                     pSectorBuffer[x + 1] = pIDE[DATA_READ_REG_HIGH];
	movw R30,R22
	adiw R30,1
	add R30,R0
	adc R31,R1
	lds R26,_pIDE
	lds R27,_pIDE+1
	subi R26,0  ; offset = 1024
	sbci R27,252
	ld R2,x
	std z+0,R2
;                                 }
L71:
	subi R22,254  ; offset = 2
	sbci R23,255
L73:
	cp R22,R10
	cpc R23,R11
	brlo L70
X27:
;                             } else {
	xjmp L69
L68:
;                                 for (x = 0; x < y; x = x + 2) {
	clr R22
	clr R23
	xjmp L77
L74:
;                                     bDummy += pIDE[DATA_READ_REG_LOW];
	lds R30,_pIDE
	lds R31,_pIDE+1
	subi R30,0  ; addi 768
	sbci R31,253
	ldd R2,z+0
	subi R30,0
	sbci R31,3
	add R14,R2
;                                     bDummy += pIDE[DATA_READ_REG_HIGH];
	subi R30,0  ; addi 1024
	sbci R31,252
	ldd R2,z+0
	add R14,R2
;                                 }
L75:
	subi R22,254  ; offset = 2
	sbci R23,255
L77:
	cp R22,R10
	cpc R23,R11
	brlo L74
X28:
;                             }
L69:
; 
;                             *pReadCount = y;
	ldd R30,y+12
	ldd R31,y+13
	std z+1,R11
	std z+0,R10
; 
;                             bStatus = IDEIn(STATUS_REG);
	lds R30,_pIDE
	lds R31,_pIDE+1
	ldd R10,z+7
;                         }       /* endif STATUS_DATA_REQUEST */
L64:
;                     }           /* endif STATUS_ERROR */
L63:
;                 }               /* endif WaitForInterrupt(ATAPITIMEOUT) */
L60:
;             }                   /* endif (WaitDRQ(ATAPITIMEOUT) */
L54:
;         }                       /* endif WaitNotBusy(ATAPITIMEOUT) */
L48:
;     }
L46:
;     /* endif SelectDevice(bDevice) */
;     return (nError);
	movw R16,R20
L45:
	.dbline 0 ; func end
	xcall pop_xgsetF0FC
	adiw R28,2
	ret
;     wReadCount -> y+6
;    wErrorCount -> R14,R15
;         nError -> R10,R11
;        dwValue -> y+2
;    pMaxSectors -> y+20
;  pSectorBuffer -> y+18
;         pDrive -> R12,R13
	.even
_ATAPIGetTotalSectors:
	st -y,r19
	st -y,r18
	xcall push_xgsetF0FC
	movw R12,R16
	sbiw R28,8
; }
; 
; /************************************************************/
; /*  ATAPIGetTotalSectors                                    */
; /*                                                          */
; /*  Return: IDE_OK, IDE_ERROR                               */
; /************************************************************/
; static int ATAPIGetTotalSectors(LPDRIVE pDrive, BYTE * pSectorBuffer, DWORD * pMaxSectors)
; {
;     int nError;
;     WORD wReadCount;
;     WORD wErrorCount;
;     DWORD dwValue;
; 
;     nError = IDE_OK;
	clr R10
	clr R11
;     *pMaxSectors = 0;
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R30,y+20
	ldd R31,y+21
	std z+0,R20
	std z+1,R21
	std z+2,R22
	std z+3,R23
; 
;     wErrorCount = 4;
	ldi R24,4
	ldi R25,0
	movw R14,R24
	xjmp L80
L79:
;     while (wErrorCount) {
; 
;         ATAPI_CMD(ATAPI_CMD_READ_CAPACITY);
	ldi R24,12
	ldi R25,0
	std y+1,R25
	std y+0,R24
	clr R18
	clr R19
	ldi R16,<_aATAPICmd
	ldi R17,>_aATAPICmd
	xcall _memset
	ldi R24,37
	sts _aATAPICmd,R24
;         nError = ATAPISendCommand(pDrive, pSectorBuffer, &wReadCount);
	movw R24,R28
	adiw R24,6
	std y+1,R25
	std y+0,R24
	ldd R18,y+18
	ldd R19,y+19
	movw R16,R12
	xcall _ATAPISendCommand
	movw R10,R16
;         if ((nError == IDE_OK) && (wReadCount == 8)) {
	cpi R16,0
	cpc R16,R17
	breq X37
	xjmp L82
X37:
X33:
	ldd R24,y+6
	ldd R25,y+7
	cpi R24,8
	ldi R30,0
	cpc R25,R30
	breq X38
	xjmp L82
X38:
X34:
;             dwValue = pSectorBuffer[0];
	ldd R30,y+18
	ldd R31,y+19
	ldd R2,z+0
	clr R3
	clr R4
	clr R5
	std y+2,R2
	std y+3,R3
	std y+4,R4
	std y+5,R5
;             dwValue = dwValue << 8;
	ldi R24,8
	ldi R25,0
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	st -y,R24
	xcall lsl32
	std y+2,R16
	std y+3,R17
	std y+4,R18
	std y+5,R19
;             dwValue |= pSectorBuffer[1];
	ldd R30,y+18
	ldd R31,y+19
	ldd R2,z+1
	clr R3
	clr R4
	clr R5
	ldd R6,y+2
	ldd R7,y+3
	ldd R8,y+4
	ldd R9,y+5
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	std y+2,R6
	std y+3,R7
	std y+4,R8
	std y+5,R9
;             dwValue = dwValue << 8;
	ldi R24,8
	ldi R25,0
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	st -y,R24
	xcall lsl32
	std y+2,R16
	std y+3,R17
	std y+4,R18
	std y+5,R19
;             dwValue |= pSectorBuffer[2];
	ldd R30,y+18
	ldd R31,y+19
	ldd R2,z+2
	clr R3
	clr R4
	clr R5
	ldd R6,y+2
	ldd R7,y+3
	ldd R8,y+4
	ldd R9,y+5
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	std y+2,R6
	std y+3,R7
	std y+4,R8
	std y+5,R9
;             dwValue = dwValue << 8;
	ldi R24,8
	ldi R25,0
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	st -y,R24
	xcall lsl32
	std y+2,R16
	std y+3,R17
	std y+4,R18
	std y+5,R19
;             dwValue |= pSectorBuffer[3];
	ldd R30,y+18
	ldd R31,y+19
	ldd R2,z+3
	clr R3
	clr R4
	clr R5
	ldd R6,y+2
	ldd R7,y+3
	ldd R8,y+4
	ldd R9,y+5
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	std y+2,R6
	std y+3,R7
	std y+4,R8
	std y+5,R9
;             *pMaxSectors = dwValue;
	ldd R2,y+2
	ldd R3,y+3
	ldd R4,y+4
	ldd R5,y+5
	ldd R30,y+20
	ldd R31,y+21
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
; 
;             //
;             // Get SectorSize
;             //
;             dwValue = pSectorBuffer[4];
	ldd R30,y+18
	ldd R31,y+19
	ldd R2,z+4
	clr R3
	clr R4
	clr R5
	std y+2,R2
	std y+3,R3
	std y+4,R4
	std y+5,R5
;             dwValue = dwValue << 8;
	ldi R24,8
	ldi R25,0
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	st -y,R24
	xcall lsl32
	std y+2,R16
	std y+3,R17
	std y+4,R18
	std y+5,R19
;             dwValue |= pSectorBuffer[5];
	ldd R30,y+18
	ldd R31,y+19
	ldd R2,z+5
	clr R3
	clr R4
	clr R5
	ldd R6,y+2
	ldd R7,y+3
	ldd R8,y+4
	ldd R9,y+5
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	std y+2,R6
	std y+3,R7
	std y+4,R8
	std y+5,R9
;             dwValue = dwValue << 8;
	ldi R24,8
	ldi R25,0
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	st -y,R24
	xcall lsl32
	std y+2,R16
	std y+3,R17
	std y+4,R18
	std y+5,R19
;             dwValue |= pSectorBuffer[6];
	ldd R30,y+18
	ldd R31,y+19
	ldd R2,z+6
	clr R3
	clr R4
	clr R5
	ldd R6,y+2
	ldd R7,y+3
	ldd R8,y+4
	ldd R9,y+5
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	std y+2,R6
	std y+3,R7
	std y+4,R8
	std y+5,R9
;             dwValue = dwValue << 8;
	ldi R24,8
	ldi R25,0
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	st -y,R24
	xcall lsl32
	std y+2,R16
	std y+3,R17
	std y+4,R18
	std y+5,R19
;             dwValue |= pSectorBuffer[7];
	ldd R30,y+18
	ldd R31,y+19
	ldd R2,z+7
	clr R3
	clr R4
	clr R5
	ldd R6,y+2
	ldd R7,y+3
	ldd R8,y+4
	ldd R9,y+5
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	std y+2,R6
	std y+3,R7
	std y+4,R8
	std y+5,R9
;             if (dwValue > ATAPI_SECTOR_SIZE) {
	ldi R20,0
	ldi R21,8
	ldi R22,0
	ldi R23,0
	ldd R2,y+2
	ldd R3,y+3
	ldd R4,y+4
	ldd R5,y+5
	cp R20,R2
	cpc R21,R3
	cpc R22,R4
	cpc R23,R5
	brsh L84
X35:
;                 dwValue = ATAPI_SECTOR_SIZE;
	ldi R20,0
	ldi R21,8
	ldi R22,0
	ldi R23,0
	std y+2,R20
	std y+3,R21
	std y+4,R22
	std y+5,R23
;             }
L84:
;             pDrive->wSectorSize = (WORD) (dwValue & 0x0000FFFF);
	ldi R20,255
	ldi R21,255
	ldi R22,0
	ldi R23,0
	ldd R2,y+2
	ldd R3,y+3
	ldd R4,y+4
	ldd R5,y+5
	and R2,R20
	and R3,R21
	and R4,R22
	and R5,R23
	movw R30,R12
	std z+9,R3
	std z+8,R2
;             break;
	xjmp L81
L82:
;         }
;         wErrorCount--;
	movw R24,R14
	sbiw R24,1
	movw R14,R24
;         NutSleep(2000);
	ldi R16,208
	ldi R17,7
	ldi R18,0
	ldi R19,0
	xcall _NutSleep
;     }
L80:
	tst R14
	breq X39
	xjmp L79
X39:
	tst R15
	breq X40
	xjmp L79
X40:
X36:
L81:
; 
;     return (nError);
	movw R16,R10
L78:
	.dbline 0 ; func end
	adiw R28,8
	xcall pop_xgsetF0FC
	adiw R28,2
	ret
; dwTotalSectors -> y+4
;      bErrorReg -> R10
;        bStatus -> R14
;        wConfig -> R14,R15
;        bDevice -> R10
;         nError -> R20,R21
;              i -> y+2
;  pSectorBuffer -> R12,R13
;         pDrive -> R22,R23
	.even
_GetDeviceInfoPacket:
	xcall push_xgsetF0FC
	movw R12,R18
	movw R22,R16
	sbiw R28,8
; }
; 
; /************************************************************/
; /*  GetDeviceInfoPacket                                     */
; /*                                                          */
; /*  PIO data in command protocol (see ATAPI-4 r17 p224 9.7) */
; /*                                                          */
; /*  Return: IDE_OK, IDE_ERROR                               */
; /************************************************************/
; static int GetDeviceInfoPacket(LPDRIVE pDrive, BYTE * pSectorBuffer)
; {
;     WORD i;
;     int nError;
;     BYTE bStatus;
;     BYTE bErrorReg;
;     BYTE bDevice;
;     WORD wConfig;
;     DWORD dwTotalSectors;
; 
;     nError = IDE_ERROR;
	ldi R20,1
	ldi R21,0
;     bDevice = pDrive->bDevice;
	movw R30,R22
	ldd R10,z+3
; 
;     if (SelectDevice(bDevice) == IDE_OK) {
	mov R16,R10
	xcall _SelectDevice
	cpi R16,0
	cpc R16,R17
	breq X53
	xjmp L87
X53:
X41:
; 
;         ClearEvent(&hIDEEvent);
	ldi R16,<_hIDEEvent
	ldi R17,>_hIDEEvent
	xcall _ClearEvent
; 
;         IDEOut(COMMAND_REG, COMMAND_DEVICE_INFO_P);
	ldi R24,161
	lds R30,_pIDE
	lds R31,_pIDE+1
	std z+7,R24
;         if (WaitForInterrupt(DISKTIMEOUT) == IDE_OK) {
	ldi R16,16
	ldi R17,39
	ldi R18,0
	ldi R19,0
	xcall _WaitForInterrupt
	cpi R16,0
	cpc R16,R17
	breq X54
	xjmp L89
X54:
X42:
; 
;             if (gbIntStatus & STATUS_DATA_REQUEST) {
	lds R2,_gbIntStatus
	sbrs R2,3
	rjmp L91
X43:
; 
;                 for (i = 0; i < IDE_SECTOR_SIZE; i = i + 2) {
	clr R2
	clr R3
	std y+3,R3
	std y+2,R2
	xjmp L96
L93:
;                     pSectorBuffer[i] = pIDE[DATA_READ_REG_LOW];
	ldd R30,y+2
	ldd R31,y+3
	add R30,R12
	adc R31,R13
	lds R26,_pIDE
	lds R27,_pIDE+1
	subi R26,0  ; offset = 768
	sbci R27,253
	ld R2,x
	std z+0,R2
;                     if (pDrive->bIDEMode == MEM_8BIT_COMPACT_FLASH) {
	movw R30,R22
	ldd R24,z+2
	cpi R24,3
	brne L97
X44:
;                         pSectorBuffer[i + 1] = pIDE[DATA_READ_REG_LOW];
	ldd R30,y+2
	ldd R31,y+3
	adiw R30,1
	add R30,R12
	adc R31,R13
	lds R26,_pIDE
	lds R27,_pIDE+1
	subi R26,0  ; offset = 768
	sbci R27,253
	ld R2,x
	std z+0,R2
;                     } else {
	xjmp L98
L97:
;                         pSectorBuffer[i + 1] = pIDE[DATA_READ_REG_HIGH];
	ldd R30,y+2
	ldd R31,y+3
	adiw R30,1
	add R30,R12
	adc R31,R13
	lds R26,_pIDE
	lds R27,_pIDE+1
	subi R26,0  ; offset = 1024
	sbci R27,252
	ld R2,x
	std z+0,R2
;                     }
L98:
;                 }
L94:
	ldd R24,y+2
	ldd R25,y+3
	adiw R24,2
	std y+3,R25
	std y+2,R24
L96:
	ldd R24,y+2
	ldd R25,y+3
	cpi R24,0
	ldi R30,2
	cpc R25,R30
	brsh X55
	xjmp L93
X55:
X45:
; 
;                 //
;                 // Status register is read to clear
;                 // pending interrupts.
;                 //
;                 bStatus = IDEIn(STATUS_REG);
; 
;                 pDrive->wFlags = 0;
	clr R2
	clr R3
	movw R30,R22
	std z+1,R3
	std z+0,R2
; 
;                 wConfig = *(WORD *) & pSectorBuffer[0];
	movw R30,R12
	ldd R14,z+0
	ldd R15,z+1
;                 if ((wConfig & ATAPI_CFG_INTRQ) == ATAPI_USE_INTRQ) {
	movw R24,R14
	andi R24,96
	andi R25,0
	cpi R24,32
	ldi R30,0
	cpc R25,R30
	brne L99
X46:
;                     pDrive->wFlags |= IDE_SUPPORT_INTRQ_PACKET;
	movw R30,R22
	ldd R24,z+0
	ldd R25,z+1
	ori R24,8
	std z+1,R25
	std z+0,R24
;                 }
L99:
;                 if ((wConfig & ATAPI_CFG_DEVICE) == ATAPI_IS_DIRECT_ACCESS) {
	movw R24,R14
	andi R24,0
	andi R25,31
	cpi R24,0
	cpc R24,R25
	brne L101
X47:
;                     pDrive->wFlags |= IDE_ZIP_DEVICE;
	movw R30,R22
	ldd R24,z+0
	ldd R25,z+1
	ori R25,32
	std z+1,R25
	std z+0,R24
;                 }
L101:
;                 if ((wConfig & ATAPI_CFG_DEVICE) == ATAPI_IS_CDROM) {
	movw R24,R14
	andi R24,0
	andi R25,31
	cpi R24,0
	ldi R30,5
	cpc R25,R30
	brne L103
X48:
;                     pDrive->wFlags |= (IDE_READ_ONLY | IDE_CDROM_DEVICE);
	movw R30,R22
	ldd R24,z+0
	ldd R25,z+1
	ori R25,80
	std z+1,R25
	std z+0,R24
;                 }
L103:
;                 if ((wConfig & ATAPI_CFG_ATAPI) == ATAPI_IS_PACKET) {
	movw R24,R14
	andi R24,0
	andi R25,192
	cpi R24,0
	ldi R30,128
	cpc R25,R30
	brne L105
X49:
;                     pDrive->wFlags |= IDE_SUPPORT_PACKET;
	movw R30,R22
	ldd R24,z+0
	ldd R25,z+1
	ori R24,4
	std z+1,R25
	std z+0,R24
;                 }
L105:
; 
;                 if ((wConfig & ATAPI_CFG_12_BYTE_MSK) == ATAPI_IS_12_BYTE) {
	movw R24,R14
	andi R24,3
	andi R25,0
	cpi R24,0
	cpc R24,R25
	breq X56
	xjmp L107
X56:
X50:
;                     pDrive->wFlags |= IDE_READY;
	movw R30,R22
	ldd R24,z+0
	ldd R25,z+1
	ori R25,128
	std z+1,R25
	std z+0,R24
; 
;                     nError = ATAPIGetTotalSectors(pDrive, pSectorBuffer, &dwTotalSectors);
	movw R24,R28
	adiw R24,4
	std y+1,R25
	std y+0,R24
	movw R18,R12
	movw R16,R30
	xcall _ATAPIGetTotalSectors
	movw R14,R16
	movw R20,R14
;                     if (nError == IDE_OK) {
	cpi R16,0
	cpc R16,R17
	brne L109
X51:
;                         pDrive->dwTotalSectors = dwTotalSectors;
	ldd R2,y+4
	ldd R3,y+5
	ldd R4,y+6
	ldd R5,y+7
	movw R30,R22
	std z+4,R2
	std z+5,R3
	std z+6,R4
	std z+7,R5
; 
;                         //
;                         // ModeSense
;                         //
;                         ATAPI_CMD(0x5A);
	ldi R24,12
	ldi R25,0
	std y+1,R25
	std y+0,R24
	clr R18
	clr R19
	ldi R16,<_aATAPICmd
	ldi R17,>_aATAPICmd
	xcall _memset
	ldi R24,90
	sts _aATAPICmd,R24
;                         aATAPICmd[2] = 0x2A;
	ldi R24,42
	sts _aATAPICmd+2,R24
;                         aATAPICmd[7] = 0x08;
	ldi R24,8
	sts _aATAPICmd+7,R24
;                         aATAPICmd[8] = 0x00;
	clr R2
	sts _aATAPICmd+8,R2
;                         ATAPISendCommand(pDrive, pSectorBuffer, &i);
	movw R24,R28
	adiw R24,2
	std y+1,R25
	std y+0,R24
	movw R18,R12
	movw R16,R22
	xcall _ATAPISendCommand
; 
;                         //
;                         // Set Speed to 150KByte
;                         //
;                         IDEATAPISetCDSpeed(bDevice, 150);
	ldi R18,150
	ldi R19,0
	mov R16,R10
	xcall _IDEATAPISetCDSpeed
;                     } else {
	xjmp L110
L109:
;                         pDrive->dwTotalSectors = 0;
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	movw R30,R22
	std z+4,R24
	std z+5,R25
	std z+6,R26
	std z+7,R27
;                     }
L110:
; 
;                     //ATAPITest(pDrive, pSectorBuffer);
;                 }
L107:
;             }
L91:
; 
;             if (gbIntStatus & STATUS_ERROR) {
	lds R2,_gbIntStatus
	sbrs R2,0
	rjmp L114
X52:
;                 bErrorReg = IDEIn(ERROR_REG);
	lds R30,_pIDE
	lds R31,_pIDE+1
	ldd R10,z+1
;             }
L114:
;         }
L89:
; 
;     }
L87:
; 
;     return (nError);
	movw R16,R20
L86:
	.dbline 0 ; func end
	adiw R28,8
	xjmp pop_xgsetF0FC
;      bErrorReg -> R10
;        bStatus -> R12
;          pInfo -> R10,R11
;        bDevice -> R12
;         nError -> R20,R21
;              i -> R12,R13
;  pSectorBuffer -> R10,R11
;         pDrive -> R22,R23
	.even
_GetDeviceInfo:
	xcall push_xgsetF03C
	movw R10,R18
	movw R22,R16
; }
; #endif
; 
; /************************************************************/
; /*  GetDeviceInfo                                           */
; /*                                                          */
; /*  PIO data in command protocol (see ATAPI-4 r17 p224 9.7) */
; /*                                                          */
; /*  Return: IDE_OK, IDE_ERROR                               */
; /************************************************************/
; static int GetDeviceInfo(LPDRIVE pDrive, BYTE * pSectorBuffer)
; {
;     WORD i;
;     int nError;
;     BYTE bStatus;
;     BYTE bErrorReg;
;     BYTE bDevice;
;     IDEDEVICEINFO *pInfo;
; 
;     nError = IDE_ERROR;
	ldi R20,1
	ldi R21,0
;     bDevice = pDrive->bDevice;
	movw R30,R22
	ldd R12,z+3
; 
;     if (SelectDevice(bDevice) == IDE_OK) {
	mov R16,R12
	xcall _SelectDevice
	cpi R16,0
	cpc R16,R17
	breq X64
	xjmp L117
X64:
X57:
; 
;         ClearEvent(&hIDEEvent);
	ldi R16,<_hIDEEvent
	ldi R17,>_hIDEEvent
	xcall _ClearEvent
; 
; #if 0
;         IDEOut(FEATURE_REG, 0);
;         IDEOut(SECTOR_COUNT_REG, 1);
;         IDEOut(SECTOR_REG, 0);
;         IDEOut(CYLINDER_LOW_REG, 0);
;         IDEOut(CYLINDER_HIGH_REG, 0);
; #endif
; 
;         IDEOut(COMMAND_REG, COMMAND_DEVICE_INFO);
	ldi R24,236
	lds R30,_pIDE
	lds R31,_pIDE+1
	std z+7,R24
;         if (WaitForInterrupt(DISKTIMEOUT) == IDE_OK) {
	ldi R16,16
	ldi R17,39
	ldi R18,0
	ldi R19,0
	xcall _WaitForInterrupt
	cpi R16,0
	cpc R16,R17
	breq X65
	xjmp L119
X65:
X58:
; 
;             if (gbIntStatus & STATUS_DATA_REQUEST) {
	lds R2,_gbIntStatus
	sbrs R2,3
	rjmp L121
X59:
; 
;                 for (i = 0; i < IDE_SECTOR_SIZE; i = i + 2) {
	clr R12
	clr R13
	xjmp L126
L123:
;                     pSectorBuffer[i] = pIDE[DATA_READ_REG_LOW];
	movw R30,R12
	add R30,R10
	adc R31,R11
	lds R26,_pIDE
	lds R27,_pIDE+1
	subi R26,0  ; offset = 768
	sbci R27,253
	ld R2,x
	std z+0,R2
;                     if (pDrive->bIDEMode == MEM_8BIT_COMPACT_FLASH) {
	movw R30,R22
	ldd R24,z+2
	cpi R24,3
	brne L127
X60:
;                         pSectorBuffer[i + 1] = pIDE[DATA_READ_REG_LOW];
	movw R30,R12
	adiw R30,1
	add R30,R10
	adc R31,R11
	lds R26,_pIDE
	lds R27,_pIDE+1
	subi R26,0  ; offset = 768
	sbci R27,253
	ld R2,x
	std z+0,R2
;                     } else {
	xjmp L128
L127:
;                         pSectorBuffer[i + 1] = pIDE[DATA_READ_REG_HIGH];
	movw R30,R12
	adiw R30,1
	add R30,R10
	adc R31,R11
	lds R26,_pIDE
	lds R27,_pIDE+1
	subi R26,0  ; offset = 1024
	sbci R27,252
	ld R2,x
	std z+0,R2
;                     }
L128:
;                 }
L124:
	movw R24,R12
	adiw R24,2
	movw R12,R24
L126:
	movw R24,R12
	cpi R24,0
	ldi R30,2
	cpc R25,R30
	brsh X66
	xjmp L123
X66:
X61:
; 
;                 //
;                 // Status register is read to clear
;                 // pending interrupts.
;                 //
;                 bStatus = IDEIn(STATUS_REG);
	lds R30,_pIDE
	lds R31,_pIDE+1
	ldd R12,z+7
; 
;                 pInfo = (IDEDEVICEINFO *) pSectorBuffer;
; 
; #if (IDE_SUPPORT_CHS == 1)
;                 pDrive->wCylinders = (WORD) pInfo->Cylinders;
;                 pDrive->wHeads = (BYTE) pInfo->Heads;
;                 pDrive->wSectorsPerTrack = (BYTE) pInfo->SectorsPerTrack;
;                 pDrive->dwOneSide = pDrive->wCylinders * pDrive->wSectorsPerTrack;
; #endif
; 
;                 if (pInfo->LBASectors > 0) {
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	movw R30,R10
	subi R30,136  ; addi 120
	sbci R31,255
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	cp R2,R24
	cpc R3,R25
	cpc R4,R26
	cpc R5,R27
	breq L129
X62:
;                     pDrive->wFlags = IDE_READY | IDE_SUPPORT_LBA;
	ldi R24,32769
	ldi R25,128
	movw R30,R22
	std z+1,R25
	std z+0,R24
;                     pDrive->dwTotalSectors = pInfo->LBASectors;
	movw R30,R10
	subi R30,136  ; addi 120
	sbci R31,255
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	movw R30,R22
	std z+4,R2
	std z+5,R3
	std z+6,R4
	std z+7,R5
;                 } else {
L129:
; 
; #if (IDE_SUPPORT_CHS == 1)
;                     pDrive->wFlags = IDE_READY;
;                     pDrive->dwTotalSectors = pInfo->Cylinders;
;                     pDrive->dwTotalSectors *= pInfo->Heads;
;                     pDrive->dwTotalSectors *= pInfo->SectorsPerTrack;
; #endif
; 
;                 }
L130:
; 
;                 nError = IDE_OK;
	clr R20
	clr R21
;             }
L121:
; 
;             if (gbIntStatus & STATUS_ERROR) {
	lds R2,_gbIntStatus
	sbrs R2,0
	rjmp L131
X63:
;                 bErrorReg = IDEIn(ERROR_REG);
	lds R30,_pIDE
	lds R31,_pIDE+1
	ldd R10,z+1
;             }
L131:
;         }
L119:
; 
;     }
L117:
; 
;     return (nError);
	movw R16,R20
L116:
	.dbline 0 ; func end
	xjmp pop_xgsetF03C
;  bSectorNumber -> R18
;   bSectorCount -> R18
;  bCylinderHigh -> R18
;   bCylinderLow -> R20
;  nPacketDevice -> R16,R17
	.even
_IsPacketDevice:
	st -y,R20
	st -y,R21
; }
; 
; /************************************************************/
; /*  IsPacketDevice                                          */
; /*                                                          */
; /*  Check Command block register,                           */
; /*  see page 210, 9.1 Signature and persistence             */
; /*                                                          */
; /*  Return: TRUE, FALSE                                     */
; /************************************************************/
; #if (IDE_SUPPORT_ATAPI == 1)
; static int IsPacketDevice(void)
; {
;     int nPacketDevice;
;     BYTE bSectorCount;
;     BYTE bSectorNumber;
;     BYTE bCylinderLow;
;     BYTE bCylinderHigh;
; 
;     nPacketDevice = FALSE;
	clr R16
	clr R17
; 
;     bSectorCount = IDEIn(SECTOR_COUNT_REG);
	lds R30,_pIDE
	lds R31,_pIDE+1
	ldd R18,z+2
;     bSectorNumber = IDEIn(SECTOR_REG);
	ldd R18,z+3
;     bCylinderLow = IDEIn(CYLINDER_LOW_REG);
	ldd R20,z+4
;     bCylinderHigh = IDEIn(CYLINDER_HIGH_REG);
	ldd R18,z+5
; 
; 
;     if ((bCylinderLow == 0x14) && (bCylinderHigh == 0xEB)) {
	cpi R20,20
	brne L134
X67:
	cpi R18,235
	brne L134
X68:
;         nPacketDevice = TRUE;
	ldi R16,1
;     }
L134:
; 
;     return (nPacketDevice);
L133:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
;        bResult -> R22
;         nError -> R20,R21
;         pDrive -> R10,R11
	.even
_DeviceDiag:
	xcall push_xgsetF00C
	movw R10,R16
; }
; #else
; static int IsPacketDevice(void)
; {
;     return (FALSE);
; }
; #endif
; 
; /************************************************************/
; /*  DeviceDiag                                              */
; /*                                                          */
; /*  NON-data command protocol (see ATAPI-4 r17 p231 9.9)    */
; /*                                                          */
; /*  Return: IDE_OK, IDE_ERROR                               */
; /************************************************************/
; static int DeviceDiag(LPDRIVE pDrive)
; {
;     int nError;
;     BYTE bResult;
; 
;     nError = IDE_ERROR;
	ldi R20,1
	ldi R21,0
; 
;     if (SelectDevice(0) == IDE_OK) {
	clr R16
	xcall _SelectDevice
	cpi R16,0
	cpc R16,R17
	brne L137
X69:
; 
; #if 0
;         IDEOut(FEATURE_REG, 0);
;         IDEOut(SECTOR_COUNT_REG, 1);
;         IDEOut(SECTOR_REG, 0);
;         IDEOut(CYLINDER_LOW_REG, 0);
;         IDEOut(CYLINDER_HIGH_REG, 0);
; #endif
; 
;         ClearEvent(&hIDEEvent);
	ldi R16,<_hIDEEvent
	ldi R17,>_hIDEEvent
	xcall _ClearEvent
; 
;         //
;         // Check if we are a PACKET device
;         //
;         if (IsPacketDevice() == TRUE) {
	xcall _IsPacketDevice
	cpi R16,1
	ldi R30,0
	cpc R17,R30
	brne L139
X70:
;             nError = IDE_OK;
	clr R20
;             pDrive->wFlags = IDE_SUPPORT_PACKET;
	ldi R24,4
	ldi R25,0
	movw R30,R10
	std z+1,R25
	std z+0,R24
;         } else {
	xjmp L140
L139:
; 
;             IDEOut(COMMAND_REG, COMMAND_DIAG);
	ldi R24,144
	lds R30,_pIDE
	lds R31,_pIDE+1
	std z+7,R24
;             if (WaitForInterrupt(INITTIMEOUT) == IDE_OK) {
	ldi R16,16
	ldi R17,39
	ldi R18,0
	ldi R19,0
	xcall _WaitForInterrupt
	movw R10,R16
	cpi R16,0
	cpc R16,R17
	brne L141
X71:
; 
;                 bResult = IDEIn(ERROR_REG);
	lds R30,_pIDE
	lds R31,_pIDE+1
	ldd R22,z+1
;                 if (bResult == 0x01) {  // see ATAPI-4 r17 p72
	cpi R22,1
	brne L143
X72:
;                     nError = IDE_OK;
	clr R20
	clr R21
;                 }
L143:
; 
;             }
L141:
;         }
L140:
;     }
L137:
; 
;     return (nError);
	movw R16,R20
L136:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
;         bValue -> R10
;      bErrorReg -> R10
;        bStatus -> R12
;              i -> R14,R15
;         nError -> y+2
;         pDrive -> y+0
;              x -> R10,R11
;   wSectorCount -> y+20
;  dwStartSector -> y+16
;          pData -> y+14
;        bDevice -> R10
	.even
_ReadSectors:
	st -y,r19
	st -y,r18
	xcall push_xgsetF0FC
	mov R10,R16
	sbiw R28,4
; }
; 
; /************************************************************/
; /*  ReadSectors                                             */
; /*                                                          */
; /*  PIO data in command protocol, see ATAPI-4 r17 p224 9.7  */
; /*                                                          */
; /*  Return: IDE_OK, IDE_ERROR                               */
; /************************************************************/
; static int ReadSectors(BYTE bDevice, BYTE * pData, DWORD dwStartSector, WORD wSectorCount)
; {
;     WORD i, x;
;     int nError;
;     BYTE bValue;
;     BYTE bErrorReg;
;     BYTE bStatus;
;     LPDRIVE pDrive;
; 
; #if (IDE_SUPPORT_CHS == 1)
;     WORD wCHSSector;
;     WORD wCHSHead;
;     WORD wCHSCylinder;
; #endif
; 
;     pDrive = &sDrive[bDevice];
	ldi R24,10
	mul R24,R10
	movw R2,R0
	ldi R24,<_sDrive
	ldi R25,>_sDrive
	add R2,R24
	adc R3,R25
	std y+1,R3
	std y+0,R2
;     nError = SelectDevice(bDevice);
	mov R16,R10
	xcall _SelectDevice
	std y+3,R17
	std y+2,R16
; 
; #if (IDE_SUPPORT_CHS == 0)
;     //
;     // NO CHS support
;     //
;     if ((pDrive->wFlags & IDE_SUPPORT_LBA) == 0) {
	ldd R30,y+0
	ldd R31,y+1
	ldd R2,z+0
	ldd R3,z+1
	sbrc R2,0
	rjmp L146
X73:
;         //
;         // If we have a CHS device, this is an ERROR
;         //
;         nError = IDE_ERROR;
	ldi R24,1
	ldi R25,0
	std y+3,R25
	std y+2,R24
;     }
L146:
; #endif
; 
;     if (nError == IDE_OK) {
	ldd R0,y+2
	ldd R1,y+3
	tst R0
	breq X81
	xjmp L148
X81:
	tst R1
	breq X82
	xjmp L148
X82:
X74:
; 
;         ClearEvent(&hIDEEvent);
	ldi R16,<_hIDEEvent
	ldi R17,>_hIDEEvent
	xcall _ClearEvent
; 
;         if (pDrive->wFlags & IDE_SUPPORT_LBA) {
	ldd R30,y+0
	ldd R31,y+1
	ldd R2,z+0
	ldd R3,z+1
	sbrs R2,0
	rjmp L150
X75:
;             //
;             // LBA
;             //
;             bValue = (BYTE) ((bDevice << 4) | 0xE0 | (dwStartSector >> 24));
	ldi R24,24
	ldi R25,0
	ldd R16,y+16
	ldd R17,y+17
	ldd R18,y+18
	ldd R19,y+19
	st -y,R24
	xcall lsr32
	mov R24,R10
	clr R25
	lsl R24
	rol R25
	lsl R24
	rol R25
	lsl R24
	rol R25
	lsl R24
	rol R25
	ori R24,224
	movw R2,R24
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	or R2,R16
	or R3,R17
	or R4,R18
	or R5,R19
	mov R10,R2
;             IDEOut(DISK_HEAD_REG, bValue);
	lds R30,_pIDE
	lds R31,_pIDE+1
	std z+6,R10
;             IDEOut(LBA_16_23, (BYTE) (dwStartSector >> 16));
	ldd R2,y+16
	ldd R3,y+17
	ldd R4,y+18
	ldd R5,y+19
	movw R2,R4
	clr R4
	clr R5
	lds R30,_pIDE
	lds R31,_pIDE+1
	std z+5,R2
;             IDEOut(LBA_8_15, (BYTE) (dwStartSector >> 8));
	ldi R24,8
	ldi R25,0
	ldd R16,y+16
	ldd R17,y+17
	ldd R18,y+18
	ldd R19,y+19
	st -y,R24
	xcall lsr32
	lds R30,_pIDE
	lds R31,_pIDE+1
	std z+4,R16
;             IDEOut(LBA_0_7, (BYTE) (dwStartSector));
	ldd R2,y+16
	ldd R3,y+17
	ldd R4,y+18
	ldd R5,y+19
	lds R30,_pIDE
	lds R31,_pIDE+1
	std z+3,R2
; 
;             IDEOut(SECTOR_COUNT_REG, (BYTE) (wSectorCount & 0xff));
	ldd R24,y+20
	ldd R25,y+21
	andi R25,0
	lds R30,_pIDE
	lds R31,_pIDE+1
	std z+2,R24
;             IDEOut(COMMAND_REG, COMMAND_READ_SECTORS);
	ldi R24,32
	lds R30,_pIDE
	lds R31,_pIDE+1
	std z+7,R24
; 
; #if (IDE_SUPPORT_CHS == 1)
;         } else {
;             //
;             // CHS
;             //
;             wCHSSector = (WORD) (dwStartSector % pDrive->wSectorsPerTrack) + 1;
;             wCHSHead = (WORD) (dwStartSector / pDrive->dwOneSide);
;             dwStartSector = dwStartSector % pDrive->dwOneSide;
;             wCHSCylinder = (WORD) (dwStartSector / pDrive->wSectorsPerTrack);
; 
;             wCHSHead |= (bDevice << 4) | 0xA0;
; 
;             IDEOut(DISK_HEAD_REG, (BYTE) wCHSHead);
;             IDEOut(SECTOR_REG, (BYTE) wCHSSector);
;             IDEOut(CYLINDER_LOW_REG, (BYTE) (wCHSCylinder & 0x00FF));
;             IDEOut(CYLINDER_HIGH_REG, (BYTE) (wCHSCylinder >> 8));
; 
;             IDEOut(SECTOR_COUNT_REG, (BYTE) (wSectorCount & 0xff));
;             IDEOut(COMMAND_REG, COMMAND_READ_SECTORS);
; #endif
;         }
L150:
; 
;         for (i = 0; i < wSectorCount; i++) {
	clr R14
	clr R15
	xjmp L155
L152:
;             nError = WaitForInterrupt(DISKTIMEOUT);
	ldi R16,16
	ldi R17,39
	ldi R18,0
	ldi R19,0
	xcall _WaitForInterrupt
	std y+3,R17
	std y+2,R16
;             if (nError == IDE_OK) {
	movw R0,R16
	cpi R16,0
	cpc R16,R17
	breq X83
	xjmp L156
X83:
X76:
;                 bStatus = gbIntStatus;
	lds R12,_gbIntStatus
; 
;                 if (bStatus & STATUS_ERROR) {
	sbrs R12,0
	rjmp L158
X77:
;                     bErrorReg = IDEIn(ERROR_REG);
	lds R30,_pIDE
	lds R31,_pIDE+1
	ldd R10,z+1
;                     nError = IDE_ERROR;
	ldi R24,1
	ldi R25,0
	std y+3,R25
	std y+2,R24
;                     break;
	xjmp L154
L158:
;                 }
; 
;                 for (x = 0; x < IDE_SECTOR_SIZE; x = x + 2) {
	clr R10
	clr R11
	xjmp L163
L160:
;                     pData[x] = pIDE[DATA_READ_REG_LOW];
	movw R30,R10
	ldd R0,y+14
	ldd R1,y+15
	add R30,R0
	adc R31,R1
	lds R26,_pIDE
	lds R27,_pIDE+1
	subi R26,0  ; offset = 768
	sbci R27,253
	ld R2,x
	std z+0,R2
;                     if (pDrive->bIDEMode == MEM_8BIT_COMPACT_FLASH) {
	ldd R30,y+0
	ldd R31,y+1
	ldd R24,z+2
	cpi R24,3
	brne L164
X78:
;                         pData[x + 1] = pIDE[DATA_READ_REG_LOW];
	movw R30,R10
	adiw R30,1
	add R30,R0
	adc R31,R1
	lds R26,_pIDE
	lds R27,_pIDE+1
	subi R26,0  ; offset = 768
	sbci R27,253
	ld R2,x
	std z+0,R2
;                     } else {
	xjmp L165
L164:
;                         pData[x + 1] = pIDE[DATA_READ_REG_HIGH];
	movw R30,R10
	adiw R30,1
	ldd R0,y+14
	ldd R1,y+15
	add R30,R0
	adc R31,R1
	lds R26,_pIDE
	lds R27,_pIDE+1
	subi R26,0  ; offset = 1024
	sbci R27,252
	ld R2,x
	std z+0,R2
;                     }
L165:
;                 }
L161:
	movw R24,R10
	adiw R24,2
	movw R10,R24
L163:
	movw R24,R10
	cpi R24,0
	ldi R30,2
	cpc R25,R30
	brsh X84
	xjmp L160
X84:
X79:
; 
;                 pData += IDE_SECTOR_SIZE;
	ldd R24,y+14
	ldd R25,y+15
	subi R24,0  ; offset = 512
	sbci R25,254
	std y+15,R25
	std y+14,R24
; 
;             } else {
	xjmp L157
L156:
;                 bStatus = IDEIn(STATUS_REG);
	lds R30,_pIDE
	lds R31,_pIDE+1
	ldd R12,z+7
;                 bErrorReg = IDEIn(ERROR_REG);
	ldd R10,z+1
;             }
L157:
;         }
L153:
	movw R24,R14
	adiw R24,1
	movw R14,R24
L155:
	ldd R0,y+20
	ldd R1,y+21
	cp R14,R0
	cpc R15,R1
	brsh X85
	xjmp L152
X85:
X80:
L154:
; 
;         bStatus = IDEIn(STATUS_REG);
	lds R30,_pIDE
	lds R31,_pIDE+1
	ldd R12,z+7
; 
;     }
L148:
;     /* SelectDevice */
;     return (nError);
	ldd R16,y+2
	ldd R17,y+3
L145:
	.dbline 0 ; func end
	adiw R28,4
	xcall pop_xgsetF0FC
	adiw R28,2
	ret
;  pSectorBuffer -> R10,R11
;     bNewStatus -> R20
;            arg -> R10,R11
	.even
_CFChange::
	xcall push_xgset300C
	movw R10,R16
	sbiw R28,2
; }
; 
; #if (IDE_SUPPORT_WRITE == 1)
; /************************************************************/
; /*  WriteSectors                                            */
; /*                                                          */
; /*  PIO data out command protocol, see ATAPI-4 r17 p227 9.8 */
; /*                                                          */
; /*  Return: IDE_OK, IDE_ERROR                               */
; /************************************************************/
; static BYTE WriteSectors(WORD bDevice, BYTE * pData, DWORD dwStartSector, WORD wSectorCount)
; {
;     WORD i;
;     int x;
;     int nError;
;     BYTE bValue;
;     BYTE bStatus;
;     BYTE bErrorReg;
;     LPDRIVE pDrive;
; 
; #if (IDE_SUPPORT_CHS == 1)
;     WORD wCHSSector;
;     WORD wCHSHead;
;     WORD wCHSCylinder;
; #endif
; 
;     pDrive = &sDrive[bDevice];
;     nError = SelectDevice(bDevice);
; 
; #if (IDE_SUPPORT_CHS == 0)
;     //
;     // NO CHS support
;     //
;     if ((pDrive->wFlags & IDE_SUPPORT_LBA) == 0) {
;         //
;         // If we found a CHS device, this is an ERROR
;         //
;         nError = IDE_ERROR;
;     }
; #endif
; 
;     if (nError == IDE_OK) {
; 
;         if (pDrive->wFlags & IDE_SUPPORT_LBA) {
;             //
;             // LBA
;             //
;             bValue = (BYTE) ((bDevice << 4) | 0xE0 | (dwStartSector >> 24));
;             IDEOut(DISK_HEAD_REG, bValue);
;             IDEOut(LBA_16_23, (BYTE) (dwStartSector >> 16));
;             IDEOut(LBA_8_15, (BYTE) (dwStartSector >> 8));
;             IDEOut(LBA_0_7, (BYTE) (dwStartSector));
; 
;             IDEOut(SECTOR_COUNT_REG, (BYTE) (wSectorCount & 0xff));
;             IDEOut(COMMAND_REG, COMMAND_WRITE_SECTORS);
; 
; #if (IDE_SUPPORT_CHS == 1)
;         } else {
;             //
;             // CHS
;             //
;             wCHSSector = (WORD) (dwStartSector % pDrive->wSectorsPerTrack) + 1;
;             wCHSHead = (WORD) (dwStartSector / pDrive->dwOneSide);
;             dwStartSector = dwStartSector % pDrive->dwOneSide;
;             wCHSCylinder = (WORD) (dwStartSector / pDrive->wSectorsPerTrack);
; 
;             wCHSHead |= (bDevice << 4) | 0xA0;
; 
;             IDEOut(DISK_HEAD_REG, (BYTE) wCHSHead);
;             IDEOut(SECTOR_REG, (BYTE) wCHSSector);
;             IDEOut(CYLINDER_LOW_REG, (BYTE) (wCHSCylinder & 0x00FF));
;             IDEOut(CYLINDER_HIGH_REG, (BYTE) (wCHSCylinder >> 8));
; 
;             IDEOut(SECTOR_COUNT_REG, (BYTE) (wSectorCount & 0xff));
;             IDEOut(COMMAND_REG, COMMAND_WRITE_SECTORS);
; #endif
;         }
; 
;         if (WaitDRQ(CONTROLLERTIMEOUT) == IDE_OK) {
; 
;             bStatus = IDEIn(STATUS_REG);
;             for (i = 0; i < wSectorCount; i++) {
; 
;                 for (x = 0; x < IDE_SECTOR_SIZE; x = x + 2) {
;                     if (pDrive->bIDEMode == MEM_8BIT_COMPACT_FLASH) {
;                         IDEOut(DATA_WRITE_REG_LOW, pData[x]);
;                         IDEOut(DATA_WRITE_REG_LOW, pData[x + 1]);
;                     } else {
;                         IDEOut(DATA_WRITE_REG_HIGH, pData[x + 1]);
;                         IDEOut(DATA_WRITE_REG_LOW, pData[x]);
;                     }
;                 }
; 
;                 pData += IDE_SECTOR_SIZE;
; 
;                 nError = WaitForInterrupt(DISKTIMEOUT);
;                 if (nError == IDE_OK) {
;                     bStatus = gbIntStatus;
; 
;                     if ((bStatus & STATUS_ERROR) == STATUS_ERROR) {
;                         bErrorReg = IDEIn(ERROR_REG);
;                         nError = IDE_ERROR;
;                         break;
;                     }
;                 } else {
;                     //
;                     // Error
;                     //
;                     nError = IDE_ERROR;
;                     break;
;                 }
;             }
; 
;         } else {
;             //
;             // Device: Set error status (D)
;             //
;             WaitForInterrupt(DISKTIMEOUT);
;             bErrorReg = IDEIn(ERROR_REG);
;         }                       /* endif WaitDRQ */
; 
;     }
;     /* SelectDevice */
;     return (nError);
; }
; #endif
; 
; /************************************************************/
; /*  CFChange                                                */
; /************************************************************/
; THREAD(CFChange, arg)
; {
	xjmp L168
L167:
;     BYTE bNewStatus;
;     BYTE *pSectorBuffer;
; 
;     while (1) {
; 
;         NutEventWaitNext(&hCFChangeInt, 0);
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+0,R26
	std y+1,R27
	movw R18,R24
	ldi R16,<_hCFChangeInt
	ldi R17,>_hCFChangeInt
	xcall _NutEventWaitNext
;         //
;         // Wait a while, that the cf contact is stable and not to bounce.
;         //
;         NutSleep(2000);
	ldi R16,208
	ldi R17,7
	ldi R18,0
	ldi R19,0
	xcall _NutSleep
; 
;         bNewStatus = (PINE & BV(CF_IRQ));
	in R20,0x1
	andi R20,64
;         if (bNewStatus != gbCFMountStatus) {
	lds R2,_gbCFMountStatus
	cp R20,R2
	brne X92
	xjmp L170
X92:
X86:
; 
;             if (bNewStatus == CF_AVAILABLE) {
	tst R20
	brne L172
X87:
;                 gbCFMountStatus = CF_AVAILABLE;
	clr R2
	sts _gbCFMountStatus,R2
;                 //
;                 // We must mount the new CF card.
;                 //
;                 HardwareReset(&sDrive[0]);
	ldi R16,<_sDrive
	ldi R17,>_sDrive
	xcall _HardwareReset
; 
;                 pSectorBuffer = (BYTE *) NutHeapAlloc(IDE_SECTOR_SIZE);
	ldi R16,512
	ldi R17,2
	xcall _NutHeapAlloc
	movw R10,R16
;                 if (pSectorBuffer != NULL) {
	cpi R16,0
	cpc R16,R17
	breq L174
X88:
;                     IDEMountDevice(IDE_DRIVE_C, pSectorBuffer);
	movw R18,R10
	clr R16
	xcall _IDEMountDevice
;                     NutHeapFree(pSectorBuffer);
	movw R16,R10
	xcall _NutHeapFree
; 
;                     if (pUserMountFunc != NULL) {
	lds R2,_pUserMountFunc
	lds R3,_pUserMountFunc+1
	tst R2
	brne X89
	tst R3
	breq L176
X89:
;                         pUserMountFunc(IDE_DRIVE_C);
	clr R16
	clr R17
	movw R30,R2
	xcall  xicall
;                     }
L176:
;                 }
L174:
; 
;                 NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
;                 EICR &= ~CF_INT_SENS_MASK;
	in R24,0x3a
	andi R24,207
	out 0x3a,R24
;                 EICR |= CF_INT_RISING_EDGE;
	in R24,0x3a
	ori R24,48
	out 0x3a,R24
;                 NutExitCritical();
	pop R0
	out 0x3F, R0
	
; 
;             } else {
	xjmp L173
L172:
;                 gbCFMountStatus = CF_NOT_AVAILABLE;
	ldi R24,1
	sts _gbCFMountStatus,R24
;                 //
;                 // The user has removed the CF card,
;                 // now UnMount the device.
;                 //
;                 IDEUnMountDevice(IDE_DRIVE_C);
	clr R16
	xcall _IDEUnMountDevice
; 
;                 if (pUserUnMountFunc != NULL) {
	lds R2,_pUserUnMountFunc
	lds R3,_pUserUnMountFunc+1
	tst R2
	brne X90
	tst R3
	breq L178
X90:
;                     pUserUnMountFunc(IDE_DRIVE_C);
	clr R16
	clr R17
	movw R30,R2
	xcall  xicall
;                 }
L178:
; 
;                 NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
;                 EICR &= ~CF_INT_SENS_MASK;
	in R24,0x3a
	andi R24,207
	out 0x3a,R24
;                 EICR |= CF_INT_FALLING_EDGE;
	in R24,0x3a
	ori R24,32
	out 0x3a,R24
;                 NutExitCritical();
	pop R0
	out 0x3F, R0
	
;             }
L173:
;         }                       /* endif bValue != gbCFMountStatus */
L170:
;     }                           /* end while */
L168:
	xjmp L167
X91:
L166:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgset300C
;         bValue -> R20
;         nError -> R10,R11
;              i -> R10,R11
;   pUnMountFunc -> y+12
;     pMountFunc -> y+10
;       nIDEMode -> R20,R21
;   nBaseAddress -> R22,R23
	.even
_IDEInit::
	xcall push_xgsetF00C
	movw R20,R18
	movw R22,R16
	sbiw R28,4
; }
; 
; /*==========================================================*/
; /*  DEFINE: All code exported                               */
; /*==========================================================*/
; /************************************************************/
; /*  IDEInit                                                 */
; /************************************************************/
; int IDEInit(int nBaseAddress, int nIDEMode, IDE_MOUNT_FUNC * pMountFunc, IDE_MOUNT_FUNC * pUnMountFunc)
; {
;     int i;
;     int nError;
;     BYTE bValue;
; 
;     pUserMountFunc = pMountFunc;
	ldd R0,y+10
	ldd R1,y+11
	sts _pUserMountFunc+1,R1
	sts _pUserMountFunc,R0
;     pUserUnMountFunc = pUnMountFunc;
	ldd R0,y+12
	ldd R1,y+13
	sts _pUserUnMountFunc+1,R1
	sts _pUserUnMountFunc,R0
; 
;     //
;     // If nBaseAddress is 0, we use the default address
;     //
;     if (nBaseAddress == 0) {
	cpi R22,0
	cpc R22,R23
	brne L181
X93:
;         nBaseAddress = IDE_BASE_ADDRESS;
	ldi R22,57344
	ldi R23,224
;     }
L181:
;     //
;     // With MCUCR 0xC0 and XMCRA 0x02 we set:
;     //
;     // Wait two cycles during read/write and
;     // wait one cycle before driving out new address.
;     // This setting is for 0x1100 - 0xffff
;     //
; #ifdef __AVR_ENHANCED__
;     XMCRA = _BV(SRW11);
	ldi R24,2
	sts 109,R24
; #endif
; 
;     //
;     // Enable the IDE Reset
;     //
;     DDRD = 0x20;
	ldi R24,32
	out 0x11,R24
; 
; 
;     for (i = 0; i < IDE_MAX_SUPPORTED_DEVICE; i++) {
	clr R10
	clr R11
L183:
;         memset((BYTE *) & sDrive[i], 0x00, sizeof(DRIVE));
	ldi R24,10
	ldi R25,0
	std y+1,R25
	std y+0,R24
	clr R18
	clr R19
	ldi R16,10
	ldi R17,0
	push R18
	push R19
	movw R18,R10
	xcall empy16s
	movw R2,R16
	pop R19
	pop R18
	ldi R24,<_sDrive
	ldi R25,>_sDrive
	add R2,R24
	adc R3,R25
	movw R16,R2
	xcall _memset
; 
;         sDrive[i].bDevice = (BYTE) i;
	ldi R16,10
	ldi R17,0
	movw R18,R10
	xcall empy16s
	movw R30,R16
	ldi R24,<_sDrive+3
	ldi R25,>_sDrive+3
	add R30,R24
	adc R31,R25
	std z+0,R10
;         sDrive[i].bIDEMode = (BYTE) nIDEMode;
	ldi R16,10
	ldi R17,0
	movw R18,R10
	xcall empy16s
	movw R30,R16
	ldi R24,<_sDrive+2
	ldi R25,>_sDrive+2
	add R30,R24
	adc R31,R25
	std z+0,R20
;     }
L184:
	movw R24,R10
	adiw R24,1
	movw R10,R24
	cpi R24,1
	ldi R30,0
	cpc R25,R30
	brge X102
	xjmp L183
X102:
X94:
; 
;     IDESemaInit();
	xcall _IDESemaInit
; 
;     pIDE = (unsigned char *) nBaseAddress;
	sts _pIDE+1,R23
	sts _pIDE,R22
; 
;     ClearEvent(&hIDEEvent);
	ldi R16,<_hIDEEvent
	ldi R17,>_hIDEEvent
	xcall _ClearEvent
; 
;     NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
; 
;     //
;     // Clear interrupt status
;     //
;     gbIntStatus = 0;
	clr R2
	sts _gbIntStatus,R2
; 
;     //
;     // Install IDE interrupt
;     //
;     nError = NutRegisterIrqHandler(&sig_INTERRUPT7, IDEInterrupt, NULL);
	clr R3
	std y+1,R3
	std y+0,R2
	ldi R18,<PL_IDEInterrupt
	ldi R19,>PL_IDEInterrupt
	ldi R16,<_sig_INTERRUPT7
	ldi R17,>_sig_INTERRUPT7
	xcall _NutRegisterIrqHandler
	movw R10,R16
;     if (nError == FALSE) {
	cpi R16,0
	cpc R16,R17
	brne L189
X95:
;         EICR |= IDE_INT_RISING_EDGE;
	in R24,0x3a
	ori R24,192
	out 0x3a,R24
;         sbi(EIMSK, IDE_IRQ);
	in R24,0x39
	ori R24,128
	out 0x39,R24
;     }
L189:
; 
;     switch (nIDEMode) {
	cpi R20,0
	cpc R20,R21
	brne X103
	xjmp L192
X103:
X96:
	cpi R20,1
	ldi R30,0
	cpc R21,R30
	breq L194
X97:
	cpi R20,2
	ldi R30,0
	cpc R21,R30
	breq L192
X98:
	cpi R20,3
	ldi R30,0
	cpc R21,R30
	breq L196
X99:
	xjmp L191
L194:
;     case IDE_HARDDISK:{
;             break;
;         }
; 
;         //
;         // If your drive does not work correct with 14.7456Mhz,
;         // try to devide the clock by 2.
;         //
;         // Important: You must correct the baudrate in your app.
;         // if you set 115200, you get only 57600.
;         //
;     case IDE_HARDDISK_7MHZ:{
; #if defined(CLKPR) /* AT90MEGA128 uses a clock prescaler register */
;             CLKPR = _BV(CLKPCE); // Enable clock speed change
;             CLKPR = 2; // Run at half the clock speed
; #else
;             XDIV = 0xff;
	ldi R24,255
	out 0x3c,R24
; #endif
;             break;
	xjmp L192
L196:
;         }
;     case IDE_COMPACT_FLASH:{
;             break;
;         }
;     case MEM_8BIT_COMPACT_FLASH:{
;             //
;             // Now we will support to change the CF-Card in
;             // a running system, therefore we must install
;             // a INT handler and some other parts :-)
;             //
; 
;             //
;             // Clear CF_INT_SENS_MASK.
;             //
;             EICR &= ~CF_INT_SENS_MASK;
	in R24,0x3a
	andi R24,207
	out 0x3a,R24
; 
;             //
;             // Check the status of the compact flash.
;             //
;             bValue = (PINE & BV(CF_IRQ));
	in R20,0x1
	andi R20,64
;             if (bValue == CF_AVAILABLE) {
	brne L197
X100:
;                 gbCFMountStatus = CF_AVAILABLE;
	clr R2
	sts _gbCFMountStatus,R2
; 
;                 //
;                 // The rising edge between two samples
;                 // of INTX generates an interrupt request.
;                 //
;                 EICR |= CF_INT_RISING_EDGE;
	in R24,0x3a
	ori R24,48
	out 0x3a,R24
;             } else {
	xjmp L198
L197:
;                 gbCFMountStatus = CF_NOT_AVAILABLE;
	ldi R24,1
	sts _gbCFMountStatus,R24
; 
;                 //
;                 // The falling edge between two samples
;                 // of INTX generates an interrupt request.
;                 //
;                 EICR |= CF_INT_FALLING_EDGE;
	in R24,0x3a
	ori R24,32
	out 0x3a,R24
;             }
L198:
; 
;             nError = NutRegisterIrqHandler(&sig_INTERRUPT6, CFInterrupt, NULL);
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	ldi R18,<PL_CFInterrupt
	ldi R19,>PL_CFInterrupt
	ldi R16,<_sig_INTERRUPT6
	ldi R17,>_sig_INTERRUPT6
	xcall _NutRegisterIrqHandler
	movw R10,R16
;             if (nError == FALSE) {
	cpi R16,0
	cpc R16,R17
	brne L192
X101:
;                 NutThreadCreate("cfchange", CFChange, NULL, 640);
	ldi R24,640
	ldi R25,2
	std y+3,R25
	std y+2,R24
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	ldi R18,<PL_CFChange
	ldi R19,>PL_CFChange
	ldi R16,<L201
	ldi R17,>L201
	xcall _NutThreadCreate
;                 sbi(EIMSK, CF_IRQ);
	in R24,0x39
	ori R24,64
	out 0x39,R24
;             }
; 
;             break;
L191:
L192:
;         }
;     }
;     NutExitCritical();
	pop R0
	out 0x3F, R0
	
; 
;     HardwareReset(&sDrive[0]);
	ldi R16,<_sDrive
	ldi R17,>_sDrive
	xcall _HardwareReset
; 
;     nError = IDE_OK;
	clr R10
	clr R11
; 
;     return (nError);
	movw R16,R10
L180:
	.dbline 0 ; func end
	adiw R28,4
	xjmp pop_xgsetF00C
;         nError -> R20,R21
;         pDrive -> R22,R23
;  pSectorBuffer -> R10,R11
;        bDevice -> R12
	.even
_IDEMountDevice::
	xcall push_xgsetF03C
	movw R10,R18
	mov R12,R16
; }
; 
; /************************************************************/
; /*  IDEMountDevice                                          */
; /************************************************************/
; int IDEMountDevice(BYTE bDevice, BYTE * pSectorBuffer)
; {
;     int nError;
;     LPDRIVE pDrive;
; 
;     pDrive = NULL;
	clr R22
	clr R23
; 
;     IDELock();
	xcall _IDELock
; 
;     if (bDevice >= IDE_MAX_SUPPORTED_DEVICE) {
	mov R24,R12
	cpi R24,1
	brlo L203
X104:
;         nError = IDE_ERROR;
	ldi R20,1
	ldi R21,0
;     } else {
	xjmp L204
L203:
;         pDrive = &sDrive[bDevice];
	ldi R24,10
	mul R24,R12
	movw R22,R0
	ldi R24,<_sDrive
	ldi R25,>_sDrive
	add R22,R24
	adc R23,R25
; 
;         pDrive->wFlags = 0;
	clr R2
	clr R3
	movw R30,R22
	std z+1,R3
	std z+0,R2
; 
; #if (IDE_SUPPORT_CHS == 1)
;         //
;         // CHS values
;         //
;         pDrive->wCylinders = 0;
;         pDrive->wHeads = 0;
;         pDrive->wSectorsPerTrack = 0;
; #endif
; 
;         //
;         // LBA value
;         //
;         pDrive->dwTotalSectors = 0;
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std z+4,R24
	std z+5,R25
	std z+6,R26
	std z+7,R27
; 
;         nError = DeviceDiag(pDrive);
	movw R16,R30
	xcall _DeviceDiag
	movw R20,R16
;         if (pDrive->wFlags & IDE_SUPPORT_PACKET) {
	movw R30,R22
	ldd R2,z+0
	ldd R3,z+1
	sbrs R2,2
	rjmp L205
X105:
; #if (IDE_SUPPORT_ATAPI == 1)
;             pDrive->wSectorSize = ATAPI_SECTOR_SIZE;
	ldi R24,2048
	ldi R25,8
	std z+9,R25
	std z+8,R24
;             nError = GetDeviceInfoPacket(pDrive, pSectorBuffer);
	movw R18,R10
	movw R16,R30
	xcall _GetDeviceInfoPacket
	movw R20,R16
;             if (pDrive->wFlags & IDE_READY) {
	movw R30,R22
	ldd R2,z+0
	ldd R3,z+1
	sbrs R3,7
	rjmp L206
X106:
;                 nError = IDE_OK;
	clr R20
	clr R21
;             }
; #endif
;         } else {
	xjmp L206
L205:
;             if (nError != IDE_OK) {
	cpi R20,0
	cpc R20,R21
	breq L209
X107:
;                 //
;                 // Try it again
;                 //
;                 nError = DeviceDiag(pDrive);
	movw R16,R22
	xcall _DeviceDiag
	movw R12,R16
	movw R20,R12
;             }
L209:
; 
;             if (nError == IDE_OK) {
	cpi R20,0
	cpc R20,R21
	brne L211
X108:
;                 pDrive->wSectorSize = IDE_SECTOR_SIZE;
	ldi R24,512
	ldi R25,2
	movw R30,R22
	std z+9,R25
	std z+8,R24
;                 nError = GetDeviceInfo(pDrive, pSectorBuffer);
	movw R18,R10
	movw R16,R30
	xcall _GetDeviceInfo
	movw R10,R16
	movw R20,R10
;                 if (pDrive->wFlags & IDE_READY) {
	movw R30,R22
	ldd R2,z+0
	ldd R3,z+1
	sbrs R3,7
	rjmp L213
X109:
;                     nError = IDE_OK;
	clr R20
	clr R21
;                 }
L213:
;             }
L211:
;         }
L206:
; 
;     }                           /* (bDevice >= IDE_MAX_SUPPORTED_DEVICE) */
L204:
; 
;     IDEFree();
	xcall _IDEFree
; 
;     return (nError);
	movw R16,R20
L202:
	.dbline 0 ; func end
	xjmp pop_xgsetF03C
;         pDrive -> R20,R21
;    nSectorSize -> R10,R11
;        bDevice -> R20
	.even
_IDEGetSectorSize::
	xcall push_xgset300C
	mov R20,R16
; }
; 
; /************************************************************/
; /*  IDEGetSectorSize                                        */
; /************************************************************/
; int IDEGetSectorSize(BYTE bDevice)
; {
;     int nSectorSize;
;     LPDRIVE pDrive;
; 
;     nSectorSize = 0;
	clr R10
	clr R11
; 
;     IDELock();
	xcall _IDELock
; 
;     if (bDevice >= IDE_MAX_SUPPORTED_DEVICE) {
	cpi R20,1
	brlo L216
X110:
;         nSectorSize = 0;
;     } else {
	xjmp L217
L216:
;         pDrive = &sDrive[bDevice];
	ldi R24,10
	mul R24,R20
	movw R20,R0
	ldi R24,<_sDrive
	ldi R25,>_sDrive
	add R20,R24
	adc R21,R25
;         nSectorSize = pDrive->wSectorSize;
	movw R30,R20
	ldd R10,z+8
	ldd R11,z+9
;     }
L217:
; 
;     IDEFree();
	xcall _IDEFree
; 
;     return (nSectorSize);
	movw R16,R10
L215:
	.dbline 0 ; func end
	xjmp pop_xgset300C
;         pDrive -> R10,R11
;       nIsCDROM -> R20,R21
;        bDevice -> R22
	.even
_IDEIsCDROMDevice::
	xcall push_xgsetF00C
	mov R22,R16
; }
; 
; /************************************************************/
; /*  IDEIsCDROMDevice                                        */
; /************************************************************/
; int IDEIsCDROMDevice(BYTE bDevice)
; {
;     int nIsCDROM;
;     LPDRIVE pDrive;
; 
;     nIsCDROM = FALSE;
	clr R20
	clr R21
; 
;     IDELock();
	xcall _IDELock
; 
;     if (bDevice >= IDE_MAX_SUPPORTED_DEVICE) {
	cpi R22,1
	brlo L219
X111:
;         nIsCDROM = FALSE;
;     } else {
	xjmp L220
L219:
;         pDrive = &sDrive[bDevice];
	ldi R24,10
	mul R24,R22
	movw R10,R0
	ldi R24,<_sDrive
	ldi R25,>_sDrive
	add R10,R24
	adc R11,R25
;         if ((pDrive->wFlags & IDE_READY) && (pDrive->wFlags & IDE_CDROM_DEVICE)) {
	movw R30,R10
	ldd R2,z+0
	ldd R3,z+1
	sbrs R3,7
	rjmp L221
X112:
	sbrs R3,4
	rjmp L221
X113:
;             nIsCDROM = TRUE;
	ldi R20,1
	ldi R21,0
;         }
L221:
;     }
L220:
; 
;     IDEFree();
	xcall _IDEFree
; 
;     return (nIsCDROM);
	movw R16,R20
L218:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
;         pDrive -> R10,R11
;         nIsZIP -> R20,R21
;        bDevice -> R22
	.even
_IDEIsZIPDevice::
	xcall push_xgsetF00C
	mov R22,R16
; }
; 
; /************************************************************/
; /*  IDEIsZIPDevice                                          */
; /************************************************************/
; int IDEIsZIPDevice(BYTE bDevice)
; {
;     int nIsZIP;
;     LPDRIVE pDrive;
; 
;     nIsZIP = FALSE;
	clr R20
	clr R21
; 
;     IDELock();
	xcall _IDELock
; 
;     if (bDevice >= IDE_MAX_SUPPORTED_DEVICE) {
	cpi R22,1
	brlo L224
X114:
;         nIsZIP = FALSE;
;     } else {
	xjmp L225
L224:
;         pDrive = &sDrive[bDevice];
	ldi R24,10
	mul R24,R22
	movw R10,R0
	ldi R24,<_sDrive
	ldi R25,>_sDrive
	add R10,R24
	adc R11,R25
;         if ((pDrive->wFlags & IDE_READY) && (pDrive->wFlags & IDE_ZIP_DEVICE)) {
	movw R30,R10
	ldd R2,z+0
	ldd R3,z+1
	sbrs R3,7
	rjmp L226
X115:
	sbrs R3,5
	rjmp L226
X116:
;             nIsZIP = TRUE;
	ldi R20,1
	ldi R21,0
;         }
L226:
;     }
L225:
; 
;     IDEFree();
	xcall _IDEFree
; 
;     return (nIsZIP);
	movw R16,R20
L223:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
;         pDrive -> R10,R11
;         nError -> R20,R21
;        bDevice -> R22
	.even
_IDEUnMountDevice::
	xcall push_xgsetF00C
	mov R22,R16
; }
; 
; /************************************************************/
; /*  IDEUnMountDevice                                        */
; /************************************************************/
; int IDEUnMountDevice(BYTE bDevice)
; {
;     int nError = 0;
	clr R20
	clr R21
;     LPDRIVE pDrive;
; 
;     pDrive = NULL;
	clr R10
	clr R11
; 
;     IDELock();
	xcall _IDELock
; 
;     if (bDevice >= IDE_MAX_SUPPORTED_DEVICE) {
	cpi R22,1
	brlo L229
X117:
;         nError = IDE_ERROR;
	ldi R20,1
;     } else {
	xjmp L230
L229:
;         pDrive = &sDrive[bDevice];
	ldi R24,10
	mul R24,R22
	movw R10,R0
	ldi R24,<_sDrive
	ldi R25,>_sDrive
	add R10,R24
	adc R11,R25
; 
;         pDrive->wFlags = 0;
	clr R2
	clr R3
	movw R30,R10
	std z+1,R3
	std z+0,R2
;     }
L230:
; 
;     IDEFree();
	xcall _IDEFree
; 
;     return (nError);
	movw R16,R20
L228:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
;         pDrive -> R20,R21
; dwTotalSectors -> y+0
;        bDevice -> R20
	.even
_IDEGetTotalSectors::
	st -y,R20
	st -y,R21
	mov R20,R16
	sbiw R28,4
; }
; 
; /************************************************************/
; /*  IDEGetTotalSectors                                      */
; /************************************************************/
; DWORD IDEGetTotalSectors(BYTE bDevice)
; {
;     DWORD dwTotalSectors;
;     LPDRIVE pDrive;
; 
;     dwTotalSectors = 0;
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+0,R24
	std y+1,R25
	std y+2,R26
	std y+3,R27
; 
;     IDELock();
	xcall _IDELock
; 
;     if (bDevice >= IDE_MAX_SUPPORTED_DEVICE) {
	cpi R20,1
	brlo L232
X118:
;         dwTotalSectors = 0;
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+0,R24
	std y+1,R25
	std y+2,R26
	std y+3,R27
;     } else {
	xjmp L233
L232:
;         pDrive = &sDrive[bDevice];
	ldi R24,10
	mul R24,R20
	movw R20,R0
	ldi R24,<_sDrive
	ldi R25,>_sDrive
	add R20,R24
	adc R21,R25
;         dwTotalSectors = pDrive->dwTotalSectors;
	movw R30,R20
	ldd R2,z+4
	ldd R3,z+5
	ldd R4,z+6
	ldd R5,z+7
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
; 
;         dwTotalSectors -= 64;
	ldi R24,64
	ldi R25,0
	ldi R26,0
	ldi R27,0
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	sub R2,R24
	sbc R3,R25
	sbc R4,R26
	sbc R5,R27
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
;     }
L233:
; 
;     IDEFree();
	xcall _IDEFree
; 
;     return (dwTotalSectors);
	ldd R16,y+0
	ldd R17,y+1
	ldd R18,y+2
	ldd R19,y+3
L231:
	.dbline 0 ; func end
	adiw R28,4
	ld R21,y+
	ld R20,y+
	ret
;          pByte -> R14,R15
;              i -> y+6
;         pDrive -> y+10
;         nError -> y+8
;     wReadCount -> R12,R13
;   wSectorCount -> y+30
;  dwStartSector -> y+26
;          pData -> R10,R11
;        bDevice -> y+22
	.even
_IDEReadSectors::
	xcall push_arg4
	xcall push_xgsetF0FC
	movw R10,R18
	sbiw R28,12
; }
; 
; /************************************************************/
; /*  IDEReadSectors                                          */
; /************************************************************/
; int IDEReadSectors(BYTE bDevice, void *pData, DWORD dwStartSector, WORD wSectorCount)
; {
;     WORD i;
;     int nError;
;     WORD wReadCount;
;     LPDRIVE pDrive = 0;
	clr R0
	clr R1
	std y+11,R1
	std y+10,R0
;     BYTE *pByte;
; 
;     nError = IDE_OK;
	std y+9,R1
	std y+8,R0
; 
;     IDELock();
	xcall _IDELock
; 
;     if (bDevice >= IDE_MAX_SUPPORTED_DEVICE) {
	ldd R24,y+22
	cpi R24,1
	brlo L235
X119:
;         nError = IDE_DRIVE_NOT_FOUND;
	ldi R24,2
	ldi R25,0
	std y+9,R25
	std y+8,R24
;     } else {
	xjmp L236
L235:
;         pDrive = &sDrive[bDevice];
	ldi R24,10
	ldd R0,y+22
	mul R24,R0
	movw R2,R0
	ldi R24,<_sDrive
	ldi R25,>_sDrive
	add R2,R24
	adc R3,R25
	std y+11,R3
	std y+10,R2
;         if ((pDrive->wFlags & IDE_READY) == 0) {
	movw R30,R2
	ldd R2,z+0
	ldd R3,z+1
	sbrc R3,7
	rjmp L237
X120:
;             nError = IDE_DRIVE_NOT_FOUND;
	ldi R24,2
	ldi R25,0
	std y+9,R25
	std y+8,R24
;         } else {
	xjmp L238
L237:
;             if ((dwStartSector + wSectorCount) > pDrive->dwTotalSectors) {
	ldd R2,y+30
	ldd R3,y+31
	clr R4
	clr R5
	ldd R6,y+26
	ldd R7,y+27
	ldd R8,y+28
	ldd R9,y+29
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	ldd R30,y+10
	ldd R31,y+11
	ldd R2,z+4
	ldd R3,z+5
	ldd R4,z+6
	ldd R5,z+7
	cp R2,R6
	cpc R3,R7
	cpc R4,R8
	cpc R5,R9
	brsh L239
X121:
;                 nError = IDE_PARAM_ERROR;
	ldi R24,3
	ldi R25,0
	std y+9,R25
	std y+8,R24
;             }
L239:
;         }
L238:
;     }
L236:
; 
;     if ((pDrive->wFlags & IDE_SUPPORT_PACKET) && ((wSectorCount > 1))) {
	ldd R30,y+10
	ldd R31,y+11
	ldd R2,z+0
	ldd R3,z+1
	sbrs R2,2
	rjmp L241
X122:
	ldi R24,1
	ldi R25,0
	ldd R0,y+30
	ldd R1,y+31
	cp R24,R0
	cpc R25,R1
	brsh L241
X123:
;         //
;         // Sorry, in this version we support
;         // only 1 sector for PACKET devices.
;         //
;         nError = IDE_PARAM_ERROR;
	ldi R24,3
	std y+9,R25
	std y+8,R24
;     }
L241:
; 
;     if ((pDrive->wFlags & IDE_SUPPORT_PACKET) && (nError == IDE_OK)) {
	ldd R30,y+10
	ldd R31,y+11
	ldd R2,z+0
	ldd R3,z+1
	sbrs R2,2
	rjmp L243
X124:
	ldd R0,y+8
	ldd R1,y+9
	tst R0
	breq X133
	xjmp L243
X133:
	tst R1
	breq X134
	xjmp L243
X134:
X125:
; #if (IDE_SUPPORT_ATAPI == 1)
;         //
;         // ATAPI
;         //
;         ATAPI_CMD(ATAPI_CMD_READ12);
	ldi R24,12
	ldi R25,0
	std y+1,R25
	std y+0,R24
	clr R18
	clr R19
	ldi R16,<_aATAPICmd
	ldi R17,>_aATAPICmd
	xcall _memset
	ldi R24,168
	sts _aATAPICmd,R24
;         i = 5;
	ldi R24,5
	ldi R25,0
	std y+7,R25
	std y+6,R24
	xjmp L246
L245:
;         while (dwStartSector) {
;             aATAPICmd[i--] = (BYTE) dwStartSector;
	ldd R2,y+6
	ldd R3,y+7
	movw R24,R2
	sbiw R24,1
	std y+7,R25
	std y+6,R24
	ldi R24,<_aATAPICmd
	ldi R25,>_aATAPICmd
	movw R30,R2
	add R30,R24
	adc R31,R25
	ldd R2,y+26
	ldd R3,y+27
	ldd R4,y+28
	ldd R5,y+29
	std z+0,R2
;             dwStartSector >>= 8;
	ldi R24,8
	ldi R25,0
	movw R16,R2
	movw R18,R4
	st -y,R24
	xcall lsr32
	std y+26,R16
	std y+27,R17
	std y+28,R18
	std y+29,R19
;         }
L246:
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R2,y+26
	ldd R3,y+27
	ldd R4,y+28
	ldd R5,y+29
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brne L245
X126:
;         //
;         // Reading one sector only
;         //
;         aATAPICmd[9] = 1;
	ldi R24,1
	sts _aATAPICmd+9,R24
;         nError = ATAPISendCommand(pDrive, pData, &i);
	movw R24,R28
	adiw R24,6
	std y+1,R25
	std y+0,R24
	movw R18,R10
	ldd R16,y+10
	ldd R17,y+11
	xcall _ATAPISendCommand
	std y+9,R17
	std y+8,R16
;         if ((nError != IDE_OK) || (i != pDrive->wSectorSize)) {
	movw R0,R16
	cpi R16,0
	cpc R16,R17
	brne L251
X127:
	ldd R30,y+10
	ldd R31,y+11
	ldd R2,z+8
	ldd R3,z+9
	ldd R4,y+6
	ldd R5,y+7
	cp R4,R2
	cpc R5,R3
	brne X135
	xjmp L244
X135:
X128:
L251:
;             nError = IDE_ERROR;
	ldi R24,1
	ldi R25,0
	std y+9,R25
	std y+8,R24
;         }
; #else
;         nError = IDE_ERROR;
; #endif
;     } else {
	xjmp L244
L243:
;         if (nError == IDE_OK) {
	ldd R0,y+8
	ldd R1,y+9
	tst R0
	breq X136
	xjmp L252
X136:
	tst R1
	breq X137
	xjmp L252
X137:
X129:
;             pByte = (BYTE *) pData;
	movw R14,R10
	xjmp L255
L254:
;             while (wSectorCount > 0) {
; 
;                 if (wSectorCount < 256) {
	ldd R24,y+30
	ldd R25,y+31
	cpi R24,0
	ldi R30,1
	cpc R25,R30
	brsh L257
X130:
;                     wReadCount = wSectorCount;
	movw R12,R24
;                 } else {
	xjmp L258
L257:
;                     wReadCount = 256;
	ldi R24,256
	ldi R25,1
	movw R12,R24
;                 }
L258:
; 
;                 nError = ReadSectors(bDevice, pByte, dwStartSector, wReadCount);
	std y+5,R13
	std y+4,R12
	ldd R2,y+26
	ldd R3,y+27
	ldd R4,y+28
	ldd R5,y+29
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	movw R18,R14
	ldd R16,y+22
	xcall _ReadSectors
	movw R10,R16
	std y+9,R11
	std y+8,R10
;                 if (nError != IDE_OK) {
	movw R0,R10
	cpi R16,0
	cpc R16,R17
	breq L259
X131:
;                     break;
	xjmp L256
L259:
;                 }
; 
;                 dwStartSector += wReadCount;
	movw R2,R12
	clr R4
	clr R5
	ldd R6,y+26
	ldd R7,y+27
	ldd R8,y+28
	ldd R9,y+29
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	std y+26,R6
	std y+27,R7
	std y+28,R8
	std y+29,R9
;                 wSectorCount -= wReadCount;
	ldd R0,y+30
	ldd R1,y+31
	sub R0,R2
	sbc R1,R3
	std y+31,R1
	std y+30,R0
;                 pByte += (wReadCount * pDrive->wSectorSize);
	ldd R30,y+10
	ldd R31,y+11
	ldd R18,z+8
	ldd R19,z+9
	movw R16,R2
	xcall empy16s
	add R14,R16
	adc R15,R17
;             }
L255:
	ldd R0,y+30
	ldd R1,y+31
	tst R0
	breq X138
	xjmp L254
X138:
	tst R1
	breq X139
	xjmp L254
X139:
X132:
L256:
;         }
L252:
;     }
L244:
; 
;     IDEFree();
	xcall _IDEFree
; 
;     return (nError);
	ldd R16,y+8
	ldd R17,y+9
L234:
	.dbline 0 ; func end
	adiw R28,12
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
;              i -> y+2
;         pDrive -> R10,R11
;         nError -> R20,R21
;         wSpeed -> R22,R23
;        bDevice -> R12
	.even
_IDEATAPISetCDSpeed::
	xcall push_xgsetF03C
	movw R22,R18
	mov R12,R16
	sbiw R28,4
; }
; 
; #if (IDE_SUPPORT_WRITE == 1)
; /************************************************************/
; /*  IDEWriteSectors                                         */
; /************************************************************/
; int IDEWriteSectors(BYTE bDevice, void *pData, DWORD dwStartSector, WORD wSectorCount)
; {
;     int nError;
;     WORD wWriteCount;
;     LPDRIVE pDrive;
;     BYTE *pByte;
; 
;     nError = IDE_OK;
;     pDrive = NULL;
; 
;     IDELock();
; 
;     if (bDevice >= IDE_MAX_SUPPORTED_DEVICE) {
;         nError = IDE_DRIVE_NOT_FOUND;
;     } else {
;         pDrive = &sDrive[bDevice];
; 
;         if ((dwStartSector + wSectorCount) > pDrive->dwTotalSectors) {
;             nError = IDE_PARAM_ERROR;
;         }
;         if ((pDrive->wFlags & IDE_READY) == 0) {
;             nError = IDE_DRIVE_NOT_FOUND;
;         }
;         if (pDrive->wFlags & IDE_READ_ONLY) {
;             nError = IDE_NOT_SUPPORTED;
;         }
;     }
; 
;     if (nError == IDE_OK) {
;         pByte = (BYTE *) pData;
;         while (wSectorCount > 0) {
; 
;             if (wSectorCount < 256) {
;                 wWriteCount = wSectorCount;
;             } else {
;                 wWriteCount = 256;
;             }
; 
;             nError = WriteSectors(bDevice, pByte, dwStartSector, wWriteCount);
;             if (nError != IDE_OK) {
;                 break;
;             }
; 
;             dwStartSector += wWriteCount;
;             wSectorCount -= wWriteCount;
;             pByte += (wWriteCount * IDE_SECTOR_SIZE);
;         }
;     }
; 
;     IDEFree();
; 
;     return (nError);
; }
; #endif
; 
; #if (IDE_SUPPORT_ATAPI == 1)
; /************************************************************/
; /*  IDEATAPISetCDSpeed                                      */
; /************************************************************/
; int IDEATAPISetCDSpeed(BYTE bDevice, WORD wSpeed)
; {
;     WORD i;
;     int nError;
;     LPDRIVE pDrive;
; 
;     nError = IDE_OK;
	clr R20
	clr R21
;     pDrive = NULL;
	clr R10
	clr R11
; 
;     if (bDevice >= IDE_MAX_SUPPORTED_DEVICE) {
	mov R24,R12
	cpi R24,1
	brlo L262
X140:
;         nError = IDE_DRIVE_NOT_FOUND;
	ldi R20,2
;     } else {
	xjmp L263
L262:
;         pDrive = &sDrive[bDevice];
	ldi R24,10
	mul R24,R12
	movw R10,R0
	ldi R24,<_sDrive
	ldi R25,>_sDrive
	add R10,R24
	adc R11,R25
;         if ((pDrive->wFlags & IDE_READY) == 0) {
	movw R30,R10
	ldd R2,z+0
	ldd R3,z+1
	sbrc R3,7
	rjmp L264
X141:
;             nError = IDE_DRIVE_NOT_FOUND;
	ldi R20,2
	ldi R21,0
;         }
L264:
;         if ((pDrive->wFlags & IDE_SUPPORT_PACKET) == 0) {
	movw R30,R10
	ldd R2,z+0
	ldd R3,z+1
	sbrc R2,2
	rjmp L266
X142:
;             nError = IDE_NOT_SUPPORTED;
	ldi R20,8
	ldi R21,0
;         }
L266:
;     }
L263:
; 
;     if (nError == IDE_OK) {
	cpi R20,0
	cpc R20,R21
	brne L268
X143:
;         ATAPI_CMD(0xBB);
	ldi R24,12
	ldi R25,0
	std y+1,R25
	std y+0,R24
	clr R18
	clr R19
	ldi R16,<_aATAPICmd
	ldi R17,>_aATAPICmd
	xcall _memset
	ldi R24,187
	sts _aATAPICmd,R24
;         aATAPICmd[2] = (BYTE) ((wSpeed >> 8) & 0x00FF);
	movw R24,R22
	mov R24,R25
	clr R25
	andi R25,0
	sts _aATAPICmd+2,R24
;         aATAPICmd[3] = (BYTE) (wSpeed & 0x00FF);
	movw R24,R22
	andi R25,0
	sts _aATAPICmd+3,R24
;         nError = ATAPISendCommand(pDrive, NULL, &i);
	movw R24,R28
	adiw R24,2
	std y+1,R25
	std y+0,R24
	clr R18
	clr R19
	movw R16,R10
	xcall _ATAPISendCommand
	movw R20,R16
;     }
L268:
; 
;     return (nError);
	movw R16,R20
L261:
	.dbline 0 ; func end
	adiw R28,4
	xjmp pop_xgsetF03C
	.area bss(ram, con, rel)
_aATAPICmd:
	.blkb 12
_hCFChangeInt:
	.blkb 2
_hIDESemaphore:
	.blkb 2
_sDrive:
	.blkb 10
_pIDE:
	.blkb 2
_hIDEEvent:
	.blkb 2
	.area data(ram, con, rel)
L201:
	.blkb 9
	.area idata
	.byte 'c,'f,'c,'h,'a,'n,'g,'e,0
	.area data(ram, con, rel)
; }
; #endif
	.area func_lit
PL_CFChange:	.word `_CFChange
PL_CFInterrupt:	.word `_CFInterrupt
PL_IDEInterrupt:	.word `_IDEInterrupt
