	.module irsony.c
	.area vector(rom, abs)
	.org 20
	jmp _SIG_INTERRUPT4
	.org 40
	jmp _SIG_OVERFLOW2
	.area text(rom, con, rel)
	.even
_SIG_OVERFLOW2::
	st -y,R2
	st -y,R3
	st -y,R24
	st -y,R25
	in R2,0x3f
	st -y,R2
; /*
;  * Copyright (C) 2003 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  */
; 
; /*
;  * $Log: irsony.c,v $
;  * Revision 1.1  2005/07/26 18:02:27  haraldkipp
;  * Moved from dev.
;  *
;  * Revision 1.3  2005/01/28 12:13:14  freckle
;  * changed NutEventPostFromIRQ into NutEventPostFromIrq
;  *
;  * Revision 1.2  2004/03/18 18:41:18  haraldkipp
;  * Bugfix. Now works with ICCAVR
;  *
;  * Revision 1.1  2003/07/21 18:07:54  haraldkipp
;  * Sony infrared remote control driver added
;  *
;  */
; 
; #include <cfg/medianut.h>
; #include <sys/atom.h>
; #include <sys/event.h>
; 
; #ifdef __IMAGECRAFT__
; #pragma interrupt_handler SIG_INTERRUPT4:iv_INT4
; #pragma interrupt_handler SIG_OVERFLOW2:iv_TIMER2_OVF
; #endif
; 
; /*!
;  * \addtogroup xgIrSony
;  */
; /*@{*/
; 
; #include <dev/irsony.h>
; 
; #define IRTIMER_START   0xF0
; #define IRTIMER_SCALE   0x01
; 
; /*!
;  * \brief Last valid infrared code received.
;  */
; long nut_ircode;
; 
; /*!
;  * \brief Queue of threads waiting for infrared input.
;  */
; HANDLE nut_irqueue;
; 
; /*
;  * Tick counter, incremented on each timer overflow and
;  * cleared on each edge detection on the infrared signal.
;  */
; static u_short irticks;
; 
; /*
;  * Number of bits received from infrared decoder.
;  */
; static u_char irbitnum;
; 
; /*! \fn SIG_OVERFLOW2(void)
;  * \brief Timer 2 overflow handler.
;  */
; SIGNAL(SIG_OVERFLOW2)
; {
;     /* Set the timer value. */
;     outb(TCNT2, IRTIMER_START);
	ldi R24,240
	out 0x24,R24
; 
;     /*
;      * Increment our tick counter. If it overflows, then wait
;      * for the next start bit and disable the timer.
;      */
;     if (++irticks == 0) {
	lds R24,_irticks
	lds R25,_irticks+1
	adiw R24,1
	movw R2,R24
	sts _irticks+1,R3
	sts _irticks,R2
	cpi R24,0
	cpc R24,R25
	brne L2
X0:
;         irbitnum = 0;
	clr R2
	sts _irbitnum,R2
;         cbi(TIMSK, 6);
	in R24,0x37
	andi R24,191
	out 0x37,R24
;     }
L2:
L1:
	.dbline 0 ; func end
	ld R2,y+
	out 0x3f,R2
	ld R25,y+
	ld R24,y+
	ld R3,y+
	ld R2,y+
	reti
	.area bss(ram, con, rel)
L5:
	.blkb 2
L6:
	.blkb 2
L7:
	.blkb 2
L8:
	.blkb 1
	.area text(rom, con, rel)
;         bitlen -> R10,R11
	.even
_SIG_INTERRUPT4::
	xcall push_lset
	st -y,R10
	st -y,R11
; }
; 
; /*! \fn SIG_INTERRUPT4(void)
;  * \brief Infrared decoder signal edge handler.
;  */
; SIGNAL(SIG_INTERRUPT4)
; {
;     static u_short minset;      /* Min. length of bit value 1, calculated from start bit. */
;     static u_short ccode;       /* Current code. */
;     static u_short lcode;       /* Last code. */
;     static u_char ncode;        /* Number of equal codes. */
;     u_short bitlen = irticks;   /* Length of the current bit. */
	lds R10,_irticks
	lds R11,_irticks+1
; 
;     irticks = 0;
	clr R2
	clr R3
	sts _irticks+1,R3
	sts _irticks,R2
; 
;     /* Rising egde marks end of bit. */
;     if (inb(IR_SIGNAL_PIN) & _BV(IR_SIGNAL_BIT)) {
	sbis 0x1,4
	rjmp L9
X1:
;         /* Start bit. */
;         if (irbitnum++ == 0) {
	lds R2,_irbitnum
	clr R3
	mov R24,R2
	subi R24,255    ; addi 1
	sts _irbitnum,R24
	tst R2
	brne L11
X2:
;             ccode = 0;
	clr R2
	sts L6+1,R3
	sts L6,R2
;             minset = bitlen / 3;
	ldi R18,3
	ldi R19,0
	movw R16,R10
	xcall div16u
	sts L5+1,R17
	sts L5,R16
;         }
	xjmp L10
L11:
;         /* Data bits. */
;         else {
;             /* If its length is greater than a third of the start bit,
;                then we assume this bit set. */
;             if (bitlen >= minset)
	lds R2,L5
	lds R3,L5+1
	cp R10,R2
	cpc R11,R3
	brlo L13
X3:
;                 ccode |= _BV(12);
	lds R24,L6
	lds R25,L6+1
	ori R25,16
	sts L6+1,R25
	sts L6,R24
L13:
;             ccode >>= 1;
	lds R2,L6
	lds R3,L6+1
	lsr R3
	ror R2
	sts L6+1,R3
	sts L6,R2
;             /* All data bits collected? */
;             if (irbitnum > 12) {
	ldi R24,12
	lds R2,_irbitnum
	cp R24,R2
	brlo X9
	xjmp L10
X9:
X4:
;                 cbi(TIMSK, 6);
	in R24,0x37
	andi R24,191
	out 0x37,R24
;                 irbitnum = 0;
	clr R2
	sts _irbitnum,R2
;                 if (ncode++) {
	lds R2,L8
	clr R3
	mov R24,R2
	subi R24,255    ; addi 1
	sts L8,R24
	tst R2
	breq L17
X5:
;                     if (lcode != ccode)
	lds R2,L6
	lds R3,L6+1
	lds R4,L7
	lds R5,L7+1
	cp R4,R2
	cpc R5,R3
	breq L19
X6:
;                         ncode = 0;
	clr R2
	sts L8,R2
	xjmp L10
L19:
;                     /* If we have two equal codes, pass it to the 
;                        application. */
;                     else if (ncode > 1) {
	ldi R24,1
	lds R2,L8
	cp R24,R2
	brsh L10
X7:
;                         ncode = 0;
	clr R2
	sts L8,R2
;                         nut_ircode = ccode;
	lds R2,L6
	lds R3,L6+1
	clr R4
	clr R5
	sts _nut_ircode+1,R3
	sts _nut_ircode,R2
	sts _nut_ircode+2+1,R5
	sts _nut_ircode+2,R4
;                         NutEventPostFromIrq(&nut_irqueue);
	ldi R16,<_nut_irqueue
	ldi R17,>_nut_irqueue
	xcall _NutEventPostFromIrq
;                     }
;                 } else
	xjmp L10
L17:
;                     lcode = ccode;
	lds R2,L6
	lds R3,L6+1
	sts L7+1,R3
	sts L7,R2
;             }
;         }
;     }
	xjmp L10
L9:
;     /* Falling edges mark the start of a bit. Enable timer
;        overflow interrupts. */
;     else if (irbitnum == 0) {
	lds R2,_irbitnum
	tst R2
	brne L23
X8:
;         sbi(TIMSK, 6);
	in R24,0x37
	ori R24,64
	out 0x37,R24
;     }
L23:
L10:
L4:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	xcall pop_lset
	reti
	.even
_NutIrInitSony::
; 
; }
; 
; /*!
;  * \brief Enable Sony infrared remote control.
;  */
; int NutIrInitSony(void)
; {
;     NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
;     /* 
;      * Initialize timer 2 and enable overflow interrupts.
;      */
;     outb(TCNT2, IRTIMER_START);
	ldi R24,240
	out 0x24,R24
;     outb(TCCR2, IRTIMER_SCALE);
	ldi R24,1
	out 0x25,R24
;     sbi(TIMSK, 6);
	in R24,0x37
	ori R24,64
	out 0x37,R24
; 
;     /* 
;      * Enable infrared decoder interrupts on both edges. 
;      */
;     cbi(IR_SIGNAL_DDR, IR_SIGNAL_BIT);
	cbi 0x2,4
;     sbi(EICR, 0);
	in R24,0x3a
	ori R24,1
	out 0x3a,R24
;     cbi(EICR, 1);
	in R24,0x3a
	andi R24,253
	out 0x3a,R24
;     sbi(EIMSK, IR_SIGNAL_BIT);
	in R24,0x39
	ori R24,16
	out 0x39,R24
; 
;     NutExitCritical();
	pop R0
	out 0x3F, R0
	
; 
;     return 0;
	clr R16
	clr R17
L25:
	.dbline 0 ; func end
	ret
	.area bss(ram, con, rel)
_irbitnum:
	.blkb 1
_irticks:
	.blkb 2
_nut_irqueue::
	.blkb 2
_nut_ircode::
	.blkb 4
; }
; 
; /*@}*/
