	.module ivect01.c
	.area data(ram, con, rel)
_sig_INTERRUPT0::
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.blkw 1
	.area idata
	.word PL_AvrInterrupt0Ctl
	.area data(ram, con, rel)
	.area text(rom, con, rel)
;           bval -> R12
;           ival -> R10,R11
;             rc -> R20,R21
;        enabled -> R22,R23
;          param -> R18,R19
;            cmd -> R16,R17
	.even
_AvrInterrupt0Ctl:
	xcall push_xgsetF03C
; /*
;  * Copyright (C) 2001-2005 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  */
; 
; /*!
;  * \file arch/avr/dev/ivect01.c
;  * \brief AVR external interrupt 0.
;  *
;  * \verbatim
;  *
;  * $Log: ivect01.c,v $
;  * Revision 1.3.2.1  2006/01/25 09:44:01  haraldkipp
;  * Applied Thiago A. Correa's patch to fix ICC warnings.
;  *
;  * Revision 1.3  2005/10/24 18:02:34  haraldkipp
;  * Fixes for ATmega103.
;  *
;  * Revision 1.2  2005/10/24 09:34:29  haraldkipp
;  * New interrupt control function added to allow future platform
;  * independant drivers.
;  *
;  * Revision 1.1  2005/07/26 18:02:27  haraldkipp
;  * Moved from dev.
;  *
;  * Revision 1.2  2004/01/30 17:02:19  drsung
;  * Separate interrupt stack for avr-gcc only added.
;  *
;  * Revision 1.1.1.1  2003/05/09 14:40:40  haraldkipp
;  * Initial using 3.2.1
;  *
;  * Revision 1.1  2003/02/04 17:53:58  harald
;  * *** empty log message ***
;  *
;  * \endverbatim
;  */
; 
; #include <dev/irqreg.h>
; 
; /*!
;  * \addtogroup xgIrqReg
;  */
; /*@{*/
; 
; static int AvrInterrupt0Ctl(int cmd, void *param);
; 
; IRQ_HANDLER sig_INTERRUPT0 = {
; #ifdef NUT_PERFMON
;     0,                          /* Interrupt counter, ir_count. */
; #endif
;     NULL,                       /* Passed argument, ir_arg. */
;     NULL,                       /* Handler subroutine, ir_handler. */
;     AvrInterrupt0Ctl            /* Interrupt control, ir_ctl. */
; };
; 
; /*!
;  * \brief External interrupt 0 control.
;  *
;  * \param cmd   Control command.
;  *              - NUT_IRQCTL_INIT Initialize and disable interrupt.
;  *              - NUT_IRQCTL_STATUS Query interrupt status.
;  *              - NUT_IRQCTL_ENABLE Enable interrupt.
;  *              - NUT_IRQCTL_DISABLE Disable interrupt.
;  *              - NUT_IRQCTL_GETMODE Query interrupt mode.
;  *              - NUT_IRQCTL_SETMODE Set interrupt mode.
;  *              - NUT_IRQCTL_GETPRIO Query interrupt priority.
;  *              - NUT_IRQCTL_SETPRIO Set interrupt priority.
;  *              - NUT_IRQCTL_GETCOUNT Query and clear interrupt counter.
;  * \param param Pointer to optional parameter.
;  *
;  * \return 0 on success, -1 otherwise.
;  */
; static int AvrInterrupt0Ctl(int cmd, void *param)
; {
;     int rc = 0;
	clr R20
	clr R21
;     u_int *ival = (u_int *) param;
	movw R10,R18
;     int enabled = bit_is_set(EIMSK, INT0);
	in R2,0x39
	sbrs R2,0
	rjmp L3
X0:
	ldi R22,1
	ldi R23,0
	xjmp L4
L3:
	clr R22
	clr R23
L4:
; 
;     /* Disable interrupt. */
;     cbi(EIMSK, INT0);
	in R24,0x39
	andi R24,254
	out 0x39,R24
; 
;     switch (cmd) {
	cpi R16,16
	ldi R30,0
	cpc R17,R30
	brne X18
	xjmp L9
X18:
X1:
	cpi R16,17
	ldi R30,0
	cpc R17,R30
	brne X19
	xjmp L14
X19:
X2:
	cpi R16,18
	ldi R30,0
	cpc R17,R30
	brne X20
	xjmp L15
X20:
X3:
	cpi R16,24
	ldi R30,0
	cpc R17,R30
	brne X21
	xjmp L16
X21:
X4:
	cpi R16,25
	ldi R30,0
	cpc R17,R30
	brne X22
	xjmp L21
X22:
X5:
	ldi R24,25
	ldi R25,0
	cp R24,R16
	cpc R25,R17
	brlt L30
X6:
L29:
	cpi R16,0
	cpc R16,R17
	breq L7
X7:
	cpi R16,1
	ldi R30,0
	cpc R17,R30
	breq L8
X8:
	xjmp L5
L30:
	cpi R16,32
	ldi R30,0
	cpc R17,R30
	brne X23
	xjmp L28
X23:
X9:
	xjmp L5
L7:
;     case NUT_IRQCTL_INIT:
; #ifdef __AVR_ENHANCED__
;         /* Initialize to low level triggered. */
;         cbi(EICRA, ISC00);
	lds R24,106
	andi R24,254
	sts 106,R24
;         cbi(EICRA, ISC01);
	lds R24,106
	andi R24,253
	sts 106,R24
L8:
; #endif
;     case NUT_IRQCTL_CLEAR:
; #ifdef __AVR_ENHANCED__
;         /* Clear any pending interrupt. */
;         outb(EIFR, _BV(INTF0));
	ldi R24,1
	out 0x38,R24
; #endif /* __AVR_ENHANCED__ */
;         break;
	xjmp L6
L9:
;     case NUT_IRQCTL_STATUS:
; #ifdef __AVR_ENHANCED__
;         if (bit_is_set(EIFR, INTF0)) {
	in R2,0x38
	sbrs R2,0
	rjmp L10
X10:
;             *ival = 1;
	ldi R24,1
	ldi R25,0
	movw R30,R10
	std z+1,R25
	std z+0,R24
;         } else {
	xjmp L11
L10:
;             *ival = 0;
	clr R2
	clr R3
	movw R30,R10
	std z+1,R3
	std z+0,R2
;         }
L11:
; #else /* !__AVR_ENHANCED__ */
;         *ival = 0;
; #endif /* __AVR_ENHANCED__ */
;         if (enabled) {
	cpi R22,0
	cpc R22,R23
	brne X24
	xjmp L6
X24:
X11:
;             *ival |= 0x80;
	movw R30,R10
	ldd R24,z+0
	ldd R25,z+1
	ori R24,128
	std z+1,R25
	std z+0,R24
;         }
;         break;
	xjmp L6
L14:
;     case NUT_IRQCTL_ENABLE:
;         enabled = 1;
	ldi R22,1
	ldi R23,0
;         break;
	xjmp L6
L15:
;     case NUT_IRQCTL_DISABLE:
;         enabled = 0;
	clr R22
	clr R23
;         break;
	xjmp L6
L16:
;     case NUT_IRQCTL_GETMODE:
; #ifdef __AVR_ENHANCED__
;         {
;             u_char bval = inb(EICRA) & (_BV(ISC01) | _BV(ISC00));
	lds R24,106
	andi R24,3
	mov R12,R24
;             if (bval == 0) {
	tst R24
	brne L17
X12:
;                 *ival = NUT_IRQMODE_LOWLEVEL;
	ldi R24,1
	ldi R25,0
	movw R30,R10
	std z+1,R25
	std z+0,R24
;             }
	xjmp L6
L17:
;             else if (bval == (_BV(ISC01) | _BV(ISC00))) {
	mov R24,R12
	cpi R24,3
	brne L19
X13:
;                 *ival = NUT_IRQMODE_RISINGEDGE;
	ldi R24,6
	ldi R25,0
	movw R30,R10
	std z+1,R25
	std z+0,R24
;             } else  {
	xjmp L6
L19:
;                 *ival = NUT_IRQMODE_FALLINGEDGE;
	ldi R24,5
	ldi R25,0
	movw R30,R10
	std z+1,R25
	std z+0,R24
;             }
;         }
; #else /* !__AVR_ENHANCED__ */
;         *ival = NUT_IRQMODE_LOWLEVEL;
; #endif /* __AVR_ENHANCED__ */
;         break;
	xjmp L6
L21:
;     case NUT_IRQCTL_SETMODE:
; #ifdef __AVR_ENHANCED__
;         if (*ival == NUT_IRQMODE_LOWLEVEL) {
	movw R30,R10
	ldd R24,z+0
	ldd R25,z+1
	cpi R24,1
	ldi R30,0
	cpc R25,R30
	brne L22
X14:
;             cbi(EICRA, ISC00);
	lds R24,106
	andi R24,254
	sts 106,R24
;             cbi(EICRA, ISC01);
	lds R24,106
	andi R24,253
	sts 106,R24
;         } else if (*ival == NUT_IRQMODE_FALLINGEDGE) {
	xjmp L6
L22:
	movw R30,R10
	ldd R24,z+0
	ldd R25,z+1
	cpi R24,5
	ldi R30,0
	cpc R25,R30
	brne L24
X15:
;             cbi(EICRA, ISC00);
	lds R24,106
	andi R24,254
	sts 106,R24
;             sbi(EICRA, ISC01);
	lds R24,106
	ori R24,2
	sts 106,R24
;         } else  if (*ival == NUT_IRQMODE_RISINGEDGE) {
	xjmp L6
L24:
	movw R30,R10
	ldd R24,z+0
	ldd R25,z+1
	cpi R24,6
	ldi R30,0
	cpc R25,R30
	brne L26
X16:
;             sbi(EICRA, ISC00);
	lds R24,106
	ori R24,1
	sts 106,R24
;             sbi(EICRA, ISC01);
	lds R24,106
	ori R24,2
	sts 106,R24
;         } else  {
	xjmp L6
L26:
;             rc = -1;
	ldi R20,-1
	ldi R21,-1
;         }
; #else /* !__AVR_ENHANCED__ */
;         if (*ival != NUT_IRQMODE_LOWLEVEL) {
;             rc = -1;
;         }
; #endif /* __AVR_ENHANCED__ */
;         break;
	xjmp L6
L28:
;     case NUT_IRQCTL_GETPRIO:
;         *ival = 0;
	clr R2
	clr R3
	movw R30,R10
	std z+1,R3
	std z+0,R2
;         break;
	xjmp L6
L5:
; #ifdef NUT_PERFMON
;     case NUT_IRQCTL_GETCOUNT:
;         *ival = (u_int) sig_INTERRUPT0.ir_count;
;         sig_INTERRUPT0.ir_count = 0;
;         break;
; #endif
;     default:
;         rc = -1;
	ldi R20,-1
	ldi R21,-1
;         break;
L6:
;     }
; 
;     /* Enable interrupt. */
;     if (enabled) {
	cpi R22,0
	cpc R22,R23
	breq L31
X17:
;         sbi(EIMSK, INT0);
	in R24,0x39
	ori R24,1
	out 0x39,R24
;     }
L31:
;     return rc;
	movw R16,R20
L2:
	.dbline 0 ; func end
	xjmp pop_xgsetF03C
	.area vector(rom, abs)
	.org 4
	jmp _SIG_INTERRUPT0
	.area text(rom, con, rel)
	.even
_SIG_INTERRUPT0::
	xcall push_lset
; }
; 
; /*! 
;  * \fn SIG_INTERRUPT0(void)
;  * \brief External interrupt 0 entry.
;  */
; #ifdef __IMAGECRAFT__
; #pragma interrupt_handler SIG_INTERRUPT0:iv_INT0
; #endif
; NUTSIGNAL(SIG_INTERRUPT0, sig_INTERRUPT0)
	ldi R16,<_sig_INTERRUPT0
	ldi R17,>_sig_INTERRUPT0
	xcall _CallHandler
L33:
	.dbline 0 ; func end
	xcall pop_lset
	reti
; 
; /*@}*/
	.area func_lit
PL_AvrInterrupt0Ctl:	.word `_AvrInterrupt0Ctl
