	.module ivect06.c
	.area data(ram, con, rel)
_sig_INTERRUPT5::
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.blkw 1
	.area idata
	.word PL_AvrInterrupt5Ctl
	.area data(ram, con, rel)
	.area text(rom, con, rel)
;           bval -> R12
;           ival -> R10,R11
;             rc -> R20,R21
;        enabled -> R22,R23
;          param -> R18,R19
;            cmd -> R16,R17
	.even
_AvrInterrupt5Ctl:
	xcall push_xgsetF03C
; /*
;  * Copyright (C) 2001-2005 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  */
; 
; /*!
;  * \file arch/avr/dev/ivect06.c
;  * \brief AVR external interrupt 5.
;  *
;  * \verbatim
;  *
;  * $Log: ivect06.c,v $
;  * Revision 1.3.2.1  2006/01/25 09:44:01  haraldkipp
;  * Applied Thiago A. Correa's patch to fix ICC warnings.
;  *
;  * Revision 1.3  2005/10/24 18:02:34  haraldkipp
;  * Fixes for ATmega103.
;  *
;  * Revision 1.2  2005/10/24 09:34:30  haraldkipp
;  * New interrupt control function added to allow future platform
;  * independant drivers.
;  *
;  * Revision 1.1  2005/07/26 18:02:40  haraldkipp
;  * Moved from dev.
;  *
;  * Revision 1.2  2004/01/30 17:02:19  drsung
;  * Separate interrupt stack for avr-gcc only added.
;  *
;  * Revision 1.1.1.1  2003/05/09 14:40:41  haraldkipp
;  * Initial using 3.2.1
;  *
;  * Revision 1.2  2003/03/31 14:53:06  harald
;  * Prepare release 3.1
;  *
;  * \endverbatim
;  */
; 
; #include <dev/irqreg.h>
; 
; /*!
;  * \addtogroup xgIrqReg
;  */
; /*@{*/
; 
; static int AvrInterrupt5Ctl(int cmd, void *param);
; 
; IRQ_HANDLER sig_INTERRUPT5 = {
; #ifdef NUT_PERFMON
;     0,                          /* Interrupt counter, ir_count. */
; #endif
;     NULL,                       /* Passed argument, ir_arg. */
;     NULL,                       /* Handler subroutine, ir_handler. */
;     AvrInterrupt5Ctl            /* Interrupt control, ir_ctl. */
; };
; 
; /*!
;  * \brief External interrupt 5 control.
;  *
;  * \param cmd   Control command.
;  *              - NUT_IRQCTL_INIT Initialize and disable interrupt.
;  *              - NUT_IRQCTL_STATUS Query interrupt status.
;  *              - NUT_IRQCTL_ENABLE Enable interrupt.
;  *              - NUT_IRQCTL_DISABLE Disable interrupt.
;  *              - NUT_IRQCTL_GETMODE Query interrupt mode.
;  *              - NUT_IRQCTL_SETMODE Set interrupt mode.
;  *              - NUT_IRQCTL_GETPRIO Query interrupt priority.
;  *              - NUT_IRQCTL_SETPRIO Set interrupt priority.
;  *              - NUT_IRQCTL_GETCOUNT Query and clear interrupt counter.
;  * \param param Pointer to optional parameter.
;  *
;  * \return 0 on success, -1 otherwise.
;  */
; static int AvrInterrupt5Ctl(int cmd, void *param)
; {
;     int rc = 0;
	clr R20
	clr R21
;     u_int *ival = (u_int *) param;
	movw R10,R18
;     int enabled = bit_is_set(EIMSK, INT5);
	in R2,0x39
	sbrs R2,5
	rjmp L3
X0:
	ldi R22,1
	ldi R23,0
	xjmp L4
L3:
	clr R22
	clr R23
L4:
;     u_char bval;
; 
;     /* Disable interrupt. */
;     cbi(EIMSK, INT5);
	in R24,0x39
	andi R24,223
	out 0x39,R24
; 
;     switch (cmd) {
	cpi R16,16
	ldi R30,0
	cpc R17,R30
	breq L9
X1:
	cpi R16,17
	ldi R30,0
	cpc R17,R30
	brne X20
	xjmp L14
X20:
X2:
	cpi R16,18
	ldi R30,0
	cpc R17,R30
	brne X21
	xjmp L15
X21:
X3:
	cpi R16,24
	ldi R30,0
	cpc R17,R30
	brne X22
	xjmp L16
X22:
X4:
	cpi R16,25
	ldi R30,0
	cpc R17,R30
	brne X23
	xjmp L23
X23:
X5:
	ldi R24,25
	ldi R25,0
	cp R24,R16
	cpc R25,R17
	brlt L34
X6:
L33:
	cpi R16,0
	cpc R16,R17
	breq L7
X7:
	cpi R16,1
	ldi R30,0
	cpc R17,R30
	breq L8
X8:
	xjmp L5
L34:
	cpi R16,32
	ldi R30,0
	cpc R17,R30
	brne X24
	xjmp L32
X24:
X9:
	xjmp L5
L7:
;     case NUT_IRQCTL_INIT:
;         /* Initialize to low level triggered. */
;         cbi(EICR, ISC50);
	in R24,0x3a
	andi R24,251
	out 0x3a,R24
;         cbi(EICR, ISC51);
	in R24,0x3a
	andi R24,247
	out 0x3a,R24
L8:
;     case NUT_IRQCTL_CLEAR:
;         /* Clear any pending interrupt. */
;         outb(EIFR, _BV(INTF5));
	ldi R24,32
	out 0x38,R24
;         break;
	xjmp L6
L9:
;     case NUT_IRQCTL_STATUS:
;         if (bit_is_set(EIFR, INTF5)) {
	in R2,0x38
	sbrs R2,5
	rjmp L10
X10:
;             *ival = 1;
	ldi R24,1
	ldi R25,0
	movw R30,R10
	std z+1,R25
	std z+0,R24
;         } else {
	xjmp L11
L10:
;             *ival = 0;
	clr R2
	clr R3
	movw R30,R10
	std z+1,R3
	std z+0,R2
;         }
L11:
;         if (enabled) {
	cpi R22,0
	cpc R22,R23
	brne X25
	xjmp L6
X25:
X11:
;             *ival |= 0x80;
	movw R30,R10
	ldd R24,z+0
	ldd R25,z+1
	ori R24,128
	std z+1,R25
	std z+0,R24
;         }
;         break;
	xjmp L6
L14:
;     case NUT_IRQCTL_ENABLE:
;         enabled = 1;
	ldi R22,1
	ldi R23,0
;         break;
	xjmp L6
L15:
;     case NUT_IRQCTL_DISABLE:
;         enabled = 0;
	clr R22
	clr R23
;         break;
	xjmp L6
L16:
;     case NUT_IRQCTL_GETMODE:
;         bval = inb(EICR) & _BV(ISC51 | ISC50);
	in R24,0x3a
	andi R24,8
	mov R12,R24
;         if (bval == _BV(ISC51)) {
	cpi R24,8
	brne L17
X12:
;             *ival = NUT_IRQMODE_FALLINGEDGE;
	ldi R24,5
	ldi R25,0
	movw R30,R10
	std z+1,R25
	std z+0,R24
;         } else if (bval == _BV(ISC50)) {
	xjmp L6
L17:
	mov R24,R12
	cpi R24,4
	brne L19
X13:
;             *ival = NUT_IRQMODE_EDGE;
	ldi R24,7
	ldi R25,0
	movw R30,R10
	std z+1,R25
	std z+0,R24
;         } else if (bval == _BV(ISC51 | ISC50)) {
	xjmp L6
L19:
	mov R24,R12
	cpi R24,8
	brne L21
X14:
;             *ival = NUT_IRQMODE_RISINGEDGE;
	ldi R24,6
	ldi R25,0
	movw R30,R10
	std z+1,R25
	std z+0,R24
;         } else {
	xjmp L6
L21:
;             *ival = NUT_IRQMODE_LOWLEVEL;
	ldi R24,1
	ldi R25,0
	movw R30,R10
	std z+1,R25
	std z+0,R24
;         }
;         break;
	xjmp L6
L23:
;     case NUT_IRQCTL_SETMODE:
;         if (*ival == NUT_IRQMODE_LOWLEVEL) {
	movw R30,R10
	ldd R24,z+0
	ldd R25,z+1
	cpi R24,1
	ldi R30,0
	cpc R25,R30
	brne L24
X15:
;             cbi(EICR, ISC50);
	in R24,0x3a
	andi R24,251
	out 0x3a,R24
;             cbi(EICR, ISC51);
	in R24,0x3a
	andi R24,247
	out 0x3a,R24
;         } else if (*ival == NUT_IRQMODE_EDGE) {
	xjmp L6
L24:
	movw R30,R10
	ldd R24,z+0
	ldd R25,z+1
	cpi R24,7
	ldi R30,0
	cpc R25,R30
	brne L26
X16:
;             sbi(EICR, ISC50);
	in R24,0x3a
	ori R24,4
	out 0x3a,R24
;             cbi(EICR, ISC51);
	in R24,0x3a
	andi R24,247
	out 0x3a,R24
;         } else if (*ival == NUT_IRQMODE_FALLINGEDGE) {
	xjmp L6
L26:
	movw R30,R10
	ldd R24,z+0
	ldd R25,z+1
	cpi R24,5
	ldi R30,0
	cpc R25,R30
	brne L28
X17:
;             cbi(EICR, ISC50);
	in R24,0x3a
	andi R24,251
	out 0x3a,R24
;             sbi(EICR, ISC51);
	in R24,0x3a
	ori R24,8
	out 0x3a,R24
;         } else if (*ival == NUT_IRQMODE_RISINGEDGE) {
	xjmp L6
L28:
	movw R30,R10
	ldd R24,z+0
	ldd R25,z+1
	cpi R24,6
	ldi R30,0
	cpc R25,R30
	brne L30
X18:
;             sbi(EICR, ISC50);
	in R24,0x3a
	ori R24,4
	out 0x3a,R24
;             sbi(EICR, ISC51);
	in R24,0x3a
	ori R24,8
	out 0x3a,R24
;         } else {
	xjmp L6
L30:
;             rc = -1;
	ldi R20,-1
	ldi R21,-1
;         }
;         break;
	xjmp L6
L32:
;     case NUT_IRQCTL_GETPRIO:
;         *ival = 5;
	ldi R24,5
	ldi R25,0
	movw R30,R10
	std z+1,R25
	std z+0,R24
;         break;
	xjmp L6
L5:
; #ifdef NUT_PERFMON
;     case NUT_IRQCTL_GETCOUNT:
;         *ival = (u_int) sig_INTERRUPT5.ir_count;
;         sig_INTERRUPT5.ir_count = 0;
;         break;
; #endif
;     default:
;         rc = -1;
	ldi R20,-1
	ldi R21,-1
;         break;
L6:
;     }
; 
;     /* Enable interrupt. */
;     if (enabled) {
	cpi R22,0
	cpc R22,R23
	breq L35
X19:
;         sbi(EIMSK, INT5);
	in R24,0x39
	ori R24,32
	out 0x39,R24
;     }
L35:
;     return rc;
	movw R16,R20
L2:
	.dbline 0 ; func end
	xjmp pop_xgsetF03C
	.area vector(rom, abs)
	.org 24
	jmp _SIG_INTERRUPT5
	.area text(rom, con, rel)
	.even
_SIG_INTERRUPT5::
	xcall push_lset
; }
; 
; /*! \fn SIG_INTERRUPT5(void)
;  * \brief External interrupt 5 entry.
;  */
; #ifdef __IMAGECRAFT__
; #pragma interrupt_handler SIG_INTERRUPT5:iv_INT5
; #endif
; NUTSIGNAL(SIG_INTERRUPT5, sig_INTERRUPT5)
	ldi R16,<_sig_INTERRUPT5
	ldi R17,>_sig_INTERRUPT5
	xcall _CallHandler
L37:
	.dbline 0 ; func end
	xcall pop_lset
	reti
; 
; 
; /*@}*/
	.area func_lit
PL_AvrInterrupt5Ctl:	.word `_AvrInterrupt5Ctl
