	.module ivect12.c
	.area data(ram, con, rel)
_sig_OUTPUT_COMPARE1A::
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.blkw 1
	.area idata
	.word PL_AvrTimer1CompAIrqCtl
	.area data(ram, con, rel)
	.area text(rom, con, rel)
;           ival -> R10,R11
;             rc -> R20,R21
;        enabled -> R22,R23
;          param -> R18,R19
;            cmd -> R16,R17
	.even
_AvrTimer1CompAIrqCtl:
	xcall push_xgsetF00C
; /*
;  * Copyright (C) 2001-2005 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  */
; 
; /*!
;  * \file arch/avr/dev/ivect12.c
;  * \brief Timer/Counter 1 compare match A interrupt.
;  *
;  * \verbatim
;  *
;  * $Log: ivect12.c,v $
;  * Revision 1.2.2.1  2006/01/25 09:44:01  haraldkipp
;  * Applied Thiago A. Correa's patch to fix ICC warnings.
;  *
;  * Revision 1.2  2005/10/24 09:34:30  haraldkipp
;  * New interrupt control function added to allow future platform
;  * independant drivers.
;  *
;  * Revision 1.1  2005/07/26 18:02:40  haraldkipp
;  * Moved from dev.
;  *
;  * Revision 1.2  2004/01/30 17:02:19  drsung
;  * Separate interrupt stack for avr-gcc only added.
;  *
;  * Revision 1.1.1.1  2003/05/09 14:40:42  haraldkipp
;  * Initial using 3.2.1
;  *
;  * Revision 1.2  2003/03/31 14:53:06  harald
;  * Prepare release 3.1
;  *
;  * \endverbatim
;  */
; 
; #include <dev/irqreg.h>
; 
; /*!
;  * \addtogroup xgIrqReg
;  */
; /*@{*/
; 
; static int AvrTimer1CompAIrqCtl(int cmd, void *param);
; 
; IRQ_HANDLER sig_OUTPUT_COMPARE1A = {
; #ifdef NUT_PERFMON
;     0,                          /* Interrupt counter, ir_count. */
; #endif
;     NULL,                       /* Passed argument, ir_arg. */
;     NULL,                       /* Handler subroutine, ir_handler. */
;     AvrTimer1CompAIrqCtl        /* Interrupt control, ir_ctl. */
; };
; 
; /*!
;  * \brief Timer/Counter 1 compare match A interrupt control.
;  *
;  * \param cmd   Control command.
;  *              - NUT_IRQCTL_INIT Initialize and disable interrupt.
;  *              - NUT_IRQCTL_CLEAR Clear interrupt.
;  *              - NUT_IRQCTL_STATUS Query interrupt status.
;  *              - NUT_IRQCTL_ENABLE Enable interrupt.
;  *              - NUT_IRQCTL_DISABLE Disable interrupt.
;  *              - NUT_IRQCTL_GETPRIO Query interrupt priority.
;  *              - NUT_IRQCTL_GETCOUNT Query and clear interrupt counter.
;  * \param param Pointer to optional parameter.
;  *
;  * \return 0 on success, -1 otherwise.
;  */
; static int AvrTimer1CompAIrqCtl(int cmd, void *param)
; {
;     int rc = 0;
	clr R20
	clr R21
;     u_int *ival = (u_int *) param;
	movw R10,R18
;     int enabled = bit_is_set(TIMSK, OCIE1A);
	in R2,0x37
	sbrs R2,4
	rjmp L3
X0:
	ldi R22,1
	ldi R23,0
	xjmp L4
L3:
	clr R22
	clr R23
L4:
; 
;     /* Disable interrupt. */
;     cbi(TIMSK, OCIE1A);
	in R24,0x37
	andi R24,239
	out 0x37,R24
; 
;     switch (cmd) {
	cpi R16,16
	ldi R30,0
	cpc R17,R30
	breq L9
X1:
	cpi R16,17
	ldi R30,0
	cpc R17,R30
	brne X11
	xjmp L14
X11:
X2:
	cpi R16,18
	ldi R30,0
	cpc R17,R30
	brne X12
	xjmp L15
X12:
X3:
	ldi R24,18
	ldi R25,0
	cp R24,R16
	cpc R25,R17
	brlt L18
X4:
L17:
	cpi R16,0
	cpc R16,R17
	breq L7
X5:
	cpi R16,1
	ldi R30,0
	cpc R17,R30
	breq L8
X6:
	xjmp L5
L18:
	cpi R16,32
	ldi R30,0
	cpc R17,R30
	breq L16
X7:
	xjmp L5
L7:
;     case NUT_IRQCTL_INIT:
;         enabled = 0;
	clr R22
	clr R23
L8:
;     case NUT_IRQCTL_CLEAR:
;         /* Clear any pending interrupt. */
;         outb(TIFR, _BV(OCF1A));
	ldi R24,16
	out 0x36,R24
;         break;
	xjmp L6
L9:
;     case NUT_IRQCTL_STATUS:
;         if (bit_is_set(TIFR, OCF1A)) {
	in R2,0x36
	sbrs R2,4
	rjmp L10
X8:
;             *ival = 1;
	ldi R24,1
	ldi R25,0
	movw R30,R10
	std z+1,R25
	std z+0,R24
;         } else {
	xjmp L11
L10:
;             *ival = 0;
	clr R2
	clr R3
	movw R30,R10
	std z+1,R3
	std z+0,R2
;         }
L11:
;         if (enabled) {
	cpi R22,0
	cpc R22,R23
	breq L6
X9:
;             *ival |= 0x80;
	movw R30,R10
	ldd R24,z+0
	ldd R25,z+1
	ori R24,128
	std z+1,R25
	std z+0,R24
;         }
;         break;
	xjmp L6
L14:
;     case NUT_IRQCTL_ENABLE:
;         enabled = 1;
	ldi R22,1
	ldi R23,0
;         break;
	xjmp L6
L15:
;     case NUT_IRQCTL_DISABLE:
;         enabled = 0;
	clr R22
	clr R23
;         break;
	xjmp L6
L16:
;     case NUT_IRQCTL_GETPRIO:
;         *ival = 11;
	ldi R24,11
	ldi R25,0
	movw R30,R10
	std z+1,R25
	std z+0,R24
;         break;
	xjmp L6
L5:
; #ifdef NUT_PERFMON
;     case NUT_IRQCTL_GETCOUNT:
;         *ival = (u_int) sig_OUTPUT_COMPARE1A.ir_count;
;         sig_OUTPUT_COMPARE1A.ir_count = 0;
;         break;
; #endif
;     default:
;         rc = -1;
	ldi R20,-1
	ldi R21,-1
;         break;
L6:
;     }
; 
;     /* Enable interrupt. */
;     if (enabled) {
	cpi R22,0
	cpc R22,R23
	breq L19
X10:
;         sbi(TIMSK, OCIE1A);
	in R24,0x37
	ori R24,16
	out 0x37,R24
;     }
L19:
;     return rc;
	movw R16,R20
L2:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
	.area vector(rom, abs)
	.org 48
	jmp _SIG_OUTPUT_COMPARE1A
	.area text(rom, con, rel)
	.even
_SIG_OUTPUT_COMPARE1A::
	xcall push_lset
; }
; 
; /*! \fn SIG_OUTPUT_COMPARE1A(void)
;  * \brief Timer 1A output compare interrupt entry.
;  */
; #ifdef __IMAGECRAFT__
; #pragma interrupt_handler SIG_OUTPUT_COMPARE1A:iv_TIMER1_COMPA
; #endif
; NUTSIGNAL(SIG_OUTPUT_COMPARE1A, sig_OUTPUT_COMPARE1A)
	ldi R16,<_sig_OUTPUT_COMPARE1A
	ldi R17,>_sig_OUTPUT_COMPARE1A
	xcall _CallHandler
L21:
	.dbline 0 ; func end
	xcall pop_lset
	reti
; 
; 
; /*@}*/
	.area func_lit
PL_AvrTimer1CompAIrqCtl:	.word `_AvrTimer1CompAIrqCtl
