	.module pcmcia.c
	.area text(rom, con, rel)
;            eIO -> y+0
;          wData -> R18,R19
;       wAddress -> R16,R17
	.even
_WriteXXX:
; /****************************************************************************
; *  This file is part of the WLAN-Ethernut driver.
; *
; *  Copyright (c) 2004 by Michael Fischer. All rights reserved.
; *
; *  Redistribution and use in source and binary forms, with or without 
; *  modification, are permitted provided that the following conditions 
; *  are met:
; *  
; *  1. Redistributions of source code must retain the above copyright 
; *     notice, this list of conditions and the following disclaimer.
; *  2. Redistributions in binary form must reproduce the above copyright
; *     notice, this list of conditions and the following disclaimer in the 
; *     documentation and/or other materials provided with the distribution.
; *  3. Neither the name of the author nor the names of its contributors may 
; *     be used to endorse or promote products derived from this software 
; *     without specific prior written permission.
; *
; *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
; *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
; *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
; *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
; *  THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
; *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
; *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS 
; *  OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
; *  AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
; *  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF 
; *  THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
; *  SUCH DAMAGE.
; *
; ****************************************************************************
; *  History:
; *
; *  07.02.04  mifi   First Version for the XC9572-PC84 ONLY!
; *                   The BASE_ADDRESS is 0x8800!!
; ****************************************************************************/
; #define __PCMCIA_C__
; 
; /*
;  * The PCMCIA interface works with a Xilinx XC9572-PC84 CPLD.
;  * All the lines like CE1, CE2, WE, OE and so on must be control
;  * separate by the latch.
;  *
; */
; 
; #include <compiler.h>
; 
; #include <dev/wlantypes.h>
; #include <dev/pcmcia.h>
; 
; /*==========================================================*/
; /*  DEFINE: All Structures and Common Constants             */
; /*==========================================================*/
; /*
;  * Address offset, register index of the CPLD
; */
; #define BASE_ADDRESS  0x8800
; #define DATA_LOW      0
; #define DATA_HIGH     1
; #define ADDRESS_LOW   2
; #define ADDRESS_HIGH  3
; #define CTRL          4
; 
; /*
;  * CTRL bit definition
; */
; #define CTRL_CE1      0x01
; #define CTRL_CE2      0x02
; #define CTRL_OE       0x04
; #define CTRL_WE       0x08
; #define CTRL_IORD     0x10
; #define CTRL_IOWR     0x20
; #define CTRL_REGS     0x40
; #define CTRL_DATA_OUT 0x80
; 
; #define DATA_LOW_REG      *((volatile BYTE *)BASE_ADDRESS+DATA_LOW)
; #define DATA_HIGH_REG     *((volatile BYTE *)BASE_ADDRESS+DATA_HIGH)
; #define ADDRESS_LOW_REG   *((volatile BYTE *)BASE_ADDRESS+ADDRESS_LOW)
; #define ADDRESS_HIGH_REG  *((volatile BYTE *)BASE_ADDRESS+ADDRESS_HIGH)
; #define CTRL_REG          *((volatile BYTE *)BASE_ADDRESS+CTRL)
; 
; /*
;  * Some delay values
; */
; #define DELAY_CE_WRITE()
; #define DELAY_WRITE()
; #define DELAY_WRITE_CE()
; 
; #define DELAY_CE_READ()
; #define DELAY_READ()    _NOP();_NOP(); _NOP();_NOP()
; #define DELAY_READ_CE()
; 
; typedef enum {
;     TYPE_IO = 0,
;     TYPE_MEM
; } MEMORY_TYPE;
; 
; /*==========================================================*/
; /*  DEFINE: Prototypes                                      */
; /*==========================================================*/
; 
; /*==========================================================*/
; /*  DEFINE: Definition of all local Data                    */
; /*==========================================================*/
; //static volatile BYTE *pCPLD = (volatile BYTE *) BASE_ADDRESS;
; //static BYTE gbCTRLValue = 0x7C;
; 
; /*==========================================================*/
; /*  DEFINE: Definition of all local Procedures              */
; /*==========================================================*/
; /************************************************************/
; /*  WriteXXX                                                */
; /************************************************************/
; static void WriteXXX(WORD wAddress, WORD wData, MEMORY_TYPE eIO)
; {
;     cli();
	cli
; 
;     /*
;      * set ADDRESS
;      */
;     ADDRESS_LOW_REG = LOBYTE(wAddress);
	movw R24,R16
	andi R25,0
	sts 34818,R24
;     ADDRESS_HIGH_REG = HIBYTE(wAddress);
	movw R24,R16
	mov R24,R25
	clr R25
	andi R25,0
	sts 34819,R24
; 
;     /*
;      * set DATA
;      */
;     DATA_LOW_REG = LOBYTE(wData);
	movw R24,R18
	andi R25,0
	sts 34816,R24
;     DATA_HIGH_REG = HIBYTE(wData);
	movw R24,R18
	mov R24,R25
	clr R25
	andi R25,0
	sts 34817,R24
; 
;     /*
;      * set CE1, CE2
;      */
;     CTRL_REG = (CTRL_CE1 | CTRL_CE2 | CTRL_OE | CTRL_WE | CTRL_IORD | CTRL_IOWR | CTRL_DATA_OUT);
	ldi R24,191
	sts 34820,R24
; 
;     DELAY_CE_WRITE();
; 
;     /*
;      * set WR/IOWR
;      */
;     if (eIO == TYPE_MEM) {
	ldd R24,y+0
	cpi R24,1
	brne L3
X0:
;         CTRL_REG = (CTRL_CE1 | CTRL_CE2 | CTRL_OE | CTRL_IORD | CTRL_IOWR | CTRL_DATA_OUT);
	ldi R24,183
	sts 34820,R24
;     } else {
	xjmp L4
L3:
;         CTRL_REG = (CTRL_CE1 | CTRL_CE2 | CTRL_OE | CTRL_WE | CTRL_IORD | CTRL_DATA_OUT);
	ldi R24,159
	sts 34820,R24
;     }
L4:
; 
;     DELAY_WRITE();
; 
;     /*
;      * check the WAIT signal
;      */
; 
;     /*
;      * remove WR/IOWR
;      */
;     CTRL_REG = (CTRL_CE1 | CTRL_CE2 | CTRL_OE | CTRL_WE | CTRL_IORD | CTRL_IOWR | CTRL_DATA_OUT);
	ldi R24,191
	sts 34820,R24
; 
;     DELAY_WRITE_CE();
; 
;     /*
;      * remove CE1, CE2
;      */
;     CTRL_REG = (CTRL_OE | CTRL_WE | CTRL_IORD | CTRL_IOWR);
	ldi R24,60
	sts 34820,R24
; 
;     sei();
	sei
L2:
	.dbline 0 ; func end
	ret
;          bHigh -> R10
;           bLow -> R12
;          wData -> R10,R11
;            eIO -> R18
;       wAddress -> R16,R17
	.even
_ReadXXX:
	xcall push_xgset003C
; }
; 
; /************************************************************/
; /*  ReadXXX                                                 */
; /************************************************************/
; static WORD ReadXXX(WORD wAddress, MEMORY_TYPE eIO)
; {
;     BYTE bLow;
;     BYTE bHigh;
;     WORD wData;
; 
;     cli();
	cli
; 
;     /*
;      * set ADDRESS
;      */
;     ADDRESS_LOW_REG = LOBYTE(wAddress);
	movw R24,R16
	andi R25,0
	sts 34818,R24
;     ADDRESS_HIGH_REG = HIBYTE(wAddress);
	movw R24,R16
	mov R24,R25
	clr R25
	andi R25,0
	sts 34819,R24
; 
;     /*
;      * set CE1, CE2
;      */
;     CTRL_REG = (CTRL_CE1 | CTRL_CE2 | CTRL_OE | CTRL_WE | CTRL_IORD | CTRL_IOWR);
	ldi R24,63
	sts 34820,R24
; 
;     DELAY_CE_READ();
; 
;     /*
;      * set OE/IORD
;      */
;     if (eIO == TYPE_MEM) {
	cpi R18,1
	brne L6
X1:
;         CTRL_REG = (CTRL_CE1 | CTRL_CE2 | CTRL_WE | CTRL_IORD | CTRL_IOWR);
	ldi R24,59
	sts 34820,R24
;     } else {
	xjmp L7
L6:
;         CTRL_REG = (CTRL_CE1 | CTRL_CE2 | CTRL_OE | CTRL_WE | CTRL_IOWR);
	ldi R24,47
	sts 34820,R24
;     }
L7:
; 
;     DELAY_READ();
	nop
	nop
	nop
	nop
; 
;     /*
;      * check the WAIT signal
;      */
;     bLow = DATA_LOW_REG;
	lds R12,34816
;     bHigh = DATA_HIGH_REG;
	lds R10,34817
; 
;     /*
;      * remove OE/IORD
;      */
;     CTRL_REG = (CTRL_CE1 | CTRL_CE2 | CTRL_OE | CTRL_WE | CTRL_IORD | CTRL_IOWR | CTRL_DATA_OUT);
	ldi R24,191
	sts 34820,R24
; 
;     DELAY_READ_CE();
; 
;     /*
;      * remove CE1, CE2
;      */
;     CTRL_REG = (CTRL_OE | CTRL_WE | CTRL_IORD | CTRL_IOWR);
	ldi R24,60
	sts 34820,R24
; 
;     wData = (WORD) bHigh;
	clr R11
;     wData = (wData << 8) | (WORD) bLow;
	mov R2,R12
	clr R3
	movw R4,R10
	mov R5,R4
	clr R4
	or R4,R2
	or R5,R3
	movw R10,R4
; 
;     sei();
	sei
; 
;     return (wData);
	movw R16,R4
L5:
	.dbline 0 ; func end
	xjmp pop_xgset003C
;          wData -> R12,R13
;       wAddress -> R10,R11
	.even
_pcmcia_WriteMem::
	xcall push_xgset003C
	movw R12,R18
	movw R10,R16
	sbiw R28,1
; }
; 
; /*==========================================================*/
; /*  DEFINE: All code exported                               */
; /*==========================================================*/
; /************************************************************/
; /*  pcmcia_WriteMem                                         */
; /************************************************************/
; void pcmcia_WriteMem(WORD wAddress, WORD wData)
; {
;     WriteXXX(wAddress, wData, TYPE_MEM);
	ldi R24,1
	std y+0,R24
	movw R18,R12
	movw R16,R10
	xcall _WriteXXX
L8:
	.dbline 0 ; func end
	adiw R28,1
	xjmp pop_xgset003C
;          wData -> R12,R13
;       wAddress -> R10,R11
	.even
_pcmcia_WriteReg::
	xcall push_xgset003C
	movw R12,R18
	movw R10,R16
	sbiw R28,1
; }
; 
; /************************************************************/
; /*  pcmcia_WriteReg                                         */
; /************************************************************/
; void pcmcia_WriteReg(WORD wAddress, WORD wData)
; {
;     WriteXXX(wAddress, wData, TYPE_IO);
	clr R2
	std y+0,R2
	movw R18,R12
	movw R16,R10
	xcall _WriteXXX
L9:
	.dbline 0 ; func end
	adiw R28,1
	xjmp pop_xgset003C
;       wAddress -> R10,R11
	.even
_pcmcia_ReadMem::
	st -y,R10
	st -y,R11
	movw R10,R16
; }
; 
; /************************************************************/
; /*  pcmcia_ReadMem                                          */
; /************************************************************/
; WORD pcmcia_ReadMem(WORD wAddress)
; {
;     return (ReadXXX(wAddress, TYPE_MEM));
	ldi R18,1
	movw R16,R10
	xcall _ReadXXX
L10:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
;       wAddress -> R10,R11
	.even
_pcmcia_ReadReg::
	st -y,R10
	st -y,R11
	movw R10,R16
; }
; 
; /************************************************************/
; /*  pcmcia_ReadReg                                          */
; /************************************************************/
; WORD pcmcia_ReadReg(WORD wAddress)
; {
;     return (ReadXXX(wAddress, TYPE_IO));
	clr R18
	movw R16,R10
	xcall _ReadXXX
L11:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
; }
