	.module twif.c
	.area text(rom, con, rel)
;           twsr -> R22
;           twcr -> R20
;            arg -> R10,R11
	.even
_TwInterrupt:
	xcall push_xgsetF00C
	movw R10,R16
; /*
;  * Copyright (C) 2001-2005 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  */
; 
; /*
;  * $Log: twif.c,v $
;  * Revision 1.3  2005/10/24 10:56:30  haraldkipp
;  * Added const modifier to transmit data pointer in TwMasterTransact().
;  *
;  * Revision 1.2  2005/10/07 22:03:29  hwmaier
;  * Using __AVR_ENHANCED__ macro instead of __AVR_ATmega128__ to support also AT90CAN128 MCU
;  *
;  * Revision 1.1  2005/07/26 18:02:40  haraldkipp
;  * Moved from dev.
;  *
;  * Revision 1.9  2005/01/24 21:12:05  freckle
;  * renamed NutEventPostFromIRQ into NutEventPostFromIrq
;  *
;  * Revision 1.8  2005/01/21 16:49:46  freckle
;  * Seperated calls to NutEventPostAsync between Threads and IRQs
;  *
;  * Revision 1.7  2004/12/16 08:40:35  haraldkipp
;  * Late increment fixes ICCAVR bug.
;  *
;  * Revision 1.6  2004/11/08 18:12:59  haraldkipp
;  * Soooo many fixes, but I'm tired...really.
;  *
;  * Revision 1.5  2004/09/08 10:19:14  haraldkipp
;  * *** empty log message ***
;  *
;  * Revision 1.4  2003/11/03 17:03:53  haraldkipp
;  * Many new comments added
;  *
;  * Revision 1.3  2003/07/20 18:28:10  haraldkipp
;  * Explain how to disable timeout.
;  *
;  * Revision 1.2  2003/07/17 09:38:07  haraldkipp
;  * Setting different speeds is now supported.
;  *
;  * Revision 1.1.1.1  2003/05/09 14:40:53  haraldkipp
;  * Initial using 3.2.1
;  *
;  * Revision 1.2  2003/03/31 14:53:08  harald
;  * Prepare release 3.1
;  *
;  * Revision 1.1  2003/02/04 17:54:59  harald
;  * *** empty log message ***
;  *
;  */
; 
; #include <string.h>
; 
; #include <dev/irqreg.h>
; 
; #include <sys/event.h>
; #include <sys/atom.h>
; #include <sys/timer.h>
; #include <sys/thread.h>
; #include <sys/heap.h>
; 
; #include <dev/twif.h>
; 
; #ifdef __AVR_ENHANCED__
; 
; static volatile u_char tw_if_bsy;   /* Set while interface is busy. */
; 
; HANDLE tw_mm_mutex;          /* Exclusive master access. */
; HANDLE tw_mm_que;            /* Threads waiting for master transfer done. */
; HANDLE tw_sr_que;            /* Threads waiting for slave receive. */
; HANDLE tw_st_que;            /* Threads waiting for slave transmit done. */
; 
; static u_char tw_mm_sla;            /* Destination slave address. */
; static volatile u_char tw_mm_err;   /* Current master mode error. */
; static u_char tw_mm_error;          /* Last master mode error. */
; 
; static CONST u_char *tw_mt_buf;     /* Pointer to the master transmit buffer. */
; static volatile u_short tw_mt_len;  /* Number of bytes to transmit in master mode. */
; static volatile u_short tw_mt_idx;  /* Current master transmit buffer index. */
; 
; static u_char *tw_mr_buf;           /* Pointer to the master receive buffer. */
; static volatile u_short tw_mr_siz;  /* Size of the master receive buffer. */
; static volatile u_short tw_mr_idx;  /* Current master receive buffer index. */
; 
; static volatile u_char tw_sm_sla;   /* Slave address received. */
; static volatile u_char tw_sm_err;   /* Current slave mode error. */
; static u_char tw_sm_error;          /* Last slave mode error. */
; 
; static u_char *tw_st_buf;           /* Pointer to the slave transmit buffer. */
; static volatile u_short tw_st_len;  /* Number of bytes to transmit in slave mode. */
; static volatile u_short tw_st_idx;  /* Current slave transmit buffer index. */
; 
; static u_char *tw_sr_buf;           /* Pointer to the slave receive buffer. */
; static volatile u_short tw_sr_siz;  /* Size of the master receive buffer. */
; static volatile u_short tw_sr_idx;  /* Current slave receive buffer index. */
; 
; /*
; TWINT TWEA TWSTA TWSTO TWWC TWEN  0  TWIE
;   C                      R        R
; */
; 
; #define TWGO    (_BV(TWINT) | _BV(TWEN) | _BV(TWIE))
; 
; /*
;  * TWI interrupt handler.
;  */
; static void TwInterrupt(void *arg)
; {
;     u_char twsr;
;     register u_char twcr = inb(TWCR);
	lds R20,116
; 
;     /*
;      * Read the status and interpret its contents.
;      */
;     twsr = inb(TWSR) & 0xF8;
	lds R22,113
	andi R22,248
;     switch (twsr) {
	mov R10,R22
	clr R11
	movw R24,R10
	cpi R24,96
	ldi R30,0
	cpc R25,R30
	brne X62
	xjmp L28
X62:
X0:
	ldi R24,96
	cp R24,R10
	cpc R25,R11
	brge X63
	xjmp L59
X63:
X1:
L58:
	movw R24,R10
	cpi R24,40
	ldi R30,0
	cpc R25,R30
	brne X64
	xjmp L9
X64:
X2:
	ldi R24,40
	ldi R25,0
	cp R24,R10
	cpc R25,R11
	brge X65
	xjmp L61
X65:
X3:
L60:
	movw R24,R10
	cpi R24,16
	ldi R30,0
	cpc R25,R30
	brne X66
	xjmp L6
X66:
X4:
	ldi R24,16
	ldi R25,0
	cp R24,R10
	cpc R25,R11
	brlt L63
X5:
L62:
	tst R10
	brne X6
	tst R11
	brne X67
	xjmp L57
X67:
X6:
	movw R24,R10
	cpi R24,0
	ldi R30,0
	cpc R25,R30
	brge X68
	xjmp L3
X68:
X7:
L64:
	movw R24,R10
	cpi R24,8
	ldi R30,0
	cpc R25,R30
	brne X69
	xjmp L6
X69:
X8:
	xjmp L3
L63:
	movw R24,R10
	cpi R24,24
	ldi R30,0
	cpc R25,R30
	brne X70
	xjmp L9
X70:
X9:
	cpi R24,24
	ldi R30,0
	cpc R25,R30
	brge X71
	xjmp L3
X71:
X10:
L65:
	movw R24,R10
	cpi R24,32
	ldi R30,0
	cpc R25,R30
	brne X72
	xjmp L14
X72:
X11:
	xjmp L3
L61:
	movw R24,R10
	cpi R24,64
	ldi R30,0
	cpc R25,R30
	brne X73
	xjmp L22
X73:
X12:
	ldi R24,64
	ldi R25,0
	cp R24,R10
	cpc R25,R11
	brlt L67
X13:
L66:
	movw R24,R10
	cpi R24,48
	ldi R30,0
	cpc R25,R30
	brne X74
	xjmp L14
X74:
X14:
	cpi R24,48
	ldi R30,0
	cpc R25,R30
	brge X75
	xjmp L3
X75:
X15:
L68:
	movw R24,R10
	cpi R24,56
	ldi R30,0
	cpc R25,R30
	brne X76
	xjmp L20
X76:
X16:
	xjmp L3
L67:
	movw R24,R10
	cpi R24,80
	ldi R30,0
	cpc R25,R30
	brne X77
	xjmp L21
X77:
X17:
	ldi R24,80
	ldi R25,0
	cp R24,R10
	cpc R25,R11
	brlt L70
X18:
L69:
	movw R24,R10
	cpi R24,72
	ldi R30,0
	cpc R25,R30
	brne X78
	xjmp L14
X78:
X19:
	xjmp L3
L70:
	movw R24,R10
	cpi R24,88
	ldi R30,0
	cpc R25,R30
	brne X79
	xjmp L25
X79:
X20:
	xjmp L3
L59:
	movw R24,R10
	cpi R24,152
	ldi R30,0
	cpc R25,R30
	brne X80
	xjmp L36
X80:
X21:
	ldi R24,152
	ldi R25,0
	cp R24,R10
	cpc R25,R11
	brge X81
	xjmp L72
X81:
X22:
L71:
	movw R24,R10
	cpi R24,120
	ldi R30,0
	cpc R25,R30
	brne X82
	xjmp L28
X82:
X23:
	ldi R24,120
	ldi R25,0
	cp R24,R10
	cpc R25,R11
	brlt L74
X24:
L73:
	movw R24,R10
	cpi R24,104
	ldi R30,0
	cpc R25,R30
	brne X83
	xjmp L28
X83:
X25:
	cpi R24,104
	ldi R30,0
	cpc R25,R30
	brge X84
	xjmp L3
X84:
X26:
L75:
	movw R24,R10
	cpi R24,112
	ldi R30,0
	cpc R25,R30
	brne X85
	xjmp L28
X85:
X27:
	xjmp L3
L74:
	movw R24,R10
	cpi R24,136
	ldi R30,0
	cpc R25,R30
	brne X86
	xjmp L36
X86:
X28:
	ldi R24,136
	ldi R25,0
	cp R24,R10
	cpc R25,R11
	brlt L77
X29:
L76:
	movw R24,R10
	cpi R24,128
	ldi R30,0
	cpc R25,R30
	brne X87
	xjmp L31
X87:
X30:
	xjmp L3
L77:
	movw R24,R10
	cpi R24,144
	ldi R30,0
	cpc R25,R30
	brne X88
	xjmp L31
X88:
X31:
	xjmp L3
L72:
	movw R24,R10
	cpi R24,176
	ldi R30,0
	cpc R25,R30
	brne X89
	xjmp L47
X89:
X32:
	ldi R24,176
	ldi R25,0
	cp R24,R10
	cpc R25,R11
	brlt L79
X33:
L78:
	movw R24,R10
	cpi R24,160
	ldi R30,0
	cpc R25,R30
	brne X90
	xjmp L40
X90:
X34:
	cpi R24,160
	ldi R30,0
	cpc R25,R30
	brge X91
	xjmp L3
X91:
X35:
L80:
	movw R24,R10
	cpi R24,168
	ldi R30,0
	cpc R25,R30
	brne X92
	xjmp L47
X92:
X36:
	xjmp L3
L79:
	movw R24,R10
	cpi R24,192
	ldi R30,0
	cpc R25,R30
	brne X93
	xjmp L53
X93:
X37:
	ldi R24,192
	ldi R25,0
	cp R24,R10
	cpc R25,R11
	brlt L82
X38:
L81:
	movw R24,R10
	cpi R24,184
	ldi R30,0
	cpc R25,R30
	brne X94
	xjmp L48
X94:
X39:
	xjmp L3
L82:
	movw R24,R10
	cpi R24,200
	ldi R30,0
	cpc R25,R30
	brne X95
	xjmp L53
X95:
X40:
	xjmp L3
L6:
; 
;     /*
;      * 0x08: Start condition has been transmitted.
;      * 0x10: Repeated start condition has been transmitted.
;      */
;     case TW_START:
;     case TW_REP_START:
;         /* We are entering the master mode. Mark the interface busy. */
;         tw_if_bsy = 1;
	ldi R24,1
	sts _tw_if_bsy,R24
;         tw_mt_idx = 0;
	clr R2
	clr R3
	sts _tw_mt_idx+1,R3
	sts _tw_mt_idx,R2
;         tw_mr_idx = 0;
	sts _tw_mr_idx+1,R3
	sts _tw_mr_idx,R2
; 
;         /*
;          * If outgoing data is available, transmit SLA+W. Logic is in
;          * master transmit mode.
;          */
;         if (tw_mt_len) {
	lds R2,_tw_mt_len
	lds R3,_tw_mt_len+1
	tst R2
	brne X41
	tst R3
	breq L7
X41:
;             outb(TWDR, tw_mm_sla);
	lds R2,_tw_mm_sla
	sts 115,R2
;         }
	xjmp L8
L7:
; 
;         /*
;          * If outgoing data not available, transmit SLA+R. Logic will
;          * switch to master receiver mode.
;          */
;         else {
;             outb(TWDR, tw_mm_sla | 1);
	lds R24,_tw_mm_sla
	ori R24,1
	sts 115,R24
;         }
L8:
;         outb(TWCR, TWGO | (twcr & _BV(TWEA)));
	mov R24,R20
	andi R24,64
	ori R24,133
	sts 116,R24
;         break;
	xjmp L4
L9:
; 
;     /*
;      * 0x18: SLA+W has been transmitted and ACK has been received.
;      * 0x28: Data byte has been transmitted and ACK has been received.
;      */
;     case TW_MT_SLA_ACK:
;     case TW_MT_DATA_ACK:
;         /*
;          * If outgoing data left to send, put the next byte in the data
;          * register.
;          */
;         if (tw_mt_idx < tw_mt_len) {
	lds R2,_tw_mt_len
	lds R3,_tw_mt_len+1
	lds R4,_tw_mt_idx
	lds R5,_tw_mt_idx+1
	cp R4,R2
	cpc R5,R3
	brsh L10
X42:
;             outb(TWDR, tw_mt_buf[tw_mt_idx]);
	lds R2,_tw_mt_buf
	lds R3,_tw_mt_buf+1
	lds R30,_tw_mt_idx
	lds R31,_tw_mt_idx+1
	add R30,R2
	adc R31,R3
	ldd R2,z+0
	sts 115,R2
;             /* Late increment fixes ICCAVR bug. Thanks to Andreas Siebert and Michael Fischer. */
;             tw_mt_idx++;
	lds R24,_tw_mt_idx
	lds R25,_tw_mt_idx+1
	adiw R24,1
	sts _tw_mt_idx+1,R25
	sts _tw_mt_idx,R24
;             outb(TWCR, TWGO | (twcr & _BV(TWEA)));
	mov R24,R20
	andi R24,64
	ori R24,133
	sts 116,R24
;             break;
	xjmp L4
L10:
;         }
; 
;         /*
;          * All outgoing data has been sent. If a response is expected,
;          * transmit a repeated start condition.
;          */
;         tw_mt_len = 0;
	clr R2
	clr R3
	sts _tw_mt_len+1,R3
	sts _tw_mt_len,R2
;         if (tw_mr_siz) {
	lds R2,_tw_mr_siz
	lds R3,_tw_mr_siz+1
	tst R2
	brne X43
	tst R3
	breq L12
X43:
;             outb(TWCR, TWGO | (twcr & _BV(TWEA)) | _BV(TWSTA));
	mov R24,R20
	andi R24,64
	ori R24,165
	sts 116,R24
;             break;
	xjmp L4
L12:
L14:
;         }
; 
;     /*
;      * 0x20: SLA+W has been transmitted, but not acknowledged.
;      * 0x30: Data byte has been transmitted, but not acknowledged.
;      * 0x48: SLA+R has been transmitted, but not acknowledged.
;      */
;     case TW_MT_SLA_NACK:
;     case TW_MT_DATA_NACK:
;     case TW_MR_SLA_NACK:
;         /* Set unique error code. */
;         if (twsr == TW_MT_SLA_NACK || twsr == TW_MR_SLA_NACK) {
	cpi R22,32
	breq L17
X44:
	cpi R22,72
	brne L15
X45:
L17:
;             tw_mm_err = TWERR_SLA_NACK;
	ldi R24,4
	sts _tw_mm_err,R24
;             tw_mt_len = 0;
	clr R2
	clr R3
	sts _tw_mt_len+1,R3
	sts _tw_mt_len,R2
;             tw_mr_siz = 0;
	sts _tw_mr_siz+1,R3
	sts _tw_mr_siz,R2
;         }
L15:
; 
;         /* Wake up the application. */
;         NutEventPostFromIrq(&tw_mm_que);
	ldi R16,<_tw_mm_que
	ldi R17,>_tw_mm_que
	xcall _NutEventPostFromIrq
; 
;         /*
;          * Send a stop condition. If we have a listener, generate
;          * an acknowlegde on an incoming address byte.
;          */
;         if(tw_sr_siz) {
	lds R2,_tw_sr_siz
	lds R3,_tw_sr_siz+1
	tst R2
	brne X46
	tst R3
	breq L18
X46:
;             outb(TWCR, TWGO | _BV(TWEA) | _BV(TWSTO));
	ldi R24,213
	sts 116,R24
;         }
	xjmp L19
L18:
;         else {
;             outb(TWCR, TWGO | _BV(TWSTO));
	ldi R24,149
	sts 116,R24
;         }
L19:
; 
;         /* The interface is idle. */
;         tw_if_bsy = 0;
	clr R2
	sts _tw_if_bsy,R2
;         break;
	xjmp L4
L20:
; 
;     /*
;      * 0x38: Arbitration lost while in master mode.
;      */
;     case TW_MT_ARB_LOST:
;         /*
;          * The start condition will be automatically resend after
;          * the bus becomes available.
;          */
;         sbi(TWCR, TWSTA);
	lds R24,116
	ori R24,32
	sts 116,R24
;         /* The interface is idle. */
;         tw_if_bsy = 0;
	clr R2
	sts _tw_if_bsy,R2
;         break;
	xjmp L4
L21:
; 
;     /*
;      * 0x50: Data byte has been received and acknowledged.
;      */
;     case TW_MR_DATA_ACK:
;         /*
;          * Store the data byte in the master receive buffer.
;          */
;         tw_mr_buf[tw_mr_idx] = inb(TWDR);
	lds R2,_tw_mr_buf
	lds R3,_tw_mr_buf+1
	lds R30,_tw_mr_idx
	lds R31,_tw_mr_idx+1
	add R30,R2
	adc R31,R3
	lds R2,115
	std z+0,R2
;         /* Late increment fixes ICCAVR bug. Thanks to Andreas Siebert and Michael Fischer. */
;         tw_mr_idx++;
	lds R24,_tw_mr_idx
	lds R25,_tw_mr_idx+1
	adiw R24,1
	sts _tw_mr_idx+1,R25
	sts _tw_mr_idx,R24
L22:
; 
;     /*
;      * 0x40: SLA+R has been transmitted and ACK has been received.
;      */
;     case TW_MR_SLA_ACK:
;         /*
;          * Acknowledge next data bytes except the last one.
;          */
;         if (tw_mr_idx + 1 < tw_mr_siz) {
	lds R2,_tw_mr_siz
	lds R3,_tw_mr_siz+1
	lds R24,_tw_mr_idx
	lds R25,_tw_mr_idx+1
	adiw R24,1
	cp R24,R2
	cpc R25,R3
	brsh L23
X47:
;             outb(TWCR, TWGO | _BV(TWEA));
	ldi R24,197
	sts 116,R24
;         }
	xjmp L4
L23:
;         else {
;             outb(TWCR, TWGO);
	ldi R24,133
	sts 116,R24
;         }
;         break;
	xjmp L4
L25:
; 
;     /*
;      * 0x58: Data byte has been received, but not acknowledged.
;      */
;     case TW_MR_DATA_NACK:
;         /*
;          * Store the last data byte.
;          */
;         tw_mr_buf[tw_mr_idx] = inb(TWDR);
	lds R2,_tw_mr_buf
	lds R3,_tw_mr_buf+1
	lds R30,_tw_mr_idx
	lds R31,_tw_mr_idx+1
	add R30,R2
	adc R31,R3
	lds R2,115
	std z+0,R2
;         /* Late increment fixes ICCAVR bug. Thanks to Andreas Siebert and Michael Fischer. */
;         tw_mr_idx++;
	lds R24,_tw_mr_idx
	lds R25,_tw_mr_idx+1
	adiw R24,1
	sts _tw_mr_idx+1,R25
	sts _tw_mr_idx,R24
;         tw_mr_siz = 0;
	clr R2
	clr R3
	sts _tw_mr_siz+1,R3
	sts _tw_mr_siz,R2
; 
;         /* Wake up the application. */
;         NutEventPostFromIrq(&tw_mm_que);
	ldi R16,<_tw_mm_que
	ldi R17,>_tw_mm_que
	xcall _NutEventPostFromIrq
; 
;         /*
;          * Send a stop condition. If we have a listener, generate
;          * an acknowlegde on an incoming address byte.
;          */
;         if(tw_sr_siz) {
	lds R2,_tw_sr_siz
	lds R3,_tw_sr_siz+1
	tst R2
	brne X48
	tst R3
	breq L26
X48:
;             outb(TWCR, TWGO | _BV(TWEA) | _BV(TWSTO));
	ldi R24,213
	sts 116,R24
;         }
	xjmp L27
L26:
;         else {
;             outb(TWCR, TWGO | _BV(TWSTO));
	ldi R24,149
	sts 116,R24
;         }
L27:
; 
;         /* The interface is idle. */
;         tw_if_bsy = 0;
	clr R2
	sts _tw_if_bsy,R2
;         break;
	xjmp L4
L28:
; 
;     /*
;      * 0x60: Own SLA+W has been received and acknowledged.
;      * 0x68: Arbitration lost as master. Own SLA+W has been received
;      *       and acknowledged.
;      * 0x70: General call address has been received and acknowledged.
;      * 0x78: Arbitration lost as master. General call address has been
;      *       received and acknowledged.
;      */
;     case TW_SR_SLA_ACK:
;     case TW_SR_ARB_LOST_SLA_ACK:
;     case TW_SR_GCALL_ACK:
;     case TW_SR_ARB_LOST_GCALL_ACK:
;         /*
;          * Do only acknowledge incoming data bytes, if we got receive
;          * buffer space. Fetch the slave address from the data register
;          * and reset the receive index.
;          */
;         if (tw_sr_siz) {
	lds R2,_tw_sr_siz
	lds R3,_tw_sr_siz+1
	tst R2
	brne X49
	tst R3
	breq L29
X49:
;             /* We are entering the slave receive mode. Mark the interface busy. */
;             tw_if_bsy = 1;
	ldi R24,1
	sts _tw_if_bsy,R24
; 
;             tw_sm_sla = inb(TWDR);
	lds R2,115
	sts _tw_sm_sla,R2
;             outb(TWCR, TWGO | _BV(TWEA));
	ldi R24,197
	sts 116,R24
;             tw_sr_idx = 0;
	clr R2
	clr R3
	sts _tw_sr_idx+1,R3
	sts _tw_sr_idx,R2
;         }
	xjmp L4
L29:
; 
;         /*
;          * Do not acknowledge incoming data.
;          */
;         else {
;             outb(TWCR, TWGO);
	ldi R24,133
	sts 116,R24
;         }
;         break;
	xjmp L4
L31:
; 
;     /*
;      * 0x80: Data byte for own SLA has been received and acknowledged.
;      * 0x90: Data byte for general call address has been received and
;      *       acknowledged.
;      */
;     case TW_SR_DATA_ACK:
;     case TW_SR_GCALL_DATA_ACK:
;         /*
;          * If the receive buffer isn't filled up, store data byte.
;          */
;         if (tw_sr_idx < tw_sr_siz) {
	lds R2,_tw_sr_siz
	lds R3,_tw_sr_siz+1
	lds R4,_tw_sr_idx
	lds R5,_tw_sr_idx+1
	cp R4,R2
	cpc R5,R3
	brsh L32
X50:
;             tw_sr_buf[tw_sr_idx] = inb(TWDR);
	lds R2,_tw_sr_buf
	lds R3,_tw_sr_buf+1
	lds R30,_tw_sr_idx
	lds R31,_tw_sr_idx+1
	add R30,R2
	adc R31,R3
	lds R2,115
	std z+0,R2
;             /* Late increment fixes ICCAVR bug. Thanks to Andreas Siebert and Michael Fischer. */
;             tw_sr_idx++;
	lds R24,_tw_sr_idx
	lds R25,_tw_sr_idx+1
	adiw R24,1
	sts _tw_sr_idx+1,R25
	sts _tw_sr_idx,R24
;         }
	xjmp L33
L32:
;         else {
;             tw_sr_siz = 0;
	clr R2
	clr R3
	sts _tw_sr_siz+1,R3
	sts _tw_sr_siz,R2
;         }
L33:
; 
;         /*
;          * If more space is available for incoming data, then continue
;          * receiving. Otherwise do not acknowledge new data bytes.
;          */
;         if (tw_sr_siz) {
	lds R2,_tw_sr_siz
	lds R3,_tw_sr_siz+1
	tst R2
	brne X51
	tst R3
	breq L34
X51:
;             outb(TWCR, TWGO | _BV(TWEA));
	ldi R24,197
	sts 116,R24
;             break;
	xjmp L4
L34:
L36:
;         }
; 
;     /*
;      * 0x88: Data byte received, but not acknowledged.
;      * 0x98: Data byte for general call address received, but not
;      *       acknowledged.
;      */
;     case TW_SR_DATA_NACK:
;     case TW_SR_GCALL_DATA_NACK:
;         /*
;          * Continue not accepting more data.
;          */
;         if (tw_mt_len || tw_mr_siz) {
	lds R2,_tw_mt_len
	lds R3,_tw_mt_len+1
	tst R2
	brne L39
	tst R3
	brne L39
X52:
	lds R2,_tw_mr_siz
	lds R3,_tw_mr_siz+1
	tst R2
	brne X53
	tst R3
	breq L37
X53:
L39:
;             outb(TWCR, inb(TWCR) | _BV(TWEA) | _BV(TWSTA));
	lds R24,116
	ori R24,96
	sts 116,R24
;         }
	xjmp L4
L37:
;         else {
;             outb(TWCR, inb(TWCR) | _BV(TWEA));
	lds R24,116
	ori R24,64
	sts 116,R24
;         }
;         break;
	xjmp L4
L40:
; 
;     /*
;      * 0xA0: Stop condition or repeated start condition received.
;      */
;     case TW_SR_STOP:
;         /*
;          * Wake up the application. If successful, do nothing. This
;          * will keep SCL low and thus block the bus. The application
;          * must now setup the transmit buffer and re-enable the
;          * interface.
;          */
;         if (NutEventPostFromIrq(&tw_sr_que) == 0 || tw_sm_err) {
	ldi R16,<_tw_sr_que
	ldi R17,>_tw_sr_que
	xcall _NutEventPostFromIrq
	cpi R16,0
	cpc R16,R17
	breq L43
X54:
	lds R2,_tw_sm_err
	tst R2
	breq L41
X55:
L43:
;             /*
;              * If no one has been waiting on the queue, the application
;              * probably gave up waiting. So we continue on our own, either
;              * in idle mode or switching to master mode if a master
;              * request is waiting.
;              */
;             if (tw_mt_len || tw_mr_siz) {
	lds R2,_tw_mt_len
	lds R3,_tw_mt_len+1
	tst R2
	brne L46
	tst R3
	brne L46
X56:
	lds R2,_tw_mr_siz
	lds R3,_tw_mr_siz+1
	tst R2
	brne X57
	tst R3
	breq L44
X57:
L46:
;                 outb(TWCR, TWGO | _BV(TWSTA));
	ldi R24,165
	sts 116,R24
;             }
	xjmp L45
L44:
;             else {
;                 outb(TWCR, TWGO);
	ldi R24,133
	sts 116,R24
;             }
L45:
;             tw_if_bsy = 0;
	clr R2
	sts _tw_if_bsy,R2
;         }
	xjmp L4
L41:
;         else {
;             tw_sr_siz = 0;
	clr R2
	clr R3
	sts _tw_sr_siz+1,R3
	sts _tw_sr_siz,R2
;             outb(TWCR, twcr & ~(_BV(TWINT) | _BV(TWIE)));
	mov R24,R20
	andi R24,126
	sts 116,R24
;         }
;         break;
	xjmp L4
L47:
; 
;     /*
;      * 0xA8: Own SLA+R has been received and acknowledged.
;      * 0xB0: Arbitration lost in master mode. Own SLA has been received
;      *       and acknowledged.
;      */
;     case TW_ST_SLA_ACK:
;     case TW_ST_ARB_LOST_SLA_ACK:
;         /* Not idle. */
;         tw_if_bsy = 1;
	ldi R24,1
	sts _tw_if_bsy,R24
;         /* Reset transmit index and fall through for outgoing data. */
;         tw_st_idx = 0;
	clr R2
	clr R3
	sts _tw_st_idx+1,R3
	sts _tw_st_idx,R2
L48:
; 
;     /*
;      * 0xB8: Data bytes has been transmitted and acknowledged.
;      */
;     case TW_ST_DATA_ACK:
;         /*
;          * If outgoing data left to send, put the next byte in the
;          * data register. Otherwise transmit a dummy byte.
;          */
;         if (tw_st_idx < tw_st_len) {
	lds R2,_tw_st_len
	lds R3,_tw_st_len+1
	lds R4,_tw_st_idx
	lds R5,_tw_st_idx+1
	cp R4,R2
	cpc R5,R3
	brsh L49
X58:
;             outb(TWDR, tw_st_buf[tw_st_idx]);
	lds R2,_tw_st_buf
	lds R3,_tw_st_buf+1
	lds R30,_tw_st_idx
	lds R31,_tw_st_idx+1
	add R30,R2
	adc R31,R3
	ldd R2,z+0
	sts 115,R2
;             /* Do not set acknowledge on the last data byte. */
;             /* Early increment fixes ICCAVR bug. Thanks to Andreas Siebert and Michael Fischer. */
;             ++tw_st_idx;
	lds R24,_tw_st_idx
	lds R25,_tw_st_idx+1
	adiw R24,1
	sts _tw_st_idx+1,R25
	sts _tw_st_idx,R24
;             if (tw_st_idx < tw_st_len) {
	lds R2,_tw_st_len
	lds R3,_tw_st_len+1
	lds R4,_tw_st_idx
	lds R5,_tw_st_idx+1
	cp R4,R2
	cpc R5,R3
	brsh L51
X59:
;                 outb(TWCR, TWGO | _BV(TWEA));
	ldi R24,197
	sts 116,R24
;             }
	xjmp L4
L51:
;             else {
;                 tw_st_len = 0;
	clr R2
	clr R3
	sts _tw_st_len+1,R3
	sts _tw_st_len,R2
;                 outb(TWCR, TWGO);
	ldi R24,133
	sts 116,R24
;             }
;             break;
	xjmp L4
L49:
;         }
; 
;         /* No more data. Continue sending dummies. */
;         outb(TWDR, 0);
	clr R2
	sts 115,R2
;         outb(TWCR, TWGO);
	ldi R24,133
	sts 116,R24
;         break;
	xjmp L4
L53:
; 
;     /*
;      * 0xC0: Data byte has been transmitted, but not acknowledged.
;      * 0xC8: Last data byte has been transmitted and acknowledged.
;      */
;     case TW_ST_DATA_NACK:
;     case TW_ST_LAST_DATA:
;         NutEventPostFromIrq(&tw_st_que);
	ldi R16,<_tw_st_que
	ldi R17,>_tw_st_que
	xcall _NutEventPostFromIrq
; 
;         /* Transmit start condition, if a master transfer is waiting. */
;         if (tw_mt_len || tw_mr_siz) {
	lds R2,_tw_mt_len
	lds R3,_tw_mt_len+1
	tst R2
	brne L56
	tst R3
	brne L56
X60:
	lds R2,_tw_mr_siz
	lds R3,_tw_mr_siz+1
	tst R2
	brne X61
	tst R3
	breq L54
X61:
L56:
;             outb(TWCR, TWGO | _BV(TWSTA) | /**/ _BV(TWEA));
	ldi R24,229
	sts 116,R24
;         }
	xjmp L55
L54:
;         /* Otherwise enter idle state. */
;         else {
;             outb(TWCR, TWGO | _BV(TWEA));
	ldi R24,197
	sts 116,R24
;         }
L55:
;         tw_if_bsy = 0;
	clr R2
	sts _tw_if_bsy,R2
;         break;
	xjmp L4
L57:
; 
;     /*
;      * 0x00: Bus error.
;      */
;     case TW_BUS_ERROR:
;         outb(TWCR, inb(TWCR) | _BV(TWSTO));
	lds R24,116
	ori R24,16
	sts 116,R24
; #if 1
;         tw_if_bsy = 0;
	clr R2
	sts _tw_if_bsy,R2
;         tw_mm_err = TWERR_BUS;
	ldi R24,2
	sts _tw_mm_err,R24
;         tw_sm_err = TWERR_BUS;
	sts _tw_sm_err,R24
;         NutEventPostFromIrq(&tw_sr_que);
	ldi R16,<_tw_sr_que
	ldi R17,>_tw_sr_que
	xcall _NutEventPostFromIrq
;         NutEventPostFromIrq(&tw_st_que);
	ldi R16,<_tw_st_que
	ldi R17,>_tw_st_que
	xcall _NutEventPostFromIrq
;         NutEventPostFromIrq(&tw_mm_que);
	ldi R16,<_tw_mm_que
	ldi R17,>_tw_mm_que
	xcall _NutEventPostFromIrq
; #endif
;         break;
L3:
L4:
L2:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
;           twcr -> R22
;           twsr -> R10
;             rc -> R20,R21
;            tmo -> y+16
;          rxsiz -> y+14
;         rxdata -> y+12
;          txlen -> y+10
;         txdata -> R10,R11
;            sla -> R12
	.even
_TwMasterTransact::
	xcall push_xgsetF03C
	movw R10,R18
	mov R12,R16
	sbiw R28,2
;     }
; }
; 
; #endif /* __AVR_ENHANCED__ */
; 
; /*!
;  * \brief Transmit and/or receive data as a master.
;  *
;  * The two-wire serial interface must have been initialized by calling
;  * TwInit() before this function can be used.
;  *
;  * \note This function is only available on ATmega128 systems.
;  *
;  * \param sla    Slave address of the destination. This slave address
;  *               must be specified as a 7-bit address. For example, the
;  *               PCF8574A may be configured to slave addresses from 0x38
;  *               to 0x3F.
;  * \param txdata Points to the data to transmit. Ignored, if the number
;  *               of data bytes to transmit is zero.
;  * \param txlen  Number of data bytes to transmit. If zero, then the
;  *               interface will not send any data to the slave device
;  *               and will directly enter the master receive mode.
;  * \param rxdata Points to a buffer, where the received data will be
;  *               stored. Ignored, if the maximum number of bytes to
;  *               receive is zero.
;  * \param rxsiz  Maximum number of bytes to receive. Set to zero, if
;  *               no bytes are expected from the slave device.
;  * \param tmo    Timeout in milliseconds. To disable timeout, set this
;  *               parameter to NUT_WAIT_INFINITE.
;  *
;  * \return The number of bytes received, -1 in case of an error or timeout.
;  *
;  * \bug Joel Dotreppe reported, that TwMasterTransact() doesn't work when
;  *      passing 0 for txdata and txlen. Though, I'm not able to verify this.
;  */
; int TwMasterTransact(u_char sla, CONST void *txdata, u_short txlen, void *rxdata, u_short rxsiz, u_long tmo)
; {
;     int rc = -1;
	ldi R20,-1
	ldi R21,-1
; 
; #ifdef __AVR_ENHANCED__
;     /* This routine is marked reentrant, so lock the interface. */
;     if(NutEventWait(&tw_mm_mutex, 500)) {
	ldi R24,244
	ldi R25,1
	ldi R26,0
	ldi R27,0
	std y+0,R26
	std y+1,R27
	movw R18,R24
	ldi R16,<_tw_mm_mutex
	ldi R17,>_tw_mm_mutex
	xcall _NutEventWait
	cpi R16,0
	cpc R16,R17
	breq L87
X96:
;         tw_mm_err = TWERR_IF_LOCKED;
	ldi R24,3
	sts _tw_mm_err,R24
;         NutEventPost(&tw_mm_mutex);
	ldi R16,<_tw_mm_mutex
	ldi R17,>_tw_mm_mutex
	xcall _NutEventPost
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L83
L86:
;     }
; 
;     while(tw_if_bsy) {
;         NutSleep(63);
	ldi R16,63
	ldi R17,0
	ldi R18,0
	ldi R19,0
	xcall _NutSleep
;     }
L87:
	lds R2,_tw_if_bsy
	tst R2
	brne L86
X97:
;     NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
;     /*
;      * Set all parameters for master mode.
;      */
;     tw_mm_sla = sla << 1;
	mov R2,R12
	lsl R2
	sts _tw_mm_sla,R2
;     tw_mm_err = 0;
	clr R2
	sts _tw_mm_err,R2
;     tw_mt_len = txlen;
	ldd R0,y+10
	ldd R1,y+11
	sts _tw_mt_len+1,R1
	sts _tw_mt_len,R0
;     tw_mt_buf = txdata;
	sts _tw_mt_buf+1,R11
	sts _tw_mt_buf,R10
;     tw_mr_siz = rxsiz;
	ldd R0,y+14
	ldd R1,y+15
	sts _tw_mr_siz+1,R1
	sts _tw_mr_siz,R0
;     tw_mr_buf = rxdata;
	ldd R0,y+12
	ldd R1,y+13
	sts _tw_mr_buf+1,R1
	sts _tw_mr_buf,R0
; 
;     /*
;      * Send a start condition if the interface is idle. If busy, then
;      * the interrupt routine will automatically initiate the transfer
;      * as soon as the interface becomes ready again.
;      */
;     if(tw_if_bsy == 0) {
	lds R2,_tw_if_bsy
	tst R2
	brne L89
X98:
;         u_char twcr = inb(TWCR);
	lds R22,116
;         u_char twsr = inb(TWSR);
	lds R10,113
;         if((twsr & 0xF8) == TW_NO_INFO) {
	mov R24,R10
	andi R24,248
	cpi R24,248
	brne L91
X99:
;             if(tw_sr_siz) {
	lds R2,_tw_sr_siz
	lds R3,_tw_sr_siz+1
	tst R2
	brne X100
	tst R3
	breq L93
X100:
;                 outb(TWCR, _BV(TWEN) | _BV(TWIE) | _BV(TWEA) | _BV(TWSTA) | (twcr & _BV(TWSTO)));
	mov R24,R22
	andi R24,16
	ori R24,101
	sts 116,R24
;             }
	xjmp L94
L93:
;             else {
;                 outb(TWCR, _BV(TWEN) | _BV(TWIE) | _BV(TWSTA) | (twcr & _BV(TWSTO)));
	mov R24,R22
	andi R24,16
	ori R24,37
	sts 116,R24
;             }
L94:
;         }
L91:
;     }
L89:
; 
;     /* Clear the queue. */
;     //*broken?! NutEventBroadcastAsync(&tw_mm_que);
;     if (tw_mm_que == SIGNALED) {
	lds R24,_tw_mm_que
	lds R25,_tw_mm_que+1
	cpi R24,255
	ldi R30,255
	cpc R25,R30
	brne L95
X101:
;         tw_mm_que = 0;
	clr R2
	clr R3
	sts _tw_mm_que+1,R3
	sts _tw_mm_que,R2
;     }
L95:
;     NutExitCritical();
	pop R0
	out 0x3F, R0
	
; 
;     /*
;      * Wait for master transmission done.
;      */
;     rc = -1;
	ldi R20,-1
	ldi R21,-1
;     if (NutEventWait(&tw_mm_que, tmo)) {
	ldd R2,y+16
	ldd R3,y+17
	ldd R4,y+18
	ldd R5,y+19
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldi R16,<_tw_mm_que
	ldi R17,>_tw_mm_que
	xcall _NutEventWait
	cpi R16,0
	cpc R16,R17
	breq L97
X102:
;         tw_mm_error = TWERR_TIMEOUT;
	ldi R24,1
	sts _tw_mm_error,R24
;     } else {
	xjmp L98
L97:
;         NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
;         if (tw_mm_err) {
	lds R2,_tw_mm_err
	tst R2
	breq L99
X103:
;             tw_mm_error = tw_mm_err;
	lds R2,_tw_mm_err
	sts _tw_mm_error,R2
;         } else {
	xjmp L100
L99:
;             rc = tw_mr_idx;
	lds R20,_tw_mr_idx
	lds R21,_tw_mr_idx+1
;         }
L100:
;         NutExitCritical();
	pop R0
	out 0x3F, R0
	
;     }
L98:
; 
;     /*
;      * Release the interface.
;      */
;     NutEventPost(&tw_mm_mutex);
	ldi R16,<_tw_mm_mutex
	ldi R17,>_tw_mm_mutex
	xcall _NutEventPost
; 
; #endif /* __AVR_ENHANCED__ */
;     return rc;
	movw R16,R20
L83:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgsetF03C
;             rc -> R16,R17
	.even
_TwMasterError::
; }
; 
; /*!
;  * \brief Get last master mode error.
;  *
;  * You may call this function to determine the specific cause
;  * of an error after TwMasterTransact() failed.
;  *
;  * \note This function is only available on ATmega128 systems.
;  *
;  */
; int TwMasterError(void)
; {
; #ifndef __AVR_ENHANCED__
;     return -1;
; #else
;     int rc = (int) tw_mm_error;
	lds R16,_tw_mm_error
	clr R17
;     tw_mm_error = 0;
	clr R2
	sts _tw_mm_error,R2
;     return rc;
L101:
	.dbline 0 ; func end
	ret
;           twsr -> R22
;             rc -> R20,R21
;            tmo -> y+12
;          rxsiz -> y+10
;         rxdata -> R12,R13
;            sla -> R10,R11
	.even
_TwSlaveListen::
	xcall push_xgsetF03C
	movw R12,R18
	movw R10,R16
	sbiw R28,2
; #endif
; }
; 
; /*!
;  * \brief Listen for incoming data from a master.
;  *
;  * If this function returns without error, the bus is blocked. The caller
;  * must immediately process the request and return a response by calling
;  * TwSlaveRespond().
;  *
;  * \note This function is only available on ATmega128 systems. The
;  *       function is not reentrant.
;  *
;  * \param sla    Points to a byte variable, which receives the slave
;  *               address sent by the master. This can be used by the
;  *               caller to determine whether the the interface has been
;  *               addressed by a general call or its individual address.
;  * \param rxdata Points to a data buffer where the received data bytes
;  *               are stored.
;  * \param rxsize Specifies the maximum number of data bytes to receive.
;  * \param tmo	 Timeout in milliseconds. To disable timeout,
;  *               set this parameter to NUT_WAIT_INFINITE.
;  *
;  * \return The number of bytes received, -1 in case of an error or timeout.
;  */
; int TwSlaveListen(u_char * sla, void *rxdata, u_short rxsiz, u_long tmo)
; {
; #ifndef __AVR_ENHANCED__
;     return -1;
; #else
;     int rc = -1;
	ldi R20,-1
	ldi R21,-1
; 
;     NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
; 
;     /* Initialize parameters for slave receive. */
;     tw_sm_err = 0;
	clr R2
	sts _tw_sm_err,R2
;     tw_sr_siz = rxsiz;
	ldd R0,y+10
	ldd R1,y+11
	sts _tw_sr_siz+1,R1
	sts _tw_sr_siz,R0
;     tw_sr_buf = rxdata;
	sts _tw_sr_buf+1,R13
	sts _tw_sr_buf,R12
; 
;     /*
;      * If the interface is currently not busy then enable it for
;      * address recognition.
;      */
;     if(tw_if_bsy == 0) {
	lds R2,_tw_if_bsy
	tst R2
	brne L103
X104:
;         u_char twsr = inb(TWSR);
	lds R22,113
;         if((twsr & 0xF8) == TW_NO_INFO) {
	mov R24,R22
	andi R24,248
	cpi R24,248
	brne L105
X105:
;             if(tw_mt_len || tw_mr_siz)
	lds R2,_tw_mt_len
	lds R3,_tw_mt_len+1
	tst R2
	brne L109
	tst R3
	brne L109
X106:
	lds R2,_tw_mr_siz
	lds R3,_tw_mr_siz+1
	tst R2
	brne X107
	tst R3
	breq L107
X107:
L109:
;                 outb(TWCR, _BV(TWEA) | _BV(TWEN) | _BV(TWIE) | _BV(TWSTA));
	ldi R24,101
	sts 116,R24
	xjmp L108
L107:
;             else
;                 outb(TWCR, _BV(TWEA) | _BV(TWEN) | _BV(TWIE));
	ldi R24,69
	sts 116,R24
L108:
;         }
L105:
;     }
L103:
; 
;     /* Clear the queue. */
;     //*broken?! NutEventBroadcastAsync(&tw_sr_que);
;     if (tw_sr_que == SIGNALED) {
	lds R24,_tw_sr_que
	lds R25,_tw_sr_que+1
	cpi R24,255
	ldi R30,255
	cpc R25,R30
	brne L110
X108:
;         tw_sr_que = 0;
	clr R2
	clr R3
	sts _tw_sr_que+1,R3
	sts _tw_sr_que,R2
;     }
L110:
; 
;     /* Wait for a frame on the slave mode queue. */
;     if (NutEventWait(&tw_sr_que, tmo)) {
	ldd R2,y+12
	ldd R3,y+13
	ldd R4,y+14
	ldd R5,y+15
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldi R16,<_tw_sr_que
	ldi R17,>_tw_sr_que
	xcall _NutEventWait
	cpi R16,0
	cpc R16,R17
	breq L112
X109:
;         NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
;         tw_sm_err = TWERR_TIMEOUT;
	ldi R24,1
	sts _tw_sm_err,R24
;         tw_sr_siz = 0;
	clr R2
	clr R3
	sts _tw_sr_siz+1,R3
	sts _tw_sr_siz,R2
;         NutExitCritical();
	pop R0
	out 0x3F, R0
	
;     }
L112:
;     NutExitCritical();
	pop R0
	out 0x3F, R0
	
; 
;     /*
;      * Return the number of bytes received and the destination slave
;      * address, if no slave error occured. In this case the bus is
;      * blocked.
;      */
;     if(tw_sm_err == 0) {
	lds R2,_tw_sm_err
	tst R2
	brne L114
X110:
;         rc = tw_sr_idx;
	lds R20,_tw_sr_idx
	lds R21,_tw_sr_idx+1
;         *sla = tw_sm_sla;
	lds R2,_tw_sm_sla
	movw R30,R10
	std z+0,R2
;     }
L114:
;     return rc;
	movw R16,R20
L102:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgsetF03C
;           twsr -> R10
;           twcr -> R10
;             rc -> R20,R21
;            tmo -> y+8
;          txlen -> R10,R11
;         txdata -> R12,R13
	.even
_TwSlaveRespond::
	xcall push_xgset303C
	movw R10,R18
	movw R12,R16
	sbiw R28,2
; #endif /* __AVR_ENHANCED__ */
; }
; 
; /*!
;  * \brief Send response to a master.
;  *
;  * This function must be called as soon as possible after TwSlaveListen()
;  * returned successfully, even if no data needs to be returned. Not doing
;  * so will completely block the bus.
;  *
;  * \note This function is only available on ATmega128 systems.
;  *
;  * \param txdata Points to the data to transmit. Ignored, if the
;  *      		 number of bytes to transmit is zero.
;  * \param txlen  Number of data bytes to transmit.
;  * \param tmo	 Timeout in milliseconds. To disable timeout,
;  *               set this parameter to NUT_WAIT_INFINITE.
;  *
;  * \return The number of bytes transmitted, -1 in case of an error or timeout.
;  */
; int TwSlaveRespond(void *txdata, u_short txlen, u_long tmo)
; {
;     int rc = -1;
	ldi R20,-1
	ldi R21,-1
; #ifdef __AVR_ENHANCED__
; 
;     /* The bus is blocked. No critical section required. */
;     tw_st_buf = txdata;
	sts _tw_st_buf+1,R13
	sts _tw_st_buf,R12
;     tw_st_len = txlen;
	sts _tw_st_len+1,R11
	sts _tw_st_len,R10
; 
;     /*
;      * If there is anything to transmit, start the interface.
;      */
;     if (txlen) {
	tst R10
	brne X111
	tst R11
	brne X117
	xjmp L117
X117:
X111:
;         NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
;         /* Clear the queue. */
;         //*broken?! NutEventBroadcastAsync(&tw_st_que);
;         if (tw_st_que == SIGNALED) {
	lds R24,_tw_st_que
	lds R25,_tw_st_que+1
	cpi R24,255
	ldi R30,255
	cpc R25,R30
	brne L119
X112:
;             tw_st_que = 0;
	clr R2
	clr R3
	sts _tw_st_que+1,R3
	sts _tw_st_que,R2
;         }
L119:
; 
;         /* Release the bus, accepting SLA+R. */
;         outb(TWCR, TWGO | _BV(TWEA));
	ldi R24,197
	sts 116,R24
; 
;         NutExitCritical();
	pop R0
	out 0x3F, R0
	
;         if (NutEventWait(&tw_st_que, tmo)) {
	ldd R2,y+8
	ldd R3,y+9
	ldd R4,y+10
	ldd R5,y+11
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldi R16,<_tw_st_que
	ldi R17,>_tw_st_que
	xcall _NutEventWait
	cpi R16,0
	cpc R16,R17
	breq L121
X113:
;             tw_sm_err = TWERR_TIMEOUT;
	ldi R24,1
	sts _tw_sm_err,R24
;         }
L121:
; 
;         NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
;         tw_st_len = 0;
	clr R2
	clr R3
	sts _tw_st_len+1,R3
	sts _tw_st_len,R2
;         if (tw_sm_err) {
	lds R2,_tw_sm_err
	tst R2
	breq L123
X114:
;             tw_sm_error = tw_sm_err;
	lds R2,_tw_sm_err
	sts _tw_sm_error,R2
;         } else {
	xjmp L124
L123:
;             rc = tw_st_idx;
	lds R20,_tw_st_idx
	lds R21,_tw_st_idx+1
;         }
L124:
;         NutExitCritical();
	pop R0
	out 0x3F, R0
	
;     }
	xjmp L118
L117:
; 
;     /*
;      * Nothing to transmit.
;      */
;     else {
;         u_char twcr;
;         u_char twsr;
;         rc = 0;
	clr R20
	clr R21
;         /* Release the bus, not accepting SLA+R. */
; 
;         NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
;         twcr = inb(TWCR);
	lds R10,116
;         twsr = inb(TWSR);
	lds R10,113
;         /* Transmit start condition, if a master transfer is waiting. */
;         if (tw_mt_len || tw_mr_siz) {
	lds R2,_tw_mt_len
	lds R3,_tw_mt_len+1
	tst R2
	brne L127
	tst R3
	brne L127
X115:
	lds R2,_tw_mr_siz
	lds R3,_tw_mr_siz+1
	tst R2
	brne X116
	tst R3
	breq L125
X116:
L127:
;             outb(TWCR, TWGO | _BV(TWSTA));
	ldi R24,165
	sts 116,R24
;         }
	xjmp L126
L125:
;         /* Otherwise enter idle state. */
;         else {
;             tw_if_bsy = 0;
	clr R2
	sts _tw_if_bsy,R2
;             outb(TWCR, TWGO);
	ldi R24,133
	sts 116,R24
;         }
L126:
; 
;         NutExitCritical();
	pop R0
	out 0x3F, R0
	
;     }
L118:
; #endif /* __AVR_ENHANCED__ */
;     return rc;
	movw R16,R20
L116:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgset303C
;             rc -> R16,R17
	.even
_TwSlaveError::
; }
; 
; /*!
;  * \brief Get last slave mode error.
;  *
;  * You may call this function to determine the specific cause
;  * of an error after TwSlaveListen() or TwSlaveRespond() failed.
;  *
;  * \note This function is only available on ATmega128 systems.
;  *
;  */
; int TwSlaveError(void)
; {
; #ifndef __AVR_ENHANCED__
;     return -1;
; #else
;     int rc = (int) tw_sm_error;
	lds R16,_tw_sm_error
	clr R17
;     tw_sm_error = 0;
	clr R2
	sts _tw_sm_error,R2
;     return rc;
L128:
	.dbline 0 ; func end
	ret
;           lval -> y+0
;             rc -> R10,R11
;           conf -> R12,R13
;            req -> R14,R15
	.even
_TwIOCtl::
	xcall push_xgsetF0FC
	movw R12,R18
	movw R14,R16
	sbiw R28,4
; #endif
; }
; 
; /*!
;  * \brief Perform TWI control functions.
;  *
;  * This function is only available on ATmega128 systems.
;  *
;  * \param req  Requested control function. May be set to one of the
;  *	       following constants:
;  *	       - TWI_SETSPEED, if conf points to an u_long value containing the bitrate.
;  *	       - TWI_GETSPEED, if conf points to an u_long value receiving the current bitrate.
;  * \param conf Points to a buffer that contains any data required for
;  *	       the given control function or receives data from that
;  *	       function.
;  * \return 0 on success, -1 otherwise.
;  *
;  * \note Timeout is limited to the granularity of the system timer.
;  *
;  */
; int TwIOCtl(int req, void *conf)
; {
; #ifndef __AVR_ENHANCED__
;     return -1;
; #else
;     int rc = 0;
	clr R10
	clr R11
;     u_long lval;
; 
;     switch (req) {
	movw R24,R14
	cpi R24,1
	ldi R30,4
	cpc R25,R30
	breq L134
X118:
	cpi R24,2
	ldi R30,4
	cpc R25,R30
	brne X130
	xjmp L141
X130:
X119:
	cpi R24,3
	ldi R30,4
	cpc R25,R30
	breq L132
X120:
	cpi R24,4
	ldi R30,4
	cpc R25,R30
	breq L133
X121:
	cpi R24,9
	ldi R30,4
	cpc R25,R30
	brne X131
	xjmp L131
X131:
X122:
	cpi R24,10
	ldi R30,4
	cpc R25,R30
	brne X132
	xjmp L131
X132:
X123:
	xjmp L130
L132:
;     case TWI_SETSLAVEADDRESS:
;         TWAR = (*((u_char *) conf) << 1) | 1;
	movw R30,R12
	ldd R24,z+0
	lsl R24
	ori R24,1
	sts 114,R24
;         break;
	xjmp L131
L133:
;     case TWI_GETSLAVEADDRESS:
;         *((u_char *) conf) = TWAR;
	lds R2,114
	movw R30,R12
	std z+0,R2
;         break;
	xjmp L131
L134:
; 
;     case TWI_SETSPEED:
;         lval = ((2UL * NutGetCpuClock() / (*((u_long *) conf)) + 1UL) / 2UL - 16UL) / 2UL;
	xcall _NutGetCpuClock
	ldi R20,2
	ldi R21,0
	ldi R22,0
	ldi R23,0
	st -y,R19
	st -y,R18
	st -y,R17
	st -y,R16
	movw R16,R20
	movw R18,R22
	xcall empy32u
	movw R30,R12
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	xcall div32u
	movw R2,R16
	movw R4,R18
	ldi R20,1
	ldi R21,0
	ldi R22,0
	ldi R23,0
	add R2,R20
	adc R3,R21
	adc R4,R22
	adc R5,R23
	lsr R5
	ror R4
	ror R3
	ror R2
	ldi R20,16
	ldi R21,0
	ldi R22,0
	ldi R23,0
	sub R2,R20
	sbc R3,R21
	sbc R4,R22
	sbc R5,R23
	lsr R5
	ror R4
	ror R3
	ror R2
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
;         if (lval > 1020UL) {
	ldi R20,252
	ldi R21,3
	ldi R22,0
	ldi R23,0
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	cp R20,R2
	cpc R21,R3
	cpc R22,R4
	cpc R23,R5
	brsh L135
X124:
;             lval /= 16UL;
	ldi R24,4
	ldi R25,0
	movw R16,R2
	movw R18,R4
	st -y,R24
	xcall lsr32
	std y+0,R16
	std y+1,R17
	std y+2,R18
	std y+3,R19
;             sbi(TWSR, TWPS1);
	lds R24,113
	ori R24,2
	sts 113,R24
;         } else {
	xjmp L136
L135:
;             cbi(TWSR, TWPS1);
	lds R24,113
	andi R24,253
	sts 113,R24
;         }
L136:
;         if (lval > 255UL) {
	ldi R20,255
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	cp R20,R2
	cpc R21,R3
	cpc R22,R4
	cpc R23,R5
	brsh L137
X125:
;             lval /= 4UL;
	ldi R24,2
	ldi R25,0
	movw R16,R2
	movw R18,R4
	st -y,R24
	xcall lsr32
	std y+0,R16
	std y+1,R17
	std y+2,R18
	std y+3,R19
;             sbi(TWSR, TWPS0);
	lds R24,113
	ori R24,1
	sts 113,R24
;         } else {
	xjmp L138
L137:
;             cbi(TWSR, TWPS0);
	lds R24,113
	andi R24,254
	sts 113,R24
;         }
L138:
;         if (lval > 9UL && lval < 256UL) {
	ldi R20,9
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	cp R20,R2
	cpc R21,R3
	cpc R22,R4
	cpc R23,R5
	brsh L139
X126:
	ldi R20,0
	ldi R21,1
	ldi R22,0
	ldi R23,0
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brsh L139
X127:
;             outb(TWBR, (u_char) lval);
	sts 112,R2
;         } else {
	xjmp L131
L139:
;             rc = -1;
	ldi R24,-1
	ldi R25,-1
	movw R10,R24
;         }
;         break;
	xjmp L131
L141:
;     case TWI_GETSPEED:
;         lval = 2UL;
	ldi R20,2
	ldi R21,0
	ldi R22,0
	ldi R23,0
	std y+0,R20
	std y+1,R21
	std y+2,R22
	std y+3,R23
;         if (bit_is_set(TWSR, TWPS0)) {
	lds R2,113
	sbrs R2,0
	rjmp L142
X128:
;             lval *= 4UL;
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	ldi R20,4
	ldi R21,0
	ldi R22,0
	ldi R23,0
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	movw R16,R20
	movw R18,R22
	xcall empy32u
	std y+0,R16
	std y+1,R17
	std y+2,R18
	std y+3,R19
;         }
L142:
;         if (bit_is_set(TWSR, TWPS1)) {
	lds R2,113
	sbrs R2,1
	rjmp L144
X129:
;             lval *= 16UL;
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	ldi R20,16
	ldi R21,0
	ldi R22,0
	ldi R23,0
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	movw R16,R20
	movw R18,R22
	xcall empy32u
	std y+0,R16
	std y+1,R17
	std y+2,R18
	std y+3,R19
;         }
L144:
;         *((u_long *) conf) = NutGetCpuClock() / (16UL + lval * (u_long) inb(TWBR));
	xcall _NutGetCpuClock
	movw R2,R16
	movw R4,R18
	lds R6,112
	clr R7
	clr R8
	clr R9
	ldd R16,y+0
	ldd R17,y+1
	ldd R18,y+2
	ldd R19,y+3
	st -y,R9
	st -y,R8
	st -y,R7
	st -y,R6
	xcall empy32u
	ldi R20,16
	ldi R21,0
	ldi R22,0
	ldi R23,0
	movw R6,R16
	movw R8,R18
	add R6,R20
	adc R7,R21
	adc R8,R22
	adc R9,R23
	st -y,R9
	st -y,R8
	st -y,R7
	st -y,R6
	movw R16,R2
	movw R18,R4
	xcall div32u
	movw R30,R12
	std z+0,R16
	std z+1,R17
	std z+2,R18
	std z+3,R19
;         break;
	xjmp L131
L130:
; 
;     case TWI_GETSTATUS:
;         break;
;     case TWI_SETSTATUS:
;         break;
; 
;     default:
;         rc = -1;
	ldi R24,-1
	ldi R25,-1
	movw R10,R24
;         break;
L131:
;     }
;     return rc;
	movw R16,R10
L129:
	.dbline 0 ; func end
	adiw R28,4
	xjmp pop_xgsetF0FC
;          speed -> y+2
;            sla -> R10
	.even
_TwInit::
	st -y,R10
	st -y,R11
	mov R10,R16
	sbiw R28,6
; #endif /* __AVR_ENHANCED__ */
; }
; 
; /*!
;  * \brief Initialize TWI interface.
;  *
;  * The specified slave address is used only, if the local system
;  * is running as a slave. Anyway, care must be taken that it doesn't
;  * conflict with another connected device.
;  *
;  * \note This function is only available on ATmega128 systems.
;  *
;  * \param sla Slave address, must be specified as a 7-bit address,
;  *            always lower than 128.
;  */
; int TwInit(u_char sla)
; {
; #ifndef __AVR_ENHANCED__
;     return -1;
; #else
;     u_long speed = 2400;
	ldi R24,96
	ldi R25,9
	ldi R26,0
	ldi R27,0
	std y+2,R24
	std y+3,R25
	std y+4,R26
	std y+5,R27
; 
;     if (NutRegisterIrqHandler(&sig_2WIRE_SERIAL, TwInterrupt, 0)) {
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	ldi R18,<PL_TwInterrupt
	ldi R19,>PL_TwInterrupt
	ldi R16,<_sig_2WIRE_SERIAL
	ldi R17,>_sig_2WIRE_SERIAL
	xcall _NutRegisterIrqHandler
	cpi R16,0
	cpc R16,R17
	breq L149
X133:
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L148
L149:
;     }
; 
;     /*
;      * Set address register, enable general call address, set transfer
;      * speed and enable interface.
;      */
;     outb(TWAR, (sla << 1) | 1);
	mov R24,R10
	lsl R24
	ori R24,1
	sts 114,R24
;     TwIOCtl(TWI_SETSPEED, &speed);
	movw R18,R28
	subi R18,254  ; offset = 2
	sbci R19,255
	ldi R16,1025
	ldi R17,4
	xcall _TwIOCtl
;     outb(TWCR, _BV(TWINT));
	ldi R24,128
	sts 116,R24
;     outb(TWCR, _BV(TWEN) | _BV(TWIE));
	ldi R24,5
	sts 116,R24
; 
;     /*
;      * Initialize mutex semaphores.
;      */
;     NutEventPost(&tw_mm_mutex);
	ldi R16,<_tw_mm_mutex
	ldi R17,>_tw_mm_mutex
	xcall _NutEventPost
; 
;     return 0;
	clr R16
	clr R17
L148:
	.dbline 0 ; func end
	adiw R28,6
	ld R11,y+
	ld R10,y+
	ret
	.area bss(ram, con, rel)
_tw_sr_idx:
	.blkb 2
_tw_sr_siz:
	.blkb 2
_tw_sr_buf:
	.blkb 2
_tw_st_idx:
	.blkb 2
_tw_st_len:
	.blkb 2
_tw_st_buf:
	.blkb 2
_tw_sm_error:
	.blkb 1
_tw_sm_err:
	.blkb 1
_tw_sm_sla:
	.blkb 1
_tw_mr_idx:
	.blkb 2
_tw_mr_siz:
	.blkb 2
_tw_mr_buf:
	.blkb 2
_tw_mt_idx:
	.blkb 2
_tw_mt_len:
	.blkb 2
_tw_mt_buf:
	.blkb 2
_tw_mm_error:
	.blkb 1
_tw_mm_err:
	.blkb 1
_tw_mm_sla:
	.blkb 1
_tw_st_que::
	.blkb 2
_tw_sr_que::
	.blkb 2
_tw_mm_que::
	.blkb 2
_tw_mm_mutex::
	.blkb 2
_tw_if_bsy:
	.blkb 1
; #endif /* __AVR_ENHANCED__ */
; }
	.area func_lit
PL_TwInterrupt:	.word `_TwInterrupt
