	.module fclose.c
	.area text(rom, con, rel)
;             rc -> R20,R21
;              i -> R22
;         stream -> R10,R11
	.even
_fclose::
	xcall push_xgsetF00C
	movw R10,R16
; /*
;  * Copyright (C) 2001-2003 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  */
; 
; /*
;  * $Log: fclose.c,v $
;  * Revision 1.2  2004/09/08 10:19:05  haraldkipp
;  * Todo: We need a better check for stdio channels!
;  *
;  * Revision 1.1.1.1  2003/05/09 14:40:24  haraldkipp
;  * Initial using 3.2.1
;  *
;  * Revision 1.1  2003/02/04 17:49:04  harald
;  * *** empty log message ***
;  *
;  */
; 
; 
; #include "nut_io.h"
; 
; #include <errno.h>
; #include <io.h>
; #include <stdlib.h>
; 
; /*!
;  * \addtogroup xgCrtStdio
;  */
; /*@{*/
; 
; /*!
;  * \brief Close a stream.
;  *
;  * The calling thread may be suspended until all buffered output data 
;  * has been written.
;  *
;  * \param stream Pointer to a previously opened stream.
;  *
;  * \return 0 if the stream is successfully closed, EOF otherwise.
;  */
; int fclose(FILE * stream)
; {
;     int rc = EOF;
	ldi R20,-1
	ldi R21,-1
;     u_char i;
; 
;     /*
;      * Search the list first to detect bad stream pointer.
;      */
;     if (stream == 0) {
	tst R10
	brne L2
	tst R11
	brne L2
X0:
;         errno = EBADF;
	ldi R24,9
	ldi R25,0
	sts _errno+1,R25
	sts _errno,R24
;         return EOF;
	ldi R16,-1
	ldi R17,-1
	xjmp L1
L2:
;     }
;     for (i = 0; __iob[i] != stream;) {
	clr R22
	xjmp L7
L4:
;         if (++i >= FOPEN_MAX) {
	mov R24,R22
	subi R24,255    ; addi 1
	mov R22,R24
	cpi R22,8
	brlo L8
X1:
;             errno = EBADF;
	ldi R24,9
	ldi R25,0
	sts _errno+1,R25
	sts _errno,R24
;             return EOF;
	ldi R16,-1
	ldi R17,-1
	xjmp L1
L8:
;         }
;     }
L5:
L7:
	ldi R24,2
	mul R24,R22
	movw R30,R0
	ldi R24,<___iob
	ldi R25,>___iob
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldd R3,z+1
	cp R2,R10
	cpc R3,R11
	brne L4
X2:
; 
;     /*
;      * Ignore unopened standard streams.
;      */
;     //if ((void *) stream < RAMSTART)
;     //    return 0;
; 
;     /*
;      * Close the file or device.
;      */
;     if (_close(stream->iob_fd) == 0)
	movw R30,R10
	ldd R16,z+0
	ldd R17,z+1
	xcall __close
	cpi R16,0
	cpc R16,R17
	brne L10
X3:
;         rc = 0;
	clr R20
	clr R21
L10:
;     free(stream);
	movw R16,R10
	xcall _free_M
;     __iob[i] = 0;
	ldi R24,2
	mul R24,R22
	movw R30,R0
	ldi R24,<___iob
	ldi R25,>___iob
	add R30,R24
	adc R31,R25
	clr R2
	clr R3
	std z+1,R3
	std z+0,R2
; 
;     return rc;
	movw R16,R20
L1:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
; }
; 
; /*@}*/
