	.module fdopen.c
	.area text(rom, con, rel)
;         mflags -> R22,R23
;              i -> R20
;           mode -> R12,R13
;             fd -> R10,R11
	.even
__fdopen::
	xcall push_xgsetF03C
	movw R12,R18
	movw R10,R16
; /*
;  * Copyright (C) 2001-2003 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  */
; 
; /*
;  * $Log: fdopen.c,v $
;  * Revision 1.1.1.1  2003/05/09 14:40:24  haraldkipp
;  * Initial using 3.2.1
;  *
;  * Revision 1.1  2003/02/04 17:49:04  harald
;  * *** empty log message ***
;  *
;  */
; 
; #include "nut_io.h"
; 
; #include <errno.h>
; #include <fcntl.h>
; #include <stdlib.h>
; 
; 
; /*!
;  * \addtogroup xgCrtStdio
;  */
; /*@{*/
; 
; /*! 
;  * \brief Open a stream associated with a file, device or socket descriptor.
;  *
;  * \param fd   Descriptor of a previously opened file, device or
;  *             connected socket.
;  * \param mode Specifies the access mode.
;  *	       \li \c "r" Read only.
;  *	       \li \c "w" Write only.
;  *	       \li \c "a" Write only at the end of file.
;  *	       \li \c "r+" Read and write existing file.
;  *	       \li \c "w+" Read and write, destroys existing file contents.
;  *	       \li \c "a+" Read and write, preserves existing file contents.
;  *             \li \c "b" May be appended to any of the above strings to 
;  *                        specify binary access.
;  *
;  * \return A pointer to the open stream or a null pointer to indicate 
;  *         an error.
;  */
; FILE *_fdopen(int fd, CONST char *mode)
; {
;     int mflags = _O_TEXT;
;     u_char i;
; 
;     /*
;      * Translate file mode.
;      */
;     if ((mflags = _fmode(mode)) == EOF)
	movw R16,R12
	xcall __fmode
	movw R22,R16
	cpi R22,255
	ldi R30,255
	cpc R23,R30
	brne L2
X0:
;         return 0;
	clr R16
	clr R17
	xjmp L1
L2:
; 
;     /*
;      * Find an empty slot.
;      */
;     for (i = 3; __iob[i]; i++)
	ldi R20,3
	xjmp L7
L4:
;         if (i >= FOPEN_MAX - 1) {
	cpi R20,7
	brlo L8
X1:
;             errno = ENFILE;
	ldi R24,23
	ldi R25,0
	sts _errno+1,R25
	sts _errno,R24
;             return 0;
	clr R16
	clr R17
	xjmp L1
L8:
L5:
	inc R20
L7:
	ldi R24,2
	mul R24,R20
	movw R30,R0
	ldi R24,<___iob
	ldi R25,>___iob
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldd R3,z+1
	tst R2
	brne L4
	tst R3
	brne L4
X2:
;         }
; 
;     if ((__iob[i] = malloc(sizeof(FILE))) != 0) {
	ldi R16,7
	ldi R17,0
	xcall _malloc_M
	ldi R24,2
	mul R24,R20
	movw R30,R0
	ldi R24,<___iob
	ldi R25,>___iob
	add R30,R24
	adc R31,R25
	std z+1,R17
	std z+0,R16
	cpi R16,0
	cpc R16,R17
	brne X4
	xjmp L10
X4:
X3:
;         __iob[i]->iob_fd = fd;
	ldi R24,2
	mul R24,R20
	movw R30,R0
	ldi R24,<___iob
	ldi R25,>___iob
	add R30,R24
	adc R31,R25
	ldd R26,z+0
	ldd R27,z+1
	st x+,R10
	st x,R11
;         __iob[i]->iob_mode = mflags;
	ldi R24,2
	mul R24,R20
	movw R30,R0
	ldi R24,<___iob
	ldi R25,>___iob
	add R30,R24
	adc R31,R25
	ldd R26,z+0
	ldd R27,z+1
	adiw R26,2
	st x+,R22
	st x,R23
;         __iob[i]->iob_flags = 0;
	ldi R24,2
	mul R24,R20
	movw R30,R0
	ldi R24,<___iob
	ldi R25,>___iob
	add R30,R24
	adc R31,R25
	push R26
	push R27
	ldd R26,z+0
	ldd R27,z+1
	movw R30,R26
	pop R27
	pop R26
	clr R2
	std z+4,R2
;         __iob[i]->iob_unget = 0;
	ldi R24,2
	mul R24,R20
	movw R30,R0
	ldi R24,<___iob
	ldi R25,>___iob
	add R30,R24
	adc R31,R25
	ldd R26,z+0
	ldd R27,z+1
	clr R3
	adiw R26,5
	st x+,R2
	st x,R3
;     } else
	xjmp L11
L10:
;         errno = ENOMEM;
	ldi R24,12
	ldi R25,0
	sts _errno+1,R25
	sts _errno,R24
L11:
; 
; 
;     return __iob[i];
	ldi R24,2
	mul R24,R20
	movw R30,R0
	ldi R24,<___iob
	ldi R25,>___iob
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	ldd R17,z+1
L1:
	.dbline 0 ; func end
	xjmp pop_xgsetF03C
; }
; 
; /*@}*/
