	.module fflush.c
	.area text(rom, con, rel)
;         stream -> R10,R11
	.even
_fflush::
	st -y,R10
	st -y,R11
	movw R10,R16
	sbiw R28,2
; /*
;  * Copyright (C) 2001-2003 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  */
; 
; /*
;  * $Log: fflush.c,v $
;  * Revision 1.1.1.1  2003/05/09 14:40:25  haraldkipp
;  * Initial using 3.2.1
;  *
;  * Revision 1.1  2003/02/04 17:49:04  harald
;  * *** empty log message ***
;  *
;  */
; 
; #include "nut_io.h"
; 
; #include <io.h>
; 
; /*!
;  * \addtogroup xgCrtStdio
;  */
; /*@{*/
; 
; /*!
;  * \brief Flush a stream.
;  *
;  * The calling thread may be suspended until all buffered output data 
;  * has been written.
;  *
;  * \param stream Pointer to a previously opened stream.
;  *
;  * \return 0 if the buffer was successfully flushed, EOF if an error 
;  *         occured.
;  *
;  * \warning The function will not check, if the stream pointer points
;  *          to a valid stream.
;  */
; int fflush(FILE * stream)
; {
;     if (_write(stream->iob_fd, 0, 0))
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	clr R18
	clr R19
	movw R30,R10
	ldd R16,z+0
	ldd R17,z+1
	xcall __write
	cpi R16,0
	cpc R16,R17
	breq L2
X0:
;         return EOF;
	ldi R16,-1
	ldi R17,-1
	xjmp L1
L2:
;     return 0;
	clr R16
	clr R17
L1:
	.dbline 0 ; func end
	adiw R28,2
	ld R11,y+
	ld R10,y+
	ret
; }
; 
; /*@}*/
