	.module filelength.c
	.area text(rom, con, rel)
;            vdv -> R10,R11
;              l -> y+2
;             fp -> R22,R23
;            dev -> R20,R21
;             fd -> R10,R11
	.even
__filelength::
	xcall push_xgsetF00C
	movw R10,R16
	sbiw R28,6
; /*
;  * Copyright (C) 2001-2003 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  */
; 
; /*
;  * $Log: filelength.c,v $
;  * Revision 1.6  2004/08/05 06:49:44  drsung
;  * Now the correct value for VIRTUALDEVICEs is returned.
;  *
;  * Revision 1.5  2004/07/30 19:14:09  drsung
;  * filelength implemented for VIRTUALDEVICEs using the new
;  * global ioctl command IOCTL_GETFILESIZE.
;  *
;  * Revision 1.4  2004/03/16 16:48:27  haraldkipp
;  * Added Jan Dubiec's H8/300 port.
;  *
;  * Revision 1.3  2003/07/20 18:24:55  haraldkipp
;  * errno support added.
;  *
;  * Revision 1.2  2003/07/20 17:19:00  haraldkipp
;  * Description and result corrected.
;  *
;  * Revision 1.1.1.1  2003/05/09 14:40:25  haraldkipp
;  * Initial using 3.2.1
;  *
;  * Revision 1.1  2003/02/04 17:49:04  harald
;  * *** empty log message ***
;  *
;  */
; 
; #include "nut_io.h"
; 
; #include <errno.h>
; #include <sys/device.h>
; #include <io.h>
; 
; /*!
;  * \addtogroup xgCrtLowio
;  */
; /*@{*/
; 
; /*!
;  * \brief Return the length of a file.
;  * 
;  * \param fd   Descriptor of a previously opened file, device or
;  *             connected socket.
;  *
;  * \return Filelength in bytes or -1 in case of an error.
;  */
; long _filelength(int fd)
; {
;     NUTFILE *fp = (NUTFILE *) ((uptr_t) fd);
	movw R22,R10
;     NUTDEVICE *dev = fp->nf_dev;
	movw R30,R22
	ldd R20,z+2
	ldd R21,z+3
;     long l;
; 
;     if (dev == 0) {
	cpi R20,0
	cpc R20,R21
	brne L2
X0:
;         NUTVIRTUALDEVICE *vdv = (NUTVIRTUALDEVICE *) fp;
;         if (vdv->vdv_ioctl && vdv->vdv_ioctl(vdv, IOCTL_GETFILESIZE, &l) == 0)
	ldd R2,z+11
	ldd R3,z+12
	tst R2
	brne X1
	tst R3
	breq L4
X1:
	movw R24,R28
	adiw R24,2
	std y+1,R25
	std y+0,R24
	ldi R18,10
	ldi R19,0
	movw R16,R30
	movw R30,R2
	xcall  xicall
	cpi R16,0
	cpc R16,R17
	brne L4
X2:
;             return l;
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	xjmp L1
L4:
;         else {
;             errno = EBADF;
	ldi R24,9
	ldi R25,0
	sts _errno+1,R25
	sts _errno,R24
;             return -1;
	ldi R16,255
	ldi R17,255
	ldi R18,255
	ldi R19,255
	xjmp L1
L2:
;         }
;     }
; 
;     if (dev->dev_size == 0) {
	movw R30,R20
	ldd R2,z+33
	ldd R3,z+34
	tst R2
	brne L6
	tst R3
	brne L6
X3:
;         errno = EBADF;
	ldi R24,9
	ldi R25,0
	sts _errno+1,R25
	sts _errno,R24
;         return -1;
	ldi R16,255
	ldi R17,255
	ldi R18,255
	ldi R19,255
	xjmp L1
L6:
;     }
; 
;     return (*dev->dev_size) (fp);
	movw R16,R22
	movw R30,R20
	ldd R26,z+33
	ldd R27,z+34
	movw R30,R26
	xcall  xicall
L1:
	.dbline 0 ; func end
	adiw R28,6
	xjmp pop_xgsetF00C
; }
; 
; /*@}*/
