	.module fread.c
	.area text(rom, con, rel)
;             nu -> R22,R23
;             rc -> R20,R21
;         stream -> R12,R13
;          count -> R14,R15
;           size -> R10,R11
;         buffer -> R20,R21
	.even
_fread::
	xcall push_xgsetF0FC
	movw R10,R18
	movw R20,R16
	sbiw R28,2
	ldd R14,y+12
	ldd R15,y+13
	ldd R12,y+14
	ldd R13,y+15
; /*
;  * Copyright (C) 2001-2003 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  */
; 
; /*
;  * $Log: fread.c,v $
;  * Revision 1.2  2004/04/15 10:23:24  haraldkipp
;  * Distinguish between read error and end of file
;  *
;  * Revision 1.1.1.1  2003/05/09 14:40:27  haraldkipp
;  * Initial using 3.2.1
;  *
;  * Revision 1.1  2003/02/04 17:49:05  harald
;  * *** empty log message ***
;  *
;  */
; 
; 
; #include "nut_io.h"
; 
; #include <io.h>
; 
; /*!
;  * \addtogroup xgCrtStdio
;  */
; /*@{*/
; 
; /*!
;  * \brief Read data from a stream.
;  *
;  * \param buffer Pointer to the buffer that receives the data.
;  * \param size   Item size in bytes.
;  * \param count  Maximum number of items to read.
;  * \param stream Pointer to a previously opened stream.
;  *
;  * \return The number of full items read, which may be less then the
;  *         specified number.
;  *
;  * \warning The function will not check, if the stream pointer points
;  *          to a valid stream.
;  */
; size_t fread(void *buffer, size_t size, size_t count, FILE * stream)
; {
;     size_t rc;
;     size_t nu = 0;
	clr R22
	clr R23
; 
;     if (size > 1)
	ldi R24,1
	ldi R25,0
	cp R24,R10
	cpc R25,R11
	brsh L2
X0:
;         count *= size;
	movw R18,R10
	movw R16,R14
	xcall empy16s
	movw R14,R16
L2:
;     if (stream->iob_flags & _IOUNG) {
	movw R30,R12
	ldd R2,z+4
	sbrs R2,3
	rjmp L4
X1:
;         stream->iob_flags &= ~_IOUNG;
	movw R24,R30
	adiw R24,4
	movw R30,R24
	ldd R24,z+0
	andi R24,247
	std z+0,R24
;         *((char *) buffer) = (char) stream->iob_unget;
	movw R30,R12
	ldd R2,z+5
	ldd R3,z+6
	movw R30,R20
	std z+0,R2
;         buffer = ((char *) buffer) + 1;
	subi R20,255  ; offset = 1
	sbci R21,255
;         count--;
	movw R24,R14
	sbiw R24,1
	movw R14,R24
;         nu++;
	subi R22,255  ; offset = 1
	sbci R23,255
;     }
L4:
;     rc = (size_t) _read(stream->iob_fd, buffer, count);
	std y+1,R15
	std y+0,R14
	movw R18,R20
	movw R30,R12
	ldd R16,z+0
	ldd R17,z+1
	xcall __read
	movw R20,R16
;     if (rc == 0) {
	cpi R16,0
	cpc R16,R17
	brne L6
X2:
;         stream->iob_flags |= _IOEOF;
	movw R24,R12
	adiw R24,4
	movw R14,R24
	movw R30,R24
	ldd R24,z+0
	ori R24,32
	std z+0,R24
;     }
	xjmp L7
L6:
;     else if(rc == (size_t)-1) {
	cpi R20,255
	ldi R30,255
	cpc R21,R30
	brne L8
X3:
;         stream->iob_flags |= _IOERR;
	movw R24,R12
	adiw R24,4
	movw R12,R24
	movw R30,R24
	ldd R24,z+0
	ori R24,16
	std z+0,R24
;         rc = 0;
	clr R20
	clr R21
;     }
L8:
L7:
;     rc += nu;
	add R20,R22
	adc R21,R23
;     if (size > 1) {
	ldi R24,1
	ldi R25,0
	cp R24,R10
	cpc R25,R11
	brsh L10
X4:
;         rc /= size;
	movw R18,R10
	movw R16,R20
	xcall div16u
	movw R20,R16
;     }
L10:
;     return rc;
	movw R16,R20
L1:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgsetF0FC
; }
; 
; /*@}*/
