	.module freopen.c
	.area text(rom, con, rel)
;         mflags -> R22,R23
;              i -> R20
;         stream -> y+8
;           mode -> R12,R13
;           name -> R10,R11
	.even
_freopen::
	xcall push_xgsetF03C
	movw R12,R18
	movw R10,R16
; /*
;  * Copyright (C) 2001-2003 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  */
; 
; /*
;  * $Log: freopen.c,v $
;  * Revision 1.3  2004/09/08 10:19:05  haraldkipp
;  * Todo: We need a better check for stdio channels!
;  *
;  * Revision 1.2  2004/03/16 16:48:27  haraldkipp
;  * Added Jan Dubiec's H8/300 port.
;  *
;  * Revision 1.1.1.1  2003/05/09 14:40:27  haraldkipp
;  * Initial using 3.2.1
;  *
;  * Revision 1.1  2003/02/04 17:49:05  harald
;  * *** empty log message ***
;  *
;  */
; 
; #include "nut_io.h"
; 
; #include <errno.h>
; #include <io.h>
; #include <fcntl.h>
; #include <stdlib.h>
; 
; /*!
;  * \addtogroup xgCrtStdio
;  */
; /*@{*/
; 
; /*!
;  * \brief Reassign a stream.
;  *
;  * \param name The name of a registered device, optionally followed by a
;  *             colon and a filename.
;  * \param mode Specifies the access mode.
;  *	       \li \c "r" Read only.
;  *	       \li \c "w" Write only.
;  *	       \li \c "a" Write only at the end of file.
;  *	       \li \c "r+" Read and write existing file.
;  *	       \li \c "w+" Read and write, destroys existing file contents.
;  *	       \li \c "a+" Read and write, preserves existing file contents.
;  *             \li \c "b" May be appended to any of the above strings to 
;  *                        specify binary access.
;  *
;  * \param stream Pointer to a previously opened stream.
;  *
;  * \return A pointer to the open stream or a null pointer to indicate 
;  *         an error.
;  */
; FILE *freopen(CONST char *name, CONST char *mode, FILE * stream)
; {
;     int mflags = _O_TEXT;
;     u_char i;
; 
;     /*
;      * Translate file mode.
;      */
;     if ((mflags = _fmode(mode)) == EOF)
	movw R16,R12
	xcall __fmode
	movw R22,R16
	cpi R22,255
	ldi R30,255
	cpc R23,R30
	brne L2
X0:
;         return 0;
	clr R16
	clr R17
	xjmp L1
L2:
; 
;     for (i = 0; __iob[i] != stream;)
	clr R20
	xjmp L7
L4:
;         if (++i >= FOPEN_MAX) {
	mov R24,R20
	subi R24,255    ; addi 1
	mov R20,R24
	cpi R20,8
	brlo L8
X1:
;             errno = EBADF;
	ldi R24,9
	ldi R25,0
	sts _errno+1,R25
	sts _errno,R24
;             return 0;
	clr R16
	clr R17
	xjmp L1
L8:
L5:
L7:
	ldi R24,2
	mul R24,R20
	movw R30,R0
	ldi R24,<___iob
	ldi R25,>___iob
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldd R3,z+1
	ldd R0,y+8
	ldd R1,y+9
	cp R2,R0
	cpc R3,R1
	brne L4
X2:
;         }
; 
;     //if (stream)
;     //    _close(stream->iob_fd);
;     //else 
;     if ((__iob[i] = malloc(sizeof(FILE))) == 0)
	ldi R16,7
	ldi R17,0
	xcall _malloc_M
	movw R12,R16
	ldi R24,2
	mul R24,R20
	movw R30,R0
	ldi R24,<___iob
	ldi R25,>___iob
	add R30,R24
	adc R31,R25
	std z+1,R13
	std z+0,R12
	cpi R16,0
	cpc R16,R17
	brne L10
X3:
;         return 0;
	clr R16
	clr R17
	xjmp L1
L10:
; 
;     if ((__iob[i]->iob_fd = _open(name, mflags)) == -1) {
	movw R18,R22
	movw R16,R10
	xcall __open
	movw R10,R16
	ldi R24,2
	mul R24,R20
	movw R30,R0
	ldi R24,<___iob
	ldi R25,>___iob
	add R30,R24
	adc R31,R25
	ldd R26,z+0
	ldd R27,z+1
	st x+,R10
	st x,R11
	cpi R16,255
	ldi R30,255
	cpc R17,R30
	brne L12
X4:
;         free(__iob[i]);
	ldi R24,2
	mul R24,R20
	movw R30,R0
	ldi R24,<___iob
	ldi R25,>___iob
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	ldd R17,z+1
	xcall _free_M
;         if (i < 3)
	cpi R20,3
	brsh L14
X5:
;             __iob[i] = (FILE *) ((uptr_t) (i + 1));
	ldi R24,2
	mul R24,R20
	movw R30,R0
	ldi R24,<___iob
	ldi R25,>___iob
	add R30,R24
	adc R31,R25
	mov R24,R20
	clr R25
	adiw R24,1
	std z+1,R25
	std z+0,R24
	xjmp L15
L14:
;         else
;             __iob[i] = 0;
	ldi R24,2
	mul R24,R20
	movw R30,R0
	ldi R24,<___iob
	ldi R25,>___iob
	add R30,R24
	adc R31,R25
	clr R2
	clr R3
	std z+1,R3
	std z+0,R2
L15:
;         return 0;
	clr R16
	clr R17
	xjmp L1
L12:
;     }
; 
;     __iob[i]->iob_mode = mflags;
	ldi R24,2
	mul R24,R20
	movw R30,R0
	ldi R24,<___iob
	ldi R25,>___iob
	add R30,R24
	adc R31,R25
	ldd R26,z+0
	ldd R27,z+1
	adiw R26,2
	st x+,R22
	st x,R23
;     __iob[i]->iob_flags = 0;
	ldi R24,2
	mul R24,R20
	movw R30,R0
	ldi R24,<___iob
	ldi R25,>___iob
	add R30,R24
	adc R31,R25
	push R26
	push R27
	ldd R26,z+0
	ldd R27,z+1
	movw R30,R26
	pop R27
	pop R26
	clr R2
	std z+4,R2
;     __iob[i]->iob_unget = 0;
	ldi R24,2
	mul R24,R20
	movw R30,R0
	ldi R24,<___iob
	ldi R25,>___iob
	add R30,R24
	adc R31,R25
	ldd R26,z+0
	ldd R27,z+1
	clr R3
	adiw R26,5
	st x+,R2
	st x,R3
; 
;     return __iob[i];
	ldi R24,2
	mul R24,R20
	movw R30,R0
	ldi R24,<___iob
	ldi R25,>___iob
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	ldd R17,z+1
L1:
	.dbline 0 ; func end
	xjmp pop_xgsetF03C
; }
; 
; /*@}*/
