	.module localtim.c
	.area text(rom, con, rel)
;          ltime -> y+0
;            ptm -> R10,R11
;          timer -> R12,R13
	.even
_localtime_r::
	xcall push_xgsetF0FC
	movw R10,R18
	movw R12,R16
	sbiw R28,8
; /*
;  * Copyright (C) 2001-2003 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  * Portions of the following functions are derived from material which is 
;  * Copyright (c) 1985 by Microsoft Corporation.  All rights are reserved.
;  */
; /*
;  * $Log: localtim.c,v $
;  * Revision 1.4  2004/10/14 16:43:00  drsung
;  * Fixed compiler warning "comparison between signed and unsigned"
;  *
;  * Revision 1.3  2003/12/19 22:26:37  drsung
;  * Dox written.
;  *
;  * Revision 1.2  2003/11/26 11:14:32  haraldkipp
;  * Portability issues
;  *
;  * Revision 1.1  2003/11/24 18:07:37  drsung
;  * first release
;  *
;  *
;  */
;  
; 
; #include <time.h>
; #include "ctime.h"
; 
; #define __need_NULL
; #include <stddef.h>
; 
; #define LONG_MAX   2147483647L
; 
; /*!
;  * \addtogroup xgCrtTime
;  * @{
;  */
; 
; /*!
;  * \brief Convert a time value and correct for the local time zone.
;  *
;  * Thread safe version of \b localtime. See ::localtime for more information.
;  *
;  * \param timer Pointer to stored time. 
;  * \param ptm Pointer to structure ::tm where the converted time is stored. 
;  * \return Always return 0.
;  *
;  */
; int localtime_r(CONST time_t * timer, tm * ptm)
; {
;     long ltime;
;     if ((*timer > (time_t)(3 * _DAY_SEC)) && (*timer < (time_t)(LONG_MAX - 3 * _DAY_SEC))) {
	movw R30,R12
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
	ldi R20,128
	ldi R21,244
	ldi R22,3
	ldi R23,0
	ldd R2,y+4
	ldd R3,y+5
	ldd R4,y+6
	ldd R5,y+7
	cp R20,R2
	cpc R21,R3
	cpc R22,R4
	cpc R23,R5
	brlt X11
	xjmp L2
X11:
X0:
	ldi R20,127
	ldi R21,11
	ldi R22,252
	ldi R23,127
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brlt X12
	xjmp L2
X12:
X1:
;         /*
;          * The date does not fall within the first three, or last
;          * three, representable days of the Epoch. Therefore, there
;          * is no possibility of overflowing or underflowing the
;          * time_t representation as we compensate for timezone and
;          * Daylight Savings Time.
;          */
; 
;         ltime = (long) *timer - _timezone;
	lds R4,__timezone+2
	lds R5,__timezone+2+1
	lds R2,__timezone
	lds R3,__timezone+1
	ldd R6,z+0
	ldd R7,z+1
	ldd R8,z+2
	ldd R9,z+3
	sub R6,R2
	sbc R7,R3
	sbc R8,R4
	sbc R9,R5
	std y+0,R6
	std y+1,R7
	std y+2,R8
	std y+3,R9
;         gmtime_r((time_t *) & ltime, ptm);
	movw R18,R10
	movw R16,R28
	xcall _gmtime_r
; 
;         /*
;          * Check and adjust for Daylight Saving Time.
;          */
;         if (_daylight && _isindst(ptm)) {
	lds R2,__daylight
	tst R2
	brne X13
	xjmp L3
X13:
X2:
	movw R16,R10
	xcall __isindst
	cpi R16,0
	cpc R16,R17
	brne X14
	xjmp L3
X14:
X3:
;             ltime -= _dstbias;
	lds R4,__dstbias+2
	lds R5,__dstbias+2+1
	lds R2,__dstbias
	lds R3,__dstbias+1
	ldd R6,y+0
	ldd R7,y+1
	ldd R8,y+2
	ldd R9,y+3
	sub R6,R2
	sbc R7,R3
	sbc R8,R4
	sbc R9,R5
	std y+0,R6
	std y+1,R7
	std y+2,R8
	std y+3,R9
;             gmtime_r((time_t *) & ltime, ptm);
	movw R18,R10
	movw R16,R28
	xcall _gmtime_r
;             ptm->tm_isdst = 1;
	ldi R24,1
	ldi R25,0
	movw R30,R10
	std z+17,R25
	std z+16,R24
;         }
;     } else {
	xjmp L3
L2:
;         gmtime_r(timer, ptm);
	movw R18,R10
	movw R16,R12
	xcall _gmtime_r
; 
;         /*
;          * The date falls with the first three, or last three days
;          * of the Epoch. It is possible the time_t representation
;          * would overflow or underflow while compensating for
;          * timezone and Daylight Savings Time. Therefore, make the
;          * timezone and Daylight Savings Time adjustments directly
;          * in the tm structure. The beginning of the Epoch is
;          * 00:00:00, 01-01-70 (UCT) and the last representable second
;          * in the Epoch is 03:14:07, 01-19-2038 (UCT). This will be
;          * used in the calculations below.
;          *
;          * First, adjust for the timezone.
;          */
;         if (_isindst(ptm))
	movw R16,R10
	xcall __isindst
	cpi R16,0
	cpc R16,R17
	breq L6
X4:
;             ltime = (long) ptm->tm_sec - (_timezone + _dstbias);
	lds R4,__dstbias+2
	lds R5,__dstbias+2+1
	lds R2,__dstbias
	lds R3,__dstbias+1
	lds R8,__timezone+2
	lds R9,__timezone+2+1
	lds R6,__timezone
	lds R7,__timezone+1
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	movw R30,R10
	ldd R2,z+0
	ldd R3,z+1
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	sub R2,R6
	sbc R3,R7
	sbc R4,R8
	sbc R5,R9
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	xjmp L7
L6:
;         else
;             ltime = (long) ptm->tm_sec - _timezone;
	lds R4,__timezone+2
	lds R5,__timezone+2+1
	lds R2,__timezone
	lds R3,__timezone+1
	movw R30,R10
	ldd R6,z+0
	ldd R7,z+1
	clr R8
	sbrc R7,7
	com R8
	clr R9
	sbrc R8,7
	com R9
	sub R6,R2
	sbc R7,R3
	sbc R8,R4
	sbc R9,R5
	std y+0,R6
	std y+1,R7
	std y+2,R8
	std y+3,R9
L7:
;         ptm->tm_sec = (int) (ltime % 60);
	ldi R20,60
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R16,y+0
	ldd R17,y+1
	ldd R18,y+2
	ldd R19,y+3
	st -y,R23
	st -y,R22
	st -y,R21
	st -y,R20
	xcall mod32s
	movw R30,R10
	std z+1,R17
	std z+0,R16
;         if (ptm->tm_sec < 0) {
	ldd R24,z+0
	ldd R25,z+1
	cpi R24,0
	ldi R26,0
	cpc R25,R26
	brge L8
X5:
;             ptm->tm_sec += 60;
	adiw R24,60
	std z+1,R25
	std z+0,R24
;             ltime -= 60;
	ldi R20,60
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	sub R2,R20
	sbc R3,R21
	sbc R4,R22
	sbc R5,R23
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
;         }
L8:
; 
;         ltime = (long) ptm->tm_min + ltime / 60;
	ldi R20,60
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R16,y+0
	ldd R17,y+1
	ldd R18,y+2
	ldd R19,y+3
	st -y,R23
	st -y,R22
	st -y,R21
	st -y,R20
	xcall div32s
	movw R30,R10
	ldd R2,z+2
	ldd R3,z+3
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	add R2,R16
	adc R3,R17
	adc R4,R18
	adc R5,R19
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
;         ptm->tm_min = (int) (ltime % 60);
	ldi R20,60
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R16,y+0
	ldd R17,y+1
	ldd R18,y+2
	ldd R19,y+3
	st -y,R23
	st -y,R22
	st -y,R21
	st -y,R20
	xcall mod32s
	movw R30,R10
	std z+3,R17
	std z+2,R16
;         if (ptm->tm_min < 0) {
	ldd R24,z+2
	ldd R25,z+3
	cpi R24,0
	ldi R26,0
	cpc R25,R26
	brge L10
X6:
;             ptm->tm_min += 60;
	movw R24,R30
	adiw R24,2
	movw R12,R24
	movw R30,R24
	ldd R24,z+0
	ldd R25,z+1
	adiw R24,60
	std z+1,R25
	std z+0,R24
;             ltime -= 60;
	ldi R20,60
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	sub R2,R20
	sbc R3,R21
	sbc R4,R22
	sbc R5,R23
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
;         }
L10:
; 
;         ltime = (long) ptm->tm_hour + ltime / 60;
	ldi R20,60
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R16,y+0
	ldd R17,y+1
	ldd R18,y+2
	ldd R19,y+3
	st -y,R23
	st -y,R22
	st -y,R21
	st -y,R20
	xcall div32s
	movw R30,R10
	ldd R2,z+4
	ldd R3,z+5
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	add R2,R16
	adc R3,R17
	adc R4,R18
	adc R5,R19
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
;         ptm->tm_hour = (int) (ltime % 24);
	ldi R20,24
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R16,y+0
	ldd R17,y+1
	ldd R18,y+2
	ldd R19,y+3
	st -y,R23
	st -y,R22
	st -y,R21
	st -y,R20
	xcall mod32s
	movw R30,R10
	std z+5,R17
	std z+4,R16
;         if (ptm->tm_hour < 0) {
	ldd R24,z+4
	ldd R25,z+5
	cpi R24,0
	ldi R26,0
	cpc R25,R26
	brge L12
X7:
;             ptm->tm_hour += 24;
	movw R24,R30
	adiw R24,4
	movw R12,R24
	movw R30,R24
	ldd R24,z+0
	ldd R25,z+1
	adiw R24,24
	std z+1,R25
	std z+0,R24
;             ltime -= 24;
	ldi R20,24
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	sub R2,R20
	sbc R3,R21
	sbc R4,R22
	sbc R5,R23
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
;         }
L12:
; 
;         ltime /= 24;
	ldi R20,24
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R16,y+0
	ldd R17,y+1
	ldd R18,y+2
	ldd R19,y+3
	st -y,R23
	st -y,R22
	st -y,R21
	st -y,R20
	xcall div32s
	std y+0,R16
	std y+1,R17
	std y+2,R18
	std y+3,R19
; 
;         if (ltime > 0L) {
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	cp R20,R2
	cpc R21,R3
	cpc R22,R4
	cpc R23,R5
	brlt X15
	xjmp L14
X15:
X8:
;             /*
;              * There is no possibility of overflowing the tm_mday
;              * and tm_yday fields since the date can be no later
;              * than January 19.
;              */
;             ptm->tm_wday = (ptm->tm_wday + ltime) % 7;
	movw R24,R10
	adiw R24,12
	movw R12,R24
	movw R30,R24
	ldd R16,z+0
	ldd R17,z+1
	clr R18
	sbrc R17,7
	com R18
	clr R19
	sbrc R18,7
	com R19
	add R16,R2
	adc R17,R3
	adc R18,R4
	adc R19,R5
	ldi R20,7
	ldi R21,0
	ldi R22,0
	ldi R23,0
	st -y,R23
	st -y,R22
	st -y,R21
	st -y,R20
	xcall mod32s
	movw R30,R12
	std z+1,R17
	std z+0,R16
;             ptm->tm_mday += ltime;
	movw R24,R10
	adiw R24,6
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	movw R30,R24
	ldd R6,z+0
	ldd R7,z+1
	clr R8
	sbrc R7,7
	com R8
	clr R9
	sbrc R8,7
	com R9
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	std z+1,R7
	std z+0,R6
;             ptm->tm_yday += ltime;
	movw R24,R10
	adiw R24,14
	movw R12,R24
	movw R30,R24
	ldd R6,z+0
	ldd R7,z+1
	clr R8
	sbrc R7,7
	com R8
	clr R9
	sbrc R8,7
	com R9
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	std z+1,R7
	std z+0,R6
;         } else if (ltime < 0L) {
	xjmp L15
L14:
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brlt X16
	xjmp L16
X16:
X9:
;             /*
;              * It is possible to underflow the tm_mday and tm_yday
;              * fields. If this happens, then adjusted date must
;              * lie in December 1969.
;              */
;             ptm->tm_wday = (ptm->tm_wday + 7 + ltime) % 7;
	movw R24,R10
	adiw R24,12
	movw R12,R24
	movw R30,R24
	ldd R16,z+0
	ldd R17,z+1
	subi R16,249  ; offset = 7
	sbci R17,255
	clr R18
	sbrc R17,7
	com R18
	clr R19
	sbrc R18,7
	com R19
	add R16,R2
	adc R17,R3
	adc R18,R4
	adc R19,R5
	ldi R20,7
	ldi R21,0
	ldi R22,0
	ldi R23,0
	st -y,R23
	st -y,R22
	st -y,R21
	st -y,R20
	xcall mod32s
	movw R30,R12
	std z+1,R17
	std z+0,R16
;             if ((ptm->tm_mday += ltime) <= 0) {
	movw R24,R10
	adiw R24,6
	movw R14,R24
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	movw R30,R24
	ldd R6,z+0
	ldd R7,z+1
	clr R8
	sbrc R7,7
	com R8
	clr R9
	sbrc R8,7
	com R9
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	movw R12,R6
	std z+1,R13
	std z+0,R12
	clr R2
	clr R3
	cp R2,R6
	cpc R3,R7
	brlt L18
X10:
;                 ptm->tm_mday += 31;
	movw R24,R10
	adiw R24,6
	movw R30,R24
	ldd R24,z+0
	ldd R25,z+1
	adiw R24,31
	std z+1,R25
	std z+0,R24
;                 ptm->tm_yday = 364;
	ldi R24,364
	ldi R25,1
	movw R30,R10
	std z+15,R25
	std z+14,R24
;                 ptm->tm_mon = 11;
	ldi R24,11
	ldi R25,0
	std z+9,R25
	std z+8,R24
;                 ptm->tm_year--;
	movw R24,R30
	adiw R24,10
	movw R12,R24
	movw R30,R24
	ldd R24,z+0
	ldd R25,z+1
	sbiw R24,1
	std z+1,R25
	std z+0,R24
;             } else {
	xjmp L19
L18:
;                 ptm->tm_yday += ltime;
	movw R24,R10
	adiw R24,14
	movw R10,R24
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	movw R30,R24
	ldd R6,z+0
	ldd R7,z+1
	clr R8
	sbrc R7,7
	com R8
	clr R9
	sbrc R8,7
	com R9
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	std z+1,R7
	std z+0,R6
;             }
L19:
;         }
L16:
L15:
; 
; 
;     }
L3:
;     return 0;
	clr R16
	clr R17
L1:
	.dbline 0 ; func end
	adiw R28,8
	xjmp pop_xgsetF0FC
;          timer -> R10,R11
	.even
_localtime::
	st -y,R10
	st -y,R11
	movw R10,R16
; }
; 
; 
; /*!
;  * \brief Convert a time value and correct for the local time zone.
;  *
;  * The localtime function converts a time stored as a time_t value and stores the 
;  * result in a structure of type ::tm. The long value \e timer represents the seconds 
;  * elapsed since midnight (00:00:00), January 1, 1970, UTC. This value is usually 
;  * obtained from the ::time function.
;  *
;  * ::gmtime, ::mktime, and \b localtime all use a single statically allocated ::tm structure 
;  * for the conversion. Each call to one of these routines destroys the result of the 
;  * previous call.
;  *
;  * \b localtime corrects for the local time zone if the user first sets the global 
;  * variable #_timezone. 
;  * 
;  * \param timer Pointer to stored time. 
;  * \return Return a pointer to the structure result. If the value in \e timer 
;  * represents a date before midnight, January 1, 1970, return \b NULL.
;  *
;  */
; /*
;   Note: This function is *not* thread safe, because it uses a static variable
;   to store the calculated values. To be safe, you must surround the call to localtime 
;   _and_ the usage of the returned pointer with NutEnterCritical() and NutExitCritical()!
;   Provided for compatibility to std c lib.
; */
; tm *localtime(CONST time_t * timer)
; {
;     if (localtime_r(timer, &_tb))
	ldi R18,<__tb
	ldi R19,>__tb
	movw R16,R10
	xcall _localtime_r
	cpi R16,0
	cpc R16,R17
	breq L21
X17:
;         return NULL;
	clr R16
	clr R17
	xjmp L20
L21:
;     else
;         return &_tb;
	ldi R16,<__tb
	ldi R17,>__tb
L20:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
; }
; 
; /*@}*/
