	.module open.c
	.area text(rom, con, rel)
;            dev -> R20,R21
;       dev_name -> y+4
;           nidx -> R20
;           nptr -> R10,R11
;           mode -> R12,R13
;           name -> R14,R15
	.even
__open::
	xcall push_xgset30FC
	movw R12,R18
	movw R14,R16
	sbiw R28,13
; /*
;  * Copyright (C) 2001-2003 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  */
; 
; /*
;  * $Log: open.c,v $
;  * Revision 1.3  2004/03/16 16:48:27  haraldkipp
;  * Added Jan Dubiec's H8/300 port.
;  *
;  * Revision 1.2  2003/08/05 20:01:55  haraldkipp
;  * Typing errors corrected
;  *
;  * Revision 1.1.1.1  2003/05/09 14:40:30  haraldkipp
;  * Initial using 3.2.1
;  *
;  * Revision 1.1  2003/02/04 17:49:08  harald
;  * *** empty log message ***
;  *
;  */
; 
; #include "nut_io.h"
; 
; #include <errno.h>
; #include <sys/device.h>
; 
; /*!
;  * \addtogroup xgCrtLowio
;  */
; /*@{*/
; 
; 
; /*!
;  * \brief Open a file.
;  *
;  * \param name The name of a registered device, optionally followed by a
;  *             colon and a filename.
;  * \param mode Operation mode. May be any of the following:
;  * - _O_APPEND Always write at the end. 
;  * - _O_BINARY Raw mode.
;  * - _O_CREAT Create file if it does not exist. 
;  * - _O_EXCL Open only if it does not exist. 
;  * - _O_RDONLY Read only. 
;  * - _O_RDWR Read and write. 
;  * - _O_TEXT End of line translation. 
;  * - _O_TRUNC Truncate file if it exists. 
;  * - _O_WRONLY Write only.
;  *
;  * \return File descriptor for the opened file or -1 to indicate an error.
;  */
; int _open(CONST char *name, int mode)
; {
;     NUTDEVICE *dev;
;     u_char dev_name[9];
;     u_char nidx;
;     CONST char *nptr = name;
	movw R10,R14
; 
;     /*
;      * Extract device name.
;      */
;     for (nidx = 0; *nptr && *nptr != ':' && nidx < 8; nidx++) {
	clr R20
	xjmp L5
L2:
;         dev_name[nidx] = *nptr++;
	movw R24,R28
	adiw R24,4
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	movw R26,R10
	ld R2,X+
	movw R10,R26
	std z+0,R2
;     }
L3:
	inc R20
L5:
	movw R30,R10
	ldd R2,z+0
	clr R3
	tst R2
	breq L7
X0:
	mov R24,R2
	cpi R24,58
	breq L7
X1:
	cpi R20,8
	brlo L2
X2:
L7:
;     dev_name[nidx] = 0;
	movw R24,R28
	adiw R24,4
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	clr R2
	std z+0,R2
; 
;     /*
;      * Get device structure of registered device. In later releases we
;      * try to open a file on a root device.
;      */
;     if ((dev = NutDeviceLookup(dev_name)) == 0) {
	movw R16,R28
	subi R16,252  ; offset = 4
	sbci R17,255
	xcall _NutDeviceLookup
	movw R20,R16
	cpi R20,0
	cpc R20,R21
	brne L8
X3:
;         errno = ENOENT;
	ldi R24,2
	ldi R25,0
	sts _errno+1,R25
	sts _errno,R24
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L1
L8:
;     }
; 
;     /*
;      * We should check, if the mode flags are device conformant.
;      */
; 
;     /*
;      * If a device name was specified, open this device. Otherwise open
;      * a file on the device.
;      */
;     if (*nptr++ != ':')
	movw R30,R10
	ld R24,Z+
	movw R10,R30
	cpi R24,58
	breq L10
X4:
;         nptr = 0;
	clr R10
	clr R11
L10:
;     return (int) ((uptr_t) ((*dev->dev_open) (dev, nptr, mode, 0)));
	clr R2
	clr R3
	std y+3,R3
	std y+2,R2
	std y+1,R13
	std y+0,R12
	movw R18,R10
	movw R16,R20
	movw R30,R20
	ldd R26,z+29
	ldd R27,z+30
	movw R30,R26
	xcall  xicall
	movw R10,R16
L1:
	.dbline 0 ; func end
	adiw R28,13
	xjmp pop_xgset30FC
; }
; 
; /*@}*/
