	.module strtok_r.c
	.area text(rom, con, rel)
;          p_tok -> R10,R11
;           p_ch -> R20,R21
;             sp -> R22,R23
;          p_sep -> R12,R13
;        p_delim -> R18,R19
;         pp_str -> R16,R17
	.even
_end_tok:
	xcall push_xgsetF03C
	ldd R12,y+8
	ldd R13,y+9
; /*--------------------------------------------------------------------------*/
; /*                                                                          */
; /*  File:           STRTOK_R.C                                              */
; /*  Created:        20-September-2002                                       */
; /*  Author:         Peter Scandrett                                         */
; /*  Description:    Module to provide a reentrant version of the 'C'        */
; /*                      function STRTOK.                                    */
; /*                                                                          */
; /*--------------------------------------------------------------------------*/
; /*                                                                          */
; /*  Copyright (C) 2002 by ALSTOM Australia Limited. All rights reserved.    */
; /*                                                                          */
; /*  Redistribution and use in source and binary forms, with or without      */
; /*  modification, are permitted provided that the following conditions      */
; /*  are met:                                                                */
; /*  1.  Redistributions of source code must retain the above copyright      */
; /*      notice and this list of conditions.                                 */
; /*  2.  Neither the name of ALSTOM Australia Limited nor the names of its   */
; /*      contributors may be used to endorse or promote products derived     */
; /*      from this software.                                                 */
; /*                                                                          */
; /*  THIS SOFTWARE IS PROVIDED BY ALSTOM AUSTRALIA LIMITED AND CONTRIBUTORS  */
; /*  ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT     */
; /*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS       */
; /*  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL ALSTOM       */
; /*  AUSTRALIA LIMITED OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,   */
; /*  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,    */
; /*  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS   */
; /*  OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED      */
; /*  AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  */
; /*  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF   */
; /*  THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH    */
; /*  DAMAGE.                                                                 */
; /*                                                                          */
; /*--------------------------------------------------------------------------*/
; 
; /*
;  * $Log: strtok_r.c,v $
;  * Revision 1.5  2004/07/27 19:28:51  drsung
;  * Implementation of strtok_r adjusted to the POSIX 1c standard.
;  *
;  * Revision 1.4  2003/12/16 22:34:41  drsung
;  * Portability issues
;  *
;  */
; 
; #include <stdlib.h>
; #include <string.h>
; 
; #include "strtok_r.h"
; 
; /*!
;  * \addtogroup xgCrtMisc
;  *
;  * The functions strtok_r(), strsep_r() and strsep_rs() are intended as a 
;  * replacement for the strtok() function. While the strtok() function should 
;  * be preferred for portability reasons (it conforms to ISO/IEC 9899:1990 
;  * ("ISO C89")) it may not be able to be used in a multi-threaded environment 
;  * (that is it is not reentrant). Functions strsep_r() and strsep_rs() can 
;  * handle empty fields, (i.e. detect fields delimited by two adjacent 
;  * delimiter characters). Function strsep() first appeared in 4.4BSD.
;  */
; /*@{*/
; 
; /*--------------------------------------------------------------------------*/
; 
; static char *end_tok(char **pp_str, CONST char *p_delim, char *p_sep)
; {
;     register const char *sp;
;     char *p_tok;
;     char *p_ch;
; 
;     /*  Use a local pointer. */
;     p_ch = *pp_str;
	movw R30,R16
	ldd R20,z+0
	ldd R21,z+1
; 
;     /*  Scan for next deliminator. */
;     p_tok = p_ch;
	movw R10,R20
	xjmp L3
L2:
;     while (*p_ch != 0) {
;         for (sp = p_delim; *sp != 0; sp++) {
	movw R22,R18
	xjmp L8
L5:
;             if (*sp == *p_ch) {
	movw R30,R20
	ldd R2,z+0
	movw R30,R22
	lpm R3,Z
	cp R3,R2
	brne L9
X0:
;                 if (p_sep != NULL) {
	tst R12
	brne X1
	tst R13
	breq L11
X1:
;                     /*  Save terminator. */
;                     *p_sep = *p_ch;
	movw R30,R20
	ldd R2,z+0
	movw R30,R12
	std z+0,R2
;                 }
L11:
;                 *p_ch++ = 0;
	clr R2
	movw R30,R20
	st Z+,R2
	movw R20,R30
;                 *pp_str = p_ch;
	movw R30,R16
	std z+1,R21
	std z+0,R20
;                 return p_tok;
	movw R16,R10
	xjmp L1
L9:
;             }
;         }
L6:
	subi R22,255  ; offset = 1
	sbci R23,255
L8:
	movw R30,R22
	lpm R2,Z
	tst R2
	breq X4
	xjmp L5
X4:
X2:
;         p_ch++;
	subi R20,255  ; offset = 1
	sbci R21,255
;     }
L3:
	movw R30,R20
	ldd R2,z+0
	tst R2
	breq X5
	xjmp L2
X5:
X3:
; 
;     /*  At end of string, so exit, but return last token. */
;     *pp_str = p_ch;
	movw R30,R16
	std z+1,R21
	std z+0,R20
;     return p_tok;
	movw R16,R10
L1:
	.dbline 0 ; func end
	xjmp pop_xgsetF03C
;           p_ch -> R20,R21
;          p_sep -> R14,R15
;        p_delim -> R12,R13
;         pp_str -> R10,R11
	.even
_strsep_rs::
	xcall push_xgset30FC
	movw R12,R18
	movw R10,R16
	sbiw R28,2
	ldd R14,y+10
	ldd R15,y+11
; }
; 
; /*--------------------------------------------------------------------------*/
; 
; /*!
;  * \brief Thread safe variant of strsep.
;  *
;  * This function is identical in operation to strsep_r(), except it returns the 
;  * deliminating character.
;  */
; char *strsep_rs(char **pp_str, CONST char *p_delim, char *p_sep)
; {
;     char *p_ch;
; 
;     /*  Assume terminator was end of string. */
;     if (p_sep != NULL)
	tst R14
	brne X6
	tst R15
	breq L14
X6:
;         *p_sep = 0;
	clr R2
	movw R30,R14
	std z+0,R2
L14:
; 
;     /*  Check not passed a NULL. */
;     if (pp_str == NULL)
	tst R10
	brne L16
	tst R11
	brne L16
X7:
;         return NULL;
	clr R16
	clr R17
	xjmp L13
L16:
; 
;     /*  Use a local pointer. */
;     p_ch = *pp_str;
	movw R30,R10
	ldd R20,z+0
	ldd R21,z+1
;     if (p_ch == NULL)
	cpi R20,0
	cpc R20,R21
	brne L18
X8:
;         return NULL;
	clr R16
	clr R17
	xjmp L13
L18:
; 
;     if (*p_ch == 0)
	movw R30,R20
	ldd R2,z+0
	tst R2
	brne L20
X9:
;         return NULL;
	clr R16
	clr R17
	xjmp L13
L20:
; 
;     /*  Check a valid delimiter string. */
;     if ((p_delim == NULL) || (*p_delim == 0)) {
	tst R12
	brne X10
	tst R13
	breq L24
X10:
	movw R30,R12
	ldd R2,z+0
	tst R2
	brne L22
X11:
L24:
;         *pp_str = NULL;
	clr R2
	clr R3
	movw R30,R10
	std z+1,R3
	std z+0,R2
;         return p_ch;
	movw R16,R20
	xjmp L13
L22:
;     }
;     /*  Scan for next deliminator. */
;     return end_tok(pp_str, p_delim, p_sep);
	std y+1,R15
	std y+0,R14
	movw R18,R12
	movw R16,R10
	xcall _end_tok
L13:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgset30FC
;        p_delim -> R12,R13
;         pp_str -> R10,R11
	.even
_strsep_r::
	xcall push_xgset003C
	movw R12,R18
	movw R10,R16
	sbiw R28,2
; }
; 
; /*--------------------------------------------------------------------------*/
; 
; /*!
;  * \brief Thread safe version of strsep.
;  *
;  * This function locates, in the string referenced by *str, the first occurrence of 
;  * any character in the string delim (or the terminating `\0' character) and 
;  * replaces it with a `\0'. The location of the next character after the delimiter 
;  * character (or NULL, if the end of the string was reached) is stored in *str. 
;  * The original value of *str is returned.
;  *
;  * An "empty" field, i.e. one caused by two adjacent delimiter characters, can be 
;  * detected by comparing the location referenced by the pointer returned in *str 
;  * to `\0'.
;  *
;  * If *str is initially NULL, strsep_r() returns NULL. 
;  *
;  * If delim is NULL or the empty string, strsep_r() returns *str.
;  */
; char *strsep_r(char **pp_str, CONST char *p_delim)
; {
;     return strsep_rs(pp_str, p_delim, NULL);
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	movw R18,R12
	movw R16,R10
	xcall _strsep_rs
L25:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgset003C
;          token -> R10,R11
;       save_ptr -> R12,R13
;          delim -> R14,R15
;              s -> R20,R21
	.even
_strtok_r::
	xcall push_xgset30FC
	movw R14,R18
	movw R20,R16
	ldd R12,y+8
	ldd R13,y+9
; }
; 
; /*--------------------------------------------------------------------------*/
; /*!
;  * \brief Thread safe version of strtok.
;  *
;  * This function locates, in the string referenced by *s, the occurrence of 
;  * any character in the string delim (or the terminating `\0' character) and 
;  * replaces them with a `\0'. The location of the next character after the 
;  * delimiter character (or NULL, if the end of the string was reached) is 
;  * stored in *save_ptr. The first character not a delimiter character from 
;  * the original value of *s is returned.
;  *
;  * \deprecated This function is supported by avrlibc, which uses different
;  *             parameters. It's still available for ICCAVR, but should be
;  *             avoided for portability reasons.
;  */
; #ifdef __IMAGECRAFT__
; /* Parse S into tokens separated by characters in DELIM.
;    If S is NULL, the saved pointer in SAVE_PTR is used as
;    the next starting point.  For example:
; 	char s[] = "-abc-=-def";
; 	char *sp;
; 	x = strtok_r(s, "-", &sp);	// x = "abc", sp = "=-def"
; 	x = strtok_r(NULL, "-=", &sp);	// x = "def", sp = NULL
; 	x = strtok_r(NULL, "=", &sp);	// x = NULL
; 		// s = "abc\0-def\0"
; */
; char *strtok_r(char *s, CONST char *delim, char **save_ptr)
; {
;     char *token;
; 
;     if (s == NULL)
	cpi R20,0
	cpc R20,R21
	brne L27
X12:
;         s = *save_ptr;
	movw R30,R12
	ldd R20,z+0
	ldd R21,z+1
L27:
; 
;     /* Scan leading delimiters.  */
;     s += strspn(s, delim);
	movw R18,R14
	movw R16,R20
	xcall _strspn
	add R20,R16
	adc R21,R17
;     if (*s == '\0')
	movw R30,R20
	ldd R2,z+0
	tst R2
	brne L29
X13:
;         return NULL;
	clr R16
	clr R17
	xjmp L26
L29:
; 
;     /* Find the end of the token.  */
;     token = s;
	movw R10,R20
;     s = strpbrk(token, delim);
	movw R18,R14
	movw R16,R10
	xcall _strpbrk
	movw R20,R16
;     if (s == NULL)
	cpi R16,0
	cpc R16,R17
	brne L31
X14:
;         /* This token finishes the string.  */
;         *save_ptr = strchr(token, '\0');
	clr R18
	clr R19
	movw R16,R10
	xcall _strchr
	movw R14,R16
	movw R30,R12
	std z+1,R15
	std z+0,R14
	xjmp L32
L31:
;     else {
;         /* Terminate the token and make *SAVE_PTR point past it.  */
;         *s = '\0';
	clr R2
	movw R30,R20
	std z+0,R2
;         *save_ptr = s + 1;
	movw R24,R30
	adiw R24,1
	movw R30,R12
	std z+1,R25
	std z+0,R24
;     }
L32:
;     return token;
	movw R16,R10
L26:
	.dbline 0 ; func end
	xjmp pop_xgset30FC
; }
; #endif /*__IMAGECRAFT__ */
; 
; /*@}*/
; 
; /*-------------------------- end of file STRTOK_R.C ------------------------*/
