	.module time.c
	.area data(ram, con, rel)
_epo_offs:
	.blkb 4
	.area idata
	.word 0,0
	.area data(ram, con, rel)
	.area text(rom, con, rel)
;              r -> y+0
;          timer -> R10,R11
	.even
_time::
	st -y,R10
	st -y,R11
	movw R10,R16
	sbiw R28,4
; /*
;  * Copyright (C) 2001-2003 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  */
; /*
;  * $Log: time.c,v $
;  * Revision 1.3  2003/12/19 22:26:38  drsung
;  * Dox written.
;  *
;  * Revision 1.2  2003/11/26 11:14:32  haraldkipp
;  * Portability issues
;  *
;  * Revision 1.1  2003/11/24 18:07:37  drsung
;  * first release
;  *
;  *
;  */
; 
; #include <time.h>
; #include <sys/timer.h>
; #include <sys/atom.h>
; 
; static u_long epo_offs = 0;
; 
; /*!
;  * \addtogroup xgCrtTime
;  *
;  */
; /*@{*/
; 
; /*!
;  * \brief Get the system time.
;  *
;  * The \b time function returns the number of seconds elapsed since midnight (00:00:00), January 1, 1970, 
;  * coordinated universal time (UTC), according to the system clock. The return value is stored in the location 
;  * given by \e timer. This parameter may be \b NULL, in which case the return value is not stored.
;  *
;  * \param timer Pointer to the storage location for time. 
;  * \return Return the time in elapsed seconds. There is no error return. 
;  *
;  */
; time_t time(time_t * timer)
; {
;     u_long r;
; 
;     NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
;     r = epo_offs + NutGetSeconds();
	xcall _NutGetSeconds
	lds R4,_epo_offs+2
	lds R5,_epo_offs+2+1
	lds R2,_epo_offs
	lds R3,_epo_offs+1
	add R2,R16
	adc R3,R17
	adc R4,R18
	adc R5,R19
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
;     NutExitCritical();
	pop R0
	out 0x3F, R0
	
; 
;     if (timer)
	tst R10
	brne X0
	tst R11
	breq L2
X0:
;         *timer = r;
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	movw R30,R10
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
L2:
;     return r;
	ldd R16,y+0
	ldd R17,y+1
	ldd R18,y+2
	ldd R19,y+3
L1:
	.dbline 0 ; func end
	adiw R28,4
	ld R11,y+
	ld R10,y+
	ret
;          timer -> R10,R11
	.even
_stime::
	st -y,R10
	st -y,R11
	movw R10,R16
; }
; 
; /*!
;  * \brief Set the system time.
;  *
;  * \param timer Pointer to the storage location for time.
;  * \return This function always returns 0.
;  *
;  */
; int stime(time_t * timer)
; {
;     NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
;     epo_offs = *(u_long *) timer - NutGetSeconds();
	xcall _NutGetSeconds
	movw R30,R10
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	sub R2,R16
	sbc R3,R17
	sbc R4,R18
	sbc R5,R19
	sts _epo_offs+1,R3
	sts _epo_offs,R2
	sts _epo_offs+2+1,R5
	sts _epo_offs+2,R4
;     NutExitCritical();
	pop R0
	out 0x3F, R0
	
;     return 0;
	clr R16
	clr R17
L4:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
; }
; 
; /*@}*/
