	.module ungetc.c
	.area text(rom, con, rel)
;         stream -> R18,R19
;              c -> R16,R17
	.even
_ungetc::
; /*
;  * Copyright (C) 2001-2003 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  */
; 
; /*
;  * $Log: ungetc.c,v $
;  * Revision 1.1.1.1  2003/05/09 14:40:34  haraldkipp
;  * Initial using 3.2.1
;  *
;  * Revision 1.1  2003/02/04 17:49:09  harald
;  * *** empty log message ***
;  *
;  */
; 
; #include "nut_io.h"
; 
; /*!
;  * \addtogroup xgCrtStdio
;  */
; /*@{*/
; 
; /*!
;  * \brief Push a character back onto a stream.
;  *
;  * \param c      Character to push back.
;  * \param stream Pointer to a previously opened stream.
;  *
;  * \warning Only a single character can be pushed back. Any previously
;  *          pushed and not yet read character will be lost.
;  */
; int ungetc(int c, FILE * stream)
; {
;     if ((stream->iob_flags & _IOUNG) != 0 || c == EOF)
	movw R30,R18
	ldd R2,z+4
	sbrc R2,3
	rjmp L4
X0:
	cpi R16,255
	ldi R30,255
	cpc R17,R30
	brne L2
X1:
L4:
;         return EOF;
	ldi R16,-1
	ldi R17,-1
	xjmp L1
L2:
;     stream->iob_unget = c;
	movw R30,R18
	std z+6,R17
	std z+5,R16
;     stream->iob_flags |= _IOUNG;
	movw R24,R30
	adiw R24,4
	movw R30,R24
	ldd R24,z+0
	ori R24,8
	std z+0,R24
; 
;     return c;
L1:
	.dbline 0 ; func end
	ret
; }
; 
; /*@}*/
