	.module write_p.c
	.area text(rom, con, rel)
;            vdv -> R14,R15
;            dev -> R20,R21
;             fp -> R22,R23
;          count -> R12,R13
;           data -> R10,R11
;             fd -> R14,R15
	.even
__write_P::
	xcall push_xgsetF0FC
	movw R10,R18
	movw R14,R16
	sbiw R28,2
	ldd R12,y+12
	ldd R13,y+13
; /*
;  * Copyright (C) 2001-2003 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  */
; 
; /*
;  * $Log: write_p.c,v $
;  * Revision 1.3  2004/06/25 08:28:11  freckle
;  * Added note that write calls are not thread-safe, i.e, two writes might
;  * come out intermixed (although no bytes get lost)
;  *
;  * Revision 1.2  2004/03/16 16:48:27  haraldkipp
;  * Added Jan Dubiec's H8/300 port.
;  *
;  * Revision 1.1.1.1  2003/05/09 14:40:35  haraldkipp
;  * Initial using 3.2.1
;  *
;  * Revision 1.1  2003/02/04 17:49:09  harald
;  * *** empty log message ***
;  *
;  */
; 
; #include "nut_io.h"
; 
; #include <sys/device.h>
; 
; /*!
;  * \addtogroup xgCrtLowio
;  */
; /*@{*/
; 
; /*!
;  * \brief Writes data from program space to a file, device or socket.
;  *
;  * Similar to _write() except that the data is located in program 
;  * memory.
;  *
;  * \param fd    Descriptor of a previously opened file, device or
;  *              connected socket.
;  * \param data  Pointer to data in program space to be written.
;  * \param count Number of bytes to write.
;  *
;  * \return The number of bytes written, which may be less than the number
;  *         of bytes specified. A return value of -1 indicates an error.
;  *
;  * \note   The write implementation of the underlying driver does not need
;  *         to be thread-safe. Parallel writes using device usartavr will
;  *         lead to intermixed data (if data doesn't fit into ringbuffer
;  *         on the first try )
;  */
; int _write_P(int fd, PGM_P data, unsigned int count)
; {
;     NUTFILE *fp = (NUTFILE *) ((uptr_t) fd);
	movw R22,R14
;     NUTDEVICE *dev = fp->nf_dev;
	movw R30,R22
	ldd R20,z+2
	ldd R21,z+3
; 
;     if (dev == 0) {
	cpi R20,0
	cpc R20,R21
	brne L2
X0:
;         NUTVIRTUALDEVICE *vdv = (NUTVIRTUALDEVICE *) fp;
;         return (*vdv->vdv_write_P) (vdv, data, count);
	std y+1,R13
	std y+0,R12
	movw R18,R10
	movw R16,R30
	ldd R26,z+9
	ldd R27,z+10
	movw R30,R26
	xcall  xicall
	xjmp L1
L2:
;     }
;     return (*dev->dev_write_P) (fp, data, count);
	std y+1,R13
	std y+0,R12
	movw R18,R10
	movw R16,R22
	movw R30,R20
	ldd R26,z+27
	ldd R27,z+28
	movw R30,R26
	xcall  xicall
L1:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgsetF0FC
; }
; 
; /*@}*/
