	.module chat.c
	.area text(rom, con, rel)
;              c -> R18,R19
;            str -> R16,R17
	.even
_strechr:
; /*
;  * Copyright (C) 2001-2004 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  */
; 
; /*
;  * $Log: chat.c,v $
;  * Revision 1.7  2005/04/30 16:42:41  chaac
;  * Fixed bug in handling of NUTDEBUG. Added include for cfg/os.h. If NUTDEBUG
;  * is defined in NutConf, it will make effect where it is used.
;  *
;  * Revision 1.6  2004/03/16 16:48:27  haraldkipp
;  * Added Jan Dubiec's H8/300 port.
;  *
;  * Revision 1.5  2004/03/08 11:12:59  haraldkipp
;  * Debug output added.
;  *
;  * Revision 1.4  2004/01/15 08:02:35  drsung
;  * Copyright added
;  *
;  */
; 
; #include <cfg/os.h>
; #include <sys/timer.h>
; #include <dev/uart.h>
; 
; #include <stdlib.h>
; #include <string.h>
; #include <io.h>
; 
; #include <dev/chat.h>
; 
; u_char *chat_report;
; 
; #ifdef NUTDEBUG
; 
; static FILE *__chat_trs;        /*!< \brief Chat trace output stream. */
; static u_char __chat_trf;       /*!< \brief Chat trace flags. */
; 
; /*!
;  * \brief Control chat tracing.
;  *
;  * \param stream Pointer to a previously opened stream or null to 
;  *               disable trace output.
;  * \param flags  Flags to enable specific traces.
;  */
; void NutTraceChat(FILE * stream, u_char flags)
; {
;     if (stream)
;         __chat_trs = stream;
;     if (__chat_trs) {
;         static prog_char dbgfmt[] = "Chat trace flags=0x%02X\n";
;         __chat_trf = flags;
;         fprintf_P(__chat_trs, dbgfmt, flags);
;     } else
;         __chat_trf = 0;
; }
; 
; #endif
; 
; /*
;  * Special version of strchr, handling escaped characters.
;  */
; static char *strechr(CONST char *str, int c)
; {
	xjmp L4
L3:
;     while (*str) {
;         if (*str == '\\') {
	movw R30,R16
	ldd R24,z+0
	cpi R24,92
	brne L6
X0:
;             if (*++str)
	movw R24,R30
	adiw R24,1
	movw R16,R24
	movw R30,R24
	ldd R2,z+0
	tst R2
	breq L7
X1:
;                 str++;
	subi R16,255  ; offset = 1
	sbci R17,255
;         } else if (*str == c)
	xjmp L7
L6:
	movw R30,R16
	ldd R2,z+0
	clr R3
	cp R2,R18
	cpc R3,R19
	brne L10
X2:
;             return (char *) str;
	xjmp L2
L10:
;         else
;             str++;
	subi R16,255  ; offset = 1
	sbci R17,255
L7:
;     }
L4:
	movw R30,R16
	ldd R2,z+0
	tst R2
	brne L3
X3:
;     return 0;
	clr R16
	clr R17
L2:
	.dbline 0 ; func end
	ret
;             cp -> R10,R11
;             ch -> y+2
;              m -> R20
;              i -> R14
;            str -> R12,R13
;             ci -> y+13
	.even
_NutChatExpectString::
	xcall push_arg4
	xcall push_xgsetF0FC
	movw R12,R18
	sbiw R28,3
; }
; 
; /*!
;  * \brief Wait for a specific string to appear.
;  *
;  * \param ci  Pointer to a NUTCHAT structure, which must have been 
;  *            created by NutChatCreate().
;  * \param str Expected string. May be empty if nothing is expected.
;  *
;  * \return 0 on success, 3 in case of a timeout error while waiting
;  *         for an expected string, or the index of an abort string 
;  *         plus 4, if one has been received. 
;  */
; int NutChatExpectString(NUTCHAT * ci, char *str)
; {
;     char ch;
;     u_char m;
;     u_char i;
;     char *cp = str;
	movw R10,R12
	xjmp L14
L13:
; 
; #ifdef NUTDEBUG
;     if (__chat_trf) {
;         static prog_char dbgfmt[] = "Expect '%s', got '";
;         fprintf_P(__chat_trs, dbgfmt, str);
;     }
; #endif
; 
;     while (*cp) {
; 
;         /*
;          * Read the next character. Return on timeout.
;          */
;         if (_read(ci->chat_fd, &ch, 1) != 1) {
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	movw R18,R28
	subi R18,254  ; offset = 2
	sbci R19,255
	ldd R30,y+13
	ldd R31,y+14
	ldd R16,z+0
	ldd R17,z+1
	xcall __read
	cpi R16,1
	ldi R30,0
	cpc R17,R30
	breq L16
X4:
; #ifdef NUTDEBUG
;             if (__chat_trf) {
;                 static prog_char dbgmsg[] = "' TIMEOUT\n";
;                 fputs_P(dbgmsg, __chat_trs);
;             }
; #endif
;             return 3;
	ldi R16,3
	ldi R17,0
	xjmp L12
L16:
;         }
; #ifdef NUTDEBUG
;         if (__chat_trf) {
;             if (ch > 31 && ch < 127) {
;                 fputc(ch, __chat_trs);
;             } else {
;                 fprintf(__chat_trs, "\\x%02X", ch);
;             }
;         }
; #endif
;         /*
;          * If the character doesn't match the next expected one,
;          * then restart from the beginning of the expected string.
;          */
;         if (ch != *cp) {
	movw R30,R10
	ldd R2,z+0
	ldd R3,y+2
	cp R3,R2
	breq L18
X5:
;             cp = str;
	movw R10,R12
;         }
L18:
; 
;         /*
;          * If the character matched, advance the pointer into
;          * the expected string.
;          */
;         if (ch == *cp) {
	movw R30,R10
	ldd R2,z+0
	ldd R3,y+2
	cp R3,R2
	brne L20
X6:
;             cp++;
	movw R24,R30
	adiw R24,1
	movw R10,R24
;         }
L20:
; 
;         /*
;          * Check for abort strings.
;          */
;         for (i = 0; i < ci->chat_aborts; i++) {
	clr R14
	xjmp L25
L22:
;             m = ci->chat_abomat[i];
	ldd R24,y+13
	ldd R25,y+14
	adiw R24,24
	mov R30,R14
	clr R31
	add R30,R24
	adc R31,R25
	ldd R20,z+0
;             if (ch == ci->chat_abort[i][m]) {
	ldi R24,2
	mul R24,R14
	movw R30,R0
	ldd R24,y+13
	ldd R25,y+14
	adiw R24,4
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldd R3,z+1
	mov R30,R20
	clr R31
	add R30,R2
	adc R31,R3
	ldd R2,z+0
	ldd R3,y+2
	cp R3,R2
	brne L26
X7:
;                 if (ci->chat_abort[i][++m] == 0) {
	mov R24,R20
	subi R24,255    ; addi 1
	mov R4,R24
	mov R20,R24
	ldi R24,2
	mul R24,R14
	movw R30,R0
	ldd R24,y+13
	ldd R25,y+14
	adiw R24,4
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldd R3,z+1
	mov R30,R4
	clr R31
	add R30,R2
	adc R31,R3
	ldd R2,z+0
	tst R2
	brne L27
X8:
; #ifdef NUTDEBUG
;                     if (__chat_trf) {
;                         static prog_char dbgmsg[] = "' ABORT\n";
;                         fputs_P(dbgmsg, __chat_trs);
;                     }
; #endif
;                     return i + 4;
	mov R16,R14
	clr R17
	subi R16,252  ; offset = 4
	sbci R17,255
	xjmp L12
L26:
;                 }
;             } else
;                 m = (ch == ci->chat_abort[i][0]);
	ldi R24,2
	mul R24,R14
	movw R30,R0
	ldd R24,y+13
	ldd R25,y+14
	adiw R24,4
	add R30,R24
	adc R31,R25
	ldd R26,z+0
	ldd R27,z+1
	ld R2,x
	ldd R3,y+2
	cp R3,R2
	brne L30
X9:
	ldi R22,1
	ldi R23,0
	xjmp L31
L30:
	clr R22
	clr R23
L31:
	mov R20,R22
L27:
;             ci->chat_abomat[i] = m;
	ldd R24,y+13
	ldd R25,y+14
	adiw R24,24
	mov R30,R14
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R20
;         }
L23:
	inc R14
L25:
	ldd R30,y+13
	ldd R31,y+14
	ldd R2,z+3
	cp R14,R2
	brsh X21
	xjmp L22
X21:
X10:
; 
;         /*
;          * Check for report strings.
;          */
;         if (ci->chat_report_state > 0) {
	ldi R24,0
	ldd R2,z+37
	cp R24,R2
	brlo X22
	xjmp L32
X22:
X11:
;             m = ci->chat_repmat;
	ldd R20,z+36
;             if (ci->chat_report_state == 2) {
	ldd R24,z+37
	cpi R24,2
	brne L34
X12:
;                 chat_report[m++] = ch;
	mov R14,R20
	clr R15
	subi R20,255    ; addi 1
	lds R2,_chat_report
	lds R3,_chat_report+1
	mov R30,R14
	clr R31
	add R30,R2
	adc R31,R3
	ldd R2,y+2
	std z+0,R2
;             } else if (ch == ci->chat_report_search[m]) {
	xjmp L35
L34:
	ldd R30,y+13
	ldd R31,y+14
	ldd R2,z+34
	ldd R3,z+35
	mov R30,R20
	clr R31
	add R30,R2
	adc R31,R3
	ldd R2,z+0
	ldd R3,y+2
	cp R3,R2
	brne L36
X13:
;                 chat_report[m++] = ch;
	mov R14,R20
	clr R15
	subi R20,255    ; addi 1
	lds R2,_chat_report
	lds R3,_chat_report+1
	mov R30,R14
	clr R31
	add R30,R2
	adc R31,R3
	ldd R2,y+2
	std z+0,R2
;                 if (ci->chat_report_search[m] == 0) {
	ldd R30,y+13
	ldd R31,y+14
	ldd R2,z+34
	ldd R3,z+35
	mov R30,R20
	clr R31
	add R30,R2
	adc R31,R3
	ldd R2,z+0
	tst R2
	brne L37
X14:
;                     ci->chat_report_state = 2;
	ldi R24,2
	ldd R30,y+13
	ldd R31,y+14
	std z+37,R24
;                 }
;             } else {
	xjmp L37
L36:
;                 m = (ch == ci->chat_report_search[0]);
	ldd R30,y+13
	ldd R31,y+14
	ldd R26,z+34
	ldd R27,z+35
	ld R2,x
	ldd R3,y+2
	cp R3,R2
	brne L40
X15:
	ldi R24,1
	ldi R25,0
	movw R14,R24
	xjmp L41
L40:
	clr R14
	clr R15
L41:
	mov R20,R14
;             }
L37:
L35:
;             ci->chat_repmat = m;
	ldd R30,y+13
	ldd R31,y+14
	std z+36,R20
;         }
L32:
;     }
L14:
	movw R30,R10
	ldd R2,z+0
	tst R2
	breq X23
	xjmp L13
X23:
X16:
; 
;     /*
;      * Read the remainder of the string before NutChatSendString clears it
;      */
;     if (ci->chat_report_state == 2) {
	ldd R30,y+13
	ldd R31,y+14
	ldd R24,z+37
	cpi R24,2
	breq X24
	xjmp L42
X24:
X17:
;         m = ci->chat_repmat;    /* not needed... (but not nice to remove it) */
	ldd R20,z+36
	xjmp L45
L44:
;         while (m < CHAT_MAX_REPORT_SIZE) {
;             if (_read(ci->chat_fd, &ch, 1) != 1 || ch < ' ') {
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	movw R18,R28
	subi R18,254  ; offset = 2
	sbci R19,255
	ldd R30,y+13
	ldd R31,y+14
	ldd R16,z+0
	ldd R17,z+1
	xcall __read
	movw R10,R16
	cpi R16,1
	ldi R30,0
	cpc R17,R30
	brne L49
X18:
	ldd R24,y+2
	cpi R24,32
	brsh L47
X19:
L49:
;                 break;
	xjmp L46
L47:
;             }
;             chat_report[m++] = ch;
	mov R10,R20
	clr R11
	subi R20,255    ; addi 1
	lds R2,_chat_report
	lds R3,_chat_report+1
	mov R30,R10
	clr R31
	add R30,R2
	adc R31,R3
	ldd R2,y+2
	std z+0,R2
; 
; #ifdef NUTDEBUG
;             if (__chat_trf) {
;                 if (ch > 31 && ch < 127) {
;                     fputc(ch, __chat_trs);
;                 } else {
;                     fprintf(__chat_trs, "\\x%02X", ch);
;                 }
;             }
; #endif
;         }
L45:
	cpi R20,32
	brlo L44
X20:
L46:
;         ci->chat_report_state = 0;      /* Only find first occurence */
	clr R2
	ldd R30,y+13
	ldd R31,y+14
	std z+37,R2
;         chat_report[m] = 0;
	lds R2,_chat_report
	lds R3,_chat_report+1
	mov R30,R20
	clr R31
	add R30,R2
	adc R31,R3
	clr R2
	std z+0,R2
;     }
L42:
; #ifdef NUTDEBUG
;     if (__chat_trf) {
;         static prog_char dbgmsg[] = "'\n";
;         fputs_P(dbgmsg, __chat_trs);
;     }
; #endif
; 
;     return 0;
	clr R16
	clr R17
L12:
	.dbline 0 ; func end
	adiw R28,3
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
;            eol -> R22
;             rc -> R20,R21
;           skip -> R14
;             ch -> y+2
;            str -> R12,R13
;             fd -> y+13
	.even
_NutChatSendString:
	xcall push_arg4
	xcall push_xgsetF0FC
	movw R12,R18
	sbiw R28,3
; }
; 
; /*
;  * \return 0 on success or 2 in case of an I/O error.
;  */
; static int NutChatSendString(int fd, char *str)
; {
;     int rc = 0;
	clr R20
	clr R21
;     u_char eol = 1;
	ldi R22,1
;     u_char skip;
;     char ch;
; 
; #ifdef NUTDEBUG
;     if (__chat_trf) {
;         static prog_char dbgfmt[] = "Send '%s'\n";
;         fprintf_P(__chat_trs, dbgfmt, str);
;     }
; #endif
; 
;     /* Flush input buffer. */
;     _read(fd, 0, 0);
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	clr R18
	clr R19
	ldd R16,y+13
	ldd R17,y+14
	xcall __read
	xjmp L52
L51:
;     while (*str && eol && rc == 0) {
;         ch = *str++;
	movw R30,R12
	ld R2,Z+
	movw R12,R30
	std y+2,R2
;         skip = 0;
	clr R14
;         if (ch == '^') {
	mov R24,R2
	cpi R24,94
	brne L54
X25:
;             ch = *str++;
	ld R2,Z+
	movw R12,R30
	std y+2,R2
;             ch &= 0x1f;
	mov R24,R2
	andi R24,31
	std y+2,R24
;         } else if (ch == '\\') {
	xjmp L55
L54:
	ldd R24,y+2
	cpi R24,92
	breq X51
	xjmp L56
X51:
X26:
;             ch = *str++;
	movw R30,R12
	ld R2,Z+
	movw R12,R30
	std y+2,R2
;             switch (ch) {
	mov R10,R2
	clr R11
	movw R24,R10
	cpi R24,98
	ldi R30,0
	cpc R25,R30
	breq L61
X27:
	cpi R24,99
	ldi R30,0
	cpc R25,R30
	breq L62
X28:
	cpi R24,100
	ldi R30,0
	cpc R25,R30
	breq L63
X29:
	ldi R24,100
	cp R24,R10
	cpc R25,R11
	brlt L77
X30:
L76:
	movw R24,R10
	cpi R24,78
	ldi R30,0
	cpc R25,R30
	breq L65
X31:
	xjmp L58
L77:
	movw R24,R10
	cpi R24,110
	ldi R30,0
	cpc R25,R30
	breq L64
X32:
	cpi R24,112
	ldi R30,0
	cpc R25,R30
	breq L66
X33:
	cpi R24,114
	ldi R30,0
	cpc R25,R30
	breq L67
X34:
	cpi R24,115
	ldi R30,0
	cpc R25,R30
	breq L68
X35:
	cpi R24,116
	ldi R30,0
	cpc R25,R30
	breq L69
X36:
	xjmp L58
L61:
;             case 'b':
;                 ch = '\b';
	ldi R24,8
	std y+2,R24
;                 break;
	xjmp L59
L62:
;             case 'c':
;                 eol = 0;
	clr R22
;                 skip = 1;
	clr R14
	inc R14
;                 break;
	xjmp L59
L63:
;             case 'd':
;                 NutSleep(1000);
	ldi R16,232
	ldi R17,3
	ldi R18,0
	ldi R19,0
	xcall _NutSleep
;                 skip = 1;
	clr R14
	inc R14
;                 break;
	xjmp L59
L64:
;             case 'n':
;                 ch = '\n';
	ldi R24,10
	std y+2,R24
;                 break;
	xjmp L59
L65:
;             case 'N':
;                 ch = 0;
	clr R2
	std y+2,R2
;                 break;
	xjmp L59
L66:
;             case 'p':
;                 NutDelay(100);
	ldi R16,100
	xcall _NutDelay
;                 skip = 1;
	clr R14
	inc R14
;                 break;
	xjmp L59
L67:
;             case 'r':
;                 ch = '\r';
	ldi R24,13
	std y+2,R24
;                 break;
	xjmp L59
L68:
;             case 's':
;                 ch = ' ';
	ldi R24,32
	std y+2,R24
;                 break;
	xjmp L59
L69:
;             case 't':
;                 ch = '\t';
	ldi R24,9
	std y+2,R24
;                 break;
	xjmp L59
L58:
;             default:
;                 if (ch >= '0' && ch <= '7') {
	ldd R24,y+2
	cpi R24,48
	brlo L59
X37:
	ldi R24,55
	ldd R2,y+2
	cp R24,R2
	brlo L59
X38:
;                     ch &= 0x07;
	mov R24,R2
	andi R24,7
	std y+2,R24
;                     if (*str >= '0' && *str <= '7') {
	movw R30,R12
	ldd R2,z+0
	clr R3
	mov R24,R2
	cpi R24,48
	brlo L59
X39:
	ldi R24,55
	cp R24,R2
	brlo L59
X40:
;                         ch <<= 3;
	ldd R2,y+2
	lsl R2
	lsl R2
	lsl R2
	std y+2,R2
;                         ch |= *str++ & 0x07;
	ld R24,Z+
	movw R12,R30
	andi R24,7
	or R2,R24
	std y+2,R2
;                         if (*str >= '0' && *str <= '7') {
	ldd R2,z+0
	clr R3
	mov R24,R2
	cpi R24,48
	brlo L59
X41:
	ldi R24,55
	cp R24,R2
	brlo L59
X42:
;                             ch <<= 3;
	ldd R2,y+2
	lsl R2
	lsl R2
	lsl R2
	std y+2,R2
;                             ch |= *str++ & 0x07;
	ld R24,Z+
	movw R12,R30
	andi R24,7
	or R2,R24
	std y+2,R2
;                         }
;                     }
;                 }
;                 break;
L59:
;             }
;         }
L56:
L55:
;         if (skip)
	tst R14
	breq L78
X43:
;             skip = 0;
	clr R14
	xjmp L79
L78:
;         else {
;             NutDelay(10);
	ldi R16,10
	xcall _NutDelay
;             if (_write(fd, &ch, 1) != 1)
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	movw R18,R28
	subi R18,254  ; offset = 2
	sbci R19,255
	ldd R16,y+13
	ldd R17,y+14
	xcall __write
	movw R14,R16
	cpi R16,1
	ldi R30,0
	cpc R17,R30
	breq L80
X44:
;                 rc = 2;
	ldi R20,2
	ldi R21,0
	xjmp L81
L80:
;             else
;                 _write(fd, 0, 0);
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	clr R18
	clr R19
	ldd R16,y+13
	ldd R17,y+14
	xcall __write
L81:
;         }
L79:
;     }
L52:
	movw R30,R12
	ldd R2,z+0
	tst R2
	breq L83
X45:
	tst R22
	breq L83
X46:
	cpi R20,0
	cpc R20,R21
	brne X52
	xjmp L51
X52:
X47:
L83:
;     if (eol && rc == 0 && _write(fd, "\r", 1) != 1)
	tst R22
	breq L84
X48:
	cpi R20,0
	cpc R20,R21
	brne L84
X49:
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<L86
	ldi R19,>L86
	ldd R16,y+13
	ldd R17,y+14
	xcall __write
	movw R22,R16
	cpi R16,1
	ldi R30,0
	cpc R17,R30
	breq L84
X50:
;         rc = 2;
	ldi R20,2
	ldi R21,0
	xjmp L85
L84:
;     else
;         _write(fd, 0, 0);
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	clr R18
	clr R19
	ldd R16,y+13
	ldd R17,y+14
	xcall __write
L85:
; 
;     return rc;
	movw R16,R20
L50:
	.dbline 0 ; func end
	adiw R28,3
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
;             rc -> R10,R11
;      subexpect -> R14,R15
;          reply -> R22,R23
;            str -> R12,R13
;             ci -> y+10
	.even
_NutChatExpect::
	xcall push_arg4
	xcall push_xgsetF0FC
	movw R12,R18
; }
; 
; /*
;  * \param ci Pointer to a NUTCHAT structure, which must have been 
;  *           created by NutChatCreate().
;  *
;  * \return 0 on success, 1 in case of invalid parameters, 2 in case
;  *         of an I/O error, 3 in case of a timeout error while waiting
;  *         for an expected string, or the index of an abort string plus
;  *         4, if one has been received. 
;  */
; int NutChatExpect(NUTCHAT * ci, char *str)
; {
;     int rc = 0;
	clr R10
	clr R11
;     char *reply;
;     char *subexpect;
; 
;     /*
;      * Process special keywords.
;      */
;     if (strcmp(str, "ABORT") == 0) {
	ldi R18,<L90
	ldi R19,>L90
	movw R16,R12
	xcall _strcmp
	cpi R16,0
	cpc R16,R17
	brne L88
X53:
;         ci->chat_arg = CHAT_ARG_ABORT;
	ldi R24,1
	ldd R30,y+10
	ldd R31,y+11
	std z+2,R24
;         return 0;
	clr R16
	clr R17
	xjmp L87
L88:
;     }
;     if (strcmp(str, "TIMEOUT") == 0) {
	ldi R18,<L93
	ldi R19,>L93
	movw R16,R12
	xcall _strcmp
	cpi R16,0
	cpc R16,R17
	brne L91
X54:
;         ci->chat_arg = CHAT_ARG_TIMEOUT;
	ldi R24,2
	ldd R30,y+10
	ldd R31,y+11
	std z+2,R24
;         return 0;
	clr R16
	clr R17
	xjmp L87
L91:
;     }
;     if (strcmp(str, "REPORT") == 0) {
	ldi R18,<L96
	ldi R19,>L96
	movw R16,R12
	xcall _strcmp
	movw R14,R16
	cpi R16,0
	cpc R16,R17
	breq X62
	xjmp L98
X62:
X55:
;         ci->chat_repmat = 0;    /* not needed ??? */
	clr R2
	ldd R30,y+10
	ldd R31,y+11
	std z+36,R2
;         ci->chat_report_state = 1;
	ldi R24,1
	std z+37,R24
;         ci->chat_arg = CHAT_ARG_REPORT;
	ldi R24,3
	std z+2,R24
;         return 0;
	clr R16
	clr R17
	xjmp L87
L97:
;     }
; 
;     /*
;      * Process expected string.
;      */
;     while (str) {
;         if ((reply = strechr(str, '-')) != 0) {
	ldi R18,45
	ldi R19,0
	movw R16,R12
	xcall _strechr
	movw R14,R16
	movw R22,R14
	cpi R16,0
	cpc R16,R17
	breq L100
X56:
;             *reply++ = 0;
	clr R2
	movw R30,R22
	st Z+,R2
	movw R22,R30
;             if ((subexpect = strechr(reply, '-')) != 0)
	ldi R18,45
	ldi R19,0
	movw R16,R30
	xcall _strechr
	movw R20,R16
	movw R14,R20
	cpi R16,0
	cpc R16,R17
	breq L101
X57:
;                 *subexpect++ = 0;
	clr R2
	movw R30,R14
	st Z+,R2
	movw R14,R30
;         } else
	xjmp L101
L100:
;             subexpect = 0;
	clr R14
	clr R15
L101:
; 
;         if ((rc = NutChatExpectString(ci, str)) != 3 || reply == 0)
	movw R18,R12
	ldd R16,y+10
	ldd R17,y+11
	xcall _NutChatExpectString
	movw R20,R16
	movw R10,R20
	cpi R16,3
	ldi R30,0
	cpc R17,R30
	brne L106
X58:
	cpi R22,0
	cpc R22,R23
	brne L104
X59:
L106:
;             break;
	xjmp L99
L104:
;         if ((rc = NutChatSendString(ci->chat_fd, reply)) != 0)
	movw R18,R22
	ldd R30,y+10
	ldd R31,y+11
	ldd R16,z+0
	ldd R17,z+1
	xcall _NutChatSendString
	movw R22,R16
	movw R10,R22
	cpi R16,0
	cpc R16,R17
	breq L107
X60:
;             break;
	xjmp L99
L107:
;         str = subexpect;
	movw R12,R14
;     }
L98:
	tst R12
	breq X63
	xjmp L97
X63:
	tst R13
	breq X64
	xjmp L97
X64:
X61:
L99:
;     return rc;
	movw R16,R10
L87:
	.dbline 0 ; func end
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
;             lv -> y+2
;             cp -> R12,R13
;             ch -> R22
;            str -> R10,R11
;             ci -> R20,R21
	.even
_NutChatSend::
	xcall push_xgsetF0FC
	movw R10,R18
	movw R20,R16
	sbiw R28,6
; }
; 
; /*!
;  * \brief Process a chat send argument.
;  *
;  * \param ci  Pointer to a NUTCHAT structure, which must have been 
;  *            created by NutChatCreate().
;  * \param str String containing the chat send argument.
;  *
;  * \return 0 on success, 1 in case of invalid parameters, 2 in case
;  *         of an I/O error, 3 in case of a timeout error while waiting
;  *         for an expected string, or the index of an abort string plus
;  *         4, if one has been received. 
;  */
; int NutChatSend(NUTCHAT * ci, char *str)
; {
;     char *cp;
;     char ch;
;     long lv;
; 
;     /*
;      * Add a chat abort string.
;      */
;     if (ci->chat_arg == CHAT_ARG_ABORT) {
	movw R30,R20
	ldd R24,z+2
	cpi R24,1
	breq X87
	xjmp L110
X87:
X65:
;         ci->chat_arg = CHAT_ARG_SEND;
	clr R2
	std z+2,R2
; 
;         if (ci->chat_aborts >= CHAT_MAX_ABORTS)
	ldd R24,z+3
	cpi R24,10
	brlo L112
X66:
;             return 1;
	ldi R16,1
	ldi R17,0
	xjmp L109
L112:
;         cp = malloc(strlen(str) + 1);
	movw R16,R10
	xcall _strlen
	subi R16,255  ; offset = 1
	sbci R17,255
	xcall _malloc_M
	movw R12,R16
;         ci->chat_abort[ci->chat_aborts++] = cp;
	movw R24,R20
	adiw R24,3
	movw R14,R24
	movw R30,R24
	ldd R22,z+0
	mov R24,R22
	subi R24,255    ; addi 1
	std z+0,R24
	ldi R24,2
	mul R24,R22
	movw R30,R0
	movw R24,R20
	adiw R24,4
	add R30,R24
	adc R31,R25
	std z+1,R13
	std z+0,R12
	xjmp L115
L114:
;         while (*str) {
;             ch = *str++;
	movw R30,R10
	ld R22,Z+
	movw R10,R30
;             if (ch == '^')
	cpi R22,94
	brne L117
X67:
;                 *cp = *str++ & 0x1f;
	ld R24,Z+
	movw R10,R30
	andi R24,31
	movw R30,R12
	std z+0,R24
	xjmp L118
L117:
;             else if (ch == '\\') {
	cpi R22,92
	breq X88
	xjmp L119
X88:
X68:
;                 ch = *str++;
	movw R30,R10
	ld R22,Z+
	movw R10,R30
;                 switch (ch) {
	mov R14,R22
	clr R15
	movw R24,R14
	cpi R24,98
	ldi R30,0
	cpc R25,R30
	breq L124
X69:
	cpi R24,98
	ldi R30,0
	cpc R25,R30
	brge X89
	xjmp L121
X89:
X70:
L137:
	movw R24,R14
	cpi R24,110
	ldi R30,0
	cpc R25,R30
	breq L125
X71:
	cpi R24,114
	ldi R30,0
	cpc R25,R30
	breq L126
X72:
	cpi R24,115
	ldi R30,0
	cpc R25,R30
	breq L127
X73:
	cpi R24,116
	ldi R30,0
	cpc R25,R30
	breq L128
X74:
	xjmp L121
L124:
;                 case 'b':
;                     *cp++ = '\b';
	ldi R24,8
	movw R30,R12
	st Z+,R24
	movw R12,R30
;                     break;
	xjmp L120
L125:
;                 case 'n':
;                     *cp++ = '\n';
	ldi R24,10
	movw R30,R12
	st Z+,R24
	movw R12,R30
;                     break;
	xjmp L120
L126:
;                 case 'r':
;                     *cp++ = '\r';
	ldi R24,13
	movw R30,R12
	st Z+,R24
	movw R12,R30
;                     break;
	xjmp L120
L127:
;                 case 's':
;                     *cp++ = ' ';
	ldi R24,32
	movw R30,R12
	st Z+,R24
	movw R12,R30
;                     break;
	xjmp L120
L128:
;                 case 't':
;                     *cp++ = '\t';
	ldi R24,9
	movw R30,R12
	st Z+,R24
	movw R12,R30
;                     break;
	xjmp L120
L121:
;                 default:
;                     if (ch >= '0' && ch <= '7') {
	cpi R22,48
	brlo L129
X75:
	ldi R24,55
	cp R24,R22
	brlo L129
X76:
;                         ch &= 0x07;
	andi R22,7
;                         if (*str >= '0' && *str <= '7') {
	movw R30,R10
	ldd R14,z+0
	clr R15
	mov R24,R14
	cpi R24,48
	brlo L131
X77:
	ldi R24,55
	cp R24,R14
	brlo L131
X78:
;                             ch <<= 3;
	lsl R22
	lsl R22
	lsl R22
;                             ch |= *str++ & 0x07;
	ld R24,Z+
	movw R10,R30
	andi R24,7
	or R22,R24
;                             if (*str >= '0' && *str <= '7') {
	ldd R14,z+0
	clr R15
	mov R24,R14
	cpi R24,48
	brlo L133
X79:
	ldi R24,55
	cp R24,R14
	brlo L133
X80:
;                                 ch <<= 3;
	lsl R22
	lsl R22
	lsl R22
;                                 ch |= *str++ & 0x07;
	ld R24,Z+
	movw R10,R30
	andi R24,7
	or R22,R24
;                             }
L133:
;                         }
L131:
;                     }
L129:
;                     if (ch)
	tst R22
	breq L120
X81:
;                         *cp++ = ch;
	movw R30,R12
	st Z+,R22
	movw R12,R30
;                     break;
;                 }
;             } else
	xjmp L120
L119:
;                 *cp++ = ch;
	movw R30,R12
	st Z+,R22
	movw R12,R30
L120:
L118:
;         }
L115:
	movw R30,R10
	ldd R2,z+0
	tst R2
	breq X90
	xjmp L114
X90:
X82:
;         *cp = 0;
	clr R2
	movw R30,R12
	std z+0,R2
;         return 0;
	clr R16
	clr R17
	xjmp L109
L110:
;     }
; 
;     /*
;      * Set chat timeout.
;      */
;     if (ci->chat_arg == CHAT_ARG_TIMEOUT) {
	movw R30,R20
	ldd R24,z+2
	cpi R24,2
	breq X91
	xjmp L138
X91:
X83:
;         ci->chat_arg = CHAT_ARG_SEND;
	clr R2
	std z+2,R2
; 
;         lv = atol(str) * 1000L;
	movw R16,R10
	xcall _atol
	ldi R24,232
	ldi R25,3
	ldi R26,0
	ldi R27,0
	st -y,R19
	st -y,R18
	st -y,R17
	st -y,R16
	movw R16,R24
	movw R18,R26
	xcall empy32s
	std y+2,R16
	std y+3,R17
	std y+4,R18
	std y+5,R19
;         if (lv <= 0)
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	ldd R2,y+2
	ldd R3,y+3
	ldd R4,y+4
	ldd R5,y+5
	cp R24,R2
	cpc R25,R3
	cpc R26,R4
	cpc R27,R5
	brlt L140
X84:
;             lv = CHAT_DEFAULT_TIMEOUT;
	ldi R24,45
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+2,R24
	std y+3,R25
	std y+4,R26
	std y+5,R27
L140:
; 
;         _ioctl(ci->chat_fd, UART_SETREADTIMEOUT, &lv);
	movw R24,R28
	adiw R24,2
	std y+1,R25
	std y+0,R24
	ldi R18,267
	ldi R19,1
	movw R30,R20
	ldd R16,z+0
	ldd R17,z+1
	xcall __ioctl
; 
;         return 0;
	clr R16
	clr R17
	xjmp L109
L138:
;     }
; 
;     /*
;      * Set report string
;      */
;     if (ci->chat_arg == CHAT_ARG_REPORT) {
	movw R30,R20
	ldd R24,z+2
	cpi R24,3
	breq X92
	xjmp L142
X92:
X85:
;         ci->chat_arg = CHAT_ARG_SEND;
	clr R2
	std z+2,R2
;         chat_report = malloc(CHAT_MAX_REPORT_SIZE + 1);
	ldi R16,33
	ldi R17,0
	xcall _malloc_M
	movw R14,R16
	sts _chat_report+1,R15
	sts _chat_report,R14
;         cp = malloc(strlen(str) + 1);
	movw R16,R10
	xcall _strlen
	movw R22,R16
	subi R16,255  ; offset = 1
	sbci R17,255
	xcall _malloc_M
	movw R14,R16
	movw R12,R14
;         ci->chat_report_search = cp;
	movw R30,R20
	std z+35,R13
	std z+34,R12
	xjmp L145
L144:
;         while (*str)
;             *cp++ = *str++;     /* Do it the easy way, not as smart and thorough as the abort string... */
	movw R30,R10
	movw R26,R12
	ld R0,Z+
	movw R10,R30
	st X+,R0
	movw R12,R26
L145:
	movw R30,R10
	ldd R2,z+0
	tst R2
	brne L144
X86:
;         *cp = 0;
	clr R2
	movw R30,R12
	std z+0,R2
; 
;         return 0;
	clr R16
	clr R17
	xjmp L109
L142:
;     }
; 
;     /*
;      * Send the argument string.
;      */
;     return NutChatSendString(ci->chat_fd, str);
	movw R18,R10
	movw R30,R20
	ldd R16,z+0
	ldd R17,z+1
	xcall _NutChatSendString
	movw R10,R16
L109:
	.dbline 0 ; func end
	adiw R28,6
	xjmp pop_xgsetF0FC
;             ci -> R10,R11
;             fd -> R12,R13
	.even
_NutChatCreate::
	xcall push_xgset003C
	movw R12,R16
	sbiw R28,2
; }
; 
; 
; /*!
;  * \brief Create a NUTCHAT structure.
;  *
;  * \return Pointer to a new NUTCHAT structure.
;  */
; NUTCHAT *NutChatCreate(int fd)
; {
;     NUTCHAT *ci;
; 
;     if ((ci = malloc(sizeof(NUTCHAT))) != 0) {
	ldi R16,38
	ldi R17,0
	xcall _malloc_M
	movw R10,R16
	tst R10
	brne X93
	tst R11
	breq L148
X93:
;         memset(ci, 0, sizeof(NUTCHAT));
	ldi R24,38
	ldi R25,0
	std y+1,R25
	std y+0,R24
	clr R18
	clr R19
	xcall _memset
;         ci->chat_fd = fd;
	movw R30,R10
	std z+1,R13
	std z+0,R12
;     }
L148:
;     return ci;
	movw R16,R10
L147:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgset003C
;              i -> R10
;             ci -> R20,R21
	.even
_NutChatDestroy::
	xcall push_xgset300C
	movw R20,R16
; }
; 
; /*!
;  * \brief Destroy a previously created NUTCHAT structure.
;  *
;  * \param ci Pointer to a NUTCHAT structure, which must have been 
;  *           created by NutChatCreate().
;  */
; void NutChatDestroy(NUTCHAT * ci)
; {
;     u_char i;
; 
;     if (ci) {
	cpi R20,0
	cpc R20,R21
	breq L151
X94:
;         for (i = 0; i < ci->chat_aborts; i++)
	clr R10
	xjmp L156
L153:
;             free(ci->chat_abort[i]);
	ldi R24,2
	mul R24,R10
	movw R30,R0
	movw R24,R20
	adiw R24,4
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	ldd R17,z+1
	xcall _free_M
L154:
	inc R10
L156:
	movw R30,R20
	ldd R2,z+3
	cp R10,R2
	brlo L153
X95:
;         free(ci);
	movw R16,R30
	xcall _free_M
;     }
L151:
L150:
	.dbline 0 ; func end
	xjmp pop_xgset300C
;          quote -> R22
;           iwto -> y+10
;           irto -> y+6
;             to -> y+2
;             ci -> R10,R11
;            arg -> R12,R13
;        sendflg -> R14
;             rc -> R20,R21
;         script -> y+26
;             fd -> y+24
	.even
_NutChatProc:
	xcall push_arg4
	xcall push_xgsetF0FC
	sbiw R28,14
; }
; 
; /*!
;  * \brief Chat processor.
;  *
;  * \return 0 on success, 1 in case of invalid parameters, 2 in case
;  *         of an I/O error, 3 in case of a timeout error while waiting
;  *         for an expected string, or the index of an abort string plus
;  *         4, if one has been received. 
;  */
; static int NutChatProc(int fd, char *script)
; {
;     int rc = 0;
	clr R20
	clr R21
;     char sendflg = 0;
	clr R14
;     NUTCHAT *ci;
;     char *arg;
;     u_long to;
;     u_long irto;
;     u_long iwto;
; 
;     /*
;      * Initialize the chat info structure.
;      */
;     if ((ci = NutChatCreate(fd)) == 0)
	ldd R16,y+24
	ldd R17,y+25
	xcall _NutChatCreate
	movw R10,R16
	tst R10
	brne L158
	tst R11
	brne L158
X96:
;         return 2;
	ldi R16,2
	ldi R17,0
	xjmp L157
L158:
; 
;     /*
;      * Save current and set default timeouts.
;      */
;     _ioctl(fd, UART_GETREADTIMEOUT, &irto);
	movw R24,R28
	adiw R24,6
	std y+1,R25
	std y+0,R24
	ldi R18,268
	ldi R19,1
	ldd R16,y+24
	ldd R17,y+25
	xcall __ioctl
;     _ioctl(fd, UART_GETWRITETIMEOUT, &iwto);
	movw R24,R28
	adiw R24,10
	std y+1,R25
	std y+0,R24
	ldi R18,270
	ldi R19,1
	ldd R16,y+24
	ldd R17,y+25
	xcall __ioctl
;     to = 45000;
	ldi R24,200
	ldi R25,175
	ldi R26,0
	ldi R27,0
	std y+2,R24
	std y+3,R25
	std y+4,R26
	std y+5,R27
;     _ioctl(fd, UART_SETREADTIMEOUT, &to);
	movw R24,R28
	adiw R24,2
	std y+1,R25
	std y+0,R24
	ldi R18,267
	ldi R19,1
	ldd R16,y+24
	ldd R17,y+25
	xcall __ioctl
;     to = 5000;
	ldi R24,136
	ldi R25,19
	ldi R26,0
	ldi R27,0
	std y+2,R24
	std y+3,R25
	std y+4,R26
	std y+5,R27
;     _ioctl(fd, UART_SETWRITETIMEOUT, &to);
	movw R24,R28
	adiw R24,2
	std y+1,R25
	std y+0,R24
	ldi R18,269
	ldi R19,1
	ldd R16,y+24
	ldd R17,y+25
	xcall __ioctl
	xjmp L161
L160:
; 
;     /*
;      * This loop splits up the chat string into arguments and 
;      * alternating calls NutChatSend and NutChatExpect.
;      */
;     while (*script && rc == 0) {
; 
;         /*
;          * Skip leading spaces.
;          */
;         if (*script == ' ' || *script == '\t' || *script == '\r' || *script == '\n') {
	ldd R30,y+26
	ldd R31,y+27
	ldd R2,z+0
	clr R3
	mov R24,R2
	cpi R24,32
	breq L167
X97:
	cpi R24,9
	breq L167
X98:
	cpi R24,13
	breq L167
X99:
	cpi R24,10
	brne L163
X100:
L167:
;             script++;
	ldd R24,y+26
	ldd R25,y+27
	adiw R24,1
	std y+27,R25
	std y+26,R24
;             continue;
	xjmp L161
L163:
;         }
; 
;         /*
;          * Collect a quoted argument.
;          */
;         if (*script == '"' || *script == '\'') {
	ldd R30,y+26
	ldd R31,y+27
	ldd R22,z+0
	clr R23
	cpi R22,34
	breq L170
X101:
	cpi R22,39
	brne L168
X102:
L170:
;             char quote = *script++;
	ldd R30,y+26
	ldd R31,y+27
	ld R22,Z+
	std y+27,R31
	std y+26,R30
; 
;             arg = script;
	movw R12,R30
	xjmp L172
L171:
;             while (*script != quote) {
;                 if (*script == 0) {
	ldd R30,y+26
	ldd R31,y+27
	ldd R2,z+0
	tst R2
	brne L174
X103:
;                     rc = 1;
	ldi R20,1
	ldi R21,0
;                     break;
	xjmp L169
L174:
;                 }
;                 if (*script++ == '\\') {
	ldd R30,y+26
	ldd R31,y+27
	ld R24,Z+
	std y+27,R31
	std y+26,R30
	cpi R24,92
	brne L176
X104:
;                     if (*script)
	ldd R2,z+0
	tst R2
	breq L178
X105:
;                         ++script;
	movw R24,R30
	adiw R24,1
	std y+27,R25
	std y+26,R24
L178:
;                 }
L176:
;             }
L172:
	ldd R30,y+26
	ldd R31,y+27
	ldd R2,z+0
	cp R2,R22
	brne L171
X106:
;         }
	xjmp L169
L168:
; 
;         /*
;          * Collect an argument upto the next space.
;          */
;         else {
;             arg = script;
	ldd R12,y+26
	ldd R13,y+27
	xjmp L181
L180:
;             while (*script && *script != ' ' && *script != '\t' && *script != '\r' && *script != '\n')
;                 ++script;
	ldd R24,y+26
	ldd R25,y+27
	adiw R24,1
	std y+27,R25
	std y+26,R24
L181:
	ldd R30,y+26
	ldd R31,y+27
	ldd R22,z+0
	clr R23
	tst R22
	breq L186
X107:
	cpi R22,32
	breq L186
X108:
	cpi R22,9
	breq L186
X109:
	cpi R22,13
	breq L186
X110:
	cpi R22,10
	brne L180
X111:
L186:
;         }
L169:
; 
;         if (*script)
	ldd R30,y+26
	ldd R31,y+27
	ldd R2,z+0
	tst R2
	breq L187
X112:
;             *script++ = 0;
	clr R2
	st Z+,R2
	std y+27,R31
	std y+26,R30
L187:
; 
;         /*
;          * Either send or expect the collected argument.
;          */
;         if (rc == 0) {
	cpi R20,0
	cpc R20,R21
	brne L189
X113:
;             if (sendflg)
	tst R14
	breq L191
X114:
;                 rc = NutChatSend(ci, arg);
	movw R18,R12
	movw R16,R10
	xcall _NutChatSend
	movw R22,R16
	movw R20,R22
	xjmp L192
L191:
;             else
;                 rc = NutChatExpect(ci, arg);
	movw R18,R12
	movw R16,R10
	xcall _NutChatExpect
	movw R12,R16
	movw R20,R12
L192:
;             sendflg = !sendflg;
	tst R14
	brne L193
X115:
	ldi R24,1
	ldi R25,0
	movw R12,R24
	xjmp L194
L193:
	clr R12
	clr R13
L194:
	mov R14,R12
;         }
L189:
;     }
L161:
	ldd R30,y+26
	ldd R31,y+27
	ldd R2,z+0
	tst R2
	breq L195
X116:
	cpi R20,0
	cpc R20,R21
	brne X118
	xjmp L160
X118:
X117:
L195:
; 
;     /*
;      * Restore initial timeout values.
;      */
;     _ioctl(fd, UART_SETREADTIMEOUT, &irto);
	movw R24,R28
	adiw R24,6
	std y+1,R25
	std y+0,R24
	ldi R18,267
	ldi R19,1
	ldd R16,y+24
	ldd R17,y+25
	xcall __ioctl
;     _ioctl(fd, UART_SETWRITETIMEOUT, &iwto);
	movw R24,R28
	adiw R24,10
	std y+1,R25
	std y+0,R24
	ldi R18,269
	ldi R19,1
	ldd R16,y+24
	ldd R17,y+25
	xcall __ioctl
; 
;     /*
;      * Release allocated memory.
;      */
;     NutChatDestroy(ci);
	movw R16,R10
	xcall _NutChatDestroy
; 
;     return rc;
	movw R16,R20
L157:
	.dbline 0 ; func end
	adiw R28,14
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
;            buf -> R10,R11
;             rc -> R20,R21
;         script -> R14,R15
;             fd -> R12,R13
	.even
_NutChat::
	xcall push_xgset30FC
	movw R14,R18
	movw R12,R16
; }
; 
; /*!
;  * \brief Execute a conversational exchange with a serial device.
;  *
;  * Its primary purpose is to establish a modem connection.
;  *
;  * \param fd Descriptor of a previously opened device.
;  * \param script Pointer to a string containing the chat script.
;  *
;  * \return 0 on success, 1 in case of invalid parameters, 2 in case
;  *         of an I/O error, 3 in case of a timeout error while waiting
;  *         for an expected string, or the index of an abort string plus
;  *         4, if one has been received. 
;  */
; int NutChat(int fd, CONST char *script)
; {
;     int rc = -1;
	ldi R20,-1
	ldi R21,-1
;     char *buf;
; 
;     /*
;      * Work with a local copy of the chat string.
;      */
;     if ((buf = malloc(strlen(script) + 1)) != 0) {
	movw R16,R14
	xcall _strlen
	subi R16,255  ; offset = 1
	sbci R17,255
	xcall _malloc_M
	movw R10,R16
	tst R10
	brne X119
	tst R11
	breq L197
X119:
;         strcpy(buf, script);
	movw R18,R14
	xcall _strcpy
;         rc = NutChatProc(fd, buf);
	movw R18,R10
	movw R16,R12
	xcall _NutChatProc
	movw R12,R16
	movw R20,R12
;         free(buf);
	movw R16,R10
	xcall _free_M
;     }
L197:
;     return rc;
	movw R16,R20
L196:
	.dbline 0 ; func end
	xjmp pop_xgset30FC
;            buf -> R10,R11
;             rc -> R20,R21
;         script -> R14,R15
;             fd -> R12,R13
	.even
_NutChat_P::
	xcall push_xgset30FC
	movw R14,R18
	movw R12,R16
; }
; 
; /*!
;  * \brief Execute a conversational exchange with a serial device.
;  *
;  * Similar to NutChat() except that the chat string is located in
;  * program memory.
;  *
;  * \return 0 on success, 1 in case of invalid parameters, 2 in case
;  *         of an I/O error, 3 in case of a timeout error while waiting
;  *         for an expected string, or the index of an abort string plus
;  *         4, if one has been received. 
;  */
; #ifdef __HARVARD_ARCH__
; int NutChat_P(int fd, PGM_P script)
; {
;     int rc = -1;
	ldi R20,-1
	ldi R21,-1
;     char *buf;
; 
;     /*
;      * Work with a local copy of the chat string.
;      */
;     if ((buf = malloc(strlen_P(script) + 1)) != 0) {
	movw R16,R14
	xcall _cstrlen
	subi R16,255  ; offset = 1
	sbci R17,255
	xcall _malloc_M
	movw R10,R16
	tst R10
	brne X120
	tst R11
	breq L200
X120:
;         strcpy_P(buf, script);
	movw R18,R14
	xcall _cstrcpy
;         rc = NutChatProc(fd, buf);
	movw R18,R10
	movw R16,R12
	xcall _NutChatProc
	movw R12,R16
	movw R20,R12
;         free(buf);
	movw R16,R10
	xcall _free_M
;     }
L200:
;     return rc;
	movw R16,R20
L199:
	.dbline 0 ; func end
	xjmp pop_xgset30FC
	.area bss(ram, con, rel)
_chat_report::
	.blkb 2
	.area data(ram, con, rel)
L96:
	.blkb 7
	.area idata
	.byte 'R,'E,'P,'O,'R,'T,0
	.area data(ram, con, rel)
L93:
	.blkb 8
	.area idata
	.byte 'T,'I,'M,'E,'O,'U,'T,0
	.area data(ram, con, rel)
L90:
	.blkb 6
	.area idata
	.byte 'A,'B,'O,'R,'T,0
	.area data(ram, con, rel)
L86:
	.blkb 2
	.area idata
	.byte 13,0
	.area data(ram, con, rel)
; }
; #endif
