	.module ihndlr.c
	.area text(rom, con, rel)
;            irh -> R20,R21
	.even
_CallHandler::
	st -y,R20
	st -y,R21
	movw R20,R16
; /*
;  * Copyright (C) 2001-2005 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  */
; 
; /*
;  * $Log: ihndlr.c,v $
;  * Revision 1.4.2.1  2006/02/02 14:00:02  haraldkipp
;  * NutIrqSetPriority() didn't correctly return the previous priority. This
;  * bug has been fixed.
;  *
;  * Revision 1.4  2005/10/24 10:17:24  haraldkipp
;  * New API functions added to create platform independant drivers.
;  * Interrupt counting requires NUT_PERFMON to be defined.
;  *
;  * Revision 1.3  2005/08/02 17:46:47  haraldkipp
;  * Major API documentation update.
;  *
;  * Revision 1.2  2005/07/26 16:30:58  haraldkipp
;  * Copyright added.
;  * Temporarily exclude NutRegisterIrqHandler() from Linux builds.
;  *
;  */
; 
; #include <sys/atom.h>
; #include <dev/irqreg.h>
; 
; /*!
;  * \addtogroup xgInterrupt
;  */
; /*@{*/
; 
; /*!
;  * \brief Call a registered interrupt handler.
;  */
; void CallHandler(IRQ_HANDLER * irh)
; {
; #ifdef NUT_PERFMON
;     irh->ir_count++;
; #endif
;     if (irh->ir_handler)
	movw R30,R20
	ldd R2,z+2
	ldd R3,z+3
	tst R2
	brne X0
	tst R3
	breq L3
X0:
;         (irh->ir_handler) (irh->ir_arg);
	ldd R16,z+0
	ldd R17,z+1
	ldd R26,z+2
	ldd R27,z+3
	movw R30,R26
	xcall  xicall
L3:
L2:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
;             rc -> R10,R11
;            arg -> y+6
;        handler -> R12,R13
;            irq -> R20,R21
	.even
_NutRegisterIrqHandler::
	xcall push_xgset303C
	movw R12,R18
	movw R20,R16
; }
; 
; /*!
;  * \brief Register an interrupt handler.
;  *
;  * This function is typically called by device drivers, but
;  * applications may also implement their local interrupt
;  * handlers.
;  *
;  * \param irq     Interrupt to be associated with this handler.
;  * \param handler This routine will be called by Nut/OS, when the 
;  *                specified interrupt occurs.
;  * \param arg     Argument to be passed to the interrupt handler.
;  *
;  * \return 0 on success, -1 otherwise.
;  */
; #if !defined (__linux__) && !defined(__APPLE__) && !defined(__CYGWIN__)
; int NutRegisterIrqHandler(IRQ_HANDLER * irq, void (*handler) (void *), void *arg)
; {
;     int rc = 0;
	clr R10
	clr R11
; 
;     /* Initialize this interrupt. */
;     if (irq->ir_ctl) {
	movw R30,R20
	ldd R2,z+4
	ldd R3,z+5
	tst R2
	brne X1
	tst R3
	breq L6
X1:
;         rc = (irq->ir_ctl) (NUT_IRQCTL_INIT, NULL);
	clr R18
	clr R19
	clr R16
	clr R17
	ldd R26,z+4
	ldd R27,z+5
	movw R30,R26
	xcall  xicall
	movw R10,R16
;     }
L6:
; 
;     /* Set the interrupt handler. */
;     irq->ir_arg = arg;
	movw R30,R20
	ldd R0,y+6
	ldd R1,y+7
	std z+1,R1
	std z+0,R0
;     irq->ir_handler = handler;
	std z+3,R13
	std z+2,R12
; 
;     return rc;
	movw R16,R10
L5:
	.dbline 0 ; func end
	xjmp pop_xgset303C
;             rc -> R20,R21
;            irq -> R22,R23
	.even
_NutIrqEnable::
	xcall push_xgsetF000
	movw R22,R16
; }
; 
; /*!
;  * \brief Enable a specified interrupt.
;  *
;  * \param irq Interrupt to enable.
;  *
;  * \return 0 on success, -1 otherwise.
;  */
; int NutIrqEnable(IRQ_HANDLER * irq)
; {
;     int rc = -1;
	ldi R20,-1
	ldi R21,-1
; 
;     if (irq->ir_ctl) {
	movw R30,R22
	ldd R2,z+4
	ldd R3,z+5
	tst R2
	brne X2
	tst R3
	breq L9
X2:
;         rc = (irq->ir_ctl) (NUT_IRQCTL_ENABLE, NULL);
	clr R18
	clr R19
	ldi R16,17
	ldi R17,0
	ldd R26,z+4
	ldd R27,z+5
	movw R30,R26
	xcall  xicall
	movw R20,R16
;     }
L9:
;     return rc;
	movw R16,R20
L8:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
;             rc -> R20,R21
;            irq -> R22,R23
	.even
_NutIrqDisable::
	xcall push_xgsetF000
	movw R22,R16
; }
; 
; /*!
;  * \brief Disable a specified interrupt.
;  *
;  * \param irq Interrupt to disable.
;  *
;  * \return 0 on success, -1 otherwise.
;  */
; int NutIrqDisable(IRQ_HANDLER * irq)
; {
;     int rc = -1;
	ldi R20,-1
	ldi R21,-1
; 
;     if (irq->ir_ctl) {
	movw R30,R22
	ldd R2,z+4
	ldd R3,z+5
	tst R2
	brne X3
	tst R3
	breq L12
X3:
;         rc = (irq->ir_ctl) (NUT_IRQCTL_DISABLE, NULL);
	clr R18
	clr R19
	ldi R16,18
	ldi R17,0
	ldd R26,z+4
	ldd R27,z+5
	movw R30,R26
	xcall  xicall
	movw R20,R16
;     }
L12:
;     return rc;
	movw R16,R20
L11:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
;           prev -> y+0
;             rc -> R20,R21
;          level -> y+6
;            irq -> R22,R23
	.even
_NutIrqSetPriority::
	st -y,r19
	st -y,r18
	xcall push_xgsetF000
	movw R22,R16
	sbiw R28,2
; }
; 
; /*!
;  * \brief Modify the priority level of an interrupt.
;  *
;  * The function returns the old priority, which makes it easy to 
;  * temporarily switch to another priority and later set back the 
;  * old one.
;  *
;  * \note Not all targets support dynamic interrupt prioritization.
;  *       Check the hardware data sheet for valid levels.
;  *
;  * \param irq   Interrupt to modify.
;  * \param level New priority level.
;  *
;  * \return Old priority level or -1 in case of an error.
;  */
; int NutIrqSetPriority(IRQ_HANDLER * irq, int level)
; {
;     int rc = -1;
	ldi R20,-1
	ldi R21,-1
; 
;     if (irq->ir_ctl) {
	movw R30,R22
	ldd R2,z+4
	ldd R3,z+5
	tst R2
	brne X4
	tst R3
	breq L15
X4:
;         int prev;
; 
;         rc = (irq->ir_ctl) (NUT_IRQCTL_GETPRIO, &prev);
	movw R18,R28
	ldi R16,32
	ldi R17,0
	ldd R26,z+4
	ldd R27,z+5
	movw R30,R26
	xcall  xicall
	movw R20,R16
;         if (rc == 0 && (rc = (irq->ir_ctl) (NUT_IRQCTL_SETPRIO, &level)) == 0) {
	cpi R16,0
	cpc R16,R17
	brne L17
X5:
	movw R18,R28
	subi R18,250  ; offset = 6
	sbci R19,255
	ldi R16,33
	ldi R17,0
	movw R30,R22
	ldd R26,z+4
	ldd R27,z+5
	movw R30,R26
	xcall  xicall
	movw R20,R16
	cpi R20,0
	cpc R20,R21
	brne L17
X6:
;             rc = prev;
	ldd R20,y+0
	ldd R21,y+1
;         }
L17:
;     }
L15:
;     return rc;
	movw R16,R20
L14:
	.dbline 0 ; func end
	adiw R28,2
	xcall pop_xgsetF000
	adiw R28,2
	ret
; }
; 
; #endif
; 
; /*@}*/
