	.module netbuf.c
	.area text(rom, con, rel)
;           size -> R10,R11
;            nbd -> R20,R21
	.even
_NutNetBufAllocData:
	xcall push_xgset300C
	movw R10,R18
	movw R20,R16
; /*
;  * Copyright (C) 2001-2003 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  * -
;  * Portions Copyright (C) 2000 David J. Hudson <dave@humbug.demon.co.uk>
;  *
;  * This file is distributed in the hope that it will be useful, but WITHOUT
;  * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;  * FITNESS FOR A PARTICULAR PURPOSE.
;  *
;  * You can redistribute this file and/or modify it under the terms of the GNU
;  * General Public License (GPL) as published by the Free Software Foundation;
;  * either version 2 of the License, or (at your discretion) any later version.
;  * See the accompanying file "copying-gpl.txt" for more details.
;  *
;  * As a special exception to the GPL, permission is granted for additional
;  * uses of the text contained in this file.  See the accompanying file
;  * "copying-liquorice.txt" for details.
;  * -
;  * Portions Copyright (c) 1983, 1993 by
;  *  The Regents of the University of California.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the University nor the names of its contributors
;  *    may be used to endorse or promote products derived from this software
;  *    without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
;  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
;  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
;  * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
;  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
;  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
;  * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
;  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
;  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
;  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  * -
;  * Portions Copyright (c) 1993 by Digital Equipment Corporation.
;  *
;  * Permission to use, copy, modify, and distribute this software for any
;  * purpose with or without fee is hereby granted, provided that the above
;  * copyright notice and this permission notice appear in all copies, and that
;  * the name of Digital Equipment Corporation not be used in advertising or
;  * publicity pertaining to distribution of the document or software without
;  * specific, written prior permission.
;  * 
;  * THE SOFTWARE IS PROVIDED "AS IS" AND DIGITAL EQUIPMENT CORP. DISCLAIMS ALL
;  * WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES
;  * OF MERCHANTABILITY AND FITNESS.   IN NO EVENT SHALL DIGITAL EQUIPMENT
;  * CORPORATION BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
;  * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
;  * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
;  * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
;  * SOFTWARE.
;  */
; 
; /*
;  * $Log: netbuf.c,v $
;  * Revision 1.3  2005/04/30 16:42:41  chaac
;  * Fixed bug in handling of NUTDEBUG. Added include for cfg/os.h. If NUTDEBUG
;  * is defined in NutConf, it will make effect where it is used.
;  *
;  * Revision 1.2  2004/01/16 07:51:43  drsung
;  * Bugfix for reallocating smaller network buffers. Thx to Mike Cornelius.
;  *
;  * Revision 1.1.1.1  2003/05/09 14:40:46  haraldkipp
;  * Initial using 3.2.1
;  *
;  * Revision 1.12  2003/03/31 14:53:07  harald
;  * Prepare release 3.1
;  *
;  * Revision 1.11  2003/02/04 17:50:54  harald
;  * Version 3 released
;  *
;  * Revision 1.10  2002/06/26 17:29:08  harald
;  * First pre-release with 2.4 stack
;  *
;  */
; 
; #include <cfg/os.h>
; #include <string.h>
; 
; #include <sys/heap.h>
; #include <dev/netbuf.h>
; 
; #ifdef NUTDEBUG
; #include <sys/osdebug.h>
; #endif
; 
; /*!
;  * \addtogroup xgnetbuf
;  */
; /*@{*/
; 
; static int NutNetBufAllocData(NBDATA * nbd, u_short size)
; {
;     if ((nbd->vp = NutHeapAlloc(size)) == 0) {
	movw R16,R10
	xcall _NutHeapAlloc
	movw R30,R20
	std z+1,R17
	std z+0,R16
	cpi R16,0
	cpc R16,R17
	brne L2
X0:
;         nbd->sz = 0;
	clr R2
	clr R3
	std z+3,R3
	std z+2,R2
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L1
L2:
;     }
;     nbd->sz = size;
	movw R30,R20
	std z+3,R11
	std z+2,R10
;     return 0;
	clr R16
	clr R17
L1:
	.dbline 0 ; func end
	xjmp pop_xgset300C
;            nbd -> R20,R21
	.even
_NutNetBufFreeData:
	st -y,R20
	st -y,R21
	movw R20,R16
; }
; 
; static void NutNetBufFreeData(NBDATA * nbd)
; {
;     NutHeapFree(nbd->vp);
	movw R30,R20
	ldd R16,z+0
	ldd R17,z+1
	xcall _NutHeapFree
;     nbd->vp = 0;
	clr R2
	clr R3
	movw R30,R20
	std z+1,R3
	std z+0,R2
;     nbd->sz = 0;
	std z+3,R3
	std z+2,R2
L4:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
;           size -> R12,R13
;           type -> R10
;             nb -> R20,R21
	.even
_NutNetBufAlloc::
	xcall push_xgsetF0FC
	mov R10,R18
	movw R20,R16
	ldd R12,y+10
	ldd R13,y+11
; }
; 
; /*!
;  * \brief Allocate or re-allocate a network buffer part.
;  *
;  * \param nb   Points to an existing network buffer structure or NULL, 
;  *             if a new structure should be created. An existing buffer
;  *             must not be used any further if this function returns
;  *             a null pointer.
;  * \param type Part of the buffer to be allocated. This can be any of
;  *             the following:
;  *             - NBAF_DATALINK
;  *             - NBAF_NETWORK
;  *             - NBAF_TRANSPORT
;  *             - NBAF_APPLICATION
;  * \param size Size of the part to be allocated.
;  *
;  * \return Pointer to the allocated network buffer structure. A null
;  *         pointer is returned if not enough memory is available and
;  *         the whole structure is released.
;  */
; NETBUF *NutNetBufAlloc(NETBUF * nb, u_char type, u_short size)
; {
;     if (nb == 0) {
	cpi R20,0
	cpc R20,R21
	brne L6
X1:
;         nb = NutHeapAllocClear(sizeof(NETBUF));
	ldi R16,19
	ldi R17,0
	xcall _NutHeapAllocClear
	movw R20,R16
;     }
L6:
; 
;     if (nb && type) {
	cpi R20,0
	cpc R20,R21
	brne X29
	xjmp L8
X29:
X2:
	tst R10
	brne X30
	xjmp L8
X30:
X3:
;         if (size) {
	tst R12
	brne X4
	tst R13
	brne X31
	xjmp L10
X31:
X4:
;             if (type & NBAF_DATALINK) {
	sbrs R10,4
	rjmp L12
X5:
;                 if (nb->nb_flags & NBAF_DATALINK) {
	movw R30,R20
	ldd R2,z+2
	sbrs R2,4
	rjmp L14
X6:
;                     if (nb->nb_dl.sz < size) {
	ldd R2,z+5
	ldd R3,z+6
	cp R2,R12
	cpc R3,R13
	brsh L16
X7:
;                         NutNetBufFreeData(&nb->nb_dl);
	movw R16,R30
	subi R16,253  ; offset = 3
	sbci R17,255
	xcall _NutNetBufFreeData
;                         if (NutNetBufAllocData(&nb->nb_dl, size)) {
	movw R18,R12
	movw R16,R20
	subi R16,253  ; offset = 3
	sbci R17,255
	xcall _NutNetBufAllocData
	cpi R16,0
	cpc R16,R17
	breq L15
X8:
;                             NutNetBufFree(nb);
	movw R16,R20
	xcall _NutNetBufFree
;                             return 0;
	clr R16
	clr R17
	xjmp L5
L16:
;                         }
;                     } else
;                         nb->nb_dl.sz = size;
	movw R30,R20
	std z+6,R13
	std z+5,R12
;                 } else if (NutNetBufAllocData(&nb->nb_dl, size)) {
	xjmp L15
L14:
	movw R18,R12
	movw R16,R20
	subi R16,253  ; offset = 3
	sbci R17,255
	xcall _NutNetBufAllocData
	movw R14,R16
	cpi R16,0
	cpc R16,R17
	breq L20
X9:
;                     NutNetBufFree(nb);
	movw R16,R20
	xcall _NutNetBufFree
;                     return 0;
	clr R16
	clr R17
	xjmp L5
L20:
L15:
;                 }
;             }
L12:
; 
;             if (type & NBAF_NETWORK) {
	sbrs R10,5
	rjmp L22
X10:
;                 if (nb->nb_flags & NBAF_NETWORK) {
	movw R30,R20
	ldd R2,z+2
	sbrs R2,5
	rjmp L24
X11:
;                     if (nb->nb_nw.sz < size) {
	ldd R2,z+9
	ldd R3,z+10
	cp R2,R12
	cpc R3,R13
	brsh L26
X12:
;                         NutNetBufFreeData(&nb->nb_nw);
	movw R16,R30
	subi R16,249  ; offset = 7
	sbci R17,255
	xcall _NutNetBufFreeData
;                         if (NutNetBufAllocData(&nb->nb_nw, size)) {
	movw R18,R12
	movw R16,R20
	subi R16,249  ; offset = 7
	sbci R17,255
	xcall _NutNetBufAllocData
	movw R14,R16
	cpi R16,0
	cpc R16,R17
	breq L25
X13:
;                             NutNetBufFree(nb);
	movw R16,R20
	xcall _NutNetBufFree
;                             return 0;
	clr R16
	clr R17
	xjmp L5
L26:
;                         }
;                     } else
;                         nb->nb_nw.sz = size;
	movw R30,R20
	std z+10,R13
	std z+9,R12
;                 } else if (NutNetBufAllocData(&nb->nb_nw, size)) {
	xjmp L25
L24:
	movw R18,R12
	movw R16,R20
	subi R16,249  ; offset = 7
	sbci R17,255
	xcall _NutNetBufAllocData
	movw R14,R16
	cpi R16,0
	cpc R16,R17
	breq L30
X14:
;                     NutNetBufFree(nb);
	movw R16,R20
	xcall _NutNetBufFree
;                     return 0;
	clr R16
	clr R17
	xjmp L5
L30:
L25:
;                 }
;             }
L22:
; 
;             if (type & NBAF_TRANSPORT) {
	sbrs R10,6
	rjmp L32
X15:
;                 if (nb->nb_flags & NBAF_TRANSPORT) {
	movw R30,R20
	ldd R2,z+2
	sbrs R2,6
	rjmp L34
X16:
;                     if (nb->nb_tp.sz < size) {
	ldd R2,z+13
	ldd R3,z+14
	cp R2,R12
	cpc R3,R13
	brsh L36
X17:
;                         NutNetBufFreeData(&nb->nb_tp);
	movw R16,R30
	subi R16,245  ; offset = 11
	sbci R17,255
	xcall _NutNetBufFreeData
;                         if (NutNetBufAllocData(&nb->nb_tp, size)) {
	movw R18,R12
	movw R16,R20
	subi R16,245  ; offset = 11
	sbci R17,255
	xcall _NutNetBufAllocData
	movw R14,R16
	cpi R16,0
	cpc R16,R17
	breq L35
X18:
;                             NutNetBufFree(nb);
	movw R16,R20
	xcall _NutNetBufFree
;                             return 0;
	clr R16
	clr R17
	xjmp L5
L36:
;                         }
;                     } else
;                         nb->nb_tp.sz = size;
	movw R30,R20
	std z+14,R13
	std z+13,R12
;                 } else if (NutNetBufAllocData(&nb->nb_tp, size)) {
	xjmp L35
L34:
	movw R18,R12
	movw R16,R20
	subi R16,245  ; offset = 11
	sbci R17,255
	xcall _NutNetBufAllocData
	movw R14,R16
	cpi R16,0
	cpc R16,R17
	breq L40
X19:
;                     NutNetBufFree(nb);
	movw R16,R20
	xcall _NutNetBufFree
;                     return 0;
	clr R16
	clr R17
	xjmp L5
L40:
L35:
;                 }
;             }
L32:
; 
;             if (type & NBAF_APPLICATION) {
	sbrs R10,7
	rjmp L42
X20:
;                 if (nb->nb_flags & NBAF_APPLICATION) {
	movw R30,R20
	ldd R2,z+2
	sbrs R2,7
	rjmp L44
X21:
;                     if (nb->nb_ap.sz < size) {
	ldd R2,z+17
	ldd R3,z+18
	cp R2,R12
	cpc R3,R13
	brsh L46
X22:
;                         NutNetBufFreeData(&nb->nb_ap);
	movw R16,R30
	subi R16,241  ; offset = 15
	sbci R17,255
	xcall _NutNetBufFreeData
;                         if (NutNetBufAllocData(&nb->nb_ap, size)) {
	movw R18,R12
	movw R16,R20
	subi R16,241  ; offset = 15
	sbci R17,255
	xcall _NutNetBufAllocData
	movw R14,R16
	cpi R16,0
	cpc R16,R17
	breq L45
X23:
;                             NutNetBufFree(nb);
	movw R16,R20
	xcall _NutNetBufFree
;                             return 0;
	clr R16
	clr R17
	xjmp L5
L46:
;                         }
;                     } else
;                         nb->nb_ap.sz = size;
	movw R30,R20
	std z+18,R13
	std z+17,R12
;                 } else if (NutNetBufAllocData(&nb->nb_ap, size)) {
	xjmp L45
L44:
	movw R18,R12
	movw R16,R20
	subi R16,241  ; offset = 15
	sbci R17,255
	xcall _NutNetBufAllocData
	movw R12,R16
	cpi R16,0
	cpc R16,R17
	breq L50
X24:
;                     NutNetBufFree(nb);
	movw R16,R20
	xcall _NutNetBufFree
;                     return 0;
	clr R16
	clr R17
	xjmp L5
L50:
L45:
;                 }
;             }
L42:
;             nb->nb_flags |= type;
	movw R22,R20
	subi R22,254  ; offset = 2
	sbci R23,255
	movw R30,R22
	ldd R2,z+0
	or R2,R10
	std z+0,R2
;         } else {
	xjmp L11
L10:
;             type &= nb->nb_flags;
	movw R30,R20
	ldd R2,z+2
	and R10,R2
;             if (type & NBAF_DATALINK)
	sbrs R10,4
	rjmp L52
X25:
;                 NutNetBufFreeData(&nb->nb_dl);
	movw R16,R30
	subi R16,253  ; offset = 3
	sbci R17,255
	xcall _NutNetBufFreeData
L52:
;             if (type & NBAF_NETWORK)
	sbrs R10,5
	rjmp L54
X26:
;                 NutNetBufFreeData(&nb->nb_nw);
	movw R16,R20
	subi R16,249  ; offset = 7
	sbci R17,255
	xcall _NutNetBufFreeData
L54:
;             if (type & NBAF_TRANSPORT)
	sbrs R10,6
	rjmp L56
X27:
;                 NutNetBufFreeData(&nb->nb_tp);
	movw R16,R20
	subi R16,245  ; offset = 11
	sbci R17,255
	xcall _NutNetBufFreeData
L56:
;             if (type & NBAF_APPLICATION)
	sbrs R10,7
	rjmp L58
X28:
;                 NutNetBufFreeData(&nb->nb_ap);
	movw R16,R20
	subi R16,241  ; offset = 15
	sbci R17,255
	xcall _NutNetBufFreeData
L58:
;             nb->nb_flags &= ~type;
	movw R22,R20
	subi R22,254  ; offset = 2
	sbci R23,255
	mov R2,R10
	com R2
	movw R30,R22
	ldd R3,z+0
	and R3,R2
	std z+0,R3
;         }
L11:
;     }
L8:
;     return nb;
	movw R16,R20
L5:
	.dbline 0 ; func end
	xjmp pop_xgsetF0FC
;          clone -> R20,R21
;             nb -> R22,R23
	.even
_NutNetBufClone::
	xcall push_xgsetF00C
	movw R22,R16
	sbiw R28,2
; }
; 
; /*!
;  * \brief Create a copy of an existing network buffer
;  *        structure.
;  *
;  * \param nb Points to an existing network buffer
;  *           structure, previously allocated by
;  *           NutNetBufAlloc().
;  *
;  * \return Pointer to a newly allocated copy.
;  */
; NETBUF *NutNetBufClone(NETBUF * nb)
; {
;     NETBUF *clone;
; 
;     if ((clone = NutHeapAllocClear(sizeof(NETBUF))) == 0)
	ldi R16,19
	ldi R17,0
	xcall _NutHeapAllocClear
	movw R20,R16
	cpi R20,0
	cpc R20,R21
	brne L61
X32:
;         return 0;
	clr R16
	clr R17
	xjmp L60
L61:
; 
;     if (nb->nb_dl.sz) {
	movw R30,R22
	ldd R2,z+5
	ldd R3,z+6
	tst R2
	brne X33
	tst R3
	brne X41
	xjmp L63
X41:
X33:
;         if (NutNetBufAllocData(&clone->nb_dl, nb->nb_dl.sz)) {
	ldd R18,z+5
	ldd R19,z+6
	movw R16,R20
	subi R16,253  ; offset = 3
	sbci R17,255
	xcall _NutNetBufAllocData
	cpi R16,0
	cpc R16,R17
	breq L65
X34:
;             NutNetBufFree(clone);
	movw R16,R20
	xcall _NutNetBufFree
;             return 0;
	clr R16
	clr R17
	xjmp L60
L65:
;         }
;         memcpy(clone->nb_dl.vp, nb->nb_dl.vp, nb->nb_dl.sz);
	movw R30,R22
	ldd R2,z+5
	ldd R3,z+6
	std y+1,R3
	std y+0,R2
	ldd R18,z+3
	ldd R19,z+4
	movw R30,R20
	ldd R16,z+3
	ldd R17,z+4
	xcall _memcpy
;         clone->nb_flags |= NBAF_DATALINK;
	movw R24,R20
	adiw R24,2
	movw R10,R24
	movw R30,R24
	ldd R24,z+0
	ori R24,16
	std z+0,R24
;     }
L63:
;     if (nb->nb_nw.sz) {
	movw R30,R22
	ldd R2,z+9
	ldd R3,z+10
	tst R2
	brne X35
	tst R3
	brne X42
	xjmp L67
X42:
X35:
;         if (NutNetBufAllocData(&clone->nb_nw, nb->nb_nw.sz)) {
	ldd R18,z+9
	ldd R19,z+10
	movw R16,R20
	subi R16,249  ; offset = 7
	sbci R17,255
	xcall _NutNetBufAllocData
	movw R10,R16
	cpi R16,0
	cpc R16,R17
	breq L69
X36:
;             NutNetBufFree(clone);
	movw R16,R20
	xcall _NutNetBufFree
;             return 0;
	clr R16
	clr R17
	xjmp L60
L69:
;         }
;         memcpy(clone->nb_nw.vp, nb->nb_nw.vp, nb->nb_nw.sz);
	movw R30,R22
	ldd R2,z+9
	ldd R3,z+10
	std y+1,R3
	std y+0,R2
	ldd R18,z+7
	ldd R19,z+8
	movw R30,R20
	ldd R16,z+7
	ldd R17,z+8
	xcall _memcpy
;         clone->nb_flags |= NBAF_NETWORK;
	movw R24,R20
	adiw R24,2
	movw R10,R24
	movw R30,R24
	ldd R24,z+0
	ori R24,32
	std z+0,R24
;     }
L67:
;     if (nb->nb_tp.sz) {
	movw R30,R22
	ldd R2,z+13
	ldd R3,z+14
	tst R2
	brne X37
	tst R3
	brne X43
	xjmp L71
X43:
X37:
;         if (NutNetBufAllocData(&clone->nb_tp, nb->nb_tp.sz)) {
	ldd R18,z+13
	ldd R19,z+14
	movw R16,R20
	subi R16,245  ; offset = 11
	sbci R17,255
	xcall _NutNetBufAllocData
	movw R10,R16
	cpi R16,0
	cpc R16,R17
	breq L73
X38:
;             NutNetBufFree(clone);
	movw R16,R20
	xcall _NutNetBufFree
;             return 0;
	clr R16
	clr R17
	xjmp L60
L73:
;         }
;         memcpy(clone->nb_tp.vp, nb->nb_tp.vp, nb->nb_tp.sz);
	movw R30,R22
	ldd R2,z+13
	ldd R3,z+14
	std y+1,R3
	std y+0,R2
	ldd R18,z+11
	ldd R19,z+12
	movw R30,R20
	ldd R16,z+11
	ldd R17,z+12
	xcall _memcpy
;         clone->nb_flags |= NBAF_TRANSPORT;
	movw R24,R20
	adiw R24,2
	movw R10,R24
	movw R30,R24
	ldd R24,z+0
	ori R24,64
	std z+0,R24
;     }
L71:
;     if (nb->nb_ap.sz) {
	movw R30,R22
	ldd R2,z+17
	ldd R3,z+18
	tst R2
	brne X39
	tst R3
	brne X44
	xjmp L75
X44:
X39:
;         if (NutNetBufAllocData(&clone->nb_ap, nb->nb_ap.sz)) {
	ldd R18,z+17
	ldd R19,z+18
	movw R16,R20
	subi R16,241  ; offset = 15
	sbci R17,255
	xcall _NutNetBufAllocData
	movw R10,R16
	cpi R16,0
	cpc R16,R17
	breq L77
X40:
;             NutNetBufFree(clone);
	movw R16,R20
	xcall _NutNetBufFree
;             return 0;
	clr R16
	clr R17
	xjmp L60
L77:
;         }
;         memcpy(clone->nb_ap.vp, nb->nb_ap.vp, nb->nb_ap.sz);
	movw R30,R22
	ldd R2,z+17
	ldd R3,z+18
	std y+1,R3
	std y+0,R2
	ldd R18,z+15
	ldd R19,z+16
	movw R30,R20
	ldd R16,z+15
	ldd R17,z+16
	xcall _memcpy
;         clone->nb_flags |= NBAF_APPLICATION;
	movw R22,R20
	subi R22,254  ; offset = 2
	sbci R23,255
	movw R30,R22
	ldd R24,z+0
	ori R24,128
	std z+0,R24
;     }
L75:
;     return clone;
	movw R16,R20
L60:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgsetF00C
;             nb -> R20,R21
	.even
_NutNetBufFree::
	st -y,R20
	st -y,R21
	movw R20,R16
	sbiw R28,2
; }
; 
; /*!
;  * \brief Release a network buffer structure.
;  *
;  * Returns all memory previously allocated by a
;  * network buffer to the available heap space.
;  *
;  * \param nb Points to an existing network buffer
;  *           structure, previously allocated by
;  *           NutNetBufAlloc().
;  *
;  * \return 0 if successfull or -1 if the structure
;  *         contains previously released memory space.
;  */
; int NutNetBufFree(NETBUF * nb)
; {
;     if(nb) {
	cpi R20,0
	cpc R20,R21
	breq L80
X45:
;         NutNetBufAlloc(nb, nb->nb_flags, 0);
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	movw R30,R20
	ldd R18,z+2
	movw R16,R30
	xcall _NutNetBufAlloc
;         if (NutHeapFree(nb)) {
	movw R16,R20
	xcall _NutHeapFree
	cpi R16,0
	cpc R16,R17
	breq L82
X46:
;             return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L79
L82:
;         }
;     }
L80:
;     return 0;
	clr R16
	clr R17
L79:
	.dbline 0 ; func end
	adiw R28,2
	ld R21,y+
	ld R20,y+
	ret
; }
; 
; /*@}*/
