	.module usart.c
	.area text(rom, con, rel)
;             rc -> R10,R11
;            dcb -> R20,R21
;            dev -> R20,R21
	.even
_UsartInit::
	xcall push_xgset300C
	movw R20,R16
; /*
;  * Copyright (C) 2001-2003 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  */
; 
; /*
;  * $Log: usart.c,v $
;  * Revision 1.5  2004/10/14 16:43:06  drsung
;  * Fixed compiler warning "comparison between signed and unsigned"
;  *
;  * Revision 1.4  2004/05/24 20:17:15  drsung
;  * Added function UsartSize to return number of chars in input buffer.
;  *
;  * Revision 1.3  2004/05/20 09:05:07  drsung
;  * Memory was allocated twice for NUTFILE in UsartOpen.
;  *
;  * Revision 1.2  2004/03/18 13:59:14  haraldkipp
;  * Comment updated
;  *
;  * Revision 1.1  2003/12/15 19:25:33  haraldkipp
;  * New USART driver added
;  *
;  */
; 
; #include <compiler.h>
; #include <stdlib.h>
; #include <string.h>
; 
; #include <sys/atom.h>
; #include <sys/heap.h>
; #include <sys/event.h>
; #include <sys/timer.h>
; 
; #include <dev/irqreg.h>
; #include <dev/usart.h>
; 
; #include <fcntl.h>
; 
; /*
;  * Not nice because stdio already defined them. But in order to save memory,
;  * we do the whole buffering and including stdio here would be more weird.
;  */
; #ifndef _IOFBF
; #define _IOFBF  0x00
; #define _IOLBF  0x01
; #define _IONBF  0x02
; #endif
; 
; /*!
;  * \addtogroup xgUsart
;  */
; /*@{*/
; 
; /*!
;  * \brief Initialize the USART device.
;  *
;  * This function is called by NutRegisterDevice(), using the 
;  * _NUTDEVICE::dev_init entry. It will call the low level
;  * driver's _USARTDCB::dcb_init routine to initialize the hardware.
;  *
;  * \param dev Identifies the device to initialize.
;  *
;  * \return 0 on success, -1 otherwise.
;  *
;  * \todo Read initial settings from EEPROM.
;  */
; int UsartInit(NUTDEVICE * dev)
; {
;     int rc;
;     USARTDCB *dcb = dev->dev_dcb;
	movw R30,R20
	ldd R20,z+17
	ldd R21,z+18
; 
;     /* Initialize the low level hardware driver. */
;     if ((rc = (*dcb->dcb_init) ()) == 0) {
	movw R30,R20
	ldd R26,z+53
	ldd R27,z+54
	movw R30,R26
	xcall  xicall
	movw R10,R16
	tst R10
	brne L3
	tst R11
	brne L3
X0:
;         /* Ignore errors on initial configuration. */
;         (*dcb->dcb_set_speed) (USART_INITSPEED);
	ldi R16,0
	ldi R17,194
	ldi R18,1
	ldi R19,0
	movw R30,R20
	subi R30,191  ; addi 65
	sbci R31,255
	ldd R26,z+0
	ldd R27,z+1
	movw R30,R26
	xcall  xicall
;     }
L3:
;     return rc;
	movw R16,R10
L2:
	.dbline 0 ; func end
	xjmp pop_xgset300C
;            xsz -> R14,R15
;            xbp -> R12,R13
;           hiwm -> y+12
;           lowm -> y+10
;           size -> R10,R11
;            rbf -> R20,R21
	.even
_UsartResetBuffer:
	xcall push_xgset30FC
	movw R10,R18
	movw R20,R16
	sbiw R28,2
; }
; 
; /*!
;  * \brief Reset an USART ring buffer.
;  *
;  * \param rbf Pointer to the ring buffer structure.
;  * \param size Buffer size.
;  * \param lowm Low watermark.
;  * \param hiwm High watermark.
;  *
;  * \return 0 on success, -1 if changing the buffer size fails.
;  */
; static int UsartResetBuffer(RINGBUF * rbf, size_t size, size_t lowm, size_t hiwm)
; {
;     u_char *xbp = rbf->rbf_start;
	movw R30,R20
	ldd R12,z+4
	ldd R13,z+5
;     size_t xsz = rbf->rbf_siz;
	ldd R14,z+8
	ldd R15,z+9
; 
;     /* Disable further buffer usage. */
;     NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
;     rbf->rbf_siz = 0;
	clr R2
	clr R3
	std z+9,R3
	std z+8,R2
;     NutExitCritical();
	pop R0
	out 0x3F, R0
	
; 
;     /* Resize the buffer, if required. */
;     if (xsz != size) {
	cp R14,R10
	cpc R15,R11
	breq L6
X1:
;         if (xsz && xbp) {
	tst R14
	brne X2
	tst R15
	breq L8
X2:
	tst R12
	brne X3
	tst R13
	breq L8
X3:
;             free(xbp);
	movw R16,R12
	xcall _free_M
;         }
L8:
;         if (size && (xbp = malloc(size)) == 0) {
	tst R10
	brne X4
	tst R11
	breq L10
X4:
	movw R16,R10
	xcall _malloc_M
	movw R12,R16
	tst R12
	brne L10
	tst R13
	brne L10
X5:
;             return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L5
L10:
;         }
;     }
L6:
; 
;     /* Update ring buffer status. */
;     memset(rbf, 0, sizeof(RINGBUF));
	ldi R24,18
	ldi R25,0
	std y+1,R25
	std y+0,R24
	clr R18
	clr R19
	movw R16,R20
	xcall _memset
;     if (size) {
	tst R10
	brne X6
	tst R11
	breq L12
X6:
;         rbf->rbf_start = xbp;
	movw R30,R20
	std z+5,R13
	std z+4,R12
;         rbf->rbf_head = xbp;
	std z+1,R13
	std z+0,R12
;         rbf->rbf_tail = xbp;
	std z+3,R13
	std z+2,R12
;         rbf->rbf_last = xbp + size;
	movw R2,R10
	add R2,R12
	adc R3,R13
	std z+7,R3
	std z+6,R2
;         rbf->rbf_lwm = lowm;
	ldd R0,y+10
	ldd R1,y+11
	std z+13,R1
	std z+12,R0
;         rbf->rbf_hwm = hiwm;
	ldd R0,y+12
	ldd R1,y+13
	std z+15,R1
	std z+14,R0
; 
;         /* Re-enable buffer usage. */
;         NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
;         rbf->rbf_siz = size;
	std z+9,R11
	std z+8,R10
;         NutExitCritical();
	pop R0
	out 0x3F, R0
	
;     }
L12:
;     return 0;
	clr R16
	clr R17
L5:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgset30FC
;            dev -> R20,R21
;             cp -> y+8
;             rc -> R20,R21
;             ch -> R14
;          taken -> y+6
;          avail -> R12,R13
;            dcb -> y+4
;            rbf -> R10,R11
;           size -> y+20
;         buffer -> R12,R13
;             fp -> R20,R21
	.even
_UsartRead::
	xcall push_xgsetF0FC
	movw R12,R18
	movw R20,R16
	sbiw R28,10
; }
; 
; /*! 
;  * \brief Read from device. 
;  *
;  * This function is called by the low level input routines of the 
;  * \ref xrCrtLowio "C runtime library", using the _NUTDEVICE::dev_read 
;  * entry.
;  *
;  * The function may block the calling thread until at least one
;  * character has been received or a timeout occurs.
;  *
;  * It is recommended to set a proper read timeout with software handshake.
;  * In this case a timeout may occur, if the communication peer lost our 
;  * last XON character. The application may then use ioctl() to disable the 
;  * receiver and do the read again. This will send out another XON.
;  *
;  * \param fp     Pointer to a \ref _NUTFILE structure, obtained by a 
;  *               previous call to UsartOpen().
;  * \param buffer Pointer to the buffer that receives the data. If zero,
;  *               then all characters in the input buffer will be
;  *               removed.
;  * \param size   Maximum number of bytes to read.
;  *
;  * \return The number of bytes read, which may be less than the number
;  *         of bytes specified. A return value of -1 indicates an error,
;  *         while zero is returned in case of a timeout.
;  */
; int UsartRead(NUTFILE * fp, void *buffer, int size)
; {
;     size_t rc;
;     size_t avail;
;     size_t taken = 0;
	clr R0
	clr R1
	std y+7,R1
	std y+6,R0
;     u_char ch;
;     u_char *cp = buffer;
	std y+9,R13
	std y+8,R12
;     NUTDEVICE *dev = fp->nf_dev;
	movw R30,R20
	ldd R20,z+2
	ldd R21,z+3
;     USARTDCB *dcb = dev->dev_dcb;
	movw R30,R20
	ldd R2,z+17
	ldd R3,z+18
	std y+5,R3
	std y+4,R2
;     RINGBUF *rbf = &dcb->dcb_rx_rbf;
	movw R24,R2
	adiw R24,34
	movw R10,R24
; 
;     /*
;      * No buffer allocated, this device is read only.
;      */
;     if (rbf->rbf_siz == 0) {
	movw R30,R24
	ldd R2,z+8
	ldd R3,z+9
	tst R2
	brne L15
	tst R3
	brne L15
X7:
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L14
L15:
;     }
; 
;     /*
;      * Call without data pointer discards receive buffer.
;      */
;     if (buffer == 0) {
	tst R12
	brne L17
	tst R13
	brne L17
X8:
;         UsartResetBuffer(rbf, rbf->rbf_siz, rbf->rbf_lwm, rbf->rbf_hwm);
	movw R30,R10
	ldd R2,z+14
	ldd R3,z+15
	std y+3,R3
	std y+2,R2
	ldd R2,z+12
	ldd R3,z+13
	std y+1,R3
	std y+0,R2
	ldd R18,z+8
	ldd R19,z+9
	movw R16,R30
	xcall _UsartResetBuffer
;         (*dcb->dcb_rx_start) ();
	ldd R30,y+4
	ldd R31,y+5
	ldd R26,z+59
	ldd R27,z+60
	movw R30,R26
	xcall  xicall
;         return 0;
	clr R16
	clr R17
	xjmp L14
L17:
;     }
; 
;     /*
;      * Wait until at least one character is buffered or until a read
;      * timeout occured.
;      */
;     for (;;) {
L19:
;         /* Atomic access to the ring buffer counter. */
;         NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
;         avail = rbf->rbf_cnt;
	movw R30,R10
	ldd R12,z+10
	ldd R13,z+11
;         NutExitCritical();
	pop R0
	out 0x3F, R0
	
;         if (avail) {
	tst R12
	brne X9
	tst R13
	breq L23
X9:
;             break;
	xjmp L21
L23:
;         }
;         /* 
;          * This will enable RTS hardware handshake or re-enable the 
;          * remote transmitter by sending a XON character.
;          */
;         (*dcb->dcb_rx_start) ();
	ldd R30,y+4
	ldd R31,y+5
	ldd R26,z+59
	ldd R27,z+60
	movw R30,R26
	xcall  xicall
;         if (NutEventWait(&rbf->rbf_que, dcb->dcb_rtimeout)) {
	ldd R30,y+4
	ldd R31,y+5
	ldd R2,z+8
	ldd R3,z+9
	ldd R4,z+10
	ldd R5,z+11
	std y+0,R4
	std y+1,R5
	movw R18,R2
	movw R16,R10
	subi R16,240  ; offset = 16
	sbci R17,255
	xcall _NutEventWait
	cpi R16,0
	cpc R16,R17
	breq L19
X10:
;             return 0;
	clr R16
	clr R17
	xjmp L14
L21:
;         }
;     }
; 
;     /*
;      * Get cooked characters from receive buffer.
;      */
;     if (dcb->dcb_modeflags & USART_MF_COOKEDMODE) {
	ldi R24,128
	ldi R25,0
	ldi R26,0
	ldi R27,0
	ldd R30,y+4
	ldd R31,y+5
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	and R2,R24
	and R3,R25
	and R4,R26
	and R5,R27
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	cp R2,R24
	cpc R3,R25
	cpc R4,R26
	cpc R5,R27
	brne X24
	xjmp L27
X24:
X11:
;         for (rc = 0; rc < (size_t) size;) {
	clr R20
	clr R21
	xjmp L32
L29:
;             if (taken >= avail) {
	ldd R0,y+6
	ldd R1,y+7
	cp R0,R12
	cpc R1,R13
	brlo L33
X12:
;                 break;
	xjmp L28
L33:
;             }
;             ch = *rbf->rbf_tail++;
	movw R24,R10
	adiw R24,2
	movw R30,R24
	ldd R22,z+0
	ldd R23,z+1
	movw R24,R22
	adiw R24,1
	std z+1,R25
	std z+0,R24
	movw R30,R22
	ldd R14,z+0
;             if (rbf->rbf_tail == rbf->rbf_last) {
	movw R30,R10
	ldd R2,z+6
	ldd R3,z+7
	ldd R4,z+2
	ldd R5,z+3
	cp R4,R2
	cpc R5,R3
	brne L35
X13:
;                 rbf->rbf_tail = rbf->rbf_start;
	ldd R2,z+4
	ldd R3,z+5
	std z+3,R3
	std z+2,R2
;             }
L35:
;             taken++;
	ldd R24,y+6
	ldd R25,y+7
	adiw R24,1
	std y+7,R25
	std y+6,R24
;             if (ch == '\r' || ch == '\n') {
	mov R24,R14
	cpi R24,13
	breq L39
X14:
	cpi R24,10
	brne L37
X15:
L39:
;                 if (dcb->dcb_last_eol == 0 || dcb->dcb_last_eol == ch) {
	ldd R30,y+4
	ldd R31,y+5
	ldd R22,z+52
	clr R23
	tst R22
	breq L42
X16:
	cp R22,R14
	brne L38
X17:
L42:
;                     dcb->dcb_last_eol = ch;
	ldd R30,y+4
	ldd R31,y+5
	std z+52,R14
;                     *cp++ = '\n';
	ldi R24,10
	ldd R30,y+8
	ldd R31,y+9
	st Z+,R24
	std y+9,R31
	std y+8,R30
;                     rc++;
	subi R20,255  ; offset = 1
	sbci R21,255
;                 }
;             } else {
	xjmp L38
L37:
;                 dcb->dcb_last_eol = 0;
	clr R2
	ldd R30,y+4
	ldd R31,y+5
	std z+52,R2
;                 *cp++ = ch;
	ldd R30,y+8
	ldd R31,y+9
	st Z+,R14
	std y+9,R31
	std y+8,R30
;                 rc++;
	subi R20,255  ; offset = 1
	sbci R21,255
;             }
L38:
;         }
L30:
L32:
	ldd R0,y+20
	ldd R1,y+21
	cp R20,R0
	cpc R21,R1
	brsh X25
	xjmp L29
X25:
X18:
;     }
	xjmp L28
L27:
; 
;     /*
;      * Get raw characters from receive buffer.
;      */
;     else {
;         if ((rc = size) > avail)
	ldd R20,y+20
	ldd R21,y+21
	movw R0,R20
	cp R12,R20
	cpc R13,R21
	brsh L43
X19:
;             rc = avail;
	movw R20,R12
L43:
;         for (taken = 0; taken < rc; taken++) {
	clr R0
	clr R1
	std y+7,R1
	std y+6,R0
	xjmp L48
L45:
;             *cp++ = *rbf->rbf_tail++;
	movw R24,R10
	adiw R24,2
	movw R12,R24
	movw R30,R24
	ldd R14,z+0
	ldd R15,z+1
	movw R24,R14
	adiw R24,1
	std z+1,R25
	std z+0,R24
	movw R30,R14
	ldd R2,z+0
	ldd R30,y+8
	ldd R31,y+9
	st Z+,R2
	std y+9,R31
	std y+8,R30
;             if (rbf->rbf_tail == rbf->rbf_last) {
	movw R30,R10
	ldd R2,z+6
	ldd R3,z+7
	ldd R4,z+2
	ldd R5,z+3
	cp R4,R2
	cpc R5,R3
	brne L49
X20:
;                 rbf->rbf_tail = rbf->rbf_start;
	ldd R2,z+4
	ldd R3,z+5
	std z+3,R3
	std z+2,R2
;             }
L49:
;         }
L46:
	ldd R24,y+6
	ldd R25,y+7
	adiw R24,1
	std y+7,R25
	std y+6,R24
L48:
	ldd R0,y+6
	ldd R1,y+7
	cp R0,R20
	cpc R1,R21
	brsh X26
	xjmp L45
X26:
X21:
;     }
L28:
; 
;     if (taken) {
	ldd R0,y+6
	ldd R1,y+7
	tst R0
	brne X22
	tst R1
	breq L51
X22:
;         NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
;         rbf->rbf_cnt -= taken;
	movw R24,R10
	adiw R24,10
	movw R12,R24
	movw R30,R24
	ldd R2,z+0
	ldd R3,z+1
	sub R2,R0
	sbc R3,R1
	std z+1,R3
	std z+0,R2
;         NutExitCritical();
	pop R0
	out 0x3F, R0
	
;         if (rbf->rbf_cnt < rbf->rbf_lwm) {
	movw R30,R10
	ldd R2,z+12
	ldd R3,z+13
	ldd R4,z+10
	ldd R5,z+11
	cp R4,R2
	cpc R5,R3
	brsh L53
X23:
;             (*dcb->dcb_rx_start) ();
	ldd R30,y+4
	ldd R31,y+5
	ldd R26,z+59
	ldd R27,z+60
	movw R30,R26
	xcall  xicall
;         }
L53:
;     }
L51:
;     return (int) rc;
	movw R16,R20
L14:
	.dbline 0 ; func end
	adiw R28,10
	xjmp pop_xgsetF0FC
;             rc -> R10,R11
;            rbf -> R20,R21
;           left -> y+8
;          added -> R10,R11
;            dcb -> R22,R23
	.even
_UsartFlushOutput:
	xcall push_xgsetF00C
	movw R10,R18
	movw R22,R16
	sbiw R28,2
; }
; 
; /*!
;  * \brief Flush output buffer.
;  *
;  * The current thread will be blocked until all characters upto a specified
;  * value have been written or until a timeout occured.
;  *
;  * \param  rbf   Pointer to a ring buffer structure.
;  * \param  added Number of bytes to add to the ring buffer counter. The
;  *               characters must have been added without updating the
;  *               counter. Because access to the counter has to be atomic,
;  *               this parameter simplifies the calling routine a bit.
;  * \param  left  The number of bytes left in the buffer before this
;  *               function returns.
;  * \param  tmo   Timeout in milliseconds.
;  *
;  * \return Number of bytes left in the output buffer, which is greater
;  *         than the specified value in case of a timeout.
;  */
; static size_t UsartFlushOutput(USARTDCB *dcb, size_t added, size_t left)
; {
;     size_t rc;
;     RINGBUF *rbf = &dcb->dcb_tx_rbf;
	movw R20,R22
	subi R20,240  ; offset = 16
	sbci R21,255
; 
;     /* 
;      * Add the new characters to the buffer count.
;      */
;     NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
;     rbf->rbf_cnt += added;
	movw R24,R20
	adiw R24,10
	movw R30,R24
	ldd R2,z+0
	ldd R3,z+1
	add R2,R10
	adc R3,R11
	std z+1,R3
	std z+0,R2
;     rc = rbf->rbf_cnt;
	movw R30,R20
	ldd R10,z+10
	ldd R11,z+11
;     NutExitCritical();
	pop R0
	out 0x3F, R0
	
	xjmp L57
L56:
; 
;     while (rc > left) {
;         /* Start transmitter and wait for the next event. */
;         (*dcb->dcb_tx_start) ();
	movw R30,R22
	ldd R26,z+57
	ldd R27,z+58
	movw R30,R26
	xcall  xicall
;         if (NutEventWait(&rbf->rbf_que, dcb->dcb_wtimeout)) {
	movw R30,R22
	ldd R2,z+12
	ldd R3,z+13
	ldd R4,z+14
	ldd R5,z+15
	std y+0,R4
	std y+1,R5
	movw R18,R2
	movw R16,R20
	subi R16,240  ; offset = 16
	sbci R17,255
	xcall _NutEventWait
	cpi R16,0
	cpc R16,R17
	breq L59
X27:
;             break;
	xjmp L58
L59:
;         }
;         /* Refresh the count. */
;         NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
;         rc = rbf->rbf_cnt;
	movw R30,R20
	ldd R10,z+10
	ldd R11,z+11
;         NutExitCritical();
	pop R0
	out 0x3F, R0
	
;     };
L57:
	ldd R0,y+8
	ldd R1,y+9
	cp R0,R10
	cpc R1,R11
	brlo L56
X28:
L58:
;     return rc;
	movw R16,R10
L55:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgsetF00C
;         lbmode -> y+9
;            dcb -> y+7
;             rc -> R20,R21
;            cnt -> y+5
;         cooked -> y+4
;             cp -> R22,R23
;          added -> R12,R13
;             ch -> R14
;            rbf -> y+2
;           pflg -> y+22
;            len -> y+20
;         buffer -> R10,R11
;            dev -> R20,R21
	.even
_UsartPut:
	xcall push_xgsetF0FC
	movw R10,R18
	movw R20,R16
	sbiw R28,10
; }
; 
; /*!
;  * \brief Write to device.
;  *
;  * \param dev    Pointer to a previously registered NUTDEVICE structure.
;  * \param buffer Pointer the data to write.
;  * \param len    Number of data bytes to write.
;  * \param pflg   If this flag is set, then the buffer is located in program
;  *               space.
;  *
;  * \return The number of bytes written. In case of a write timeout, this
;  *         may be less than the specified length.
;  */
; static int UsartPut(NUTDEVICE * dev, CONST void *buffer, int len, int pflg)
; {
;     int rc;
;     CONST u_char *cp;
;     u_char lbmode;
;     ureg_t cooked;
;     u_char ch;
;     size_t cnt;
;     size_t added;
;     USARTDCB *dcb = dev->dev_dcb;
	movw R30,R20
	ldd R2,z+17
	ldd R3,z+18
	std y+8,R3
	std y+7,R2
;     RINGBUF *rbf = &dcb->dcb_tx_rbf;
	movw R24,R2
	adiw R24,16
	std y+3,R25
	std y+2,R24
; 
;     /*
;      * No output ring buffer allocated, this device is read only.
;      */
;     if (rbf->rbf_siz == 0) {
	movw R30,R24
	ldd R2,z+8
	ldd R3,z+9
	tst R2
	brne L62
	tst R3
	brne L62
X29:
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L61
L62:
;     }
; 
;     /*
;      * Call without data pointer flushes the buffer. In this case a return
;      * value not equal zero indicates write timeout.
;      */
;     if (buffer == 0) {
	tst R10
	brne L64
	tst R11
	brne L64
X30:
;         return UsartFlushOutput(dcb, 0, 0);
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	clr R18
	clr R19
	ldd R16,y+7
	ldd R17,y+8
	xcall _UsartFlushOutput
	xjmp L61
L64:
;     }
; 
;     if (dcb->dcb_modeflags & USART_MF_LINEBUFFER)
	ldi R24,0
	ldi R25,2
	ldi R26,0
	ldi R27,0
	ldd R30,y+7
	ldd R31,y+8
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	and R2,R24
	and R3,R25
	and R4,R26
	and R5,R27
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	cp R2,R24
	cpc R3,R25
	cpc R4,R26
	cpc R5,R27
	breq L66
X31:
;         lbmode = 1;
	clr R0
	inc R0
	std y+9,R0
	xjmp L67
L66:
;     else
;         lbmode = 0;
	clr R0
	std y+9,R0
L67:
; 
;     if (dcb->dcb_modeflags & USART_MF_COOKEDMODE)
	ldi R24,128
	ldi R25,0
	ldi R26,0
	ldi R27,0
	ldd R30,y+7
	ldd R31,y+8
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	and R2,R24
	and R3,R25
	and R4,R26
	and R5,R27
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	cp R2,R24
	cpc R3,R25
	cpc R4,R26
	cpc R5,R27
	breq L68
X32:
;         cooked = 1;
	clr R0
	inc R0
	std y+4,R0
	xjmp L69
L68:
;     else
;         cooked = 0;
	clr R0
	std y+4,R0
L69:
; 
;     /*
;      * Get the number of buffered bytes. The transmit interrupt will modify
;      * this value, so make the query atomic.
;      */
;     NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
;     cnt = rbf->rbf_cnt;
	ldd R30,y+2
	ldd R31,y+3
	ldd R2,z+10
	ldd R3,z+11
	std y+6,R3
	std y+5,R2
;     NutExitCritical();
	pop R0
	out 0x3F, R0
	
; 
;     /*
;      * Move bytes to the transmit buffer.
;      */
;     cp = buffer;
	movw R22,R10
;     added = 0;
	clr R12
	clr R13
;     for (rc = 0; rc < len;) {
	clr R20
	clr R21
	xjmp L73
L70:
;         /*
;          * If we reached the high watermark, then kick the hardware driver 
;          * to start transmission and wait until the low watermark is reached.
;          */
;         if (cnt + added >= rbf->rbf_hwm) {
	ldd R2,y+5
	ldd R3,y+6
	add R2,R12
	adc R3,R13
	ldd R30,y+2
	ldd R31,y+3
	ldd R4,z+14
	ldd R5,z+15
	cp R2,R4
	cpc R3,R5
	brlo L74
X33:
;             cnt = UsartFlushOutput(dcb, added, rbf->rbf_lwm);
	ldd R2,z+12
	ldd R3,z+13
	std y+1,R3
	std y+0,R2
	movw R18,R12
	ldd R16,y+7
	ldd R17,y+8
	xcall _UsartFlushOutput
	std y+6,R17
	std y+5,R16
;             added = 0;
	clr R12
	clr R13
;             /* If still above the mark, then a timeout occured. */
;             if(cnt > rbf->rbf_lwm) {
	ldd R30,y+2
	ldd R31,y+3
	ldd R2,z+12
	ldd R3,z+13
	movw R0,R16
	cp R2,R16
	cpc R3,R17
	brsh L76
X34:
;                 break;
	xjmp L72
L76:
;             }
;         }
L74:
; 
;         /*
;          * Get the next data byte. If the pflg parameter is set, then data
;          * is located in program space.
;          */
;         ch = pflg ? PRG_RDB(cp) : *cp;
	ldd R0,y+22
	ldd R1,y+23
	tst R0
	brne X35
	tst R1
	breq L78
X35:
	movw R30,R22
	lpm R10,Z
	clr R11
	xjmp L79
L78:
	movw R30,R22
	ldd R10,z+0
	clr R11
L79:
	mov R14,R10
; 
;         /*
;          * In cooked mode we prepend a carriage return to any linefeed
;          * character.
;          */
;         if (cooked == 1 && ch == '\n') {
	ldd R24,y+4
	cpi R24,1
	brne L80
X36:
	mov R24,R14
	cpi R24,10
	brne L80
X37:
;             cooked = 2;
	ldi R24,2
	std y+4,R24
;             ch = '\r';
	ldi R24,13
	mov R14,R24
;             if (lbmode == 1)
	ldd R24,y+9
	cpi R24,1
	brne L81
X38:
;                 lbmode = 2;
	ldi R24,2
	std y+9,R24
;         } else {
	xjmp L81
L80:
;             if (cooked == 2)
	ldd R24,y+4
	cpi R24,2
	brne L84
X39:
;                 cooked = 1;
	clr R0
	inc R0
	std y+4,R0
L84:
;             cp++;
	subi R22,255  ; offset = 1
	sbci R23,255
;             rc++;
	subi R20,255  ; offset = 1
	sbci R21,255
;         }
L81:
;         *rbf->rbf_head++ = ch;
	ldd R30,y+2
	ldd R31,y+3
	ldd R10,z+0
	ldd R11,z+1
	movw R24,R10
	adiw R24,1
	std z+1,R25
	std z+0,R24
	movw R30,R10
	std z+0,R14
;         if (rbf->rbf_head == rbf->rbf_last) {
	ldd R30,y+2
	ldd R31,y+3
	ldd R2,z+6
	ldd R3,z+7
	ldd R4,z+0
	ldd R5,z+1
	cp R4,R2
	cpc R5,R3
	brne L86
X40:
;             rbf->rbf_head = rbf->rbf_start;
	ldd R2,z+4
	ldd R3,z+5
	std z+1,R3
	std z+0,R2
;         }
L86:
;         added++;
	movw R24,R12
	adiw R24,1
	movw R12,R24
;     }
L71:
L73:
	ldd R0,y+20
	ldd R1,y+21
	cp R20,R0
	cpc R21,R1
	brge X43
	xjmp L70
X43:
X41:
L72:
; 
;     if (added) {
	tst R12
	brne X42
	tst R13
	breq L88
X42:
;         NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
;         rbf->rbf_cnt += added;
	ldd R24,y+2
	ldd R25,y+3
	adiw R24,10
	movw R10,R24
	movw R30,R24
	ldd R2,z+0
	ldd R3,z+1
	add R2,R12
	adc R3,R13
	std z+1,R3
	std z+0,R2
;         NutExitCritical();
	pop R0
	out 0x3F, R0
	
;         (*dcb->dcb_tx_start) ();
	ldd R30,y+7
	ldd R31,y+8
	ldd R26,z+57
	ldd R27,z+58
	movw R30,R26
	xcall  xicall
;     }
L88:
; 
;     return rc;
	movw R16,R20
L61:
	.dbline 0 ; func end
	adiw R28,10
	xjmp pop_xgsetF0FC
;            len -> y+8
;         buffer -> R10,R11
;             fp -> R20,R21
	.even
_UsartWrite::
	xcall push_xgset300C
	movw R10,R18
	movw R20,R16
	sbiw R28,4
; }
; 
; /*!
;  * \brief Write a device or file.
;  *
;  * This function is called by the low level output routines of the 
;  * \ref xrCrtLowio "C runtime library", using the 
;  * \ref _NUTDEVICE::dev_write entry.
;  *
;  * The function may block the calling thread.
;  *
;  * \param fp     Pointer to a _NUTFILE structure, obtained by a previous 
;  *               call to UsartOpen().
;  * \param buffer Pointer to the data to be written. If zero, then the
;  *               output buffer will be flushed.
;  * \param len    Number of bytes to write.
;  *
;  * \return The number of bytes written, which may be less than the number
;  *         of bytes specified if a timeout occured. A return value of -1 
;  *         indicates an error.
;  */
; int UsartWrite(NUTFILE * fp, CONST void *buffer, int len)
; {
;     return UsartPut(fp->nf_dev, buffer, len, 0);
	clr R2
	clr R3
	std y+3,R3
	std y+2,R2
	ldd R0,y+8
	ldd R1,y+9
	std y+1,R1
	std y+0,R0
	movw R18,R10
	movw R30,R20
	ldd R16,z+2
	ldd R17,z+3
	xcall _UsartPut
L90:
	.dbline 0 ; func end
	adiw R28,4
	xjmp pop_xgset300C
;            len -> y+8
;         buffer -> R10,R11
;             fp -> R20,R21
	.even
_UsartWrite_P::
	xcall push_xgset300C
	movw R10,R18
	movw R20,R16
	sbiw R28,4
; }
; 
; /*!
;  * \brief Write a device or file.
;  *
;  * Similar to UsartWrite() except that the data is located in program 
;  * memory.
;  *
;  * This function is called by the low level output routines of the 
;  * \ref xrCrtLowio "C runtime library", using the _NUTDEVICE::dev_write_P 
;  * entry.
;  *
;  * The function may block the calling thread.
;  *
;  * \param fp     Pointer to a NUTFILE structure, obtained by a previous 
;  *               call to UsartOpen().
;  * \param buffer Pointer to the data in program space to be written.
;  * \param len    Number of bytes to write.
;  *
;  * \return The number of bytes written, which may be less than the number
;  *         of bytes specified if a timeout occured. A return value of -1 
;  *         indicates an error.
;  */
; int UsartWrite_P(NUTFILE * fp, PGM_P buffer, int len)
; {
;     return UsartPut(fp->nf_dev, (CONST char *) buffer, len, 1);
	ldi R24,1
	ldi R25,0
	std y+3,R25
	std y+2,R24
	ldd R0,y+8
	ldd R1,y+9
	std y+1,R1
	std y+0,R0
	movw R18,R10
	movw R30,R20
	ldd R16,z+2
	ldd R17,z+3
	xcall _UsartPut
L91:
	.dbline 0 ; func end
	adiw R28,4
	xjmp pop_xgset300C
;            dev -> R20,R21
;            dcb -> R20,R21
;             fp -> R22,R23
	.even
_UsartClose::
	xcall push_xgsetF000
	movw R22,R16
	sbiw R28,4
; }
; 
; /*! 
;  * \brief Close an USART device.
;  *
;  * This function is called by the low level close routine of the C runtime 
;  * library, using the _NUTDEVICE::dev_close entry.
;  *
;  * \param fp Pointer to a _NUTFILE structure, obtained by a previous call
;  *           to UsartOpen().
;  *
;  * \return 0 on success or -1 otherwise.
;  *
;  * \todo We may support shared open and use dev_irq as an open counter.
;  */
; int UsartClose(NUTFILE * fp)
; {
;     NUTDEVICE *dev = fp->nf_dev;
	movw R30,R22
	ldd R20,z+2
	ldd R21,z+3
;     USARTDCB *dcb = dev->dev_dcb;
	movw R30,R20
	ldd R20,z+17
	ldd R21,z+18
; 
;     if (fp == 0 || fp == NUTFILE_EOF)
	movw R2,R22
	cpi R22,0
	cpc R22,R23
	breq L95
X44:
	cpi R22,255
	ldi R30,255
	cpc R23,R30
	brne L93
X45:
L95:
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L92
L93:
; 
;     free(fp);
	movw R16,R22
	xcall _free_M
;     UsartResetBuffer(&dcb->dcb_tx_rbf, 0, 0, 0);
	clr R2
	clr R3
	std y+3,R3
	std y+2,R2
	std y+1,R3
	std y+0,R2
	clr R18
	clr R19
	movw R16,R20
	subi R16,240  ; offset = 16
	sbci R17,255
	xcall _UsartResetBuffer
;     UsartResetBuffer(&dcb->dcb_rx_rbf, 0, 0, 0);
	clr R2
	clr R3
	std y+3,R3
	std y+2,R2
	std y+1,R3
	std y+0,R2
	clr R18
	clr R19
	movw R16,R20
	subi R16,222  ; offset = 34
	sbci R17,255
	xcall _UsartResetBuffer
; 
;     return 0;
	clr R16
	clr R17
L92:
	.dbline 0 ; func end
	adiw R28,4
	xjmp pop_xgsetF000
;            dcb -> R22,R23
;             fp -> R20,R21
;            acc -> y+16
;           mode -> R10,R11
;           name -> R14,R15
;            dev -> R12,R13
	.even
_UsartOpen::
	xcall push_xgsetF0FC
	movw R14,R18
	movw R12,R16
	sbiw R28,4
	ldd R10,y+14
	ldd R11,y+15
; }
; 
; /*!
;  * \brief Open an USART device.
;  *
;  * This function is called by the low level open routine of the C runtime 
;  * library, using the _NUTDEVICE::dev_open entry.
;  *
;  * \param dev Pointer to the NUTDEVICE structure.
;  * \param name Ignored, should point to an empty string.
;  * \param mode Operation mode. Any of the following values may be or-ed:
;  * - \ref _O_BINARY
;  * - \ref _O_RDONLY
;  * - \ref _O_WRONLY
;  * \param acc Ignored, should be zero.
;  *
;  * \return Pointer to a NUTFILE structure if successful or NUTFILE_EOF otherwise.
;  *
;  * \todo We may support shared open and use dev_irq as an open counter.
;  */
; NUTFILE *UsartOpen(NUTDEVICE * dev, CONST char *name, int mode, int acc)
; {
;     USARTDCB *dcb = dev->dev_dcb;
	movw R30,R12
	ldd R22,z+17
	ldd R23,z+18
;     NUTFILE *fp;
; 
;     /*
;      * Create the tranmit buffer unless this is used for read only.
;      */
;     if ((mode & 0x0003) != _O_RDONLY) {
	movw R24,R10
	andi R24,3
	andi R25,0
	cpi R24,0
	cpc R24,R25
	breq L97
X46:
;         if (UsartResetBuffer(&dcb->dcb_tx_rbf, USART_TXBUFSIZ, USART_TXLOWMARK, USART_TXHIWMARK)) {
	ldi R24,56
	ldi R25,0
	std y+3,R25
	std y+2,R24
	ldi R24,40
	std y+1,R25
	std y+0,R24
	ldi R18,64
	ldi R19,0
	movw R16,R22
	subi R16,240  ; offset = 16
	sbci R17,255
	xcall _UsartResetBuffer
	cpi R16,0
	cpc R16,R17
	breq L99
X47:
;             return NUTFILE_EOF;
	ldi R16,-1
	ldi R17,-1
	xjmp L96
L99:
;         }
;     }
L97:
; 
;     /*
;      * Create the receive buffer unless this is used for write only.
;      */
;     if ((mode & 0x0003) != _O_WRONLY) {
	movw R24,R10
	andi R24,3
	andi R25,0
	cpi R24,1
	ldi R30,0
	cpc R25,R30
	breq L101
X48:
;         if (UsartResetBuffer(&dcb->dcb_rx_rbf, USART_RXBUFSIZ, USART_RXLOWMARK, USART_RXHIWMARK)) {
	ldi R24,240
	ldi R25,0
	std y+3,R25
	std y+2,R24
	ldi R24,208
	std y+1,R25
	std y+0,R24
	ldi R18,256
	ldi R19,1
	movw R16,R22
	subi R16,222  ; offset = 34
	sbci R17,255
	xcall _UsartResetBuffer
	cpi R16,0
	cpc R16,R17
	breq L103
X49:
;             free(dcb->dcb_tx_rbf.rbf_start);
	movw R30,R22
	ldd R16,z+20
	ldd R17,z+21
	xcall _free_M
;             return NUTFILE_EOF;
	ldi R16,-1
	ldi R17,-1
	xjmp L96
L103:
;         }
;     }
L101:
; 
;     /*
;      * Allocate memory for the file structure.
;      */
;     if ((fp = malloc(sizeof(NUTFILE))) == 0) {
	ldi R16,6
	ldi R17,0
	xcall _malloc_M
	movw R14,R16
	movw R20,R14
	cpi R16,0
	cpc R16,R17
	brne L105
X50:
;         free(dcb->dcb_tx_rbf.rbf_start);
	movw R30,R22
	ldd R16,z+20
	ldd R17,z+21
	xcall _free_M
;         free(dcb->dcb_rx_rbf.rbf_start);
	movw R30,R22
	ldd R16,z+38
	ldd R17,z+39
	xcall _free_M
;         return NUTFILE_EOF;
	ldi R16,-1
	ldi R17,-1
	xjmp L96
L105:
;     }
; 
;     /* Set proper device modes. */
;     if ((mode & 0xC000) == _O_BINARY) {
	movw R24,R10
	andi R24,0
	andi R25,192
	cpi R24,0
	ldi R30,128
	cpc R25,R30
	brne L107
X51:
;         dcb->dcb_modeflags &= ~USART_MF_COOKEDMODE;
	ldi R24,127
	ldi R25,255
	ldi R26,255
	ldi R27,255
	movw R30,R22
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	and R2,R24
	and R3,R25
	and R4,R26
	and R5,R27
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;     } else {
	xjmp L108
L107:
;         dcb->dcb_modeflags |= USART_MF_COOKEDMODE;
	ldi R24,128
	ldi R25,0
	ldi R26,0
	ldi R27,0
	movw R30,R22
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	or R2,R24
	or R3,R25
	or R4,R26
	or R5,R27
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;     }
L108:
; 
;     /* 
;      * For now we do the initialization here. Later we may implement
;      * a file creation routine to get a linked list of all opened
;      * files in the system.
;      */
;     fp->nf_next = 0;
	clr R2
	clr R3
	movw R30,R20
	std z+1,R3
	std z+0,R2
;     fp->nf_dev = dev;
	std z+3,R13
	std z+2,R12
;     fp->nf_fcb = 0;
	std z+5,R3
	std z+4,R2
; 
;     if ((mode & 0x0003) != _O_WRONLY) {
	movw R24,R10
	andi R24,3
	andi R25,0
	cpi R24,1
	ldi R30,0
	cpc R25,R30
	breq L109
X52:
;         (*dcb->dcb_rx_start) ();
	movw R30,R22
	ldd R26,z+59
	ldd R27,z+60
	movw R30,R26
	xcall  xicall
;     }
L109:
; 
;     return fp;
	movw R16,R20
L96:
	.dbline 0 ; func end
	adiw R28,4
	xjmp pop_xgsetF0FC
	.area func_lit(rom, con, rel)
L172:
	.word `L114
	.word `L115
	.word `L116
	.word `L117
	.word `L118
	.word `L119
	.word `L120
	.word `L121
	.word `L122
	.word `L133
	.word `L138
	.word `L139
	.word `L140
	.word `L141
	.word `L142
	.word `L145
	.word `L148
	.word `L149
	.word `L150
	.word `L153
	.word `L112
	.word `L112
	.word `L112
	.word `L112
	.word `L156
	.word `L157
	.word `L158
	.word `L161
	.word `L162
	.word `L163
	.word `L112
	.word `L164
	.word `L165
	.word `L166
	.word `L167
	.word `L168
	.word `L169
	.word `L170
	.word `L171
	.area text(rom, con, rel)
;            rbf -> R12,R13
;             bv -> R14
;             rc -> y+8
;             lv -> y+4
;            lvp -> R10,R11
;            dcb -> R22,R23
;           conf -> y+20
;            req -> R20,R21
;            dev -> R22,R23
	.even
_UsartIOCtl::
	xcall push_xgsetF0FC
	movw R20,R18
	movw R22,R16
	sbiw R28,10
; }
; 
; /*!
;  * \brief Perform USART control functions.
;  *
;  * This function is called by the ioctl() function of the C runtime
;  * library.
;  *
;  * \param dev  Identifies the device that receives the device-control
;  *             function.
;  * \param req  Requested control function. May be set to one of the
;  *             following constants:
;  *             - \ref UART_SETSPEED
;  *             - \ref UART_GETSPEED
;  *             - \ref UART_SETDATABITS
;  *             - \ref UART_GETDATABITS
;  *             - \ref UART_SETPARITY
;  *             - \ref UART_GETPARITY
;  *             - \ref UART_SETSTOPBITS
;  *             - \ref UART_GETSTOPBITS
;  *             - \ref UART_SETSTATUS
;  *             - \ref UART_GETSTATUS
;  *             - \ref UART_SETREADTIMEOUT
;  *             - \ref UART_GETREADTIMEOUT
;  *             - \ref UART_SETWRITETIMEOUT
;  *             - \ref UART_GETWRITETIMEOUT
;  *             - \ref UART_SETLOCALECHO
;  *             - \ref UART_GETLOCALECHO
;  *             - \ref UART_SETFLOWCONTROL
;  *             - \ref UART_GETFLOWCONTROL
;  *             - \ref UART_SETCOOKEDMODE
;  *             - \ref UART_GETCOOKEDMODE
;  *             - \ref UART_SETCLOCKMODE
;  *             - \ref UART_GETCLOCKMODE
;  *             - \ref UART_SETTXBUFSIZ
;  *             - \ref UART_GETTXBUFSIZ
;  *             - \ref UART_SETRXBUFSIZ
;  *             - \ref UART_GETRXBUFSIZ
;  *             - \ref UART_SETTXBUFLWMARK
;  *             - \ref UART_GETTXBUFLWMARK
;  *             - \ref UART_SETTXBUFHWMARK
;  *             - \ref UART_GETTXBUFHWMARK
;  *             - \ref UART_SETRXBUFLWMARK
;  *             - \ref UART_GETRXBUFLWMARK
;  *             - \ref UART_SETRXBUFHWMARK
;  *             - \ref UART_GETRXBUFHWMARK
;  *
;  * \param conf Points to a buffer that contains any data required for
;  *             the given control function or receives data from that
;  *             function.
;  * \return 0 on success, -1 otherwise.
;  *
;  * \warning Timeout values are given in milliseconds and are limited to 
;  *          the granularity of the system timer. To disable timeout,
;  *          set the parameter to NUT_WAIT_INFINITE.
;  */
; int UsartIOCtl(NUTDEVICE * dev, int req, void *conf)
; {
;     int rc = 0;
	clr R0
	clr R1
	std y+9,R1
	std y+8,R0
;     USARTDCB *dcb;
;     RINGBUF *rbf;
;     u_long *lvp = (u_long *) conf;
	ldd R10,y+20
	ldd R11,y+21
;     u_long lv = *lvp;
	movw R30,R10
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
;     u_char bv = (u_char) lv;
	ldd R2,y+4
	ldd R3,y+5
	ldd R4,y+6
	ldd R5,y+7
	mov R14,R2
; 
;     dcb = dev->dev_dcb;
	movw R30,R22
	ldd R22,z+17
	ldd R23,z+18
; 
;     switch (req) {
	cpi R20,1
	ldi R30,1
	cpc R21,R30
	brge X67
	xjmp L112
X67:
X53:
	ldi R24,295
	ldi R25,1
	cp R24,R20
	cpc R25,R21
	brge X68
	xjmp L112
X68:
X54:
	ldi R16,2
	ldi R17,0
	movw R18,R20
	xcall empy16s
	movw R30,R16
	ldi R24,<L172-514
	ldi R25,>L172-514
	add R30,R24
	adc R31,R25
	lpm R2,Z+
	lpm R3,Z
	movw R30,R2
	ijmp
L114:
;     case UART_SETSPEED:
;         rc = (*dcb->dcb_set_speed) (lv);
	ldd R16,y+4
	ldd R17,y+5
	ldd R18,y+6
	ldd R19,y+7
	movw R30,R22
	subi R30,191  ; addi 65
	sbci R31,255
	ldd R26,z+0
	ldd R27,z+1
	movw R30,R26
	xcall  xicall
	std y+9,R17
	std y+8,R16
;         break;
	xjmp L113
L115:
;     case UART_GETSPEED:
;         *lvp = (*dcb->dcb_get_speed) ();
	movw R30,R22
	subi R30,189  ; addi 67
	sbci R31,255
	ldd R26,z+0
	ldd R27,z+1
	movw R30,R26
	xcall  xicall
	movw R30,R10
	std z+0,R16
	std z+1,R17
	std z+2,R18
	std z+3,R19
;         break;
	xjmp L113
L116:
; 
;     case UART_SETDATABITS:
;         rc = (*dcb->dcb_set_data_bits) (bv);
	mov R16,R14
	movw R30,R22
	subi R30,187  ; addi 69
	sbci R31,255
	ldd R26,z+0
	ldd R27,z+1
	movw R30,R26
	xcall  xicall
	std y+9,R17
	std y+8,R16
;         break;
	xjmp L113
L117:
;     case UART_GETDATABITS:
;         *lvp = (*dcb->dcb_get_data_bits) ();
	movw R30,R22
	subi R30,185  ; addi 71
	sbci R31,255
	ldd R26,z+0
	ldd R27,z+1
	movw R30,R26
	xcall  xicall
	mov R12,R16
	mov R2,R12
	clr R3
	clr R4
	clr R5
	movw R30,R10
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;         break;
	xjmp L113
L118:
; 
;     case UART_SETPARITY:
;         rc = (*dcb->dcb_set_parity) (bv);
	mov R16,R14
	movw R30,R22
	subi R30,183  ; addi 73
	sbci R31,255
	ldd R26,z+0
	ldd R27,z+1
	movw R30,R26
	xcall  xicall
	movw R12,R16
	std y+9,R13
	std y+8,R12
;         break;
	xjmp L113
L119:
;     case UART_GETPARITY:
;         *lvp = (*dcb->dcb_get_parity) ();
	movw R30,R22
	subi R30,181  ; addi 75
	sbci R31,255
	ldd R26,z+0
	ldd R27,z+1
	movw R30,R26
	xcall  xicall
	mov R12,R16
	mov R2,R12
	clr R3
	clr R4
	clr R5
	movw R30,R10
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;         break;
	xjmp L113
L120:
; 
;     case UART_SETSTOPBITS:
;         rc = (*dcb->dcb_set_stop_bits) (bv);
	mov R16,R14
	movw R30,R22
	subi R30,179  ; addi 77
	sbci R31,255
	ldd R26,z+0
	ldd R27,z+1
	movw R30,R26
	xcall  xicall
	movw R12,R16
	std y+9,R13
	std y+8,R12
;         break;
	xjmp L113
L121:
;     case UART_GETSTOPBITS:
;         *lvp = (*dcb->dcb_get_stop_bits) ();
	movw R30,R22
	subi R30,177  ; addi 79
	sbci R31,255
	ldd R26,z+0
	ldd R27,z+1
	movw R30,R26
	xcall  xicall
	mov R12,R16
	mov R2,R12
	clr R3
	clr R4
	clr R5
	movw R30,R10
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;         break;
	xjmp L113
L122:
; 
;     case UART_SETSTATUS:
;         if (lv & UART_RXBUFFEREMPTY) {
	ldi R24,64
	ldi R25,0
	ldi R26,0
	ldi R27,0
	ldd R2,y+4
	ldd R3,y+5
	ldd R4,y+6
	ldd R5,y+7
	and R2,R24
	and R3,R25
	and R4,R26
	and R5,R27
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	cp R2,R24
	cpc R3,R25
	cpc R4,R26
	cpc R5,R27
	breq L123
X55:
;             rbf = &dcb->dcb_rx_rbf;
	movw R24,R22
	adiw R24,34
	movw R12,R24
;             rc = UsartResetBuffer(rbf, rbf->rbf_siz, rbf->rbf_lwm, rbf->rbf_hwm);
	movw R30,R24
	ldd R2,z+14
	ldd R3,z+15
	std y+3,R3
	std y+2,R2
	ldd R2,z+12
	ldd R3,z+13
	std y+1,R3
	std y+0,R2
	ldd R18,z+8
	ldd R19,z+9
	movw R16,R24
	xcall _UsartResetBuffer
	movw R20,R16
	std y+9,R21
	std y+8,R20
;             if (rc == 0) {
	movw R0,R16
	cpi R16,0
	cpc R16,R17
	brne L125
X56:
;                 (*dcb->dcb_rx_start) ();
	movw R30,R22
	ldd R26,z+59
	ldd R27,z+60
	movw R30,R26
	xcall  xicall
;             }
L125:
;         }
L123:
;         if (lv & UART_TXBUFFEREMPTY) {
	ldi R24,128
	ldi R25,0
	ldi R26,0
	ldi R27,0
	ldd R2,y+4
	ldd R3,y+5
	ldd R4,y+6
	ldd R5,y+7
	and R2,R24
	and R3,R25
	and R4,R26
	and R5,R27
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	cp R2,R24
	cpc R3,R25
	cpc R4,R26
	cpc R5,R27
	breq L127
X57:
;             rbf = &dcb->dcb_tx_rbf;
	movw R24,R22
	adiw R24,16
	movw R12,R24
;             if (rc == 0) {
	ldd R0,y+8
	ldd R1,y+9
	tst R0
	brne L129
	tst R1
	brne L129
X58:
;                 rc = UsartResetBuffer(rbf, rbf->rbf_siz, rbf->rbf_lwm, rbf->rbf_hwm);
	movw R30,R24
	ldd R2,z+14
	ldd R3,z+15
	std y+3,R3
	std y+2,R2
	ldd R2,z+12
	ldd R3,z+13
	std y+1,R3
	std y+0,R2
	ldd R18,z+8
	ldd R19,z+9
	movw R16,R24
	xcall _UsartResetBuffer
	movw R20,R16
	std y+9,R21
	std y+8,R20
;             }
L129:
;         }
L127:
;         if (rc == 0) {
	ldd R0,y+8
	ldd R1,y+9
	tst R0
	breq X69
	xjmp L113
X69:
	tst R1
	breq X70
	xjmp L113
X70:
X59:
;             rc = (*dcb->dcb_set_status) (lv & ~(UART_RXBUFFEREMPTY | UART_TXBUFFEREMPTY));
	ldi R24,63
	ldi R25,255
	ldi R26,255
	ldi R27,255
	ldd R16,y+4
	ldd R17,y+5
	ldd R18,y+6
	ldd R19,y+7
	and R16,R24
	and R17,R25
	and R18,R26
	and R19,R27
	movw R30,R22
	subi R30,175  ; addi 81
	sbci R31,255
	ldd R26,z+0
	ldd R27,z+1
	movw R30,R26
	xcall  xicall
	movw R20,R16
	std y+9,R21
	std y+8,R20
;         }
;         break;
	xjmp L113
L133:
;     case UART_GETSTATUS:
;         *lvp = (*dcb->dcb_get_status) ();
	movw R30,R22
	subi R30,173  ; addi 83
	sbci R31,255
	ldd R26,z+0
	ldd R27,z+1
	movw R30,R26
	xcall  xicall
	movw R30,R10
	std z+0,R16
	std z+1,R17
	std z+2,R18
	std z+3,R19
;         /*
;          * Determine buffer status.
;          */
;         if (dcb->dcb_rx_rbf.rbf_cnt == 0) {
	movw R30,R22
	ldd R2,z+44
	ldd R3,z+45
	tst R2
	brne L134
	tst R3
	brne L134
X60:
;             *lvp |= UART_RXBUFFEREMPTY;
	ldi R24,64
	ldi R25,0
	ldi R26,0
	ldi R27,0
	movw R30,R10
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	or R2,R24
	or R3,R25
	or R4,R26
	or R5,R27
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;         }
L134:
;         if (dcb->dcb_tx_rbf.rbf_cnt == 0) {
	movw R30,R22
	ldd R2,z+26
	ldd R3,z+27
	tst R2
	breq X71
	xjmp L113
X71:
	tst R3
	breq X72
	xjmp L113
X72:
X61:
;             *lvp |= UART_TXBUFFEREMPTY;
	ldi R24,128
	ldi R25,0
	ldi R26,0
	ldi R27,0
	movw R30,R10
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	or R2,R24
	or R3,R25
	or R4,R26
	or R5,R27
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;         }
;         break;
	xjmp L113
L138:
; 
;     case UART_SETREADTIMEOUT:
;         dcb->dcb_rtimeout = lv;
	ldd R2,y+4
	ldd R3,y+5
	ldd R4,y+6
	ldd R5,y+7
	movw R30,R22
	std z+8,R2
	std z+9,R3
	std z+10,R4
	std z+11,R5
;         break;
	xjmp L113
L139:
;     case UART_GETREADTIMEOUT:
;         *lvp = dcb->dcb_rtimeout;
	movw R30,R22
	ldd R2,z+8
	ldd R3,z+9
	ldd R4,z+10
	ldd R5,z+11
	movw R30,R10
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;         break;
	xjmp L113
L140:
; 
;     case UART_SETWRITETIMEOUT:
;         dcb->dcb_wtimeout = lv;
	ldd R2,y+4
	ldd R3,y+5
	ldd R4,y+6
	ldd R5,y+7
	movw R30,R22
	std z+12,R2
	std z+13,R3
	std z+14,R4
	std z+15,R5
;         break;
	xjmp L113
L141:
;     case UART_GETWRITETIMEOUT:
;         *lvp = dcb->dcb_wtimeout;
	movw R30,R22
	ldd R2,z+12
	ldd R3,z+13
	ldd R4,z+14
	ldd R5,z+15
	movw R30,R10
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;         break;
	xjmp L113
L142:
; 
;     case UART_SETLOCALECHO:
;         if (bv)
	tst R14
	breq L143
X62:
;             dcb->dcb_modeflags |= USART_MF_LOCALECHO;
	ldi R24,64
	ldi R25,0
	ldi R26,0
	ldi R27,0
	movw R30,R22
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	or R2,R24
	or R3,R25
	or R4,R26
	or R5,R27
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
	xjmp L113
L143:
;         else
;             dcb->dcb_modeflags &= ~USART_MF_LOCALECHO;
	ldi R24,191
	ldi R25,255
	ldi R26,255
	ldi R27,255
	movw R30,R22
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	and R2,R24
	and R3,R25
	and R4,R26
	and R5,R27
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;         break;
	xjmp L113
L145:
;     case UART_GETLOCALECHO:
;         if (dcb->dcb_modeflags & USART_MF_LOCALECHO)
	ldi R24,64
	ldi R25,0
	ldi R26,0
	ldi R27,0
	movw R30,R22
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	and R2,R24
	and R3,R25
	and R4,R26
	and R5,R27
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	cp R2,R24
	cpc R3,R25
	cpc R4,R26
	cpc R5,R27
	breq L146
X63:
;             *lvp = 1;
	ldi R24,1
	ldi R25,0
	ldi R26,0
	ldi R27,0
	movw R30,R10
	std z+0,R24
	std z+1,R25
	std z+2,R26
	std z+3,R27
	xjmp L113
L146:
;         else
;             *lvp = 0;
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	movw R30,R10
	std z+0,R24
	std z+1,R25
	std z+2,R26
	std z+3,R27
;         break;
	xjmp L113
L148:
; 
;     case UART_SETFLOWCONTROL:
;         rc = (*dcb->dcb_set_flow_control) (lv);
	ldd R16,y+4
	ldd R17,y+5
	ldd R18,y+6
	ldd R19,y+7
	movw R30,R22
	ldd R26,z+61
	ldd R27,z+62
	movw R30,R26
	xcall  xicall
	movw R20,R16
	std y+9,R21
	std y+8,R20
;         break;
	xjmp L113
L149:
;     case UART_GETFLOWCONTROL:
;         *lvp = (*dcb->dcb_get_flow_control) ();
	movw R30,R22
	adiw R30,63
	ldd R26,z+0
	ldd R27,z+1
	movw R30,R26
	xcall  xicall
	movw R30,R10
	std z+0,R16
	std z+1,R17
	std z+2,R18
	std z+3,R19
;         break;
	xjmp L113
L150:
; 
;     case UART_SETCOOKEDMODE:
;         if (bv)
	tst R14
	breq L151
X64:
;             dcb->dcb_modeflags |= USART_MF_COOKEDMODE;
	ldi R24,128
	ldi R25,0
	ldi R26,0
	ldi R27,0
	movw R30,R22
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	or R2,R24
	or R3,R25
	or R4,R26
	or R5,R27
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
	xjmp L113
L151:
;         else
;             dcb->dcb_modeflags &= ~USART_MF_COOKEDMODE;
	ldi R24,127
	ldi R25,255
	ldi R26,255
	ldi R27,255
	movw R30,R22
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	and R2,R24
	and R3,R25
	and R4,R26
	and R5,R27
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;         break;
	xjmp L113
L153:
;     case UART_GETCOOKEDMODE:
;         if (dcb->dcb_modeflags & USART_MF_COOKEDMODE)
	ldi R24,128
	ldi R25,0
	ldi R26,0
	ldi R27,0
	movw R30,R22
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	and R2,R24
	and R3,R25
	and R4,R26
	and R5,R27
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	cp R2,R24
	cpc R3,R25
	cpc R4,R26
	cpc R5,R27
	breq L154
X65:
;             *lvp = 1;
	ldi R24,1
	ldi R25,0
	ldi R26,0
	ldi R27,0
	movw R30,R10
	std z+0,R24
	std z+1,R25
	std z+2,R26
	std z+3,R27
	xjmp L113
L154:
;         else
;             *lvp = 0;
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	movw R30,R10
	std z+0,R24
	std z+1,R25
	std z+2,R26
	std z+3,R27
;         break;
	xjmp L113
L156:
; 
;     case UART_SETCLOCKMODE:
;         rc = (*dcb->dcb_set_clock_mode) (lv);
	ldd R16,y+4
	movw R30,R22
	subi R30,171  ; addi 85
	sbci R31,255
	ldd R26,z+0
	ldd R27,z+1
	movw R30,R26
	xcall  xicall
	movw R14,R16
	std y+9,R15
	std y+8,R14
;         break;
	xjmp L113
L157:
;     case UART_GETCLOCKMODE:
;         *lvp = (*dcb->dcb_get_clock_mode) ();
	movw R30,R22
	subi R30,169  ; addi 87
	sbci R31,255
	ldd R26,z+0
	ldd R27,z+1
	movw R30,R26
	xcall  xicall
	mov R14,R16
	mov R2,R14
	clr R3
	clr R4
	clr R5
	movw R30,R10
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;         break;
	xjmp L113
L158:
; 
;     case UART_SETTXBUFSIZ:
;         rbf = &dcb->dcb_tx_rbf;
	movw R24,R22
	adiw R24,16
	movw R12,R24
;         rc = UsartResetBuffer(rbf, (size_t) lv, rbf->rbf_lwm, rbf->rbf_hwm);
	movw R30,R24
	ldd R2,z+14
	ldd R3,z+15
	std y+3,R3
	std y+2,R2
	ldd R2,z+12
	ldd R3,z+13
	std y+1,R3
	std y+0,R2
	ldd R18,y+4
	ldd R19,y+5
	movw R16,R24
	xcall _UsartResetBuffer
	movw R14,R16
	std y+9,R15
	std y+8,R14
;         if (rc == 0) {
	movw R0,R14
	cpi R16,0
	cpc R16,R17
	breq X73
	xjmp L113
X73:
X66:
;             (*dcb->dcb_rx_start) ();
	movw R30,R22
	ldd R26,z+59
	ldd R27,z+60
	movw R30,R26
	xcall  xicall
;         }
;         break;
	xjmp L113
L161:
;     case UART_GETTXBUFSIZ:
;         *lvp = dcb->dcb_tx_rbf.rbf_siz;
	movw R30,R22
	ldd R2,z+24
	ldd R3,z+25
	clr R4
	clr R5
	movw R30,R10
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;         break;
	xjmp L113
L162:
; 
;     case UART_SETRXBUFSIZ:
;         rbf = &dcb->dcb_rx_rbf;
	movw R24,R22
	adiw R24,34
;         rc = UsartResetBuffer(rbf, (size_t) lv, rbf->rbf_lwm, rbf->rbf_hwm);
	movw R30,R24
	ldd R2,z+14
	ldd R3,z+15
	std y+3,R3
	std y+2,R2
	ldd R2,z+12
	ldd R3,z+13
	std y+1,R3
	std y+0,R2
	ldd R18,y+4
	ldd R19,y+5
	movw R16,R24
	xcall _UsartResetBuffer
	movw R12,R16
	std y+9,R13
	std y+8,R12
;         break;
	xjmp L113
L163:
;     case UART_GETRXBUFSIZ:
;         *lvp = dcb->dcb_rx_rbf.rbf_siz;
	movw R30,R22
	ldd R2,z+42
	ldd R3,z+43
	clr R4
	clr R5
	movw R30,R10
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;         break;
	xjmp L113
L164:
; 
;     case UART_SETTXBUFLWMARK:
;         NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
;         dcb->dcb_tx_rbf.rbf_lwm = (size_t) lv;
	ldd R2,y+4
	ldd R3,y+5
	movw R30,R22
	std z+29,R3
	std z+28,R2
;         NutExitCritical();
	pop R0
	out 0x3F, R0
	
;         break;
	xjmp L113
L165:
;     case UART_GETTXBUFLWMARK:
;         *lvp = dcb->dcb_tx_rbf.rbf_lwm;
	movw R30,R22
	ldd R2,z+28
	ldd R3,z+29
	clr R4
	clr R5
	movw R30,R10
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;         break;
	xjmp L113
L166:
; 
;     case UART_SETTXBUFHWMARK:
;         NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
;         dcb->dcb_tx_rbf.rbf_hwm = (size_t) lv;
	ldd R2,y+4
	ldd R3,y+5
	movw R30,R22
	std z+31,R3
	std z+30,R2
;         NutExitCritical();
	pop R0
	out 0x3F, R0
	
;         break;
	xjmp L113
L167:
;     case UART_GETTXBUFHWMARK:
;         *lvp = dcb->dcb_tx_rbf.rbf_hwm;
	movw R30,R22
	ldd R2,z+30
	ldd R3,z+31
	clr R4
	clr R5
	movw R30,R10
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;         break;
	xjmp L113
L168:
; 
;     case UART_SETRXBUFLWMARK:
;         NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
;         dcb->dcb_rx_rbf.rbf_lwm = (size_t) lv;
	ldd R2,y+4
	ldd R3,y+5
	movw R30,R22
	std z+47,R3
	std z+46,R2
;         NutExitCritical();
	pop R0
	out 0x3F, R0
	
;         break;
	xjmp L113
L169:
;     case UART_GETRXBUFLWMARK:
;         *lvp = dcb->dcb_rx_rbf.rbf_lwm;
	movw R30,R22
	ldd R2,z+46
	ldd R3,z+47
	clr R4
	clr R5
	movw R30,R10
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;         break;
	xjmp L113
L170:
; 
;     case UART_SETRXBUFHWMARK:
;         NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
;         dcb->dcb_rx_rbf.rbf_hwm = (size_t) lv;
	ldd R2,y+4
	ldd R3,y+5
	movw R30,R22
	std z+49,R3
	std z+48,R2
;         NutExitCritical();
	pop R0
	out 0x3F, R0
	
;         break;
	xjmp L113
L171:
;     case UART_GETRXBUFHWMARK:
;         *lvp = dcb->dcb_rx_rbf.rbf_hwm;
	movw R30,R22
	ldd R2,z+48
	ldd R3,z+49
	clr R4
	clr R5
	movw R30,R10
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;         break;
	xjmp L113
L112:
; 
;     default:
;         rc = -1;
	ldi R24,-1
	ldi R25,-1
	std y+9,R25
	std y+8,R24
;         break;
L113:
;     }
;     return rc;
	ldd R16,y+8
	ldd R17,y+9
L111:
	.dbline 0 ; func end
	adiw R28,10
	xjmp pop_xgsetF0FC
;            rbf -> R20,R21
;            dcb -> R20,R21
;            dev -> R20,R21
;          avail -> y+0
;             fp -> R16,R17
	.even
_UsartSize::
	st -y,R20
	st -y,R21
	sbiw R28,4
; }
; 
; /*!
;  * \brief Retrieves the number of characters in input buffer.
;  *
;  * This function is called by the low level size routine of the C runtime 
;  * library, using the _NUTDEVICE::dev_size entry.
;  *
;  * \param fp     Pointer to a \ref _NUTFILE structure, obtained by a 
;  *               previous call to UsartOpen().
;  *
;  * \return The number of bytes currently stored in input buffer.
;  */
; long UsartSize (NUTFILE *fp)
; {
;     long avail;
;     NUTDEVICE *dev = fp->nf_dev;
	movw R30,R16
	ldd R20,z+2
	ldd R21,z+3
;     USARTDCB *dcb = dev->dev_dcb;
	movw R30,R20
	ldd R20,z+17
	ldd R21,z+18
;     RINGBUF *rbf = &dcb->dcb_rx_rbf;
	subi R20,222  ; offset = 34
	sbci R21,255
; 
;     /* Atomic access to the ring buffer counter. */
;     NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
;     avail = rbf->rbf_cnt;
	movw R30,R20
	ldd R2,z+10
	ldd R3,z+11
	clr R4
	clr R5
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
;     NutExitCritical();
	pop R0
	out 0x3F, R0
	
; 
;     return avail;
	ldd R16,y+0
	ldd R17,y+1
	ldd R18,y+2
	ldd R19,y+3
L174:
	.dbline 0 ; func end
	adiw R28,4
	ld R21,y+
	ld R20,y+
	ret
; }
; 
; 
; /*@}*/
