	.module dirent.c
	.area text(rom, con, rel)
;            dev -> R22,R23
;       dev_name -> y+2
;            dir -> R20,R21
;           nidx -> R22
;           nptr -> R10,R11
;           name -> R12,R13
	.even
_opendir::
	xcall push_xgsetF0FC
	movw R12,R16
	sbiw R28,11
; /*
;  * Copyright (C) 2004-2005 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  *-
;  * Parts are
;  *
;  * Copyright (c) 1989, 1993
;  *      The Regents of the University of California.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the University nor the names of its contributors
;  *    may be used to endorse or promote products derived from this software
;  *    without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
;  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
;  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
;  * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
;  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
;  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
;  * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
;  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
;  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
;  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  */
; 
; /*!
;  * \file fs/dirent.c
;  * \brief Directory functions.
;  *
;  * \verbatim
;  *
;  * $Log: dirent.c,v $
;  * Revision 1.2  2005/02/07 18:57:47  haraldkipp
;  * ICCAVR compile errors fixed
;  *
;  * Revision 1.1  2005/02/05 20:35:21  haraldkipp
;  * Peanut added
;  *
;  *
;  * \endverbatim
;  */
; 
; #include <sys/device.h>
; 
; #include <stdlib.h>
; #include <string.h>
; #include <stdio.h>
; #include <errno.h>
; 
; #include <fs/fs.h>
; 
; #include <dirent.h>
; 
; /*!
;  * \addtogroup xgFSDir
;  */
; /*@{*/
; 
; /*!
;  * \brief Open a directory stream.
;  *
;  * Opens a directory and associates a directory stream with it.
;  *
;  * \param name Pathname of the directory. Must be the full pathname
;  *             including the device, because Nut/OS doesn't support 
;  *             relative paths.
;  *
;  * \return A pointer used to identify the directory stream in subsequent 
;  *         operations. NULL is returned if the directory cannot be accessed, 
;  *         or if it cannot allocate enough memory.
;  */
; DIR *opendir(CONST char *name)
; {
;     DIR *dir = 0;
	clr R20
	clr R21
;     NUTDEVICE *dev;
;     u_char dev_name[9];
;     u_char nidx;
;     CONST char *nptr = name;
	movw R10,R12
; 
;     /* Extract the device name. */
;     for (nidx = 0; *nptr && *nptr != ':' && nidx < 8; nidx++) {
	clr R22
	xjmp L7
L4:
;         dev_name[nidx] = *nptr++;
	movw R24,R28
	adiw R24,2
	mov R30,R22
	clr R31
	add R30,R24
	adc R31,R25
	movw R26,R10
	ld R2,X+
	movw R10,R26
	std z+0,R2
;     }
L5:
	inc R22
L7:
	movw R30,R10
	ldd R2,z+0
	clr R3
	tst R2
	breq L9
X0:
	mov R24,R2
	cpi R24,58
	breq L9
X1:
	cpi R22,8
	brlo L4
X2:
L9:
;     dev_name[nidx] = 0;
	movw R24,R28
	adiw R24,2
	mov R30,R22
	clr R31
	add R30,R24
	adc R31,R25
	clr R2
	std z+0,R2
; 
;     /* Get device structure of registered device. */
;     if ((dev = NutDeviceLookup(dev_name)) == 0) {
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _NutDeviceLookup
	movw R22,R16
	cpi R22,0
	cpc R22,R23
	brne L10
X3:
;         errno = ENODEV;
	ldi R24,19
	ldi R25,0
	sts _errno+1,R25
	sts _errno,R24
;         return 0;
	clr R16
	clr R17
	xjmp L3
L10:
;     }
; 
;     /* Allocate and initialize the stream. */
;     if ((dir = malloc(sizeof(DIR))) == 0) {
	ldi R16,10
	ldi R17,0
	xcall _malloc_M
	movw R14,R16
	movw R20,R14
	cpi R16,0
	cpc R16,R17
	brne L12
X4:
;         errno = ENOMEM;
	ldi R24,12
	ldi R25,0
	sts _errno+1,R25
	sts _errno,R24
;         return 0;
	clr R16
	clr R17
	xjmp L3
L12:
;     }
;     memset(dir, 0, sizeof(DIR));
	ldi R24,10
	ldi R25,0
	std y+1,R25
	std y+0,R24
	clr R18
	clr R19
	movw R16,R20
	xcall _memset
;     dir->dd_fd.nf_dev = dev;
	movw R30,R20
	std z+3,R23
	std z+2,R22
; 
;     /* Allocate and initialize the data buffer. */
;     if ((dir->dd_len = strlen(name + 1)) < sizeof(struct dirent)) {
	movw R16,R12
	subi R16,255  ; offset = 1
	sbci R17,255
	xcall _strlen
	movw R12,R16
	movw R30,R20
	std z+9,R13
	std z+8,R12
	cpi R16,8
	ldi R26,1
	cpc R17,R26
	brsh L14
X5:
;         dir->dd_len = sizeof(struct dirent);
	ldi R24,264
	ldi R25,1
	std z+9,R25
	std z+8,R24
;     }
L14:
;     if ((dir->dd_buf = malloc(dir->dd_len)) == 0) {
	movw R30,R20
	ldd R16,z+8
	ldd R17,z+9
	xcall _malloc_M
	movw R12,R16
	movw R30,R20
	std z+7,R13
	std z+6,R12
	cpi R16,0
	cpc R16,R17
	brne L16
X6:
;         free(dir);
	movw R16,R30
	xcall _free_M
;         errno = ENOMEM;
	ldi R24,12
	ldi R25,0
	sts _errno+1,R25
	sts _errno,R24
;         return 0;
	clr R16
	clr R17
	xjmp L3
L16:
;     }
;     if (*nptr == ':') {
	movw R30,R10
	ldd R24,z+0
	cpi R24,58
	brne L18
X7:
;         nptr++;
	movw R24,R30
	adiw R24,1
	movw R10,R24
;     }
L18:
;     strcpy(dir->dd_buf, nptr);
	movw R18,R10
	movw R30,R20
	ldd R16,z+6
	ldd R17,z+7
	xcall _strcpy
; 
;     /* Call the proper IOCTL. */
;     if ((*dev->dev_ioctl) (dev, FS_DIR_OPEN, dir)) {
	std y+1,R21
	std y+0,R20
	ldi R18,4371
	ldi R19,17
	movw R16,R22
	movw R30,R22
	ldd R26,z+21
	ldd R27,z+22
	movw R30,R26
	xcall  xicall
	movw R10,R16
	cpi R16,0
	cpc R16,R17
	breq L20
X8:
;         free(dir->dd_buf);
	movw R30,R20
	ldd R16,z+6
	ldd R17,z+7
	xcall _free_M
;         free(dir);
	movw R16,R20
	xcall _free_M
;         dir = 0;
	clr R20
	clr R21
;     }
L20:
;     return dir;
	movw R16,R20
L3:
	.dbline 0 ; func end
	adiw R28,11
	xjmp pop_xgsetF0FC
;            dev -> R22,R23
;            dir -> R20,R21
	.even
_closedir::
	xcall push_xgsetF000
	movw R20,R16
	sbiw R28,2
; }
; 
; /*!
;  * \brief Close a directory stream.
;  *
;  * Closes the given directory stream and frees any allocated memory.
;  *
;  * \param dir Pointer to the directory stream.
;  *
;  * \return 0 on success. On failure, -1 is returned and the global 
;  *         variable errno is set to indicate the error.
;  */
; int closedir(DIR * dir)
; {
;     NUTDEVICE *dev;
; 
;     if (dir) {
	cpi R20,0
	cpc R20,R21
	breq L23
X9:
;         dev = dir->dd_fd.nf_dev;
	movw R30,R20
	ldd R22,z+2
	ldd R23,z+3
;         (*dev->dev_ioctl) (dev, FS_DIR_CLOSE, dir);
	std y+1,R21
	std y+0,R20
	ldi R18,4372
	ldi R19,17
	movw R16,R22
	movw R30,R22
	ldd R26,z+21
	ldd R27,z+22
	movw R30,R26
	xcall  xicall
;         if (dir->dd_buf) {
	movw R30,R20
	ldd R2,z+6
	ldd R3,z+7
	tst R2
	brne X10
	tst R3
	breq L25
X10:
;             free(dir->dd_buf);
	ldd R16,z+6
	ldd R17,z+7
	xcall _free_M
;         }
L25:
;         free(dir);
	movw R16,R20
	xcall _free_M
;     }
L23:
;     return 0;
	clr R16
	clr R17
L22:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgsetF000
;            dev -> R22,R23
;            dir -> R20,R21
	.even
_readdir::
	xcall push_xgsetF000
	movw R20,R16
	sbiw R28,2
; }
; 
; /*!
;  * \brief Get the next directory entry.
;  *
;  * \param dir Pointer to the directory stream.
;  *
;  * \return A pointer to the next directory entry. It returns NULL upon 
;  *         reaching the end of the directory.
;  */
; struct dirent *readdir(DIR * dir)
; {
;     NUTDEVICE *dev = dir->dd_fd.nf_dev;
	movw R30,R20
	ldd R22,z+2
	ldd R23,z+3
; 
;     if ((*dev->dev_ioctl) (dev, FS_DIR_READ, dir)) {
	std y+1,R21
	std y+0,R20
	ldi R18,4373
	ldi R19,17
	movw R16,R22
	movw R30,R22
	ldd R26,z+21
	ldd R27,z+22
	movw R30,R26
	xcall  xicall
	cpi R16,0
	cpc R16,R17
	breq L28
X11:
;         return 0;
	clr R16
	clr R17
	xjmp L27
L28:
;     }
;     return (struct dirent *) (dir->dd_buf);
	movw R30,R20
	ldd R16,z+6
	ldd R17,z+7
L27:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgsetF000
; }
; 
; /*@}*/
