	.module fat.c
	.area data(ram, con, rel)
_gnIsInit:
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
_pSectorBuffer:
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
_pLongName1:
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
_pLongName2:
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.area text(rom, con, rel)
	.even
_FATLock::
	sbiw R28,2
; /****************************************************************************
; *  This file is part of the AVRIDE device driver.
; *
; *  Copyright (c) 2002-2003 by Michael Fischer. All rights reserved.
; *
; *  Redistribution and use in source and binary forms, with or without 
; *  modification, are permitted provided that the following conditions 
; *  are met:
; *  
; *  1. Redistributions of source code must retain the above copyright 
; *     notice, this list of conditions and the following disclaimer.
; *  2. Redistributions in binary form must reproduce the above copyright
; *     notice, this list of conditions and the following disclaimer in the 
; *     documentation and/or other materials provided with the distribution.
; *  3. Neither the name of the author nor the names of its contributors may 
; *     be used to endorse or promote products derived from this software 
; *     without specific prior written permission.
; *
; *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
; *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
; *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
; *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
; *  THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
; *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
; *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS 
; *  OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
; *  AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
; *  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF 
; *  THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
; *  SUCH DAMAGE.
; *
; ****************************************************************************
; *  History:
; *
; *  14.12.02  mifi   First Version 
; *  23.12.02  mifi   Add FileOpen, FileClose, FileError, FileSize,
; *                   FileSeek and FileRead. But the FileSeek function.
; *                   does not work in the moment, later...
; *  28.12.02  mifi   Now support FAT16 AND FAT32.
; *  01.01.03  mifi   Support long directory entries, but without to 
; *                   check the checksum of the short entry.
; *                   Change FAT32FileSize return value from int to long.
; *                   The max size of a long filename segment is
; *                   (FAT_LONG_NAME_LEN-1). But the complete filename can
; *                   be longer. 
; *
; *                   segment1/segment2/segment3/index.html
; *
; *                   segmentX max length = (FAT_LONG_NAME_LEN-1)
; *
; *  04.01.03  mifi   Take a look at the return values...
; *  18.01.03  mifi   Change Licence from GPL to BSD.
; *  25.01.03  mifi   Implement a new FindFile function.
; *                   I have some trouble with short file names under
; *                   Win98. Win98 store a short name like "enlogo.gif"
; *                   as a long name, nasty OS. 
; *                   Remove FAT32_MAX_FILES and the array aFileHandle,
; *                   a file handle will now be allocated by NutHeapAlloc, 
; *                   therefore we have no restrictions about the count of 
; *                   the open file handle. (Only by available memory)
; *  27.01.03  mifi   Rename all FAT32xxx function to FATxxx.
; *
; *  28.01.03  mifi   Start porting to Nut/OS 3.X.X
; *  19.06.03  mifi   Change the call of IDEInit, now we use the BaseAddress
; *                   of 0. Because the fat module does not need to know the
; *                   address. It will be handled in ide.c.
; *  29.06.03  mifi   First ATAPI-Version
; *                   Now we can read files from a CD-ROM. But there exist
; *                   some open points:
; *                   - only first session from a multisession CD is supported
; *                   - only iso9660, no Joliet support now, later
; ****************************************************************************/
; #define __FAT_C__
; 
; #include <string.h>
; #include <stddef.h>
; #include <ctype.h>
; 
; #include <sys/heap.h>
; #include <sys/event.h>
; #include <sys/thread.h>
; 
; #include <sys/device.h>
; 
; #include <dev/ide.h>
; #include <fs/fat.h>
; #include <fs/typedefs.h>
; 
; /*==========================================================*/
; /*  DEFINE: All Structures and Common Constants             */
; /*==========================================================*/
; //
; // FAT return codes
; //
; #define FAT_OK                0
; #define FAT_ERROR             -1
; #define FAT_ERROR_EOF         -2
; #define FAT_ERROR_IDE         -3
; 
; //
; // Define for correct return values Nut/OS
; //
; #define NUTDEV_OK                       0
; #define NUTDEV_ERROR                    -1
; 
; 
; #define FAT_MAX_DRIVE                   2
; 
; //
; // Some defines for the FAT structures
; //
; #define ZIP_DRIVE_BR_SECTOR             32
; 
; #define BPB_RsvdSecCnt                  32
; #define BPB_NumFATs                     2
; #define BPB_HiddSec                     63
; 
; #define FAT32_MEDIA                     0xf8
; 
; #define FAT32_OFFSET_FSINFO             1
; #define FAT32_OFFSET_BACKUP_BOOT        6
; 
; #define FAT16_CLUSTER_EOF               0x0000FFFF
; #define FAT16_CLUSTER_ERROR             0x0000FFF7
; #define FAT16_CLUSTER_MASK              0x0000FFFF
; 
; #define FAT32_CLUSTER_EOF               0x0FFFFFFF
; #define FAT32_CLUSTER_ERROR             0x0FFFFFF7
; #define FAT32_CLUSTER_MASK              0x0FFFFFFF
; 
; #define FAT_SIGNATURE                   0xAA55
; 
; #define MBR_SIGNATURE                   FAT_SIGNATURE
; #define MBR_FAT32                       0x0C
; 
; #define FSINFO_FIRSTSIGNATURE           0x41615252
; #define FSINFO_FSINFOSIGNATURE          0x61417272
; #define FSINFO_SIGNATURE                FAT_SIGNATURE
; 
; #define DIRECTORY_ATTRIBUTE_READ_ONLY   0x01
; #define DIRECTORY_ATTRIBUTE_HIDDEN      0x02
; #define DIRECTORY_ATTRIBUTE_SYSTEM_FILE 0x04
; #define DIRECTORY_ATTRIBUTE_VOLUME_ID   0x08
; #define DIRECTORY_ATTRIBUTE_DIRECTORY   0x10
; #define DIRECTORY_ATTRIBUTE_ARCHIVE     0x20
; 
; //
; // DIRECTORY_ATTRIBUTE_READ_ONLY   |
; // DIRECTORY_ATTRIBUTE_HIDDEN      |
; // DIRECTORY_ATTRIBUTE_SYSTEM_FILE |
; // DIRECTORY_ATTRIBUTE_VOLUME_ID
; //
; #define DIRECTORY_ATTRIBUTE_LONG_NAME   0x0F
; 
; //
; // DIRECTORY_ATTRIBUTE_READ_ONLY   |
; // DIRECTORY_ATTRIBUTE_HIDDEN      |
; // DIRECTORY_ATTRIBUTE_SYSTEM_FILE |
; // DIRECTORY_ATTRIBUTE_VOLUME_ID   |
; // DIRECTORY_ATTRIBUTE_DIRECTORY   |
; // DIRECTORY_ATTRIBUTE_ARCHIVE
; // 
; #define DIRECTORY_ATTRIBUTE_LONG_NAME_MASK  0x3F
; 
; #define FAT_NAME_LEN                    8
; #define FAT_EXT_LEN                     3
; 
; //
; // FAT_SHORT_NAME_LEN name len = 
; // name + ext + 1 for the point
; //
; #define FAT_SHORT_NAME_LEN              (FAT_NAME_LEN+FAT_EXT_LEN+1)
; #define FAT_LONG_NAME_LEN               64
; 
; 
; //
; // Some stuff for HD and CD, DRIVE_INFO Flags
; // 
; //
; #define FLAG_FAT_IS_CDROM               0x0001
; #define FLAG_FAT_IS_ZIP                 0x0002
; 
; //
; //  DiskSize to SectorPerCluster table
; //
; typedef struct {
;     DWORD DiskSize;
;     BYTE SecPerClusVal;
; } DSKSZTOSECPERCLUS;
; 
; typedef struct _FAT32FileDataTime {
;     unsigned Seconds:5;
;     unsigned Minute:6;
;     unsigned Hour:5;
;     unsigned Day:5;
;     unsigned Month:4;
;     unsigned Year:7;
; } FAT32_FILEDATETIME, *PFAT32_FILEDATETIME;
; 
; typedef struct _FAT32DirectoryEntry {
;     BYTE Name[FAT_NAME_LEN];
;     BYTE Extension[FAT_EXT_LEN];
;     BYTE Attribute;
;     BYTE Reserved[8];
;     WORD HighCluster;
;     FAT32_FILEDATETIME Date;
;     WORD LowCluster;
;     DWORD FileSize;
; } FAT32_DIRECTORY_ENTRY;
; 
; typedef struct _FAT32DirectoryEntryLong {
;     BYTE Order;
;     WORD Name1[5];
;     BYTE Attribute;
;     BYTE Type;
;     BYTE Chksum;
;     WORD Name2[6];
;     WORD LowCluster;
;     WORD Name3[2];
; } FAT32_DIRECTORY_ENTRY_LONG;
; 
; typedef struct _FAT32FileSystemInformation {
;     DWORD FirstSignature;
;     BYTE Reserved1[480];
;     DWORD FSInfoSignature;
;     DWORD NumberOfFreeClusters;
;     DWORD MostRecentlyAllocatedCluster;
;     BYTE Reserved2[12];
;     BYTE Reserved3[2];
;     WORD Signature;
; } FAT32_FSINFO;
; 
; typedef struct _FAT32PartitionEntry {
;     BYTE BootInd;
;     BYTE FirstHead;
;     BYTE FirstSector;
;     BYTE FirstTrack;
;     BYTE FileSystem;
;     BYTE LastHead;
;     BYTE LastSector;
;     BYTE LastTrack;
;     DWORD StartSectors;
;     DWORD NumSectors;
; } FAT32_PARTITION_ENTRY;
; 
; typedef struct _FAT32PartionTable {
;     BYTE LoadInstruction[446];
;     FAT32_PARTITION_ENTRY Partition[4];
;     WORD Signature;             /* AA55 */
; } FAT32_PARTITION_TABLE;
; 
; typedef struct _bpbfat16 {
;     BYTE DrvNum;
;     BYTE Reserved1;
;     BYTE BootSig;
;     DWORD VollID;
;     BYTE VolLab[11];
;     BYTE FilSysType[8];
;     BYTE Reserved2[28];
; } BPBFAT16;
; 
; typedef struct _bpbfat32 {
;     DWORD FATSz32;              // xxx
;     WORD ExtFlags;              // 0
;     WORD FSVer;                 // must 0
;     DWORD RootClus;             // 
;     WORD FSInfo;                // typically 1
;     WORD BkBootSec;             // typically 6
;     BYTE Reserved[12];          // set all to zero
;     BYTE DrvNum;                // must 0x80
;     BYTE Reserved1;             // set all to zero
;     BYTE BootSig;               // must 0x29 
;     DWORD VollID;               // xxx
;     BYTE VolLab[11];            // "abcdefghijk"
;     BYTE FilSysType[8];         // "FAT32   "
; } BPBFAT32;
; 
; typedef union _bpboffset36 {
;     BPBFAT16 FAT16;
;     BPBFAT32 FAT32;
; } BPBOFFSET36;
; 
; typedef struct _FAT32BootRecord {
;     BYTE JumpBoot[3];           // 0xeb, 0x58, 0x90
;     BYTE OEMName[8];            // "MSWIN4.1"
;     WORD BytsPerSec;            // must 512
;     BYTE SecPerClus;            // 8 for 4K cluster
;     WORD RsvdSecCnt;            // typically 32 for FAT32
;     BYTE NumFATs;               // always 2
;     WORD RootEntCnt;            // must 0 for FAT32
;     WORD TotSec16;              // must 0 for FAT32
;     BYTE Media;                 // must 0xf8
; 
;     WORD FATSz16;               // 0   for FAT32
;     WORD SecPerTrk;             // 63  for FAT32
;     WORD NumHeads;              // 255 for FAT32
;     DWORD HiddSec;              // 63  for FAT32
; 
;     DWORD TotSec32;             // xxx
; 
;     BPBOFFSET36 Off36;
; 
;     BYTE Reserved[420];
;     WORD Signature;             // must 0xAA55
; } FAT32_BOOT_RECORD, *PFAT32_BOOT_RECORD;
; 
; typedef struct _fat_entry_table16 {
;     WORD aEntry[256];
; } FAT_ENTRY_TABLE16;
; 
; typedef struct _fat_entry_table32 {
;     DWORD aEntry[128];
; } FAT_ENTRY_TABLE32;
; 
; typedef union _fat_dir_table {
;     FAT32_DIRECTORY_ENTRY aShort[16];
;     FAT32_DIRECTORY_ENTRY_LONG aLong[16];
; } FAT_DIR_TABLE;
; 
; typedef struct _drive_info {
;     BYTE bIsFAT32;
;     BYTE bDevice;
;     BYTE bSectorsPerCluster;
;     BYTE bFlags;
; 
;     WORD wSectorSize;
; 
;     DWORD dwRootDirSectors;
;     DWORD dwFirstRootDirSector;
; 
;     DWORD dwRootCluster;
;     DWORD dwFAT1StartSector;
;     DWORD dwFAT2StartSector;
;     DWORD dwCluster2StartSector;
; 
;     DWORD dwClusterSize;
; } DRIVE_INFO;
; 
; typedef struct _fhandle {
;     DWORD dwFileSize;
;     DWORD dwStartCluster;
;     DWORD dwReadCluster;
;     DWORD dwFilePointer;        /* total file pointer   */
;     DWORD dwClusterPointer;     /* cluster read pointer */
; 
;     int nLastError;
;     int nEOF;
; 
;     DRIVE_INFO *pDrive;
; } FHANDLE;
; 
; #if (IDE_SUPPORT_ATAPI == 1)
; //
; // Some ATAPI stuff
; //
; typedef struct _atapi_pvd {
;     BYTE descr_type;
;     BYTE magic[5];
;     BYTE descr_ver;
;     BYTE unused;
;     BYTE sysid[32];
;     BYTE volid[32];
;     BYTE zeros1[8];
;     BYTE seknum[8];
;     BYTE zeros2[32];
;     BYTE volsetsize[4];
;     BYTE volseqnum[4];
;     BYTE seksize[4];
;     BYTE pathtablen[8];
;     BYTE firstsek_LEpathtab1_LE[4];
;     BYTE firstsek_LEpathtab2_LE[4];
;     BYTE firstsek_BEpathtab1_BE[4];
;     BYTE firstsek_BEpathtab2_BE[4];
;     BYTE rootdir[34];
;     BYTE volsetid[128];
;     BYTE pubid[128];
;     BYTE dataprepid[128];
;     BYTE appid[128];
;     BYTE copyr[37];
;     BYTE abstractfileid[37];
;     BYTE bibliofileid[37];
;     BYTE creationdate[17];
;     BYTE modify[17];
;     BYTE expire[17];
;     BYTE effective[17];
;     BYTE filestruc_ver;
;     BYTE zero;
;     BYTE app_use[512];
;     BYTE res[653];
; } ATAPI_PVD;
; 
; //
; // Descriptor values
; //
; #define ATAPI_BOOT_RECORD   0x00
; #define ATAPI_PVD_DESC      0x01
; #define ATAPI_SVD_DESC      0x02
; #define ATAPI_VDST_DESC     0xFF
; 
; typedef struct _ATAPIDirectoryRecord {
;     BYTE bRecordSize;
;     BYTE bShouldBeZero;
;     DWORD dwFirstSector;
;     DWORD dwNotUse1;
;     DWORD dwEntrySize;
;     DWORD dwNotUse2;
;     BYTE bDate[7];
;     BYTE bFlags;
;     BYTE bInterleaveInfo[2];
;     BYTE bVolumeSequenceNumber[4];
;     BYTE bIdentifierLength;
;     BYTE bName[1];
; } ATAPI2_DIRECTORY_RECORD;
; #endif
; 
; /*==========================================================*/
; /*  DEFINE: Definition of all local Data                    */
; /*==========================================================*/
; static int gnIsInit = FALSE;
; 
; static BYTE *pSectorBuffer = NULL;
; static char *pLongName1 = NULL;
; static char *pLongName2 = NULL;
; static DRIVE_INFO sDriveInfo[FAT_MAX_DRIVE];
; 
; static HANDLE hFATSemaphore;
; /*==========================================================*/
; /*  DEFINE: Definition of all local Procedures              */
; /*==========================================================*/
; /************************************************************/
; /*  FATLock                                                 */
; /************************************************************/
; void FATLock(void)
; {
;     NutEventWait(&hFATSemaphore, 0);
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+0,R26
	std y+1,R27
	movw R18,R24
	ldi R16,<_hFATSemaphore
	ldi R17,>_hFATSemaphore
	xcall _NutEventWait
L2:
	.dbline 0 ; func end
	adiw R28,2
	ret
	.even
_FATFree::
; }
; 
; /************************************************************/
; /*  FATFree                                                 */
; /************************************************************/
; void FATFree(void)
; {
;     NutEventPost(&hFATSemaphore);
	ldi R16,<_hFATSemaphore
	ldi R17,>_hFATSemaphore
	xcall _NutEventPost
L3:
	.dbline 0 ; func end
	ret
	.even
_FATSemaInit::
; }
; 
; /************************************************************/
; /*  FATSemaInit                                             */
; /************************************************************/
; void FATSemaInit(void)
; {
;     NutEventPost(&hFATSemaphore);
	ldi R16,<_hFATSemaphore
	ldi R17,>_hFATSemaphore
	xcall _NutEventPost
L4:
	.dbline 0 ; func end
	ret
;       dwSector -> y+0
;      dwCluster -> y+10
;         pDrive -> R10,R11
	.even
_GetFirstSectorOfCluster:
	st -y,r19
	st -y,r18
	xcall push_xgsetF00C
	movw R10,R16
	sbiw R28,4
; }
; 
; /************************************************************/
; /*  GetFirstSectorOfCluster                                 */
; /************************************************************/
; static DWORD GetFirstSectorOfCluster(DRIVE_INFO * pDrive, DWORD dwCluster)
; {
;     DWORD dwSector;
; 
;     if (pDrive->bFlags & FLAG_FAT_IS_CDROM) {
	movw R30,R10
	ldd R2,z+3
	sbrs R2,0
	rjmp L6
X0:
;         dwSector = dwCluster;
	ldd R2,y+10
	ldd R3,y+11
	ldd R4,y+12
	ldd R5,y+13
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
;     } else {
	xjmp L7
L6:
;         dwSector = (dwCluster - 2) * pDrive->bSectorsPerCluster;
	ldi R20,2
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R16,y+10
	ldd R17,y+11
	ldd R18,y+12
	ldd R19,y+13
	sub R16,R20
	sbc R17,R21
	sbc R18,R22
	sbc R19,R23
	movw R30,R10
	ldd R2,z+2
	clr R3
	clr R4
	clr R5
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	xcall empy32u
	std y+0,R16
	std y+1,R17
	std y+2,R18
	std y+3,R19
;         dwSector += pDrive->dwCluster2StartSector;
	movw R30,R10
	ldd R2,z+26
	ldd R3,z+27
	ldd R4,z+28
	ldd R5,z+29
	ldd R6,y+0
	ldd R7,y+1
	ldd R8,y+2
	ldd R9,y+3
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	std y+0,R6
	std y+1,R7
	std y+2,R8
	std y+3,R9
;     }
L7:
; 
;     return (dwSector);
	ldd R16,y+0
	ldd R17,y+1
	ldd R18,y+2
	ldd R19,y+3
L5:
	.dbline 0 ; func end
	adiw R28,4
	xcall pop_xgsetF00C
	adiw R28,2
	ret
;    pFatTable32 -> R12,R13
;    pFatTable16 -> R10,R11
;        dwIndex -> y+14
;       dwSector -> y+10
;  dwNextCluster -> y+6
;      dwCluster -> y+26
;         pDrive -> R10,R11
	.even
_GetNextCluster:
	st -y,r19
	st -y,r18
	xcall push_xgsetF03C
	movw R10,R16
	sbiw R28,18
; }
; 
; /************************************************************/
; /*  GetNextCluster                                          */
; /************************************************************/
; static DWORD GetNextCluster(DRIVE_INFO * pDrive, DWORD dwCluster)
; {
;     DWORD dwNextCluster;
;     DWORD dwSector;
;     DWORD dwIndex;
;     FAT_ENTRY_TABLE16 *pFatTable16;
;     FAT_ENTRY_TABLE32 *pFatTable32;
; 
;     if (pDrive->bFlags & FLAG_FAT_IS_CDROM) {
	movw R30,R10
	ldd R2,z+3
	sbrs R2,0
	rjmp L9
X1:
;         dwNextCluster = dwCluster + 1;
	ldi R20,1
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R2,y+26
	ldd R3,y+27
	ldd R4,y+28
	ldd R5,y+29
	add R2,R20
	adc R3,R21
	adc R4,R22
	adc R5,R23
	std y+6,R2
	std y+7,R3
	std y+8,R4
	std y+9,R5
;     } else {
	xjmp L10
L9:
;         if (pDrive->bIsFAT32 == TRUE) {
	movw R30,R10
	ldd R24,z+0
	cpi R24,1
	breq X7
	xjmp L11
X7:
X2:
;             //
;             //  (IDE_SECTOR_SIZE / sizeof(long)) == 128
;             // 
;             dwSector = (dwCluster / 128) + pDrive->dwFAT1StartSector;
	ldi R24,7
	ldi R25,0
	ldd R16,y+26
	ldd R17,y+27
	ldd R18,y+28
	ldd R19,y+29
	st -y,R24
	xcall lsr32
	movw R2,R16
	movw R4,R18
	movw R30,R10
	ldd R6,z+18
	ldd R7,z+19
	ldd R8,z+20
	ldd R9,z+21
	add R2,R6
	adc R3,R7
	adc R4,R8
	adc R5,R9
	std y+10,R2
	std y+11,R3
	std y+12,R4
	std y+13,R5
;             dwIndex = dwCluster % 128;
	ldi R20,127
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R2,y+26
	ldd R3,y+27
	ldd R4,y+28
	ldd R5,y+29
	and R2,R20
	and R3,R21
	and R4,R22
	and R5,R23
	std y+14,R2
	std y+15,R3
	std y+16,R4
	std y+17,R5
; 
;             IDEReadSectors(pDrive->bDevice, pSectorBuffer, dwSector, 1);
	ldi R24,1
	ldi R25,0
	std y+5,R25
	std y+4,R24
	ldd R2,y+10
	ldd R3,y+11
	ldd R4,y+12
	ldd R5,y+13
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	lds R18,_pSectorBuffer
	lds R19,_pSectorBuffer+1
	ldd R16,z+1
	xcall _IDEReadSectors
;             pFatTable32 = (FAT_ENTRY_TABLE32 *) pSectorBuffer;
	lds R12,_pSectorBuffer
	lds R13,_pSectorBuffer+1
; 
;             dwNextCluster = (pFatTable32->aEntry[dwIndex] & FAT32_CLUSTER_MASK);
	ldd R2,y+14
	ldd R3,y+15
	ldd R4,y+16
	ldd R5,y+17
	ldi R20,4
	ldi R21,0
	ldi R22,0
	ldi R23,0
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	movw R16,R20
	movw R18,R22
	xcall empy32u
	movw R30,R16
	add R30,R12
	adc R31,R13
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	ldi R20,255
	ldi R21,255
	ldi R22,255
	ldi R23,15
	and R2,R20
	and R3,R21
	and R4,R22
	and R5,R23
	std y+6,R2
	std y+7,R3
	std y+8,R4
	std y+9,R5
;             if ((dwNextCluster == FAT32_CLUSTER_EOF) || (dwNextCluster == FAT32_CLUSTER_ERROR)) {
	ldi R20,255
	ldi R21,255
	ldi R22,255
	ldi R23,15
	ldd R2,y+6
	ldd R3,y+7
	ldd R4,y+8
	ldd R5,y+9
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	breq L15
X3:
	ldi R20,247
	ldi R21,255
	ldi R22,255
	ldi R23,15
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	breq X8
	xjmp L12
X8:
X4:
L15:
;                 dwNextCluster = 0;
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	std y+6,R20
	std y+7,R21
	std y+8,R22
	std y+9,R23
;             }
; 
;         } else {                /* FAT16 */
	xjmp L12
L11:
;             //
;             //  (IDE_SECTOR_SIZE / sizeof(word)) == 256
;             // 
;             dwSector = (dwCluster / 256) + pDrive->dwFAT1StartSector;
	ldi R24,8
	ldi R25,0
	ldd R16,y+26
	ldd R17,y+27
	ldd R18,y+28
	ldd R19,y+29
	st -y,R24
	xcall lsr32
	movw R2,R16
	movw R4,R18
	movw R30,R10
	ldd R6,z+18
	ldd R7,z+19
	ldd R8,z+20
	ldd R9,z+21
	add R2,R6
	adc R3,R7
	adc R4,R8
	adc R5,R9
	std y+10,R2
	std y+11,R3
	std y+12,R4
	std y+13,R5
;             dwIndex = dwCluster % 256;
	ldi R20,255
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R2,y+26
	ldd R3,y+27
	ldd R4,y+28
	ldd R5,y+29
	and R2,R20
	and R3,R21
	and R4,R22
	and R5,R23
	std y+14,R2
	std y+15,R3
	std y+16,R4
	std y+17,R5
; 
;             IDEReadSectors(pDrive->bDevice, pSectorBuffer, dwSector, 1);
	ldi R24,1
	ldi R25,0
	std y+5,R25
	std y+4,R24
	ldd R2,y+10
	ldd R3,y+11
	ldd R4,y+12
	ldd R5,y+13
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	lds R18,_pSectorBuffer
	lds R19,_pSectorBuffer+1
	ldd R16,z+1
	xcall _IDEReadSectors
;             pFatTable16 = (FAT_ENTRY_TABLE16 *) pSectorBuffer;
	lds R10,_pSectorBuffer
	lds R11,_pSectorBuffer+1
; 
;             dwNextCluster = (pFatTable16->aEntry[dwIndex] & FAT16_CLUSTER_MASK);
	ldd R2,y+14
	ldd R3,y+15
	ldd R4,y+16
	ldd R5,y+17
	ldi R20,2
	ldi R21,0
	ldi R22,0
	ldi R23,0
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	movw R16,R20
	movw R18,R22
	xcall empy32u
	movw R30,R16
	add R30,R10
	adc R31,R11
	ldd R2,z+0
	ldd R3,z+1
	clr R4
	clr R5
	std y+6,R2
	std y+7,R3
	std y+8,R4
	std y+9,R5
;             if ((dwNextCluster == FAT16_CLUSTER_EOF) || (dwNextCluster == FAT16_CLUSTER_ERROR)) {
	ldi R20,255
	ldi R21,255
	ldi R22,0
	ldi R23,0
	ldd R2,y+6
	ldd R3,y+7
	ldd R4,y+8
	ldd R5,y+9
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	breq L18
X5:
	ldi R20,247
	ldi R21,255
	ldi R22,0
	ldi R23,0
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brne L16
X6:
L18:
;                 dwNextCluster = 0;
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	std y+6,R20
	std y+7,R21
	std y+8,R22
	std y+9,R23
;             }
L16:
; 
;         }                       /* endif pDrive->bIsFAT32 */
L12:
;     }
L10:
; 
;     return (dwNextCluster);
	ldd R16,y+6
	ldd R17,y+7
	ldd R18,y+8
	ldd R19,y+9
L8:
	.dbline 0 ; func end
	adiw R28,18
	xcall pop_xgsetF03C
	adiw R28,2
	ret
;          Value -> R20
;         wValue -> R20,R21
	.even
_GetLongChar:
	st -y,R20
	st -y,R21
	movw R20,R16
; }
; 
; /************************************************************/
; /*  GetLongChar                                             */
; /************************************************************/
; static char GetLongChar(WORD wValue)
; {
;     BYTE Value;
; 
;     Value = (BYTE) (wValue & 0x00FF);
	andi R21,0
;     if (Value == 0xFF) {
	cpi R20,255
	brne L20
X9:
;         Value = 0;
	clr R20
;     }
L20:
; 
;     if (Value != 0) {
	tst R20
	breq L22
X10:
;         Value = toupper(Value);
	mov R16,R20
	clr R17
	xcall _toupper
	mov R20,R16
;     }
L22:
; 
;     return ((char) Value);
	mov R16,R20
L19:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
;          pRead -> R20,R21
;      pLongName -> R16,R17
	.even
_CheckATAPIName:
	xcall push_xgsetF000
; }
; 
; #if (IDE_SUPPORT_ATAPI == 1)
; /************************************************************/
; /*  CheckATAPIName                                          */
; /*                                                          */
; /*  Some values are not allowed in a "ATAPIname",           */
; /*  Therefore we will change the name here.                 */
; /************************************************************/
; static char *CheckATAPIName(char *pLongName)
; {
;     char *pRead;
; 
;     pRead = pLongName;
	movw R20,R16
	xjmp L26
L25:
; 
;     while (*pRead != 0) {
;         switch (*pRead) {
	movw R30,R20
	ldd R22,z+0
	clr R23
	cpi R22,32
	ldi R30,0
	cpc R23,R30
	breq L32
X11:
	cpi R22,32
	ldi R30,0
	cpc R23,R30
	brlt L28
X12:
L33:
	cpi R22,45
	ldi R30,0
	cpc R23,R30
	breq L31
X13:
	xjmp L28
L31:
;         case '-':
;             *pRead = '_';
	ldi R24,95
	movw R30,R20
	std z+0,R24
;             break;
	xjmp L29
L32:
;         case ' ':
;             *pRead = '_';
	ldi R24,95
	movw R30,R20
	std z+0,R24
;             break;
L28:
L29:
;         }
;         pRead++;
	subi R20,255  ; offset = 1
	sbci R21,255
;     }
L26:
	movw R30,R20
	ldd R2,z+0
	tst R2
	brne L25
X14:
; 
;     return (pLongName);
L24:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
;    bPointCount -> R10
;         pWrite -> R20,R21
;          pRead -> R22,R23
;           bDir -> R18
;      pLongName -> R16,R17
	.even
_RemoveChar:
	xcall push_xgsetF00C
; }
; 
; /************************************************************/
; /*  RemoveChar                                              */
; /*                                                          */
; /*  Houston, we have a problem....                          */
; /*  Some chars are not allowed in a name, in the case of    */
; /*  ATAPI, the filename test.pic.gif is stored as           */
; /*  testpic.gif. For a directory, we must remove all '.'    */
; /*  Therefore we must correct the name :o(                  */
; /************************************************************/
; static char *RemoveChar(char *pLongName, BYTE bDir)
; {
;     char *pRead;
;     char *pWrite;
;     BYTE bPointCount;
; 
;     pRead = pLongName;
	movw R22,R16
;     pWrite = pLongName;
	movw R20,R16
; 
;     if (bDir == TRUE) {
	cpi R18,1
	brne L35
X15:
	xjmp L38
L37:
;         while (*pRead != 0) {
;             if (*pRead != '.') {
	movw R30,R22
	ldd R24,z+0
	cpi R24,46
	breq L40
X16:
;                 *pWrite = *pRead;
	ldd R2,z+0
	movw R30,R20
	std z+0,R2
;                 pWrite++;
	subi R20,255  ; offset = 1
	sbci R21,255
;             }
L40:
;             pRead++;
	subi R22,255  ; offset = 1
	sbci R23,255
;         }
L38:
	movw R30,R22
	ldd R2,z+0
	tst R2
	brne L37
X17:
;         *pWrite = 0;
	clr R2
	movw R30,R20
	std z+0,R2
;     } else {
	xjmp L36
L35:
;         //
;         // 1. search all points in the name
;         //
;         pRead = pLongName;
	movw R22,R16
;         bPointCount = 0;
	clr R10
	xjmp L43
L42:
;         while (*pRead != 0) {
;             if (*pRead == '.') {
	movw R30,R22
	ldd R24,z+0
	cpi R24,46
	brne L45
X18:
;                 bPointCount++;
	inc R10
;             }
L45:
;             pRead++;
	subi R22,255  ; offset = 1
	sbci R23,255
;         }
L43:
	movw R30,R22
	ldd R2,z+0
	tst R2
	brne L42
X19:
; 
;         if (bPointCount >= 2) {
	mov R24,R10
	cpi R24,2
	brlo L47
X20:
;             //
;             // Remove the points...
;             //
;             bPointCount--;
	dec R10
; 
;             pRead = pLongName;
	movw R22,R16
;             pWrite = pLongName;
	movw R20,R16
	xjmp L50
L49:
; 
;             while (*pRead != 0) {
;                 if ((*pRead == '.') && (bPointCount)) {
	movw R30,R22
	ldd R24,z+0
	cpi R24,46
	brne L52
X21:
	tst R10
	breq L52
X22:
;                     bPointCount--;
	dec R10
;                 } else {
	xjmp L53
L52:
;                     *pWrite = *pRead;
	movw R30,R22
	ldd R2,z+0
	movw R30,R20
	std z+0,R2
;                     pWrite++;
	subi R20,255  ; offset = 1
	sbci R21,255
;                 }
L53:
;                 pRead++;
	subi R22,255  ; offset = 1
	sbci R23,255
;             }
L50:
	movw R30,R22
	ldd R2,z+0
	tst R2
	brne L49
X23:
;             *pWrite = 0;
	clr R2
	movw R30,R20
	std z+0,R2
;         }
L47:
;     }
L36:
; 
;     return (pLongName);
L34:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
;    dwDirSector -> y+14
; dwMaxDirSector -> y+10
;   bSearchFlags -> y+19
;       dwSector -> y+6
;   bLongNameLen -> y+18
;     wByteCount -> R14,R15
;      pDirEntry -> R10,R11
;    nIsLongName -> y+42
;      pFileSize -> y+40
;   dwDirCluster -> y+36
;      pLongName -> y+34
;   pSearchEntry -> R10,R11
;         pDrive -> y+30
	.even
_FindFileATAPI:
	xcall push_arg4
	xcall push_xgsetF0FC
	movw R10,R18
	sbiw R28,20
; }
; 
; /************************************************************/
; /*  FindFileATAPI                                           */
; /*                                                          */
; /*  Find a file by a given name pLongName.                  */
; /*  For ATAPI, we have NO cluster. A cluster is the same    */
; /*  as a sector.                                            */
; /************************************************************/
; static DWORD FindFileATAPI(DRIVE_INFO * pDrive,
;                            FAT32_DIRECTORY_ENTRY * pSearchEntry,
;                            char *pLongName, DWORD dwDirCluster, DWORD * pFileSize, int nIsLongName)
; {
;     DWORD dwSector;
;     DWORD dwDirSector;
;     DWORD dwMaxDirSector;
;     WORD wByteCount;
;     BYTE bLongNameLen;
;     BYTE bSearchFlags;
;     ATAPI2_DIRECTORY_RECORD *pDirEntry;
; 
;     dwSector = 0;
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	std y+6,R20
	std y+7,R21
	std y+8,R22
	std y+9,R23
;     dwDirSector = dwDirCluster;
	ldd R2,y+36
	ldd R3,y+37
	ldd R4,y+38
	ldd R5,y+39
	std y+14,R2
	std y+15,R3
	std y+16,R4
	std y+17,R5
; 
;     dwMaxDirSector = pDrive->dwFirstRootDirSector + pDrive->dwRootDirSectors - 1;
	ldd R30,y+30
	ldd R31,y+31
	ldd R2,z+6
	ldd R3,z+7
	ldd R4,z+8
	ldd R5,z+9
	ldd R6,z+10
	ldd R7,z+11
	ldd R8,z+12
	ldd R9,z+13
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	ldi R20,1
	ldi R21,0
	ldi R22,0
	ldi R23,0
	sub R6,R20
	sbc R7,R21
	sbc R8,R22
	sbc R9,R23
	std y+10,R6
	std y+11,R7
	std y+12,R8
	std y+13,R9
; 
;     bSearchFlags = 0;
	clr R0
	std y+19,R0
;     if (pSearchEntry->Attribute == DIRECTORY_ATTRIBUTE_DIRECTORY) {
	movw R30,R10
	ldd R24,z+11
	cpi R24,16
	brne L55
X24:
;         bSearchFlags = 0x02;
	ldi R24,2
	std y+19,R24
;         pLongName = RemoveChar(pLongName, TRUE);
	ldi R18,1
	ldd R16,y+34
	ldd R17,y+35
	xcall _RemoveChar
	std y+35,R17
	std y+34,R16
;     } else {
	xjmp L56
L55:
;         pLongName = RemoveChar(pLongName, FALSE);
	clr R18
	ldd R16,y+34
	ldd R17,y+35
	xcall _RemoveChar
	std y+35,R17
	std y+34,R16
;     }
L56:
; 
;     //
;     // ' ' and '-' are not allowed in the name, change it...
;     //
;     pLongName = CheckATAPIName(pLongName);
	ldd R16,y+34
	ldd R17,y+35
	xcall _CheckATAPIName
	movw R10,R16
	std y+35,R11
	std y+34,R10
;     bLongNameLen = strlen(pLongName);
	xcall _strlen
	movw R10,R16
	std y+18,R10
	xjmp L58
L57:
; 
;     while (dwDirCluster <= dwMaxDirSector) {
;         IDEReadSectors(pDrive->bDevice, pSectorBuffer, dwDirCluster, 1);
	ldi R24,1
	ldi R25,0
	std y+5,R25
	std y+4,R24
	ldd R2,y+36
	ldd R3,y+37
	ldd R4,y+38
	ldd R5,y+39
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	lds R18,_pSectorBuffer
	lds R19,_pSectorBuffer+1
	ldd R30,y+30
	ldd R31,y+31
	ldd R16,z+1
	xcall _IDEReadSectors
; 
;         wByteCount = 0;
	clr R14
	clr R15
;         pDirEntry = (ATAPI2_DIRECTORY_RECORD *) & pSectorBuffer[0];
	lds R10,_pSectorBuffer
	lds R11,_pSectorBuffer+1
	xjmp L61
L60:
;         while (wByteCount < pDrive->dwClusterSize) {
;             if (pDirEntry->bRecordSize == 0) {
	movw R30,R10
	ldd R2,z+0
	tst R2
	brne L63
X25:
;                 break;
	xjmp L62
L63:
;             } else {
;                 //
;                 // Check pDirEntry
;                 //
;                 if (((pDirEntry->bFlags & 0x03) == bSearchFlags) &&
	movw R30,R10
	ldd R24,z+25
	andi R24,3
	ldd R0,y+19
	cp R24,R0
	breq X31
	xjmp L65
X31:
X26:
	ldd R2,z+32
	ldd R0,y+18
	cp R2,R0
	brlo L65
X27:
	mov R2,R0
	clr R3
	std y+1,R3
	std y+0,R2
	ldd R18,y+34
	ldd R19,y+35
	movw R16,R30
	subi R16,223  ; offset = 33
	sbci R17,255
	xcall _strncmp
	movw R12,R16
	cpi R16,0
	cpc R16,R17
	brne L65
X28:
;                     (pDirEntry->bIdentifierLength >= bLongNameLen) &&
;                     (strncmp(&pDirEntry->bName[0], pLongName, bLongNameLen) == 0)) {
;                     //
;                     // We have found the file :-)
;                     // 
;                     dwSector = pDirEntry->dwFirstSector;
	movw R30,R10
	ldd R2,z+2
	ldd R3,z+3
	ldd R4,z+4
	ldd R5,z+5
	std y+6,R2
	std y+7,R3
	std y+8,R4
	std y+9,R5
;                     *pFileSize = pDirEntry->dwEntrySize;
	ldd R2,z+10
	ldd R3,z+11
	ldd R4,z+12
	ldd R5,z+13
	ldd R30,y+40
	ldd R31,y+41
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;                     // Sorry for the return here :-(
;                     return (dwSector);
	ldd R16,y+6
	ldd R17,y+7
	ldd R18,y+8
	ldd R19,y+9
	xjmp L54
L65:
;                 }
; 
;                 wByteCount += pDirEntry->bRecordSize;
	movw R30,R10
	ldd R2,z+0
	clr R3
	add R14,R2
	adc R15,R3
;                 pDirEntry = (ATAPI2_DIRECTORY_RECORD *) & pSectorBuffer[wByteCount];
	lds R2,_pSectorBuffer
	lds R3,_pSectorBuffer+1
	movw R10,R14
	add R10,R2
	adc R11,R3
;             }
;         }
L61:
	ldd R30,y+30
	ldd R31,y+31
	ldd R2,z+30
	ldd R3,z+31
	ldd R4,z+32
	ldd R5,z+33
	movw R6,R14
	clr R8
	clr R9
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	brsh X32
	xjmp L60
X32:
X29:
L62:
;         dwDirCluster++;
	ldi R20,1
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R2,y+36
	ldd R3,y+37
	ldd R4,y+38
	ldd R5,y+39
	add R2,R20
	adc R3,R21
	adc R4,R22
	adc R5,R23
	std y+36,R2
	std y+37,R3
	std y+38,R4
	std y+39,R5
;     }
L58:
	ldd R2,y+10
	ldd R3,y+11
	ldd R4,y+12
	ldd R5,y+13
	ldd R6,y+36
	ldd R7,y+37
	ldd R8,y+38
	ldd R9,y+39
	cp R2,R6
	cpc R3,R7
	cpc R4,R8
	cpc R5,R9
	brlo X33
	xjmp L57
X33:
X30:
; 
;     return (dwSector);
	ldd R16,y+6
	ldd R17,y+7
	ldd R18,y+8
	ldd R19,y+9
L54:
	.dbline 0 ; func end
	adiw R28,20
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
;       nNameLen -> R12,R13
;         bError -> R10
;       dwSector -> y+10
;  nDirMaxSector -> y+28
;              i -> y+26
;      bMaxOrder -> y+25
;       bEndLoop -> y+24
;         bFound -> y+23
;   dwNewCluster -> y+6
;      pDirTable -> y+21
;         bOrder -> y+20
; pDirEntryShort -> R10,R11
;              x -> y+18
;        nMaxLen -> y+16
;       pDirName -> y+14
;  pDirEntryLong -> R14,R15
;    nIsLongName -> y+52
;      pFileSize -> y+50
;   dwDirCluster -> y+46
;      pLongName -> y+44
;   pSearchEntry -> y+42
;         pDrive -> y+40
	.even
_FindFile:
	xcall push_arg4
	xcall push_xgsetF0FC
	sbiw R28,30
; }
; #endif
; 
; /************************************************************/
; /*  FindFile                                                */
; /*                                                          */
; /*  Find a file by a given name pLongName.                  */
; /*                                                          */
; /*  It is possible that a SHORT name like "enlogo.gif"      */
; /*  is stored as a LONG name. I have seen this              */
; /*  nasty behaviour by Win98. Therefore I will check        */
; /*  the long name too, even if nIsLongName is FALSE.        */
; /************************************************************/
; static DWORD FindFile(DRIVE_INFO * pDrive,
;                       FAT32_DIRECTORY_ENTRY * pSearchEntry, char *pLongName, DWORD dwDirCluster, DWORD * pFileSize, int nIsLongName)
; {
;     int i, x;
;     BYTE bError;
;     int nNameLen;
;     int nMaxLen;
;     BYTE bFound;
;     BYTE bEndLoop;
;     BYTE bOrder;
;     BYTE bMaxOrder;
;     int nDirMaxSector;
;     DWORD dwSector;
;     DWORD dwNewCluster;
;     FAT32_DIRECTORY_ENTRY *pDirEntryShort;
;     FAT32_DIRECTORY_ENTRY_LONG *pDirEntryLong;
;     char *pDirName = 0;
	clr R0
	clr R1
	std y+15,R1
	std y+14,R0
;     FAT_DIR_TABLE *pDirTable;
; 
;     bError = FALSE;
	clr R10
;     *pFileSize = 0;
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R30,y+50
	ldd R31,y+51
	std z+0,R20
	std z+1,R21
	std z+2,R22
	std z+3,R23
;     dwNewCluster = 0;
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	std y+6,R20
	std y+7,R21
	std y+8,R22
	std y+9,R23
; 
;     nNameLen = strlen(pLongName);
	ldd R16,y+44
	ldd R17,y+45
	xcall _strlen
	movw R12,R16
; 
;     bMaxOrder = (BYTE) ((nNameLen + 12) / 13);
	ldi R18,13
	ldi R19,0
	subi R16,244  ; offset = 12
	sbci R17,255
	xcall div16s
	std y+25,R16
;     nMaxLen = (int) (bMaxOrder * 13);
	ldi R24,13
	mov R0,R16
	mul R24,R0
	std y+17,R1
	std y+16,R0
;     if (nMaxLen >= (FAT_LONG_NAME_LEN - 1)) {
	movw R24,R0
	cpi R24,63
	ldi R30,0
	cpc R25,R30
	brlt L68
X34:
;         bError = TRUE;
	clr R10
	inc R10
;     }
L68:
; 
;     bOrder = (BYTE) (0x40 | bMaxOrder);
	ldd R24,y+25
	clr R25
	ori R24,64
	std y+20,R24
;     if (bOrder == 0xE5) {
	cpi R24,229
	brne L70
X35:
;         //
;         // I do not know what should I do if the bOrder is 0xe5.
;         // This is a sign for a "empty" entry. 
;         //
;         bError = TRUE;
	clr R10
	inc R10
;     }
L70:
; 
;     if (bError == FALSE) {
	tst R10
	breq X56
	xjmp L72
X56:
X36:
;         bFound = FALSE;
	clr R0
	std y+23,R0
;         bEndLoop = FALSE;
	std y+24,R0
	xjmp L75
L74:
;         while ((bEndLoop == FALSE) && (dwDirCluster != 0)) {
;             dwSector = GetFirstSectorOfCluster(pDrive, dwDirCluster);
	ldd R2,y+46
	ldd R3,y+47
	ldd R4,y+48
	ldd R5,y+49
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldd R16,y+40
	ldd R17,y+41
	xcall _GetFirstSectorOfCluster
	std y+10,R16
	std y+11,R17
	std y+12,R18
	std y+13,R19
;             nDirMaxSector = (int) pDrive->bSectorsPerCluster;
	ldd R30,y+40
	ldd R31,y+41
	ldd R2,z+2
	clr R3
	std y+29,R3
	std y+28,R2
; 
;             //
;             // Test for special case dwDirCluster and FAT16.
;             //
;             if ((dwDirCluster == 1) && (pDrive->bIsFAT32 == FALSE)) {
	ldi R20,1
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R2,y+46
	ldd R3,y+47
	ldd R4,y+48
	ldd R5,y+49
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brne L77
X37:
	ldd R30,y+40
	ldd R31,y+41
	ldd R2,z+0
	tst R2
	brne L77
X38:
;                 dwSector = pDrive->dwFirstRootDirSector;
	ldd R2,z+10
	ldd R3,z+11
	ldd R4,z+12
	ldd R5,z+13
	std y+10,R2
	std y+11,R3
	std y+12,R4
	std y+13,R5
;                 nDirMaxSector = (int) pDrive->dwRootDirSectors;
	ldd R30,y+40
	ldd R31,y+41
	ldd R2,z+6
	ldd R3,z+7
	std y+29,R3
	std y+28,R2
;             }
L77:
;             //
;             // One cluster has SecPerCluster sectors.
;             //
;             for (i = 0; i < nDirMaxSector; i++) {
	clr R0
	clr R1
	std y+27,R1
	std y+26,R0
	xjmp L82
L79:
;                 IDEReadSectors(pDrive->bDevice, pSectorBuffer, dwSector + i, 1);
	ldi R24,1
	ldi R25,0
	std y+5,R25
	std y+4,R24
	ldd R2,y+26
	ldd R3,y+27
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	ldd R6,y+10
	ldd R7,y+11
	ldd R8,y+12
	ldd R9,y+13
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	std y+0,R6
	std y+1,R7
	std y+2,R8
	std y+3,R9
	lds R18,_pSectorBuffer
	lds R19,_pSectorBuffer+1
	ldd R30,y+40
	ldd R31,y+41
	ldd R16,z+1
	xcall _IDEReadSectors
;                 pDirTable = (FAT_DIR_TABLE *) pSectorBuffer;
	lds R2,_pSectorBuffer
	lds R3,_pSectorBuffer+1
	std y+22,R3
	std y+21,R2
; 
;                 //
;                 // And one sector has 16 entries.
;                 //
;                 // IDE_SECTOR_SIZE / sizeof(FAT32_DIRECTORY_ENTRY) = 16
;                 //
;                 for (x = 0; x < 16; x++) {
	clr R0
	clr R1
	std y+19,R1
	std y+18,R0
L83:
;                     if (bFound == TRUE) {
	ldd R24,y+23
	cpi R24,1
	breq X57
	xjmp L87
X57:
X39:
;                         pDirEntryShort = (FAT32_DIRECTORY_ENTRY *) & pDirTable->aShort[x];
	ldi R16,32
	ldi R17,0
	ldd R18,y+18
	ldd R19,y+19
	xcall empy16s
	movw R10,R16
	ldd R0,y+21
	ldd R1,y+22
	add R10,R0
	adc R11,R1
;                         dwNewCluster = pDirEntryShort->HighCluster;
	movw R30,R10
	ldd R2,z+20
	ldd R3,z+21
	clr R4
	clr R5
	std y+6,R2
	std y+7,R3
	std y+8,R4
	std y+9,R5
;                         dwNewCluster = (dwNewCluster << 16) | (DWORD) pDirEntryShort->LowCluster;
	ldd R2,z+26
	ldd R3,z+27
	clr R4
	clr R5
	ldd R6,y+6
	ldd R7,y+7
	ldd R8,y+8
	ldd R9,y+9
	movw R8,R6
	clr R6
	clr R7
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	std y+6,R6
	std y+7,R7
	std y+8,R8
	std y+9,R9
;                         *pFileSize = pDirEntryShort->FileSize;
	ldd R2,z+28
	ldd R3,z+29
	ldd R4,z+30
	ldd R5,z+31
	ldd R30,y+50
	ldd R31,y+51
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;                         bEndLoop = TRUE;
	clr R0
	inc R0
	std y+24,R0
;                         break;
	xjmp L85
L87:
;                     }
;                     //
;                     // Check for valid entry.
;                     //
;                     pDirEntryShort = (FAT32_DIRECTORY_ENTRY *) & pDirTable->aShort[x];
	ldi R16,32
	ldi R17,0
	ldd R18,y+18
	ldd R19,y+19
	xcall empy16s
	movw R10,R16
	ldd R0,y+21
	ldd R1,y+22
	add R10,R0
	adc R11,R1
;                     pDirEntryLong = (FAT32_DIRECTORY_ENTRY_LONG *) & pDirTable->aLong[x];
	ldi R16,32
	ldi R17,0
	ldd R18,y+18
	ldd R19,y+19
	xcall empy16s
	movw R14,R16
	ldd R0,y+21
	ldd R1,y+22
	add R14,R0
	adc R15,R1
; 
;                     if (nIsLongName == FALSE) {
	ldd R0,y+52
	ldd R1,y+53
	tst R0
	breq X58
	xjmp L89
X58:
	tst R1
	breq X59
	xjmp L89
X59:
X40:
;                         //
;                         // Check if it could be a short name. If Win2000 tell us it
;                         // is a short name, it is true. But with Win98 we must
;                         // test both, short and long...
;                         //
;                         if ((pDirEntryShort->Name[0] != 0xE5) && (pDirEntryShort->Name[0] != 0x00)) {
	movw R30,R10
	ldd R2,z+0
	clr R3
	mov R24,R2
	cpi R24,229
	brne X60
	xjmp L91
X60:
X41:
	tst R24
	brne X61
	xjmp L91
X61:
X42:
;                             if (memcmp(pDirEntryShort, pSearchEntry, 11) == 0) {
	ldi R24,11
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldd R18,y+42
	ldd R19,y+43
	movw R16,R30
	xcall _memcmp
	movw R12,R16
	cpi R16,0
	cpc R16,R17
	breq X62
	xjmp L93
X62:
X43:
;                                 //
;                                 // Check for the correct attribute, this is done with
;                                 // the '&' and not with the memcmp.
;                                 // With the '&' it is possible to find a hidden archive too :-)
;                                 //
;                                 if ((pDirEntryShort->Attribute & pSearchEntry->Attribute) == pSearchEntry->Attribute) {
	ldd R30,y+42
	ldd R31,y+43
	ldd R12,z+11
	clr R13
	movw R30,R10
	ldd R2,z+11
	clr R3
	and R2,R12
	and R3,R13
	cp R2,R12
	cpc R3,R13
	brne L95
X44:
; 
;                                     dwNewCluster = pDirEntryShort->HighCluster;
	ldd R2,z+20
	ldd R3,z+21
	clr R4
	clr R5
	std y+6,R2
	std y+7,R3
	std y+8,R4
	std y+9,R5
;                                     dwNewCluster = (dwNewCluster << 16) | (DWORD) pDirEntryShort->LowCluster;
	ldd R2,z+26
	ldd R3,z+27
	clr R4
	clr R5
	ldd R6,y+6
	ldd R7,y+7
	ldd R8,y+8
	ldd R9,y+9
	movw R8,R6
	clr R6
	clr R7
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	std y+6,R6
	std y+7,R7
	std y+8,R8
	std y+9,R9
;                                     *pFileSize = pDirEntryShort->FileSize;
	ldd R2,z+28
	ldd R3,z+29
	ldd R4,z+30
	ldd R5,z+31
	ldd R30,y+50
	ldd R31,y+51
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
; 
;                                     bEndLoop = TRUE;
	clr R0
	inc R0
	std y+24,R0
;                                     break;
	xjmp L85
L95:
; 
;                                 }       /* endif Attribute */
;                             }   /* endif test Name+Ext */
L93:
;                         }       /* endif Name[0] != 0xe5, 0x00 */
L91:
;                     }
L89:
;                     /* endif nIsLongName == FALSE */
;                     if ((pDirEntryLong->Attribute == DIRECTORY_ATTRIBUTE_LONG_NAME) && (pDirEntryLong->Order == bOrder)) {
	movw R30,R14
	ldd R24,z+11
	cpi R24,15
	breq X63
	xjmp L97
X63:
X45:
	ldd R2,z+0
	ldd R0,y+20
	cp R2,R0
	breq X64
	xjmp L97
X64:
X46:
;                         //
;                         // Next bOrder is bOrder--
;                         //  
;                         if (bOrder & 0x40) {
	sbrs R0,6
	rjmp L99
X47:
;                             bOrder &= ~0x40;
	mov R24,R0
	andi R24,191
	std y+20,R24
; 
;                             //
;                             // Get the space for the name.
;                             //
;                             pDirName = pLongName2;
	lds R2,_pLongName2
	lds R3,_pLongName2+1
	std y+15,R3
	std y+14,R2
; 
;                             //
;                             // Set the end of string.
;                             //
;                             pDirName[nMaxLen--] = 0;
	ldd R10,y+16
	ldd R11,y+17
	movw R24,R10
	sbiw R24,1
	std y+17,R25
	std y+16,R24
	movw R30,R10
	ldd R0,y+14
	ldd R1,y+15
	add R30,R0
	adc R31,R1
	clr R2
	std z+0,R2
;                         }
L99:
; 
;                         pDirName[nMaxLen--] = GetLongChar(pDirEntryLong->Name3[1]);
	ldd R12,y+16
	ldd R13,y+17
	movw R24,R12
	sbiw R24,1
	std y+17,R25
	std y+16,R24
	movw R30,R14
	ldd R16,z+30
	ldd R17,z+31
	xcall _GetLongChar
	mov R10,R16
	movw R30,R12
	ldd R0,y+14
	ldd R1,y+15
	add R30,R0
	adc R31,R1
	std z+0,R10
;                         pDirName[nMaxLen--] = GetLongChar(pDirEntryLong->Name3[0]);
	ldd R12,y+16
	ldd R13,y+17
	movw R24,R12
	sbiw R24,1
	std y+17,R25
	std y+16,R24
	movw R30,R14
	ldd R16,z+28
	ldd R17,z+29
	xcall _GetLongChar
	mov R10,R16
	movw R30,R12
	ldd R0,y+14
	ldd R1,y+15
	add R30,R0
	adc R31,R1
	std z+0,R10
; 
;                         pDirName[nMaxLen--] = GetLongChar(pDirEntryLong->Name2[5]);
	ldd R12,y+16
	ldd R13,y+17
	movw R24,R12
	sbiw R24,1
	std y+17,R25
	std y+16,R24
	movw R30,R14
	ldd R16,z+24
	ldd R17,z+25
	xcall _GetLongChar
	mov R10,R16
	movw R30,R12
	ldd R0,y+14
	ldd R1,y+15
	add R30,R0
	adc R31,R1
	std z+0,R10
;                         pDirName[nMaxLen--] = GetLongChar(pDirEntryLong->Name2[4]);
	ldd R12,y+16
	ldd R13,y+17
	movw R24,R12
	sbiw R24,1
	std y+17,R25
	std y+16,R24
	movw R30,R14
	ldd R16,z+22
	ldd R17,z+23
	xcall _GetLongChar
	mov R10,R16
	movw R30,R12
	ldd R0,y+14
	ldd R1,y+15
	add R30,R0
	adc R31,R1
	std z+0,R10
;                         pDirName[nMaxLen--] = GetLongChar(pDirEntryLong->Name2[3]);
	ldd R12,y+16
	ldd R13,y+17
	movw R24,R12
	sbiw R24,1
	std y+17,R25
	std y+16,R24
	movw R30,R14
	ldd R16,z+20
	ldd R17,z+21
	xcall _GetLongChar
	mov R10,R16
	movw R30,R12
	ldd R0,y+14
	ldd R1,y+15
	add R30,R0
	adc R31,R1
	std z+0,R10
;                         pDirName[nMaxLen--] = GetLongChar(pDirEntryLong->Name2[2]);
	ldd R12,y+16
	ldd R13,y+17
	movw R24,R12
	sbiw R24,1
	std y+17,R25
	std y+16,R24
	movw R30,R14
	ldd R16,z+18
	ldd R17,z+19
	xcall _GetLongChar
	mov R10,R16
	movw R30,R12
	ldd R0,y+14
	ldd R1,y+15
	add R30,R0
	adc R31,R1
	std z+0,R10
;                         pDirName[nMaxLen--] = GetLongChar(pDirEntryLong->Name2[1]);
	ldd R12,y+16
	ldd R13,y+17
	movw R24,R12
	sbiw R24,1
	std y+17,R25
	std y+16,R24
	movw R30,R14
	ldd R16,z+16
	ldd R17,z+17
	xcall _GetLongChar
	mov R10,R16
	movw R30,R12
	ldd R0,y+14
	ldd R1,y+15
	add R30,R0
	adc R31,R1
	std z+0,R10
;                         pDirName[nMaxLen--] = GetLongChar(pDirEntryLong->Name2[0]);
	ldd R12,y+16
	ldd R13,y+17
	movw R24,R12
	sbiw R24,1
	std y+17,R25
	std y+16,R24
	movw R30,R14
	ldd R16,z+14
	ldd R17,z+15
	xcall _GetLongChar
	mov R10,R16
	movw R30,R12
	ldd R0,y+14
	ldd R1,y+15
	add R30,R0
	adc R31,R1
	std z+0,R10
; 
;                         pDirName[nMaxLen--] = GetLongChar(pDirEntryLong->Name1[4]);
	ldd R12,y+16
	ldd R13,y+17
	movw R24,R12
	sbiw R24,1
	std y+17,R25
	std y+16,R24
	movw R30,R14
	ldd R16,z+9
	ldd R17,z+10
	xcall _GetLongChar
	mov R10,R16
	movw R30,R12
	ldd R0,y+14
	ldd R1,y+15
	add R30,R0
	adc R31,R1
	std z+0,R10
;                         pDirName[nMaxLen--] = GetLongChar(pDirEntryLong->Name1[3]);
	ldd R12,y+16
	ldd R13,y+17
	movw R24,R12
	sbiw R24,1
	std y+17,R25
	std y+16,R24
	movw R30,R14
	ldd R16,z+7
	ldd R17,z+8
	xcall _GetLongChar
	mov R10,R16
	movw R30,R12
	ldd R0,y+14
	ldd R1,y+15
	add R30,R0
	adc R31,R1
	std z+0,R10
;                         pDirName[nMaxLen--] = GetLongChar(pDirEntryLong->Name1[2]);
	ldd R12,y+16
	ldd R13,y+17
	movw R24,R12
	sbiw R24,1
	std y+17,R25
	std y+16,R24
	movw R30,R14
	ldd R16,z+5
	ldd R17,z+6
	xcall _GetLongChar
	mov R10,R16
	movw R30,R12
	ldd R0,y+14
	ldd R1,y+15
	add R30,R0
	adc R31,R1
	std z+0,R10
;                         pDirName[nMaxLen--] = GetLongChar(pDirEntryLong->Name1[1]);
	ldd R12,y+16
	ldd R13,y+17
	movw R24,R12
	sbiw R24,1
	std y+17,R25
	std y+16,R24
	movw R30,R14
	ldd R16,z+3
	ldd R17,z+4
	xcall _GetLongChar
	mov R10,R16
	movw R30,R12
	ldd R0,y+14
	ldd R1,y+15
	add R30,R0
	adc R31,R1
	std z+0,R10
;                         pDirName[nMaxLen--] = GetLongChar(pDirEntryLong->Name1[0]);
	ldd R10,y+16
	ldd R11,y+17
	movw R24,R10
	sbiw R24,1
	std y+17,R25
	std y+16,R24
	movw R30,R14
	ldd R16,z+1
	ldd R17,z+2
	xcall _GetLongChar
	mov R14,R16
	movw R30,R10
	ldd R0,y+14
	ldd R1,y+15
	add R30,R0
	adc R31,R1
	std z+0,R14
; 
;                         bOrder--;
	ldd R0,y+20
	dec R0
	std y+20,R0
;                         if (bOrder == 0) {
	tst R0
	brne L101
X48:
;                             //
;                             // Now compare the name.
;                             //
;                             bOrder = (BYTE) (0x40 | bMaxOrder);
	ldd R24,y+25
	clr R25
	ori R24,64
	std y+20,R24
;                             nMaxLen = (int) (bMaxOrder * 13);
	ldi R24,13
	ldd R0,y+25
	mul R24,R0
	std y+17,R1
	std y+16,R0
;                             if (memcmp(pLongName, pDirName, strlen(pLongName)) == 0) {
	ldd R16,y+44
	ldd R17,y+45
	xcall _strlen
	movw R14,R16
	std y+1,R15
	std y+0,R14
	ldd R18,y+14
	ldd R19,y+15
	ldd R16,y+44
	ldd R17,y+45
	xcall _memcmp
	movw R14,R16
	cpi R16,0
	cpc R16,R17
	brne L103
X49:
;                                 //
;                                 // The next entry will be the correct entry.
;                                 //
;                                 bFound = TRUE;
	clr R0
	inc R0
	std y+23,R0
;                             }
L103:
;                         }
L101:
;                     }
L97:
;                     /* pDirEntryLong->Order == bOrder */
;                 }               /* endfor x<16 */
L84:
	ldd R24,y+18
	ldd R25,y+19
	adiw R24,1
	std y+19,R25
	std y+18,R24
	cpi R24,16
	ldi R30,0
	cpc R25,R30
	brge X65
	xjmp L83
X65:
X50:
L85:
; 
;                 if (bEndLoop == TRUE) {
	ldd R24,y+24
	cpi R24,1
	brne L105
X51:
;                     break;
	xjmp L81
L105:
;                 }
;             }
L80:
	ldd R24,y+26
	ldd R25,y+27
	adiw R24,1
	std y+27,R25
	std y+26,R24
L82:
	ldd R0,y+26
	ldd R1,y+27
	ldd R16,y+28
	ldd R17,y+29
	cp R0,R16
	cpc R1,R17
	brge X66
	xjmp L79
X66:
X52:
L81:
; 
;             if (bEndLoop == FALSE) {
	ldd R0,y+24
	tst R0
	brne L107
X53:
;                 //
;                 // No file found in this cluster, get the next one.
;                 //
;                 dwDirCluster = GetNextCluster(pDrive, dwDirCluster);
	ldd R2,y+46
	ldd R3,y+47
	ldd R4,y+48
	ldd R5,y+49
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldd R16,y+40
	ldd R17,y+41
	xcall _GetNextCluster
	std y+46,R16
	std y+47,R17
	std y+48,R18
	std y+49,R19
;             }
L107:
;         }                       /* endwhile */
L75:
	ldd R0,y+24
	tst R0
	brne L109
X54:
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R2,y+46
	ldd R3,y+47
	ldd R4,y+48
	ldd R5,y+49
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	breq X67
	xjmp L74
X67:
X55:
L109:
; 
;     }
L72:
;     /* endif bError == FALSE */
;     return (dwNewCluster);
	ldd R16,y+6
	ldd R17,y+7
	ldd R18,y+8
	ldd R19,y+9
L67:
	.dbline 0 ; func end
	adiw R28,30
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
;           pPVD -> R14,R15
;    dwPVDSector -> y+10
;         pDrive -> R12,R13
;         nError -> R10,R11
;       dwSector -> y+6
;         nDrive -> y+24
	.even
_MountATAPI:
	st -y,r17
	st -y,r16
	xcall push_xgsetF0FC
	sbiw R28,14
; }
; 
; #if (IDE_SUPPORT_ATAPI == 1)
; /************************************************************/
; /*  MountATAPI                                              */
; /************************************************************/
; static int MountATAPI(int nDrive)
; {
;     int nError = IDE_OK;
	clr R10
	clr R11
;     DWORD dwSector;
;     DWORD dwPVDSector;
;     DRIVE_INFO *pDrive;
;     ATAPI_PVD *pPVD;
; 
;     pDrive = &sDriveInfo[nDrive];
	ldi R16,34
	ldi R17,0
	ldd R18,y+24
	ldd R19,y+25
	xcall empy16s
	movw R12,R16
	ldi R24,<_sDriveInfo
	ldi R25,>_sDriveInfo
	add R12,R24
	adc R13,R25
;     dwSector = ATAPI_START_SEARCH_SECTOR;
	ldi R20,16
	ldi R21,0
	ldi R22,0
	ldi R23,0
	std y+6,R20
	std y+7,R21
	std y+8,R22
	std y+9,R23
;     dwPVDSector = 0;
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	std y+10,R20
	std y+11,R21
	std y+12,R22
	std y+13,R23
	xjmp L112
L111:
;     while (dwSector <= ATAPI_MAX_SEARCH_SECTOR) {
;         nError = IDEReadSectors(nDrive, pSectorBuffer, dwSector, 1);
	ldi R24,1
	ldi R25,0
	std y+5,R25
	std y+4,R24
	ldd R2,y+6
	ldd R3,y+7
	ldd R4,y+8
	ldd R5,y+9
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	lds R18,_pSectorBuffer
	lds R19,_pSectorBuffer+1
	ldd R16,y+24
	xcall _IDEReadSectors
	movw R10,R16
;         if (nError != IDE_OK) {
	cpi R16,0
	cpc R16,R17
	breq L114
X68:
;             break;
	xjmp L113
L114:
;         } else {
;             if ((pSectorBuffer[0] == ATAPI_PVD_DESC) &&
	lds R2,_pSectorBuffer
	lds R3,_pSectorBuffer+1
	movw R30,R2
	ldd R24,z+0
	cpi R24,1
	brne L116
X69:
	ldd R24,z+1
	cpi R24,67
	brne L116
X70:
	ldd R24,z+2
	cpi R24,68
	brne L116
X71:
	ldd R24,z+3
	cpi R24,48
	brne L116
X72:
	ldd R24,z+4
	cpi R24,48
	brne L116
X73:
	ldd R24,z+5
	cpi R24,49
	brne L116
X74:
;                 (pSectorBuffer[1] == 'C') && (pSectorBuffer[2] == 'D') &&
;                 (pSectorBuffer[3] == '0') && (pSectorBuffer[4] == '0') && (pSectorBuffer[5] == '1')) {
;                 dwPVDSector = dwSector;
	ldd R2,y+6
	ldd R3,y+7
	ldd R4,y+8
	ldd R5,y+9
	std y+10,R2
	std y+11,R3
	std y+12,R4
	std y+13,R5
;             }
L116:
;             if ((pSectorBuffer[0] == ATAPI_VDST_DESC) &&
	lds R14,_pSectorBuffer
	lds R15,_pSectorBuffer+1
	movw R30,R14
	ldd R24,z+0
	cpi R24,255
	brne L118
X75:
	ldd R24,z+1
	cpi R24,67
	brne L118
X76:
	ldd R24,z+2
	cpi R24,68
	brne L118
X77:
	ldd R24,z+3
	cpi R24,48
	brne L118
X78:
	ldd R24,z+4
	cpi R24,48
	brne L118
X79:
	ldd R24,z+5
	cpi R24,49
	brne L118
X80:
;                 (pSectorBuffer[1] == 'C') && (pSectorBuffer[2] == 'D') &&
;                 (pSectorBuffer[3] == '0') && (pSectorBuffer[4] == '0') && (pSectorBuffer[5] == '1')) {
;                 break;
	xjmp L113
L118:
;             }
;         }
;         dwSector++;
	ldi R20,1
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R2,y+6
	ldd R3,y+7
	ldd R4,y+8
	ldd R5,y+9
	add R2,R20
	adc R3,R21
	adc R4,R22
	adc R5,R23
	std y+6,R2
	std y+7,R3
	std y+8,R4
	std y+9,R5
;     }
L112:
	ldi R20,100
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R2,y+6
	ldd R3,y+7
	ldd R4,y+8
	ldd R5,y+9
	cp R20,R2
	cpc R21,R3
	cpc R22,R4
	cpc R23,R5
	brlo X83
	xjmp L111
X83:
X81:
L113:
; 
;     if (dwPVDSector != 0) {
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R2,y+10
	ldd R3,y+11
	ldd R4,y+12
	ldd R5,y+13
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brne X84
	xjmp L120
X84:
X82:
;         IDEReadSectors(nDrive, pSectorBuffer, dwPVDSector, 1);
	ldi R24,1
	ldi R25,0
	std y+5,R25
	std y+4,R24
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	lds R18,_pSectorBuffer
	lds R19,_pSectorBuffer+1
	ldd R16,y+24
	xcall _IDEReadSectors
;         pPVD = (ATAPI_PVD *) pSectorBuffer;
	lds R14,_pSectorBuffer
	lds R15,_pSectorBuffer+1
; 
;         pDrive->bSectorsPerCluster = 1;
	ldi R24,1
	movw R30,R12
	std z+2,R24
;         pDrive->dwFirstRootDirSector = *(DWORD *) & pPVD->rootdir[2];
	movw R30,R14
	subi R30,98  ; addi 158
	sbci R31,255
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	movw R30,R12
	std z+10,R2
	std z+11,R3
	std z+12,R4
	std z+13,R5
;         pDrive->dwFAT1StartSector = *(DWORD *) & pPVD->firstsek_LEpathtab1_LE[0];
	movw R30,R14
	subi R30,116  ; addi 140
	sbci R31,255
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	movw R30,R12
	std z+18,R2
	std z+19,R3
	std z+20,R4
	std z+21,R5
;         pDrive->dwFAT2StartSector = *(DWORD *) & pPVD->firstsek_LEpathtab2_LE[0];
	movw R30,R14
	subi R30,112  ; addi 144
	sbci R31,255
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	movw R30,R12
	std z+22,R2
	std z+23,R3
	std z+24,R4
	std z+25,R5
; 
;         pDrive->dwRootDirSectors = pDrive->dwFAT1StartSector - pDrive->dwFirstRootDirSector;
	ldd R2,z+10
	ldd R3,z+11
	ldd R4,z+12
	ldd R5,z+13
	ldd R6,z+18
	ldd R7,z+19
	ldd R8,z+20
	ldd R9,z+21
	sub R6,R2
	sbc R7,R3
	sbc R8,R4
	sbc R9,R5
	std z+6,R6
	std z+7,R7
	std z+8,R8
	std z+9,R9
;         pDrive->dwRootCluster = pDrive->dwFirstRootDirSector;
	ldd R2,z+10
	ldd R3,z+11
	ldd R4,z+12
	ldd R5,z+13
	std z+14,R2
	std z+15,R3
	std z+16,R4
	std z+17,R5
;         pDrive->dwClusterSize = (DWORD) pDrive->wSectorSize;
	ldd R2,z+4
	ldd R3,z+5
	clr R4
	clr R5
	std z+30,R2
	std z+31,R3
	std z+32,R4
	std z+33,R5
; 
;         //nError = IDEATAPISetCDSpeed(nDrive, 0xFFFF);
;     }
L120:
; 
;     return (nError);
	movw R16,R10
L110:
	.dbline 0 ; func end
	adiw R28,14
	xcall pop_xgsetF0FC
	adiw R28,2
	ret
; pPartitionTable -> R14,R15
; dwRootDirSectors -> y+14
;        dwFATSz -> y+10
;              i -> R10,R11
;         nError -> y+18
;       dwSector -> y+6
;    pBootRecord -> R14,R15
;         pDrive -> R12,R13
;         nDrive -> R14,R15
	.even
_MountIDE:
	xcall push_xgsetF0FC
	movw R14,R16
	sbiw R28,20
; }
; #endif
; 
; /************************************************************/
; /*  MountIDE                                                 */
; /************************************************************/
; static int MountIDE(int nDrive)
; {
;     int nError;
;     int i;
;     DWORD dwSector;
;     DWORD dwFATSz;
;     DWORD dwRootDirSectors;
;     FAT32_PARTITION_TABLE *pPartitionTable;
;     FAT32_BOOT_RECORD *pBootRecord;
;     DRIVE_INFO *pDrive;
; 
;     nError = IDE_OK;
	clr R0
	clr R1
	std y+19,R1
	std y+18,R0
;     i = nDrive;
	movw R10,R14
;     pDrive = &sDriveInfo[nDrive];
	ldi R16,34
	ldi R17,0
	movw R18,R14
	xcall empy16s
	movw R12,R16
	ldi R24,<_sDriveInfo
	ldi R25,>_sDriveInfo
	add R12,R24
	adc R13,R25
;     dwSector = 0;
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	std y+6,R20
	std y+7,R21
	std y+8,R22
	std y+9,R23
; 
;     if (pDrive->bFlags & FLAG_FAT_IS_ZIP) {
	movw R30,R12
	ldd R2,z+3
	sbrs R2,1
	rjmp L123
X85:
;         dwSector = ZIP_DRIVE_BR_SECTOR;
	ldi R20,32
	ldi R21,0
	ldi R22,0
	ldi R23,0
	std y+6,R20
	std y+7,R21
	std y+8,R22
	std y+9,R23
;     } else {
	xjmp L124
L123:
;         //
;         // Try to find a PartitionTable.
;         // 
;         nError = IDEReadSectors(nDrive, pSectorBuffer, 0, 1);
	ldi R24,1
	ldi R25,0
	std y+5,R25
	std y+4,R24
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	std y+0,R20
	std y+1,R21
	std y+2,R22
	std y+3,R23
	lds R18,_pSectorBuffer
	lds R19,_pSectorBuffer+1
	mov R16,R14
	xcall _IDEReadSectors
	std y+19,R17
	std y+18,R16
;         if (nError == IDE_OK) {
	movw R0,R16
	cpi R16,0
	cpc R16,R17
	brne L125
X86:
;             pPartitionTable = (FAT32_PARTITION_TABLE *) pSectorBuffer;
	lds R14,_pSectorBuffer
	lds R15,_pSectorBuffer+1
; 
;             if (pPartitionTable->Signature == FAT_SIGNATURE) {
	movw R30,R14
	subi R30,2  ; addi 510
	sbci R31,254
	ldd R24,z+0
	ldd R25,z+1
	subi R30,254
	sbci R31,1
	cpi R24,85
	ldi R26,170
	cpc R25,R26
	brne L127
X87:
;                 if (pPartitionTable->Partition[0].NumSectors) {
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	subi R30,54  ; addi 458
	sbci R31,254
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	subi R30,202
	sbci R31,1
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	breq L129
X88:
;                     //
;                     // We found a PartitionTable, read BootRecord.
;                     // 
;                     dwSector = pPartitionTable->Partition[0].StartSectors;
	subi R30,58  ; addi 454
	sbci R31,254
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	std y+6,R2
	std y+7,R3
	std y+8,R4
	std y+9,R5
;                 }
L129:
;             }
L127:
;         }
L125:
;     }
L124:
; 
;     if (dwSector != 0) {
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R2,y+6
	ldd R3,y+7
	ldd R4,y+8
	ldd R5,y+9
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brne X92
	xjmp L131
X92:
X89:
;         IDEReadSectors(i, pSectorBuffer, dwSector, 1);
	ldi R24,1
	ldi R25,0
	std y+5,R25
	std y+4,R24
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	lds R18,_pSectorBuffer
	lds R19,_pSectorBuffer+1
	mov R16,R10
	xcall _IDEReadSectors
;         pBootRecord = (FAT32_BOOT_RECORD *) pSectorBuffer;
	lds R14,_pSectorBuffer
	lds R15,_pSectorBuffer+1
; 
;         //
;         // Test valid BootRecord.
;         //
;         if (pBootRecord->Signature == FAT_SIGNATURE) {
	movw R30,R14
	subi R30,2  ; addi 510
	sbci R31,254
	ldd R24,z+0
	ldd R25,z+1
	subi R30,254
	sbci R31,1
	cpi R24,85
	ldi R26,170
	cpc R25,R26
	breq X93
	xjmp L133
X93:
X90:
;             pDrive->bSectorsPerCluster = pBootRecord->SecPerClus;
	ldd R2,z+13
	movw R30,R12
	std z+2,R2
; 
;             if (pBootRecord->FATSz16 != 0) {
	movw R30,R14
	ldd R2,z+22
	ldd R3,z+23
	tst R2
	brne X91
	tst R3
	breq L135
X91:
;                 dwFATSz = pBootRecord->FATSz16;
	clr R4
	clr R5
	std y+10,R2
	std y+11,R3
	std y+12,R4
	std y+13,R5
;                 pDrive->bIsFAT32 = FALSE;
	clr R2
	movw R30,R12
	std z+0,R2
;                 pDrive->dwRootCluster = 1;      /* special value, see */
	ldi R20,1
	ldi R21,0
	ldi R22,0
	ldi R23,0
	std z+14,R20
	std z+15,R21
	std z+16,R22
	std z+17,R23
;                 /* FindFile           */
;             } else {
	xjmp L136
L135:
;                 dwFATSz = pBootRecord->Off36.FAT32.FATSz32;
	movw R30,R14
	ldd R2,z+36
	ldd R3,z+37
	ldd R4,z+38
	ldd R5,z+39
	std y+10,R2
	std y+11,R3
	std y+12,R4
	std y+13,R5
;                 pDrive->bIsFAT32 = TRUE;
	ldi R24,1
	movw R30,R12
	std z+0,R24
;                 pDrive->dwRootCluster = pBootRecord->Off36.FAT32.RootClus;
	movw R30,R14
	ldd R2,z+44
	ldd R3,z+45
	ldd R4,z+46
	ldd R5,z+47
	movw R30,R12
	std z+14,R2
	std z+15,R3
	std z+16,R4
	std z+17,R5
;             }
L136:
; 
;             dwRootDirSectors = ((pBootRecord->RootEntCnt * 32) + (pBootRecord->BytsPerSec - 1)) / pBootRecord->BytsPerSec;
	movw R30,R14
	ldd R2,z+11
	ldd R3,z+12
	ldd R18,z+17
	ldd R19,z+18
	ldi R16,32
	ldi R17,0
	xcall empy16s
	movw R24,R2
	sbiw R24,1
	add R16,R24
	adc R17,R25
	movw R18,R2
	xcall div16u
	movw R2,R16
	clr R4
	clr R5
	std y+14,R2
	std y+15,R3
	std y+16,R4
	std y+17,R5
; 
;             sDriveInfo[i].dwFAT1StartSector = pBootRecord->HiddSec + pBootRecord->RsvdSecCnt;
	ldi R16,34
	ldi R17,0
	movw R18,R10
	xcall empy16s
	movw R30,R16
	ldi R24,<_sDriveInfo+18
	ldi R25,>_sDriveInfo+18
	add R30,R24
	adc R31,R25
	movw R26,R14
	adiw R26,14
	ld R2,x+
	ld R3,x
	clr R4
	clr R5
	movw R26,R14
	adiw R26,28
	ld R6,x+
	ld R7,x+
	ld R8,x+
	ld R9,x
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	std z+0,R6
	std z+1,R7
	std z+2,R8
	std z+3,R9
; 
;             pDrive->dwFAT2StartSector = pDrive->dwFAT1StartSector + dwFATSz;
	ldd R2,y+10
	ldd R3,y+11
	ldd R4,y+12
	ldd R5,y+13
	movw R30,R12
	ldd R6,z+18
	ldd R7,z+19
	ldd R8,z+20
	ldd R9,z+21
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	std z+22,R6
	std z+23,R7
	std z+24,R8
	std z+25,R9
; 
;             sDriveInfo[i].dwCluster2StartSector =
	movw R30,R14
	ldd R16,z+16
	clr R17
	clr R18
	clr R19
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	xcall empy32u
	movw R30,R14
	ldd R2,z+14
	ldd R3,z+15
	clr R4
	clr R5
	ldd R6,z+28
	ldd R7,z+29
	ldd R8,z+30
	ldd R9,z+31
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	add R6,R16
	adc R7,R17
	adc R8,R18
	adc R9,R19
	ldd R2,y+14
	ldd R3,y+15
	ldd R4,y+16
	ldd R5,y+17
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	ldi R16,34
	ldi R17,0
	movw R18,R10
	xcall empy16s
	movw R30,R16
	ldi R24,<_sDriveInfo+26
	ldi R25,>_sDriveInfo+26
	add R30,R24
	adc R31,R25
	std z+0,R6
	std z+1,R7
	std z+2,R8
	std z+3,R9
;                 pBootRecord->HiddSec + pBootRecord->RsvdSecCnt + (pBootRecord->NumFATs * dwFATSz) + dwRootDirSectors;
; 
;             pDrive->dwClusterSize = pBootRecord->SecPerClus * pDrive->wSectorSize;
	movw R30,R12
	ldd R18,z+4
	ldd R19,z+5
	movw R30,R14
	ldd R16,z+13
	clr R17
	xcall empy16s
	movw R2,R16
	clr R4
	clr R5
	movw R30,R12
	std z+30,R2
	std z+31,R3
	std z+32,R4
	std z+33,R5
; 
;             pDrive->dwRootDirSectors = dwRootDirSectors;
	ldd R2,y+14
	ldd R3,y+15
	ldd R4,y+16
	ldd R5,y+17
	std z+6,R2
	std z+7,R3
	std z+8,R4
	std z+9,R5
;             pDrive->dwFirstRootDirSector = pDrive->dwFAT2StartSector + dwFATSz;
	ldd R2,y+10
	ldd R3,y+11
	ldd R4,y+12
	ldd R5,y+13
	ldd R6,z+22
	ldd R7,z+23
	ldd R8,z+24
	ldd R9,z+25
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	std z+10,R6
	std z+11,R7
	std z+12,R8
	std z+13,R9
; 
;         }                       /* endif pBootRecord->Signature */
L133:
;     }
L131:
;     /* endif dwSector != 0 */
;     return (nError);
	ldd R16,y+18
	ldd R17,y+19
L122:
	.dbline 0 ; func end
	adiw R28,20
	xjmp pop_xgsetF0FC
;         nError -> R20,R21
;              i -> R22
;         nDrive -> R10,R11
	.even
_FATMountDrive:
	xcall push_xgsetF00C
	movw R10,R16
	sbiw R28,2
; }
; 
; /*==========================================================*/
; /*  DEFINE: All code exported by the NUTDEVICE              */
; /*==========================================================*/
; /************************************************************/
; /*  FATMountDrive                                           */
; /************************************************************/
; static int FATMountDrive(int nDrive)
; {
;     BYTE i;
;     int nError;
; 
;     nError = IDE_OK;
	clr R20
	clr R21
; 
;     FATLock();
	xcall _FATLock
; 
;     nDrive = nDrive;
; 
;     if (pLongName1 == NULL) {
	lds R2,_pLongName1
	lds R3,_pLongName1+1
	tst R2
	brne L140
	tst R3
	brne L140
X94:
;         pLongName1 = (char *) NutHeapAlloc(FAT_LONG_NAME_LEN);
	ldi R16,64
	ldi R17,0
	xcall _NutHeapAlloc
	sts _pLongName1+1,R17
	sts _pLongName1,R16
;     }
L140:
;     if (pLongName2 == NULL) {
	lds R2,_pLongName2
	lds R3,_pLongName2+1
	tst R2
	brne L142
	tst R3
	brne L142
X95:
;         pLongName2 = (char *) NutHeapAlloc(FAT_LONG_NAME_LEN);
	ldi R16,64
	ldi R17,0
	xcall _NutHeapAlloc
	sts _pLongName2+1,R17
	sts _pLongName2,R16
;     }
L142:
;     if (pSectorBuffer == NULL) {
	lds R2,_pSectorBuffer
	lds R3,_pSectorBuffer+1
	tst R2
	brne L144
	tst R3
	brne L144
X96:
;         pSectorBuffer = (BYTE *) NutHeapAlloc(MAX_SECTOR_SIZE);
	ldi R16,2048
	ldi R17,8
	xcall _NutHeapAlloc
	movw R10,R16
	sts _pSectorBuffer+1,R11
	sts _pSectorBuffer,R10
;     }
L144:
; 
;     if ((pSectorBuffer != NULL) && (pLongName1 != NULL) && (pLongName2 != NULL)) {
	lds R2,_pSectorBuffer
	lds R3,_pSectorBuffer+1
	tst R2
	brne X97
	tst R3
	brne X106
	xjmp L146
X106:
X97:
	lds R2,_pLongName1
	lds R3,_pLongName1+1
	tst R2
	brne X98
	tst R3
	brne X107
	xjmp L146
X107:
X98:
	lds R2,_pLongName2
	lds R3,_pLongName2+1
	tst R2
	brne X99
	tst R3
	brne X108
	xjmp L146
X108:
X99:
; 
;         for (i = 0; i < FAT_MAX_DRIVE; i++) {
	clr R22
	xjmp L151
L148:
;             memset((BYTE *) & sDriveInfo[i], 0x00, sizeof(DRIVE_INFO));
	ldi R24,34
	ldi R25,0
	std y+1,R25
	std y+0,R24
	clr R18
	clr R19
	mul R24,R22
	movw R16,R0
	ldi R24,<_sDriveInfo
	ldi R25,>_sDriveInfo
	add R16,R24
	adc R17,R25
	xcall _memset
; 
;             sDriveInfo[i].bDevice = i;
	ldi R24,34
	mul R24,R22
	movw R30,R0
	ldi R24,<_sDriveInfo+1
	ldi R25,>_sDriveInfo+1
	add R30,R24
	adc R31,R25
	std z+0,R22
;             sDriveInfo[i].wSectorSize = IDEGetSectorSize(i);
	mov R16,R22
	xcall _IDEGetSectorSize
	movw R10,R16
	ldi R24,34
	mul R24,R22
	movw R30,R0
	ldi R24,<_sDriveInfo+4
	ldi R25,>_sDriveInfo+4
	add R30,R24
	adc R31,R25
	std z+1,R11
	std z+0,R10
; 
;             if (IDEIsCDROMDevice(i) == TRUE) {
	mov R16,R22
	xcall _IDEIsCDROMDevice
	movw R10,R16
	cpi R16,1
	ldi R30,0
	cpc R17,R30
	brne L154
X100:
;                 sDriveInfo[i].bFlags |= FLAG_FAT_IS_CDROM;
	ldi R24,34
	mul R24,R22
	movw R10,R0
	ldi R24,<_sDriveInfo+3
	ldi R25,>_sDriveInfo+3
	add R10,R24
	adc R11,R25
	movw R30,R10
	ldd R24,z+0
	ori R24,1
	std z+0,R24
;             }
L154:
; 
;             if (IDEIsZIPDevice(i) == TRUE) {
	mov R16,R22
	xcall _IDEIsZIPDevice
	movw R10,R16
	cpi R16,1
	ldi R30,0
	cpc R17,R30
	brne L157
X101:
;                 sDriveInfo[i].bFlags |= FLAG_FAT_IS_ZIP;
	ldi R24,34
	mul R24,R22
	movw R10,R0
	ldi R24,<_sDriveInfo+3
	ldi R25,>_sDriveInfo+3
	add R10,R24
	adc R11,R25
	movw R30,R10
	ldd R24,z+0
	ori R24,2
	std z+0,R24
;             }
L157:
; 
;             switch (sDriveInfo[i].wSectorSize) {
	ldi R24,34
	mul R24,R22
	movw R30,R0
	ldi R24,<_sDriveInfo+4
	ldi R25,>_sDriveInfo+4
	add R30,R24
	adc R31,R25
	ldd R10,z+0
	ldd R11,z+1
	movw R24,R10
	cpi R24,0
	ldi R30,2
	cpc R25,R30
	breq L164
X102:
	cpi R24,0
	ldi R30,2
	cpc R25,R30
	brlt L160
X103:
L166:
	movw R24,R10
	cpi R24,0
	ldi R30,8
	cpc R25,R30
	breq L165
X104:
	xjmp L160
L164:
;             case IDE_SECTOR_SIZE:{
;                     nError = MountIDE(i);
	mov R16,R22
	clr R17
	xcall _MountIDE
	movw R10,R16
	movw R20,R10
;                     break;
	xjmp L161
L165:
;                 }
; #if (IDE_SUPPORT_ATAPI == 1)
;             case ATAPI_SECTOR_SIZE:{
;                     nError = MountATAPI(i);
	mov R16,R22
	clr R17
	xcall _MountATAPI
	movw R10,R16
	movw R20,R10
;                     break;
	xjmp L161
L160:
;                 }
; #endif
;             default:{
;                     nError = IDE_ERROR;
	ldi R20,1
	ldi R21,0
;                     break;
L161:
;                 }
;             }
; 
;         }                       /* endfor i<FAT32_MAX_DRIVE */
L149:
	inc R22
L151:
	cpi R22,2
	brsh X109
	xjmp L148
X109:
X105:
;     }
L146:
;     /* endif pSectorBuffer != NULL */
;     FATFree();
	xcall _FATFree
; 
;     return (nError);
	movw R16,R20
L139:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgsetF00C
;         pDrive -> R22,R23
;         nError -> R20,R21
;         nDrive -> R22,R23
	.even
_FATUnMountDrive:
	xcall push_xgsetF000
	movw R22,R16
; }
; 
; /************************************************************/
; /*  FATUnMountDrive                                         */
; /************************************************************/
; static int FATUnMountDrive(int nDrive)
; {
;     int nError;
;     DRIVE_INFO *pDrive;
; 
;     FATLock();
	xcall _FATLock
; 
;     nError = FAT_OK;
	clr R20
	clr R21
; 
;     if ((nDrive >= IDE_DRIVE_C) && (nDrive <= IDE_DRIVE_D)) {
	cpi R22,0
	ldi R30,0
	cpc R23,R30
	brlt L168
X110:
	ldi R24,1
	ldi R25,0
	cp R24,R22
	cpc R25,R23
	brlt L168
X111:
;         pDrive = &sDriveInfo[nDrive];
	ldi R16,34
	ldi R17,0
	movw R18,R22
	xcall empy16s
	movw R22,R16
	ldi R24,<_sDriveInfo
	ldi R25,>_sDriveInfo
	add R22,R24
	adc R23,R25
;         pDrive->bSectorsPerCluster = 0;
	clr R2
	movw R30,R22
	std z+2,R2
;     } else {
	xjmp L169
L168:
;         nError = FAT_ERROR;
	ldi R20,-1
	ldi R21,-1
;     }
L169:
; 
;     FATFree();
	xcall _FATFree
; 
;     return (nError);
	movw R16,R20
L167:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
;  pSectorBuffer -> R10,R11
;         nDrive -> R12,R13
	.even
_CFMount:
	xcall push_xgset003C
	movw R12,R16
; }
; 
; /************************************************************/
; /*  CFMount                                                 */
; /************************************************************/
; static void CFMount(int nDrive)
; {
;     BYTE *pSectorBuffer;
; 
;     pSectorBuffer = (BYTE *) NutHeapAlloc(MAX_SECTOR_SIZE);
	ldi R16,2048
	ldi R17,8
	xcall _NutHeapAlloc
	movw R10,R16
;     if (pSectorBuffer != NULL) {
	cpi R16,0
	cpc R16,R17
	breq L171
X112:
;         FATMountDrive(nDrive);
	movw R16,R12
	xcall _FATMountDrive
;         NutHeapFree(pSectorBuffer);
	movw R16,R10
	xcall _NutHeapFree
;     }
L171:
L170:
	.dbline 0 ; func end
	xjmp pop_xgset003C
;         nDrive -> R10,R11
	.even
_CFUnMount:
	st -y,R10
	st -y,R11
	movw R10,R16
; }
; 
; /************************************************************/
; /*  CFUnMount                                               */
; /************************************************************/
; static void CFUnMount(int nDrive)
; {
;     FATUnMountDrive(nDrive);
	movw R16,R10
	xcall _FATUnMountDrive
L173:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
;       nIDEMode -> R22,R23
;  pSectorBuffer -> R10,R11
;         nError -> R20,R21
;        pDevice -> R12,R13
	.even
_FATInit:
	xcall push_xgsetF03C
	movw R12,R16
	sbiw R28,4
; }
; 
; /************************************************************/
; /*  FATInit                                                 */
; /************************************************************/
; static int FATInit(NUTDEVICE * pDevice)
; {
;     int nError;
;     int nIDEMode;
;     BYTE *pSectorBuffer;
; 
;     nError = NUTDEV_OK;
	clr R20
	clr R21
;     nIDEMode = IDE_HARDDISK;
	clr R22
	clr R23
;     pSectorBuffer = NULL;
	clr R10
	clr R11
; 
;     if (gnIsInit == FALSE) {
	lds R2,_gnIsInit
	lds R3,_gnIsInit+1
	tst R2
	breq X120
	xjmp L175
X120:
	tst R3
	breq X121
	xjmp L175
X121:
X113:
;         gnIsInit = TRUE;
	ldi R24,1
	ldi R25,0
	sts _gnIsInit+1,R25
	sts _gnIsInit,R24
;         //
;         // Get the mode.
;         //
;         switch (pDevice->dev_base) {
	movw R30,R12
	ldd R12,z+12
	ldd R13,z+13
	movw R24,R12
	cpi R24,1
	ldi R30,0
	cpc R25,R30
	breq L180
X114:
	cpi R24,2
	ldi R30,0
	cpc R25,R30
	breq L181
X115:
	cpi R24,3
	ldi R30,0
	cpc R25,R30
	breq L182
X116:
	cpi R24,4
	ldi R30,0
	cpc R25,R30
	breq L183
X117:
	xjmp L177
L180:
;         case FAT_MODE_IDE_HD:
;             nIDEMode = IDE_HARDDISK;
	clr R22
	clr R23
;             break;
	xjmp L178
L181:
;         case FAT_MODE_IDE_HD_7MHZ:
;             nIDEMode = IDE_HARDDISK_7MHZ;
	ldi R22,1
	ldi R23,0
;             break;
	xjmp L178
L182:
;         case FAT_MODE_IDE_CF:
;             nIDEMode = IDE_COMPACT_FLASH;
	ldi R22,2
	ldi R23,0
;             break;
	xjmp L178
L183:
;         case FAT_MODE_MEM_CF:
;             nIDEMode = MEM_8BIT_COMPACT_FLASH;
	ldi R22,3
	ldi R23,0
;             break;
	xjmp L178
L177:
;         default:
;             nError = NUTDEV_ERROR;
	ldi R20,-1
	ldi R21,-1
;             break;
L178:
;         }
; 
;         if (nError == NUTDEV_OK) {
	cpi R20,0
	cpc R20,R21
	brne L184
X118:
; 
;             //
;             // Init my semaphore.
;             //
;             FATSemaInit();
	xcall _FATSemaInit
; 
;             pSectorBuffer = (BYTE *) NutHeapAlloc(MAX_SECTOR_SIZE);
	ldi R16,2048
	ldi R17,8
	xcall _NutHeapAlloc
	movw R10,R16
;             if (pSectorBuffer != NULL) {
	cpi R16,0
	cpc R16,R17
	breq L186
X119:
;                 IDEInit(0, nIDEMode, CFMount, CFUnMount);
	ldi R24,<PL_CFUnMount
	ldi R25,>PL_CFUnMount
	std y+3,R25
	std y+2,R24
	ldi R24,<PL_CFMount
	ldi R25,>PL_CFMount
	std y+1,R25
	std y+0,R24
	movw R18,R22
	clr R16
	clr R17
	xcall _IDEInit
; 
;                 IDEMountDevice(IDE_DRIVE_C, pSectorBuffer);
	movw R18,R10
	clr R16
	xcall _IDEMountDevice
;                 FATMountDrive(IDE_DRIVE_C);
	clr R16
	clr R17
	xcall _FATMountDrive
; 
;                 NutHeapFree(pSectorBuffer);
	movw R16,R10
	xcall _NutHeapFree
;             }                   /* endif pSectorBuffer != NULL */
L186:
;         }                       /* endif nError == NUTDEV_OK */
L184:
;     }
L175:
;     /* endif gnIsInit == FALSE */
;     return (nError);
	movw R16,R20
L174:
	.dbline 0 ; func end
	adiw R28,4
	xjmp pop_xgsetF03C
;     dwFileSize -> y+46
;      dwCluster -> y+42
;         nError -> y+58
;     pExtension -> R22,R23
;       hNUTFile -> R20,R21
;          hFile -> y+56
;         pDrive -> y+54
;      nLongName -> y+52
;              x -> R22,R23
;      sDirEntry -> y+10
;      nEndWhile -> R14,R15
;     pShortName -> R10,R11
;      pLongName -> y+50
;              i -> R12,R13
;        nAccess -> y+76
;          nMode -> y+74
;          pName -> y+72
;        pDevice -> y+70
	.even
_FATFileOpen:
	xcall push_arg4
	xcall push_xgsetF0FC
	sbiw R28,60
; }
; 
; /************************************************************/
; /*  FATFileOpen                                             */
; /*                                                          */
; /*  Opens an existing file for reading.                     */
; /*                                                          */
; /*  Parameters: pName points to a string that specifies the */
; /*              name of the file to open. The name must     */
; /*              exactly match the full pathname of the file.*/
; /*                                                          */
; /*  Returns:    A pointer to a FILE structure that can be   */
; /*              used to read the file and retrieve          */
; /*              information about the file.                 */
; /*                                                          */
; /*              A return value of -1 indicates an error.    */
; /************************************************************/
; static NUTFILE *FATFileOpen(NUTDEVICE * pDevice, CONST char *pName, int nMode, int nAccess)
; {
;     int i, x;
;     int nError;
;     int nEndWhile;
;     DWORD dwFileSize;
;     DWORD dwCluster;
;     FHANDLE *hFile;
;     DRIVE_INFO *pDrive;
;     FAT32_DIRECTORY_ENTRY sDirEntry;
; 
;     NUTFILE *hNUTFile;
; 
;     int nLongName;
;     char *pLongName;
;     char *pShortName;
;     char *pExtension;
; 
;     //
;     // If the user has forgotten to call NUTDeviceOpen,
;     // we must call FATInit.
;     //
;     if (gnIsInit == FALSE) {
	lds R2,_gnIsInit
	lds R3,_gnIsInit+1
	tst R2
	brne L189
	tst R3
	brne L189
X122:
;         FATInit(pDevice);
	movw R30,R28
	subi R30,186  ; addi 70
	sbci R31,255
	ldd R16,z+0
	ldd R17,z+1
	xcall _FATInit
;     }
L189:
; 
;     FATLock();
	xcall _FATLock
; 
;     pDrive = NULL;
	clr R0
	clr R1
	std y+55,R1
	std y+54,R0
;     nError = TRUE;
	ldi R24,1
	ldi R25,0
	std y+59,R25
	std y+58,R24
;     nLongName = FALSE;
	std y+53,R1
	std y+52,R0
;     pLongName = (char *) pLongName1;
	lds R2,_pLongName1
	lds R3,_pLongName1+1
	std y+51,R3
	std y+50,R2
; 
;     //
;     // hFile is our FAT-Handle.
;     //
;     hFile = NULL;
	std y+57,R1
	std y+56,R0
; 
;     //
;     // hNUTFile is the.... correct, NUT handle.
;     //   
;     hNUTFile = (NUTFILE *) NUTDEV_ERROR;
	ldi R20,-1
	ldi R21,-1
; 
;     if (pDevice != NULL) {
	movw R30,R28
	subi R30,186  ; addi 70
	sbci R31,255
	ldd R0,z+0
	ldd R1,z+1
	tst R0
	brne X123
	tst R1
	breq L191
X123:
;         switch (pDevice->dev_name[4]) {
	movw R30,R0
	ldd R22,z+6
	clr R23
	cpi R22,67
	ldi R30,0
	cpc R23,R30
	breq L196
X124:
	cpi R22,68
	ldi R30,0
	cpc R23,R30
	breq L197
X125:
	xjmp L193
L196:
;         case 'C':{
;                 pDrive = &sDriveInfo[IDE_DRIVE_C];
	ldi R24,<_sDriveInfo
	ldi R25,>_sDriveInfo
	std y+55,R25
	std y+54,R24
;                 break;
	xjmp L194
L197:
;             }
;         case 'D':{
;                 pDrive = &sDriveInfo[IDE_DRIVE_D];
	ldi R24,<_sDriveInfo+34
	ldi R25,>_sDriveInfo+34
	std y+55,R25
	std y+54,R24
;                 break;
L193:
L194:
;             }
;         }
;     }
L191:
; 
;     if ((pDrive != NULL) && (pDrive->bSectorsPerCluster != 0) && (pName[0] != 0)) {
	ldd R0,y+54
	ldd R1,y+55
	tst R0
	brne X126
	tst R1
	brne X159
	xjmp L199
X159:
X126:
	movw R30,R0
	ldd R2,z+2
	tst R2
	brne X160
	xjmp L199
X160:
X127:
	movw R26,R28
	subi R26,184  ; addi 72
	sbci R27,255
	ld R30,x+
	ld R31,x
	ldd R2,z+0
	tst R2
	brne X161
	xjmp L199
X161:
X128:
; 
;         //
;         // Create a new file handle.
;         //    
;         hFile = (FHANDLE *) NutHeapAlloc(sizeof(FHANDLE));
	ldi R16,26
	ldi R17,0
	xcall _NutHeapAlloc
	std y+57,R17
	std y+56,R16
; 
;         if ((pDrive->dwFAT1StartSector) && (hFile != NULL) && (*pName != '.')) {
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	ldd R30,y+54
	ldd R31,y+55
	ldd R2,z+18
	ldd R3,z+19
	ldd R4,z+20
	ldd R5,z+21
	cp R2,R24
	cpc R3,R25
	cpc R4,R26
	cpc R5,R27
	brne X162
	xjmp L201
X162:
X129:
	movw R0,R16
	cpi R16,0
	cpc R16,R17
	brne X163
	xjmp L201
X163:
X130:
	movw R26,R28
	subi R26,184  ; addi 72
	sbci R27,255
	ld R30,x+
	ld R31,x
	ldd R24,z+0
	cpi R24,46
	brne X164
	xjmp L201
X164:
X131:
; 
;             memset(hFile, 0x00, sizeof(FHANDLE));
	ldi R24,26
	ldi R25,0
	std y+1,R25
	std y+0,R24
	clr R18
	clr R19
	xcall _memset
; 
;             //
;             // Start by the ROOT dir...
;             //
;             dwCluster = pDrive->dwRootCluster;
	ldd R30,y+54
	ldd R31,y+55
	ldd R2,z+14
	ldd R3,z+15
	ldd R4,z+16
	ldd R5,z+17
	std y+42,R2
	std y+43,R3
	std y+44,R4
	std y+45,R5
; 
;             //
;             // If the first char a "/", jump over, e.g. "/index.html"
;             // 
;             //
;             if (*pName == '/') {
	movw R26,R28
	subi R26,184  ; addi 72
	sbci R27,255
	ld R30,x+
	ld R31,x
	ldd R24,z+0
	cpi R24,47
	brne L203
X132:
;                 pName++;
	movw R24,R30
	adiw R24,1
	movw R30,R28
	subi R30,184  ; addi 72
	sbci R31,255
	std z+1,R25
	std z+0,R24
;             }
L203:
; 
;             nEndWhile = FALSE;
	clr R14
	clr R15
	xjmp L206
L205:
;             while (nEndWhile == FALSE) {        /* master loop */
; 
;                 nLongName = FALSE;
	clr R0
	clr R1
	std y+53,R1
	std y+52,R0
; 
;                 //
;                 // Get Name
;                 //
;                 i = 0;
	clr R12
	clr R13
	xjmp L209
L208:
;                 while ((*pName != '/') && (*pName != '\\') && (*pName != 0)) {
; 
;                     if (i >= (FAT_LONG_NAME_LEN - 1)) {
	movw R24,R12
	cpi R24,63
	ldi R30,0
	cpc R25,R30
	brlt L211
X133:
;                         nEndWhile = TRUE;
	ldi R24,1
	ldi R25,0
	movw R14,R24
;                         break;
	xjmp L210
L211:
;                     }
; 
;                     pLongName[i] = toupper(*pName);
	movw R26,R28
	subi R26,184  ; addi 72
	sbci R27,255
	ld R30,x+
	ld R31,x
	ldd R16,z+0
	clr R17
	xcall _toupper
	movw R30,R12
	ldd R0,y+50
	ldd R1,y+51
	add R30,R0
	adc R31,R1
	std z+0,R16
; 
;                     i++;
	movw R24,R12
	adiw R24,1
	movw R12,R24
;                     pName++;
	movw R30,R28
	subi R30,184  ; addi 72
	sbci R31,255
	ldd R24,z+0
	ldd R25,z+1
	adiw R24,1
	movw R30,R28
	subi R30,184  ; addi 72
	sbci R31,255
	std z+1,R25
	std z+0,R24
;                 }               /* endwhile Name */
L209:
	movw R26,R28
	subi R26,184  ; addi 72
	sbci R27,255
	ld R30,x+
	ld R31,x
	ldd R22,z+0
	clr R23
	cpi R22,47
	breq L214
X134:
	cpi R22,92
	breq L214
X135:
	tst R22
	breq X165
	xjmp L208
X165:
X136:
L214:
L210:
; 
;                 if (nEndWhile == FALSE) {
	tst R14
	breq X166
	xjmp L215
X166:
	tst R15
	breq X167
	xjmp L215
X167:
X137:
;                     pLongName[i] = 0;
	movw R30,R12
	ldd R0,y+50
	ldd R1,y+51
	add R30,R0
	adc R31,R1
	clr R2
	std z+0,R2
; 
;                     //
;                     // Check if it is a Long Directory Entry.
;                     // Yes, I know that 'i' is the length of the string.
;                     // But the code is easier to read with the next strlen.
;                     //
;                     if (strlen(pLongName) <= FAT_SHORT_NAME_LEN) {
	movw R16,R0
	xcall _strlen
	movw R10,R16
	ldi R24,12
	ldi R25,0
	cp R24,R16
	cpc R25,R17
	brlo L217
X138:
;                         //
;                         // It could be a ShortName, but "abc.defg" is possible
;                         // and this is a long name too. Therfore we need some tests.
;                         //
;                         pExtension = strchr(pLongName, '.');
	ldi R18,46
	ldi R19,0
	ldd R16,y+50
	ldd R17,y+51
	xcall _strchr
	movw R10,R16
	movw R22,R10
;                         if (pExtension == NULL) {
	cpi R16,0
	cpc R16,R17
	brne L219
X139:
;                             if (strlen(pLongName) > FAT_NAME_LEN) {
	ldd R16,y+50
	ldd R17,y+51
	xcall _strlen
	movw R10,R16
	ldi R24,8
	ldi R25,0
	cp R24,R16
	cpc R25,R17
	brsh L221
X140:
;                                 nLongName = TRUE;
	ldi R24,1
	std y+53,R25
	std y+52,R24
;                             } else {
	xjmp L218
L221:
;                                 nLongName = FALSE;
	clr R0
	clr R1
	std y+53,R1
	std y+52,R0
;                             }
;                         } else {
	xjmp L218
L219:
;                             //
;                             // Check the length of the extensions.
;                             //
;                             pExtension++;       /* jump over the '.' */
	subi R22,255  ; offset = 1
	sbci R23,255
;                             if (strlen(pExtension) > 3) {
	movw R16,R22
	xcall _strlen
	movw R10,R16
	ldi R24,3
	ldi R25,0
	cp R24,R16
	cpc R25,R17
	brsh L218
X141:
;                                 nLongName = TRUE;
	ldi R24,1
	std y+53,R25
	std y+52,R24
;                             }
;                         }
;                     } else {    /* Len > FAT_SHORT_NAME_LEN */
	xjmp L218
L217:
;                         //
;                         // Now we have a LongName, sure.
;                         // See the "nasty Win98" in FindFile :-)
;                         //
;                         nLongName = TRUE;
	ldi R24,1
	ldi R25,0
	std y+53,R25
	std y+52,R24
;                     }
L218:
; 
;                     //
;                     // Here we knows, if we have a LongName or ShortName.
;                     //
;                     if (nLongName == FALSE) {
	ldd R0,y+52
	ldd R1,y+53
	tst R0
	breq X168
	xjmp L225
X168:
	tst R1
	breq X169
	xjmp L225
X169:
X142:
;                         //
;                         // ShortName
;                         //
;                         pShortName = pLongName;
	ldd R10,y+50
	ldd R11,y+51
;                         memset(&sDirEntry, 0x00, sizeof(FAT32_DIRECTORY_ENTRY));
	ldi R24,32
	ldi R25,0
	std y+1,R25
	std y+0,R24
	clr R18
	clr R19
	movw R16,R28
	subi R16,246  ; offset = 10
	sbci R17,255
	xcall _memset
;                         memset(sDirEntry.Name, 0x20, FAT_NAME_LEN);
	ldi R24,8
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,32
	ldi R19,0
	movw R16,R28
	subi R16,246  ; offset = 10
	sbci R17,255
	xcall _memset
;                         memset(sDirEntry.Extension, 0x20, FAT_EXT_LEN);
	ldi R24,3
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,32
	ldi R19,0
	movw R16,R28
	subi R16,238  ; offset = 18
	sbci R17,255
	xcall _memset
; 
;                         //
;                         // Get the name
;                         //
;                         i = 0;
	clr R12
	clr R13
	xjmp L229
L228:
;                         while ((pShortName[i] != '.') && (pShortName[i] != 0)) {
;                             sDirEntry.Name[i] = pShortName[i];
	movw R30,R12
	add R30,R10
	adc R31,R11
	ldd R2,z+0
	movw R24,R28
	adiw R24,10
	movw R30,R12
	add R30,R24
	adc R31,R25
	std z+0,R2
;                             i++;
	movw R24,R12
	adiw R24,1
	movw R12,R24
;                         }
L229:
	movw R30,R12
	add R30,R10
	adc R31,R11
	ldd R22,z+0
	clr R23
	cpi R22,46
	breq L231
X143:
	tst R22
	brne L228
X144:
L231:
;                         //
;                         // And the extension
;                         //
;                         if (pShortName[i] == '.') {
	movw R30,R12
	add R30,R10
	adc R31,R11
	ldd R24,z+0
	cpi R24,46
	brne L232
X145:
;                             i++;        /* jump over the '.' */
	movw R24,R12
	adiw R24,1
	movw R12,R24
;                             x = 0;
	clr R22
	clr R23
	xjmp L235
L234:
;                             while (pShortName[i] != 0) {
;                                 sDirEntry.Extension[x] = pShortName[i];
	movw R30,R12
	add R30,R10
	adc R31,R11
	ldd R2,z+0
	movw R24,R28
	adiw R24,18
	movw R30,R22
	add R30,R24
	adc R31,R25
	std z+0,R2
;                                 i++;
	movw R24,R12
	adiw R24,1
	movw R12,R24
;                                 x++;
	subi R22,255  ; offset = 1
	sbci R23,255
;                             }
L235:
	movw R30,R12
	add R30,R10
	adc R31,R11
	ldd R2,z+0
	tst R2
	brne L234
X146:
;                         }
L232:
;                     }
L225:
;                     //
;                     // The file could be a long or short one.
;                     // I have seen that Win98 store the short filename
;                     // in a long one :-(
;                     //
;                     switch (*pName) {
	movw R26,R28
	subi R26,184  ; addi 72
	sbci R27,255
	ld R30,x+
	ld R31,x
	ldd R12,z+0
	clr R13
	movw R24,R12
	cpi R24,47
	ldi R30,0
	cpc R25,R30
	brne X170
	xjmp L247
X170:
X147:
	ldi R24,47
	cp R24,R12
	cpc R25,R13
	brlt L254
X148:
L253:
	tst R12
	brne X149
	tst R13
	breq L241
X149:
	xjmp L238
L254:
	movw R24,R12
	cpi R24,92
	ldi R30,0
	cpc R25,R30
	brne X171
	xjmp L247
X171:
X150:
	xjmp L238
L241:
;                         //
;                         // The file is an ARCHIVE
;                         //
;                     case 0:{
;                             nEndWhile = TRUE;
	ldi R24,1
	ldi R25,0
	movw R14,R24
;                             sDirEntry.Attribute = DIRECTORY_ATTRIBUTE_ARCHIVE;
	ldi R24,32
	std y+21,R24
; 
;                             if (pDrive->bFlags & FLAG_FAT_IS_CDROM) {
	ldd R30,y+54
	ldd R31,y+55
	ldd R2,z+3
	sbrs R2,0
	rjmp L243
X151:
;                                 dwCluster = FindFileATAPI(pDrive, &sDirEntry, pLongName, dwCluster, &dwFileSize, nLongName);
	ldd R0,y+52
	ldd R1,y+53
	std y+9,R1
	std y+8,R0
	movw R24,R28
	adiw R24,46
	std y+7,R25
	std y+6,R24
	ldd R2,y+42
	ldd R3,y+43
	ldd R4,y+44
	ldd R5,y+45
	std y+2,R2
	std y+3,R3
	std y+4,R4
	std y+5,R5
	ldd R0,y+50
	ldd R1,y+51
	std y+1,R1
	std y+0,R0
	movw R18,R28
	subi R18,246  ; offset = 10
	sbci R19,255
	movw R16,R30
	xcall _FindFileATAPI
	std y+42,R16
	std y+43,R17
	std y+44,R18
	std y+45,R19
;                             } else {
	xjmp L244
L243:
; #if (IDE_SUPPORT_ATAPI == 1)
;                                 dwCluster = FindFile(pDrive, &sDirEntry, pLongName, dwCluster, &dwFileSize, nLongName);
	ldd R0,y+52
	ldd R1,y+53
	std y+9,R1
	std y+8,R0
	movw R24,R28
	adiw R24,46
	std y+7,R25
	std y+6,R24
	ldd R2,y+42
	ldd R3,y+43
	ldd R4,y+44
	ldd R5,y+45
	std y+2,R2
	std y+3,R3
	std y+4,R4
	std y+5,R5
	ldd R0,y+50
	ldd R1,y+51
	std y+1,R1
	std y+0,R0
	movw R18,R28
	subi R18,246  ; offset = 10
	sbci R19,255
	ldd R16,y+54
	ldd R17,y+55
	xcall _FindFile
	std y+42,R16
	std y+43,R17
	std y+44,R18
	std y+45,R19
; #else
;                                 dwCluster = 0;
; #endif
;                             }
L244:
;                             if (dwCluster != 0) {
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	ldd R2,y+42
	ldd R3,y+43
	ldd R4,y+44
	ldd R5,y+45
	cp R2,R24
	cpc R3,R25
	cpc R4,R26
	cpc R5,R27
	brne X172
	xjmp L239
X172:
X152:
;                                 hFile->dwFileSize = dwFileSize;
	ldd R2,y+46
	ldd R3,y+47
	ldd R4,y+48
	ldd R5,y+49
	ldd R30,y+56
	ldd R31,y+57
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;                                 hFile->dwStartCluster = dwCluster;
	ldd R2,y+42
	ldd R3,y+43
	ldd R4,y+44
	ldd R5,y+45
	std z+4,R2
	std z+5,R3
	std z+6,R4
	std z+7,R5
;                                 hFile->dwReadCluster = dwCluster;
	std z+8,R2
	std z+9,R3
	std z+10,R4
	std z+11,R5
;                                 hFile->dwFilePointer = 0;
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std z+12,R24
	std z+13,R25
	std z+14,R26
	std z+15,R27
;                                 hFile->dwClusterPointer = 0;
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std z+16,R24
	std z+17,R25
	std z+18,R26
	std z+19,R27
;                                 hFile->pDrive = pDrive;
	ldd R0,y+54
	ldd R1,y+55
	std z+25,R1
	std z+24,R0
;                                 hFile->nLastError = FAT_OK;
	clr R2
	clr R3
	std z+21,R3
	std z+20,R2
;                                 hFile->nEOF = FALSE;
	std z+23,R3
	std z+22,R2
; 
;                                 nError = FALSE;
	clr R0
	clr R1
	std y+59,R1
	std y+58,R0
;                             }
;                             break;
	xjmp L239
L247:
;                         }       /* endcase 0 */
; 
;                         //
;                         // The file is a DIRECTORY
;                         //
;                     case '/':
;                     case '\\':{
;                             pName++;    /* jump over the char */
	movw R30,R28
	subi R30,184  ; addi 72
	sbci R31,255
	ldd R24,z+0
	ldd R25,z+1
	adiw R24,1
	movw R30,R28
	subi R30,184  ; addi 72
	sbci R31,255
	std z+1,R25
	std z+0,R24
; 
;                             sDirEntry.Attribute = DIRECTORY_ATTRIBUTE_DIRECTORY;
	ldi R24,16
	std y+21,R24
; 
;                             if (pDrive->bFlags & FLAG_FAT_IS_CDROM) {
	ldd R30,y+54
	ldd R31,y+55
	ldd R2,z+3
	sbrs R2,0
	rjmp L249
X153:
;                                 dwCluster = FindFileATAPI(pDrive, &sDirEntry, pLongName, dwCluster, &dwFileSize, nLongName);
	ldd R0,y+52
	ldd R1,y+53
	std y+9,R1
	std y+8,R0
	movw R24,R28
	adiw R24,46
	std y+7,R25
	std y+6,R24
	ldd R2,y+42
	ldd R3,y+43
	ldd R4,y+44
	ldd R5,y+45
	std y+2,R2
	std y+3,R3
	std y+4,R4
	std y+5,R5
	ldd R0,y+50
	ldd R1,y+51
	std y+1,R1
	std y+0,R0
	movw R18,R28
	subi R18,246  ; offset = 10
	sbci R19,255
	movw R16,R30
	xcall _FindFileATAPI
	std y+42,R16
	std y+43,R17
	std y+44,R18
	std y+45,R19
;                             } else {
	xjmp L250
L249:
; #if (IDE_SUPPORT_ATAPI == 1)
;                                 dwCluster = FindFile(pDrive, &sDirEntry, pLongName, dwCluster, &dwFileSize, nLongName);
	ldd R0,y+52
	ldd R1,y+53
	std y+9,R1
	std y+8,R0
	movw R24,R28
	adiw R24,46
	std y+7,R25
	std y+6,R24
	ldd R2,y+42
	ldd R3,y+43
	ldd R4,y+44
	ldd R5,y+45
	std y+2,R2
	std y+3,R3
	std y+4,R4
	std y+5,R5
	ldd R0,y+50
	ldd R1,y+51
	std y+1,R1
	std y+0,R0
	movw R18,R28
	subi R18,246  ; offset = 10
	sbci R19,255
	ldd R16,y+54
	ldd R17,y+55
	xcall _FindFile
	std y+42,R16
	std y+43,R17
	std y+44,R18
	std y+45,R19
; #else
;                                 dwCluster = 0;
; #endif
;                             }
L250:
;                             if (dwCluster != 0) {
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	ldd R2,y+42
	ldd R3,y+43
	ldd R4,y+44
	ldd R5,y+45
	cp R2,R24
	cpc R3,R25
	cpc R4,R26
	cpc R5,R27
	breq L251
X154:
; 
;                                 //
;                                 // The new Cluster is the Cluster of the directory
;                                 //
; 
;                             } else {
	xjmp L239
L251:
;                                 nEndWhile = TRUE;
	ldi R24,1
	ldi R25,0
	movw R14,R24
;                             }
;                             break;
	xjmp L239
L238:
;                         }       /* endcase / \ */
; 
;                     default:{
;                             nEndWhile = TRUE;
	ldi R24,1
	ldi R25,0
	movw R14,R24
;                             break;
L239:
;                         }
;                     }           /* end switch */
; 
;                 }
L215:
;                 /* endif nEndWhile == FALSE */
;             }                   /* end while */
L206:
	tst R14
	brne X155
	tst R15
	brne X173
	xjmp L205
X173:
X155:
; 
;         }
L201:
;         /* endif pDrive->dwFAT1StartSector */
;         if (nError == TRUE) {
	ldd R24,y+58
	ldd R25,y+59
	cpi R24,1
	ldi R30,0
	cpc R25,R30
	brne L255
X156:
;             //
;             // We found no file, therefore we can delete our FAT-Handle
;             //
;             if (hFile != NULL) {
	ldd R0,y+56
	ldd R1,y+57
	tst R0
	brne X157
	tst R1
	breq L256
X157:
;                 NutHeapFree(hFile);
	movw R16,R0
	xcall _NutHeapFree
;             }
;         } else {
	xjmp L256
L255:
;             //
;             // We have found a FILE and can create a NUT-Handle.
;             //
;             hNUTFile = NutHeapAlloc(sizeof(NUTFILE));
	ldi R16,6
	ldi R17,0
	xcall _NutHeapAlloc
	movw R12,R16
	movw R20,R12
;             if (hNUTFile != NULL) {
	cpi R16,0
	cpc R16,R17
	breq L259
X158:
;                 hNUTFile->nf_next = 0;
	clr R2
	clr R3
	movw R30,R20
	std z+1,R3
	std z+0,R2
;                 hNUTFile->nf_dev = pDevice;
	movw R26,R28
	subi R26,186  ; addi 70
	sbci R27,255
	ld R0,x+
	ld R1,x
	std z+3,R1
	std z+2,R0
;                 hNUTFile->nf_fcb = hFile;
	ldd R0,y+56
	ldd R1,y+57
	std z+5,R1
	std z+4,R0
;             } else {
	xjmp L260
L259:
;                 //
;                 // Error, no mem for the NUT-Handle, therefore we 
;                 // can delete our FAT-Handle too.
;                 //
;                 NutHeapFree(hFile);
	ldd R16,y+56
	ldd R17,y+57
	xcall _NutHeapFree
;             }
L260:
;         }
L256:
; 
;     }
L199:
;     /* endif pName[0] != 0 */
;     FATFree();
	xcall _FATFree
; 
;     return (hNUTFile);
	movw R16,R20
L188:
	.dbline 0 ; func end
	adiw R28,60
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
;          hFile -> R10,R11
;         nError -> R20,R21
;       hNUTFile -> R22,R23
	.even
_FATFileClose:
	xcall push_xgsetF00C
	movw R22,R16
; }
; 
; /************************************************************/
; /*  FATFileClose                                            */
; /*                                                          */
; /*  Close a previously opened file.                         */
; /*                                                          */
; /*  Parameters: hNUTFile Identifies the file to close.      */
; /*              This pointer must have been created by      */
; /*              calling FAT32FileOpen().                    */
; /*                                                          */
; /*  Returns:    0 if the function is successfully closed,   */
; /*              -1 otherwise.                               */
; /************************************************************/
; static int FATFileClose(NUTFILE * hNUTFile)
; {
;     int nError;
;     FHANDLE *hFile;
; 
;     nError = NUTDEV_ERROR;
	ldi R20,-1
	ldi R21,-1
; 
;     FATLock();
	xcall _FATLock
; 
;     if (hNUTFile != NULL) {
	cpi R22,0
	cpc R22,R23
	breq L262
X174:
;         hFile = (FHANDLE *) hNUTFile->nf_fcb;
	movw R30,R22
	ldd R10,z+4
	ldd R11,z+5
;         if (hFile != NULL) {
	tst R10
	brne X175
	tst R11
	breq L264
X175:
;             //
;             // Clear our FAT-Handle
;             //
;             NutHeapFree(hFile);
	movw R16,R10
	xcall _NutHeapFree
;         }
L264:
;         //
;         // Clear the NUT-Handle
;         //
;         NutHeapFree(hNUTFile);
	movw R16,R22
	xcall _NutHeapFree
; 
;         nError = NUTDEV_OK;
	clr R20
	clr R21
;     }
L262:
; 
;     FATFree();
	xcall _FATFree
; 
;     return (nError);
	movw R16,R20
L261:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
;          hFile -> R10,R11
;          lSize -> y+0
;       hNUTFile -> R20,R21
	.even
_FATFileSize::
	xcall push_xgset300C
	movw R20,R16
	sbiw R28,4
; }
; 
; /************************************************************/
; /*  FATFileSize                                             */
; /*                                                          */
; /*  Retrieve the size of a file.                            */
; /*                                                          */
; /*  Parameters: pFile Identifies the file to query.         */
; /*              This pointer must have been created by      */
; /*              calling FAT32FileOpen().                    */
; /*                                                          */
; /*  Returns:    The number of bytes in this file or         */
; /*              -1 if an error occured                      */
; /************************************************************/
; long FATFileSize(NUTFILE * hNUTFile)
; {
;     long lSize;
;     FHANDLE *hFile;
; 
;     FATLock();
	xcall _FATLock
; 
;     lSize = NUTDEV_ERROR;
	ldi R24,255
	ldi R25,255
	ldi R26,255
	ldi R27,255
	std y+0,R24
	std y+1,R25
	std y+2,R26
	std y+3,R27
; 
;     if (hNUTFile != NULL) {
	cpi R20,0
	cpc R20,R21
	breq L267
X176:
;         hFile = (FHANDLE *) hNUTFile->nf_fcb;
	movw R30,R20
	ldd R10,z+4
	ldd R11,z+5
;         if (hFile != NULL) {
	tst R10
	brne X177
	tst R11
	breq L269
X177:
;             lSize = hFile->dwFileSize;
	movw R30,R10
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
;         }
L269:
;     }
L267:
; 
;     FATFree();
	xcall _FATFree
; 
;     return (lSize);
	ldd R16,y+0
	ldd R17,y+1
	ldd R18,y+2
	ldd R19,y+3
L266:
	.dbline 0 ; func end
	adiw R28,4
	xjmp pop_xgset300C
;          pByte -> y+22
;     nBytesRead -> y+20
;   nSectorCount -> R10,R11
;       dwSector -> y+10
;   dwReadSector -> y+6
;  nSectorOffset -> R12,R13
;         nError -> y+18
;         pDrive -> y+16
;    wSectorSize -> R14,R15
;   nBytesToRead -> R10,R11
;          hFile -> y+14
;          nSize -> y+34
;          pData -> R10,R11
;       hNUTFile -> R12,R13
	.even
_FATFileRead::
	xcall push_xgsetF0FC
	movw R10,R18
	movw R12,R16
	sbiw R28,24
; }
; 
; #if 0
; /************************************************************/
; /*  FATFileSeek                                             */
; /*                                                          */
; /*  Move the file pointer to a new position.                */
; /*  It points to the next byte to be read from a file.      */
; /*  The file pointer is automatically incremented for       */
; /*  each byte read. When the file is opened, it is at       */
; /*  position 0, the beginning of the file.                  */
; /*                                                          */
; /*  Parameters: pFile Identifies the file to seek.          */
; /*              This pointer must have been created by      */
; /*              calling FAT32FileOpen().                    */
; /*                                                          */
; /*              lPos Specifies the new absolute position    */
; /*              of the file pointer.                        */
; /*                                                          */
; /*  Returns:    0 if the function is successful,            */
; /*              -1 otherwise.                               */
; /************************************************************/
; int FATFileSeek(FILE * pFile, long lPos)
; {
;     int nError = NUTDEV_ERROR;
;     FHANDLE *hFile;
; 
;     FATLock();
; 
;     hFile = (FHANDLE *) pFile;
; 
;     //
;     // We must do some work here...
;     //
;     nError = FAT32_ERROR;
; 
;     FATFree();
; 
;     return (nError);
; }
; #endif
; 
; /************************************************************/
; /*  FATFileRead                                             */
; /*                                                          */
; /*  Read data from a file.                                  */
; /*                                                          */
; /*  Parameters: pFile Identifies the file to read from.     */
; /*              This pointer must have been created by      */
; /*              calling FAT32FileOpen().                    */
; /*                                                          */
; /*              pData Points to the buffer that receives    */
; /*              the data.                                   */
; /*                                                          */
; /*              nSize Specifies the number of bytes to      */
; /*              read from the file.                         */
; /*                                                          */
; /*  Returns:    The number of bytes read from the file or   */
; /*               -1 if an error occured.                    */
; /************************************************************/
; int FATFileRead(NUTFILE * hNUTFile, void *pData, int nSize)
; {
;     int nError;
;     int nBytesRead;
;     int nBytesToRead;
;     FHANDLE *hFile;
;     DRIVE_INFO *pDrive;
;     BYTE *pByte;
;     DWORD dwReadSector;
;     DWORD dwSector;
;     int nSectorCount;
;     int nSectorOffset;
;     WORD wSectorSize;
; 
;     nBytesRead = 0;
	clr R0
	clr R1
	std y+21,R1
	std y+20,R0
; 
;     FATLock();
	xcall _FATLock
; 
;     hFile = NULL;
	clr R0
	clr R1
	std y+15,R1
	std y+14,R0
;     nError = NUTDEV_ERROR;
	ldi R24,-1
	ldi R25,-1
	std y+19,R25
	std y+18,R24
; 
;     if (hNUTFile != NULL) {
	tst R12
	brne X178
	tst R13
	breq L272
X178:
;         hFile = (FHANDLE *) hNUTFile->nf_fcb;
	movw R30,R12
	ldd R2,z+4
	ldd R3,z+5
	std y+15,R3
	std y+14,R2
;     }
L272:
; 
;     if ((hFile != NULL) && (nSize != 0)) {
	ldd R0,y+14
	ldd R1,y+15
	tst R0
	brne X179
	tst R1
	brne X189
	xjmp L274
X189:
X179:
	ldd R0,y+34
	ldd R1,y+35
	tst R0
	brne X180
	tst R1
	brne X190
	xjmp L274
X190:
X180:
;         if (hFile->dwFilePointer < hFile->dwFileSize) {
	ldd R30,y+14
	ldd R31,y+15
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	ldd R6,z+12
	ldd R7,z+13
	ldd R8,z+14
	ldd R9,z+15
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	brlo X191
	xjmp L276
X191:
X181:
; 
;             if ((hFile->dwFilePointer + nSize) > hFile->dwFileSize) {
	movw R2,R0
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	cp R2,R6
	cpc R3,R7
	cpc R4,R8
	cpc R5,R9
	brsh L278
X182:
;                 nSize = (int) (hFile->dwFileSize - hFile->dwFilePointer);
	ldd R2,z+12
	ldd R3,z+13
	ldd R4,z+0
	ldd R5,z+1
	sub R4,R2
	sbc R5,R3
	std y+35,R5
	std y+34,R4
;             }
L278:
; 
;             pDrive = (DRIVE_INFO *) hFile->pDrive;
	ldd R30,y+14
	ldd R31,y+15
	ldd R2,z+24
	ldd R3,z+25
	std y+17,R3
	std y+16,R2
;             pByte = (BYTE *) pData;
	std y+23,R11
	std y+22,R10
; 
;             nBytesRead = nSize;
	ldd R0,y+34
	ldd R1,y+35
	std y+21,R1
	std y+20,R0
;             wSectorSize = pDrive->wSectorSize;
	ldd R30,y+16
	ldd R31,y+17
	ldd R14,z+4
	ldd R15,z+5
	xjmp L281
L280:
; 
;             while (nSize) {
;                 dwSector = GetFirstSectorOfCluster(pDrive, hFile->dwReadCluster);
	ldd R30,y+14
	ldd R31,y+15
	ldd R2,z+8
	ldd R3,z+9
	ldd R4,z+10
	ldd R5,z+11
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldd R16,y+16
	ldd R17,y+17
	xcall _GetFirstSectorOfCluster
	std y+10,R16
	std y+11,R17
	std y+12,R18
	std y+13,R19
;                 nSectorCount = hFile->dwClusterPointer / wSectorSize;
	movw R2,R14
	clr R4
	clr R5
	ldd R30,y+14
	ldd R31,y+15
	ldd R16,z+16
	ldd R17,z+17
	ldd R18,z+18
	ldd R19,z+19
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	xcall div32u
	movw R10,R16
;                 nSectorOffset = hFile->dwClusterPointer % wSectorSize;
	movw R2,R14
	clr R4
	clr R5
	ldd R30,y+14
	ldd R31,y+15
	ldd R16,z+16
	ldd R17,z+17
	ldd R18,z+18
	ldd R19,z+19
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	xcall mod32u
	movw R12,R16
; 
;                 //
;                 // (Sector + SectorCount) is the sector to read
;                 // SectorOffset is the start position in the sector itself
;                 //
;                 dwReadSector = dwSector + nSectorCount;
	movw R2,R10
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	ldd R6,y+10
	ldd R7,y+11
	ldd R8,y+12
	ldd R9,y+13
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	std y+6,R6
	std y+7,R7
	std y+8,R8
	std y+9,R9
; 
;                 nError = IDEReadSectors(pDrive->bDevice, pSectorBuffer, dwReadSector, 1);
	ldi R24,1
	ldi R25,0
	std y+5,R25
	std y+4,R24
	ldd R2,y+6
	ldd R3,y+7
	ldd R4,y+8
	ldd R5,y+9
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	lds R18,_pSectorBuffer
	lds R19,_pSectorBuffer+1
	ldd R30,y+16
	ldd R31,y+17
	ldd R16,z+1
	xcall _IDEReadSectors
	std y+19,R17
	std y+18,R16
;                 if (nError == IDE_OK) {
	movw R0,R16
	cpi R16,0
	cpc R16,R17
	breq X192
	xjmp L283
X192:
X183:
;                     //
;                     // Find the size we can read from ONE sector
;                     //
;                     if (nSize > (int) wSectorSize) {
	ldd R0,y+34
	ldd R1,y+35
	cp R14,R0
	cpc R15,R1
	brge L285
X184:
;                         nBytesToRead = wSectorSize;
	movw R10,R14
;                     } else {
	xjmp L286
L285:
;                         nBytesToRead = nSize;
	ldd R10,y+34
	ldd R11,y+35
;                     }
L286:
; 
;                     //
;                     // Test inside a sector
;                     //
;                     if ((nSectorOffset + nBytesToRead) > (int) wSectorSize) {
	movw R2,R12
	add R2,R10
	adc R3,R11
	cp R14,R2
	cpc R15,R3
	brge L287
X185:
;                         nBytesToRead = wSectorSize - nSectorOffset;
	movw R10,R14
	sub R10,R12
	sbc R11,R13
;                     }
L287:
; 
;                     memcpy(pByte, &pSectorBuffer[nSectorOffset], nBytesToRead);
	std y+1,R11
	std y+0,R10
	lds R2,_pSectorBuffer
	lds R3,_pSectorBuffer+1
	movw R18,R12
	add R18,R2
	adc R19,R3
	ldd R16,y+22
	ldd R17,y+23
	xcall _memcpy
;                     pByte += nBytesToRead;
	ldd R0,y+22
	ldd R1,y+23
	add R0,R10
	adc R1,R11
	std y+23,R1
	std y+22,R0
; 
;                     hFile->dwFilePointer += nBytesToRead;
	ldd R24,y+14
	ldd R25,y+15
	adiw R24,12
	movw R2,R10
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	movw R30,R24
	ldd R6,z+0
	ldd R7,z+1
	ldd R8,z+2
	ldd R9,z+3
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	std z+0,R6
	std z+1,R7
	std z+2,R8
	std z+3,R9
;                     hFile->dwClusterPointer += nBytesToRead;
	ldd R24,y+14
	ldd R25,y+15
	adiw R24,16
	movw R12,R24
	movw R2,R10
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	movw R30,R24
	ldd R6,z+0
	ldd R7,z+1
	ldd R8,z+2
	ldd R9,z+3
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	std z+0,R6
	std z+1,R7
	std z+2,R8
	std z+3,R9
; 
;                     //
;                     // Check for EOF
;                     if (hFile->dwFilePointer >= hFile->dwFileSize) {
	ldd R30,y+14
	ldd R31,y+15
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	ldd R6,z+12
	ldd R7,z+13
	ldd R8,z+14
	ldd R9,z+15
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	brlo L289
X186:
;                         hFile->nEOF = TRUE;
	ldi R24,1
	ldi R25,0
	std z+23,R25
	std z+22,R24
;                     }
L289:
; 
;                     if (hFile->dwClusterPointer >= pDrive->dwClusterSize) {
	ldd R30,y+16
	ldd R31,y+17
	ldd R2,z+30
	ldd R3,z+31
	ldd R4,z+32
	ldd R5,z+33
	ldd R30,y+14
	ldd R31,y+15
	ldd R6,z+16
	ldd R7,z+17
	ldd R8,z+18
	ldd R9,z+19
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	brlo L291
X187:
;                         //
;                         // We must switch to the next cluster
;                         //
;                         hFile->dwReadCluster = GetNextCluster(pDrive, hFile->dwReadCluster);
	movw R24,R30
	adiw R24,8
	movw R12,R24
	movw R30,R24
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldd R16,y+16
	ldd R17,y+17
	xcall _GetNextCluster
	movw R30,R12
	std z+0,R16
	std z+1,R17
	std z+2,R18
	std z+3,R19
;                         hFile->dwClusterPointer = 0;
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R30,y+14
	ldd R31,y+15
	std z+16,R20
	std z+17,R21
	std z+18,R22
	std z+19,R23
;                     }
L291:
; 
;                     nSize -= nBytesToRead;
	ldd R0,y+34
	ldd R1,y+35
	sub R0,R10
	sbc R1,R11
	std y+35,R1
	std y+34,R0
; 
;                 } else {        /* IDEReadSectors Error */
	xjmp L284
L283:
; 
;                     nBytesRead = 0;
	clr R0
	clr R1
	std y+21,R1
	std y+20,R0
;                     hFile->nLastError = FAT_ERROR_IDE;
	ldi R24,-3
	ldi R25,-1
	ldd R30,y+14
	ldd R31,y+15
	std z+21,R25
	std z+20,R24
;                     break;
	xjmp L277
L284:
;                 }               /* endif nError == IDE_OK */
; 
;             }                   /* endwhile */
L281:
	ldd R0,y+34
	ldd R1,y+35
	tst R0
	breq X193
	xjmp L280
X193:
	tst R1
	breq X194
	xjmp L280
X194:
X188:
; 
;         } else {                /* reached the EOF */
	xjmp L277
L276:
;             hFile->nLastError = FAT_ERROR_EOF;
	ldi R24,-2
	ldi R25,-1
	ldd R30,y+14
	ldd R31,y+15
	std z+21,R25
	std z+20,R24
;         }                       /* endif hFile->dwFilePointer < hFile->dwFileSize */
L277:
; 
;     }
L274:
;     /* endif (hFile != NULL) && (nSize != 0) */
;     FATFree();
	xcall _FATFree
; 
;     return (nBytesRead);
	ldd R16,y+20
	ldd R17,y+21
L271:
	.dbline 0 ; func end
	adiw R28,24
	xjmp pop_xgsetF0FC
;         nError -> R20,R21
;          nSize -> y+2
;          pData -> R18,R19
;       hNUTFile -> R16,R17
	.even
_FATFileWrite:
	st -y,R20
	st -y,R21
; }
; 
; static int FATFileWrite(NUTFILE * hNUTFile, CONST void *pData, int nSize)
; {
;     int nError;
; 
;     nError = NUTDEV_ERROR;
	ldi R20,-1
	ldi R21,-1
; 
;     return (nError);
	movw R16,R20
L293:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
;         nError -> R20,R21
;          nSize -> y+2
;          pData -> R18,R19
;       hNUTFile -> R16,R17
	.even
_FATFileWriteP:
	st -y,R20
	st -y,R21
; }
; 
; #ifdef __HARVARD_ARCH__
; static int FATFileWriteP(NUTFILE * hNUTFile, PGM_P pData, int nSize)
; {
;     int nError;
; 
;     nError = NUTDEV_ERROR;
	ldi R20,-1
	ldi R21,-1
; 
;     return (nError);
	movw R16,R20
L294:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
	.area data(ram, con, rel)
_devFATC::
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.blkb 2
	.area idata
	.byte 'F,'A
	.area data(ram, con, rel)
	.blkb 2
	.area idata
	.byte 'T,95
	.area data(ram, con, rel)
	.blkb 2
	.area idata
	.byte 'C,0
	.area data(ram, con, rel)
	.blkb 2
	.area idata
	.byte 0,0
	.area data(ram, con, rel)
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.blkb 1
	.area idata
	.byte 2
	.area data(ram, con, rel)
	.blkb 2
	.area idata
	.word 2
	.area data(ram, con, rel)
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.blkw 1
	.area idata
	.word PL_FATInit
	.area data(ram, con, rel)
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.blkw 1
	.area idata
	.word PL_FATFileRead
	.area data(ram, con, rel)
	.blkw 1
	.area idata
	.word PL_FATFileWrite
	.area data(ram, con, rel)
	.blkw 1
	.area idata
	.word PL_FATFileWriteP
	.area data(ram, con, rel)
	.blkw 1
	.area idata
	.word PL_FATFileOpen
	.area data(ram, con, rel)
	.blkw 1
	.area idata
	.word PL_FATFileClose
	.area data(ram, con, rel)
	.blkw 1
	.area idata
	.word PL_FATFileSize
	.area data(ram, con, rel)
	.area bss(ram, con, rel)
_hFATSemaphore:
	.blkb 2
_sDriveInfo:
	.blkb 68
; }
; #endif
; 
; 
; //
; // FATC Device information structure.
; //
; NUTDEVICE devFATC = {
;     0,                          /* Pointer to next device. */
;     /* Unique device name.     */
;     {'F', 'A', 'T', '_', 'C', 0, 0, 0, 0}
;     ,
; 
;     IFTYP_STREAM,               /* Type of device.                   */
;     2,                          /* Base address.                     */
;     0,                          /* First interrupt number.           */
;     0,                          /* Interface control block.          */
;     0,                          /* Driver control block.             */
;     FATInit,                    /* Driver initialization routine.    */
;     0,                          /* Driver specific control function. */
;     FATFileRead,                /* Driver specific read function.    */
;     FATFileWrite,               /* Driver specific write function.   */
; #ifdef __HARVARD_ARCH__
;     FATFileWriteP,              /* Driver specific write_p function. */
; #endif
;     FATFileOpen,                /* Driver specific open function.    */
;     FATFileClose,               /* Driver specific close function.   */
;     FATFileSize
; };
	.area func_lit
PL_FATFileSize:	.word `_FATFileSize
PL_FATFileClose:	.word `_FATFileClose
PL_FATFileOpen:	.word `_FATFileOpen
PL_FATFileWriteP:	.word `_FATFileWriteP
PL_FATFileWrite:	.word `_FATFileWrite
PL_FATFileRead:	.word `_FATFileRead
PL_FATInit:	.word `_FATInit
PL_CFMount:	.word `_CFMount
PL_CFUnMount:	.word `_CFUnMount
