	.module pathops.c
	.area text(rom, con, rel)
;            dev -> R20,R21
;       dev_name -> y+2
;           nidx -> R20
;           nptr -> R22,R23
;         opcode -> R10,R11
;           path -> R12,R13
	.even
_PathOperation:
	xcall push_xgsetF03C
	movw R10,R18
	movw R12,R16
	sbiw R28,11
; /*
;  * Copyright (C) 2004-2005 by egnite Software GmbH. All rights reserved.
;  *
;  * Copyright (c) 1991
;  *      The Regents of the University of California.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  */
; 
; /*!
;  * \file fs/pathops.c
;  * \brief File system path operations.
;  *
;  * \verbatim
;  *
;  * $Log: pathops.c,v $
;  * Revision 1.1  2005/02/05 20:35:21  haraldkipp
;  * Peanut added
;  *
;  *
;  * \endverbatim
;  */
; 
; #include <errno.h>
; #include <sys/device.h>
; 
; #include <fs/fs.h>
; #include <unistd.h>
; #include <sys/stat.h>
; 
; #include <stdio.h>
; 
; /*!
;  * \addtogroup xgFS
;  */
; /*@{*/
; 
; static int PathOperation(CONST char *path, int opcode)
; {
;     NUTDEVICE *dev;
;     u_char dev_name[9];
;     u_char nidx;
;     CONST char *nptr = path;
	movw R22,R12
; 
;     /*
;      * Extract device name.
;      */
;     for (nidx = 0; *nptr && *nptr != ':' && nidx < 8; nidx++) {
	clr R20
	xjmp L7
L4:
;         dev_name[nidx] = *nptr++;
	movw R24,R28
	adiw R24,2
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	movw R26,R22
	ld R2,X+
	movw R22,R26
	std z+0,R2
;     }
L5:
	inc R20
L7:
	movw R30,R22
	ldd R2,z+0
	clr R3
	tst R2
	breq L9
X0:
	mov R24,R2
	cpi R24,58
	breq L9
X1:
	cpi R20,8
	brlo L4
X2:
L9:
;     dev_name[nidx] = 0;
	movw R24,R28
	adiw R24,2
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	clr R2
	std z+0,R2
;     nptr++;
	subi R22,255  ; offset = 1
	sbci R23,255
; 
;     /*
;      * Get device structure of registered device. In later releases we
;      * try to open a file on a root device.
;      */
;     if ((dev = NutDeviceLookup(dev_name)) == 0) {
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _NutDeviceLookup
	movw R20,R16
	cpi R20,0
	cpc R20,R21
	brne L10
X3:
;         errno = ENOENT;
	ldi R24,2
	ldi R25,0
	sts _errno+1,R25
	sts _errno,R24
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L3
L10:
;     }
;     return (*dev->dev_ioctl) (dev, opcode, (void *) nptr);
	std y+1,R23
	std y+0,R22
	movw R18,R10
	movw R16,R20
	movw R30,R20
	ldd R26,z+21
	ldd R27,z+22
	movw R30,R26
	xcall  xicall
	movw R10,R16
L3:
	.dbline 0 ; func end
	adiw R28,11
	xjmp pop_xgsetF03C
;           what -> R18,R19
;           path -> R16,R17
	.even
_access::
; }
; 
; /*!
;  * \brief Check the accessibility of a file.
;  *
;  * \param path Pathname of the file to check.
;  * \param what Access permission to check.
;  *
;  * \return Always -1 due to missing implementation.
;  */
; int access(CONST char *path, int what)
; {
;     return -1;
	ldi R16,-1
	ldi R17,-1
L12:
	.dbline 0 ; func end
	ret
;         whence -> y+4
;            pos -> y+0
;             fh -> R16,R17
	.even
_lseek::
	st -y,r19
	st -y,r18
; }
; 
; /*!
;  * \brief Reposition a file pointer.
;  *
;  * \param fh     Handle of an open file.
;  * \param pos    Positioning value.
;  * \param whence Positioning directive.
;  *
;  * \return Always -1 due to missing implementation.
;  */
; long lseek(int fh, long pos, int whence)
; {
;     //IOCTL_ARG3 args;
; 
;     //args.arg1 = (void *)fh;
;     //args.arg2 = (void *)(u_int)pos;
;     //args.arg3 = (void *)whence;
;     //return (*dev->dev_ioctl) (dev, opcode, (void *)&args);
;     return -1;
	ldi R16,255
	ldi R17,255
	ldi R18,255
	ldi R19,255
L13:
	.dbline 0 ; func end
	adiw R28,2
	ret
;           path -> R10,R11
	.even
_rmdir::
	st -y,R10
	st -y,R11
	movw R10,R16
; }
; 
; /*!
;  * \brief Remove a directory.
;  *
;  * \param name Pathname of the directory. Must be the full pathname
;  *             including the device, because Nut/OS doesn't support 
;  *             relative paths.
;  *
;  * \return 0 if the remove succeeds, otherwise -1 is returned.
;  */
; int rmdir(CONST char *path)
; {
;     return PathOperation(path, FS_DIR_REMOVE);
	ldi R18,4370
	ldi R19,17
	movw R16,R10
	xcall _PathOperation
L14:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
;           path -> R10,R11
	.even
_unlink::
	st -y,R10
	st -y,R11
	movw R10,R16
; }
; 
; /*!
;  * \brief Remove a file entry.
;  *
;  * \return 0 if the remove succeeds, otherwise -1 is returned.
;  */
; int unlink(CONST char *path)
; {
;     return PathOperation(path, FS_FILE_DELETE);
	ldi R18,4386
	ldi R19,17
	movw R16,R10
	xcall _PathOperation
L15:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
;           args -> y+11
;            dev -> R20,R21
;       dev_name -> y+2
;           nidx -> R20
;           nptr -> R22,R23
;              s -> R10,R11
;           path -> R12,R13
	.even
_stat::
	xcall push_xgsetF03C
	movw R10,R18
	movw R12,R16
	sbiw R28,15
; }
; 
; 
; /*!
;  * \brief Remove a directory.
;  *
;  * \return 0 if the query succeeds, otherwise -1 is returned.
;  */
; int stat(CONST char *path, struct stat *s)
; {
;     NUTDEVICE *dev;
;     u_char dev_name[9];
;     u_char nidx;
;     CONST char *nptr = path;
	movw R22,R12
;     IOCTL_ARG2 args;
; 
;     /* Extract the device name. */
;     for (nidx = 0; *nptr && *nptr != ':' && nidx < 8; nidx++) {
	clr R20
	xjmp L20
L17:
;         dev_name[nidx] = *nptr++;
	movw R24,R28
	adiw R24,2
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	movw R26,R22
	ld R2,X+
	movw R22,R26
	std z+0,R2
;     }
L18:
	inc R20
L20:
	movw R30,R22
	ldd R2,z+0
	clr R3
	tst R2
	breq L22
X4:
	mov R24,R2
	cpi R24,58
	breq L22
X5:
	cpi R20,8
	brlo L17
X6:
L22:
;     dev_name[nidx] = 0;
	movw R24,R28
	adiw R24,2
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	clr R2
	std z+0,R2
; 
;     /* Get device structure of registered device. */
;     if ((dev = NutDeviceLookup(dev_name)) != 0) {
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _NutDeviceLookup
	movw R20,R16
	cpi R20,0
	cpc R20,R21
	breq L23
X7:
;         if (*nptr == ':') {
	movw R30,R22
	ldd R24,z+0
	cpi R24,58
	brne L25
X8:
;             nptr++;
	subi R22,255  ; offset = 1
	sbci R23,255
;         }
L25:
;         args.arg1 = (void *) nptr;
	std y+12,R23
	std y+11,R22
;         args.arg2 = s;
	std y+14,R11
	std y+13,R10
;         return (*dev->dev_ioctl) (dev, FS_STATUS, (void *) &args);
	movw R24,R28
	adiw R24,11
	std y+1,R25
	std y+0,R24
	ldi R18,4353
	ldi R19,17
	movw R16,R20
	movw R30,R20
	ldd R26,z+21
	ldd R27,z+22
	movw R30,R26
	xcall  xicall
	movw R10,R16
	xjmp L16
L23:
;     }
;     return -1;
	ldi R16,-1
	ldi R17,-1
L16:
	.dbline 0 ; func end
	adiw R28,15
	xjmp pop_xgsetF03C
;              s -> R18,R19
;             fh -> R16,R17
	.even
_fstat::
; }
; 
; /*!
;  * \brief Remove a directory.
;  *
;  * \return Always -1 due to missing implementation.
;  */
; int fstat(int fh, struct stat *s)
; {
;     return -1;
	ldi R16,-1
	ldi R17,-1
L28:
	.dbline 0 ; func end
	ret
;           mode -> R12,R13
;           path -> R10,R11
	.even
_mkdir::
	xcall push_xgset003C
	movw R12,R18
	movw R10,R16
; }
; 
; /*!
;  * \brief Create a directory entry.
;  *
;  * \return 0 on success, otherwise -1 is returned.
;  */
; int mkdir(CONST char *path, int mode)
; {
;     return PathOperation(path, FS_DIR_CREATE);
	ldi R18,4369
	ldi R19,17
	movw R16,R10
	xcall _PathOperation
L29:
	.dbline 0 ; func end
	xjmp pop_xgset003C
; }
; 
; /*@}*/
