	.module uromfs.c
	.area text(rom, con, rel)
;           rome -> R14,R15
;             rc -> R10,R11
;           romf -> R12,R13
;           npos -> y+0
;         whence -> y+16
;            pos -> y+14
;             fp -> R16,R17
	.even
_UromSeek:
	st -y,r19
	st -y,r18
	xcall push_xgsetF0FC
	sbiw R28,4
; /*
;  * Copyright (C) 2001-2003 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  */
; 
; /*
;  * $Log: uromfs.c,v $
;  * Revision 1.5  2005/08/05 11:29:07  olereinhardt
;  * Added IOCTL function with support for seek
;  *
;  * Revision 1.4  2004/03/18 11:37:06  haraldkipp
;  * Deprecated functions removed
;  *
;  * Revision 1.3  2004/03/16 16:48:27  haraldkipp
;  * Added Jan Dubiec's H8/300 port.
;  *
;  * Revision 1.2  2003/07/20 19:27:59  haraldkipp
;  * Patch by Alessandro Zummo. Moves the urom filesystem filenames to
;  * AVR's flash memory.
;  *
;  * Revision 1.1.1.1  2003/05/09 14:41:02  haraldkipp
;  * Initial using 3.2.1
;  *
;  * Revision 1.12  2003/04/21 16:58:20  harald
;  * Make use of predefined eof
;  *
;  * Revision 1.11  2003/02/04 17:57:14  harald
;  * Version 3 released
;  *
;  * Revision 1.10  2002/11/02 15:16:09  harald
;  * Compiler warning avoided
;  *
;  * Revision 1.9  2002/06/26 17:29:13  harald
;  * First pre-release with 2.4 stack
;  *
;  */
; 
; #include <string.h>
; #include <errno.h>
; #include <stdio.h>
; 
; #include <sys/heap.h>
; #include <sys/file.h>
; #include <sys/device.h>
; 
; #include <fs/fs.h>
; #include <dev/urom.h>
; #include <fs/uromfs.h>
; 
; /*
; static int UromRead(NUTFILE * fp, void *buffer, int size);
; static int UromWrite(NUTFILE * fp, CONST void *buffer, int len);
; #ifdef __HARVARD_ARCH__
; static int UromWrite_P(NUTFILE * fp, PGM_P buffer, int len);
; #endif
; static NUTFILE *UromOpen(NUTDEVICE * dev, CONST char *name, int mode,
;                          int acc);
; static int UromClose(NUTFILE * fp);
; static long UromSize(NUTFILE * fp);
; */
; /*!
;  * \addtogroup xgurom
;  */
; /*@{*/
; 
; static int UromSeek(NUTFILE * fp, long *pos, int whence)
; {
;     ROMFILE *romf = fp->nf_fcb;
	movw R30,R16
	ldd R12,z+4
	ldd R13,z+5
;     ROMENTRY *rome = romf->romf_entry;
	movw R30,R12
	ldd R14,z+0
	ldd R15,z+1
; 
;     int rc = 0;
	clr R10
	clr R11
;     long npos = *pos;
	ldd R30,y+14
	ldd R31,y+15
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
; 
;     switch (whence) {
	ldd R24,y+16
	ldd R25,y+17
	cpi R24,1
	ldi R30,0
	cpc R25,R30
	breq L6
X0:
	cpi R24,2
	ldi R30,0
	cpc R25,R30
	breq L7
X1:
	xjmp L4
L6:
;     case SEEK_CUR:
;         npos += romf->romf_pos;
	movw R30,R12
	ldd R2,z+2
	ldd R3,z+3
	clr R4
	clr R5
	ldd R6,y+0
	ldd R7,y+1
	ldd R8,y+2
	ldd R9,y+3
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	std y+0,R6
	std y+1,R7
	std y+2,R8
	std y+3,R9
;         break;
	xjmp L5
L7:
;     case SEEK_END:
;         npos += rome->rome_size;
	movw R30,R14
	ldd R2,z+4
	ldd R3,z+5
	clr R4
	clr R5
	ldd R6,y+0
	ldd R7,y+1
	ldd R8,y+2
	ldd R9,y+3
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	std y+0,R6
	std y+1,R7
	std y+2,R8
	std y+3,R9
;         break;
L4:
L5:
;     }
; 
;     if (npos < 0 || npos > rome->rome_size) {
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brlt L10
X2:
	movw R30,R14
	ldd R2,z+4
	ldd R3,z+5
	clr R4
	clr R5
	ldd R6,y+0
	ldd R7,y+1
	ldd R8,y+2
	ldd R9,y+3
	cp R2,R6
	cpc R3,R7
	cpc R4,R8
	cpc R5,R9
	brge L8
X3:
L10:
;         rc = EINVAL;
	ldi R24,22
	ldi R25,0
	movw R10,R24
;     } else {
	xjmp L9
L8:
;         romf->romf_pos = npos;
	ldd R2,y+0
	ldd R3,y+1
	movw R30,R12
	std z+3,R3
	std z+2,R2
;         *pos = npos;
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	ldd R30,y+14
	ldd R31,y+15
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;     }
L9:
;     return rc;
	movw R16,R10
L3:
	.dbline 0 ; func end
	adiw R28,4
	xcall pop_xgsetF0FC
	adiw R28,2
	ret
;           rome -> R22,R23
;           romf -> R20,R21
;           size -> R10,R11
;         buffer -> R12,R13
;             fp -> R20,R21
	.even
_UromRead:
	xcall push_xgsetF03C
	movw R12,R18
	movw R20,R16
	sbiw R28,2
	ldd R10,y+10
	ldd R11,y+11
; }
; 
; /*! 
;  * \brief Read from device. 
;  */
; static int UromRead(NUTFILE * fp, void *buffer, int size)
; {
;     ROMFILE *romf = fp->nf_fcb;
	movw R30,R20
	ldd R20,z+4
	ldd R21,z+5
;     ROMENTRY *rome = romf->romf_entry;
	movw R30,R20
	ldd R22,z+0
	ldd R23,z+1
; 
;     if ((u_short) size > rome->rome_size - romf->romf_pos)
	ldd R2,z+2
	ldd R3,z+3
	movw R30,R22
	ldd R4,z+4
	ldd R5,z+5
	sub R4,R2
	sbc R5,R3
	cp R4,R10
	cpc R5,R11
	brsh L12
X4:
;         size = rome->rome_size - romf->romf_pos;
	movw R30,R20
	ldd R2,z+2
	ldd R3,z+3
	movw R30,R22
	ldd R10,z+4
	ldd R11,z+5
	sub R10,R2
	sbc R11,R3
L12:
;     if (size) {
	tst R10
	brne X5
	tst R11
	breq L14
X5:
;         memcpy_P(buffer, rome->rome_data + romf->romf_pos, size);
	std y+1,R11
	std y+0,R10
	movw R30,R22
	ldd R2,z+6
	ldd R3,z+7
	movw R30,R20
	ldd R18,z+2
	ldd R19,z+3
	add R18,R2
	adc R19,R3
	movw R16,R12
	xcall _cmemcpy
;         romf->romf_pos += size;
	movw R24,R20
	adiw R24,2
	movw R30,R24
	ldd R2,z+0
	ldd R3,z+1
	add R2,R10
	adc R3,R11
	std z+1,R3
	std z+0,R2
;     }
L14:
;     return size;
	movw R16,R10
L11:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgsetF03C
;            len -> y+0
;         buffer -> R18,R19
;             fp -> R16,R17
	.even
_UromWrite:
; }
; 
; /*! 
;  * \brief Write data to a file.
;  *
;  * \return Always returns -1.
;  */
; static int UromWrite(NUTFILE * fp, CONST void *buffer, int len)
; {
;     return -1;
	ldi R16,-1
	ldi R17,-1
L16:
	.dbline 0 ; func end
	ret
;            len -> y+0
;         buffer -> R18,R19
;             fp -> R16,R17
	.even
_UromWrite_P:
; }
; 
; /*! 
;  * \brief Write data from progam space to a file.
;  *
;  * \return Always returns -1.
;  */
; #ifdef __HARVARD_ARCH__
; static int UromWrite_P(NUTFILE * fp, PGM_P buffer, int len)
; {
;     return -1;
	ldi R16,-1
	ldi R17,-1
L17:
	.dbline 0 ; func end
	ret
;           romf -> R10,R11
;             fp -> R20,R21
;           rome -> R22,R23
;            acc -> y+12
;           mode -> y+10
;           name -> R14,R15
;            dev -> R12,R13
	.even
_UromOpen:
	xcall push_xgsetF0FC
	movw R14,R18
	movw R12,R16
; }
; #endif
; 
; 
; /*! 
;  * \brief Open a file.
;  */
; static NUTFILE *UromOpen(NUTDEVICE * dev, CONST char *name, int mode,
;                          int acc)
; {
;     NUTFILE *fp = NutHeapAlloc(sizeof(NUTFILE));
	ldi R16,6
	ldi R17,0
	xcall _NutHeapAlloc
	movw R20,R16
;     ROMENTRY *rome;
;     ROMFILE *romf = 0;
	clr R10
	clr R11
; 
;     if (fp == 0) {
	cpi R16,0
	cpc R16,R17
	brne L19
X6:
;         errno = ENOMEM;
	ldi R24,12
	ldi R25,0
	sts _errno+1,R25
	sts _errno,R24
;         return NUTFILE_EOF;
	ldi R16,-1
	ldi R17,-1
	xjmp L18
L19:
;     }
; 
;     for (rome = romEntryList; rome; rome = rome->rome_next) {
	lds R22,_romEntryList
	lds R23,_romEntryList+1
	xjmp L24
L21:
;         if (strcmp_P(name, rome->rome_name) == 0)
	movw R18,R14
	movw R30,R22
	ldd R16,z+2
	ldd R17,z+3
	xcall _cstrcmp
	cpi R16,0
	cpc R16,R17
	brne L25
X7:
;             break;
	xjmp L23
L25:
;     }
L22:
	movw R30,R22
	ldd R22,z+0
	ldd R23,z+1
L24:
	cpi R22,0
	cpc R22,R23
	brne L21
X8:
L23:
;     if (rome) {
	cpi R22,0
	cpc R22,R23
	breq L27
X9:
;         if ((romf = NutHeapAllocClear(sizeof(ROMFILE))) != 0)
	ldi R16,4
	ldi R17,0
	xcall _NutHeapAllocClear
	movw R14,R16
	movw R10,R14
	cpi R16,0
	cpc R16,R17
	breq L29
X10:
;             romf->romf_entry = rome;
	movw R30,R10
	std z+1,R23
	std z+0,R22
	xjmp L28
L29:
;         else
;             errno = ENOMEM;
	ldi R24,12
	ldi R25,0
	sts _errno+1,R25
	sts _errno,R24
;     } else
	xjmp L28
L27:
;         errno = ENOENT;
	ldi R24,2
	ldi R25,0
	sts _errno+1,R25
	sts _errno,R24
L28:
; 
;     if (romf) {
	tst R10
	brne X11
	tst R11
	breq L31
X11:
;         fp->nf_next = 0;
	clr R2
	clr R3
	movw R30,R20
	std z+1,R3
	std z+0,R2
;         fp->nf_dev = dev;
	std z+3,R13
	std z+2,R12
;         fp->nf_fcb = romf;
	std z+5,R11
	std z+4,R10
;     } else {
	xjmp L32
L31:
;         NutHeapFree(fp);
	movw R16,R20
	xcall _NutHeapFree
;         fp = NUTFILE_EOF;
	ldi R20,-1
	ldi R21,-1
;     }
L32:
; 
;     return fp;
	movw R16,R20
L18:
	.dbline 0 ; func end
	xjmp pop_xgsetF0FC
;             fp -> R20,R21
	.even
_UromClose:
	st -y,R20
	st -y,R21
	movw R20,R16
; }
; 
; /*! 
;  * \brief Close a file. 
;  */
; static int UromClose(NUTFILE * fp)
; {
;     if (fp && fp != NUTFILE_EOF) {
	movw R2,R20
	cpi R20,0
	cpc R20,R21
	breq L34
X12:
	cpi R20,255
	ldi R30,255
	cpc R21,R30
	breq L34
X13:
;         if (fp->nf_fcb)
	movw R30,R2
	ldd R2,z+4
	ldd R3,z+5
	tst R2
	brne X14
	tst R3
	breq L36
X14:
;             NutHeapFree(fp->nf_fcb);
	ldd R16,z+4
	ldd R17,z+5
	xcall _NutHeapFree
L36:
;         NutHeapFree(fp);
	movw R16,R20
	xcall _NutHeapFree
;     }
L34:
;     return 0;
	clr R16
	clr R17
L33:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
;           rome -> R20,R21
;           romf -> R10,R11
;             fp -> R16,R17
	.even
_UromSize:
	xcall push_xgset300C
; }
; 
; /*! 
;  * \brief Query file size.
;  */
; static long UromSize(NUTFILE * fp)
; {
;     ROMFILE *romf = fp->nf_fcb;
	movw R30,R16
	ldd R10,z+4
	ldd R11,z+5
;     ROMENTRY *rome = romf->romf_entry;
	movw R30,R10
	ldd R20,z+0
	ldd R21,z+1
; 
;     return (long) rome->rome_size;
	movw R30,R20
	ldd R16,z+4
	ldd R17,z+5
	clr R18
	clr R19
L38:
	.dbline 0 ; func end
	xjmp pop_xgset300C
;             rc -> R20,R21
;           conf -> R22,R23
;            req -> R10,R11
;            dev -> R12,R13
	.even
_UromIOCtl::
	xcall push_xgsetF03C
	movw R10,R18
	movw R12,R16
	sbiw R28,2
	ldd R22,y+10
	ldd R23,y+11
; }
; 
; /*!
;  * \brief Device specific functions.
;  */
; int UromIOCtl(NUTDEVICE * dev, int req, void *conf)
; {
;     int rc = -1;
	ldi R20,-1
	ldi R21,-1
; 
;     switch (req) {
	movw R24,R10
	cpi R24,35
	ldi R30,17
	cpc R25,R30
	breq L42
X15:
	xjmp L40
L42:
;     case FS_FILE_SEEK:
;         UromSeek((NUTFILE *) ((IOCTL_ARG3 *) conf)->arg1,      /* */
	movw R30,R22
	ldd R2,z+4
	ldd R3,z+5
	std y+1,R3
	std y+0,R2
	ldd R18,z+2
	ldd R19,z+3
	ldd R16,z+0
	ldd R17,z+1
	xcall _UromSeek
;                      (long *) ((IOCTL_ARG3 *) conf)->arg2,      /* */
;                      (int) ((IOCTL_ARG3 *) conf)->arg3);
;         break;
L40:
L41:
;     }
;     return rc;
	movw R16,R20
L39:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgsetF03C
	.area data(ram, con, rel)
_devUrom::
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.blkb 2
	.area idata
	.byte 'U,'R
	.area data(ram, con, rel)
	.blkb 2
	.area idata
	.byte 'O,'M
	.area data(ram, con, rel)
	.blkb 2
	.area idata
	.byte 0,0
	.area data(ram, con, rel)
	.blkb 2
	.area idata
	.byte 0,0
	.area data(ram, con, rel)
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.blkb 1
	.area idata
	.byte 1
	.area data(ram, con, rel)
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.blkw 1
	.area idata
	.word PL_UromIOCtl
	.area data(ram, con, rel)
	.blkw 1
	.area idata
	.word PL_UromRead
	.area data(ram, con, rel)
	.blkw 1
	.area idata
	.word PL_UromWrite
	.area data(ram, con, rel)
	.blkw 1
	.area idata
	.word PL_UromWrite_P
	.area data(ram, con, rel)
	.blkw 1
	.area idata
	.word PL_UromOpen
	.area data(ram, con, rel)
	.blkw 1
	.area idata
	.word PL_UromClose
	.area data(ram, con, rel)
	.blkw 1
	.area idata
	.word PL_UromSize
	.area data(ram, con, rel)
; }
; 
; 
; /*!
;  * \brief UROM device information structure.
;  *
;  * All this UROM stuff is so simple, that it even mimics
;  * its own device driver.
;  */
; NUTDEVICE devUrom = {
;     0,                          /*!< Pointer to next device. */
;     {'U', 'R', 'O', 'M', 0, 0, 0, 0, 0},        /*!< Unique device name. */
;     IFTYP_ROM,                  /*!< Type of device. Obsolete. */
;     0,                          /*!< Base address. Unused. */
;     0,                          /*!< First interrupt number. Unused. */
;     0,                          /*!< Interface control block. Unused. */
;     0,                          /*!< Driver control block. Unused. */
;     0,                          /*!< Driver initialization routine. Not supported. */
;     UromIOCtl,                  /*!< Driver specific control function. Not supported. */
;     UromRead,                   /*!< Read data from a file. */
;     UromWrite,                  /*!< Write data to a file. */
; #ifdef __HARVARD_ARCH__
;     UromWrite_P,                /*!< Write data from program space to a file. */
; #endif
;     UromOpen,                   /*!< Open a file. */
;     UromClose,                  /*!< Close a file. */
;     UromSize                    /*!< Return file size. */
; };
; 
; /*@}*/
	.area func_lit
PL_UromSize:	.word `_UromSize
PL_UromClose:	.word `_UromClose
PL_UromOpen:	.word `_UromOpen
PL_UromWrite_P:	.word `_UromWrite_P
PL_UromWrite:	.word `_UromWrite
PL_UromRead:	.word `_UromRead
PL_UromIOCtl:	.word `_UromIOCtl
