	.module arpcache.c
	.area text(rom, con, rel)
;            aep -> R22,R23
;             ae -> R20,R21
;            ifn -> R22,R23
	.even
_ArpCacheFlush:
	xcall push_xgsetF000
	movw R22,R16
; /*
;  * Copyright (C) 2001-2005 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  * -
;  * Portions Copyright (c) 1983, 1993 by
;  *  The Regents of the University of California.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the University nor the names of its contributors
;  *    may be used to endorse or promote products derived from this software
;  *    without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
;  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
;  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
;  * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
;  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
;  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
;  * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
;  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
;  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
;  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  * -
;  * Portions Copyright (c) 1993 by Digital Equipment Corporation.
;  *
;  * Permission to use, copy, modify, and distribute this software for any
;  * purpose with or without fee is hereby granted, provided that the above
;  * copyright notice and this permission notice appear in all copies, and that
;  * the name of Digital Equipment Corporation not be used in advertising or
;  * publicity pertaining to distribution of the document or software without
;  * specific, written prior permission.
;  * 
;  * THE SOFTWARE IS PROVIDED "AS IS" AND DIGITAL EQUIPMENT CORP. DISCLAIMS ALL
;  * WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES
;  * OF MERCHANTABILITY AND FITNESS.   IN NO EVENT SHALL DIGITAL EQUIPMENT
;  * CORPORATION BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
;  * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
;  * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
;  * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
;  * SOFTWARE.
;  */
; 
; /*!
;  * \file net/arpcache.c
;  * \brief ARP cache.
;  *
;  * \verbatim
;  *
;  * $Log: arpcache.c,v $
;  * Revision 1.13  2005/08/02 17:46:49  haraldkipp
;  * Major API documentation update.
;  *
;  * Revision 1.12  2005/06/05 16:49:09  haraldkipp
;  * Do not do ARP retries by default.
;  *
;  * Revision 1.11  2005/05/16 08:41:25  haraldkipp
;  * Bugfix: Empty queue before removing entry.
;  *
;  * Revision 1.10  2005/04/30 16:42:42  chaac
;  * Fixed bug in handling of NUTDEBUG. Added include for cfg/os.h. If NUTDEBUG
;  * is defined in NutConf, it will make effect where it is used.
;  *
;  * Revision 1.9  2005/03/13 13:40:32  haraldkipp
;  * If NutArpOutput() failed, then NutArpCacheQuery() released the already
;  * released NETBUF. This bug had been fixed. If NutArpAllocNetBuf() fails,
;  * the ARP entry will now be removed immediately. Additional check for
;  * valid entry pointer added. These modifications had been suggested by
;  * Dusan Ferbas. Finally memcpy() has been replaced by a simple loop in order
;  * to provide a work around for GCC Bug #18251.
;  *
;  * Revision 1.8  2005/02/07 18:57:49  haraldkipp
;  * ICCAVR compile errors fixed
;  *
;  * Revision 1.7  2005/02/07 09:26:56  haraldkipp
;  * Argh! Committed wrong source.
;  *
;  * Revision 1.5  2005/02/04 14:55:08  haraldkipp
;  * Almost a complete redesign. Replaced the ARP timer thread by calling an
;  * ARP aging routine before each incoming ARP and outgoing IP packet.
;  * This also fixes the bug, which generated two ARP requests per query.
;  * Thanks to Dusam Ferbas and Rostislav Hlebak for their help.
;  *
;  * Revision 1.4  2004/07/27 19:38:30  drsung
;  * Under certain circumstances the same ARPENTRY was
;  * allocated twice.
;  *
;  * Revision 1.3  2004/03/18 10:18:01  haraldkipp
;  * Comments updated
;  *
;  * Revision 1.2  2004/02/08 17:14:05  drsung
;  * arp entries with set ATF_PERM flag are not removed any longer.
;  *
;  * Revision 1.1.1.1  2003/05/09 14:41:26  haraldkipp
;  * Initial using 3.2.1
;  *
;  * Revision 1.16  2003/02/04 18:14:56  harald
;  * Version 3 released
;  *
;  * Revision 1.15  2002/06/26 17:29:35  harald
;  * First pre-release with 2.4 stack
;  *
;  * \endverbatim
;  */
; 
; #include <cfg/os.h>
; #include <cfg/arp.h>
; 
; #include <sys/event.h>
; #include <sys/timer.h>
; 
; #include <stdlib.h>
; #include <string.h>
; 
; #include <net/if_var.h>
; #include <netinet/if_ether.h>
; #include <arpa/inet.h>
; 
; #ifdef NUTDEBUG
; #include <net/netdebug.h>
; #endif
; 
; #if 0
; /* Use for local debugging. */
; #define NUTDEBUG
; #include <stdio.h>
; #define __tcp_trs stdout
; static u_char __tcp_trf = 1;
; #endif
; 
; /*!
;  * \addtogroup xgARP
;  */
; /*@{*/
; 
; /*!
;  * \name ARP Configuration
;  *
;  * The Nut/OS Configurator may be used to override the default values.
;  */
; /*@{*/
; 
; /*! \brief Maximum age of an entry in the ARP cache in minutes.
;  *
;  * Outdated entries will be regularly removed, forcing the Ethernet 
;  * interface to generate new ARP requests. This way MAC address
;  * changes are detected.
;  *
;  * \showinitializer
;  */
; #ifndef MAX_ARPAGE
; #define MAX_ARPAGE 9
; #endif
; 
; /*! \brief Maximum number of ARP requests generated per query.
;  *
;  * If no ARP response is received after sending out the specified
;  * number of request, the related IP address is considered unreachable.
;  *
;  * \showinitializer
;  */
; #ifndef MAX_ARPREQUESTS
; #define MAX_ARPREQUESTS 1
; #endif
; 
; /*! \brief Minimum wait before sending out a new ARP request.
;  *
;  * The specified number of milliseconds will be doubled on each retry.
;  *
;  * \showinitializer
;  */
; #ifndef MIN_ARPWAIT
; #define MIN_ARPWAIT 500
; #endif
; 
; /*@}*/
; 
; 
; /*!
;  * \brief Remove all entries marked for removal.
;  *
;  * \param ifn The network interface.
;  */
; static void ArpCacheFlush(IFNET * ifn)
; {
;     ARPENTRY *ae = ifn->arpTable;
	movw R30,R22
	ldd R20,z+23
	ldd R21,z+24
;     ARPENTRY **aep = &ifn->arpTable;
	subi R22,233  ; offset = 23
	sbci R23,255
	xjmp L3
L2:
; 
;     while (ae) {
;         if (ae->ae_flags & ATF_REM) {
	movw R30,R20
	ldd R2,z+12
	sbrs R2,0
	rjmp L5
X0:
;             /* Remove all waiting threads from the queue of this
;                entry, but do not give up the CPU. If some other
;                thread takes over and deals with ARP, we are dead. */
;             NutEventBroadcastAsync(&ae->ae_tq);
	movw R16,R30
	subi R16,242  ; offset = 14
	sbci R17,255
	xcall _NutEventBroadcastAsync
; #ifdef NUTDEBUG
;             if (__tcp_trf) {
;                 fprintf(__tcp_trs, "[ARP-DEL %s]", inet_ntoa(ae->ae_ip));
;             }
; #endif
;             *aep = ae->ae_next;
	movw R30,R20
	ldd R2,z+0
	ldd R3,z+1
	movw R30,R22
	std z+1,R3
	std z+0,R2
;             free(ae);
	movw R16,R20
	xcall _free_M
;             ae = *aep;
	movw R30,R22
	ldd R20,z+0
	ldd R21,z+1
;         } else {
	xjmp L6
L5:
;             aep = &ae->ae_next;
	movw R22,R20
;             ae = ae->ae_next;
	movw R30,R20
	ldd R20,z+0
	ldd R21,z+1
;         }
L6:
;     }
L3:
	cpi R20,0
	cpc R20,R21
	brne L2
X1:
L1:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.area bss(ram, con, rel)
L8:
	.blkb 4
	.area text(rom, con, rel)
;            rmf -> R14
;             ae -> R10,R11
;            ifn -> y+2
;            dev -> y+0
	.even
_ArpCacheAging:
	xcall push_xgsetF0FC
	sbiw R28,4
; }
; 
; /*!
;  * \brief Update the age of all ARP entries of all Ethernet devices.
;  *
;  * Increments the age of all ARP entries. Any entry with an age above
;  * \ref MAX_ARPAGE will be removed.
;  *
;  * If less less than one minute elapsed since the last update, the
;  * routine will return without updating any entry.
;  */
; static void ArpCacheAging(void)
; {
;     static u_long last_update;
;     NUTDEVICE *dev;
; 
;     if (NutGetSeconds() - last_update >= 60) {
	xcall _NutGetSeconds
	lds R4,L8+2
	lds R5,L8+2+1
	lds R2,L8
	lds R3,L8+1
	movw R6,R16
	movw R8,R18
	sub R6,R2
	sbc R7,R3
	sbc R8,R4
	sbc R9,R5
	ldi R20,60
	ldi R21,0
	ldi R22,0
	ldi R23,0
	cp R6,R20
	cpc R7,R21
	cpc R8,R22
	cpc R9,R23
	brsh X11
	xjmp L9
X11:
X2:
;         last_update = NutGetSeconds();
	xcall _NutGetSeconds
	sts L8+1,R17
	sts L8,R16
	sts L8+2+1,R19
	sts L8+2,R18
; 
;         /*
;          * Loop through the list of all registered devices.
;          */
;         for (dev = nutDeviceList; dev; dev = dev->dev_next) {
	lds R2,_nutDeviceList
	lds R3,_nutDeviceList+1
	std y+1,R3
	std y+0,R2
	xjmp L14
L11:
; 
;             /* Process network devices only. */
;             if (dev->dev_type == IFTYP_NET) {
	ldd R30,y+0
	ldd R31,y+1
	ldd R24,z+11
	cpi R24,3
	breq X12
	xjmp L15
X12:
X3:
;                 IFNET *ifn = dev->dev_icb;
	ldd R2,z+15
	ldd R3,z+16
	std y+3,R3
	std y+2,R2
; 
;                 /* Process Ethernet interfaces only. */
;                 if (ifn && ifn->if_type == IFT_ETHER) {
	movw R0,R2
	tst R2
	brne X4
	tst R3
	brne X13
	xjmp L17
X13:
X4:
	movw R30,R2
	ldd R24,z+0
	cpi R24,6
	breq X14
	xjmp L17
X14:
X5:
;                     ARPENTRY *ae;
;                     u_char rmf = 0;
	clr R14
; 
;                     /* Loop through all ARP entries of this interface. */
;                     for (ae = ifn->arpTable; ae; ae = ae->ae_next) {
	ldd R10,z+23
	ldd R11,z+24
	xjmp L22
L19:
;                         if ((ae->ae_flags & ATF_PERM) == 0 &&   /* Not permanent. */
	movw R30,R10
	ldd R2,z+12
	sbrc R2,2
	rjmp L23
X6:
	movw R24,R30
	adiw R24,13
	movw R30,R24
	ldd R2,z+0
	mov R24,R2
	subi R24,255    ; addi 1
	std z+0,R24
	mov R24,R2
	cpi R24,9
	brlo L23
X7:
;                             ae->ae_outdated++ >= MAX_ARPAGE) {  /* Outdated. */
;                             ae->ae_flags |= ATF_REM;
	movw R24,R10
	adiw R24,12
	movw R12,R24
	movw R30,R24
	ldd R24,z+0
	ori R24,1
	std z+0,R24
;                         }
L23:
;                         rmf |= ae->ae_flags;
	movw R30,R10
	ldd R2,z+12
	or R14,R2
; #ifdef NUTDEBUG
;                         if (__tcp_trf) {
;                             fprintf(__tcp_trs, "[ARP-AGE %s %u]",       /* */
;                                     inet_ntoa(ae->ae_ip), ae->ae_outdated);
;                         }
; #endif
;                     }
L20:
	movw R30,R10
	ldd R10,z+0
	ldd R11,z+1
L22:
	tst R10
	breq X15
	xjmp L19
X15:
	tst R11
	breq X16
	xjmp L19
X16:
X8:
;                     if (rmf & ATF_REM) {
	sbrs R14,0
	rjmp L25
X9:
;                         ArpCacheFlush(ifn);
	ldd R16,y+2
	ldd R17,y+3
	xcall _ArpCacheFlush
;                     }
L25:
;                 }
L17:
;             }
L15:
;         }
L12:
	ldd R30,y+0
	ldd R31,y+1
	ldd R2,z+0
	ldd R3,z+1
	std y+1,R3
	std y+0,R2
L14:
	ldd R0,y+0
	ldd R1,y+1
	tst R0
	breq X17
	xjmp L11
X17:
	tst R1
	breq X18
	xjmp L11
X18:
X10:
;     }
L9:
L7:
	.dbline 0 ; func end
	adiw R28,4
	xjmp pop_xgsetF0FC
;          entry -> R20,R21
;             ip -> y+2
;            ifn -> R16,R17
	.even
_ArpCacheLookup:
	st -y,r19
	st -y,r18
	st -y,R20
	st -y,R21
; }
; 
; /*!
;  * \brief Locate an interface's ARP entry for a given IP address.
;  *
;  * \param ifn Pointer to the network interface.
;  * \param ip  IP address to search, given in network byte order.
;  *
;  * \return Pointer to the ARP cache entry, if found, or NULL if no 
;  *         entry exists.
;  */
; static ARPENTRY *ArpCacheLookup(IFNET * ifn, u_long ip)
; {
;     ARPENTRY *entry;
; 
;     for (entry = ifn->arpTable; entry; entry = entry->ae_next) {
	movw R30,R16
	ldd R20,z+23
	ldd R21,z+24
	xjmp L31
L28:
;         if (entry->ae_ip == ip)
	ldd R2,y+2
	ldd R3,y+3
	ldd R4,y+4
	ldd R5,y+5
	movw R30,R20
	ldd R6,z+2
	ldd R7,z+3
	ldd R8,z+4
	ldd R9,z+5
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	brne L32
X19:
;             break;
	xjmp L30
L32:
;     }
L29:
	movw R30,R20
	ldd R20,z+0
	ldd R21,z+1
L31:
	cpi R20,0
	cpc R20,R21
	brne L28
X20:
L30:
;     return entry;
	movw R16,R20
L27:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	adiw R28,2
	ret
;          entry -> R20,R21
;             ha -> R10,R11
;             ip -> y+8
;            ifn -> R22,R23
	.even
_ArpCacheNew:
	st -y,r19
	st -y,r18
	xcall push_xgsetF00C
	movw R22,R16
	sbiw R28,2
	ldd R10,y+12
	ldd R11,y+13
; }
; 
; 
; /*!
;  * \brief Create a new entry in the interface's ARP cache.
;  *
;  * The new entry is added on top of the cache list.
;  *
;  * \param ifn Pointer to the network interface.
;  * \param ip  IP address of the new entry, given in network byte order.
;  * \param ha  Pointer to the MAC address. If NULL, an incomplete entry
;  *            will be created.
;  *
;  * \return Pointer to the new entry or NULL if not enough memory is 
;  *         available.
;  */
; static ARPENTRY *ArpCacheNew(IFNET * ifn, u_long ip, u_char * ha)
; {
;     ARPENTRY *entry;
; 
;     /* Remove outdated entries before adding a new one. */
;     ArpCacheAging();
	xcall _ArpCacheAging
; 
;     if ((entry = malloc(sizeof(ARPENTRY))) != 0) {
	ldi R16,16
	ldi R17,0
	xcall _malloc_M
	movw R20,R16
	cpi R20,0
	cpc R20,R21
	brne X23
	xjmp L35
X23:
X21:
;         memset(entry, 0, sizeof(ARPENTRY));
	ldi R24,16
	ldi R25,0
	std y+1,R25
	std y+0,R24
	clr R18
	clr R19
	xcall _memset
;         entry->ae_ip = ip;
	ldd R2,y+8
	ldd R3,y+9
	ldd R4,y+10
	ldd R5,y+11
	movw R30,R20
	std z+2,R2
	std z+3,R3
	std z+4,R4
	std z+5,R5
;         if (ha) {
	tst R10
	brne X22
	tst R11
	breq L37
X22:
;             memcpy(entry->ae_ha, ha, 6);
	ldi R24,6
	ldi R25,0
	std y+1,R25
	std y+0,R24
	movw R18,R10
	movw R16,R30
	subi R16,250  ; offset = 6
	sbci R17,255
	xcall _memcpy
;             entry->ae_flags = ATF_COM;
	ldi R24,2
	movw R30,R20
	std z+12,R24
;         }
L37:
;         entry->ae_next = ifn->arpTable;
	movw R30,R22
	ldd R2,z+23
	ldd R3,z+24
	movw R30,R20
	std z+1,R3
	std z+0,R2
;         ifn->arpTable = entry;
	movw R30,R22
	std z+24,R21
	std z+23,R20
; 
; #ifdef NUTDEBUG
;         if (__tcp_trf) {
;             fprintf(__tcp_trs, "\n[ARP-NEW %s", inet_ntoa(ip));
;             if (ha) {
;                 fprintf(__tcp_trs, " %02x%02x%02x%02x%02x%02x", /* */
;                         ha[0], ha[1], ha[2], ha[3], ha[4], ha[5]);
;             }
;             fputc(']', __tcp_trs);
;         }
; #endif
;     }
L35:
;     return entry;
	movw R16,R20
L34:
	.dbline 0 ; func end
	adiw R28,2
	xcall pop_xgsetF00C
	adiw R28,2
	ret
;          entry -> R22,R23
;             ha -> R10,R11
;             ip -> y+10
;            dev -> R20,R21
	.even
_NutArpCacheUpdate::
	st -y,r19
	st -y,r18
	xcall push_xgsetF00C
	movw R20,R16
	sbiw R28,4
	ldd R10,y+14
	ldd R11,y+15
; }
; 
; /*!
;  * \brief Update an ARP entry.
;  *
;  * If an entry with the same IP address exists, then this entry is 
;  * updated. If no entry exists, a new one is created. All threads 
;  * waiting for address resolution are woken up.
;  *
;  * \note This function is automatically called on each incoming
;  *       ARP telegram. Applications typically do not call this 
;  *       function.
;  *
;  * \param dev Identifies the device.
;  * \param ip  Requested IP address in network byte order.
;  * \param ha  Pointer to a buffer which receives the MAC address.
;  *
;  */
; void NutArpCacheUpdate(NUTDEVICE * dev, u_long ip, u_char * ha)
; {
;     ARPENTRY *entry;
; 
;     /*
;      * If an entry with this IP exists, wake up waiting threads. If the
;      * entry is not permanent, then update it and mark it completed first.
;      */
;     if ((entry = ArpCacheLookup(dev->dev_icb, ip)) != 0) {
	ldd R2,y+10
	ldd R3,y+11
	ldd R4,y+12
	ldd R5,y+13
	std y+0,R4
	std y+1,R5
	movw R18,R2
	movw R30,R20
	ldd R16,z+15
	ldd R17,z+16
	xcall _ArpCacheLookup
	movw R22,R16
	cpi R22,0
	cpc R22,R23
	breq L40
X24:
; 
; #ifdef NUTDEBUG
;         if (__tcp_trf) {
;             fprintf(__tcp_trs, "[ARP-UPD %s", inet_ntoa(ip));
;             if (ha) {
;                 fprintf(__tcp_trs, " %02x%02x%02x%02x%02x%02x", /* */
;                         ha[0], ha[1], ha[2], ha[3], ha[4], ha[5]);
;             }
;             fputc(']', __tcp_trs);
;         }
; #endif
; 
;         if ((entry->ae_flags & ATF_PERM) == 0) {
	movw R30,R22
	ldd R2,z+12
	sbrc R2,2
	rjmp L42
X25:
;             entry->ae_outdated = 0;
	clr R2
	std z+13,R2
;             memcpy(entry->ae_ha, ha, 6);
	ldi R24,6
	ldi R25,0
	std y+1,R25
	std y+0,R24
	movw R18,R10
	subi R16,250  ; offset = 6
	sbci R17,255
	xcall _memcpy
;             entry->ae_flags |= ATF_COM;
	movw R24,R22
	adiw R24,12
	movw R30,R24
	ldd R24,z+0
	ori R24,2
	std z+0,R24
;         }
L42:
;         NutEventBroadcast(&entry->ae_tq);
	movw R16,R22
	subi R16,242  ; offset = 14
	sbci R17,255
	xcall _NutEventBroadcast
;     }
	xjmp L41
L40:
; 
;     /* 
;      * If no entry with this IP exists, then create a new completed one. 
;      */
;     else {
;         ArpCacheNew(dev->dev_icb, ip, ha);
	std y+3,R11
	std y+2,R10
	ldd R2,y+10
	ldd R3,y+11
	ldd R4,y+12
	ldd R5,y+13
	std y+0,R4
	std y+1,R5
	movw R18,R2
	movw R30,R20
	ldd R16,z+15
	ldd R17,z+16
	xcall _ArpCacheNew
;     }
L41:
L39:
	.dbline 0 ; func end
	adiw R28,4
	xcall pop_xgsetF00C
	adiw R28,2
	ret
;        retries -> R12
;            ifn -> y+12
;             nb -> y+10
;            tmo -> y+4
;          entry -> R14,R15
;             rc -> y+8
;            mac -> y+30
;             ip -> y+26
;            dev -> y+24
	.even
_NutArpCacheQuery::
	xcall push_arg4
	xcall push_xgsetF0FC
	sbiw R28,14
; }
; 
; /*!
;  * \brief Query MAC address for a specified IP address.
;  *
;  * If no entry is available in the ARP cache, an incomplete entry is
;  * created and ARP requests are generated on increasing time intervals.
;  * The calling thread is suspended until a matching ARP response is
;  * received or until a number of requests have been generated without
;  * receiving a response.
;  *
;  * \note This function is automatically called on each outgoing
;  *       IP packet. Applications typically do not call this function.
;  *
;  * \param dev  Identifies the device.
;  * \param ip   IP address of which the caller asked the MAC address.
;  * \param mac  Buffer for the retrieved MAC address.
;  *
;  * \return 0 if address resolved, -1 otherwise.
;  */
; int NutArpCacheQuery(NUTDEVICE * dev, CONST u_long ip, u_char * mac)
; {
;     int rc = -1;
	ldi R24,-1
	ldi R25,-1
	std y+9,R25
	std y+8,R24
;     ARPENTRY *entry;
;     IFNET *ifn = dev->dev_icb;
	ldd R30,y+24
	ldd R31,y+25
	ldd R2,z+15
	ldd R3,z+16
	std y+13,R3
	std y+12,R2
;     NETBUF *nb = 0;
	clr R0
	clr R1
	std y+11,R1
	std y+10,R0
;     u_char retries = MAX_ARPREQUESTS;
	clr R12
	inc R12
;     u_long tmo = MIN_ARPWAIT;
	ldi R20,244
	ldi R21,1
	ldi R22,0
	ldi R23,0
	std y+4,R20
	std y+5,R21
	std y+6,R22
	std y+7,R23
; 
;     /* Aging the cache on each query adds some processing to the path 
;      * which we want to be as fast as possible. But when calling this 
;      * function in NutArpCacheNew only, we will never detect when a 
;      * node changes its MAC address. Anyway, the previous solution of 
;      * running a timer thread consumed too much RAM.
;      */
;     ArpCacheAging();
	xcall _ArpCacheAging
; 
;     /*
;      * Search a matching entry. If none exists, create a new incomplete 
;      * entry and a request packet. If another thread has entered this 
;      * routine, an incomplete entry exists and the current thread will 
;      * not create a request packet and send out requests.
;      */
;     if ((entry = ArpCacheLookup(ifn, ip)) == 0) {
	ldd R2,y+26
	ldd R3,y+27
	ldd R4,y+28
	ldd R5,y+29
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldd R16,y+12
	ldd R17,y+13
	xcall _ArpCacheLookup
	movw R14,R16
	tst R14
	breq X38
	xjmp L45
X38:
	tst R15
	breq X39
	xjmp L45
X39:
X26:
;         if ((entry = ArpCacheNew(ifn, ip, 0)) == 0) {
	clr R2
	clr R3
	std y+3,R3
	std y+2,R2
	ldd R2,y+26
	ldd R3,y+27
	ldd R4,y+28
	ldd R5,y+29
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldd R16,y+12
	ldd R17,y+13
	xcall _ArpCacheNew
	movw R14,R16
	tst R14
	brne L47
	tst R15
	brne L47
X27:
;             return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L44
L47:
;         }
;         if ((nb = NutArpAllocNetBuf(ARPOP_REQUEST, ip, 0)) == 0) {
	clr R2
	clr R3
	std y+3,R3
	std y+2,R2
	ldd R2,y+26
	ldd R3,y+27
	ldd R4,y+28
	ldd R5,y+29
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldi R16,1
	ldi R17,0
	xcall _NutArpAllocNetBuf
	movw R10,R16
	std y+11,R11
	std y+10,R10
	cpi R16,0
	cpc R16,R17
	brne L49
X28:
;             entry->ae_flags |= ATF_REM;
	movw R24,R14
	adiw R24,12
	movw R10,R24
	movw R30,R24
	ldd R24,z+0
	ori R24,1
	std z+0,R24
;             ArpCacheFlush(ifn);
	ldd R16,y+12
	ldd R17,y+13
	xcall _ArpCacheFlush
;             return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L44
L49:
;         }
;     }
L45:
; 
;     /*
;      * We enter a loop, which will send ARP requests on increasing 
;      * time intervals until our ARP entry gets completed. Give up 
;      * after a configured number of retries.
;      */
;     for (;;) {
L51:
;         /* If completed, provide the MAC address and exit. */
;         if (entry->ae_flags & ATF_COM) {
	movw R30,R14
	ldd R2,z+12
	sbrs R2,1
	rjmp L55
X29:
;             //Work around for GCC 3.4.3 bug #18251
;             //memcpy(mac, entry->ae_ha, 6);
;             //rc = 0;
;             rc = 6;
	ldi R24,6
	ldi R25,0
	std y+9,R25
	std y+8,R24
L57:
;             do {
;                 rc--;
	ldd R24,y+8
	ldd R25,y+9
	sbiw R24,1
	std y+9,R25
	std y+8,R24
;                 mac[rc] = entry->ae_ha[rc];
	movw R24,R14
	adiw R24,6
	ldd R30,y+8
	ldd R31,y+9
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldd R30,y+8
	ldd R31,y+9
	ldd R0,y+30
	ldd R1,y+31
	add R30,R0
	adc R31,R1
	std z+0,R2
;             } while(rc);
L58:
	ldd R0,y+8
	ldd R1,y+9
	tst R0
	brne L57
	tst R1
	brne L57
X30:
;             break;
	xjmp L53
L55:
;         }
; #ifdef NUTDEBUG
;         if (__tcp_trf) {
;             fprintf(__tcp_trs, "[%u.ARP-%s %s]",        /* */
;                     MAX_ARPREQUESTS - retries + 1,      /* */
;                     nb ? "QRY" : "WAIT",        /* */
;                     inet_ntoa(ip));
;         }
; #endif
; 
;         /* Give up on too many retries. */
;         if (retries-- == 0) {
	mov R10,R12
	clr R11
	mov R24,R10
	subi R24,1
	mov R12,R24
	tst R10
	brne L60
X31:
;             break;
	xjmp L53
L60:
;         }
;         /* Mark buffer released on transmit errors. */
;         if (nb && NutArpOutput(dev, nb)) {
	ldd R0,y+10
	ldd R1,y+11
	tst R0
	brne X32
	tst R1
	breq L62
X32:
	movw R18,R0
	ldd R16,y+24
	ldd R17,y+25
	xcall _NutArpOutput
	movw R10,R16
	cpi R16,0
	cpc R16,R17
	breq L62
X33:
;             nb = 0;
	clr R0
	clr R1
	std y+11,R1
	std y+10,R0
;             break;
	xjmp L53
L62:
;         }
;         /* Sleep until woken up by an update of this ARP entry
;            or until timeout. Double the timeout on each retry. */
;         NutEventWait(&entry->ae_tq, tmo);
	ldd R2,y+4
	ldd R3,y+5
	ldd R4,y+6
	ldd R5,y+7
	std y+0,R4
	std y+1,R5
	movw R18,R2
	movw R16,R14
	subi R16,242  ; offset = 14
	sbci R17,255
	xcall _NutEventWait
;         tmo += tmo;
	ldd R2,y+4
	ldd R3,y+5
	ldd R4,y+6
	ldd R5,y+7
	movw R6,R2
	movw R8,R4
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	std y+4,R6
	std y+5,R7
	std y+6,R8
	std y+7,R9
; 
;         /* During our sleep, another thread, which created the
;            incomplete entry, may have given up and removed the entry. 
;            In this case we should also return an error. */
;         if ((entry = ArpCacheLookup(ifn, ip)) == 0) {
	ldd R2,y+26
	ldd R3,y+27
	ldd R4,y+28
	ldd R5,y+29
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldd R16,y+12
	ldd R17,y+13
	xcall _ArpCacheLookup
	movw R10,R16
	movw R14,R10
	cpi R16,0
	cpc R16,R17
	breq X40
	xjmp L51
X40:
X34:
;             break;
;         }
;     }
L53:
; 
;     /* Only the thread that created the entry, allocated a request 
;        packet. If this thread fails, it should also remove the entry. */
;     if (nb) {
	ldd R0,y+10
	ldd R1,y+11
	tst R0
	brne X35
	tst R1
	breq L66
X35:
;         NutNetBufFree(nb);
	movw R16,R0
	xcall _NutNetBufFree
;         /* Play save and check, if the entry still exists. */
;         if (rc && entry) {
	ldd R0,y+8
	ldd R1,y+9
	tst R0
	brne X36
	tst R1
	breq L68
X36:
	tst R14
	brne X37
	tst R15
	breq L68
X37:
;             entry->ae_flags |= ATF_REM;
	movw R24,R14
	adiw R24,12
	movw R14,R24
	movw R30,R24
	ldd R24,z+0
	ori R24,1
	std z+0,R24
;             ArpCacheFlush(ifn);
	ldd R16,y+12
	ldd R17,y+13
	xcall _ArpCacheFlush
;         }
L68:
;     }
L66:
;     return rc;
	ldd R16,y+8
	ldd R17,y+9
L44:
	.dbline 0 ; func end
	adiw R28,14
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
; }
; 
; /*@}*/
