	.module arpin.c
	.area text(rom, con, rel)
;            nbr -> R10,R11
;            nif -> R12,R13
;             ah -> R12,R13
;             ea -> R10,R11
;             nb -> R20,R21
;            dev -> R22,R23
	.even
_NutArpInput::
	xcall push_xgsetF03C
	movw R20,R18
	movw R22,R16
	sbiw R28,4
; /*
;  * Copyright (C) 2001-2003 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  * -
;  * Portions Copyright (C) 2000 David J. Hudson <dave@humbug.demon.co.uk>
;  *
;  * This file is distributed in the hope that it will be useful, but WITHOUT
;  * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;  * FITNESS FOR A PARTICULAR PURPOSE.
;  *
;  * You can redistribute this file and/or modify it under the terms of the GNU
;  * General Public License (GPL) as published by the Free Software Foundation;
;  * either version 2 of the License, or (at your discretion) any later version.
;  * See the accompanying file "copying-gpl.txt" for more details.
;  *
;  * As a special exception to the GPL, permission is granted for additional
;  * uses of the text contained in this file.  See the accompanying file
;  * "copying-liquorice.txt" for details.
;  * -
;  * Portions Copyright (c) 1983, 1993 by
;  *  The Regents of the University of California.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the University nor the names of its contributors
;  *    may be used to endorse or promote products derived from this software
;  *    without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
;  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
;  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
;  * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
;  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
;  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
;  * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
;  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
;  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
;  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  * -
;  * Portions Copyright (c) 1993 by Digital Equipment Corporation.
;  *
;  * Permission to use, copy, modify, and distribute this software for any
;  * purpose with or without fee is hereby granted, provided that the above
;  * copyright notice and this permission notice appear in all copies, and that
;  * the name of Digital Equipment Corporation not be used in advertising or
;  * publicity pertaining to distribution of the document or software without
;  * specific, written prior permission.
;  * 
;  * THE SOFTWARE IS PROVIDED "AS IS" AND DIGITAL EQUIPMENT CORP. DISCLAIMS ALL
;  * WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES
;  * OF MERCHANTABILITY AND FITNESS.   IN NO EVENT SHALL DIGITAL EQUIPMENT
;  * CORPORATION BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
;  * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
;  * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
;  * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
;  * SOFTWARE.
;  */
; 
; /*
;  * $Log: arpin.c,v $
;  * Revision 1.3  2005/04/08 15:20:50  olereinhardt
;  * added <sys/types.h> (__APPLE__) and <netinet/in.h> (__linux__)
;  * for htons and simmilar.
;  *
;  * Revision 1.2  2004/07/27 19:41:00  drsung
;  * If NutArpOutput fails, the NetBuf must not be deallocated by
;  * calling NutNetBufFree.
;  *
;  * Revision 1.1.1.1  2003/05/09 14:41:26  haraldkipp
;  * Initial using 3.2.1
;  *
;  * Revision 1.9  2003/02/04 18:14:56  harald
;  * Version 3 released
;  *
;  * Revision 1.8  2002/06/26 17:29:35  harald
;  * First pre-release with 2.4 stack
;  *
;  */
; #include <sys/types.h>
; #include <net/if_var.h>
; #include <netinet/if_ether.h>
; #include <netinet/in.h>
; /*!
;  * \addtogroup xgARP
;  *
;  * \todo Response may reuse received ARP packet.
;  */
; /*@{*/
; 
; 
; /*!
;  * \brief Handle incoming ARP packets.
;  *
;  * Packets not destined to us or packets with unsupported 
;  * address type or item length are silently discarded.
;  *
;  * \note This routine is called by the Ethernet layer on
;  *       incoming ARP packets. Applications typically do
;  *       not call this function.
;  *
;  * \param dev Identifies the device that received the packet.
;  * \param nb  Pointer to a network buffer structure containing 
;  *            the ARP packet.
;  */
; void NutArpInput(NUTDEVICE * dev, NETBUF * nb)
; {
;     ETHERARP *ea;
;     ARPHDR *ah;
;     IFNET *nif;
; 
;     ea = (ETHERARP *) nb->nb_nw.vp;
	movw R30,R20
	ldd R10,z+7
	ldd R11,z+8
;     ah = (ARPHDR *) & ea->ea_hdr;
	movw R12,R10
; 
;     /*
;      * Silently discard packets with unsupported
;      * address types and lengths.
;      */
;     if (ntohs(ah->ar_hrd) != ARPHRD_ETHER ||
	movw R30,R12
	ldd R4,z+0
	ldd R5,z+1
	movw R24,R4
	andi R24,0
	movw R2,R24
	mov R2,R3
	clr R3
	movw R24,R4
	andi R25,0
	mov R25,R24
	clr R24
	or R24,R2
	or R25,R3
	cpi R24,1
	ldi R26,0
	cpc R25,R26
	brne L6
X0:
	ldd R4,z+2
	ldd R5,z+3
	movw R24,R4
	andi R24,0
	movw R2,R24
	mov R2,R3
	clr R3
	movw R24,R4
	andi R25,0
	mov R25,R24
	clr R24
	or R24,R2
	or R25,R3
	cpi R24,0
	ldi R26,8
	cpc R25,R26
	brne L6
X1:
	ldd R24,z+4
	cpi R24,6
	brne L6
X2:
	ldd R24,z+5
	cpi R24,4
	breq L2
X3:
L6:
;         ntohs(ah->ar_pro) != ETHERTYPE_IP ||
;         ah->ar_hln != 6 || ah->ar_pln != 4) {
;         NutNetBufFree(nb);
	movw R16,R20
	xcall _NutNetBufFree
;         return;
	xjmp L1
L2:
;     }
; 
;     /*
;      * Silently discard packets for other destinations.
;      */
;     nif = dev->dev_icb;
	movw R30,R22
	ldd R12,z+15
	ldd R13,z+16
;     if (ea->arp_tpa != nif->if_local_ip) {
	movw R30,R12
	ldd R2,z+7
	ldd R3,z+8
	ldd R4,z+9
	ldd R5,z+10
	movw R30,R10
	ldd R6,z+24
	ldd R7,z+25
	ldd R8,z+26
	ldd R9,z+27
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	breq L7
X4:
;         NutNetBufFree(nb);
	movw R16,R20
	xcall _NutNetBufFree
;         return;
	xjmp L1
L7:
;     }
; 
;     /*
;      * TODO: Silently discard packets with our own 
;      * source address.
;      */
; 
;     /*
;      * TODO: Discard packets with broadcast source
;      * address.
;      */
; 
;     /*
;      * TODO: Discard packets if source IP address
;      * equals our address. We should send a reply.
;      */
; 
;     /*
;      * Add the sender to our arp cache. Note, that we don't do
;      * this with replies only, but also with requests on our
;      * address. The assumption is that if someone is requesting
;      * our address, they are probably intending to talk to us,
;      * so it saves time if we cache their address.
;      */
;     NutArpCacheUpdate(dev, ea->arp_spa, ea->arp_sha);
	movw R24,R10
	adiw R24,8
	std y+3,R25
	std y+2,R24
	movw R30,R10
	ldd R2,z+14
	ldd R3,z+15
	ldd R4,z+16
	ldd R5,z+17
	std y+0,R4
	std y+1,R5
	movw R18,R2
	movw R16,R22
	xcall _NutArpCacheUpdate
; 
;     /*
;      * Reply to ARP requests.
;      */
;     if (htons(ea->ea_hdr.ar_op) == ARPOP_REQUEST) {
	movw R30,R10
	ldd R12,z+6
	ldd R13,z+7
	movw R24,R12
	andi R24,0
	movw R2,R24
	mov R2,R3
	clr R3
	movw R24,R12
	andi R25,0
	mov R25,R24
	clr R24
	or R24,R2
	or R25,R3
	cpi R24,1
	ldi R26,0
	cpc R25,R26
	brne L9
X5:
;         NETBUF *nbr =
;             NutArpAllocNetBuf(ARPOP_REPLY, ea->arp_spa, ea->arp_sha);
	movw R24,R30
	adiw R24,8
	std y+3,R25
	std y+2,R24
	ldd R2,z+14
	ldd R3,z+15
	ldd R4,z+16
	ldd R5,z+17
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldi R16,2
	ldi R17,0
	xcall _NutArpAllocNetBuf
	movw R10,R16
; 
;         if (nbr) {
	cpi R16,0
	cpc R16,R17
	breq L11
X6:
;             if (!NutArpOutput(dev, nbr))
	movw R18,R10
	movw R16,R22
	xcall _NutArpOutput
	movw R12,R16
	cpi R16,0
	cpc R16,R17
	brne L13
X7:
;                 NutNetBufFree(nbr);
	movw R16,R10
	xcall _NutNetBufFree
L13:
;         }
L11:
;     }
L9:
;     NutNetBufFree(nb);
	movw R16,R20
	xcall _NutNetBufFree
L1:
	.dbline 0 ; func end
	adiw R28,4
	xjmp pop_xgsetF03C
; }
; 
; /*@}*/
