	.module confnet.c
	.area text(rom, con, rel)
;           name -> R10,R11
	.even
_NutNetLoadConfig::
	st -y,R10
	st -y,R11
	movw R10,R16
	sbiw R28,2
; /*
;  * Copyright (C) 2001-2005 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  */
; 
; /*
;  * $Log: confnet.c,v $
;  * Revision 1.6  2005/10/04 05:37:34  hwmaier
;  * Removed preprocessor warning message for AT90CAN128 MCU as this device is now supported by avr-libc.
;  *
;  * Revision 1.5  2005/07/26 15:49:59  haraldkipp
;  * Cygwin support added.
;  *
;  * Revision 1.4  2005/02/10 07:06:50  hwmaier
;  * Changes to incorporate support for AT90CAN128 CPU
;  *
;  * Revision 1.3  2004/04/07 12:13:58  haraldkipp
;  * Matthias Ringwald's *nix emulation added
;  *
;  * Revision 1.2  2003/07/13 19:03:06  haraldkipp
;  * Make empty MAC broadcast.
;  *
;  * Revision 1.1.1.1  2003/05/09 14:41:27  haraldkipp
;  * Initial using 3.2.1
;  *
;  * Revision 1.2  2003/05/06 18:22:48  harald
;  * EEPROM corruption fixed
;  *
;  * Revision 1.1  2003/02/04 18:15:26  harald
;  * Version 3 released
;  *
;  */
; 
; #include <string.h>
; #include <arpa/inet.h>
; #include <sys/confnet.h>
; 
; CONFNET confnet;
; 
; /*!
;  * \brief Load network configuration from EEPROM.
;  *
;  * If no configuration is available in EEPROM, all configuration
;  * parameters are cleared to zero. Except the MAC address, which
;  * is set to the Ethernet broadcast address.
;  *
;  * \param name Name of the device.
;  *
;  * \return 0 if configuration has been read. Otherwise the
;  *         return value is -1.
;  */
; int NutNetLoadConfig(CONST char *name)
; {
; #if !defined(__linux__) && !defined(__APPLE__) && !defined(__CYGWIN__)
;     eeprom_read_block(&confnet, (void *) CONFNET_EE_OFFSET, sizeof(CONFNET));
	ldi R24,32
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<_confnet
	ldi R19,>_confnet
	ldi R16,64
	ldi R17,0
	xcall _EEPROMReadBytes
;     if (confnet.cd_size == sizeof(CONFNET)
	lds R24,_confnet
	cpi R24,32
	brne L2
X0:
	movw R18,R10
	ldi R16,<_confnet+1
	ldi R17,>_confnet+1
	xcall _strcmp
	cpi R16,0
	cpc R16,R17
	brne L2
X1:
;         && strcmp(confnet.cd_name, name) == 0)
;         return 0;
	clr R16
	clr R17
	xjmp L1
L2:
; #endif
;     memset(&confnet, 0, sizeof(confnet));
	ldi R24,32
	ldi R25,0
	std y+1,R25
	std y+0,R24
	clr R18
	clr R19
	ldi R16,<_confnet
	ldi R17,>_confnet
	xcall _memset
; 
;     /*
;      * Set initial MAC address to broadcast. Thanks to Tomohiro
;      * Haraikawa, who pointed out that all zeroes is occupied by
;      * Xerox and should not be used.
;      */
;     memset(confnet.cdn_mac, 0xFF, sizeof(confnet.cdn_mac));
	ldi R24,6
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,255
	ldi R19,0
	ldi R16,<_confnet+10
	ldi R17,>_confnet+10
	xcall _memset
; 
;     return -1;
	ldi R16,-1
	ldi R17,-1
L1:
	.dbline 0 ; func end
	adiw R28,2
	ld R11,y+
	ld R10,y+
	ret
;             cp -> R22,R23
;              i -> R20,R21
	.even
_NutNetSaveConfig::
	xcall push_xgsetF000
; }
; 
; /*!
;  * \brief Save network configuration in EEPROM.
;  *
;  * \return Allways 0.
;  */
; int NutNetSaveConfig(void)
; {
; #if !defined(__linux__) && !defined(__APPLE__) && !defined(__CYGWIN__)
;     u_char *cp;
;     size_t i;
; 
;     confnet.cd_size = sizeof(CONFNET);
	ldi R24,32
	sts _confnet,R24
;     for (cp = (u_char *) & confnet, i = 0; i < sizeof(CONFNET); cp++, i++)
	ldi R22,<_confnet
	ldi R23,>_confnet
	clr R20
	clr R21
	xjmp L11
L8:
;         if (eeprom_read_byte((void *) (i + CONFNET_EE_OFFSET)) != *cp)
	movw R16,R20
	subi R16,192  ; offset = 64
	sbci R17,255
	xcall _EEPROMread
	movw R30,R22
	ldd R2,z+0
	cp R16,R2
	breq L12
X2:
;             eeprom_write_byte((void *) (i + CONFNET_EE_OFFSET), *cp);
	ldd R18,z+0
	movw R16,R20
	subi R16,192  ; offset = 64
	sbci R17,255
	xcall _EEPROMwrite
L12:
L9:
	subi R22,255  ; offset = 1
	sbci R23,255
	subi R20,255  ; offset = 1
	sbci R21,255
L11:
	cpi R20,32
	ldi R30,0
	cpc R21,R30
	brlo L8
X3:
; 
; #endif
;     return 0;
	clr R16
	clr R17
L7:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.area bss(ram, con, rel)
_confnet::
	.blkb 32
; }
