	.module ipin.c
	.area text(rom, con, rel)
;   callbackFunc -> R16,R17
	.even
_NutIpSetInputFilter::
; /*
;  * Copyright (C) 2001-2005 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  * -
;  * Portions Copyright (C) 2000 David J. Hudson <dave@humbug.demon.co.uk>
;  *
;  * This file is distributed in the hope that it will be useful, but WITHOUT
;  * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;  * FITNESS FOR A PARTICULAR PURPOSE.
;  *
;  * You can redistribute this file and/or modify it under the terms of the GNU
;  * General Public License (GPL) as published by the Free Software Foundation;
;  * either version 2 of the License, or (at your discretion) any later version.
;  * See the accompanying file "copying-gpl.txt" for more details.
;  *
;  * As a special exception to the GPL, permission is granted for additional
;  * uses of the text contained in this file.  See the accompanying file
;  * "copying-liquorice.txt" for details.
;  * -
;  * Portions Copyright (c) 1983, 1993 by
;  *  The Regents of the University of California.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the University nor the names of its contributors
;  *    may be used to endorse or promote products derived from this software
;  *    without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
;  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
;  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
;  * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
;  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
;  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
;  * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
;  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
;  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
;  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  * -
;  * Portions Copyright (c) 1993 by Digital Equipment Corporation.
;  *
;  * Permission to use, copy, modify, and distribute this software for any
;  * purpose with or without fee is hereby granted, provided that the above
;  * copyright notice and this permission notice appear in all copies, and that
;  * the name of Digital Equipment Corporation not be used in advertising or
;  * publicity pertaining to distribution of the document or software without
;  * specific, written prior permission.
;  * 
;  * THE SOFTWARE IS PROVIDED "AS IS" AND DIGITAL EQUIPMENT CORP. DISCLAIMS ALL
;  * WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES
;  * OF MERCHANTABILITY AND FITNESS.   IN NO EVENT SHALL DIGITAL EQUIPMENT
;  * CORPORATION BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
;  * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
;  * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
;  * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
;  * SOFTWARE.
;  */
; 
; /*
;  * $Log: ipin.c,v $
;  * Revision 1.4  2005/06/05 16:48:26  haraldkipp
;  * Additional parameter enables NutUdpInput() to avoid responding to UDP
;  * broadcasts with ICMP unreachable messages. Fixes bug #1215192.
;  *
;  * Revision 1.3  2004/12/16 18:48:50  haraldkipp
;  * Added Damian Slee's IP filter function.
;  *
;  * Revision 1.2  2004/02/02 18:59:25  drsung
;  * Some more ICMP support added.
;  *
;  * Revision 1.1.1.1  2003/05/09 14:41:32  haraldkipp
;  * Initial using 3.2.1
;  *
;  * Revision 1.16  2003/05/06 18:14:18  harald
;  * Allow incoming DHCP telegrams, even if not broadcasted
;  *
;  * Revision 1.15  2003/03/31 12:26:05  harald
;  * Accept masks with all bits set
;  *
;  * Revision 1.14  2003/02/04 18:14:57  harald
;  * Version 3 released
;  *
;  * Revision 1.13  2002/06/26 17:29:36  harald
;  * First pre-release with 2.4 stack
;  *
;  */
; 
; #include <net/route.h>
; #include <netinet/in.h>
; #include <netinet/ip.h>
; #include <netinet/icmp.h>
; #include <netinet/ip_icmp.h>
; #include <netinet/udp.h>
; #include <sys/socket.h>
; #include <arpa/inet.h>
; 
; /*!
;  * \addtogroup xgIP
;  */
; /*@{*/
; 
; static NutIpFilterFunc NutIpFilter;
; 
; /*!
;  * \brief Set filter function for incoming IP datagrams.
;  *
;  * The callbackFunc is called by the IP layer on every incoming IP 
;  * datagram. Thus it must not block. The implementer returns 0 for 
;  * allow, -1 for deny.
;  *
;  * It is recommended to set the filer after DHCP has done its thing,
;  * just in case your DHCP server is on a different subnet for example.
;  *
;  * \param callbackFunc Pointer to callback function to filter IP packets.
;  *                     Set to 0 to disable the filter again.
;  */
; void NutIpSetInputFilter(NutIpFilterFunc callbackFunc)
; {
;     NutIpFilter = callbackFunc;
	sts _NutIpFilter+1,R17
	sts _NutIpFilter,R16
L1:
	.dbline 0 ; func end
	ret
;          bcast -> R12
;      ip_hdrlen -> R10,R11
;            dst -> y+10
;            nif -> R14,R15
;             ip -> y+26
;             nb -> y+40
;            dev -> y+38
	.even
_NutIpInput::
	xcall push_arg4
	xcall push_xgsetF0FC
	sbiw R28,28
; }
; 
; /*!
;  * \brief Process incoming IP datagrams.
;  *
;  * Datagrams addressed to other destinations and datagrams 
;  * whose version number is not 4 are silently discarded.
;  *
;  * \note This routine is called by the Ethernet layer on
;  *       incoming IP datagrams. Applications typically do
;  *       not call this function.
;  *
;  * \param dev Identifies the device that received this datagram.
;  * \param nb  The network buffer received.
;  */
; void NutIpInput(NUTDEVICE * dev, NETBUF * nb)
; {
;     IPHDR *ip;
;     u_short ip_hdrlen;
;     u_long dst;
;     ureg_t bcast;
;     IFNET *nif;
; 
;     ip = nb->nb_nw.vp;
	ldd R30,y+40
	ldd R31,y+41
	ldd R2,z+7
	ldd R3,z+8
	std y+27,R3
	std y+26,R2
; 
;     /*
;      * Silently discard datagrams of different IP version as well as
;      * fragmented or filtered datagrams.
;      */
;     if (ip->ip_v != IPVERSION ||        /* Version check. */
	movw R30,R2
	ldd R24,z+0
	swap R24
	andi R24,#0x0F
	andi R24,15
	cpi R24,4
	brne L6
X0:
	ldd R4,z+6
	ldd R5,z+7
	movw R24,R4
	andi R24,0
	movw R2,R24
	mov R2,R3
	clr R3
	movw R24,R4
	andi R25,0
	mov R25,R24
	clr R24
	or R24,R2
	or R25,R3
	andi R25,63
	cpi R24,0
	cpc R24,R25
	brne L6
X1:
	lds R2,_NutIpFilter
	lds R3,_NutIpFilter+1
	tst R2
	brne X2
	tst R3
	breq L3
X2:
	ldd R16,z+12
	ldd R17,z+13
	ldd R18,z+14
	ldd R19,z+15
	movw R30,R2
	xcall  xicall
	movw R10,R16
	cpi R16,0
	cpc R16,R17
	breq L3
X3:
L6:
;         (ntohs(ip->ip_off) & (IP_MF | IP_OFFMASK)) != 0 ||      /* Fragmentation. */
;         (NutIpFilter && NutIpFilter(ip->ip_src))) {     /* Filter. */
;         NutNetBufFree(nb);
	ldd R16,y+40
	ldd R17,y+41
	xcall _NutNetBufFree
;         return;
	xjmp L2
L3:
;     }
; 
;     ip_hdrlen = ip->ip_hl * 4;
	ldd R30,y+26
	ldd R31,y+27
	ldd R24,z+0
	andi R24,15
	ldi R25,4
	mul R25,R24
	movw R10,R0
; 
;     /*
;      * No checksum calculation on incoming datagrams!
;      */
; 
;     /*
;      * Check for broadcast.
;      */
;     dst = ip->ip_dst;
	ldd R2,z+16
	ldd R3,z+17
	ldd R4,z+18
	ldd R5,z+19
	std y+10,R2
	std y+11,R3
	std y+12,R4
	std y+13,R5
;     nif = dev->dev_icb;
	ldd R30,y+38
	ldd R31,y+39
	ldd R14,z+15
	ldd R15,z+16
; 
;     if (dst == 0xffffffff || (nif->if_local_ip && nif->if_mask != 0xffffffff && (dst | nif->if_mask) == 0xffffffff)) {
	ldi R20,255
	ldi R21,255
	ldi R22,255
	ldi R23,255
	ldd R2,y+10
	ldd R3,y+11
	ldd R4,y+12
	ldd R5,y+13
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	breq L9
X4:
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	movw R30,R14
	ldd R2,z+7
	ldd R3,z+8
	ldd R4,z+9
	ldd R5,z+10
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	breq L7
X5:
	ldd R2,z+15
	ldd R3,z+16
	ldd R4,z+17
	ldd R5,z+18
	std y+14,R2
	std y+15,R3
	std y+16,R4
	std y+17,R5
	ldi R20,255
	ldi R21,255
	ldi R22,255
	ldi R23,255
	ldd R2,y+14
	ldd R3,y+15
	ldd R4,y+16
	ldd R5,y+17
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	breq L7
X6:
	ldd R6,y+10
	ldd R7,y+11
	ldd R8,y+12
	ldd R9,y+13
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	ldi R20,255
	ldi R21,255
	ldi R22,255
	ldi R23,255
	cp R6,R20
	cpc R7,R21
	cpc R8,R22
	cpc R9,R23
	brne L7
X7:
L9:
;         bcast = 1;
	clr R12
	inc R12
;     } else {
	xjmp L8
L7:
;         bcast = 0;
	clr R12
; 
;         if (nif->if_local_ip == 0 && ip->ip_p == IPPROTO_ICMP && (dst & 0xff000000) != 0xff000000 && (dst & 0xff000000) != 0) {
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	movw R30,R14
	ldd R2,z+7
	ldd R3,z+8
	ldd R4,z+9
	ldd R5,z+10
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	breq X21
	xjmp L10
X21:
X8:
	ldd R30,y+26
	ldd R31,y+27
	ldd R24,z+9
	cpi R24,1
	breq X22
	xjmp L10
X22:
X9:
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,255
	ldd R2,y+10
	ldd R3,y+11
	ldd R4,y+12
	ldd R5,y+13
	and R2,R20
	and R3,R21
	and R4,R22
	and R5,R23
	std y+18,R2
	std y+19,R3
	std y+20,R4
	std y+21,R5
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,255
	ldd R2,y+18
	ldd R3,y+19
	ldd R4,y+20
	ldd R5,y+21
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	breq L10
X10:
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	breq L10
X11:
;             NutNetIfSetup(dev, dst, 0, 0);
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	std y+6,R20
	std y+7,R21
	std y+8,R22
	std y+9,R23
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	std y+2,R20
	std y+3,R21
	std y+4,R22
	std y+5,R23
	ldd R2,y+10
	ldd R3,y+11
	ldd R4,y+12
	ldd R5,y+13
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldd R16,y+38
	ldd R17,y+39
	xcall _NutNetIfSetup
;         }
L10:
; 
;         /*
;          * Silently discard datagrams for other destinations.
;          * However, if we haven't got an IP address yet, we
;          * allow ICMP datagrams to support dynamic IP ARP method.
;          */
;         if (nif->if_local_ip && (dst == 0 || dst != nif->if_local_ip)) {
	movw R30,R14
	ldd R2,z+7
	ldd R3,z+8
	ldd R4,z+9
	ldd R5,z+10
	std y+22,R2
	std y+23,R3
	std y+24,R4
	std y+25,R5
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R2,y+22
	ldd R3,y+23
	ldd R4,y+24
	ldd R5,y+25
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	breq L12
X12:
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R2,y+10
	ldd R3,y+11
	ldd R4,y+12
	ldd R5,y+13
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	breq L14
X13:
	ldd R2,y+22
	ldd R3,y+23
	ldd R4,y+24
	ldd R5,y+25
	ldd R6,y+10
	ldd R7,y+11
	ldd R8,y+12
	ldd R9,y+13
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	breq L12
X14:
L14:
;             NutNetBufFree(nb);
	ldd R16,y+40
	ldd R17,y+41
	xcall _NutNetBufFree
;             return;
	xjmp L2
L12:
;         }
;     }
L8:
; 
;     nb->nb_nw.sz = ip_hdrlen;
	ldd R30,y+40
	ldd R31,y+41
	std z+10,R11
	std z+9,R10
;     nb->nb_tp.vp = ((u_char *) ip) + (ip_hdrlen);
	movw R2,R10
	ldd R0,y+26
	ldd R1,y+27
	add R2,R0
	adc R3,R1
	std z+12,R3
	std z+11,R2
;     nb->nb_tp.sz = htons(ip->ip_len) - (ip_hdrlen);
	movw R30,R0
	ldd R14,z+2
	ldd R15,z+3
	movw R24,R14
	andi R24,0
	movw R2,R24
	mov R2,R3
	clr R3
	movw R24,R14
	andi R25,0
	mov R25,R24
	clr R24
	or R24,R2
	or R25,R3
	sub R24,R10
	sbc R25,R11
	ldd R30,y+40
	ldd R31,y+41
	std z+14,R25
	std z+13,R24
; 
;     switch (ip->ip_p) {
	movw R30,R0
	ldd R14,z+9
	clr R15
	movw R24,R14
	cpi R24,6
	ldi R30,0
	cpc R25,R30
	breq L20
X15:
	ldi R24,6
	cp R24,R14
	cpc R25,R15
	brlt L26
X16:
L25:
	movw R24,R14
	cpi R24,1
	ldi R30,0
	cpc R25,R30
	breq L18
X17:
	xjmp L15
L26:
	movw R24,R14
	cpi R24,17
	ldi R30,0
	cpc R25,R30
	breq L19
X18:
	xjmp L15
L18:
;     case IPPROTO_ICMP:
;         NutIcmpInput(dev, nb);
	ldd R18,y+40
	ldd R19,y+41
	ldd R16,y+38
	ldd R17,y+39
	xcall _NutIcmpInput
;         break;
	xjmp L16
L19:
;     case IPPROTO_UDP:
;         NutUdpInput(nb, bcast);
	mov R18,R12
	ldd R16,y+40
	ldd R17,y+41
	xcall _NutUdpInput
;         break;
	xjmp L16
L20:
;     case IPPROTO_TCP:
;         /*
;          * Silently discard TCP broadcasts.
;          */
;         if (bcast)
	tst R12
	breq L21
X19:
;             NutNetBufFree(nb);
	ldd R16,y+40
	ldd R17,y+41
	xcall _NutNetBufFree
	xjmp L16
L21:
;         else
;             NutTcpInput(nb);
	ldd R16,y+40
	ldd R17,y+41
	xcall _NutTcpInput
;         break;
	xjmp L16
L15:
;     default:
;         /* Unkown protocol, send ICMP destination (protocol)
;          * unreachable message.
;          */
;         if (!NutIcmpResponse(ICMP_UNREACH, ICMP_UNREACH_PROTOCOL, 0, nb))
	ldd R0,y+40
	ldd R1,y+41
	std y+5,R1
	std y+4,R0
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	std y+0,R20
	std y+1,R21
	std y+2,R22
	std y+3,R23
	ldi R18,2
	ldi R16,3
	xcall _NutIcmpResponse
	movw R12,R16
	cpi R16,0
	cpc R16,R17
	brne L16
X20:
;             NutNetBufFree(nb);
	ldd R16,y+40
	ldd R17,y+41
	xcall _NutNetBufFree
;         break;
L16:
L2:
	.dbline 0 ; func end
	adiw R28,28
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
	.area bss(ram, con, rel)
_NutIpFilter:
	.blkb 2
;     }
; }
; 
; /*@}*/
