	.module tcpout.c
	.area text(rom, con, rel)
;            nbp -> R10,R11
;          n_mss -> y+12
;             cp -> R14,R15
;           hlen -> R10
;           csum -> R14,R15
;       nb_clone -> y+18
;             nb -> y+16
;             th -> R12,R13
;           size -> y+34
;           data -> y+32
;           sock -> y+30
	.even
_NutTcpOutput::
	xcall push_arg4
	xcall push_xgsetF0FC
	sbiw R28,20
; /*
;  * Copyright (C) 2001-2005 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  * -
;  * Portions Copyright (C) 2000 David J. Hudson <dave@humbug.demon.co.uk>
;  *
;  * This file is distributed in the hope that it will be useful, but WITHOUT
;  * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;  * FITNESS FOR A PARTICULAR PURPOSE.
;  *
;  * You can redistribute this file and/or modify it under the terms of the GNU
;  * General Public License (GPL) as published by the Free Software Foundation;
;  * either version 2 of the License, or (at your discretion) any later version.
;  * See the accompanying file "copying-gpl.txt" for more details.
;  *
;  * As a special exception to the GPL, permission is granted for additional
;  * uses of the text contained in this file.  See the accompanying file
;  * "copying-liquorice.txt" for details.
;  * -
;  * Portions Copyright (c) 1983, 1993 by
;  *  The Regents of the University of California.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the University nor the names of its contributors
;  *    may be used to endorse or promote products derived from this software
;  *    without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
;  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
;  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
;  * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
;  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
;  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
;  * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
;  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
;  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
;  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  * -
;  * Portions Copyright (c) 1993 by Digital Equipment Corporation.
;  *
;  * Permission to use, copy, modify, and distribute this software for any
;  * purpose with or without fee is hereby granted, provided that the above
;  * copyright notice and this permission notice appear in all copies, and that
;  * the name of Digital Equipment Corporation not be used in advertising or
;  * publicity pertaining to distribution of the document or software without
;  * specific, written prior permission.
;  * 
;  * THE SOFTWARE IS PROVIDED "AS IS" AND DIGITAL EQUIPMENT CORP. DISCLAIMS ALL
;  * WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES
;  * OF MERCHANTABILITY AND FITNESS.   IN NO EVENT SHALL DIGITAL EQUIPMENT
;  * CORPORATION BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
;  * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
;  * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
;  * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
;  * SOFTWARE.
;  */
; 
; /*
;  * $Log: tcpout.c,v $
;  * Revision 1.5.2.1  2006/02/02 14:07:00  haraldkipp
;  * Avoid memory alignment errors.
;  *
;  * Revision 1.5  2005/04/30 16:42:42  chaac
;  * Fixed bug in handling of NUTDEBUG. Added include for cfg/os.h. If NUTDEBUG
;  * is defined in NutConf, it will make effect where it is used.
;  *
;  * Revision 1.4  2005/04/05 17:41:48  haraldkipp
;  * Header is dangerous when you forget to remove all debug outputs.
;  *
;  * Revision 1.3  2004/07/30 19:54:46  drsung
;  * Some code of TCP stack redesigned. Round trip time calculation is now
;  * supported. Fixed several bugs in TCP state machine. Now TCP connections
;  * should be more reliable under heavy traffic or poor physical connections.
;  *
;  * Revision 1.2  2004/04/15 11:05:35  haraldkipp
;  * Set retransmission timer on first transmit queue entry
;  *
;  * Revision 1.1.1.1  2003/05/09 14:41:40  haraldkipp
;  * Initial using 3.2.1
;  *
;  * Revision 1.15  2003/03/31 12:29:17  harald
;  * Check NEBUF allocation
;  *
;  * Revision 1.14  2003/02/04 18:14:57  harald
;  * Version 3 released
;  *
;  * Revision 1.13  2002/09/15 16:50:44  harald
;  * *** empty log message ***
;  *
;  * Revision 1.12  2002/06/26 17:29:36  harald
;  * First pre-release with 2.4 stack
;  *
;  */
; 
; #include <cfg/os.h>
; #include <string.h>
; 
; #include <sys/heap.h>
; #include <sys/event.h>
; #include <sys/timer.h>
; 
; #include <netinet/in.h>
; #include <netinet/ip.h>
; #include <netinet/icmp.h>
; #include <netinet/ip_icmp.h>
; #include <netinet/ipcsum.h>
; #include <sys/socket.h>
; #include <netinet/tcp.h>
; #include <net/errno.h>
; #include <sys/thread.h>
; 
; #ifdef NUTDEBUG
; #include <net/netdebug.h>
; #endif
; 
; /*!
;  * \addtogroup xgTCP
;  */
; 
; /*!
;  * \brief Initiate TCP segment transmission.
;  *
;  * Check the TCP socket status and send any segment waiting
;  * for transmission.
;  *
;  * The function will not return until the data has been stored in the 
;  * network device hardware for transmission. If the device is not ready 
;  * for transmitting a new packet, the calling thread will be suspended 
;  * until the device becomes ready again. 
;  *
;  * If the target host is connected through an Ethernet network and if 
;  * the hardware address of that host is currently unknown, an ARP 
;  * request is sent out and the function will block until a response 
;  * is received or an ARP timeout occurs.
;  *
;  * Segments containing data or SYN and FIN flags are added to a special 
;  * queue for unacknowledged segments and will be retransmitted by the 
;  * TCP timer thread, if not acknowledged by the remote within a specific 
;  * time. The state machine will remove these segments from the queue
;  * as soon as they are acknowledged.
;  *
;  * \note This function is mainly used by the TCP state machine.
;  *       Applications typically do not call this function but 
;  *       use NutTcpSend(), which is part of the TCP socket interface.
;  *
;  * \param sock  Socket descriptor. This pointer must have been retrieved 
;  *              by calling NutTcpCreateSocket().
;  *
;  * \return 0 on success, -1 otherwise. Returning 0 does not imply that 
;  *         the data has been successfully delivered, because flow control 
;  *         and retransmission is still handled in the background.
;  */
; int NutTcpOutput(TCPSOCKET * sock, CONST u_char * data, u_short size)
; {
;     NETBUF *nb;
;     NETBUF *nb_clone = 0;
	clr R0
	clr R1
	std y+19,R1
	std y+18,R0
;     TCPHDR *th;
;     u_short csum;
;     u_char hlen;
; 
;     /*
;      * Check if anything to send at all.
;      */
;     if (size == 0
	ldd R0,y+34
	ldd R1,y+35
	tst R0
	brne L2
	tst R1
	brne L2
X0:
	ldd R30,y+30
	ldd R31,y+31
	ldd R24,z+32
	andi R24,11
	brne L2
X1:
;         && (sock->so_tx_flags & (SO_SYN | SO_FIN | SO_FORCE)) == 0)
;         return 0;
	clr R16
	clr R17
	xjmp L1
L2:
; 
;     /*
;      * Build TCP header. Add room for MAXSEG option if this is a
;      * SYN segment.
;      */
;     hlen = sizeof(TCPHDR);
	ldi R24,20
	mov R10,R24
;     if (sock->so_tx_flags & SO_SYN)
	ldd R30,y+30
	ldd R31,y+31
	ldd R2,z+32
	sbrs R2,1
	rjmp L4
X2:
;         hlen += 4;
	subi R24,252    ; addi 4
	mov R10,R24
L4:
;     if ((nb = NutNetBufAlloc(0, NBAF_TRANSPORT, hlen)) == 0) {
	mov R2,R10
	clr R3
	std y+1,R3
	std y+0,R2
	ldi R18,64
	clr R16
	clr R17
	xcall _NutNetBufAlloc
	std y+17,R17
	std y+16,R16
	cpi R16,0
	cpc R16,R17
	brne L6
X3:
;         sock->so_last_error = ENOBUFS;
	ldi R24,10055
	ldi R25,39
	ldd R30,y+30
	ldd R31,y+31
	subi R30,160  ; addi 96
	sbci R31,255
	std z+1,R25
	std z+0,R24
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L1
L6:
;     }
;     th = (TCPHDR *) nb->nb_tp.vp;
	ldd R30,y+16
	ldd R31,y+17
	ldd R12,z+11
	ldd R13,z+12
;     th->th_sport = sock->so_local_port;
	ldd R30,y+30
	ldd R31,y+31
	ldd R2,z+24
	ldd R3,z+25
	movw R30,R12
	std z+1,R3
	std z+0,R2
;     th->th_dport = sock->so_remote_port;
	ldd R30,y+30
	ldd R31,y+31
	ldd R2,z+30
	ldd R3,z+31
	movw R30,R12
	std z+3,R3
	std z+2,R2
;     th->th_x2 = 0;
	movw R24,R30
	adiw R24,12
	movw R30,R24
	ldd R24,z+0
	andi R24,240
	std z+0,R24
;     th->th_off = hlen >> 2;
	movw R24,R12
	adiw R24,12
	movw R14,R24
	mov R24,R10
	lsr R24
	lsr R24
	andi R24,15
	andi R24,#0x0F
	swap R24
	andi R24,240
	movw R30,R14
	ldd R25,z+0
	andi R25,15
	or R25,R24
	std z+0,R25
; 
;     sock->so_tx_flags &= ~SO_FORCE;
	ldd R24,y+30
	ldd R25,y+31
	adiw R24,32
	movw R14,R24
	movw R30,R24
	ldd R24,z+0
	andi R24,247
	std z+0,R24
; 
;     /*
;      * Process ACK flag.
;      */
;     th->th_seq = htonl(sock->so_tx_nxt);
	ldd R30,y+30
	ldd R31,y+31
	ldd R2,z+41
	ldd R3,z+42
	ldd R4,z+43
	ldd R5,z+44
	std y+8,R2
	std y+9,R3
	std y+10,R4
	std y+11,R5
	ldi R20,0
	ldi R21,255
	ldi R22,0
	ldi R23,0
	ldd R16,y+8
	ldd R17,y+9
	ldd R18,y+10
	ldd R19,y+11
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R2,R16
	movw R4,R18
	ldi R20,255
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R16,y+8
	ldd R17,y+9
	ldd R18,y+10
	ldd R19,y+11
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R6,R16
	movw R8,R18
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	ldi R20,0
	ldi R21,0
	ldi R22,255
	ldi R23,0
	ldd R16,y+8
	ldd R17,y+9
	ldd R18,y+10
	ldd R19,y+11
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,255
	ldd R16,y+8
	ldd R17,y+9
	ldd R18,y+10
	ldd R19,y+11
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	movw R30,R12
	std z+4,R6
	std z+5,R7
	std z+6,R8
	std z+7,R9
;     if (sock->so_tx_flags & SO_ACK) {
	ldd R30,y+30
	ldd R31,y+31
	ldd R2,z+32
	sbrs R2,4
	rjmp L8
X4:
;         th->th_flags = TH_ACK;
	ldi R24,16
	movw R30,R12
	std z+13,R24
;         sock->so_tx_flags &= ~SO_ACK;
	ldd R24,y+30
	ldd R25,y+31
	adiw R24,32
	movw R14,R24
	movw R30,R24
	ldd R24,z+0
	andi R24,239
	std z+0,R24
;         th->th_ack = htonl(sock->so_rx_nxt);
	ldd R30,y+30
	ldd R31,y+31
	subi R30,192  ; addi 64
	sbci R31,255
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	std y+12,R2
	std y+13,R3
	std y+14,R4
	std y+15,R5
	ldi R20,0
	ldi R21,255
	ldi R22,0
	ldi R23,0
	ldd R16,y+12
	ldd R17,y+13
	ldd R18,y+14
	ldd R19,y+15
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R2,R16
	movw R4,R18
	ldi R20,255
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R16,y+12
	ldd R17,y+13
	ldd R18,y+14
	ldd R19,y+15
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R6,R16
	movw R8,R18
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	ldi R20,0
	ldi R21,0
	ldi R22,255
	ldi R23,0
	ldd R16,y+12
	ldd R17,y+13
	ldd R18,y+14
	ldd R19,y+15
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,255
	ldd R16,y+12
	ldd R17,y+13
	ldd R18,y+14
	ldd R19,y+15
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	movw R30,R12
	std z+8,R6
	std z+9,R7
	std z+10,R8
	std z+11,R9
;     } else {
	xjmp L9
L8:
;         th->th_flags = 0;
	clr R2
	movw R30,R12
	std z+13,R2
;         th->th_ack = 0;
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	std z+8,R20
	std z+9,R21
	std z+10,R22
	std z+11,R23
;     }
L9:
; 
;     /*
;      * Any SYN is sent first. Add options too. We rely on the caller 
;      * not to send a SYN segment with data, because this may break
;      * some old stacks.
;      */
;     if (sock->so_tx_flags & SO_SYN) {
	ldd R30,y+30
	ldd R31,y+31
	ldd R2,z+32
	sbrs R2,1
	rjmp L10
X5:
;         u_char *cp;
;         u_short n_mss = htons(sock->so_mss);
	subi R30,174  ; addi 82
	sbci R31,255
	ldd R14,z+0
	ldd R15,z+1
	movw R24,R14
	andi R24,0
	movw R2,R24
	mov R2,R3
	clr R3
	movw R24,R14
	andi R25,0
	mov R25,R24
	clr R24
	or R24,R2
	or R25,R3
	std y+13,R25
	std y+12,R24
; 
;         th->th_flags |= TH_SYN;
	movw R24,R12
	adiw R24,13
	movw R30,R24
	ldd R24,z+0
	ori R24,2
	std z+0,R24
;         sock->so_tx_flags &= ~SO_SYN;
	ldd R24,y+30
	ldd R25,y+31
	adiw R24,32
	movw R30,R24
	ldd R24,z+0
	andi R24,253
	std z+0,R24
;         sock->so_tx_nxt++;
	ldd R24,y+30
	ldd R25,y+31
	adiw R24,41
	ldi R20,1
	ldi R21,0
	ldi R22,0
	ldi R23,0
	movw R30,R24
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	add R2,R20
	adc R3,R21
	adc R4,R22
	adc R5,R23
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
; 
;         cp = (u_char *) (th + 1);
	movw R24,R12
	adiw R24,20
	movw R14,R24
;         *cp++ = TCPOPT_MAXSEG;
	ldi R24,2
	movw R30,R14
	st Z+,R24
;         *cp++ = TCPOLEN_MAXSEG;
	ldi R24,4
	st Z+,R24
	movw R14,R30
;         *cp++ = *(u_char *)&n_mss;
	movw R30,R28
	ldd R2,z+12
	movw R30,R14
	st Z+,R2
	movw R14,R30
;         *cp = *((u_char *)(&n_mss) + 1);
	ldd R2,y+13
	std z+0,R2
;     }
	xjmp L11
L10:
; 
;     /*
;      * Next preference is sending data. Set PUSH flag.
;      */
;     else if (size) {
	ldd R0,y+34
	ldd R1,y+35
	tst R0
	brne X6
	tst R1
	brne X16
	xjmp L13
X16:
X6:
;         if ((nb = NutNetBufAlloc(nb, NBAF_APPLICATION, size)) == 0) {
	std y+1,R1
	std y+0,R0
	ldi R18,128
	ldd R16,y+16
	ldd R17,y+17
	xcall _NutNetBufAlloc
	movw R14,R16
	std y+17,R15
	std y+16,R14
	cpi R16,0
	cpc R16,R17
	brne L15
X7:
;             sock->so_last_error = ENOBUFS;
	ldi R24,10055
	ldi R25,39
	ldd R30,y+30
	ldd R31,y+31
	subi R30,160  ; addi 96
	sbci R31,255
	std z+1,R25
	std z+0,R24
;             return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L1
L15:
;         }
;         memcpy(nb->nb_ap.vp, data, size);
	ldd R0,y+34
	ldd R1,y+35
	std y+1,R1
	std y+0,R0
	ldd R18,y+32
	ldd R19,y+33
	ldd R30,y+16
	ldd R31,y+17
	ldd R16,z+15
	ldd R17,z+16
	xcall _memcpy
;         sock->so_tx_nxt += size;
	ldd R24,y+30
	ldd R25,y+31
	adiw R24,41
	ldd R2,y+34
	ldd R3,y+35
	clr R4
	clr R5
	movw R30,R24
	ldd R6,z+0
	ldd R7,z+1
	ldd R8,z+2
	ldd R9,z+3
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	std z+0,R6
	std z+1,R7
	std z+2,R8
	std z+3,R9
;         th->th_flags |= TH_PUSH;
	movw R24,R12
	adiw R24,13
	movw R10,R24
	movw R30,R24
	ldd R24,z+0
	ori R24,8
	std z+0,R24
;     }
	xjmp L14
L13:
; 
;     /*
;      * If all data sent, transmit any waiting FIN.
;      */
;     else if (sock->so_tx_flags & SO_FIN) {
	ldd R30,y+30
	ldd R31,y+31
	ldd R2,z+32
	sbrs R2,0
	rjmp L17
X8:
;         th->th_flags |= TH_FIN;
	movw R24,R12
	adiw R24,13
	movw R30,R24
	ldd R24,z+0
	ori R24,1
	std z+0,R24
;         sock->so_tx_flags &= ~SO_FIN;
	ldd R24,y+30
	ldd R25,y+31
	adiw R24,32
	movw R30,R24
	ldd R24,z+0
	andi R24,254
	std z+0,R24
;         sock->so_tx_nxt++;
	ldd R24,y+30
	ldd R25,y+31
	adiw R24,41
	movw R10,R24
	ldi R20,1
	ldi R21,0
	ldi R22,0
	ldi R23,0
	movw R30,R24
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	add R2,R20
	adc R3,R21
	adc R4,R22
	adc R5,R23
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;         //@@@printf ("[%04X]TcpOutput: sending FIN\n", (u_short) sock);
;     }
L17:
L14:
L11:
; 
;     /*
;      * We close our receiver window, if it is
;      * below the maximum segment size.
;      */
;     if (sock->so_rx_win < sock->so_mss)
	ldd R30,y+30
	ldd R31,y+31
	subi R30,174  ; addi 82
	sbci R31,255
	ldd R2,z+0
	ldd R3,z+1
	subi R30,82
	sbci R31,0
	subi R30,188  ; addi 68
	sbci R31,255
	ldd R4,z+0
	ldd R5,z+1
	cp R4,R2
	cpc R5,R3
	brsh L19
X9:
;         th->th_win = 0;
	clr R2
	clr R3
	movw R30,R12
	std z+15,R3
	std z+14,R2
	xjmp L20
L19:
;     else
;         th->th_win = htons(sock->so_rx_win);
	ldd R30,y+30
	ldd R31,y+31
	subi R30,188  ; addi 68
	sbci R31,255
	ldd R10,z+0
	ldd R11,z+1
	movw R24,R10
	andi R24,0
	movw R2,R24
	mov R2,R3
	clr R3
	movw R24,R10
	andi R25,0
	mov R25,R24
	clr R24
	or R24,R2
	or R25,R3
	movw R30,R12
	std z+15,R25
	std z+14,R24
L20:
;     th->th_sum = 0;
	clr R2
	clr R3
	movw R30,R12
	std z+17,R3
	std z+16,R2
;     th->th_urp = 0;
	std z+19,R3
	std z+18,R2
; 
;     /*
;      * Calculate TCP checksum.
;      */
;     csum =
	ldd R30,y+16
	ldd R31,y+17
	ldd R2,z+17
	ldd R3,z+18
	ldd R10,z+13
	ldd R11,z+14
	add R10,R2
	adc R11,R3
	movw R24,R10
	andi R24,0
	movw R2,R24
	mov R2,R3
	clr R3
	movw R24,R10
	andi R25,0
	mov R25,R24
	clr R24
	or R24,R2
	or R25,R3
	std y+7,R25
	std y+6,R24
	ldi R24,6
	std y+4,R24
	ldd R30,y+30
	ldd R31,y+31
	ldd R2,z+26
	ldd R3,z+27
	ldd R4,z+28
	ldd R5,z+29
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldd R16,z+20
	ldd R17,z+21
	ldd R18,z+22
	ldd R19,z+23
	xcall _NutIpPseudoChkSumPartial
;         NutIpPseudoChkSumPartial(sock->so_local_addr, sock->so_remote_addr,
;                                  IPPROTO_TCP,
;                                  htons(nb->nb_tp.sz + nb->nb_ap.sz));
;     csum = NutIpChkSumPartial(csum, th, nb->nb_tp.sz);
	ldd R30,y+16
	ldd R31,y+17
	ldd R2,z+13
	ldd R3,z+14
	std y+1,R3
	std y+0,R2
	movw R18,R12
	xcall _NutIpChkSumPartial
	movw R10,R16
;     th->th_sum = NutIpChkSum(csum, nb->nb_ap.vp, nb->nb_ap.sz);
	ldd R30,y+16
	ldd R31,y+17
	ldd R2,z+17
	ldd R3,z+18
	std y+1,R3
	std y+0,R2
	ldd R18,z+15
	ldd R19,z+16
	xcall _NutIpChkSum
	movw R14,R16
	movw R30,R12
	std z+17,R15
	std z+16,R14
; 
; #ifdef NUTDEBUG
;     if (__tcp_trf)
;         NutDumpTcpHeader(__tcp_trs, "OUT", sock, nb);
; #endif
; 
; 	/*
; 	 * To avoid a race condition in tcp state machine, the segment is first
;      * appended to the transmission que, and then sent to the network.
; 	 */
; 
;     /*
;      * Append the segment to our transmission queue.
;      */
;     //@@@printf ("[%04X]TcpOutput: size: %u, flags: %u\n", (u_short) sock, size, th->th_flags);
;     if (size || ((th->th_flags & (TH_FIN | TH_SYN)))) {
	ldd R0,y+34
	ldd R1,y+35
	tst R0
	brne L23
	tst R1
	brne L23
X10:
	ldd R24,z+13
	andi R24,3
	brne X17
	xjmp L21
X17:
X11:
L23:
;         //@@@printf ("[%04X]TcpOutput: appending nb to queue\n", (u_short) sock);
;         NETBUF *nbp;
; 
;         nb->nb_next = 0;
	clr R2
	clr R3
	ldd R30,y+16
	ldd R31,y+17
	std z+1,R3
	std z+0,R2
;         if ((nbp = sock->so_tx_nbq) == 0) {
	ldd R30,y+30
	ldd R31,y+31
	ldd R14,z+56
	ldd R15,z+57
	movw R10,R14
	tst R10
	brne L27
	tst R11
	brne L27
X12:
;             sock->so_tx_nbq = nb;
	ldd R0,y+16
	ldd R1,y+17
	std z+57,R1
	std z+56,R0
;             /*
;              * First entry, so initialize our retransmission timer.
;              * It is also set at various places in the state machine,
;              * but here is the best central point to do it. We may
;              * carefully check later, if we can remove some in the
;              * state machine.
;              */
;             sock->so_retran_time = (u_short) NutGetMillis();
	xcall _NutGetMillis
	ldd R30,y+30
	ldd R31,y+31
	subi R30,162  ; addi 94
	sbci R31,255
	std z+1,R17
	std z+0,R16
;         }
	xjmp L25
L26:
;         else {
;             while (nbp->nb_next)
;                 nbp = nbp->nb_next;
	movw R30,R10
	ldd R10,z+0
	ldd R11,z+1
L27:
	movw R30,R10
	ldd R2,z+0
	ldd R3,z+1
	tst R2
	brne L26
	tst R3
	brne L26
X13:
;             nbp->nb_next = nb;
	ldd R0,y+16
	ldd R1,y+17
	std z+1,R1
	std z+0,R0
;         }
L25:
;         if (sock->so_rtt_seq == 0)
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R30,y+30
	ldd R31,y+31
	subi R30,172  ; addi 84
	sbci R31,255
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	breq X18
	xjmp L29
X18:
X14:
;             sock->so_rtt_seq = ntohl (th->th_seq);
	movw R30,R12
	ldd R2,z+4
	ldd R3,z+5
	ldd R4,z+6
	ldd R5,z+7
	std y+12,R2
	std y+13,R3
	std y+14,R4
	std y+15,R5
	ldi R20,0
	ldi R21,255
	ldi R22,0
	ldi R23,0
	ldd R16,y+12
	ldd R17,y+13
	ldd R18,y+14
	ldd R19,y+15
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R2,R16
	movw R4,R18
	ldi R20,255
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R16,y+12
	ldd R17,y+13
	ldd R18,y+14
	ldd R19,y+15
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R6,R16
	movw R8,R18
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	ldi R20,0
	ldi R21,0
	ldi R22,255
	ldi R23,0
	ldd R16,y+12
	ldd R17,y+13
	ldd R18,y+14
	ldd R19,y+15
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,255
	ldd R16,y+12
	ldd R17,y+13
	ldd R18,y+14
	ldd R19,y+15
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldd R30,y+30
	ldd R31,y+31
	subi R30,172  ; addi 84
	sbci R31,255
	std z+0,R6
	std z+1,R7
	std z+2,R8
	std z+3,R9
L29:
;         nb_clone = NutNetBufClone (nb);
	ldd R16,y+16
	ldd R17,y+17
	xcall _NutNetBufClone
	movw R12,R16
	std y+19,R13
	std y+18,R12
;     }
	xjmp L22
L21:
;     else
;         nb_clone = nb;
	ldd R0,y+16
	ldd R1,y+17
	std y+19,R1
	std y+18,R0
L22:
; 
;     /*
;      * IP output might fail because of routing, ARP or network device 
;      * problems or because the system ran out of memory.
;      */
;     if (NutIpOutput(IPPROTO_TCP, sock->so_remote_addr, nb_clone)) 
	ldd R0,y+18
	ldd R1,y+19
	std y+3,R1
	std y+2,R0
	ldd R30,y+30
	ldd R31,y+31
	ldd R2,z+26
	ldd R3,z+27
	ldd R4,z+28
	ldd R5,z+29
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldi R16,6
	xcall _NutIpOutput
	movw R12,R16
	cpi R16,0
	cpc R16,R17
	breq L31
X15:
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L1
L31:
; 
;     NutNetBufFree (nb_clone);
	ldd R16,y+18
	ldd R17,y+19
	xcall _NutNetBufFree
;     return 0;
	clr R16
	clr R17
L1:
	.dbline 0 ; func end
	adiw R28,20
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
;             ih -> y+16
;           csum -> R14,R15
;             th -> R10,R11
;             nb -> y+28
	.even
_NutTcpReject::
	st -y,r17
	st -y,r16
	xcall push_xgsetF0FC
	sbiw R28,18
; }
; 
; 
; /*!
;  * \brief Reject an incoming segment.
;  *
;  * Send RST in response to an incoming segment, which should
;  * be rejected.
;  *
;  * The function avoids to send out a RST segment in response to 
;  * an incoming RST segment.
;  *
;  * \note This function is mainly used by the TCP state machine.
;  *       Applications typically do not call this function.
;  *
;  * \param nb Network buffer structure of the incoming segment. 
;  *           Will be released within this function.
;  *
;  * \return 0 on success, -1 otherwise.
;  */
; int NutTcpReject(NETBUF * nb)
; {
;     u_short csum;
;     IPHDR *ih = (IPHDR *) nb->nb_nw.vp;
	ldd R30,y+28
	ldd R31,y+29
	ldd R2,z+7
	ldd R3,z+8
	std y+17,R3
	std y+16,R2
;     TCPHDR *th = (TCPHDR *) nb->nb_tp.vp;
	ldd R30,y+28
	ldd R31,y+29
	ldd R10,z+11
	ldd R11,z+12
; 
;     /*
;      * Never send RST in response to RST.
;      */
;     if (th->th_flags & TH_RST) {
	movw R30,R10
	ldd R2,z+13
	sbrs R2,2
	rjmp L34
X19:
;         NutNetBufFree(nb);
	ldd R16,y+28
	ldd R17,y+29
	xcall _NutNetBufFree
;         return 0;
	clr R16
	clr R17
	xjmp L33
L34:
;     }
; 
;     /*
;      * Remove any application data and TCP header options.
;      */
;     nb->nb_ap.sz = 0;
	clr R2
	clr R3
	ldd R30,y+28
	ldd R31,y+29
	std z+18,R3
	std z+17,R2
;     nb->nb_tp.sz = sizeof(TCPHDR);
	ldi R24,20
	ldi R25,0
	std z+14,R25
	std z+13,R24
; 
;     /*
;      * Swap ports.
;      */
;     csum = th->th_sport;
	movw R30,R10
	ldd R14,z+0
	ldd R15,z+1
;     th->th_sport = th->th_dport;
	ldd R2,z+2
	ldd R3,z+3
	std z+1,R3
	std z+0,R2
;     th->th_dport = csum;
	std z+3,R15
	std z+2,R14
; 
;     /*
;      * If the incoming segment has an ACK field, the reset
;      * takes its sequence number from the ACK field of the
;      * segment, otherwise the reset has sequence number zero
;      * and the ACK field is set to the sum of the sequence
;      * number and segment length of the incoming segment.
;      */
;     if (th->th_flags & TH_ACK) {
	ldd R2,z+13
	sbrs R2,4
	rjmp L36
X20:
;         th->th_flags = TH_RST;
	ldi R24,4
	std z+13,R24
;         th->th_seq = th->th_ack;
	ldd R2,z+8
	ldd R3,z+9
	ldd R4,z+10
	ldd R5,z+11
	std z+4,R2
	std z+5,R3
	std z+6,R4
	std z+7,R5
;         th->th_ack = 0;
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	std z+8,R20
	std z+9,R21
	std z+10,R22
	std z+11,R23
;     } else {
	xjmp L37
L36:
;         if (th->th_flags & TH_SYN)
	movw R30,R10
	ldd R2,z+13
	sbrs R2,1
	rjmp L38
X21:
;             th->th_ack = htonl(ntohl(th->th_seq) + 1);
	ldd R2,z+4
	ldd R3,z+5
	ldd R4,z+6
	ldd R5,z+7
	std y+8,R2
	std y+9,R3
	std y+10,R4
	std y+11,R5
	ldi R20,0
	ldi R21,255
	ldi R22,0
	ldi R23,0
	ldd R16,y+8
	ldd R17,y+9
	ldd R18,y+10
	ldd R19,y+11
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R2,R16
	movw R4,R18
	ldi R20,255
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R16,y+8
	ldd R17,y+9
	ldd R18,y+10
	ldd R19,y+11
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R6,R16
	movw R8,R18
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	ldi R20,0
	ldi R21,0
	ldi R22,255
	ldi R23,0
	ldd R16,y+8
	ldd R17,y+9
	ldd R18,y+10
	ldd R19,y+11
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,255
	ldd R16,y+8
	ldd R17,y+9
	ldd R18,y+10
	ldd R19,y+11
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldi R20,1
	ldi R21,0
	ldi R22,0
	ldi R23,0
	add R6,R20
	adc R7,R21
	adc R8,R22
	adc R9,R23
	std y+12,R6
	std y+13,R7
	std y+14,R8
	std y+15,R9
	ldi R20,0
	ldi R21,255
	ldi R22,0
	ldi R23,0
	ldd R16,y+12
	ldd R17,y+13
	ldd R18,y+14
	ldd R19,y+15
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R2,R16
	movw R4,R18
	ldi R20,255
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R16,y+12
	ldd R17,y+13
	ldd R18,y+14
	ldd R19,y+15
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R6,R16
	movw R8,R18
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	ldi R20,0
	ldi R21,0
	ldi R22,255
	ldi R23,0
	ldd R16,y+12
	ldd R17,y+13
	ldd R18,y+14
	ldd R19,y+15
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,255
	ldd R16,y+12
	ldd R17,y+13
	ldd R18,y+14
	ldd R19,y+15
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	movw R30,R10
	std z+8,R6
	std z+9,R7
	std z+10,R8
	std z+11,R9
	xjmp L39
L38:
;         else
;             th->th_ack = th->th_seq;
	movw R30,R10
	ldd R2,z+4
	ldd R3,z+5
	ldd R4,z+6
	ldd R5,z+7
	std z+8,R2
	std z+9,R3
	std z+10,R4
	std z+11,R5
L39:
;         th->th_seq = 0;
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	movw R30,R10
	std z+4,R20
	std z+5,R21
	std z+6,R22
	std z+7,R23
;         th->th_flags = TH_RST | TH_ACK;
	ldi R24,20
	std z+13,R24
;     }
L37:
;     th->th_x2 = 0;
	movw R24,R10
	adiw R24,12
	movw R30,R24
	ldd R24,z+0
	andi R24,240
	std z+0,R24
;     th->th_off = sizeof(TCPHDR) / 4;
	movw R24,R10
	adiw R24,12
	movw R30,R24
	ldd R24,z+0
	andi R24,15
	ori R24,80
	std z+0,R24
;     th->th_win = 0;
	clr R2
	clr R3
	movw R30,R10
	std z+15,R3
	std z+14,R2
;     th->th_urp = 0;
	std z+19,R3
	std z+18,R2
; 
;     /*
;      * Calculate TCP checksum without application data.
;      */
;     th->th_sum = 0;
	std z+17,R3
	std z+16,R2
;     csum =
	ldd R30,y+28
	ldd R31,y+29
	ldd R12,z+13
	ldd R13,z+14
	movw R24,R12
	andi R24,0
	movw R2,R24
	mov R2,R3
	clr R3
	movw R24,R12
	andi R25,0
	movw R4,R24
	mov R5,R4
	clr R4
	or R4,R2
	or R5,R3
	std y+7,R5
	std y+6,R4
	ldi R24,6
	std y+4,R24
	ldd R30,y+16
	ldd R31,y+17
	ldd R2,z+12
	ldd R3,z+13
	ldd R4,z+14
	ldd R5,z+15
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldd R16,z+16
	ldd R17,z+17
	ldd R18,z+18
	ldd R19,z+19
	xcall _NutIpPseudoChkSumPartial
;         NutIpPseudoChkSumPartial(ih->ip_dst, ih->ip_src, IPPROTO_TCP, 
;                                  htons(nb->nb_tp.sz));
;     th->th_sum = NutIpChkSum(csum, th, nb->nb_tp.sz);
	ldd R30,y+28
	ldd R31,y+29
	ldd R2,z+13
	ldd R3,z+14
	std y+1,R3
	std y+0,R2
	movw R18,R10
	xcall _NutIpChkSum
	movw R14,R16
	movw R30,R10
	std z+17,R15
	std z+16,R14
; 
;     /*
;      * Sent segment back to the source.
;      */
; #ifdef NUTDEBUG
;     if (__tcp_trf)
;         NutDumpTcpHeader(__tcp_trs, "REJ", 0, nb);
; #endif
;     if(NutIpOutput(IPPROTO_TCP, ih->ip_src, nb) == 0)
	ldd R0,y+28
	ldd R1,y+29
	std y+3,R1
	std y+2,R0
	ldd R30,y+16
	ldd R31,y+17
	ldd R2,z+12
	ldd R3,z+13
	ldd R4,z+14
	ldd R5,z+15
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldi R16,6
	xcall _NutIpOutput
	movw R12,R16
	cpi R16,0
	cpc R16,R17
	brne L40
X22:
;         NutNetBufFree(nb);
	ldd R16,y+28
	ldd R17,y+29
	xcall _NutNetBufFree
L40:
;     return 0;
	clr R16
	clr R17
L33:
	.dbline 0 ; func end
	adiw R28,18
	xcall pop_xgsetF0FC
	adiw R28,2
	ret
; }
