	.module tcpsm.c
	.area data(ram, con, rel)
_tcpThread:
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.area text(rom, con, rel)
;             nb -> R1,R2
;           sock -> R0,R1
	.even
_NutTcpInputOptions:
; /*
;  * Copyright (C) 2001-2005 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  * -
;  * Portions Copyright (C) 2000 David J. Hudson <dave@humbug.demon.co.uk>
;  *
;  * This file is distributed in the hope that it will be useful, but WITHOUT
;  * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;  * FITNESS FOR A PARTICULAR PURPOSE.
;  *
;  * You can redistribute this file and/or modify it under the terms of the GNU
;  * General Public License (GPL) as published by the Free Software Foundation;
;  * either version 2 of the License, or (at your discretion) any later version.
;  * See the accompanying file "copying-gpl.txt" for more details.
;  *
;  * As a special exception to the GPL, permission is granted for additional
;  * uses of the text contained in this file.  See the accompanying file
;  * "copying-liquorice.txt" for details.
;  * -
;  * Portions Copyright (c) 1983, 1993 by
;  *  The Regents of the University of California.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the University nor the names of its contributors
;  *    may be used to endorse or promote products derived from this software
;  *    without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
;  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
;  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
;  * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
;  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
;  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
;  * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
;  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
;  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
;  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  * -
;  * Portions Copyright (c) 1993 by Digital Equipment Corporation.
;  *
;  * Permission to use, copy, modify, and distribute this software for any
;  * purpose with or without fee is hereby granted, provided that the above
;  * copyright notice and this permission notice appear in all copies, and that
;  * the name of Digital Equipment Corporation not be used in advertising or
;  * publicity pertaining to distribution of the document or software without
;  * specific, written prior permission.
;  * 
;  * THE SOFTWARE IS PROVIDED "AS IS" AND DIGITAL EQUIPMENT CORP. DISCLAIMS ALL
;  * WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES
;  * OF MERCHANTABILITY AND FITNESS.   IN NO EVENT SHALL DIGITAL EQUIPMENT
;  * CORPORATION BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
;  * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
;  * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
;  * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
;  * SOFTWARE.
;  */
; 
; /*
;  * $Log: tcpsm.c,v $
;  * Revision 1.19  2005/04/30 16:42:42  chaac
;  * Fixed bug in handling of NUTDEBUG. Added include for cfg/os.h. If NUTDEBUG
;  * is defined in NutConf, it will make effect where it is used.
;  *
;  * Revision 1.18  2005/04/05 17:44:57  haraldkipp
;  * Made stack space configurable.
;  *
;  * Revision 1.17  2005/03/30 15:17:58  mrjones4u
;  * Defussed race condition in NutTcpStateActiveOpenEvent where the NutEventWait would be called after sock->so_ac_tq had been signaled and therefore the calling thread will hang due to usage of NutEventBroadcast which will not store the signaled state. This condition can e.g. occur when attempting connection an unconnected target port on an active host. The returning RST would be processed and signaled before the NutEventWait is called.
;  *
;  * Revision 1.16  2005/02/04 17:17:49  haraldkipp
;  * Unused include files removed.
;  *
;  * Revision 1.15  2005/01/21 16:49:46  freckle
;  * Seperated calls to NutEventPostAsync between Threads and IRQs
;  *
;  * Revision 1.14  2005/01/03 08:43:29  haraldkipp
;  * Replaced unprotected calls to NutEventPostAsync() by late calls to NutEventPost().
;  * This should fix the infrequent system halts/resets. The event to the transmitter
;  * waiting queue will be broadcasted on relevant state changes.
;  *
;  * Revision 1.13  2004/07/30 19:54:46  drsung
;  * Some code of TCP stack redesigned. Round trip time calculation is now
;  * supported. Fixed several bugs in TCP state machine. Now TCP connections
;  * should be more reliable under heavy traffic or poor physical connections.
;  *
;  * Revision 1.12  2004/04/15 11:08:21  haraldkipp
;  * Bugfix: Sequence number had not been incremented on FIN segments.
;  * Added Realtek hack to reduce concurrent connection problems.
;  * Rely on TCP output to set the retransmission timer.
;  *
;  * Revision 1.11  2004/02/28 20:14:38  drsung
;  * Merge from nut-3_4-release b/c of bugfixes.
;  *
;  * Revision 1.9.2.1  2004/02/28 20:02:23  drsung
;  * Bugfix in several tcp state functions. Swapped around the check
;  * for ACK and SYN flag. Because initial SYN packets don't have
;  * an ACK flag, recevied SYN packets were never rejected.
;  * Thanks to Damian Slee, who discovered that.
;  *
;  * Revision 1.9  2004/01/25 11:50:03  drsung
;  * setting correct error code on timeout while NutTcpConnect.
;  *
;  * Revision 1.8  2004/01/25 11:29:48  drsung
;  * bugfix for connection establishing.
;  *
;  * Revision 1.7  2004/01/14 19:35:19  drsung
;  * New TCP output buffer handling and fixed not starting retransmission timer for NutTcpConnect.
;  *
;  * Revision 1.6  2003/11/28 19:49:58  haraldkipp
;  * TCP connections suddenly drop during transmission.
;  * Bug in retransmission timer fixed.
;  *
;  * Revision 1.5  2003/11/04 17:57:35  haraldkipp
;  * Bugfix: Race condition left socket in close-wait state
;  *
;  * Revision 1.4  2003/11/03 16:48:02  haraldkipp
;  * Use the system timer for retransmission timouts
;  *
;  * Revision 1.3  2003/08/14 15:10:31  haraldkipp
;  * Two bugfixes: 1. NutTcpAccept fails if caller got higher priority.
;  * 2. Incoming TCP NETBUFs will never be released if TCP is not used by
;  * the application.
;  *
;  * Revision 1.2  2003/07/13 19:22:23  haraldkipp
;  * TCP transfer speed increased by changing the character receive buffer
;  * in TCPSOCKET to a NETBUF queue. (More confusing diff lines by using
;  * indent, sorry.)
;  *
;  * Revision 1.1.1.1  2003/05/09 14:41:42  haraldkipp
;  * Initial using 3.2.1
;  *
;  * Revision 1.20  2003/05/06 18:20:02  harald
;  * Stack size reduced
;  *
;  * Revision 1.19  2003/04/01 18:36:11  harald
;  * Added forced ACK response on same sequence
;  *
;  * Revision 1.18  2003/03/31 12:29:45  harald
;  * Check NEBUF allocation
;  *
;  * Revision 1.17  2003/02/04 18:14:57  harald
;  * Version 3 released
;  *
;  * Revision 1.16  2003/01/14 16:51:29  harald
;  * Handle possible deadlock in the TCP state machine in low memory situations.
;  * Fixed: TCP might fail to process incoming packets on slow connections.
;  *
;  * Revision 1.15  2002/09/15 17:05:41  harald
;  * Silently ignore late SYNs.
;  * Detect host down in local networks during connect.
;  * Avoid re-sending packets too soon.
;  *
;  * Revision 1.14  2002/09/03 17:42:20  harald
;  * Buffer sequences received in advance
;  *
;  * Revision 1.13  2002/08/16 17:54:56  harald
;  * Count out of sequence drops
;  *
;  * Revision 1.12  2002/06/26 17:29:36  harald
;  * First pre-release with 2.4 stack
;  *
;  */
; 
; #include <cfg/os.h>
; #include <cfg/tcp.h>
; 
; #include <sys/thread.h>
; #include <sys/heap.h>
; #include <sys/event.h>
; #include <sys/timer.h>
; 
; #include <net/errno.h>
; #include <netinet/in.h>
; #include <netinet/ip.h>
; #include <net/route.h>
; #include <sys/socket.h>
; #include <netinet/tcputil.h>
; #include <netinet/tcp.h>
; 
; #ifdef NUTDEBUG
; #include <net/netdebug.h>
; #endif
; 
; #ifndef NUT_THREAD_TCPSMSTACK
; #define NUT_THREAD_TCPSMSTACK   512
; #endif
; 
; extern TCPSOCKET *tcpSocketList;
; 
; /*!
;  * \addtogroup xgTCP
;  */
; /*@{*/
; 
; HANDLE tcp_in_rdy;
; NETBUF *volatile tcp_in_nbq;
; static u_short tcp_in_cnt;
; static HANDLE tcpThread = 0;
; 
; /* ================================================================
;  * Helper functions
;  * ================================================================
;  */
; 
; /*
;  * Nothing done yet.
;  */
; static void NutTcpInputOptions(TCPSOCKET * sock, NETBUF * nb)
; {
L1:
	.dbline 0 ; func end
	ret
;            nbp -> R10,R11
;             nb -> R22,R23
;           sock -> R20,R21
	.even
_NutTcpProcessAppData:
	xcall push_xgsetF00C
	movw R22,R18
	movw R20,R16
	sbiw R28,2
; }
; 
; /*!
;  * \brief Move application data in sync from the network buffer 
;  *        structure to the socket's receive buffer.
;  *
;  * \param sock Socket descriptor. This pointer must have been 
;  *             retrieved by calling NutTcpCreateSocket().
;  * \param nb   Network buffer structure containing a TCP segment.
;  */
; static void NutTcpProcessAppData(TCPSOCKET * sock, NETBUF * nb)
; {
;     /*
;      * Add the NETBUF to the socket's input buffer.
;      */
;     if (sock->so_rx_buf) {
	movw R30,R20
	subi R30,180  ; addi 76
	sbci R31,255
	ldd R2,z+0
	ldd R3,z+1
	subi R30,76
	sbci R31,0
	tst R2
	brne X0
	tst R3
	breq L3
X0:
;         NETBUF *nbp = sock->so_rx_buf;
	subi R30,180  ; addi 76
	sbci R31,255
	ldd R10,z+0
	ldd R11,z+1
	xjmp L6
L5:
; 
;         while (nbp->nb_next)
;             nbp = nbp->nb_next;
	movw R30,R10
	ldd R10,z+0
	ldd R11,z+1
L6:
	movw R30,R10
	ldd R2,z+0
	ldd R3,z+1
	tst R2
	brne L5
	tst R3
	brne L5
X1:
;         nbp->nb_next = nb;
	std z+1,R23
	std z+0,R22
;     } else
	xjmp L4
L3:
;         sock->so_rx_buf = nb;
	movw R30,R20
	subi R30,180  ; addi 76
	sbci R31,255
	std z+1,R23
	std z+0,R22
L4:
; 
;     /*
;      * Update the number of bytes available in the socket's input buffer
;      * and the sequence number we expect next.
;      */
;     sock->so_rx_cnt += nb->nb_ap.sz;
	movw R24,R20
	subi R24,186  ; offset = 70
	sbci R25,255
	movw R30,R22
	ldd R2,z+17
	ldd R3,z+18
	movw R30,R24
	ldd R4,z+0
	ldd R5,z+1
	add R4,R2
	adc R5,R3
	std z+1,R5
	std z+0,R4
;     sock->so_rx_nxt += nb->nb_ap.sz;
	movw R24,R20
	subi R24,192  ; offset = 64
	sbci R25,255
	movw R30,R22
	ldd R2,z+17
	ldd R3,z+18
	clr R4
	clr R5
	movw R30,R24
	ldd R6,z+0
	ldd R7,z+1
	ldd R8,z+2
	ldd R9,z+3
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	std z+0,R6
	std z+1,R7
	std z+2,R8
	std z+3,R9
; 
;     /*
;      * Reduce our TCP window size.
;      */
;     if (nb->nb_ap.sz >= sock->so_rx_win)
	movw R30,R20
	subi R30,188  ; addi 68
	sbci R31,255
	ldd R2,z+0
	ldd R3,z+1
	movw R30,R22
	ldd R4,z+17
	ldd R5,z+18
	cp R4,R2
	cpc R5,R3
	brlo L8
X2:
;         sock->so_rx_win = 0;
	clr R2
	clr R3
	movw R30,R20
	subi R30,188  ; addi 68
	sbci R31,255
	std z+1,R3
	std z+0,R2
	xjmp L9
L8:
;     else
;         sock->so_rx_win -= nb->nb_ap.sz;
	movw R24,R20
	subi R24,188  ; offset = 68
	sbci R25,255
	movw R10,R24
	movw R30,R22
	ldd R2,z+17
	ldd R3,z+18
	movw R30,R24
	ldd R4,z+0
	ldd R5,z+1
	sub R4,R2
	sbc R5,R3
	std z+1,R5
	std z+0,R4
L9:
; 
;     /*
;      * Set the socket's ACK flag. This will enable ACK transmission in
;      * the next outgoing segment. If no more NETBUFs are queued, we
;      * force immediate transmission of the ACK.
;      */
;     sock->so_tx_flags |= SO_ACK;
	movw R24,R20
	adiw R24,32
	movw R10,R24
	movw R30,R24
	ldd R24,z+0
	ori R24,16
	std z+0,R24
;     if (nb->nb_next)
	movw R30,R22
	ldd R2,z+0
	ldd R3,z+1
	tst R2
	brne X3
	tst R3
	breq L10
X3:
;         nb->nb_next = 0;
	clr R2
	clr R3
	std z+1,R3
	std z+0,R2
	xjmp L11
L10:
;     else
;         sock->so_tx_flags |= SO_FORCE;
	movw R22,R20
	subi R22,224  ; offset = 32
	sbci R23,255
	movw R30,R22
	ldd R24,z+0
	ori R24,8
	std z+0,R24
L11:
; 
;     NutTcpOutput(sock, 0, 0);
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	clr R18
	clr R19
	movw R16,R20
	xcall _NutTcpOutput
L2:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgsetF00C
;            nif -> R12,R13
;            mss -> R12,R13
;            dev -> R12,R13
;             th -> R14,R15
;             ih -> R12,R13
;           sock -> R10,R11
	.even
_NutTcpProcessSyn:
	xcall push_xgsetF0FC
	movw R12,R18
	movw R10,R16
	sbiw R28,10
	ldd R14,y+20
	ldd R15,y+21
; }
; 
; /*
;  * \param sock Socket descriptor.
;  */
; static void NutTcpProcessSyn(TCPSOCKET * sock, IPHDR * ih, TCPHDR * th)
; {
;     u_short mss;
;     NUTDEVICE *dev;
;     IFNET *nif;
; 
;     sock->so_local_addr = ih->ip_dst;
	movw R30,R12
	ldd R2,z+16
	ldd R3,z+17
	ldd R4,z+18
	ldd R5,z+19
	movw R30,R10
	std z+20,R2
	std z+21,R3
	std z+22,R4
	std z+23,R5
;     sock->so_remote_port = th->th_sport;
	movw R30,R14
	ldd R2,z+0
	ldd R3,z+1
	movw R30,R10
	std z+31,R3
	std z+30,R2
;     sock->so_remote_addr = ih->ip_src;
	movw R30,R12
	ldd R2,z+12
	ldd R3,z+13
	ldd R4,z+14
	ldd R5,z+15
	movw R30,R10
	std z+26,R2
	std z+27,R3
	std z+28,R4
	std z+29,R5
; 
;     sock->so_rx_nxt = sock->so_tx_wl1 = sock->so_rx_isn = ntohl(th->th_seq);
	movw R30,R14
	ldd R2,z+4
	ldd R3,z+5
	ldd R4,z+6
	ldd R5,z+7
	std y+2,R2
	std y+3,R3
	std y+4,R4
	std y+5,R5
	ldi R20,0
	ldi R21,255
	ldi R22,0
	ldi R23,0
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R2,R16
	movw R4,R18
	ldi R20,255
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R6,R16
	movw R8,R18
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	ldi R20,0
	ldi R21,0
	ldi R22,255
	ldi R23,0
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,255
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	std y+6,R6
	std y+7,R7
	std y+8,R8
	std y+9,R9
	ldd R2,y+6
	ldd R3,y+7
	ldd R4,y+8
	ldd R5,y+9
	movw R30,R10
	std z+60,R2
	std z+61,R3
	std z+62,R4
	std z+63,R5
	std z+45,R2
	std z+46,R3
	std z+47,R4
	std z+48,R5
	subi R30,192  ; addi 64
	sbci R31,255
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
	subi R30,64
	sbci R31,0
;     sock->so_rx_nxt++;
	movw R24,R30
	subi R24,192  ; offset = 64
	sbci R25,255
	ldi R20,1
	ldi R21,0
	ldi R22,0
	ldi R23,0
	movw R30,R24
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	add R2,R20
	adc R3,R21
	adc R4,R22
	adc R5,R23
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;     sock->so_tx_win = ntohs(th->th_win);
	movw R30,R14
	ldd R4,z+14
	ldd R5,z+15
	movw R24,R4
	andi R24,0
	movw R2,R24
	mov R2,R3
	clr R3
	movw R24,R4
	andi R25,0
	mov R25,R24
	clr R24
	or R24,R2
	or R25,R3
	movw R30,R10
	std z+54,R25
	std z+53,R24
; 
;     /*
;      * To avoid unnecessary fragmentation, limit the
;      * maximum segment size to the maximum transfer
;      * unit of our interface.
;      */
;     if ((dev = NutIpRouteQuery(ih->ip_src, 0)) != 0) {
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	movw R30,R12
	ldd R16,z+12
	ldd R17,z+13
	ldd R18,z+14
	ldd R19,z+15
	xcall _NutIpRouteQuery
	movw R14,R16
	movw R12,R14
	cpi R16,0
	cpc R16,R17
	brne X8
	xjmp L13
X8:
X4:
;         nif = dev->dev_icb;
	movw R30,R12
	ldd R12,z+15
	ldd R13,z+16
;         mss = nif->if_mtu - sizeof(IPHDR) - sizeof(TCPHDR);
	movw R30,R12
	ldd R24,z+19
	ldd R25,z+20
	sbiw R24,20
	sbiw R24,20
	movw R12,R24
;         if (sock->so_mss == 0 || sock->so_mss > mss)
	movw R30,R10
	subi R30,174  ; addi 82
	sbci R31,255
	ldd R14,z+0
	ldd R15,z+1
	tst R14
	brne X5
	tst R15
	breq L17
X5:
	cp R24,R14
	cpc R25,R15
	brsh L15
X6:
L17:
;             sock->so_mss = mss;
	movw R30,R10
	subi R30,174  ; addi 82
	sbci R31,255
	std z+1,R13
	std z+0,R12
L15:
; 
;         /* Limit output buffer size to mms */
;         if (sock->so_devobsz > sock->so_mss)
	movw R30,R10
	subi R30,174  ; addi 82
	sbci R31,255
	ldd R2,z+0
	ldd R3,z+1
	subi R30,82
	sbci R31,0
	ldd R4,z+17
	ldd R5,z+18
	cp R2,R4
	cpc R3,R5
	brsh L18
X7:
;             sock->so_devobsz = sock->so_mss;
	std z+18,R3
	std z+17,R2
L18:
;     }
L13:
L12:
	.dbline 0 ; func end
	adiw R28,10
	xjmp pop_xgsetF0FC
;          h_ack -> y+4
;          h_seq -> y+0
;             nb -> R12,R13
;         length -> y+34
;             th -> R12,R13
;           sock -> y+30
	.even
_NutTcpProcessAck:
	xcall push_arg4
	xcall push_xgsetF0FC
	movw R12,R18
	sbiw R28,20
; }
; 
; /*!
;  * \brief ACK processing.
;  *
;  * \param sock Socket descriptor. This pointer must have been 
;  *             retrieved by calling NutTcpCreateSocket().
;  *
;  */
; static int NutTcpProcessAck(TCPSOCKET * sock, TCPHDR * th, u_short length)
; {
;     NETBUF *nb;
;     u_long h_seq;
;     u_long h_ack;
; 
;     /*
;      * If remote acked something not yet send, reply immediately.
;      */
;     h_ack = ntohl(th->th_ack);
	movw R30,R12
	ldd R2,z+8
	ldd R3,z+9
	ldd R4,z+10
	ldd R5,z+11
	std y+8,R2
	std y+9,R3
	std y+10,R4
	std y+11,R5
	ldi R20,0
	ldi R21,255
	ldi R22,0
	ldi R23,0
	ldd R16,y+8
	ldd R17,y+9
	ldd R18,y+10
	ldd R19,y+11
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R2,R16
	movw R4,R18
	ldi R20,255
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R16,y+8
	ldd R17,y+9
	ldd R18,y+10
	ldd R19,y+11
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R6,R16
	movw R8,R18
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	ldi R20,0
	ldi R21,0
	ldi R22,255
	ldi R23,0
	ldd R16,y+8
	ldd R17,y+9
	ldd R18,y+10
	ldd R19,y+11
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,255
	ldd R16,y+8
	ldd R17,y+9
	ldd R18,y+10
	ldd R19,y+11
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	std y+4,R6
	std y+5,R7
	std y+6,R8
	std y+7,R9
;     if (h_ack > sock->so_tx_nxt) {
	ldd R30,y+30
	ldd R31,y+31
	ldd R2,z+41
	ldd R3,z+42
	ldd R4,z+43
	ldd R5,z+44
	ldd R6,y+4
	ldd R7,y+5
	ldd R8,y+6
	ldd R9,y+7
	cp R2,R6
	cpc R3,R7
	cpc R4,R8
	cpc R5,R9
	brsh L21
X9:
;         sock->so_tx_flags |= SO_ACK | SO_FORCE;
	movw R24,R30
	adiw R24,32
	movw R30,R24
	ldd R24,z+0
	ori R24,24
	std z+0,R24
;         return 0;
	clr R16
	clr R17
	xjmp L20
L21:
;     }
; 
;     /*
;      * If the new sequence number or acknowledged sequence number
;      * is above our last update, we adjust our transmit window.
;      * Avoid dupe ACK processing on window updates.
;      */
;     if (h_ack == sock->so_tx_una) {
	ldd R30,y+30
	ldd R31,y+31
	ldd R2,z+37
	ldd R3,z+38
	ldd R4,z+39
	ldd R5,z+40
	ldd R6,y+4
	ldd R7,y+5
	ldd R8,y+6
	ldd R9,y+7
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	breq X27
	xjmp L23
X27:
X10:
;         h_seq = ntohl(th->th_seq);
	movw R30,R12
	ldd R2,z+4
	ldd R3,z+5
	ldd R4,z+6
	ldd R5,z+7
	std y+12,R2
	std y+13,R3
	std y+14,R4
	std y+15,R5
	ldi R20,0
	ldi R21,255
	ldi R22,0
	ldi R23,0
	ldd R16,y+12
	ldd R17,y+13
	ldd R18,y+14
	ldd R19,y+15
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R2,R16
	movw R4,R18
	ldi R20,255
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R16,y+12
	ldd R17,y+13
	ldd R18,y+14
	ldd R19,y+15
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R6,R16
	movw R8,R18
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	ldi R20,0
	ldi R21,0
	ldi R22,255
	ldi R23,0
	ldd R16,y+12
	ldd R17,y+13
	ldd R18,y+14
	ldd R19,y+15
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,255
	ldd R16,y+12
	ldd R17,y+13
	ldd R18,y+14
	ldd R19,y+15
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	std y+0,R6
	std y+1,R7
	std y+2,R8
	std y+3,R9
;         if (h_seq > sock->so_tx_wl1 || (h_seq == sock->so_tx_wl1 && h_ack >= sock->so_tx_wl2)) {
	ldd R30,y+30
	ldd R31,y+31
	ldd R2,z+45
	ldd R3,z+46
	ldd R4,z+47
	ldd R5,z+48
	std y+16,R2
	std y+17,R3
	std y+18,R4
	std y+19,R5
	ldd R2,y+16
	ldd R3,y+17
	ldd R4,y+18
	ldd R5,y+19
	ldd R6,y+0
	ldd R7,y+1
	ldd R8,y+2
	ldd R9,y+3
	cp R2,R6
	cpc R3,R7
	cpc R4,R8
	cpc R5,R9
	brlo L27
X11:
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	breq X28
	xjmp L25
X28:
X12:
	ldd R30,y+30
	ldd R31,y+31
	ldd R2,z+49
	ldd R3,z+50
	ldd R4,z+51
	ldd R5,z+52
	ldd R6,y+4
	ldd R7,y+5
	ldd R8,y+6
	ldd R9,y+7
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	brlo L25
X13:
L27:
;             sock->so_tx_win = ntohs(th->th_win);
	movw R30,R12
	ldd R4,z+14
	ldd R5,z+15
	movw R24,R4
	andi R24,0
	movw R2,R24
	mov R2,R3
	clr R3
	movw R24,R4
	andi R25,0
	movw R4,R24
	mov R5,R4
	clr R4
	or R4,R2
	or R5,R3
	ldd R30,y+30
	ldd R31,y+31
	std z+54,R5
	std z+53,R4
;             sock->so_tx_wl1 = h_seq;
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	std z+45,R2
	std z+46,R3
	std z+47,R4
	std z+48,R5
;             sock->so_tx_wl2 = h_ack;
	ldd R2,y+4
	ldd R3,y+5
	ldd R4,y+6
	ldd R5,y+7
	std z+49,R2
	std z+50,R3
	std z+51,R4
	std z+52,R5
;         }
L25:
;     }
L23:
; 
;     /*
;      * Ignore old ACKs but wake up sleeping transmitter threads, because
;      * the window size may have changed.
;      */
;     if (h_ack < sock->so_tx_una) {
	ldd R30,y+30
	ldd R31,y+31
	ldd R2,z+37
	ldd R3,z+38
	ldd R4,z+39
	ldd R5,z+40
	ldd R6,y+4
	ldd R7,y+5
	ldd R8,y+6
	ldd R9,y+7
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	brsh L28
X14:
;         return 0;
	clr R16
	clr R17
	xjmp L20
L28:
;     }
; 
;     /*
;      * Process duplicate ACKs.
;      */
;     if (h_ack == sock->so_tx_una) {
	ldd R30,y+30
	ldd R31,y+31
	ldd R2,z+37
	ldd R3,z+38
	ldd R4,z+39
	ldd R5,z+40
	ldd R6,y+4
	ldd R7,y+5
	ldd R8,y+6
	ldd R9,y+7
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	breq X29
	xjmp L30
X29:
X15:
;         /*
;          * Don't count, if nothing is waiting for ACK,
;          * segment contains data or on SYN/FIN segments.
;          */
;         if (sock->so_tx_nbq && length == 0 && (th->th_flags & (TH_SYN | TH_FIN)) == 0) {
	ldd R2,z+56
	ldd R3,z+57
	tst R2
	brne X16
	tst R3
	breq L32
X16:
	ldd R0,y+34
	ldd R1,y+35
	tst R0
	brne L32
	tst R1
	brne L32
X17:
	movw R30,R12
	ldd R24,z+13
	andi R24,3
	brne L32
X18:
;             /*
;              * If dupe counter reaches it's limit, resend
;              * the oldest unacknowledged netbuf.
;              */
;             if (++sock->so_tx_dup >= 3) {
	ldd R24,y+30
	ldd R25,y+31
	adiw R24,55
	movw R10,R24
	movw R30,R24
	ldd R24,z+0
	subi R24,255    ; addi 1
	mov R14,R24
	std z+0,R14
	cpi R24,3
	brlo L34
X19:
;                 sock->so_tx_dup = 0;
	clr R2
	ldd R30,y+30
	ldd R31,y+31
	std z+55,R2
; #ifdef NUTDEBUG
;                 if (__tcp_trf)
;                     NutDumpTcpHeader(__tcp_trs, "RET", sock, sock->so_tx_nbq);
; #endif
;                 /*
;                  * Retransmit first unacked packet from queue.
;                  * Actually we got much more trouble if this fails.
;                  */
;                 if (NutTcpStateRetranTimeout(sock))
	movw R16,R30
	xcall _NutTcpStateRetranTimeout
	movw R14,R16
	cpi R16,0
	cpc R16,R17
	breq L36
X20:
;                     return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L20
L36:
;             }
L34:
;         }
L32:
;         return 0;
	clr R16
	clr R17
	xjmp L20
L30:
;     }
; 
;     /*
;      * We're here, so the ACK must have actually acked something
;      */
;     sock->so_tx_dup = 0;
	clr R2
	ldd R30,y+30
	ldd R31,y+31
	std z+55,R2
;     sock->so_tx_una = h_ack;
	ldd R2,y+4
	ldd R3,y+5
	ldd R4,y+6
	ldd R5,y+7
	std z+37,R2
	std z+38,R3
	std z+39,R4
	std z+40,R5
; 
;     /*
;      * Bugfix contributed by Liu Limin: If the remote is slow and this
;      * line is missing, then Ethernut will send a full data packet even
;      * if the remote closed the window.
;      */
;     sock->so_tx_win = ntohs(th->th_win);
	movw R30,R12
	ldd R12,z+14
	ldd R13,z+15
	movw R24,R12
	andi R24,0
	movw R2,R24
	mov R2,R3
	clr R3
	movw R24,R12
	andi R25,0
	movw R4,R24
	mov R5,R4
	clr R4
	or R4,R2
	or R5,R3
	ldd R30,y+30
	ldd R31,y+31
	std z+54,R5
	std z+53,R4
; 
;     /* 
;      * Do round trip time calculation.
;      */
;     if (sock->so_rtt_seq && sock->so_rtt_seq < h_ack)
	subi R30,172  ; addi 84
	sbci R31,255
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	std y+12,R2
	std y+13,R3
	std y+14,R4
	std y+15,R5
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R2,y+12
	ldd R3,y+13
	ldd R4,y+14
	ldd R5,y+15
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	breq L38
X21:
	ldd R2,y+4
	ldd R3,y+5
	ldd R4,y+6
	ldd R5,y+7
	ldd R6,y+12
	ldd R7,y+13
	ldd R8,y+14
	ldd R9,y+15
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	brsh L38
X22:
;         NutTcpCalcRtt (sock);
	ldd R16,y+30
	ldd R17,y+31
	xcall _NutTcpCalcRtt
L38:
;     sock->so_rtt_seq = 0;
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R30,y+30
	ldd R31,y+31
	subi R30,172  ; addi 84
	sbci R31,255
	std z+0,R20
	std z+1,R21
	std z+2,R22
	std z+3,R23
	xjmp L41
L40:
;     /*
;      * Remove all acknowledged netbufs.
;      */
;     while ((nb = sock->so_tx_nbq) != 0) {
;         /* Calculate the sequence beyond this netbuf. */
;         h_seq = ntohl(((TCPHDR *) (nb->nb_tp.vp))->th_seq) + nb->nb_ap.sz;
	movw R30,R12
	ldd R26,z+11
	ldd R27,z+12
	adiw R26,4
	ld R2,x+
	ld R3,x+
	ld R4,x+
	ld R5,x
	std y+16,R2
	std y+17,R3
	std y+18,R4
	std y+19,R5
	ldi R20,0
	ldi R21,255
	ldi R22,0
	ldi R23,0
	ldd R16,y+16
	ldd R17,y+17
	ldd R18,y+18
	ldd R19,y+19
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R2,R16
	movw R4,R18
	ldi R20,255
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R16,y+16
	ldd R17,y+17
	ldd R18,y+18
	ldd R19,y+19
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R6,R16
	movw R8,R18
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	ldi R20,0
	ldi R21,0
	ldi R22,255
	ldi R23,0
	ldd R16,y+16
	ldd R17,y+17
	ldd R18,y+18
	ldd R19,y+19
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,255
	ldd R16,y+16
	ldd R17,y+17
	ldd R18,y+18
	ldd R19,y+19
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	movw R30,R12
	ldd R2,z+17
	ldd R3,z+18
	clr R4
	clr R5
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	std y+0,R6
	std y+1,R7
	std y+2,R8
	std y+3,R9
;         if (((TCPHDR *) (nb->nb_tp.vp))->th_flags & (TH_SYN | TH_FIN)) {
	push R26
	push R27
	ldd R26,z+11
	ldd R27,z+12
	movw R30,R26
	pop R27
	pop R26
	ldd R24,z+13
	andi R24,3
	breq L43
X23:
;             h_seq++;
	ldi R20,1
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	add R2,R20
	adc R3,R21
	adc R4,R22
	adc R5,R23
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
;         }
L43:
;         //@@@printf ("[%04X]*: processack, check seq#: %lu\n", (u_short) sock, h_seq);
;         if (h_seq > h_ack) {
	ldd R2,y+4
	ldd R3,y+5
	ldd R4,y+6
	ldd R5,y+7
	ldd R6,y+0
	ldd R7,y+1
	ldd R8,y+2
	ldd R9,y+3
	cp R2,R6
	cpc R3,R7
	cpc R4,R8
	cpc R5,R9
	brsh L45
X24:
;             break;
	xjmp L42
L45:
;         }
;         sock->so_tx_nbq = nb->nb_next;
	movw R30,R12
	ldd R2,z+0
	ldd R3,z+1
	ldd R30,y+30
	ldd R31,y+31
	std z+57,R3
	std z+56,R2
;         NutNetBufFree(nb);
	movw R16,R12
	xcall _NutNetBufFree
;     }
L41:
	ldd R30,y+30
	ldd R31,y+31
	ldd R14,z+56
	ldd R15,z+57
	movw R12,R14
	tst R12
	breq X30
	xjmp L40
X30:
	tst R13
	breq X31
	xjmp L40
X31:
X25:
L42:
; 
;     /*
;      * Reset retransmit timer and wake up waiting transmissions.
;      */
;     if (sock->so_tx_nbq) {
	ldd R30,y+30
	ldd R31,y+31
	ldd R2,z+56
	ldd R3,z+57
	tst R2
	brne X26
	tst R3
	breq L47
X26:
;         sock->so_retran_time = (u_short) NutGetMillis();
	xcall _NutGetMillis
	ldd R30,y+30
	ldd R31,y+31
	subi R30,162  ; addi 94
	sbci R31,255
	std z+1,R17
	std z+0,R16
;     } else {
	xjmp L48
L47:
;         sock->so_retran_time = 0;
	clr R2
	clr R3
	ldd R30,y+30
	ldd R31,y+31
	subi R30,162  ; addi 94
	sbci R31,255
	std z+1,R3
	std z+0,R2
;     }
L48:
;     sock->so_retransmits = 0;
	clr R2
	clr R3
	ldd R30,y+30
	ldd R31,y+31
	subi R30,166  ; addi 90
	sbci R31,255
	std z+1,R3
	std z+0,R2
; 
;     return 0;
	clr R16
	clr R17
L20:
	.dbline 0 ; func end
	adiw R28,20
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
;            txf -> R12
;             rc -> R20,R21
;          state -> R10
;           sock -> R22,R23
	.even
_NutTcpStateChange:
	xcall push_xgsetF0FC
	mov R10,R18
	movw R22,R16
	sbiw R28,2
; }
; 
; 
; 
; /* ================================================================
;  * State changes.
;  * ================================================================
;  */
; /*!
;  * State change, possibly inform application.
;  *
;  * \param sock  Socket descriptor.
;  * \param state New state to switch to.
;  *
;  * \return 0 on success, -1 on illegal state change attempt.
;  */
; static int NutTcpStateChange(TCPSOCKET * sock, u_char state)
; {
;     int rc = 0;
	clr R20
	clr R21
;     ureg_t txf = 0;
	clr R12
; 
;     switch (sock->so_state) {
	movw R30,R22
	ldd R14,z+19
	clr R15
	tst R14
	brne X32
	tst R15
	brne X67
	xjmp L95
X67:
X32:
	movw R24,R14
	cpi R24,1
	ldi R30,0
	cpc R25,R30
	brne X68
	xjmp L59
X68:
X33:
	cpi R24,2
	ldi R30,0
	cpc R25,R30
	brne X69
	xjmp L62
X69:
X34:
	cpi R24,3
	ldi R30,0
	cpc R25,R30
	brne X70
	xjmp L69
X70:
X35:
	cpi R24,4
	ldi R30,0
	cpc R25,R30
	breq L53
X36:
	cpi R24,5
	ldi R30,0
	cpc R25,R30
	brne X71
	xjmp L87
X71:
X37:
	cpi R24,6
	ldi R30,0
	cpc R25,R30
	brne X72
	xjmp L77
X72:
X38:
	cpi R24,7
	ldi R30,0
	cpc R25,R30
	brne X73
	xjmp L90
X73:
X39:
	cpi R24,8
	ldi R30,0
	cpc R25,R30
	brne X74
	xjmp L93
X74:
X40:
	cpi R24,9
	ldi R30,0
	cpc R25,R30
	brne X75
	xjmp L84
X75:
X41:
	cpi R24,10
	ldi R30,0
	cpc R25,R30
	brne X76
	xjmp L94
X76:
X42:
	xjmp L50
L53:
;         /* Handle the most common case first. */
;     case TCPS_ESTABLISHED:
;         switch (state) {
	mov R14,R10
	clr R15
	movw R24,R14
	cpi R24,5
	ldi R30,0
	cpc R25,R30
	breq L58
X43:
	cpi R24,6
	ldi R30,0
	cpc R25,R30
	breq L57
X44:
	xjmp L54
L57:
;         case TCPS_FIN_WAIT_1:
;             /*
;              * Closed by application.
;              */
;             sock->so_tx_flags |= SO_FIN | SO_ACK;
	movw R24,R22
	adiw R24,32
	movw R30,R24
	ldd R24,z+0
	ori R24,17
	std z+0,R24
;             txf = 1;
	clr R12
	inc R12
; 
; #ifdef RTLCONNECTHACK
;             /*
;              * Hack alert!
;              * On the RTL8019AS we got a problem. Because of not handling
;              * the CHRDY line, the controller drops outgoing packets when
;              * a browser opens multiple connections concurrently, producing
;              * several short incoming packets. Empirical test showed, that
;              * a slight delay during connects and disconnects helped to
;              * remarkably reduce this problem.
;              */
;             NutDelay(5);
; #endif
;             break;
	xjmp L51
L58:
;         case TCPS_CLOSE_WAIT:
;             /*
;              * FIN received.
;              */
;             sock->so_tx_flags |= SO_ACK | SO_FORCE;
	movw R24,R22
	adiw R24,32
	movw R30,R24
	ldd R24,z+0
	ori R24,24
	std z+0,R24
;             txf = 1;
	clr R12
	inc R12
;             break;
	xjmp L51
L54:
;         default:
;             rc = -1;
	ldi R20,-1
	ldi R21,-1
;             break;
;         }
;         break;
	xjmp L51
L59:
; 
;     case TCPS_LISTEN:
;         /*
;          * SYN received.
;          */
;         if (state == TCPS_SYN_RECEIVED) {
	mov R24,R10
	cpi R24,3
	brne L60
X45:
;             sock->so_tx_flags |= SO_SYN | SO_ACK;
	movw R24,R22
	adiw R24,32
	movw R14,R24
	movw R30,R24
	ldd R24,z+0
	ori R24,18
	std z+0,R24
;             txf = 1;
	clr R12
	inc R12
; #ifdef RTLCONNECTHACK
;             /*
;              * Hack alert!
;              * On the RTL8019AS we got a problem. Because of not handling
;              * the CHRDY line, the controller drops outgoing packets when
;              * a browser opens multiple connections concurrently, producing
;              * several short incoming packets. Empirical test showed, that
;              * a slight delay during connects and disconnects helped to
;              * remarkably reduce this problem.
;              */
;             NutDelay(5);
; #endif
;         } else
	xjmp L51
L60:
;             rc = -1;
	ldi R20,-1
	ldi R21,-1
;         break;
	xjmp L51
L62:
; 
;     case TCPS_SYN_SENT:
;         switch (state) {
	mov R14,R10
	clr R15
	movw R24,R14
	cpi R24,1
	ldi R30,0
	cpc R25,R30
	brne X77
	xjmp L51
X77:
X46:
	cpi R24,3
	ldi R30,0
	cpc R25,R30
	breq L67
X47:
	cpi R24,4
	ldi R30,0
	cpc R25,R30
	breq L68
X48:
	xjmp L63
L67:
;         case TCPS_LISTEN:
;             /*
;              * RST received on passive socket.
;              */
;             break;
;         case TCPS_SYN_RECEIVED:
;             /*
;              * SYN received.
;              */
;             sock->so_tx_flags |= SO_SYN | SO_ACK;
	movw R24,R22
	adiw R24,32
	movw R14,R24
	movw R30,R24
	ldd R24,z+0
	ori R24,18
	std z+0,R24
;             txf = 1;
	clr R12
	inc R12
;             break;
	xjmp L51
L68:
;         case TCPS_ESTABLISHED:
;             /*
;              * SYNACK received.
;              */
;             sock->so_tx_flags |= SO_ACK | SO_FORCE;
	movw R24,R22
	adiw R24,32
	movw R14,R24
	movw R30,R24
	ldd R24,z+0
	ori R24,24
	std z+0,R24
;             txf = 1;
	clr R12
	inc R12
;             break;
	xjmp L51
L63:
;         default:
;             rc = -1;
	ldi R20,-1
	ldi R21,-1
;             break;
;         }
;         break;
	xjmp L51
L69:
; 
;     case TCPS_SYN_RECEIVED:
;         switch (state) {
	mov R14,R10
	clr R15
	movw R24,R14
	cpi R24,1
	ldi R30,0
	cpc R25,R30
	brne X78
	xjmp L51
X78:
X49:
	cpi R24,4
	ldi R30,0
	cpc R25,R30
	brne X79
	xjmp L51
X79:
X50:
	cpi R24,5
	ldi R30,0
	cpc R25,R30
	breq L76
X51:
	cpi R24,6
	ldi R30,0
	cpc R25,R30
	breq L75
X52:
	xjmp L70
L75:
;         case TCPS_LISTEN:
;             /*
;              * RST received on passive socket.
;              */
;             break;
;         case TCPS_ESTABLISHED:
;             /*
;              * ACK of SYN received.
;              */
;             break;
;         case TCPS_FIN_WAIT_1:
;             /*
;              * Closed by application.
;              */
;             sock->so_tx_flags |= SO_FIN;
	movw R24,R22
	adiw R24,32
	movw R14,R24
	movw R30,R24
	ldd R24,z+0
	ori R24,1
	std z+0,R24
;             txf = 1;
	clr R12
	inc R12
;             break;
	xjmp L51
L76:
;         case TCPS_CLOSE_WAIT:
;             /*
;              * FIN received.
;              */
;             sock->so_tx_flags |= SO_FIN | SO_ACK;
	movw R24,R22
	adiw R24,32
	movw R14,R24
	movw R30,R24
	ldd R24,z+0
	ori R24,17
	std z+0,R24
;             txf = 1;
	clr R12
	inc R12
;             break;
	xjmp L51
L70:
;         default:
;             rc = -1;
	ldi R20,-1
	ldi R21,-1
;             break;
;         }
;         break;
	xjmp L51
L77:
; 
;     case TCPS_FIN_WAIT_1:
;         switch (state) {
	mov R14,R10
	clr R15
	movw R24,R14
	cpi R24,6
	ldi R30,0
	cpc R25,R30
	brne X80
	xjmp L51
X80:
X53:
	cpi R24,7
	ldi R30,0
	cpc R25,R30
	breq L82
X54:
	cpi R24,9
	ldi R30,0
	cpc R25,R30
	brne X81
	xjmp L51
X81:
X55:
	cpi R24,10
	ldi R30,0
	cpc R25,R30
	brne X82
	xjmp L51
X82:
X56:
	xjmp L78
L82:
;         case TCPS_FIN_WAIT_1:
;         case TCPS_FIN_WAIT_2:
;             /*
;              * ACK of FIN received.
;              */
;             break;
;         case TCPS_CLOSING:
;             /*
;              * FIN received.
;              */
;             sock->so_tx_flags |= SO_ACK | SO_FORCE;
	movw R24,R22
	adiw R24,32
	movw R14,R24
	movw R30,R24
	ldd R24,z+0
	ori R24,24
	std z+0,R24
;             txf = 1;
	clr R12
	inc R12
;             break;
	xjmp L51
L78:
;         case TCPS_TIME_WAIT:
;             /*
;              * FIN and ACK of FIN received.
;              */
;             break;
;         default:
;             rc = -1;
	ldi R20,-1
	ldi R21,-1
;             break;
;         }
;         break;
	xjmp L51
L84:
; 
;     case TCPS_FIN_WAIT_2:
;         /*
;          * FIN received.
;          */
;         if (state != TCPS_TIME_WAIT)
	mov R24,R10
	cpi R24,10
	breq L85
X57:
;             rc = -1;
	ldi R20,-1
	ldi R21,-1
L85:
;         sock->so_tx_flags |= SO_ACK | SO_FORCE;
	movw R24,R22
	adiw R24,32
	movw R14,R24
	movw R30,R24
	ldd R24,z+0
	ori R24,24
	std z+0,R24
;         txf = 1;
	clr R12
	inc R12
;         break;
	xjmp L51
L87:
; 
;     case TCPS_CLOSE_WAIT:
;         /*
;          * Closed by application.
;          */
;         if (state == TCPS_LAST_ACK) {
	mov R24,R10
	cpi R24,8
	brne L88
X58:
;             sock->so_tx_flags |= SO_FIN | SO_ACK;
	movw R24,R22
	adiw R24,32
	movw R14,R24
	movw R30,R24
	ldd R24,z+0
	ori R24,17
	std z+0,R24
;             txf = 1;
	clr R12
	inc R12
;         } else
	xjmp L51
L88:
;             rc = -1;
	ldi R20,-1
	ldi R21,-1
;         break;
	xjmp L51
L90:
; 
;     case TCPS_CLOSING:
;         /*
;          * ACK of FIN received.
;          */
;         if (state != TCPS_TIME_WAIT)
	mov R24,R10
	cpi R24,10
	breq L51
X59:
;             rc = -1;
	ldi R20,-1
	ldi R21,-1
;         break;
	xjmp L51
L93:
; 
;     case TCPS_LAST_ACK:
;         rc = -1;
	ldi R20,-1
	ldi R21,-1
;         break;
	xjmp L51
L94:
; 
;     case TCPS_TIME_WAIT:
;         rc = -1;
	ldi R20,-1
	ldi R21,-1
;         break;
	xjmp L51
L95:
; 
;     case TCPS_CLOSED:
;         switch (state) {
	mov R14,R10
	clr R15
	movw R24,R14
	cpi R24,1
	ldi R30,0
	cpc R25,R30
	breq L51
X60:
	cpi R24,2
	ldi R30,0
	cpc R25,R30
	breq L100
X61:
	xjmp L96
L100:
;         case TCPS_LISTEN:
;             /*
;              * Passive open by application.
;              */
;             break;
;         case TCPS_SYN_SENT:
;             /*
;              * Active open by application.
;              */
;             sock->so_tx_flags |= SO_SYN;
	movw R24,R22
	adiw R24,32
	movw R14,R24
	movw R30,R24
	ldd R24,z+0
	ori R24,2
	std z+0,R24
;             txf = 1;
	clr R12
	inc R12
;             break;
	xjmp L51
L96:
;         default:
;             rc = -1;
	ldi R20,-1
	ldi R21,-1
;             break;
;         }
;         break;
L50:
L51:
;     }
; #ifdef NUTDEBUG
;     if (__tcp_trf) {
;         fprintf(__tcp_trs, " %04x-", (u_int) sock);
;         if (rc)
;             NutDumpSockState(__tcp_trs, sock->so_state, "**ERR ", "**>");
;         NutDumpSockState(__tcp_trs, state, "[>", "]");
;     }
; #endif
; 
;     if (rc == 0) {
	cpi R20,0
	cpc R20,R21
	breq X83
	xjmp L101
X83:
X62:
;         sock->so_state = state;
	movw R30,R22
	std z+19,R10
;         if (txf && NutTcpOutput(sock, 0, 0)) {
	tst R12
	breq L103
X63:
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	clr R18
	clr R19
	movw R16,R30
	xcall _NutTcpOutput
	movw R12,R16
	cpi R16,0
	cpc R16,R17
	breq L103
X64:
;             if (state == TCPS_SYN_SENT) {
	mov R24,R10
	cpi R24,2
	brne L105
X65:
;                 rc = -1;
	ldi R20,-1
	ldi R21,-1
;                 sock->so_last_error = EHOSTDOWN;
	ldi R24,10064
	ldi R25,39
	movw R30,R22
	subi R30,160  ; addi 96
	sbci R31,255
	std z+1,R25
	std z+0,R24
	subi R30,96
	sbci R31,0
;                 NutEventPostAsync(&sock->so_ac_tq);
	movw R16,R30
	subi R16,156  ; offset = 100
	sbci R17,255
	xcall _NutEventPostAsync
;             }
L105:
;         }
L103:
;         if (state == TCPS_CLOSE_WAIT) {
	mov R24,R10
	cpi R24,5
	brne L107
X66:
;             /*
;              * Inform application.
;              */
;             NutEventBroadcast(&sock->so_rx_tq);
	movw R16,R22
	subi R16,178  ; offset = 78
	sbci R17,255
	xcall _NutEventBroadcast
;             NutEventBroadcast(&sock->so_pc_tq);
	movw R16,R22
	subi R16,158  ; offset = 98
	sbci R17,255
	xcall _NutEventBroadcast
;             NutEventBroadcast(&sock->so_ac_tq);
	movw R16,R22
	subi R16,156  ; offset = 100
	sbci R17,255
	xcall _NutEventBroadcast
;         }
L107:
;     }
L101:
;     return rc;
	movw R16,R20
L49:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgsetF0FC
;           sock -> R20,R21
	.even
_NutTcpStatePassiveOpenEvent::
	st -y,R20
	st -y,R21
	movw R20,R16
	sbiw R28,2
; }
; 
; /* ================================================================
;  * Application events.
;  * ================================================================
;  */
; /*!
;  * \brief Initiated by the application.
;  *
;  * \param sock Socket descriptor. This pointer must have been 
;  *             retrieved by calling NutTcpCreateSocket().
;  *
;  * \return 0 if granted, error code otherwise.
;  */
; int NutTcpStatePassiveOpenEvent(TCPSOCKET * sock)
; {
;     if (sock->so_state != TCPS_CLOSED)
	movw R30,R20
	ldd R2,z+19
	tst R2
	breq L110
X84:
;         return (sock->so_last_error = EISCONN);
	ldi R24,10056
	ldi R25,39
	subi R30,160  ; addi 96
	sbci R31,255
	std z+1,R25
	std z+0,R24
	ldi R16,10056
	ldi R17,39
	xjmp L109
L110:
; 
;     NutTcpStateChange(sock, TCPS_LISTEN);
	ldi R18,1
	movw R16,R20
	xcall _NutTcpStateChange
; 
;     /*
;      * Block application.
;      */
;     NutEventWait(&sock->so_pc_tq, 0);
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+0,R26
	std y+1,R27
	movw R18,R24
	movw R16,R20
	subi R16,158  ; offset = 98
	sbci R17,255
	xcall _NutEventWait
; 
;     return 0;
	clr R16
	clr R17
L109:
	.dbline 0 ; func end
	adiw R28,2
	ld R21,y+
	ld R20,y+
	ret
;           sock -> R20,R21
	.even
_NutTcpStateActiveOpenEvent::
	st -y,R20
	st -y,R21
	movw R20,R16
	sbiw R28,2
; }
; 
; /*!
;  * \brief Initiated by the application.
;  *
;  * The caller must make sure, that the socket is in closed state.
;  *
;  * \param sock Socket descriptor. This pointer must have been 
;  *             retrieved by calling NutTcpCreateSocket().
;  *
;  * \return 0 if granted, -1 otherwise.
;  */
; int NutTcpStateActiveOpenEvent(TCPSOCKET * sock)
; {
;     /*
;      * Switch state to SYN_SENT. This will
;      * transmit a SYN packet.
;      */
;     NutTcpStateChange(sock, TCPS_SYN_SENT);
	ldi R18,2
	movw R16,R20
	xcall _NutTcpStateChange
; 
;     /*
;      * Block application.
;      */
; 	 if(sock->so_state == TCPS_SYN_SENT)
	movw R30,R20
	ldd R24,z+19
	cpi R24,2
	brne L113
X85:
; 		NutEventWait(&sock->so_ac_tq, 0);
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+0,R26
	std y+1,R27
	movw R18,R24
	movw R16,R30
	subi R16,156  ; offset = 100
	sbci R17,255
	xcall _NutEventWait
L113:
; 
;     if (sock->so_state != TCPS_ESTABLISHED)
	movw R30,R20
	ldd R24,z+19
	cpi R24,4
	breq L115
X86:
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L112
L115:
; 
;     return 0;
	clr R16
	clr R17
L112:
	.dbline 0 ; func end
	adiw R28,2
	ld R21,y+
	ld R20,y+
	ret
;           sock -> R20,R21
	.even
_NutTcpStateCloseEvent::
	xcall push_xgsetF000
	movw R20,R16
; }
; 
; /*!
;  * \brief Socket close by application.
;  *
;  * If socket is in state SYN_RECEIVED or ESTABLISHED,
;  * it is changed to FINWAIT1.
;  *
;  * No further data sending is accepted.
;  * Receiving is still allowed.
;  *
;  * \param sock Socket descriptor. This pointer must have been 
;  *             retrieved by calling NutTcpCreateSocket().
;  */
; int NutTcpStateCloseEvent(TCPSOCKET * sock)
; {
;     if (sock == 0)
	cpi R20,0
	cpc R20,R21
	brne L118
X87:
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L117
L118:
; 
;     NutThreadYield();
	xcall _NutThreadYield
; 
;     switch (sock->so_state) {
	movw R30,R20
	ldd R22,z+19
	clr R23
	cpi R22,0
	cpc R22,R23
	breq L123
X88:
	cpi R22,1
	ldi R30,0
	cpc R23,R30
	breq L123
X89:
	cpi R22,2
	ldi R30,0
	cpc R23,R30
	breq L123
X90:
	cpi R22,3
	ldi R30,0
	cpc R23,R30
	breq L124
X91:
	cpi R22,4
	ldi R30,0
	cpc R23,R30
	breq L124
X92:
	cpi R22,5
	ldi R30,0
	cpc R23,R30
	breq L125
X93:
	cpi R22,6
	ldi R30,0
	cpc R23,R30
	breq L126
X94:
	cpi R22,7
	ldi R30,0
	cpc R23,R30
	breq L126
X95:
	cpi R22,8
	ldi R30,0
	cpc R23,R30
	breq L126
X96:
	cpi R22,9
	ldi R30,0
	cpc R23,R30
	breq L126
X97:
	cpi R22,10
	ldi R30,0
	cpc R23,R30
	breq L126
X98:
	xjmp L120
L123:
;     case TCPS_LISTEN:
;     case TCPS_SYN_SENT:
;     case TCPS_CLOSED:
;         /*
;          * No connection yet, immediately destroy the socket.
;          */
;         NutTcpDestroySocket(sock);
	movw R16,R20
	xcall _NutTcpDestroySocket
;         break;
	xjmp L121
L124:
; 
;     case TCPS_SYN_RECEIVED:
;     case TCPS_ESTABLISHED:
;         /*
;          * Send a FIN and wait for ACK or FIN.
;          */
;         //@@@printf ("[%04X]ESTABLISHED: going to FIN_WAIT_1\n", (u_short) sock);
;         NutTcpStateChange(sock, TCPS_FIN_WAIT_1);
	ldi R18,6
	movw R16,R20
	xcall _NutTcpStateChange
;         break;
	xjmp L121
L125:
; 
;     case TCPS_CLOSE_WAIT:
;         /* 
;          * RFC 793 is wrong. 
;          */
;         //@@@printf("[%04X]CLOSE_WAIT: going to LAST_ACK\n", (u_short) sock);
;         NutTcpStateChange(sock, TCPS_LAST_ACK);
	ldi R18,8
	movw R16,R20
	xcall _NutTcpStateChange
;         break;
	xjmp L121
L126:
; 
;     case TCPS_FIN_WAIT_1:
;     case TCPS_FIN_WAIT_2:
;     case TCPS_CLOSING:
;     case TCPS_LAST_ACK:
;     case TCPS_TIME_WAIT:
;         sock->so_last_error = EALREADY;
	ldi R24,10037
	ldi R25,39
	movw R30,R20
	subi R30,160  ; addi 96
	sbci R31,255
	std z+1,R25
	std z+0,R24
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L117
L120:
; 
;     default:
;         sock->so_last_error = ENOTCONN;
	ldi R24,10057
	ldi R25,39
	movw R30,R20
	subi R30,160  ; addi 96
	sbci R31,255
	std z+1,R25
	std z+0,R24
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L117
L121:
;     }
;     return 0;
	clr R16
	clr R17
L117:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
;           sock -> R20,R21
	.even
_NutTcpStateWindowEvent::
	st -y,R20
	st -y,R21
	movw R20,R16
	sbiw R28,2
; }
; 
; /*!
;  * \brief Initiated by the application.
;  *
;  * \param sock Socket descriptor. This pointer must have been 
;  *             retrieved by calling NutTcpCreateSocket().
;  */
; int NutTcpStateWindowEvent(TCPSOCKET * sock)
; {
;     if (sock == 0)
	cpi R20,0
	cpc R20,R21
	brne L128
X99:
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L127
L128:
;     sock->so_tx_flags |= SO_ACK | SO_FORCE;
	movw R24,R20
	adiw R24,32
	movw R30,R24
	ldd R24,z+0
	ori R24,24
	std z+0,R24
;     NutTcpOutput(sock, 0, 0);
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	clr R18
	clr R19
	movw R16,R20
	xcall _NutTcpOutput
; 
;     return 0;
	clr R16
	clr R17
L127:
	.dbline 0 ; func end
	adiw R28,2
	ld R21,y+
	ld R20,y+
	ret
;     so_tx_next -> R10,R11
;           sock -> R20,R21
	.even
_NutTcpStateRetranTimeout::
	xcall push_xgset303C
	movw R20,R16
	sbiw R28,4
; }
; 
; /* ================================================================
;  * Timeout events.
;  * ================================================================
;  */
; /*!
;  * \brief Retransmit a segment after ACK timeout.
;  *
;  * This function is called by the TCP timer.
;  *
;  * \param sock Socket descriptor. This pointer must have been 
;  *             retrieved by calling NutTcpCreateSocket().
;  * \returns Nonzero if socket was aborted due to reach of retransmit 
;  *          limit or network error.
;  *
;  */
; int NutTcpStateRetranTimeout(TCPSOCKET * sock)
; {
;     NETBUF *so_tx_next;
;     if (sock->so_retransmits++ > 7)
	movw R24,R20
	subi R24,166  ; offset = 90
	sbci R25,255
	movw R30,R24
	ldd R2,z+0
	ldd R3,z+1
	movw R24,R2
	adiw R24,1
	std z+1,R25
	std z+0,R24
	ldi R24,7
	ldi R25,0
	cp R24,R2
	cpc R25,R3
	brsh L131
X100:
;     {
;         /* Abort the socket */
;         NutTcpAbortSocket(sock, ETIMEDOUT);
	ldi R18,10060
	ldi R19,39
	movw R16,R20
	xcall _NutTcpAbortSocket
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L130
L131:
;     } else {
; #ifdef NUTDEBUG
;         if (__tcp_trf)
;             NutDumpTcpHeader(__tcp_trs, "RET", sock, sock->so_tx_nbq);
; #endif
;         /* We must save sock->so_tx_nbq->nb_next before calling NutIpOutput,
;          * because in case of error the NETBUF is release by NutIpOutput and
;          * not longer available.
;          */
;         so_tx_next = sock->so_tx_nbq->nb_next;
	movw R30,R20
	ldd R26,z+56
	ldd R27,z+57
	ld R10,x+
	ld R11,x
;         if (NutIpOutput(IPPROTO_TCP, sock->so_remote_addr, sock->so_tx_nbq)) {
	ldd R2,z+56
	ldd R3,z+57
	std y+3,R3
	std y+2,R2
	ldd R2,z+26
	ldd R3,z+27
	ldd R4,z+28
	ldd R5,z+29
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldi R16,6
	xcall _NutIpOutput
	movw R12,R16
	cpi R16,0
	cpc R16,R17
	breq L133
X101:
;             /* Adjust packet queue */
;             sock->so_tx_nbq = so_tx_next;
	movw R30,R20
	std z+57,R11
	std z+56,R10
;             /* Abort the socket */
;             NutTcpAbortSocket(sock, ENETDOWN);
	ldi R18,10050
	ldi R19,39
	movw R16,R30
	xcall _NutTcpAbortSocket
;             return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L130
L133:
;         } else {
;             /* Restart the retransmission timer. */
;             sock->so_retran_time = (u_short) NutGetMillis();
	xcall _NutGetMillis
	movw R30,R20
	subi R30,162  ; addi 94
	sbci R31,255
	std z+1,R17
	std z+0,R16
;             return 0;
	clr R16
	clr R17
L130:
	.dbline 0 ; func end
	adiw R28,4
	xjmp pop_xgset303C
;             nb -> R20,R21
;             th -> y+8
;          flags -> R22
;           sock -> R10,R11
	.even
_NutTcpStateListen:
	xcall push_xgsetF00C
	mov R22,R18
	movw R10,R16
	sbiw R28,2
	ldd R20,y+10
	ldd R21,y+11
;         }
;     }
; }
; 
; /* ================================================================
;  * Segment arrival events.
;  * ================================================================
;  */
; 
; /*!
;  * \brief
;  * Process incoming segments in listening state.
;  *
;  * Wait for a connection request from a remote socket.
;  *
;  * \param sock Socket descriptor.
;  * \param nb   Network buffer structure containing a TCP segment.
;  */
; static void NutTcpStateListen(TCPSOCKET * sock, u_char flags, TCPHDR * th, NETBUF * nb)
; {
;     /*
;      * Got a SYN segment. Store relevant data in our socket
;      * structure and switch to TCPS_SYN_RECEIVED.
;      */
;     if ((flags & (TH_SYN | TH_ACK | TH_RST)) == TH_SYN) {
	mov R24,R22
	andi R24,22
	cpi R24,2
	brne L136
X102:
;         NutTcpProcessSyn(sock, nb->nb_nw.vp, th);
	ldd R0,y+8
	ldd R1,y+9
	std y+1,R1
	std y+0,R0
	movw R30,R20
	ldd R18,z+7
	ldd R19,z+8
	movw R16,R10
	xcall _NutTcpProcessSyn
;         NutTcpStateChange(sock, TCPS_SYN_RECEIVED);
	ldi R18,3
	movw R16,R10
	xcall _NutTcpStateChange
;         NutNetBufFree(nb);
	movw R16,R20
	xcall _NutNetBufFree
;     } else
	xjmp L137
L136:
;         NutTcpReject(nb);
	movw R16,R20
	xcall _NutTcpReject
L137:
L135:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgsetF00C
;             nb -> R10,R11
;             th -> R14,R15
;          flags -> R12
;           sock -> y+22
	.even
_NutTcpStateSynSent:
	xcall push_arg4
	xcall push_xgsetF0FC
	mov R12,R18
	sbiw R28,12
	ldd R14,y+26
	ldd R15,y+27
	ldd R10,y+28
	ldd R11,y+29
; }
; 
; 
; /*!
;  * \brief Process incoming segments in SYN-SENT state.
;  *
;  * Wait for a matching connection request after having sent ours.
;  *
;  * \param sock Socket descriptor.
;  * \param nb   Network buffer structure containing a TCP segment.
;  */
; static void NutTcpStateSynSent(TCPSOCKET * sock, u_char flags, TCPHDR * th, NETBUF * nb)
; {
;     /*
;      * Validate ACK, if set.
;      */
;     if (flags & TH_ACK) {
	sbrs R12,4
	rjmp L139
X103:
;         if (!IsInLimits(ntohl(th->th_ack), sock->so_tx_isn + 1, sock->so_tx_nxt)) {
	ldd R30,y+22
	ldd R31,y+23
	ldd R2,z+41
	ldd R3,z+42
	ldd R4,z+43
	ldd R5,z+44
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
	ldi R20,1
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R2,z+33
	ldd R3,z+34
	ldd R4,z+35
	ldd R5,z+36
	add R2,R20
	adc R3,R21
	adc R4,R22
	adc R5,R23
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	movw R30,R14
	ldd R2,z+8
	ldd R3,z+9
	ldd R4,z+10
	ldd R5,z+11
	std y+8,R2
	std y+9,R3
	std y+10,R4
	std y+11,R5
	ldi R20,0
	ldi R21,255
	ldi R22,0
	ldi R23,0
	ldd R16,y+8
	ldd R17,y+9
	ldd R18,y+10
	ldd R19,y+11
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R2,R16
	movw R4,R18
	ldi R20,255
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R16,y+8
	ldd R17,y+9
	ldd R18,y+10
	ldd R19,y+11
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R6,R16
	movw R8,R18
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	ldi R20,0
	ldi R21,0
	ldi R22,255
	ldi R23,0
	ldd R16,y+8
	ldd R17,y+9
	ldd R18,y+10
	ldd R19,y+11
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,255
	ldd R16,y+8
	ldd R17,y+9
	ldd R18,y+10
	ldd R19,y+11
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	movw R16,R6
	movw R18,R8
	xcall _IsInLimits
	cpi R16,0
	cpc R16,R17
	brne L141
X104:
;             NutTcpReject(nb);
	movw R16,R10
	xcall _NutTcpReject
;             return;
	xjmp L138
L141:
;         }
;     }
L139:
; 
;     /*
;      * Handle RST flag. If we were in the LISTEN state,
;      * then we return to the LISTEN state, otherwise we
;      * abort the connection and go to the CLOSED state.
;      */
;     if (flags & TH_RST) {
	sbrs R12,2
	rjmp L143
X105:
;         if (flags & TH_ACK) {
	sbrs R12,4
	rjmp L145
X106:
;             /*if (sock->so_pc_tq)
;                 NutTcpStateChange(sock, TCPS_LISTEN);
;             else */
;                 NutTcpAbortSocket(sock, ECONNREFUSED);
	ldi R18,10061
	ldi R19,39
	ldd R16,y+22
	ldd R17,y+23
	xcall _NutTcpAbortSocket
;         }
L145:
;         NutNetBufFree(nb);
	movw R16,R10
	xcall _NutNetBufFree
;         return;
	xjmp L138
L143:
;     }
; 
;     /*
;      * Handle SYN flag. If we got a valid ACK too, then
;      * our connection is established. Otherwise enter
;      * SYNRCVD state.
;      */
;     if (flags & TH_SYN) {
	sbrs R12,1
	rjmp L147
X107:
;         NutTcpProcessSyn(sock, nb->nb_nw.vp, th);
	std y+1,R15
	std y+0,R14
	movw R30,R10
	ldd R18,z+7
	ldd R19,z+8
	ldd R16,y+22
	ldd R17,y+23
	xcall _NutTcpProcessSyn
;         if (flags & TH_ACK) {
	sbrs R12,4
	rjmp L149
X108:
;             NutTcpProcessAck(sock, th, nb->nb_ap.sz);
	movw R30,R10
	ldd R2,z+17
	ldd R3,z+18
	std y+1,R3
	std y+0,R2
	movw R18,R14
	ldd R16,y+22
	ldd R17,y+23
	xcall _NutTcpProcessAck
;             NutTcpStateChange(sock, TCPS_ESTABLISHED);
	ldi R18,4
	ldd R16,y+22
	ldd R17,y+23
	xcall _NutTcpStateChange
;             /* Wake up the actively connecting thread. */
;             NutEventPost(&sock->so_ac_tq);
	ldd R16,y+22
	ldd R17,y+23
	subi R16,156  ; offset = 100
	sbci R17,255
	xcall _NutEventPost
;         } else {
	xjmp L150
L149:
;             NutTcpStateChange(sock, TCPS_SYN_RECEIVED);
	ldi R18,3
	ldd R16,y+22
	ldd R17,y+23
	xcall _NutTcpStateChange
;         }
L150:
;     }
L147:
;     NutNetBufFree(nb);
	movw R16,R10
	xcall _NutNetBufFree
L138:
	.dbline 0 ; func end
	adiw R28,12
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
;             nb -> R14,R15
;             th -> R10,R11
;          flags -> R12
;           sock -> y+22
	.even
_NutTcpStateSynReceived:
	xcall push_arg4
	xcall push_xgsetF0FC
	mov R12,R18
	sbiw R28,12
	ldd R10,y+26
	ldd R11,y+27
	ldd R14,y+28
	ldd R15,y+29
; }
; 
; /*
;  * \brief
;  * Process incoming segments in SYN-RECEIVED state.
;  *
;  * Waiting for a confirming connection request
;  * acknowledgment after having both received
;  * and sent a connection request.
;  *
;  * \param sock Socket descriptor.
;  * \param nb   Network buffer structure containing a TCP segment.
;  */
; static void NutTcpStateSynReceived(TCPSOCKET * sock, u_char flags, TCPHDR * th, NETBUF * nb)
; {
;     /*
;      * If our previous ack receives a reset response,
;      * then we fall back to the listening state.
;      */
;     if (flags & TH_RST) {
	sbrs R12,2
	rjmp L152
X109:
;         if (sock->so_pc_tq)
	ldd R30,y+22
	ldd R31,y+23
	subi R30,158  ; addi 98
	sbci R31,255
	ldd R2,z+0
	ldd R3,z+1
	subi R30,98
	sbci R31,0
	tst R2
	brne X110
	tst R3
	breq L154
X110:
;             NutTcpStateChange(sock, TCPS_LISTEN);
	ldi R18,1
	movw R16,R30
	xcall _NutTcpStateChange
	xjmp L155
L154:
;         else 
;             NutTcpAbortSocket(sock, ECONNREFUSED);
	ldi R18,10061
	ldi R19,39
	ldd R16,y+22
	ldd R17,y+23
	xcall _NutTcpAbortSocket
L155:
;         NutNetBufFree(nb);
	movw R16,R14
	xcall _NutNetBufFree
;     	sock->so_retran_time = 0;
	clr R2
	clr R3
	ldd R30,y+22
	ldd R31,y+23
	subi R30,162  ; addi 94
	sbci R31,255
	std z+1,R3
	std z+0,R2
	subi R30,94
	sbci R31,0
;         NutTcpDiscardBuffers(sock);
	movw R16,R30
	xcall _NutTcpDiscardBuffers
;         return;
	xjmp L151
L152:
;     }
; 
;     /*
;      * Reject SYNs.
;      */
;     if (flags & TH_SYN) {
	sbrs R12,1
	rjmp L156
X111:
;         NutTcpReject(nb);
	movw R16,R14
	xcall _NutTcpReject
;         return;
	xjmp L151
L156:
;     }
; 
;     /*
;      * Silently discard segments without ACK.
;      */
;     if ((flags & TH_ACK) == 0) {
	sbrc R12,4
	rjmp L158
X112:
;         NutNetBufFree(nb);
	movw R16,R14
	xcall _NutNetBufFree
;         return;
	xjmp L151
L158:
;     }
; 
;     /*
;      * Reject out of window sequence.
;      */
;     if (!IsInLimits(ntohl(th->th_ack), sock->so_tx_una + 1, sock->so_tx_nxt)) {
	ldd R30,y+22
	ldd R31,y+23
	ldd R2,z+41
	ldd R3,z+42
	ldd R4,z+43
	ldd R5,z+44
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
	ldi R20,1
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R2,z+37
	ldd R3,z+38
	ldd R4,z+39
	ldd R5,z+40
	add R2,R20
	adc R3,R21
	adc R4,R22
	adc R5,R23
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	movw R30,R10
	ldd R2,z+8
	ldd R3,z+9
	ldd R4,z+10
	ldd R5,z+11
	std y+8,R2
	std y+9,R3
	std y+10,R4
	std y+11,R5
	ldi R20,0
	ldi R21,255
	ldi R22,0
	ldi R23,0
	ldd R16,y+8
	ldd R17,y+9
	ldd R18,y+10
	ldd R19,y+11
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R2,R16
	movw R4,R18
	ldi R20,255
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R16,y+8
	ldd R17,y+9
	ldd R18,y+10
	ldd R19,y+11
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R6,R16
	movw R8,R18
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	ldi R20,0
	ldi R21,0
	ldi R22,255
	ldi R23,0
	ldd R16,y+8
	ldd R17,y+9
	ldd R18,y+10
	ldd R19,y+11
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,255
	ldd R16,y+8
	ldd R17,y+9
	ldd R18,y+10
	ldd R19,y+11
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	movw R16,R6
	movw R18,R8
	xcall _IsInLimits
	cpi R16,0
	cpc R16,R17
	brne L160
X113:
;         NutTcpReject(nb);
	movw R16,R14
	xcall _NutTcpReject
;         return;
	xjmp L151
L160:
;     }
; 
;     /* Acknowledge processing. */
;     NutTcpProcessAck(sock, th, nb->nb_ap.sz);
	movw R30,R14
	ldd R2,z+17
	ldd R3,z+18
	std y+1,R3
	std y+0,R2
	movw R18,R10
	ldd R16,y+22
	ldd R17,y+23
	xcall _NutTcpProcessAck
; 
;     /*
;      * Even SYN segments may contain application data, which will be stored
;      * in the socket's input buffer. However, there is no need to post an
;      * event to any thread waiting for data, because our connection is not 
;      * yet established.
;      */
;     if (nb->nb_ap.sz)
	movw R30,R14
	ldd R2,z+17
	ldd R3,z+18
	tst R2
	brne X114
	tst R3
	breq L162
X114:
;         NutTcpProcessAppData(sock, nb);
	movw R18,R30
	ldd R16,y+22
	ldd R17,y+23
	xcall _NutTcpProcessAppData
	xjmp L163
L162:
;     else
;         NutNetBufFree(nb);
	movw R16,R14
	xcall _NutNetBufFree
L163:
; 
;     /*
;      * Process state change.
;      */
;     if (flags & TH_FIN) {
	sbrs R12,0
	rjmp L164
X115:
;         sock->so_rx_nxt++;
	ldd R24,y+22
	ldd R25,y+23
	subi R24,192  ; offset = 64
	sbci R25,255
	ldi R20,1
	ldi R21,0
	ldi R22,0
	ldi R23,0
	movw R30,R24
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	add R2,R20
	adc R3,R21
	adc R4,R22
	adc R5,R23
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;         NutTcpStateChange(sock, TCPS_CLOSE_WAIT);
	ldi R18,5
	ldd R16,y+22
	ldd R17,y+23
	xcall _NutTcpStateChange
;     } else {
	xjmp L165
L164:
;         NutTcpStateChange(sock, TCPS_ESTABLISHED);
	ldi R18,4
	ldd R16,y+22
	ldd R17,y+23
	xcall _NutTcpStateChange
;         NutEventPost(&sock->so_pc_tq);
	ldd R16,y+22
	ldd R17,y+23
	subi R16,158  ; offset = 98
	sbci R17,255
	xcall _NutEventPost
;         NutEventPost(&sock->so_ac_tq);
	ldd R16,y+22
	ldd R17,y+23
	subi R16,156  ; offset = 100
	sbci R17,255
	xcall _NutEventPost
;     }
L165:
L151:
	.dbline 0 ; func end
	adiw R28,12
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
;           nbqp -> R12,R13
;        thq_seq -> y+10
;         th_seq -> y+6
;            thq -> R14,R15
;            nbq -> R10,R11
;             nb -> y+38
;             th -> y+36
;          flags -> y+34
;           sock -> y+32
	.even
_NutTcpStateEstablished:
	xcall push_arg4
	xcall push_xgsetF0FC
	sbiw R28,22
; }
; 
; /*
;  * \brief Process incoming segments from established connections.
;  *
;  * Received application data will be delivered to the application
;  * until we receive a FIN segment.
;  *
;  * \param sock  Socket descriptor.
;  * \param flags TCP flags.
;  * \param th    Pointer to the TCP header within the NETBUF.
;  * \param nb    Network buffer structure containing a TCP segment.
;  *
;  * \todo We may remove the unused counter of dropped segments, which
;  *       were out of sequence.
;  */
; static void NutTcpStateEstablished(TCPSOCKET * sock, u_char flags, TCPHDR * th, NETBUF * nb)
; {
;     if (flags & TH_RST) {
	ldd R0,y+34
	sbrs R0,2
	rjmp L167
X116:
;         NutNetBufFree(nb);
	ldd R16,y+38
	ldd R17,y+39
	xcall _NutNetBufFree
;         NutTcpAbortSocket(sock, ECONNRESET);
	ldi R18,10054
	ldi R19,39
	ldd R16,y+32
	ldd R17,y+33
	xcall _NutTcpAbortSocket
;         return;
	xjmp L166
L167:
;     }
; 
;     /*
;      * Reject SYNs. Silently discard late SYNs
;      * (Thanks to Mike Cornelius).
;      */
;     if (flags & TH_SYN) {
	ldd R0,y+34
	sbrs R0,1
	rjmp L169
X117:
;         if (htonl(th->th_seq) != sock->so_rx_isn)
	ldd R30,y+36
	ldd R31,y+37
	ldd R2,z+4
	ldd R3,z+5
	ldd R4,z+6
	ldd R5,z+7
	std y+2,R2
	std y+3,R3
	std y+4,R4
	std y+5,R5
	ldi R20,0
	ldi R21,255
	ldi R22,0
	ldi R23,0
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R2,R16
	movw R4,R18
	ldi R20,255
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R6,R16
	movw R8,R18
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	ldi R20,0
	ldi R21,0
	ldi R22,255
	ldi R23,0
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,255
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldd R30,y+32
	ldd R31,y+33
	ldd R2,z+60
	ldd R3,z+61
	ldd R4,z+62
	ldd R5,z+63
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	breq L171
X118:
;             NutTcpReject(nb);
	ldd R16,y+38
	ldd R17,y+39
	xcall _NutTcpReject
	xjmp L166
L171:
;         else
;             NutNetBufFree(nb);
	ldd R16,y+38
	ldd R17,y+39
	xcall _NutNetBufFree
;         return;
	xjmp L166
L169:
;     }
; 
;     /*
;      * Silently discard segments without ACK.
;      */
;     if ((flags & TH_ACK) == 0) {
	ldd R0,y+34
	sbrc R0,4
	rjmp L173
X119:
;         NutNetBufFree(nb);
	ldd R16,y+38
	ldd R17,y+39
	xcall _NutNetBufFree
;         return;
	xjmp L166
L173:
;     }
; 
;     NutTcpProcessAck(sock, th, nb->nb_ap.sz);
	ldd R30,y+38
	ldd R31,y+39
	ldd R2,z+17
	ldd R3,z+18
	std y+1,R3
	std y+0,R2
	ldd R18,y+36
	ldd R19,y+37
	ldd R16,y+32
	ldd R17,y+33
	xcall _NutTcpProcessAck
; 
;     /*
;      * If the sequence number of the incoming segment is larger than 
;      * expected, we probably missed one or more previous segments. Let's 
;      * add this one to a linked list of segments received in advance and 
;      * hope that the missing data will arrive later.
;      */
;     if (htonl(th->th_seq) > sock->so_rx_nxt) {
	ldd R30,y+36
	ldd R31,y+37
	ldd R2,z+4
	ldd R3,z+5
	ldd R4,z+6
	ldd R5,z+7
	std y+2,R2
	std y+3,R3
	std y+4,R4
	std y+5,R5
	ldi R20,0
	ldi R21,255
	ldi R22,0
	ldi R23,0
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R2,R16
	movw R4,R18
	ldi R20,255
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R6,R16
	movw R8,R18
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	ldi R20,0
	ldi R21,0
	ldi R22,255
	ldi R23,0
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,255
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldd R30,y+32
	ldd R31,y+33
	subi R30,192  ; addi 64
	sbci R31,255
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	cp R2,R6
	cpc R3,R7
	cpc R4,R8
	cpc R5,R9
	brlo X132
	xjmp L175
X132:
X120:
;         NETBUF *nbq;
;         NETBUF **nbqp;
;         TCPHDR *thq;
;         u_long th_seq;
;         u_long thq_seq;
; 
;         if (nb->nb_ap.sz) {
	ldd R30,y+38
	ldd R31,y+39
	ldd R2,z+17
	ldd R3,z+18
	tst R2
	brne X121
	tst R3
	brne X133
	xjmp L177
X133:
X121:
;             nbq = sock->so_rx_nbq;
	ldd R30,y+32
	ldd R31,y+33
	subi R30,176  ; addi 80
	sbci R31,255
	ldd R10,z+0
	ldd R11,z+1
	subi R30,80
	sbci R31,0
;             nbqp = &sock->so_rx_nbq;
	movw R24,R30
	subi R24,176  ; offset = 80
	sbci R25,255
	movw R12,R24
	xjmp L180
L179:
;             while (nbq) {
;                 thq = (TCPHDR *) (nbq->nb_tp.vp);
	movw R30,R10
	ldd R14,z+11
	ldd R15,z+12
;                 th_seq = htonl(th->th_seq);
	ldd R30,y+36
	ldd R31,y+37
	ldd R2,z+4
	ldd R3,z+5
	ldd R4,z+6
	ldd R5,z+7
	std y+14,R2
	std y+15,R3
	std y+16,R4
	std y+17,R5
	ldi R20,0
	ldi R21,255
	ldi R22,0
	ldi R23,0
	ldd R16,y+14
	ldd R17,y+15
	ldd R18,y+16
	ldd R19,y+17
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R2,R16
	movw R4,R18
	ldi R20,255
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R16,y+14
	ldd R17,y+15
	ldd R18,y+16
	ldd R19,y+17
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R6,R16
	movw R8,R18
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	ldi R20,0
	ldi R21,0
	ldi R22,255
	ldi R23,0
	ldd R16,y+14
	ldd R17,y+15
	ldd R18,y+16
	ldd R19,y+17
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,255
	ldd R16,y+14
	ldd R17,y+15
	ldd R18,y+16
	ldd R19,y+17
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	std y+6,R6
	std y+7,R7
	std y+8,R8
	std y+9,R9
;                 thq_seq = htonl(thq->th_seq);
	movw R30,R14
	ldd R2,z+4
	ldd R3,z+5
	ldd R4,z+6
	ldd R5,z+7
	std y+18,R2
	std y+19,R3
	std y+20,R4
	std y+21,R5
	ldi R20,0
	ldi R21,255
	ldi R22,0
	ldi R23,0
	ldd R16,y+18
	ldd R17,y+19
	ldd R18,y+20
	ldd R19,y+21
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R2,R16
	movw R4,R18
	ldi R20,255
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R16,y+18
	ldd R17,y+19
	ldd R18,y+20
	ldd R19,y+21
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R6,R16
	movw R8,R18
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	ldi R20,0
	ldi R21,0
	ldi R22,255
	ldi R23,0
	ldd R16,y+18
	ldd R17,y+19
	ldd R18,y+20
	ldd R19,y+21
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,255
	ldd R16,y+18
	ldd R17,y+19
	ldd R18,y+20
	ldd R19,y+21
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	std y+10,R6
	std y+11,R7
	std y+12,R8
	std y+13,R9
;                 if (th_seq < thq_seq) {
	ldd R2,y+10
	ldd R3,y+11
	ldd R4,y+12
	ldd R5,y+13
	ldd R6,y+6
	ldd R7,y+7
	ldd R8,y+8
	ldd R9,y+9
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	brsh L182
X122:
;                     *nbqp = nb;
	movw R30,R12
	ldd R0,y+38
	ldd R1,y+39
	std z+1,R1
	std z+0,R0
;                     nb->nb_next = nbq;
	movw R30,R0
	std z+1,R11
	std z+0,R10
;                     break;
	xjmp L181
L182:
;                 }
;                 if (th_seq == thq_seq) {
	ldd R2,y+10
	ldd R3,y+11
	ldd R4,y+12
	ldd R5,y+13
	ldd R6,y+6
	ldd R7,y+7
	ldd R8,y+8
	ldd R9,y+9
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	brne L184
X123:
;                     NutNetBufFree(nb);
	ldd R16,y+38
	ldd R17,y+39
	xcall _NutNetBufFree
;                     sock->so_tx_flags |= SO_ACK | SO_FORCE;
	ldd R24,y+32
	ldd R25,y+33
	adiw R24,32
	movw R30,R24
	ldd R24,z+0
	ori R24,24
	std z+0,R24
;                     NutTcpOutput(sock, 0, 0);
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	clr R18
	clr R19
	ldd R16,y+32
	ldd R17,y+33
	xcall _NutTcpOutput
;                     return;
	xjmp L166
L184:
;                 }
;                 nbqp = &nbq->nb_next;
	movw R12,R10
;                 nbq = nbq->nb_next;
	movw R30,R10
	ldd R10,z+0
	ldd R11,z+1
;             }
L180:
	tst R10
	breq X134
	xjmp L179
X134:
	tst R11
	breq X135
	xjmp L179
X135:
X124:
L181:
;             if (nbq == 0) {
	tst R10
	brne L178
	tst R11
	brne L178
X125:
;                 *nbqp = nb;
	movw R30,R12
	ldd R0,y+38
	ldd R1,y+39
	std z+1,R1
	std z+0,R0
;                 nb->nb_next = 0;
	clr R2
	clr R3
	movw R30,R0
	std z+1,R3
	std z+0,R2
;             }
;         } else
	xjmp L178
L177:
;             NutNetBufFree(nb);
	ldd R16,y+38
	ldd R17,y+39
	xcall _NutNetBufFree
L178:
; 
;         sock->so_tx_flags |= SO_ACK | SO_FORCE;
	ldd R24,y+32
	ldd R25,y+33
	adiw R24,32
	movw R30,R24
	ldd R24,z+0
	ori R24,24
	std z+0,R24
;         NutTcpOutput(sock, 0, 0);
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	clr R18
	clr R19
	ldd R16,y+32
	ldd R17,y+33
	xcall _NutTcpOutput
;         return;
	xjmp L166
L175:
;     }
; 
;     /*
;      * Acknowledge any sequence numbers not expected, 
;      * even if they do not contain any data. Keepalive
;      * packets contain a sequence number one less
;      * than the next data expected and they do not 
;      * contain any data.
;      */
;     if (htonl(th->th_seq) != sock->so_rx_nxt) {
	ldd R30,y+36
	ldd R31,y+37
	ldd R2,z+4
	ldd R3,z+5
	ldd R4,z+6
	ldd R5,z+7
	std y+6,R2
	std y+7,R3
	std y+8,R4
	std y+9,R5
	ldi R20,0
	ldi R21,255
	ldi R22,0
	ldi R23,0
	ldd R16,y+6
	ldd R17,y+7
	ldd R18,y+8
	ldd R19,y+9
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R2,R16
	movw R4,R18
	ldi R20,255
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R16,y+6
	ldd R17,y+7
	ldd R18,y+8
	ldd R19,y+9
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R6,R16
	movw R8,R18
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	ldi R20,0
	ldi R21,0
	ldi R22,255
	ldi R23,0
	ldd R16,y+6
	ldd R17,y+7
	ldd R18,y+8
	ldd R19,y+9
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,255
	ldd R16,y+6
	ldd R17,y+7
	ldd R18,y+8
	ldd R19,y+9
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldd R30,y+32
	ldd R31,y+33
	subi R30,192  ; addi 64
	sbci R31,255
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	subi R30,64
	sbci R31,0
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	brne X136
	xjmp L188
X136:
X126:
;         sock->so_tx_flags |= SO_ACK | SO_FORCE;
	movw R24,R30
	adiw R24,32
	movw R30,R24
	ldd R24,z+0
	ori R24,24
	std z+0,R24
;         /* This seems to be unused. */
;         sock->so_oos_drop++;
	ldd R24,y+32
	ldd R25,y+33
	subi R24,146  ; offset = 110
	sbci R25,255
	movw R12,R24
	ldi R20,1
	ldi R21,0
	ldi R22,0
	ldi R23,0
	movw R30,R24
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	add R2,R20
	adc R3,R21
	adc R4,R22
	adc R5,R23
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;         NutNetBufFree(nb);
	ldd R16,y+38
	ldd R17,y+39
	xcall _NutNetBufFree
;         NutTcpOutput(sock, 0, 0);
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	clr R18
	clr R19
	ldd R16,y+32
	ldd R17,y+33
	xcall _NutTcpOutput
;     } 
	xjmp L189
L188:
; 
;     /*
;      * The sequence number is exactly what we expected.
;      */
;     else if (nb->nb_ap.sz) {
	ldd R30,y+38
	ldd R31,y+39
	ldd R2,z+17
	ldd R3,z+18
	tst R2
	brne X127
	tst R3
	brne X137
	xjmp L190
X137:
X127:
;         NutTcpProcessAppData(sock, nb);
	movw R18,R30
	ldd R16,y+32
	ldd R17,y+33
	xcall _NutTcpProcessAppData
	xjmp L193
L192:
;         /*
;          * Process segments we may have received in advance.
;          */
;         while ((nb = sock->so_rx_nbq) != 0) {
;             th = (TCPHDR *) (nb->nb_tp.vp);
	ldd R30,y+38
	ldd R31,y+39
	ldd R2,z+11
	ldd R3,z+12
	std y+37,R3
	std y+36,R2
;             if (htonl(th->th_seq) > sock->so_rx_nxt)
	movw R30,R2
	ldd R2,z+4
	ldd R3,z+5
	ldd R4,z+6
	ldd R5,z+7
	std y+10,R2
	std y+11,R3
	std y+12,R4
	std y+13,R5
	ldi R20,0
	ldi R21,255
	ldi R22,0
	ldi R23,0
	ldd R16,y+10
	ldd R17,y+11
	ldd R18,y+12
	ldd R19,y+13
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R2,R16
	movw R4,R18
	ldi R20,255
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R16,y+10
	ldd R17,y+11
	ldd R18,y+12
	ldd R19,y+13
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R6,R16
	movw R8,R18
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	ldi R20,0
	ldi R21,0
	ldi R22,255
	ldi R23,0
	ldd R16,y+10
	ldd R17,y+11
	ldd R18,y+12
	ldd R19,y+13
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,255
	ldd R16,y+10
	ldd R17,y+11
	ldd R18,y+12
	ldd R19,y+13
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldd R30,y+32
	ldd R31,y+33
	subi R30,192  ; addi 64
	sbci R31,255
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	cp R2,R6
	cpc R3,R7
	cpc R4,R8
	cpc R5,R9
	brsh L195
X128:
;                 break;
	xjmp L194
L195:
;             sock->so_rx_nbq = nb->nb_next;
	ldd R30,y+38
	ldd R31,y+39
	ldd R2,z+0
	ldd R3,z+1
	ldd R30,y+32
	ldd R31,y+33
	subi R30,176  ; addi 80
	sbci R31,255
	std z+1,R3
	std z+0,R2
;             if (htonl(th->th_seq) == sock->so_rx_nxt) {
	ldd R30,y+36
	ldd R31,y+37
	ldd R2,z+4
	ldd R3,z+5
	ldd R4,z+6
	ldd R5,z+7
	std y+14,R2
	std y+15,R3
	std y+16,R4
	std y+17,R5
	ldi R20,0
	ldi R21,255
	ldi R22,0
	ldi R23,0
	ldd R16,y+14
	ldd R17,y+15
	ldd R18,y+16
	ldd R19,y+17
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R2,R16
	movw R4,R18
	ldi R20,255
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R16,y+14
	ldd R17,y+15
	ldd R18,y+16
	ldd R19,y+17
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R6,R16
	movw R8,R18
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	ldi R20,0
	ldi R21,0
	ldi R22,255
	ldi R23,0
	ldd R16,y+14
	ldd R17,y+15
	ldd R18,y+16
	ldd R19,y+17
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,255
	ldd R16,y+14
	ldd R17,y+15
	ldd R18,y+16
	ldd R19,y+17
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldd R30,y+32
	ldd R31,y+33
	subi R30,192  ; addi 64
	sbci R31,255
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	subi R30,64
	sbci R31,0
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	brne L197
X129:
;                 NutTcpProcessAppData(sock, nb);
	ldd R18,y+38
	ldd R19,y+39
	movw R16,R30
	xcall _NutTcpProcessAppData
;                 flags |= th->th_flags;
	ldd R30,y+36
	ldd R31,y+37
	ldd R2,z+13
	ldd R0,y+34
	or R0,R2
	std y+34,R0
;             } else
	xjmp L198
L197:
;                 NutNetBufFree(nb);
	ldd R16,y+38
	ldd R17,y+39
	xcall _NutNetBufFree
L198:
;         }
L193:
	ldd R30,y+32
	ldd R31,y+33
	subi R30,176  ; addi 80
	sbci R31,255
	ldd R10,z+0
	ldd R11,z+1
	std y+39,R11
	std y+38,R10
	tst R10
	breq X138
	xjmp L192
X138:
	tst R11
	breq X139
	xjmp L192
X139:
X130:
L194:
;         /* Wake up a thread waiting for data. */
;         NutEventPost(&sock->so_rx_tq);
	ldd R16,y+32
	ldd R17,y+33
	subi R16,178  ; offset = 78
	sbci R17,255
	xcall _NutEventPost
;     } else {
	xjmp L191
L190:
;         NutNetBufFree(nb);
	ldd R16,y+38
	ldd R17,y+39
	xcall _NutNetBufFree
;         //sock->so_tx_flags |= SO_ACK | SO_FORCE;
;         //NutTcpOutput(sock, 0, 0);
;     }
L191:
L189:
;     if (flags & TH_FIN) {
	ldd R0,y+34
	sbrs R0,0
	rjmp L199
X131:
;         //@@@printf ("[%04X]ESTABLISHED: going to CLOSE_WAIT\n", (u_short) sock);
;         sock->so_rx_nxt++;
	ldd R24,y+32
	ldd R25,y+33
	subi R24,192  ; offset = 64
	sbci R25,255
	movw R12,R24
	ldi R20,1
	ldi R21,0
	ldi R22,0
	ldi R23,0
	movw R30,R24
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	add R2,R20
	adc R3,R21
	adc R4,R22
	adc R5,R23
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;         NutTcpStateChange(sock, TCPS_CLOSE_WAIT);
	ldi R18,5
	ldd R16,y+32
	ldd R17,y+33
	xcall _NutTcpStateChange
;     }
L199:
L166:
	.dbline 0 ; func end
	adiw R28,22
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
;             nb -> R14,R15
;             th -> y+12
;          flags -> R12
;           sock -> R10,R11
	.even
_NutTcpStateFinWait1:
	xcall push_xgsetF0FC
	mov R12,R18
	movw R10,R16
	sbiw R28,2
	ldd R14,y+14
	ldd R15,y+15
; }
; 
; /*
;  * \brief Process incoming segments in FIN-WAIT1 state.
;  *
;  * Waiting for a connection termination request
;  * from the remote, or an acknowledgment of the
;  * connection termination request previously sent.
;  *
;  * The application already closed the socket.
;  *
;  * \param sock Socket descriptor.
;  * \param nb   Network buffer structure containing a TCP segment.
;  *
;  * \todo The out of sync case seems to be ignored. Anyway, do we
;  *       really need to process application data in this state?
;  */
; static void NutTcpStateFinWait1(TCPSOCKET * sock, u_char flags, TCPHDR * th, NETBUF * nb)
; {
;     //@@@printf ("[%04X]FIN_WAIT_1: incomming segment, IP %04X\n", (u_short) sock, ntohs(((IPHDR*)nb->nb_nw.vp)->ip_id));
;     if (flags & TH_RST) {
	sbrs R12,2
	rjmp L202
X140:
;         NutNetBufFree(nb);
	movw R16,R14
	xcall _NutNetBufFree
;         NutTcpDestroySocket(sock);
	movw R16,R10
	xcall _NutTcpDestroySocket
;         return;
	xjmp L201
L202:
;     }
; 
;     /*
;      * Reject SYNs.
;      */
;     if (flags & TH_SYN) {
	sbrs R12,1
	rjmp L204
X141:
;         NutTcpReject(nb);
	movw R16,R14
	xcall _NutTcpReject
;         return;
	xjmp L201
L204:
;     }
; 
;     /*
;      * Silently discard segments without ACK.
;      */
;     if ((flags & TH_ACK) == 0) {
	sbrc R12,4
	rjmp L206
X142:
;         NutNetBufFree(nb);
	movw R16,R14
	xcall _NutNetBufFree
;         return;
	xjmp L201
L206:
;     }
; 
;     //@@@if (flags & TH_FIN) printf ("[%04X]FIN_WAIT_1: received FIN\n", (u_short) sock);
;     //@@@printf ("[%04X]FIN_WAIT_1: received ACK: %lu, unack: %lu, next: %lu\n", (u_short) sock, ntohl(th->th_ack), sock->so_tx_una, sock->so_tx_nxt);
;     
;     //@@@printf ("[%04X]FIN_WAIT_1:  pre processack, nbq: %04X\n", (u_short) sock, (u_short) sock->so_tx_nbq);
;     NutTcpProcessAck(sock, th, nb->nb_ap.sz);
	movw R30,R14
	ldd R2,z+17
	ldd R3,z+18
	std y+1,R3
	std y+0,R2
	ldd R18,y+12
	ldd R19,y+13
	movw R16,R10
	xcall _NutTcpProcessAck
;     //@@@printf ("[%04X]FIN_WAIT_1: post processack, nbq: %04X\n", (u_short) sock, (u_short) sock->so_tx_nbq);
; 
;     /*
;      * All segments had been acknowledged, including our FIN.
;      */
;     if (sock->so_tx_nxt == sock->so_tx_una) {
	movw R30,R10
	ldd R2,z+37
	ldd R3,z+38
	ldd R4,z+39
	ldd R5,z+40
	ldd R6,z+41
	ldd R7,z+42
	ldd R8,z+43
	ldd R9,z+44
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	brne L208
X143:
;         //@@@printf ("[%04X]FIN_WAIT_1: going to FIN_WAIT_2\n", (u_short) sock);
;         NutTcpStateChange(sock, TCPS_FIN_WAIT_2);
	ldi R18,9
	movw R16,R30
	xcall _NutTcpStateChange
;     }
L208:
; 
;     /*
;      * Process application data and release the network buffer.
;      * Is this really required?
;      */
;     if (nb->nb_ap.sz) {
	movw R30,R14
	ldd R2,z+17
	ldd R3,z+18
	tst R2
	brne X144
	tst R3
	breq L210
X144:
;         NutTcpProcessAppData(sock, nb);
	movw R18,R30
	movw R16,R10
	xcall _NutTcpProcessAppData
;         /* Wake up a thread waiting for data. */
;         NutEventPost(&sock->so_rx_tq);
	movw R16,R10
	subi R16,178  ; offset = 78
	sbci R17,255
	xcall _NutEventPost
;     }
	xjmp L211
L210:
;     else
;         NutNetBufFree(nb);
	movw R16,R14
	xcall _NutNetBufFree
L211:
; 
;     if (flags & TH_FIN) {
	sbrs R12,0
	rjmp L212
X145:
;         sock->so_rx_nxt++;
	movw R24,R10
	subi R24,192  ; offset = 64
	sbci R25,255
	ldi R20,1
	ldi R21,0
	ldi R22,0
	ldi R23,0
	movw R30,R24
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	add R2,R20
	adc R3,R21
	adc R4,R22
	adc R5,R23
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;         /* 
;          * Our FIN has been acked.
;          */
;         sock->so_time_wait = 0;
	clr R2
	clr R3
	movw R30,R10
	subi R30,164  ; addi 92
	sbci R31,255
	std z+1,R3
	std z+0,R2
	subi R30,92
	sbci R31,0
;         //@@@printf ("[%04X]FIN_WAIT_1: going to CLOSING\n", (u_short) sock);
;         if (sock->so_state == TCPS_FIN_WAIT_2)
	ldd R24,z+19
	cpi R24,9
	brne L214
X146:
;             NutTcpStateChange(sock, TCPS_TIME_WAIT);
	ldi R18,10
	movw R16,R30
	xcall _NutTcpStateChange
	xjmp L215
L214:
;         else
;             NutTcpStateChange(sock, TCPS_CLOSING);
	ldi R18,7
	movw R16,R10
	xcall _NutTcpStateChange
L215:
;     }
L212:
L201:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgsetF0FC
;             nb -> R22,R23
;             th -> y+8
;          flags -> R10
;           sock -> R20,R21
	.even
_NutTcpStateFinWait2:
	xcall push_xgsetF00C
	mov R10,R18
	movw R20,R16
	sbiw R28,2
	ldd R22,y+10
	ldd R23,y+11
; }
; 
; /*
;  * \brief Process incoming segments in FIN-WAIT2 state.
;  *
;  * Waiting for a connection termination request
;  * from the remote.
;  *
;  * The application already closed the socket.
;  *
;  * \param sock Socket descriptor.
;  * \param nb   Network buffer structure containing a TCP segment.
;  *
;  * \todo There's probably no need to process application data.
;  */
; static void NutTcpStateFinWait2(TCPSOCKET * sock, u_char flags, TCPHDR * th, NETBUF * nb)
; {
;     //@@@printf ("[%04X]FIN_WAIT_2: incomming segment, IP %04X\n", (u_short) sock, ntohs(((IPHDR*)nb->nb_nw.vp)->ip_id));
;     if (flags & TH_RST) {
	sbrs R10,2
	rjmp L217
X147:
;         NutNetBufFree(nb);
	movw R16,R22
	xcall _NutNetBufFree
;         NutTcpDestroySocket(sock);
	movw R16,R20
	xcall _NutTcpDestroySocket
;         return;
	xjmp L216
L217:
;     }
; 
;     /*
;      * Reject SYNs.
;      */
;     if (flags & TH_SYN) {
	sbrs R10,1
	rjmp L219
X148:
;         NutTcpReject(nb);
	movw R16,R22
	xcall _NutTcpReject
;         return;
	xjmp L216
L219:
;     }
; 
;     /*
;      * Silently discard segments without ACK.
;      */
;     if ((flags & TH_ACK) == 0) {
	sbrc R10,4
	rjmp L221
X149:
;         NutNetBufFree(nb);
	movw R16,R22
	xcall _NutNetBufFree
;         return;
	xjmp L216
L221:
;     }
; 
;     //@@@printf ("[%04X]FIN_WAIT_2: received ACK: %lu, unack: %lu, next: %lu\n", (u_short) sock, ntohl(th->th_ack), sock->so_tx_una, sock->so_tx_nxt);
;     /*
;      * Process acknowledge and application data and release the 
;      * network buffer.
;      */
;     NutTcpProcessAck(sock, th, nb->nb_ap.sz);
	movw R30,R22
	ldd R2,z+17
	ldd R3,z+18
	std y+1,R3
	std y+0,R2
	ldd R18,y+8
	ldd R19,y+9
	movw R16,R20
	xcall _NutTcpProcessAck
; 
;     //@@@if (sock->so_tx_nbq) printf ("[%04X]FIN_WAIT_2: xmit buffer not empty!", (u_short) sock);
;     /* Do we really need this? */
;     if (nb->nb_ap.sz) {
	movw R30,R22
	ldd R2,z+17
	ldd R3,z+18
	tst R2
	brne X150
	tst R3
	breq L223
X150:
;         NutTcpProcessAppData(sock, nb);
	movw R18,R30
	movw R16,R20
	xcall _NutTcpProcessAppData
;         /* Wake up a thread waiting for data. */
;         NutEventPost(&sock->so_rx_tq);
	movw R16,R20
	subi R16,178  ; offset = 78
	sbci R17,255
	xcall _NutEventPost
;     }
	xjmp L224
L223:
;     else
;         NutNetBufFree(nb);
	movw R16,R22
	xcall _NutNetBufFree
L224:
; 
;     if (flags & TH_FIN) {
	sbrs R10,0
	rjmp L225
X151:
;         sock->so_rx_nxt++;
	movw R24,R20
	subi R24,192  ; offset = 64
	sbci R25,255
	movw R6,R24
	ldi R24,1
	ldi R25,0
	ldi R26,0
	ldi R27,0
	movw R30,R6
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	add R2,R24
	adc R3,R25
	adc R4,R26
	adc R5,R27
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;         sock->so_time_wait = 0;
	clr R2
	clr R3
	movw R30,R20
	subi R30,164  ; addi 92
	sbci R31,255
	std z+1,R3
	std z+0,R2
	subi R30,92
	sbci R31,0
;         //@@@printf ("[%04X]FIN_WAIT_2: going to TIME_WAIT\n", (u_short) sock);
;         NutTcpStateChange(sock, TCPS_TIME_WAIT);
	ldi R18,10
	movw R16,R30
	xcall _NutTcpStateChange
;     }
L225:
L216:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgsetF00C
;             nb -> R20,R21
;             th -> y+8
;          flags -> R12
;           sock -> R10,R11
	.even
_NutTcpStateCloseWait:
	xcall push_xgset303C
	mov R12,R18
	movw R10,R16
	sbiw R28,2
	ldd R20,y+10
	ldd R21,y+11
; }
; 
; /*
;  * \brief
;  * Process incoming segments in CLOSE-WAIT state.
;  *
;  * Waiting for a connection termination request
;  * from the local application.
;  *
;  * \param sock Socket descriptor.
;  * \param nb   Network buffer structure containing a TCP segment.
;  */
; static void NutTcpStateCloseWait(TCPSOCKET * sock, u_char flags, TCPHDR * th, NETBUF * nb)
; {
;     //@@@printf ("[%04X]CLOSE_WAIT: incomming segment, IP %04X\n", (u_short) sock, ((IPHDR*)nb->nb_nw.vp)->ip_id);
;     if (flags & TH_RST) {
	sbrs R12,2
	rjmp L228
X152:
;         NutNetBufFree(nb);
	movw R16,R20
	xcall _NutNetBufFree
;         NutTcpAbortSocket(sock, ECONNRESET);
	ldi R18,10054
	ldi R19,39
	movw R16,R10
	xcall _NutTcpAbortSocket
;         return;
	xjmp L227
L228:
;     }
; 
;     /*
;      * Reject SYNs.
;      */
;     if (flags & TH_SYN) {
	sbrs R12,1
	rjmp L230
X153:
;         NutTcpReject(nb);
	movw R16,R20
	xcall _NutTcpReject
;         return;
	xjmp L227
L230:
;     }
; 
;     /*
;      * Silently discard segments without ACK.
;      */
;     if ((flags & TH_ACK) == 0) {
	sbrc R12,4
	rjmp L232
X154:
;         NutNetBufFree(nb);
	movw R16,R20
	xcall _NutNetBufFree
;         return;
	xjmp L227
L232:
;     }
; 
;     NutTcpProcessAck(sock, th, nb->nb_ap.sz);
	movw R30,R20
	ldd R2,z+17
	ldd R3,z+18
	std y+1,R3
	std y+0,R2
	ldd R18,y+8
	ldd R19,y+9
	movw R16,R10
	xcall _NutTcpProcessAck
; 
;     NutNetBufFree(nb);
	movw R16,R20
	xcall _NutNetBufFree
L227:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgset303C
;             nb -> R20,R21
;             th -> y+8
;          flags -> R10
;           sock -> R22,R23
	.even
_NutTcpStateClosing:
	xcall push_xgsetF00C
	mov R10,R18
	movw R22,R16
	sbiw R28,2
	ldd R20,y+10
	ldd R21,y+11
; }
; 
; /*
;  * \brief
;  * Process incoming segments in CLOSING state.
;  *
;  * Waiting for a connection termination request
;  * acknowledgment from the remote.
;  *
;  * The application already closed the socket.
;  *
;  * \param sock Socket descriptor.
;  * \param nb   Network buffer structure containing a TCP segment.
;  */
; static void NutTcpStateClosing(TCPSOCKET * sock, u_char flags, TCPHDR * th, NETBUF * nb)
; {
;     //@@@printf ("[%04X]CLOSING: Incomming segment\n", (u_short) sock);
;     if (flags & TH_RST) {
	sbrs R10,2
	rjmp L235
X155:
;         NutNetBufFree(nb);
	movw R16,R20
	xcall _NutNetBufFree
;         NutTcpDestroySocket(sock);
	movw R16,R22
	xcall _NutTcpDestroySocket
;         return;
	xjmp L234
L235:
;     }
; 
;     /*
;      * Reject SYNs.
;      */
;     if (flags & TH_SYN) {
	sbrs R10,1
	rjmp L237
X156:
;         NutTcpReject(nb);
	movw R16,R20
	xcall _NutTcpReject
;         return;
	xjmp L234
L237:
;     }
; 
;     /*
;      * Silently discard segments without ACK.
;      */
;     if ((flags & TH_ACK) == 0) {
	sbrc R10,4
	rjmp L239
X157:
;         NutNetBufFree(nb);
	movw R16,R20
	xcall _NutNetBufFree
;         return;
	xjmp L234
L239:
;     }
; 
;     NutTcpProcessAck(sock, th, nb->nb_ap.sz);
	movw R30,R20
	ldd R2,z+17
	ldd R3,z+18
	std y+1,R3
	std y+0,R2
	ldd R18,y+8
	ldd R19,y+9
	movw R16,R22
	xcall _NutTcpProcessAck
; 
;     /*
;      * All segments had been acknowledged, including our FIN.
;      */
;     if (sock->so_tx_nxt == sock->so_tx_una) {
	movw R30,R22
	ldd R2,z+37
	ldd R3,z+38
	ldd R4,z+39
	ldd R5,z+40
	ldd R6,z+41
	ldd R7,z+42
	ldd R8,z+43
	ldd R9,z+44
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	brne L241
X158:
;         sock->so_time_wait = 0;
	clr R2
	clr R3
	subi R30,164  ; addi 92
	sbci R31,255
	std z+1,R3
	std z+0,R2
	subi R30,92
	sbci R31,0
;         NutTcpStateChange(sock, TCPS_TIME_WAIT);
	ldi R18,10
	movw R16,R30
	xcall _NutTcpStateChange
;         //@@@printf ("[%04X]CLOSING: Going to TIME_WAIT\n", (u_short) sock);
;     }
L241:
;     //@@@else printf ("[%04X]CLOSING: NOT changing state\n", (u_short) sock);
; 
;     NutNetBufFree(nb);
	movw R16,R20
	xcall _NutNetBufFree
L234:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgsetF00C
;             nb -> R22,R23
;             th -> y+8
;          flags -> R10
;           sock -> R20,R21
	.even
_NutTcpStateLastAck:
	xcall push_xgsetF00C
	mov R10,R18
	movw R20,R16
	sbiw R28,2
	ldd R22,y+10
	ldd R23,y+11
; }
; 
; /*!
;  * \brief
;  * Process incoming segment in LAST_ACK state.
;  *
;  * Waiting for an acknowledgment of the connection termination
;  * request previously sent.
;  *
;  * The application already closed the socket.
;  *
;  * \param sock  Socket descriptor.
;  * \param flags TCP flags of incoming segment.
;  * \param th    TCP header of incoming segment.
;  * \param nb    Network buffer structure containing a TCP segment.
;  */
; static void NutTcpStateLastAck(TCPSOCKET * sock, u_char flags, TCPHDR * th, NETBUF * nb)
; {
;     //@@@printf ("[%04X]LAST_ACK: incomming segment, IP %04X\n", (u_short) sock, ((IPHDR*)nb->nb_nw.vp)->ip_id);
;     if (flags & TH_RST) {
	sbrs R10,2
	rjmp L244
X159:
;         NutNetBufFree(nb);
	movw R16,R22
	xcall _NutNetBufFree
;         NutTcpDestroySocket(sock);
	movw R16,R20
	xcall _NutTcpDestroySocket
;         return;
	xjmp L243
L244:
;     }
; 
;     /*
;      * Reject SYNs.
;      */
;     if (flags & TH_SYN) {
	sbrs R10,1
	rjmp L246
X160:
;         NutTcpReject(nb);
	movw R16,R22
	xcall _NutTcpReject
;         return;
	xjmp L243
L246:
;     }
; 
;     /*
;      * Silently discard segments without ACK.
;      */
;     if ((flags & TH_ACK) == 0) {
	sbrc R10,4
	rjmp L248
X161:
;         NutNetBufFree(nb);
	movw R16,R22
	xcall _NutNetBufFree
;         return;
	xjmp L243
L248:
;     }
; 
;     NutTcpProcessAck(sock, th, nb->nb_ap.sz);
	movw R30,R22
	ldd R2,z+17
	ldd R3,z+18
	std y+1,R3
	std y+0,R2
	ldd R18,y+8
	ldd R19,y+9
	movw R16,R20
	xcall _NutTcpProcessAck
;     NutNetBufFree(nb);
	movw R16,R22
	xcall _NutNetBufFree
; 
;     if (sock->so_tx_nxt == sock->so_tx_una) 
	movw R30,R20
	ldd R2,z+37
	ldd R3,z+38
	ldd R4,z+39
	ldd R5,z+40
	ldd R6,z+41
	ldd R7,z+42
	ldd R8,z+43
	ldd R9,z+44
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	brne L250
X162:
;         NutTcpDestroySocket(sock);
	movw R16,R30
	xcall _NutTcpDestroySocket
L250:
L243:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgsetF00C
;         tx_una -> y+8
;         tx_win -> y+4
;          flags -> R10
;             th -> R12,R13
;             nb -> R20,R21
;           sock -> R22,R23
	.even
_NutTcpStateProcess:
	xcall push_xgsetF0FC
	movw R20,R18
	movw R22,R16
	sbiw R28,12
;     //@@@else printf ("[%04X]LAST_ACK: no destroy sock\n", (u_short) sock);
; }
; 
; /*!
;  * \brief Process incoming TCP segments.
;  *
;  * Processing is based on the current state of the socket connection.
;  *
;  * \param sock Socket descriptor. This pointer must have been 
;  *             retrieved by calling NutTcpCreateSocket().
;  * \param nb   Network buffer structure containing a TCP segment.
;  *             Will be released within this routine.
;  */
; static void NutTcpStateProcess(TCPSOCKET * sock, NETBUF * nb)
; {
;     u_long tx_win;
;     u_long tx_una;
;     TCPHDR *th = (TCPHDR *) nb->nb_tp.vp;
	movw R30,R20
	ldd R12,z+11
	ldd R13,z+12
;     u_char flags = th->th_flags;
	movw R30,R12
	ldd R10,z+13
; 
; #ifdef NUTDEBUG
;     if (__tcp_trf) {
;         fprintf(__tcp_trs, " %04x-", (u_int) sock);
;         NutDumpSockState(__tcp_trs, sock->so_state, "[", ">]");
;     }
; #endif
;     switch (sock->so_state) {
	movw R30,R22
	ldd R14,z+19
	clr R15
	tst R14
	brne X163
	tst R15
	brne X177
	xjmp L270
X177:
X163:
	movw R24,R14
	cpi R24,1
	ldi R30,0
	cpc R25,R30
	brne X178
	xjmp L261
X178:
X164:
	cpi R24,2
	ldi R30,0
	cpc R25,R30
	brne X179
	xjmp L262
X179:
X165:
	cpi R24,3
	ldi R30,0
	cpc R25,R30
	brne X180
	xjmp L263
X180:
X166:
	cpi R24,4
	ldi R30,0
	cpc R25,R30
	breq L256
X167:
	cpi R24,5
	ldi R30,0
	cpc R25,R30
	brne X181
	xjmp L266
X181:
X168:
	cpi R24,6
	ldi R30,0
	cpc R25,R30
	brne X182
	xjmp L264
X182:
X169:
	cpi R24,7
	ldi R30,0
	cpc R25,R30
	brne X183
	xjmp L267
X183:
X170:
	cpi R24,8
	ldi R30,0
	cpc R25,R30
	brne X184
	xjmp L268
X184:
X171:
	cpi R24,9
	ldi R30,0
	cpc R25,R30
	brne X185
	xjmp L265
X185:
X172:
	cpi R24,10
	ldi R30,0
	cpc R25,R30
	brne X186
	xjmp L269
X186:
X173:
	xjmp L253
L256:
;         /* Handle the most common case first. */
;     case TCPS_ESTABLISHED:
;         tx_win = sock->so_tx_win;
	movw R30,R22
	ldd R2,z+53
	ldd R3,z+54
	clr R4
	clr R5
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
;         tx_una = sock->so_tx_una;
	ldd R2,z+37
	ldd R3,z+38
	ldd R4,z+39
	ldd R5,z+40
	std y+8,R2
	std y+9,R3
	std y+10,R4
	std y+11,R5
;         NutTcpStateEstablished(sock, flags, th, nb);
	std y+3,R21
	std y+2,R20
	std y+1,R13
	std y+0,R12
	mov R18,R10
	movw R16,R30
	xcall _NutTcpStateEstablished
;         /* Wake up all threads waiting for transmit, if something interesting happened. */
;         if(sock->so_state != TCPS_ESTABLISHED || /* Status changed. */
	movw R30,R22
	ldd R24,z+19
	cpi R24,4
	brne L260
X174:
	ldd R2,y+4
	ldd R3,y+5
	ldd R4,y+6
	ldd R5,y+7
	ldd R6,z+53
	ldd R7,z+54
	clr R8
	clr R9
	cp R2,R6
	cpc R3,R7
	cpc R4,R8
	cpc R5,R9
	brlo L260
X175:
	ldd R2,y+8
	ldd R3,y+9
	ldd R4,y+10
	ldd R5,y+11
	ldd R6,z+37
	ldd R7,z+38
	ldd R8,z+39
	ldd R9,z+40
	cp R2,R6
	cpc R3,R7
	cpc R4,R8
	cpc R5,R9
	brlo X187
	xjmp L254
X187:
X176:
L260:
;            sock->so_tx_win > tx_win ||           /* Windows changed. */
;            sock->so_tx_una > tx_una) {           /* Unacknowledged data changed. */
;             NutEventBroadcast(&sock->so_tx_tq);
	movw R16,R22
	subi R16,198  ; offset = 58
	sbci R17,255
	xcall _NutEventBroadcast
;         }
;         break;
	xjmp L254
L261:
;     case TCPS_LISTEN:
;         NutTcpStateListen(sock, flags, th, nb);
	std y+3,R21
	std y+2,R20
	std y+1,R13
	std y+0,R12
	mov R18,R10
	movw R16,R22
	xcall _NutTcpStateListen
;         break;
	xjmp L254
L262:
;     case TCPS_SYN_SENT:
;         NutTcpStateSynSent(sock, flags, th, nb);
	std y+3,R21
	std y+2,R20
	std y+1,R13
	std y+0,R12
	mov R18,R10
	movw R16,R22
	xcall _NutTcpStateSynSent
;         break;
	xjmp L254
L263:
;     case TCPS_SYN_RECEIVED:
;         NutTcpStateSynReceived(sock, flags, th, nb);
	std y+3,R21
	std y+2,R20
	std y+1,R13
	std y+0,R12
	mov R18,R10
	movw R16,R22
	xcall _NutTcpStateSynReceived
;         break;
	xjmp L254
L264:
;     case TCPS_FIN_WAIT_1:
;         NutTcpStateFinWait1(sock, flags, th, nb);
	std y+3,R21
	std y+2,R20
	std y+1,R13
	std y+0,R12
	mov R18,R10
	movw R16,R22
	xcall _NutTcpStateFinWait1
;         break;
	xjmp L254
L265:
;     case TCPS_FIN_WAIT_2:
;         NutTcpStateFinWait2(sock, flags, th, nb);
	std y+3,R21
	std y+2,R20
	std y+1,R13
	std y+0,R12
	mov R18,R10
	movw R16,R22
	xcall _NutTcpStateFinWait2
;         break;
	xjmp L254
L266:
;     case TCPS_CLOSE_WAIT:
;         NutTcpStateCloseWait(sock, flags, th, nb);
	std y+3,R21
	std y+2,R20
	std y+1,R13
	std y+0,R12
	mov R18,R10
	movw R16,R22
	xcall _NutTcpStateCloseWait
;         break;
	xjmp L254
L267:
;     case TCPS_CLOSING:
;         NutTcpStateClosing(sock, flags, th, nb);
	std y+3,R21
	std y+2,R20
	std y+1,R13
	std y+0,R12
	mov R18,R10
	movw R16,R22
	xcall _NutTcpStateClosing
;         break;
	xjmp L254
L268:
;     case TCPS_LAST_ACK:
;         NutTcpStateLastAck(sock, flags, th, nb);
	std y+3,R21
	std y+2,R20
	std y+1,R13
	std y+0,R12
	mov R18,R10
	movw R16,R22
	xcall _NutTcpStateLastAck
;         break;
	xjmp L254
L269:
;     case TCPS_TIME_WAIT:
;         /*
;          * Ignore everything while in TIME_WAIT state.
;          */
;         NutNetBufFree(nb);
	movw R16,R20
	xcall _NutNetBufFree
;         break;
	xjmp L254
L270:
;     case TCPS_CLOSED:
;         /*
;          * Reject everything while in CLOSED state.
;          */
;         NutTcpReject(nb);
	movw R16,R20
	xcall _NutTcpReject
;         break;
	xjmp L254
L253:
;     default:
;         NutNetBufFree(nb);
	movw R16,R20
	xcall _NutNetBufFree
;         break;
L254:
L252:
	.dbline 0 ; func end
	adiw R28,12
	xjmp pop_xgsetF0FC
;            tac -> R20
;             ih -> R14,R15
;            nbx -> R10,R11
;             th -> R10,R11
;             nb -> R22,R23
;           sock -> R12,R13
;            arg -> R10,R11
	.even
_NutTcpSm::
	xcall push_xgsetF0FC
	movw R10,R16
	sbiw R28,4
;     }
; }
; 
; /*! \fn NutTcpSm(void *arg)
;  * \brief TCP state machine thread.
;  *
;  * The TCP state machine serves two purposes: It processes incoming TCP
;  * segments and handles TCP timers.
;  */
; THREAD(NutTcpSm, arg)
; {
;     NETBUF *nb;
;     NETBUF *nbx;
;     TCPHDR *th;
;     IPHDR *ih;
;     TCPSOCKET *sock;
;     u_char tac = 0;
	clr R20
; 
;     /*
;      * It won't help giving us a higher priority than the application
;      * code. We depend on the speed of the reading application.
;      */
;     NutThreadSetPriority (32);
	ldi R16,32
	xcall _NutThreadSetPriority
;     
;     for (;;) {
L272:
;         if (++tac > 3 || NutEventWait(&tcp_in_rdy, 200)) {
	subi R20,255    ; addi 1
	ldi R24,3
	cp R24,R20
	brlo L278
X188:
	ldi R24,200
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+0,R26
	std y+1,R27
	movw R18,R24
	ldi R16,<_tcp_in_rdy
	ldi R17,>_tcp_in_rdy
	xcall _NutEventWait
	cpi R16,0
	cpc R16,R17
	brne X203
	xjmp L276
X203:
X189:
L278:
;             tac = 0;
	clr R20
;             for (sock = tcpSocketList; sock; sock = sock->so_next) {
	lds R12,_tcpSocketList
	lds R13,_tcpSocketList+1
	xjmp L282
L279:
; 
;                 /*
;                  * Send late acks.
;                  */
;                 if (sock->so_tx_flags & SO_ACK) {
	movw R30,R12
	ldd R2,z+32
	sbrs R2,4
	rjmp L283
X190:
;                     sock->so_tx_flags |= SO_FORCE;
	movw R22,R30
	subi R22,224  ; offset = 32
	sbci R23,255
	movw R30,R22
	ldd R24,z+0
	ori R24,8
	std z+0,R24
;                     NutTcpOutput(sock, 0, 0);
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	clr R18
	clr R19
	movw R16,R12
	xcall _NutTcpOutput
;                 }
L283:
; 
;                 /*
;                  * Process retransmit timer.
;                  */
;                 if (sock->so_tx_nbq && sock->so_retran_time) {
	movw R30,R12
	ldd R2,z+56
	ldd R3,z+57
	tst R2
	brne X191
	tst R3
	breq L285
X191:
	subi R30,162  ; addi 94
	sbci R31,255
	ldd R2,z+0
	ldd R3,z+1
	tst R2
	brne X192
	tst R3
	breq L285
X192:
;                     if ((u_short) NutGetMillis() - sock->so_retran_time > sock->so_rtto) {
	xcall _NutGetMillis
	movw R30,R12
	subi R30,162  ; addi 94
	sbci R31,255
	ldd R2,z+0
	ldd R3,z+1
	subi R30,94
	sbci R31,0
	movw R4,R16
	sub R4,R2
	sbc R5,R3
	subi R30,168  ; addi 88
	sbci R31,255
	ldd R2,z+0
	ldd R3,z+1
	subi R30,88
	sbci R31,0
	cp R2,R4
	cpc R3,R5
	brsh L287
X193:
;                         NutTcpStateRetranTimeout(sock);
	movw R16,R30
	xcall _NutTcpStateRetranTimeout
;                     }
L287:
;                 }
L285:
; 
;                 /*
;                  * Destroy sockets after timeout in TIMEWAIT state.
;                  */
;                 if (sock->so_state == TCPS_TIME_WAIT || sock->so_state == TCPS_FIN_WAIT_2) {
	movw R22,R12
	subi R22,237  ; offset = 19
	sbci R23,255
	movw R30,R22
	ldd R24,z+0
	cpi R24,10
	breq L291
X194:
	ldd R24,z+0
	cpi R24,9
	brne L289
X195:
L291:
;                     if (sock->so_time_wait++ >= 9) {
	movw R24,R12
	subi R24,164  ; offset = 92
	sbci R25,255
	movw R10,R24
	movw R30,R24
	ldd R22,z+0
	ldd R23,z+1
	movw R24,R22
	adiw R24,1
	std z+1,R25
	std z+0,R24
	cpi R22,9
	ldi R30,0
	cpc R23,R30
	brlo L290
X196:
;                         NutTcpDestroySocket(sock);
	movw R16,R12
	xcall _NutTcpDestroySocket
;                         break;
	xjmp L272
L289:
;                     }
;                 }
; 
;                 /*
;                  * Recover from SYN flood attacks.
;                  */
;                 else if (sock->so_state == TCPS_SYN_RECEIVED) {
	movw R30,R12
	ldd R24,z+19
	cpi R24,3
	brne L294
X197:
;                     if (sock->so_time_wait++ >= 45) {
	movw R24,R30
	subi R24,164  ; offset = 92
	sbci R25,255
	movw R10,R24
	movw R30,R24
	ldd R22,z+0
	ldd R23,z+1
	movw R24,R22
	adiw R24,1
	std z+1,R25
	std z+0,R24
	cpi R22,45
	ldi R30,0
	cpc R23,R30
	brlo L296
X198:
;                         sock->so_state = TCPS_LISTEN;
	ldi R24,1
	movw R30,R12
	std z+19,R24
;                         sock->so_time_wait = 0;
	clr R2
	clr R3
	subi R30,164  ; addi 92
	sbci R31,255
	std z+1,R3
	std z+0,R2
;                     }
L296:
;                 }
L294:
L290:
;             }
L280:
	movw R30,R12
	ldd R12,z+0
	ldd R13,z+1
L282:
	tst R12
	breq X204
	xjmp L279
X204:
	tst R13
	breq X205
	xjmp L279
X205:
X199:
;         } else {
	xjmp L272
L276:
;             nb = tcp_in_nbq;
	lds R22,_tcp_in_nbq
	lds R23,_tcp_in_nbq+1
;             tcp_in_nbq = 0;
	clr R2
	clr R3
	sts _tcp_in_nbq+1,R3
	sts _tcp_in_nbq,R2
;             tcp_in_cnt = 0;
	sts _tcp_in_cnt+1,R3
	sts _tcp_in_cnt,R2
	xjmp L299
L298:
;             while (nb) {
;                 ih = (IPHDR *) nb->nb_nw.vp;
	movw R30,R22
	ldd R14,z+7
	ldd R15,z+8
;                 th = (TCPHDR *) nb->nb_tp.vp;
	ldd R10,z+11
	ldd R11,z+12
;                 sock = NutTcpFindSocket(th->th_dport, th->th_sport, ih->ip_src);
	movw R30,R14
	ldd R2,z+12
	ldd R3,z+13
	ldd R4,z+14
	ldd R5,z+15
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	movw R30,R10
	ldd R18,z+0
	ldd R19,z+1
	ldd R16,z+2
	ldd R17,z+3
	xcall _NutTcpFindSocket
	movw R10,R16
	movw R12,R10
; #ifdef NUTDEBUG
;                 if (__tcp_trf)
;                     NutDumpTcpHeader(__tcp_trs, " IN", sock, nb);
; #endif
;                 nbx = nb->nb_next;
	movw R30,R22
	ldd R10,z+0
	ldd R11,z+1
;                 if (sock) {
	cpi R16,0
	cpc R16,R17
	breq L301
X200:
;                     NutTcpInputOptions(sock, nb);
	movw R18,R30
	xcall _NutTcpInputOptions
;                     NutTcpStateProcess(sock, nb);
	movw R18,R22
	movw R16,R12
	xcall _NutTcpStateProcess
;                 }
	xjmp L302
L301:
; 
;                 /*
;                  * Reject the segment, if no matching socket was found.
;                  */
;                 else
;                     NutTcpReject(nb);
	movw R16,R22
	xcall _NutTcpReject
L302:
;                 nb = nbx;
	movw R22,R10
;             }
L299:
	cpi R22,0
	cpc R22,R23
	breq X206
	xjmp L298
X206:
X201:
;         }
;     }
	xjmp L272
X202:
L271:
	.dbline 0 ; func end
	adiw R28,4
	xjmp pop_xgsetF0FC
;           size -> R12,R13
;            nbp -> R10,R11
;             nb -> R20,R21
	.even
_NutTcpStateMachine::
	xcall push_xgset303C
	movw R20,R16
; }
; 
; /*!
;  * \brief Process incoming TCP segments.
;  *
;  * All incoming TCP packets are passed to this routine. They will
;  * be added to a global queue and processed by the TCP state
;  * machine, which is running on a separate thread.
;  *
;  * \note This routine is called by the IP layer on incoming 
;  *       TCP segments. Applications typically do not call 
;  *       this function.
;  */
; void NutTcpStateMachine(NETBUF * nb)
; {
;     NETBUF *nbp;
;     u_short size;
; 
;     nb->nb_next = 0;
	clr R2
	clr R3
	movw R30,R20
	std z+1,R3
	std z+0,R2
; 
;     /*
;      * Incoming TCP segments are rejected and released if no TCP
;      * sockets have been opened. Not doing so would add them
;      * to the queue and never release the NETBUF. Thanks to
;      * Ralph Mason for this fix.
;      */
;     if (tcpThread == 0) {
	lds R2,_tcpThread
	lds R3,_tcpThread+1
	tst R2
	brne L304
	tst R3
	brne L304
X207:
;         NutTcpReject(nb);
	movw R16,R30
	xcall _NutTcpReject
;         return;
	xjmp L303
L304:
;     }
; 
;     if ((nbp = tcp_in_nbq) == 0) {
	lds R2,_tcp_in_nbq
	lds R3,_tcp_in_nbq+1
	movw R10,R2
	tst R10
	brne L306
	tst R11
	brne L306
X208:
;         tcp_in_nbq = nb;
	sts _tcp_in_nbq+1,R21
	sts _tcp_in_nbq,R20
;         NutEventPost(&tcp_in_rdy);
	ldi R16,<_tcp_in_rdy
	ldi R17,>_tcp_in_rdy
	xcall _NutEventPost
;     } else {
	xjmp L307
L306:
;         size = nb->nb_nw.sz + nb->nb_tp.sz + nb->nb_ap.sz;
	movw R30,R20
	ldd R2,z+13
	ldd R3,z+14
	ldd R12,z+9
	ldd R13,z+10
	add R12,R2
	adc R13,R3
	ldd R2,z+17
	ldd R3,z+18
	add R12,R2
	adc R13,R3
;         if (tcp_in_cnt + size + 2048 < NutHeapAvailable()) {
	xcall _NutHeapAvailable
	lds R24,_tcp_in_cnt
	lds R25,_tcp_in_cnt+1
	add R24,R12
	adc R25,R13
	subi R24,0  ; offset = 2048
	sbci R25,248
	cp R24,R16
	cpc R25,R17
	brsh L308
X209:
;             tcp_in_cnt += size;
	lds R2,_tcp_in_cnt
	lds R3,_tcp_in_cnt+1
	add R2,R12
	adc R3,R13
	sts _tcp_in_cnt+1,R3
	sts _tcp_in_cnt,R2
	xjmp L311
L310:
;             while (nbp->nb_next)
;                 nbp = nbp->nb_next;
	movw R30,R10
	ldd R10,z+0
	ldd R11,z+1
L311:
	movw R30,R10
	ldd R2,z+0
	ldd R3,z+1
	tst R2
	brne L310
	tst R3
	brne L310
X210:
;             nbp->nb_next = nb;
	std z+1,R21
	std z+0,R20
;             NutEventPost(&tcp_in_rdy);
	ldi R16,<_tcp_in_rdy
	ldi R17,>_tcp_in_rdy
	xcall _NutEventPost
;         } else
	xjmp L309
L308:
;             NutNetBufFree(nb);
	movw R16,R20
	xcall _NutNetBufFree
L309:
;     }
L307:
L303:
	.dbline 0 ; func end
	xjmp pop_xgset303C
	.even
_NutTcpInitStateMachine::
	sbiw R28,4
; }
; 
; /*!
;  * \brief Start TCP state machine.
;  *
;  * The socket interface will automatically call this routine as
;  * soon as the first socket is created.
;  *
;  * \return 0 on success, -1 otherwise.
;  */
; int NutTcpInitStateMachine(void)
; {
;     if (tcpThread == 0 && (tcpThread = NutThreadCreate("tcpsm", NutTcpSm, NULL, NUT_THREAD_TCPSMSTACK)) == 0)
	lds R2,_tcpThread
	lds R3,_tcpThread+1
	tst R2
	brne L314
	tst R3
	brne L314
X211:
	ldi R24,512
	ldi R25,2
	std y+3,R25
	std y+2,R24
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	ldi R18,<PL_NutTcpSm
	ldi R19,>PL_NutTcpSm
	ldi R16,<L316
	ldi R17,>L316
	xcall _NutThreadCreate
	sts _tcpThread+1,R17
	sts _tcpThread,R16
	cpi R16,0
	cpc R16,R17
	brne L314
X212:
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L313
L314:
;     return 0;
	clr R16
	clr R17
L313:
	.dbline 0 ; func end
	adiw R28,4
	ret
;     last_error -> R10,R11
;           sock -> R20,R21
	.even
_NutTcpAbortSocket::
	xcall push_xgset300C
	movw R10,R18
	movw R20,R16
; }
; 
; /*!
;  * \brief Closes socket with error.
;  *
;  * Aborts any socket activity and sets last error.
;  *
;  * \param sock  Socket descriptor.
;  * \param last_error Error number to report
;  *
;  * \note This routine is called internally by Nut/Net.
;  *       Applications typically do not call this function.
;  *
;  * \return 0 on success, -1 otherwise.
;  */
; int NutTcpAbortSocket(TCPSOCKET * sock, u_short last_error)
; {
;     sock->so_last_error = last_error;
	movw R30,R20
	subi R30,160  ; addi 96
	sbci R31,255
	std z+1,R11
	std z+0,R10
	subi R30,96
	sbci R31,0
;     sock->so_retran_time = 0;
	clr R2
	clr R3
	subi R30,162  ; addi 94
	sbci R31,255
	std z+1,R3
	std z+0,R2
	subi R30,94
	sbci R31,0
;     sock->so_time_wait = 0;
	subi R30,164  ; addi 92
	sbci R31,255
	std z+1,R3
	std z+0,R2
	subi R30,92
	sbci R31,0
;     /*
;      * If NutTcpCloseSocket was already called, we have to change
;      * to TCPS_TIME_WAIT state, otherwise the socket will not be destroyed.
;      * For the other cases just go to TCPS_CLOSED.
;      */
;     if (sock->so_state >= TCPS_FIN_WAIT_1)      /* FIN_WAIT_1, FIN_WAIT_2, CLOSING, LAST_ACK, TIME_WAIT */
	ldd R24,z+19
	cpi R24,6
	brlo L318
X213:
;         sock->so_state = TCPS_TIME_WAIT;
	ldi R24,10
	std z+19,R24
	xjmp L319
L318:
;     else
;         sock->so_state = TCPS_CLOSED;
	clr R2
	movw R30,R20
	std z+19,R2
L319:
;     NutTcpDiscardBuffers(sock);
	movw R16,R20
	xcall _NutTcpDiscardBuffers
;     NutEventBroadcast(&sock->so_rx_tq);
	movw R16,R20
	subi R16,178  ; offset = 78
	sbci R17,255
	xcall _NutEventBroadcast
;     NutEventBroadcast(&sock->so_tx_tq);
	movw R16,R20
	subi R16,198  ; offset = 58
	sbci R17,255
	xcall _NutEventBroadcast
;     NutEventBroadcast(&sock->so_pc_tq);
	movw R16,R20
	subi R16,158  ; offset = 98
	sbci R17,255
	xcall _NutEventBroadcast
;     NutEventBroadcast(&sock->so_ac_tq);
	movw R16,R20
	subi R16,156  ; offset = 100
	sbci R17,255
	xcall _NutEventBroadcast
;     return 0;
	clr R16
	clr R17
L317:
	.dbline 0 ; func end
	xjmp pop_xgset300C
	.area bss(ram, con, rel)
_tcp_in_cnt:
	.blkb 2
_tcp_in_nbq::
	.blkb 2
_tcp_in_rdy::
	.blkb 2
	.area data(ram, con, rel)
L316:
	.blkb 6
	.area idata
	.byte 't,'c,'p,'s,'m,0
	.area data(ram, con, rel)
; }
; 
; /*@}*/
	.area func_lit
PL_NutTcpSm:	.word `_NutTcpSm
