	.module tcputil.c
	.area text(rom, con, rel)
;           high -> y+8
;            low -> y+4
;              x -> y+0
	.even
_IsInLimits::
	xcall push_arg4
; /*
;  * Copyright (C) 2001-2004 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  */
; 
; /*
;  * $Log: tcputil.c,v $
;  * Revision 1.2  2004/07/30 19:54:46  drsung
;  * Some code of TCP stack redesigned. Round trip time calculation is now
;  * supported. Fixed several bugs in TCP state machine. Now TCP connections
;  * should be more reliable under heavy traffic or poor physical connections.
;  *
;  * Revision 1.1.1.1  2003/05/09 14:41:45  haraldkipp
;  * Initial using 3.2.1
;  *
;  * Revision 1.10  2003/05/06 18:23:15  harald
;  * Still not done
;  *
;  * Revision 1.9  2003/02/04 18:14:57  harald
;  * Version 3 released
;  *
;  * Revision 1.8  2002/06/26 17:29:36  harald
;  * First pre-release with 2.4 stack
;  *
;  */
; 
; #include <netinet/tcputil.h>
; #include <sys/timer.h>
; #include <stdio.h>
; 
; /*!
;  * \addtogroup xgTCP
;  */
; /*@{*/
; 
; 
; /*!
;  * \brief Sequence number comparisons.
;  *
;  * Return true if x is between low and high inclusive,
;  * false otherwise
;  */
; int IsInLimits(u_long x, u_long low, u_long high)
; {
;     if (low <= high) {
	ldd R2,y+8
	ldd R3,y+9
	ldd R4,y+10
	ldd R5,y+11
	ldd R6,y+4
	ldd R7,y+5
	ldd R8,y+6
	ldd R9,y+7
	cp R2,R6
	cpc R3,R7
	cpc R4,R8
	cpc R5,R9
	brlo L2
X0:
;         if (low <= x && x <= high)
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	cp R2,R6
	cpc R3,R7
	cpc R4,R8
	cpc R5,R9
	brlo L3
X1:
	ldd R2,y+8
	ldd R3,y+9
	ldd R4,y+10
	ldd R5,y+11
	ldd R6,y+0
	ldd R7,y+1
	ldd R8,y+2
	ldd R9,y+3
	cp R2,R6
	cpc R3,R7
	cpc R4,R8
	cpc R5,R9
	brlo L3
X2:
;             return 1;
	ldi R16,1
	ldi R17,0
	xjmp L1
L2:
;     } else if (low >= x && x >= high)
	ldd R2,y+0
	ldd R3,y+1
	ldd R4,y+2
	ldd R5,y+3
	ldd R6,y+4
	ldd R7,y+5
	ldd R8,y+6
	ldd R9,y+7
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	brlo L6
X3:
	ldd R2,y+8
	ldd R3,y+9
	ldd R4,y+10
	ldd R5,y+11
	ldd R6,y+0
	ldd R7,y+1
	ldd R8,y+2
	ldd R9,y+3
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	brlo L6
X4:
;         return 1;
	ldi R16,1
	ldi R17,0
	xjmp L1
L6:
L3:
; 
;     return 0;
	clr R16
	clr R17
L1:
	.dbline 0 ; func end
	adiw R28,4
	ret
;          delta -> R10,R11
;           sock -> R22,R23
	.even
_NutTcpCalcRtt::
	xcall push_xgsetF00C
	movw R22,R16
; }
; 
; #define min(a,b) ((a>b)?b:a)
; #define max(a,b) ((a>b)?a:b)
; 
; /*
;  * Calculate round trip time.
;  */
; void NutTcpCalcRtt(TCPSOCKET * sock)
; {
;     u_short delta;
;     
;     if (sock->so_retran_time == 0)
	movw R30,R22
	subi R30,162  ; addi 94
	sbci R31,255
	ldd R2,z+0
	ldd R3,z+1
	tst R2
	brne L9
	tst R3
	brne L9
X5:
;         return;
	xjmp L8
L9:
;         
;     delta = (u_short) NutGetMillis() - sock->so_retran_time;
	xcall _NutGetMillis
	movw R30,R22
	subi R30,162  ; addi 94
	sbci R31,255
	ldd R2,z+0
	ldd R3,z+1
	subi R30,94
	sbci R31,0
	movw R10,R16
	sub R10,R2
	sbc R11,R3
;     
;     /* According to RFC793 (or STD007), page 41, we use 0.8 for ALPHA and 2.0 for BETA. */
;     /* Limit retransmission timeout to 200ms as lower and 20secs as upper boundary */
;     sock->so_rtto = min (20000, max(200, (delta * 4 + sock->so_rtto * 8) / 10));
	movw R24,R30
	subi R24,168  ; offset = 88
	sbci R25,255
	movw R6,R24
	movw R30,R24
	ldd R18,z+0
	ldd R19,z+1
	ldi R16,8
	ldi R17,0
	xcall empy16s
	movw R2,R16
	ldi R16,4
	ldi R17,0
	movw R18,R10
	xcall empy16s
	movw R4,R16
	add R4,R2
	adc R5,R3
	ldi R18,10
	ldi R19,0
	movw R16,R4
	xcall div16u
	ldi R24,200
	ldi R25,0
	cp R16,R24
	cpc R17,R25
	brsh L13
X6:
	ldi R20,200
	ldi R21,0
	xjmp L14
L13:
	movw R30,R22
	subi R30,168  ; addi 88
	sbci R31,255
	ldd R18,z+0
	ldd R19,z+1
	ldi R16,8
	ldi R17,0
	xcall empy16s
	movw R2,R16
	ldi R16,4
	ldi R17,0
	movw R18,R10
	xcall empy16s
	movw R4,R16
	add R4,R2
	adc R5,R3
	ldi R18,10
	ldi R19,0
	movw R16,R4
	xcall div16u
	movw R20,R16
L14:
	ldi R24,20000
	ldi R25,78
	cp R20,R24
	cpc R21,R25
	brlo X9
	xjmp L11
X9:
X7:
	movw R30,R22
	subi R30,168  ; addi 88
	sbci R31,255
	ldd R18,z+0
	ldd R19,z+1
	ldi R16,8
	ldi R17,0
	xcall empy16s
	movw R2,R16
	ldi R16,4
	ldi R17,0
	movw R18,R10
	xcall empy16s
	movw R4,R16
	add R4,R2
	adc R5,R3
	ldi R18,10
	ldi R19,0
	movw R16,R4
	xcall div16u
	ldi R24,200
	ldi R25,0
	cp R16,R24
	cpc R17,R25
	brsh L15
X8:
	ldi R20,200
	ldi R21,0
	xjmp L16
L15:
	movw R30,R22
	subi R30,168  ; addi 88
	sbci R31,255
	ldd R18,z+0
	ldd R19,z+1
	ldi R16,8
	ldi R17,0
	xcall empy16s
	movw R2,R16
	ldi R16,4
	ldi R17,0
	movw R18,R10
	xcall empy16s
	movw R4,R16
	add R4,R2
	adc R5,R3
	ldi R18,10
	ldi R19,0
	movw R16,R4
	xcall div16u
	movw R20,R16
L16:
	xjmp L12
L11:
	ldi R20,20000
	ldi R21,78
L12:
	movw R30,R6
	std z+1,R21
	std z+0,R20
L8:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
;     //@@@printf ("[%04X] new retran timeout: %u, delta: %u\n", (u_short) sock, sock->so_rtto, delta);
; }
; 
; /*@}*/
