	.module udpin.c
	.area text(rom, con, rel)
;            snb -> R10,R11
;             uh -> R20,R21
;           sock -> R20,R21
;          bcast -> R10
;             nb -> R22,R23
	.even
_NutUdpInput::
	xcall push_xgsetF00C
	mov R10,R18
	movw R22,R16
	sbiw R28,6
; /*
;  * Copyright (C) 2001-2003 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  * -
;  * Portions Copyright (C) 2000 David J. Hudson <dave@humbug.demon.co.uk>
;  *
;  * This file is distributed in the hope that it will be useful, but WITHOUT
;  * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;  * FITNESS FOR A PARTICULAR PURPOSE.
;  *
;  * You can redistribute this file and/or modify it under the terms of the GNU
;  * General Public License (GPL) as published by the Free Software Foundation;
;  * either version 2 of the License, or (at your discretion) any later version.
;  * See the accompanying file "copying-gpl.txt" for more details.
;  *
;  * As a special exception to the GPL, permission is granted for additional
;  * uses of the text contained in this file.  See the accompanying file
;  * "copying-liquorice.txt" for details.
;  * -
;  * Portions Copyright (c) 1983, 1993 by
;  *  The Regents of the University of California.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the University nor the names of its contributors
;  *    may be used to endorse or promote products derived from this software
;  *    without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
;  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
;  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
;  * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
;  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
;  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
;  * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
;  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
;  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
;  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  * -
;  * Portions Copyright (c) 1993 by Digital Equipment Corporation.
;  *
;  * Permission to use, copy, modify, and distribute this software for any
;  * purpose with or without fee is hereby granted, provided that the above
;  * copyright notice and this permission notice appear in all copies, and that
;  * the name of Digital Equipment Corporation not be used in advertising or
;  * publicity pertaining to distribution of the document or software without
;  * specific, written prior permission.
;  * 
;  * THE SOFTWARE IS PROVIDED "AS IS" AND DIGITAL EQUIPMENT CORP. DISCLAIMS ALL
;  * WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES
;  * OF MERCHANTABILITY AND FITNESS.   IN NO EVENT SHALL DIGITAL EQUIPMENT
;  * CORPORATION BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
;  * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
;  * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
;  * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
;  * SOFTWARE.
;  */
; 
; /*
;  * $Log: udpin.c,v $
;  * Revision 1.5  2005/06/05 16:48:32  haraldkipp
;  * Additional parameter enables NutUdpInput() to avoid responding to UDP
;  * broadcasts with ICMP unreachable messages. Fixes bug #1215192.
;  *
;  * Revision 1.4  2005/05/26 11:47:24  drsung
;  * ICMP unreachable will be sent on incoming udp packets with no local peer port.
;  *
;  * Revision 1.3  2005/02/02 16:22:35  haraldkipp
;  * Do not wake up waiting threads if the incoming datagram
;  * doesn't fit in the buffer.
;  *
;  * Revision 1.2  2003/11/24 21:01:04  drsung
;  * Packet queue added for UDP sockets.
;  *
;  * Revision 1.1.1.1  2003/05/09 14:41:45  haraldkipp
;  * Initial using 3.2.1
;  *
;  * Revision 1.10  2003/02/04 18:14:57  harald
;  * Version 3 released
;  *
;  * Revision 1.9  2002/06/26 17:29:36  harald
;  * First pre-release with 2.4 stack
;  *
;  */
; 
; #include <sys/event.h>
; 
; #include <netinet/udp.h>
; #include <sys/socket.h>
; #include <netinet/ip_icmp.h>
; #include <netinet/icmp.h>
; 
; /*!
;  * \addtogroup xgUDP
;  */
; /*@{*/
; 
; /*!
;  * \brief Handle incoming UDP packets.
;  *
;  * \note This routine is called by the IP layer on
;  *       incoming UDP packets. Applications typically do
;  *       not call this function.
;  *
;  * \param nb  Network buffer structure containing the UDP packet.
;  */
;  /* @@@ 2003-10-24: modified by OS for udp packet queue */
; void NutUdpInput(NETBUF * nb, ureg_t bcast)
; {
;     UDPHDR *uh;
;     UDPSOCKET *sock;
; 
;     uh = (UDPHDR *) nb->nb_tp.vp;
	movw R30,R22
	ldd R20,z+11
	ldd R21,z+12
; 
;     nb->nb_ap.vp = uh + 1;
	movw R24,R20
	adiw R24,8
	std z+16,R25
	std z+15,R24
;     nb->nb_ap.sz = nb->nb_tp.sz - sizeof(UDPHDR);
	ldd R24,z+13
	ldd R25,z+14
	sbiw R24,8
	std z+18,R25
	std z+17,R24
;     nb->nb_tp.sz = sizeof(UDPHDR);
	ldi R24,8
	ldi R25,0
	std z+14,R25
	std z+13,R24
; 
;     /*
;      * Find a port. If none exists and if this datagram hasn't been
;      * broadcasted, return an ICMP unreachable.
;      */
;     if ((sock = NutUdpFindSocket(uh->uh_dport)) == 0) {
	movw R30,R20
	ldd R16,z+2
	ldd R17,z+3
	xcall _NutUdpFindSocket
	movw R20,R16
	cpi R20,0
	cpc R20,R21
	brne L2
X0:
;         if (bcast || NutIcmpResponse(ICMP_UNREACH, ICMP_UNREACH_PORT, 0, nb) == 0) {
	tst R10
	brne L6
X1:
	std y+5,R23
	std y+4,R22
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+0,R24
	std y+1,R25
	std y+2,R26
	std y+3,R27
	ldi R18,3
	ldi R16,3
	xcall _NutIcmpResponse
	cpi R16,0
	cpc R16,R17
	breq X9
	xjmp L1
X9:
X2:
L6:
;         	NutNetBufFree(nb);
	movw R16,R22
	xcall _NutNetBufFree
;         }
;         return;
	xjmp L1
L2:
;     }
; 
;     /* if buffer size is defined, use packet queue */
;     if (sock->so_rx_bsz) {
	movw R30,R20
	ldd R2,z+10
	ldd R3,z+11
	tst R2
	brne X3
	tst R3
	brne X10
	xjmp L7
X10:
X3:
;         /* New packet fits into the buffer? */
;         if (sock->so_rx_cnt + nb->nb_ap.sz > sock->so_rx_bsz) {
	movw R30,R22
	ldd R2,z+17
	ldd R3,z+18
	movw R30,R20
	ldd R4,z+8
	ldd R5,z+9
	add R4,R2
	adc R5,R3
	ldd R2,z+10
	ldd R3,z+11
	cp R2,R4
	cpc R3,R5
	brsh L9
X4:
;             /* No, so discard it */
;             NutNetBufFree(nb);
	movw R16,R22
	xcall _NutNetBufFree
;             return;
	xjmp L1
L9:
;         } else {
;             /* if a first packet is already in the queue, find the end
;              * and add the new packet */
;             if (sock->so_rx_nb) {
	movw R30,R20
	ldd R2,z+4
	ldd R3,z+5
	tst R2
	brne X5
	tst R3
	breq L11
X5:
;                 NETBUF *snb;
;                 for (snb = sock->so_rx_nb; snb->nb_next != 0; snb = snb->nb_next);
	ldd R10,z+4
	ldd R11,z+5
	xjmp L16
L13:
L14:
	movw R30,R10
	ldd R10,z+0
	ldd R11,z+1
L16:
	movw R30,R10
	ldd R2,z+0
	ldd R3,z+1
	tst R2
	brne L13
	tst R3
	brne L13
X6:
;                 snb->nb_next = nb;
	std z+1,R23
	std z+0,R22
;             } else
	xjmp L12
L11:
;                 sock->so_rx_nb = nb;
	movw R30,R20
	std z+5,R23
	std z+4,R22
L12:
; 
;             /* increment input buffer count */
;             sock->so_rx_cnt += nb->nb_ap.sz;
	movw R24,R20
	adiw R24,8
	movw R10,R24
	movw R30,R22
	ldd R2,z+17
	ldd R3,z+18
	movw R30,R24
	ldd R4,z+0
	ldd R5,z+1
	add R4,R2
	adc R5,R3
	std z+1,R5
	std z+0,R4
;         };
;     } else {                    /* no packet queue */
	xjmp L8
L7:
;         /* if a packet is still buffered, discard it */
;         if (sock->so_rx_nb) {
	movw R30,R20
	ldd R2,z+4
	ldd R3,z+5
	tst R2
	brne X7
	tst R3
	breq L17
X7:
;             NutNetBufFree(sock->so_rx_nb);
	ldd R16,z+4
	ldd R17,z+5
	xcall _NutNetBufFree
;         }
L17:
;         sock->so_rx_nb = nb;
	movw R30,R20
	std z+5,R23
	std z+4,R22
;         sock->so_rx_cnt = nb->nb_ap.sz; /* set input buffer count to size of new packet */
	movw R30,R22
	ldd R2,z+17
	ldd R3,z+18
	movw R30,R20
	std z+9,R3
	std z+8,R2
;     };
L8:
; 
;     /* post the event only, if one thread is waiting */
;     if (sock->so_rx_rdy)
	movw R30,R20
	ldd R2,z+6
	ldd R3,z+7
	tst R2
	brne X8
	tst R3
	breq L19
X8:
;         NutEventPost(&sock->so_rx_rdy);
	movw R16,R30
	subi R16,250  ; offset = 6
	sbci R17,255
	xcall _NutEventPost
L19:
L1:
	.dbline 0 ; func end
	adiw R28,6
	xjmp pop_xgsetF00C
; }
; 
; /*@}*/
