	.module bankmem.c
	.area text(rom, con, rel)
	.even
_NutSegBufReset::
; /*
;  * Copyright (C) 2004 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  */
; 
; /*!
;  * $Log: bankmem.c,v $
;  * Revision 1.3  2004/12/17 15:28:33  haraldkipp
;  * Bugfix. Comparison of the read and write pointers now includes the segments.
;  * Thanks to Pete Allinson and Johan van der Stoel.
;  *
;  * Revision 1.2  2004/08/18 18:51:56  haraldkipp
;  * Made banked memory configurable.
;  *
;  * Revision 1.1  2003/07/21 18:19:48  haraldkipp
;  * First check in
;  *
;  */
; 
; #include <sys/heap.h>
; 
; /*!
;  * \addtogroup xgBankMem
;  */
; 
; /*@{*/
; 
; #include <sys/bankmem.h>
; 
; static char segbuf_empty;
; static u_long segbuf_total;
; static u_long segbuf_used;
; 
; static char *segbuf_start;
; static char *segbuf_end;
; 
; 
; static char *segbuf_wp;
; static char segbuf_ws;
; static char *segbuf_rp;
; static char segbuf_rs;
; 
; /*!
;  * \brief Reset the segmented buffer.
;  *
;  * \return Pointer to the first buffer segment.
;  */
; char *NutSegBufReset(void)
; {
;     segbuf_rp = segbuf_wp = segbuf_start;
	lds R2,_segbuf_start
	lds R3,_segbuf_start+1
	sts _segbuf_wp+1,R3
	sts _segbuf_wp,R2
	sts _segbuf_rp+1,R3
	sts _segbuf_rp,R2
;     segbuf_rs = segbuf_ws = 0;
	clr R2
	sts _segbuf_ws,R2
	sts _segbuf_rs,R2
;     NutSegBufEnable(0);
;     segbuf_empty = 1;
	ldi R24,1
	sts _segbuf_empty,R24
;     segbuf_used = 0;
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	sts _segbuf_used+1,R25
	sts _segbuf_used,R24
	sts _segbuf_used+2+1,R27
	sts _segbuf_used+2,R26
; 
;     return segbuf_start;
	lds R16,_segbuf_start
	lds R17,_segbuf_start+1
L1:
	.dbline 0 ; func end
	ret
;           size -> R20,R21
	.even
_NutSegBufInit::
	xcall push_xgset300C
	movw R20,R16
; }
; 
; /*!
;  * \brief Initialize the segmented buffer.
;  *
;  * \param size Number of bytes to allocate for the global buffer.
;  *             In systems with banked memory this parameter is 
;  *             ignored and all banked memory is occupied for the
;  *             global buffer. In systems without banked memory,
;  *             the specified number of bytes is taken from heap
;  *             memory.
;  *
;  * \return Pointer to the first buffer segment or null on failures.
;  */
; char *NutSegBufInit(size_t size)
; {
; 
; #if NUTBANK_COUNT
;     segbuf_start = (char *)(NUTBANK_START);
;     segbuf_end = (char *)(NUTBANK_START) + NUTBANK_SIZE;
;     segbuf_total = (u_long) NUTBANK_COUNT *(u_long) NUTBANK_SIZE;
; #else
;     if (size == 0)
	cpi R20,0
	cpc R20,R21
	brne L3
X0:
;         size = NutHeapAvailable() - 8192;
	xcall _NutHeapAvailable
	movw R20,R16
	subi R20,0
	sbci R21,32
L3:
;     if ((segbuf_start = NutHeapAlloc(size)) != 0)
	movw R16,R20
	xcall _NutHeapAlloc
	sts _segbuf_start+1,R17
	sts _segbuf_start,R16
	cpi R16,0
	cpc R16,R17
	breq L5
X1:
;         segbuf_end = segbuf_start + size;
	movw R4,R20
	add R4,R16
	adc R5,R17
	sts _segbuf_end+1,R5
	sts _segbuf_end,R4
L5:
;     segbuf_total = size;
	movw R2,R20
	clr R4
	clr R5
	sts _segbuf_total+1,R3
	sts _segbuf_total,R2
	sts _segbuf_total+2+1,R5
	sts _segbuf_total+2,R4
; #endif
; 
;     return NutSegBufReset();
	xcall _NutSegBufReset
	movw R10,R16
L2:
	.dbline 0 ; func end
	xjmp pop_xgset300C
;            bcp -> R16,R17
	.even
_NutSegBufWriteRequest::
; }
; 
; /*!
;  * \brief Request segmented buffer space for writing.
;  *
;  * This call will also enable the current write segment and
;  * may disable the current read segment.
;  *
;  * \param bcp Pointer to a variable, which receives the
;  *            number of consecutive bytes available for 
;  *            writing.
;  *
;  * \return Pointer to the next write position.
;  */
; char *NutSegBufWriteRequest(size_t * bcp)
; {
;     if (segbuf_empty || segbuf_ws != segbuf_rs || segbuf_wp > segbuf_rp)
	lds R2,_segbuf_empty
	tst R2
	brne L11
X2:
	lds R2,_segbuf_rs
	lds R3,_segbuf_ws
	cp R3,R2
	brne L11
X3:
	lds R2,_segbuf_rp
	lds R3,_segbuf_rp+1
	lds R4,_segbuf_wp
	lds R5,_segbuf_wp+1
	cp R2,R4
	cpc R3,R5
	brsh L8
X4:
L11:
;         *bcp = segbuf_end - segbuf_wp;
	lds R2,_segbuf_wp
	lds R3,_segbuf_wp+1
	lds R4,_segbuf_end
	lds R5,_segbuf_end+1
	sub R4,R2
	sbc R5,R3
	movw R30,R16
	std z+1,R5
	std z+0,R4
	xjmp L9
L8:
;     else
;         *bcp = segbuf_rp - segbuf_wp;
	lds R2,_segbuf_wp
	lds R3,_segbuf_wp+1
	lds R4,_segbuf_rp
	lds R5,_segbuf_rp+1
	sub R4,R2
	sbc R5,R3
	movw R30,R16
	std z+1,R5
	std z+0,R4
L9:
; 
;     NutSegBufEnable(segbuf_ws);
;     return segbuf_wp;
	lds R16,_segbuf_wp
	lds R17,_segbuf_wp+1
L7:
	.dbline 0 ; func end
	ret
;            bcp -> R16,R17
	.even
_NutSegBufReadRequest::
; }
; 
; /*!
;  * \brief Request segmented buffer space for reading.
;  *
;  * This call will also enable the current read segment and
;  * may disable the current write segment.
;  *
;  * \param bcp Pointer to a variable, which receives the
;  *            number of consecutive bytes available for 
;  *            reading.
;  *
;  * \return Pointer to the next read position.
;  */
; char *NutSegBufReadRequest(size_t * bcp)
; {
;     if (segbuf_empty)
	lds R2,_segbuf_empty
	tst R2
	breq L13
X5:
;         *bcp = 0;
	clr R2
	clr R3
	movw R30,R16
	std z+1,R3
	std z+0,R2
	xjmp L14
L13:
;     else if (segbuf_ws != segbuf_rs || segbuf_rp >= segbuf_wp)
	lds R2,_segbuf_rs
	lds R3,_segbuf_ws
	cp R3,R2
	brne L17
X6:
	lds R2,_segbuf_wp
	lds R3,_segbuf_wp+1
	lds R4,_segbuf_rp
	lds R5,_segbuf_rp+1
	cp R4,R2
	cpc R5,R3
	brlo L15
X7:
L17:
;         *bcp = segbuf_end - segbuf_rp;
	lds R2,_segbuf_rp
	lds R3,_segbuf_rp+1
	lds R4,_segbuf_end
	lds R5,_segbuf_end+1
	sub R4,R2
	sbc R5,R3
	movw R30,R16
	std z+1,R5
	std z+0,R4
	xjmp L16
L15:
;     else if ((*bcp = segbuf_wp - segbuf_rp) == 0 && segbuf_ws == segbuf_rs)
	lds R2,_segbuf_rp
	lds R3,_segbuf_rp+1
	lds R4,_segbuf_wp
	lds R5,_segbuf_wp+1
	sub R4,R2
	sbc R5,R3
	movw R30,R16
	std z+1,R5
	std z+0,R4
	tst R4
	brne L18
	tst R5
	brne L18
X8:
	lds R2,_segbuf_rs
	lds R3,_segbuf_ws
	cp R3,R2
	brne L18
X9:
;         segbuf_empty = 1;
	ldi R24,1
	sts _segbuf_empty,R24
L18:
L16:
L14:
; 
;     NutSegBufEnable(segbuf_rs);
;     return segbuf_rp;
	lds R16,_segbuf_rp
	lds R17,_segbuf_rp+1
L12:
	.dbline 0 ; func end
	ret
;             bc -> R16,R17
	.even
_NutSegBufWriteCommit::
; }
; 
; /*!
;  * \brief Commit written buffer space.
;  *
;  * The write pointer will be incremented by the specified number of bytes.
;  * If the pointer reaches the end of a segment, the next segment will be
;  * enabled and the pointer will point to the start of the new segement.
;  *
;  * \param bc Number of bytes to commit.
;  *
;  * \return Pointer to the next write position.
;  */
; char *NutSegBufWriteCommit(u_short bc)
; {
;     if (bc) {
	cpi R16,0
	cpc R16,R17
	brne X13
	xjmp L21
X13:
X10:
;         segbuf_wp += bc;
	lds R2,_segbuf_wp
	lds R3,_segbuf_wp+1
	movw R4,R16
	add R4,R2
	adc R5,R3
	sts _segbuf_wp+1,R5
	sts _segbuf_wp,R4
;         segbuf_empty = 0;
	clr R2
	sts _segbuf_empty,R2
;         segbuf_used += bc;
	movw R2,R16
	clr R4
	clr R5
	lds R8,_segbuf_used+2
	lds R9,_segbuf_used+2+1
	lds R6,_segbuf_used
	lds R7,_segbuf_used+1
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	sts _segbuf_used+1,R7
	sts _segbuf_used,R6
	sts _segbuf_used+2+1,R9
	sts _segbuf_used+2,R8
;         if (segbuf_wp == segbuf_end) {
	lds R2,_segbuf_end
	lds R3,_segbuf_end+1
	lds R4,_segbuf_wp
	lds R5,_segbuf_wp+1
	cp R4,R2
	cpc R5,R3
	brne L23
X11:
;             segbuf_wp = segbuf_start;
	lds R2,_segbuf_start
	lds R3,_segbuf_start+1
	sts _segbuf_wp+1,R3
	sts _segbuf_wp,R2
;             if (++segbuf_ws >= NUTBANK_COUNT)
	lds R24,_segbuf_ws
	subi R24,255    ; addi 1
	mov R2,R24
	sts _segbuf_ws,R2
	cpi R24,0
	brlo L25
X12:
;                 segbuf_ws = 0;
	clr R2
	sts _segbuf_ws,R2
L25:
;             NutSegBufEnable(segbuf_ws);
;         }
L23:
;     }
L21:
;     return segbuf_wp;
	lds R16,_segbuf_wp
	lds R17,_segbuf_wp+1
L20:
	.dbline 0 ; func end
	ret
;             bc -> R16,R17
	.even
_NutSegBufReadCommit::
; }
; 
; /*!
;  * \brief Commit read buffer space.
;  *
;  * The read pointer will be incremented by the specified number of bytes.
;  * If the pointer reaches the end of a segment, the next segment will be
;  * enabled and the pointer will point to the start of the new segement.
;  *
;  * \param bc Number of bytes to commit.
;  *
;  * \return Pointer to the next read position.
;  */
; char *NutSegBufReadCommit(size_t bc)
; {
;     if (bc) {
	cpi R16,0
	cpc R16,R17
	brne X19
	xjmp L28
X19:
X14:
;         segbuf_rp += bc;
	lds R2,_segbuf_rp
	lds R3,_segbuf_rp+1
	movw R4,R16
	add R4,R2
	adc R5,R3
	sts _segbuf_rp+1,R5
	sts _segbuf_rp,R4
;         segbuf_used -= bc;
	movw R2,R16
	clr R4
	clr R5
	lds R8,_segbuf_used+2
	lds R9,_segbuf_used+2+1
	lds R6,_segbuf_used
	lds R7,_segbuf_used+1
	sub R6,R2
	sbc R7,R3
	sbc R8,R4
	sbc R9,R5
	sts _segbuf_used+1,R7
	sts _segbuf_used,R6
	sts _segbuf_used+2+1,R9
	sts _segbuf_used+2,R8
;         if (segbuf_rp == segbuf_end) {
	lds R2,_segbuf_end
	lds R3,_segbuf_end+1
	lds R4,_segbuf_rp
	lds R5,_segbuf_rp+1
	cp R4,R2
	cpc R5,R3
	brne L30
X15:
;             segbuf_rp = segbuf_start;
	lds R2,_segbuf_start
	lds R3,_segbuf_start+1
	sts _segbuf_rp+1,R3
	sts _segbuf_rp,R2
;             if (++segbuf_rs >= NUTBANK_COUNT)
	lds R24,_segbuf_rs
	subi R24,255    ; addi 1
	mov R2,R24
	sts _segbuf_rs,R2
	cpi R24,0
	brlo L32
X16:
;                 segbuf_rs = 0;
	clr R2
	sts _segbuf_rs,R2
L32:
;             NutSegBufEnable(segbuf_rs);
;         }
L30:
;         if (segbuf_rp == segbuf_wp  && segbuf_rs == segbuf_ws)
	lds R2,_segbuf_wp
	lds R3,_segbuf_wp+1
	lds R4,_segbuf_rp
	lds R5,_segbuf_rp+1
	cp R4,R2
	cpc R5,R3
	brne L34
X17:
	lds R2,_segbuf_ws
	lds R3,_segbuf_rs
	cp R3,R2
	brne L34
X18:
;             segbuf_empty = 1;
	ldi R24,1
	sts _segbuf_empty,R24
L34:
;     }
L28:
;     return segbuf_rp;
	lds R16,_segbuf_rp
	lds R17,_segbuf_rp+1
L27:
	.dbline 0 ; func end
	ret
;             bc -> R16,R17
	.even
_NutSegBufWriteLast::
; }
; 
; 
; /*!
;  * \brief Commit written buffer space and finish write access.
;  *
;  * The write pointer will be incremented by the specified number of bytes.
;  * This call will also enable the current read segment and may disable the 
;  * current write segment.
;  *
;  * \param bc Number of bytes to commit.
;  */
; void NutSegBufWriteLast(u_short bc)
; {
;     if (bc) {
	cpi R16,0
	cpc R16,R17
	brne X23
	xjmp L37
X23:
X20:
;         segbuf_wp += bc;
	lds R2,_segbuf_wp
	lds R3,_segbuf_wp+1
	movw R4,R16
	add R4,R2
	adc R5,R3
	sts _segbuf_wp+1,R5
	sts _segbuf_wp,R4
;         segbuf_used += bc;
	movw R2,R16
	clr R4
	clr R5
	lds R8,_segbuf_used+2
	lds R9,_segbuf_used+2+1
	lds R6,_segbuf_used
	lds R7,_segbuf_used+1
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	sts _segbuf_used+1,R7
	sts _segbuf_used,R6
	sts _segbuf_used+2+1,R9
	sts _segbuf_used+2,R8
;         segbuf_empty = 0;
	clr R2
	sts _segbuf_empty,R2
;         if (segbuf_wp == segbuf_end) {
	lds R2,_segbuf_end
	lds R3,_segbuf_end+1
	lds R4,_segbuf_wp
	lds R5,_segbuf_wp+1
	cp R4,R2
	cpc R5,R3
	brne L39
X21:
;             segbuf_wp = segbuf_start;
	lds R2,_segbuf_start
	lds R3,_segbuf_start+1
	sts _segbuf_wp+1,R3
	sts _segbuf_wp,R2
;             if (++segbuf_ws >= NUTBANK_COUNT)
	lds R24,_segbuf_ws
	subi R24,255    ; addi 1
	mov R2,R24
	sts _segbuf_ws,R2
	cpi R24,0
	brlo L41
X22:
;                 segbuf_ws = 0;
	clr R2
	sts _segbuf_ws,R2
L41:
;         }
L39:
;     }
L37:
;     NutSegBufEnable(segbuf_rs);
L36:
	.dbline 0 ; func end
	ret
;             bc -> R16,R17
	.even
_NutSegBufReadLast::
; }
; 
; /*!
;  * \brief Commit written buffer space and finish read access.
;  *
;  * The write pointer will be incremented by the specified number of bytes.
;  * This call will also enable the current read segment and may disable the 
;  * current write segment.
;  *
;  * \param bc Number of bytes to commit.
;  */
; void NutSegBufReadLast(u_short bc)
; {
;     if (bc) {
	cpi R16,0
	cpc R16,R17
	brne X29
	xjmp L44
X29:
X24:
;         segbuf_rp += bc;
	lds R2,_segbuf_rp
	lds R3,_segbuf_rp+1
	movw R4,R16
	add R4,R2
	adc R5,R3
	sts _segbuf_rp+1,R5
	sts _segbuf_rp,R4
;         segbuf_used -= bc;
	movw R2,R16
	clr R4
	clr R5
	lds R8,_segbuf_used+2
	lds R9,_segbuf_used+2+1
	lds R6,_segbuf_used
	lds R7,_segbuf_used+1
	sub R6,R2
	sbc R7,R3
	sbc R8,R4
	sbc R9,R5
	sts _segbuf_used+1,R7
	sts _segbuf_used,R6
	sts _segbuf_used+2+1,R9
	sts _segbuf_used+2,R8
;         if (segbuf_rp == segbuf_end) {
	lds R2,_segbuf_end
	lds R3,_segbuf_end+1
	lds R4,_segbuf_rp
	lds R5,_segbuf_rp+1
	cp R4,R2
	cpc R5,R3
	brne L46
X25:
;             segbuf_rp = segbuf_start;
	lds R2,_segbuf_start
	lds R3,_segbuf_start+1
	sts _segbuf_rp+1,R3
	sts _segbuf_rp,R2
;             if (++segbuf_rs >= NUTBANK_COUNT)
	lds R24,_segbuf_rs
	subi R24,255    ; addi 1
	mov R2,R24
	sts _segbuf_rs,R2
	cpi R24,0
	brlo L48
X26:
;                 segbuf_rs = 0;
	clr R2
	sts _segbuf_rs,R2
L48:
;         }
L46:
;         if (segbuf_rp == segbuf_wp && segbuf_rs == segbuf_ws)
	lds R2,_segbuf_wp
	lds R3,_segbuf_wp+1
	lds R4,_segbuf_rp
	lds R5,_segbuf_rp+1
	cp R4,R2
	cpc R5,R3
	brne L50
X27:
	lds R2,_segbuf_ws
	lds R3,_segbuf_rs
	cp R3,R2
	brne L50
X28:
;             segbuf_empty = 1;
	ldi R24,1
	sts _segbuf_empty,R24
L50:
;     }
L44:
;     NutSegBufEnable(segbuf_ws);
L43:
	.dbline 0 ; func end
	ret
	.even
_NutSegBufAvailable::
; }
; 
; 
; /*!
;  * \brief Return the available buffer space.
;  *
;  * \return Total number of free bytes in the buffer.
;  */
; u_long NutSegBufAvailable(void)
; {
;     return segbuf_total - segbuf_used;
	lds R4,_segbuf_used+2
	lds R5,_segbuf_used+2+1
	lds R2,_segbuf_used
	lds R3,_segbuf_used+1
	lds R18,_segbuf_total+2
	lds R19,_segbuf_total+2+1
	lds R16,_segbuf_total
	lds R17,_segbuf_total+1
	sub R16,R2
	sbc R17,R3
	sbc R18,R4
	sbc R19,R5
L52:
	.dbline 0 ; func end
	ret
	.even
_NutSegBufUsed::
; }
; 
; /*!
;  * \brief Return the used buffer space.
;  *
;  * \return Total number of used bytes in the buffer.
;  */
; u_long NutSegBufUsed(void)
; {
;     return segbuf_used;
	lds R18,_segbuf_used+2
	lds R19,_segbuf_used+2+1
	lds R16,_segbuf_used
	lds R17,_segbuf_used+1
L53:
	.dbline 0 ; func end
	ret
	.area bss(ram, con, rel)
_segbuf_rs:
	.blkb 1
_segbuf_rp:
	.blkb 2
_segbuf_ws:
	.blkb 1
_segbuf_wp:
	.blkb 2
_segbuf_end:
	.blkb 2
_segbuf_start:
	.blkb 2
_segbuf_used:
	.blkb 4
_segbuf_total:
	.blkb 4
_segbuf_empty:
	.blkb 1
; }
; 
; /*@}*/
