	.module confos.c
	.area text(rom, con, rel)
	.even
_NutLoadConfig::
	sbiw R28,2
; /*
;  * Copyright (C) 2001-2005 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  */
; 
; /*
;  * $Log: confos.c,v $
;  * Revision 1.6  2005/07/26 15:49:59  haraldkipp
;  * Cygwin support added.
;  *
;  * Revision 1.5  2004/09/08 10:24:34  haraldkipp
;  * No EEPROM support for AT91
;  *
;  * Revision 1.4  2004/04/07 12:13:58  haraldkipp
;  * Matthias Ringwald's *nix emulation added
;  *
;  * Revision 1.3  2004/03/16 16:48:45  haraldkipp
;  * Added Jan Dubiec's H8/300 port.
;  *
;  * Revision 1.2  2004/03/03 17:42:19  drsung
;  * Bugfix in NutSaveConfig. Write only to eeprom if actual byte in
;  * eeprom differs from byte to write.
;  *
;  * Revision 1.1.1.1  2003/05/09 14:41:46  haraldkipp
;  * Initial using 3.2.1
;  *
;  * Revision 1.1  2003/02/04 18:17:07  harald
;  * Version 3 released
;  *
;  */
; 
; #include <cfg/arch.h>
; #include <sys/confos.h>
; 
; CONFOS confos;
; 
; /*!
;  * \brief Load Nut/OS configuration from the EEPROM.
;  *
;  * This routine is automatically called during system
;  * initialization.
;  *
;  * \return 0 if OK, -1 if configuration isn't available.
;  */
; int NutLoadConfig(void)
; {
; #if !defined(__linux__) && !defined(__APPLE__) && !defined(__CYGWIN__) && !defined(__arm__)
;     eeprom_read_block(&confos, CONFOS_EE_OFFSET, sizeof(CONFOS));
	ldi R24,19
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<_confos
	ldi R19,>_confos
	clr R16
	clr R17
	xcall _EEPROMReadBytes
;     if (confos.size != sizeof(CONFOS) || confos.magic[0] != 'O' || confos.magic[1] != 'S') {
	lds R24,_confos
	cpi R24,19
	brne L8
X0:
	lds R24,_confos+1
	cpi R24,79
	brne L8
X1:
	lds R24,_confos+1+1
	cpi R24,83
	breq L2
X2:
L8:
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L1
L2:
;     }
; #endif
;     return 0;
	clr R16
	clr R17
L1:
	.dbline 0 ; func end
	adiw R28,2
	ret
;             cp -> R22,R23
;              i -> R20,R21
	.even
_NutSaveConfig::
	xcall push_xgsetF000
; }
; 
; /*!
;  * \brief Save Nut/OS configuration in the EEPROM.
;  *
;  * \return 0 if OK, -1 on failures.
;  */
; int NutSaveConfig(void)
; {
; #if !defined(__linux__) && !defined(__APPLE__) && !defined(__CYGWIN__) && !defined(__arm__)
;     u_char *cp;
;     u_short i;
; 
;     confos.size = sizeof(CONFOS);
	ldi R24,19
	sts _confos,R24
;     confos.magic[0] = 'O';
	ldi R24,79
	sts _confos+1,R24
;     confos.magic[1] = 'S';
	ldi R24,83
	sts _confos+1+1,R24
;     for (cp = (u_char *) & confos, i = 0; i < sizeof(CONFOS); cp++, i++)
	ldi R22,<_confos
	ldi R23,>_confos
	clr R20
	clr R21
	xjmp L16
L13:
;         if (eeprom_read_byte((void *) ((uptr_t) (i + CONFOS_EE_OFFSET))) != *cp)
	movw R16,R20
	xcall _EEPROMread
	movw R30,R22
	ldd R2,z+0
	cp R16,R2
	breq L17
X3:
;             eeprom_write_byte((void *) ((uptr_t) (i + CONFOS_EE_OFFSET)), *cp);
	ldd R18,z+0
	movw R16,R20
	xcall _EEPROMwrite
L17:
L14:
	subi R22,255  ; offset = 1
	sbci R23,255
	subi R20,255  ; offset = 1
	sbci R21,255
L16:
	cpi R20,19
	ldi R30,0
	cpc R21,R30
	brlo L13
X4:
; 
; #endif
;     return 0;
	clr R16
	clr R17
L9:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.area bss(ram, con, rel)
_confos::
	.blkb 19
; }
