	.module event.c
	.area text(rom, con, rel)
;           tqpp -> R22,R23
;            tqp -> R20,R21
;            arg -> R18,R19
;          timer -> R16,R17
	.even
_NutEventTimeout::
	xcall push_xgsetF000
; /*
;  * Copyright (C) 2001-2005 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  * -
;  * Portions Copyright (C) 2000 David J. Hudson <dave@humbug.demon.co.uk>
;  *
;  * This file is distributed in the hope that it will be useful, but WITHOUT
;  * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;  * FITNESS FOR A PARTICULAR PURPOSE.
;  *
;  * You can redistribute this file and/or modify it under the terms of the GNU
;  * General Public License (GPL) as published by the Free Software Foundation;
;  * either version 2 of the License, or (at your discretion) any later version.
;  * See the accompanying file "copying-gpl.txt" for more details.
;  *
;  * As a special exception to the GPL, permission is granted for additional
;  * uses of the text contained in this file.  See the accompanying file
;  * "copying-liquorice.txt" for details.
;  */
; 
; /*
;  * $Log: event.c,v $
;  * Revision 1.23  2005/08/18 15:33:54  christianwelzel
;  * Fixed bug in handling of NUTDEBUG.
;  *
;  * Revision 1.22  2005/07/21 14:23:17  freckle
;  * inlined NutEventPostFromIrq call in NutEventPostAsync to reduce CS
;  *
;  * Revision 1.21  2005/07/20 09:19:45  haraldkipp
;  * Use native heap calls to avoid dependencies
;  *
;  * Revision 1.20  2005/07/13 15:25:50  freckle
;  * Rewrote NutEventWait to get short critical sections
;  *
;  * Revision 1.19  2005/07/12 18:44:05  freckle
;  * Removed unnecessary critical sections in NutEventPost, NutEventWait
;  *
;  * Revision 1.18  2005/07/12 18:04:12  freckle
;  * Reverted NutEventWait back to 1.15 but kept critical section in
;  * NutEventTimeout + changed CS in NutEventWaitNext
;  *
;  * Revision 1.15  2005/06/10 12:59:26  freckle
;  * corrected NuEventBroadcastAsync documentation.
;  * NutEventBroadcast uses NutEventPostAsync which disables IRQsCVS:
;  * ----------------------------------------------------------------------
;  *
;  * Revision 1.14  2005/02/21 12:37:57  phblum
;  * Removed tabs and added semicolons after NUTTRACER macros
;  *
;  * Revision 1.13  2005/02/17 14:45:10  phblum
;  * In NutEventWait(), replaced NutThreadRemoveQueue by direct removal of first thread in queue.
;  *
;  * Revision 1.12  2005/02/16 19:53:17  haraldkipp
;  * Ready-to-run queue handling removed from interrupt context.
;  *
;  * Revision 1.11  2005/01/24 22:34:35  freckle
;  * Added new tracer by Phlipp Blum <blum@tik.ee.ethz.ch>
;  *
;  * Revision 1.10  2005/01/24 21:11:21  freckle
;  * renamed NutEventPostFromIRQ into NutEventPostFromIrq
;  *
;  * Revision 1.9  2005/01/21 16:49:44  freckle
;  * Seperated calls to NutEventPostAsync between Threads and IRQs
;  *
;  * Revision 1.8  2005/01/19 17:59:45  freckle
;  * Improved interrupt performance by reducing some critical section
;  *
;  * Revision 1.7  2005/01/02 10:07:10  haraldkipp
;  * Replaced platform dependant formats in debug outputs.
;  *
;  * Revision 1.6  2004/07/20 08:33:28  freckle
;  * Fixed NutPostEvent to give up CPU if there is another thread ready with
;  * same priority to match the documentation
;  * Also removed 'SWP..' NBUTDEBUG output, as switching is done calling NutThreadYield()
;  *
;  * Revision 1.5  2004/04/07 12:13:58  haraldkipp
;  * Matthias Ringwald's *nix emulation added
;  *
;  * Revision 1.4  2004/03/19 09:05:12  jdubiec
;  * Fixed format strings declarations for AVR.
;  *
;  * Revision 1.3  2004/03/16 16:48:45  haraldkipp
;  * Added Jan Dubiec's H8/300 port.
;  *
;  * Revision 1.2  2003/07/20 18:27:44  haraldkipp
;  * Explain how to disable timeout.
;  *
;  * Revision 1.1.1.1  2003/05/09 14:41:49  haraldkipp
;  * Initial using 3.2.1
;  *
;  * Revision 1.20  2003/04/21 17:07:41  harald
;  * Comments added
;  *
;  * Revision 1.19  2003/03/31 14:46:41  harald
;  * Broadcasts clear signaled queues
;  *
;  * Revision 1.18  2003/02/04 18:15:56  harald
;  * Version 3 released
;  *
;  * Revision 1.17  2003/01/14 16:56:39  harald
;  * Racing condition on signaled events fixed.
;  * All posting routines return the number of woken up threads.
;  *
;  * Revision 1.16  2002/06/26 17:29:44  harald
;  * First pre-release with 2.4 stack
;  *
;  */
; 
; #include <cfg/os.h>
; 
; #include <compiler.h>
; #include <sys/atom.h>
; #include <sys/heap.h>
; #include <sys/timer.h>
; #include <sys/thread.h>
; #include <sys/event.h>
; 
; #ifdef NUTDEBUG
; #include <sys/osdebug.h>
; #include <stdio.h>
; #endif
; 
; #ifdef NUTTRACER
; #include <sys/tracer.h>
; #endif
; 
; /*!
;  * \addtogroup xgEvent
;  */
; /*@{*/
; 
; 
; /*!
;  * \brief Timer callback in case of event timeout.
;  *
;  * \param timer Handle of the elapsed timeout timer.
;  * \param arg   Handle of an event queue.
;  *
;  */
; void NutEventTimeout(HANDLE timer, void *arg)
; {
;     NUTTHREADINFO *tqp;
;     NUTTHREADINFO *volatile *tqpp = arg;
	movw R22,R18
; 
;     /*
;      * A signaled queue is an empty queue. So our
;      * thread already left this queue.
;      */
;     if ((tqp = *tqpp) != SIGNALED) {
	movw R30,R22
	ldd R2,z+0
	ldd R3,z+1
	movw R20,R2
	cpi R20,255
	ldi R30,255
	cpc R21,R30
	brne X3
	xjmp L2
X3:
X0:
	xjmp L5
L4:
; 
;         /*
;          * Walk down the linked list and identify
;          * the thread by the timer id it is waiting
;          * for.
;          */
;         while (tqp) {
;             if (tqp->td_timer == timer) {
	movw R30,R20
	ldd R2,z+19
	ldd R3,z+20
	cp R2,R16
	cpc R3,R17
	brne L7
X1:
;                 /* Found the thread. Remove it from the event queue and
;                    add it to the queue of threads, which are waiting to
;                    become ready at the next context switch. */
;                 *tqpp = tqp->td_qnxt;
	ldd R2,z+2
	ldd R3,z+3
	movw R30,R22
	std z+1,R3
	std z+0,R2
;                 /* protected access to readyList */
;                 NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
;                 tqp->td_qnxt = readyQueue;
	lds R2,_readyQueue
	lds R3,_readyQueue+1
	movw R30,R20
	std z+3,R3
	std z+2,R2
;                 readyQueue = tqp;
	sts _readyQueue+1,R21
	sts _readyQueue,R20
;                 NutExitCritical();
	pop R0
	out 0x3F, R0
	
;                 
;                 /* Clear the timer entry in the thread's info structure.
;                    This will tell the waiting thread, that it has been
;                    woken up by a timeout. */
;                 tqp->td_timer = 0;
	clr R2
	clr R3
	std z+20,R3
	std z+19,R2
;                 break;
	xjmp L6
L7:
;             }
;             tqpp = &tqp->td_qnxt;
	movw R22,R20
	subi R22,254  ; offset = 2
	sbci R23,255
;             tqp = tqp->td_qnxt;
	movw R30,R20
	ldd R20,z+2
	ldd R21,z+3
;         }
L5:
	cpi R20,0
	cpc R20,R21
	breq X4
	xjmp L4
X4:
X2:
L6:
;     }
L2:
L1:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
;          ticks -> y+5
;             tn -> R10,R11
;             ms -> y+13
;            qhp -> R12,R13
	.even
_NutEventWait::
	st -y,r19
	st -y,r18
	xcall push_xgset003C
	movw R12,R16
	sbiw R28,9
; }
; 
; /*!
;  * \brief Wait for an event in a specified queue.
;  *
;  * Give up the CPU until another thread posts an event to this queue 
;  * or until a time-out occurs, whichever comes first.
;  *
;  * If previously an event had been posted to this queue without any 
;  * thread waiting, then the thread will not wait for a new event,
;  * but may still pass CPU control, if another thread with equal or
;  * higher priority is ready to run.
;  *
;  * \param qhp Identifies the queue to wait on.
;  * \param ms  Maximum wait time in milliseconds. To disable timeout,
;  *            set this parameter to NUT_WAIT_INFINITE.
;  *
;  * \return 0 if event received, -1 on timeout.
;  *
;  * \note Timeout is limited to the granularity of the system timer.
;  */
; int NutEventWait(volatile HANDLE * qhp, u_long ms)
; {
;     u_long ticks;
;     NUTTIMERINFO *tn;
;     
;     /*
;      * If a timeout value had been given, create
;      * a oneshot timer.
;      */
;     if (ms) {
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	ldd R2,y+13
	ldd R3,y+14
	ldd R4,y+15
	ldd R5,y+16
	cp R2,R24
	cpc R3,R25
	cpc R4,R26
	cpc R5,R27
	breq L10
X5:
;         ticks = NutTimerMillisToTicks(ms);
	movw R16,R2
	movw R18,R4
	xcall _NutTimerMillisToTicks
	std y+5,R16
	std y+6,R17
	std y+7,R18
	std y+8,R19
;         tn = NutTimerCreate(ticks, NutEventTimeout, (void *) qhp, TM_ONESHOT);
	ldi R24,1
	std y+4,R24
	std y+3,R13
	std y+2,R12
	ldi R24,<PL_NutEventTimeout
	ldi R25,>PL_NutEventTimeout
	std y+1,R25
	std y+0,R24
	ldd R16,y+5
	ldd R17,y+6
	ldd R18,y+7
	ldd R19,y+8
	xcall _NutTimerCreate
	movw R10,R16
;     } else
	xjmp L11
L10:
;         tn = 0;
	clr R10
	clr R11
L11:
; 
;     NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
; 
;     /*
;      * Check for posts on a previously empty queue. 
;      */
;     if (*qhp == SIGNALED) {
	movw R30,R12
	ldd R24,z+0
	ldd R25,z+1
	cpi R24,255
	ldi R26,255
	cpc R25,R26
	brne L12
X6:
;         /*
;          * Even if already signaled, switch to any other thread, which 
;          * is ready to run and has the same or higher priority.
;          */
;         *qhp = 0;
	clr R2
	clr R3
	std z+1,R3
	std z+0,R2
;         NutJumpOutCritical();
	pop R0
	out 0x3F, R0
	
;         
;         /* but free previously allocated timer first */
;         if (tn)
	tst R10
	brne X7
	tst R11
	breq L14
X7:
;             NutHeapFree(tn);
	movw R16,R10
	xcall _NutHeapFree
L14:
; 
;         NutThreadYield();
	xcall _NutThreadYield
;         return 0;
	clr R16
	clr R17
	xjmp L9
L12:
;     }
; 
;     /*
;      * Remove the current thread from the list
;      * of running threads and add it to the
;      * specified queue.
;      */
; 
;     // NutThreadRemoveQueue(runningThread, &runQueue); basically would do the following:
;     runQueue = runQueue->td_qnxt;
	lds R30,_runQueue
	lds R31,_runQueue+1
	ldd R2,z+2
	ldd R3,z+3
	sts _runQueue+1,R3
	sts _runQueue,R2
;     runningThread->td_qnxt = 0;
	clr R2
	clr R3
	lds R30,_runningThread
	lds R31,_runningThread+1
	std z+3,R3
	std z+2,R2
;     runningThread->td_queue = 0;
	std z+22,R3
	std z+21,R2
; 
;     NutThreadAddPriQueue(runningThread, (NUTTHREADINFO **) qhp);
	movw R18,R12
	movw R16,R30
	xcall _NutThreadAddPriQueue
; 
;     NutExitCritical();
	pop R0
	out 0x3F, R0
	
; 
;     /* update our thread's state (sleeping + timer) */
;     runningThread->td_state = TDS_SLEEP;
	ldi R24,3
	lds R30,_runningThread
	lds R31,_runningThread+1
	std z+13,R24
;     runningThread->td_timer = tn;
	lds R30,_runningThread
	lds R31,_runningThread+1
	std z+20,R11
	std z+19,R10
;     if (tn)
	tst R10
	brne X8
	tst R11
	breq L16
X8:
;         NutTimerInsert(tn);
	movw R16,R10
	xcall _NutTimerInsert
L16:
; 
; #ifdef NUTDEBUG
;     if (__os_trf) {
;         static prog_char fmt1[] = "Rem<%p>";
;         fprintf_P(__os_trs, fmt1, runningThread);
;         NutDumpThreadList(__os_trs);
;     }
; #endif
;     
;     /*
;      * Switch to the next thread, which is ready
;      * to run.
;      */
; #ifdef NUTDEBUG
;     if (__os_trf) {
;         static prog_char fmt2[] = "SWW<%p %p>";
;         fprintf_P(__os_trs, fmt2, runningThread, runQueue);
;     }
; #endif
; #ifdef NUTTRACER
;     TRACE_ADD_ITEM(TRACE_TAG_THREAD_WAIT,(int)runningThread);
; #endif
; 
;     NutThreadResume();
	xcall _NutThreadResume
; 
;     /*
;      * If our timer handle is still set, we were
;      * woken up by an event. If the handle is
;      * cleared and a timeout value had been
;      * specified, then we know that a timeout
;      * occured.
;      */
;     if (runningThread->td_timer)
	lds R30,_runningThread
	lds R31,_runningThread+1
	ldd R2,z+19
	ldd R3,z+20
	tst R2
	brne X9
	tst R3
	breq L18
X9:
;         runningThread->td_timer = 0;
	clr R2
	clr R3
	std z+20,R3
	std z+19,R2
	xjmp L19
L18:
;     else if (ms) {
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	ldd R2,y+13
	ldd R3,y+14
	ldd R4,y+15
	ldd R5,y+16
	cp R2,R24
	cpc R3,R25
	cpc R4,R26
	cpc R5,R27
	breq L20
X10:
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L9
L20:
L19:
;     }
;     return 0;
	clr R16
	clr R17
L9:
	.dbline 0 ; func end
	adiw R28,9
	xcall pop_xgset003C
	adiw R28,2
	ret
;             ms -> y+4
;            qhp -> R10,R11
	.even
_NutEventWaitNext::
	st -y,r19
	st -y,r18
	st -y,R10
	st -y,R11
	movw R10,R16
	sbiw R28,2
; }
; 
; /*!
;  * \brief Wait for a new event in a specified queue.
;  *
;  * Give up the CPU until another thread posts an event to this
;  * queue or until a time-out occurs, whichever comes first.
;  *
;  * This call is similar to NutEventWait(), but will ignore the
;  * signaled state of the queue. This way, previously posted events to 
;  * an empty queue are not considered.
;  *
;  * \param qhp Identifies the queue to wait on.
;  * \param ms  Maximum wait time in milliseconds.
;  *
;  * \return 0 if event received, -1 on timeout.
;  *
;  * \note Timeout is limited to the granularity of the system timer.
;  */
; int NutEventWaitNext(volatile HANDLE * qhp, u_long ms)
; {
;     NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
; 
;     /*
;      * Check for posts on a previously empty queue. 
;      */
;     if (*qhp == SIGNALED)
	movw R30,R10
	ldd R24,z+0
	ldd R25,z+1
	cpi R24,255
	ldi R26,255
	cpc R25,R26
	brne L23
X11:
;         *qhp = 0;
	clr R2
	clr R3
	std z+1,R3
	std z+0,R2
L23:
; 
;     NutExitCritical();
	pop R0
	out 0x3F, R0
	
; 
;     return NutEventWait(qhp, ms);
	ldd R2,y+4
	ldd R3,y+5
	ldd R4,y+6
	ldd R5,y+7
	std y+0,R4
	std y+1,R5
	movw R18,R2
	movw R16,R10
	xcall _NutEventWait
L22:
	.dbline 0 ; func end
	adiw R28,2
	ld R11,y+
	ld R10,y+
	adiw R28,2
	ret
;             td -> R20,R21
;            qhp -> R10,R11
	.even
_NutEventPostAsync::
	xcall push_xgset300C
	movw R10,R16
; }
; 
; /*!
;  * \brief Asynchronously post an event to a specified queue.
;  *
;  * Wake up the thread with the highest priority waiting on the 
;  * specified queue. But even if the priority of the woken thread is 
;  * higher than the current thread's priority, the current one 
;  * continues running.
;  *
;  * If no thread is waiting, then the queue will be set to the signaled
;  * state. 
;  *
;  * \param qhp Identifies the queue an event is posted to.
;  *
;  * \return The number of threads woken up, either 0 or 1.
;  *
;  */
; int NutEventPostAsync(HANDLE volatile *qhp)
; {
;     /*
;      * so far, the code is identical to NutEventPostIrq
;      * but has to use Critical Sections
;      */ 
;     
;     NUTTHREADINFO *td;
;     
;     NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
; 
;     /* Ignore signaled queues. */
;     if (*qhp != SIGNALED) {
	movw R30,R10
	ldd R24,z+0
	ldd R25,z+1
	cpi R24,255
	ldi R26,255
	cpc R25,R26
	brne X15
	xjmp L26
X15:
X12:
;         
;         /* A thread is waiting. */
;         if ((td = *qhp) != 0) {
	ldd R2,z+0
	ldd R3,z+1
	movw R20,R2
	cpi R20,0
	cpc R20,R21
	breq L28
X13:
;             /* Remove the thread from the wait queue. */
;             *qhp = td->td_qnxt;
	movw R30,R2
	ldd R2,z+2
	ldd R3,z+3
	movw R30,R10
	std z+1,R3
	std z+0,R2
;             /* Stop any running timeout timer. */
;             if (td->td_timer) {
	movw R30,R20
	ldd R2,z+19
	ldd R3,z+20
	tst R2
	brne X14
	tst R3
	breq L30
X14:
;                 NutTimerStopAsync(td->td_timer);
	ldd R16,z+19
	ldd R17,z+20
	xcall _NutTimerStopAsync
;             }
L30:
;             /* Add the thread to the ready queue. */
;             td->td_qnxt = readyQueue;
	lds R2,_readyQueue
	lds R3,_readyQueue+1
	movw R30,R20
	std z+3,R3
	std z+2,R2
;             readyQueue = td;
	sts _readyQueue+1,R21
	sts _readyQueue,R20
;             
;             NutJumpOutCritical();
	pop R0
	out 0x3F, R0
	
; 
;             return 1;
	ldi R16,1
	ldi R17,0
	xjmp L25
L28:
;         }
;         
;         /* No thread is waiting. Mark the queue signaled. */
;         else {
;             *qhp = SIGNALED;
	ldi R24,65535
	ldi R25,255
	movw R30,R10
	std z+1,R25
	std z+0,R24
;         }
;     }
L26:
;     
;     NutExitCritical();
	pop R0
	out 0x3F, R0
	
; 
;     return 0;
	clr R16
	clr R17
L25:
	.dbline 0 ; func end
	xjmp pop_xgset300C
;             td -> R20,R21
;            qhp -> R10,R11
	.even
_NutEventPostFromIrq::
	xcall push_xgset300C
	movw R10,R16
; }
; 
; 
; /*!
; * \brief Asynchronously post an event to a specified queue from IRQ.
;  *
;  * Wake up the thread with the highest priority waiting on the 
;  * specified queue. This function is explicitly provided for IRQ
;  * handlers to wakeup waiting user threads
;  *
;  * \note It is save to call this function from within an interrupt
;  *       handler.
;  *
;  * \param qhp Identifies the queue an event is posted to.
;  *
;  * \return The number of threads woken up, either 0 or 1.
;  *
;  */
; int NutEventPostFromIrq(HANDLE volatile *qhp)
; {
;     /*
;      * so far, the code is identical to NutEventPostAsync
;      * but has to no Critical Sections
;      */ 
; 
;     NUTTHREADINFO *td;
; 
;     /* Ignore signaled queues. */
;     if (*qhp != SIGNALED) {
	movw R30,R10
	ldd R24,z+0
	ldd R25,z+1
	cpi R24,255
	ldi R26,255
	cpc R25,R26
	brne X19
	xjmp L33
X19:
X16:
; 
;         /* A thread is waiting. */
;         if ((td = *qhp) != 0) {
	ldd R2,z+0
	ldd R3,z+1
	movw R20,R2
	cpi R20,0
	cpc R20,R21
	breq L35
X17:
;             /* Remove the thread from the wait queue. */
;             *qhp = td->td_qnxt;
	movw R30,R2
	ldd R2,z+2
	ldd R3,z+3
	movw R30,R10
	std z+1,R3
	std z+0,R2
;             /* Stop any running timeout timer. */
;             if (td->td_timer) {
	movw R30,R20
	ldd R2,z+19
	ldd R3,z+20
	tst R2
	brne X18
	tst R3
	breq L37
X18:
;                 NutTimerStopAsync(td->td_timer);
	ldd R16,z+19
	ldd R17,z+20
	xcall _NutTimerStopAsync
;             }
L37:
;             /* Add the thread to the ready queue. */
;             td->td_qnxt = readyQueue;
	lds R2,_readyQueue
	lds R3,_readyQueue+1
	movw R30,R20
	std z+3,R3
	std z+2,R2
;             readyQueue = td;
	sts _readyQueue+1,R21
	sts _readyQueue,R20
; 
;             return 1;
	ldi R16,1
	ldi R17,0
	xjmp L32
L35:
;         }
; 
;         /* No thread is waiting. Mark the queue signaled. */
;         else {
;             *qhp = SIGNALED;
	ldi R24,65535
	ldi R25,255
	movw R30,R10
	std z+1,R25
	std z+0,R24
;         }
;     }
L33:
;     return 0;
	clr R16
	clr R17
L32:
	.dbline 0 ; func end
	xjmp pop_xgset300C
;             rc -> R10,R11
;            qhp -> R10,R11
	.even
_NutEventPost::
	st -y,R10
	st -y,R11
	movw R10,R16
; }
; 
; /*!
;  * \brief Post an event to a specified queue.
;  *
;  * Wake up the thread with the highest priority waiting on this queue. 
;  * If the priority of the waiting thread is higher or equal than the 
;  * current thread's priority, then the current thread is stopped and 
;  * CPU control is passed to the waiting thread.
;  *
;  * If no thread is waiting, the queue will be set to the signaled
;  * state. 
;  *
;  * \param qhp Identifies the queue an event is posted to.
;  *
;  * \return The number of threads woken up, either 0 or 1.
;  *
;  */
; int NutEventPost(HANDLE * qhp)
; {
;     int rc;
; 
;     rc = NutEventPostAsync(qhp);
	movw R16,R10
	xcall _NutEventPostAsync
	movw R10,R16
; 
;     /*
;      * If any thread with higher or equal priority is
;      * ready to run, switch the context.
;      */
;     NutThreadYield();
	xcall _NutThreadYield
; 
;     return rc;
	movw R16,R10
L39:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
;             rc -> R10,R11
;            qhp -> R12,R13
	.even
_NutEventBroadcastAsync::
	xcall push_xgset003C
	movw R12,R16
; }
; 
; /*!
;  * \brief Asynchronously broadcast an event to a specified queue.
;  *
;  * Wake up all threads waiting on this queue. But even if the
;  * priority of any woken thread is higher than the current thread's
;  * priority, the current one continues running.
;  *
;  * In opposite to NutEventPostAsync(), the queue will be cleared in 
;  * any case, even if it is in signaled state. Applications may use this
;  * call to make sure, that a queue is cleared before initiating some 
;  * event triggering action.
;  *
;  * \note It is save to call this function from within an interrupt
;  *       handler. 
;  *
;  * \param qhp Identifies the queue an event is broadcasted to.
;  *
;  * \return The number of threads woken up.
;  *
;  */
; int NutEventBroadcastAsync(HANDLE * qhp)
; {
;     int rc = 0;
	clr R10
	clr R11
; 
;     if (*qhp == SIGNALED)
	movw R30,R12
	ldd R24,z+0
	ldd R25,z+1
	cpi R24,255
	ldi R26,255
	cpc R25,R26
	brne L44
X20:
;         *qhp = 0;
	clr R2
	clr R3
	std z+1,R3
	std z+0,R2
	xjmp L42
L43:
;     else
;         while (*qhp)
;             rc += NutEventPostAsync(qhp);
	movw R16,R12
	xcall _NutEventPostAsync
	add R10,R16
	adc R11,R17
L44:
	movw R30,R12
	ldd R2,z+0
	ldd R3,z+1
	tst R2
	brne L43
	tst R3
	brne L43
X21:
L42:
; 
;     return rc;
	movw R16,R10
L40:
	.dbline 0 ; func end
	xjmp pop_xgset003C
;             rc -> R10,R11
;            qhp -> R12,R13
	.even
_NutEventBroadcast::
	xcall push_xgset003C
	movw R12,R16
; }
; 
; /*!
;  * \brief Broadcast an event to a specified queue.
;  *
;  * Wake up all threads waiting on this queue. If the priority of any 
;  * waiting thread is higher or equal than the current thread's 
;  * priority, then the current thread is stopped and CPU control is 
;  * passed to the woken up thread with the highest priority.
;  *
;  * In opposite to NutEventPost(), the queue will be cleared in any
;  * case, even if it is in signaled state. Applications may use this
;  * call to make sure, that a queue is cleared before initiating
;  * some event triggering action.
;  *
;  * \param qhp Identifies the queue an event is broadcasted to.
;  *
;  * \return The number of threads woken up.
;  *
;  */
; int NutEventBroadcast(HANDLE * qhp)
; {
;     int rc = 0;
	clr R10
	clr R11
; 
;     if (*qhp == SIGNALED)
	movw R30,R12
	ldd R24,z+0
	ldd R25,z+1
	cpi R24,255
	ldi R26,255
	cpc R25,R26
	brne L50
X22:
;         *qhp = 0;
	clr R2
	clr R3
	std z+1,R3
	std z+0,R2
	xjmp L48
L49:
;     else
;         while (*qhp)
;             rc += NutEventPost(qhp);
	movw R16,R12
	xcall _NutEventPost
	add R10,R16
	adc R11,R17
L50:
	movw R30,R12
	ldd R2,z+0
	ldd R3,z+1
	tst R2
	brne L49
	tst R3
	brne L49
X23:
L48:
; 
;     return rc;
	movw R16,R10
L46:
	.dbline 0 ; func end
	xjmp pop_xgset003C
; }
; 
; /*@}*/
	.area func_lit
PL_NutEventTimeout:	.word `_NutEventTimeout
