	.module heap.c
	.area data(ram, con, rel)
_heapFreeList::
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
_available::
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.area text(rom, con, rel)
;            fpp -> R10,R11
;            npp -> R12,R13
;            fit -> R20,R21
;           node -> R22,R23
;           size -> R16,R17
	.even
_NutHeapAlloc::
	xcall push_xgsetF03C
; /*
;  * Copyright (C) 2001-2005 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  * -
;  * Portions Copyright (C) 2000 David J. Hudson <dave@humbug.demon.co.uk>
;  *
;  * This file is distributed in the hope that it will be useful, but WITHOUT
;  * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;  * FITNESS FOR A PARTICULAR PURPOSE.
;  *
;  * You can redistribute this file and/or modify it under the terms of the GNU
;  * General Public License (GPL) as published by the Free Software Foundation;
;  * either version 2 of the License, or (at your discretion) any later version.
;  * See the accompanying file "copying-gpl.txt" for more details.
;  *
;  * As a special exception to the GPL, permission is granted for additional
;  * uses of the text contained in this file.  See the accompanying file
;  * "copying-liquorice.txt" for details.
;  */
; 
; /*
;  * $Log: heap.c,v $
;  * Revision 1.9  2005/08/02 17:47:04  haraldkipp
;  * Major API documentation update.
;  *
;  * Revision 1.8  2005/07/26 15:49:59  haraldkipp
;  * Cygwin support added.
;  *
;  * Revision 1.7  2005/04/30 16:42:42  chaac
;  * Fixed bug in handling of NUTDEBUG. Added include for cfg/os.h. If NUTDEBUG
;  * is defined in NutConf, it will make effect where it is used.
;  *
;  * Revision 1.6  2004/11/08 18:15:02  haraldkipp
;  * Very bad hack to support 32-bit boundaries.
;  *
;  * Revision 1.5  2004/04/07 12:13:58  haraldkipp
;  * Matthias Ringwald's *nix emulation added
;  *
;  * Revision 1.4  2004/03/19 09:05:12  jdubiec
;  * Fixed format strings declarations for AVR.
;  *
;  * Revision 1.3  2004/03/16 16:48:45  haraldkipp
;  * Added Jan Dubiec's H8/300 port.
;  *
;  * Revision 1.2  2003/07/20 16:04:36  haraldkipp
;  * Nicer debug output
;  *
;  * Revision 1.1.1.1  2003/05/09 14:41:49  haraldkipp
;  * Initial using 3.2.1
;  *
;  * Revision 1.18  2003/05/06 18:53:10  harald
;  * Use trace flag
;  *
;  * Revision 1.17  2003/03/31 14:53:30  harald
;  * Prepare release 3.1
;  *
;  * Revision 1.16  2003/02/04 18:15:56  harald
;  * Version 3 released
;  *
;  * Revision 1.15  2002/06/26 17:29:44  harald
;  * First pre-release with 2.4 stack
;  *
;  */
; 
; /*!
;  * \addtogroup xgHeap
;  */
; 
; /*@{*/
; 
; #include <cfg/os.h>
; #include <compiler.h>
; #include <string.h>
; 
; #include <sys/atom.h>
; #include <sys/heap.h>
; 
; #ifdef NUTDEBUG
; #include <sys/osdebug.h>
; #endif
; 
; #if defined(__arm__) || defined(__m68k__) || defined(__H8300H__) || defined(__H8300S__) || defined(__linux__) || defined(__APPLE__) || defined(__CYGWIN__)
; #define ARCH_32BIT
; #endif
; 
; /*!
;  * \brief List of free nodes.
;  */
; HEAPNODE *volatile heapFreeList = 0;
; 
; /*!
;  * \brief Number of bytes available.
;  */
; size_t available = 0;
; 
; /*!
;  * \brief Overhead for each allocated memory clock.
;  * \showinitializer
;  */
; /* MEMOVHD = sizeof(HEAPNODE:hn_size) + sizeof(0xDEADBEEF) */
; #define MEMOVHD (sizeof(size_t) + sizeof(0xDEADBEEF))
; 
; /*!
;  * \brief
;  * Allocate a block from heap memory.
;  *
;  * This functions allocates a memory block of the specified
;  * size and returns a pointer to that block.
;  *
;  * The actual size of the allocated block is larger than the
;  * requested size because of space required for maintenance
;  * information. This additional information is invisible to
;  * the application.
;  *
;  * The routine looks for the smallest block that will meet
;  * the required size and releases it to the caller. If the
;  * block being requested is usefully smaller than the smallest
;  * free block then the block from which the request is being
;  * met is split in two. The unused portion is put back into
;  * the free-list.
;  *
;  * The contents of the allocated block is unspecified.
;  * To allocate a block with all bytes set to zero use
;  * NutHeapAllocClear().
;  *
;  * \note Do not use this function in interrupt routines.
;  *
;  * \param size Size of the requested memory block.
;  *
;  * \return Pointer to the allocated memory block if the
;  *         function is successful or NULL if the requested
;  *         amount of memory is not available.
;  */
; void *NutHeapAlloc(size_t size)
; {
; #ifdef NUTDEBUG
; #ifdef ARCH_32BIT
;     static prog_char fmt[] = "\n[H%lx,A%09ld/%ld] ";
; #else
;     static prog_char fmt[] = "\n[H%x,A%04d/%d] ";
; #endif
; #endif
;     HEAPNODE *node;
;     HEAPNODE **npp;
;     HEAPNODE *fit = 0;
	clr R20
	clr R21
;     HEAPNODE **fpp = 0;
	clr R10
	clr R11
; 
; #if defined(__arm__) || defined(__m68k__) || defined(__H8300H__) || defined(__H8300S__) || defined(__linux__) || defined(__APPLE__) || defined(__CYGWIN__)
;     /*
;      * Allign to the word boundary
;      */
;     while ((size & 0x03) != 0)
;         size++;
; #endif
; 
;     if (size >= available) {
	lds R2,_available
	lds R3,_available+1
	cp R16,R2
	cpc R17,R3
	brlo L2
X0:
; #ifdef NUTDEBUG
;         if (__heap_trf)
;             fputs("MEMOVR\n", __heap_trs);
; #endif
;         return 0;
	clr R16
	clr R17
	xjmp L1
L2:
;     }
; 
;     /*
;      * We need additional space in front of the allocated memory
;      * block to store its size. If this is still less than the
;      * space required by a free node, increase it.
;      */
;     if ((size += MEMOVHD) < sizeof(HEAPNODE))
	movw R24,R16
	adiw R24,6
	movw R16,R24
	cpi R16,4
	ldi R30,0
	cpc R17,R30
	brsh L4
X1:
;         size = sizeof(HEAPNODE);
	ldi R16,4
	ldi R17,0
L4:
; 
;     /*
;      * Walk through the linked list of free nodes and find the best fit.
;      */
;     node = heapFreeList;
	lds R22,_heapFreeList
	lds R23,_heapFreeList+1
;     npp = (HEAPNODE **) & heapFreeList;
	ldi R24,<_heapFreeList
	ldi R25,>_heapFreeList
	movw R12,R24
	xjmp L7
L6:
;     while (node) {
; 
;         /*
;          * Found a note that fits?
;          */
;         if (node->hn_size >= size) {
	movw R30,R22
	ldd R2,z+0
	ldd R3,z+1
	cp R2,R16
	cpc R3,R17
	brlo L9
X2:
;             /*
;              * If it's an exact match, we don't
;              * search any further.
;              */
;             if (node->hn_size == size) {
	cp R2,R16
	cpc R3,R17
	brne L11
X3:
;                 fit = node;
	movw R20,R30
;                 fpp = npp;
	movw R10,R12
;                 break;
	xjmp L8
L11:
;             }
; 
;             /*
;              * Is it the first one we found
;              * or was the previous one larger?
;              */
;             if (fit == 0 || (fit->hn_size > node->hn_size)) {
	cpi R20,0
	cpc R20,R21
	breq L15
X4:
	movw R30,R22
	ldd R2,z+0
	ldd R3,z+1
	movw R30,R20
	ldd R4,z+0
	ldd R5,z+1
	cp R2,R4
	cpc R3,R5
	brsh L13
X5:
L15:
;                 fit = node;
	movw R20,R22
;                 fpp = npp;
	movw R10,R12
;             }
L13:
;         }
L9:
;         npp = &node->hn_next;
	movw R24,R22
	adiw R24,2
	movw R12,R24
;         node = node->hn_next;
	movw R30,R22
	ldd R22,z+2
	ldd R23,z+3
;     }
L7:
	cpi R22,0
	cpc R22,R23
	breq X9
	xjmp L6
X9:
X6:
L8:
; 
;     if (fit) {
	cpi R20,0
	cpc R20,R21
	brne X10
	xjmp L16
X10:
X7:
;         /*
;          * If the node we found is larger than the
;          * required space plus the space needed for
;          * a new node plus a defined threshold, then
;          * we split it.
;          */
;         if (fit->hn_size > size + sizeof(HEAPNODE) + ALLOC_THRESHOLD) {
	movw R24,R16
	adiw R24,10
	movw R30,R20
	ldd R2,z+0
	ldd R3,z+1
	cp R24,R2
	cpc R25,R3
	brsh L18
X8:
;             node = (HEAPNODE *) ((uptr_t) fit + size);
	movw R22,R30
	add R22,R16
	adc R23,R17
;             node->hn_size = fit->hn_size - size;
	sub R2,R16
	sbc R3,R17
	movw R30,R22
	std z+1,R3
	std z+0,R2
;             node->hn_next = fit->hn_next;
	movw R30,R20
	ldd R2,z+2
	ldd R3,z+3
	movw R30,R22
	std z+3,R3
	std z+2,R2
;             fit->hn_size = size;
	movw R30,R20
	std z+1,R17
	std z+0,R16
;             *fpp = node;
	movw R30,R10
	std z+1,R23
	std z+0,R22
;         } else
	xjmp L19
L18:
;             *fpp = fit->hn_next;
	movw R30,R20
	ldd R2,z+2
	ldd R3,z+3
	movw R30,R10
	std z+1,R3
	std z+0,R2
L19:
; 
;         available -= fit->hn_size;
	movw R30,R20
	ldd R2,z+0
	ldd R3,z+1
	lds R4,_available
	lds R5,_available+1
	sub R4,R2
	sbc R5,R3
	sts _available+1,R5
	sts _available,R4
;         *((u_long *) (((char *) fit) + (fit->hn_size - 4))) = 0xDEADBEEF;
	push R26
	push R27
	ldd R26,z+0
	ldd R27,z+1
	movw R30,R26
	pop R27
	pop R26
	sbiw R30,4
	add R30,R20
	adc R31,R21
	ldi R24,239
	ldi R25,190
	ldi R26,173
	ldi R27,222
	std z+0,R24
	std z+1,R25
	std z+2,R26
	std z+3,R27
;         fit = (HEAPNODE *) & fit->hn_next;
	subi R20,254  ; offset = 2
	sbci R21,255
;     }
L16:
; #ifdef NUTDEBUG
;     if (__heap_trf)
;         fprintf_P(__heap_trs, fmt, (uptr_t) fit, ((HEAPNODE *) (((uptr_t *) fit) - 1))->hn_size, size);
; #endif
;     return fit;
	movw R16,R20
L1:
	.dbline 0 ; func end
	xjmp pop_xgsetF03C
;            ptr -> R10,R11
;           size -> R12,R13
	.even
_NutHeapAllocClear::
	xcall push_xgset003C
	movw R12,R16
	sbiw R28,2
; }
; 
; /*!
;  * \brief Allocate an initialized block from heap memory.
;  *
;  * This functions allocates a memory block of the specified
;  * size with all bytes initialized to zero and returns a
;  * pointer to that block.
;  *
;  * \param size Size of the requested memory block.
;  *
;  * \return Pointer to the allocated memory block if the
;  *         function is successful or NULL if the requested
;  *         amount of memory is not available.
;  */
; void *NutHeapAllocClear(size_t size)
; {
;     void *ptr;
; 
;     if ((ptr = NutHeapAlloc(size)) != 0)
	movw R16,R12
	xcall _NutHeapAlloc
	movw R10,R16
	tst R10
	brne X11
	tst R11
	breq L21
X11:
;         memset(ptr, 0, size);
	std y+1,R13
	std y+0,R12
	clr R18
	clr R19
	xcall _memset
L21:
; 
;     return ptr;
	movw R16,R10
L20:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgset003C
;            npp -> R22,R23
;          fnode -> R20,R21
;           node -> R10,R11
;          block -> R16,R17
	.even
_NutHeapFree::
	xcall push_xgsetF00C
; }
; 
; /*!
;  * \brief Return a block to heap memory.
;  *
;  * An application calls this function, when a previously
;  * allocated memory block is no longer needed.
;  *
;  * The heap manager checks, if the released block adjoins any
;  * other free regions. If it does, then the adjacent free regions
;  * are joined together to form one larger region.
;  *
;  * \note Do not use this function in interrupt routines.
;  *
;  * \param block Points to a memory block previously allocated
;  *              through a call to NutHeapAlloc().
;  *
;  * \return 0 on success, -1 if the caller tried to free
;  *         a block which had been previously released.
;  */
; int NutHeapFree(void *block)
; {
; #ifdef NUTDEBUG
; #ifdef ARCH_32BIT
;     static prog_char fmt[] = "\n[H%lx,F%09ld] ";
; #else
;     static prog_char fmt[] = "\n[H%x,F%04d] ";
; #endif
; #endif
;     HEAPNODE *node;
;     HEAPNODE **npp;
;     HEAPNODE *fnode;
; 
;     //NutEnterCritical();
; #ifdef NUTDEBUG
;     if (__heap_trf) {
;         if (block) {
;             size_t size;
;             size = *(((uptr_t *) block) - 1);
;             if (*((u_long *) (((char *) block) + (size - MEMOVHD))) != 0xDEADBEEF)
;                 fputs("\nMEMCORR-", __heap_trs);
; 
;         } else
;             fputs("\nMEMNULL", __heap_trs);
;     }
; #endif
; 
;     /*
;      * Convert our block into a node.
;      */
;     fnode = (HEAPNODE *) (((uptr_t *) block) - 1);
	movw R20,R16
	subi R20,2
	sbci R21,0
; 
; #ifdef NUTDEBUG
;     if (__heap_trf)
;         fprintf_P(__heap_trs, fmt, (uptr_t) block, fnode->hn_size);
; #endif
;     available += fnode->hn_size;
	movw R30,R20
	ldd R2,z+0
	ldd R3,z+1
	lds R4,_available
	lds R5,_available+1
	add R4,R2
	adc R5,R3
	sts _available+1,R5
	sts _available,R4
; 
;     /*
;      * Walk through the linked list of free nodes and try
;      * to link us in.
;      */
;     node = heapFreeList;
	lds R10,_heapFreeList
	lds R11,_heapFreeList+1
;     npp = (HEAPNODE **) & heapFreeList;
	ldi R22,<_heapFreeList
	ldi R23,>_heapFreeList
	xjmp L25
L24:
;     while (node) {
;         /*
;          * If there' s a free node in front of us, merge it.
;          */
;         if (((uptr_t) node + node->hn_size) == (uptr_t) fnode) {
	movw R30,R10
	ldd R2,z+0
	ldd R3,z+1
	movw R4,R30
	add R4,R2
	adc R5,R3
	cp R4,R20
	cpc R5,R21
	breq X19
	xjmp L27
X19:
X12:
;             node->hn_size += fnode->hn_size;
	movw R30,R20
	ldd R2,z+0
	ldd R3,z+1
	movw R30,R10
	ldd R4,z+0
	ldd R5,z+1
	add R4,R2
	adc R5,R3
	std z+1,R5
	std z+0,R4
; 
;             /*
;              * If a free node is following us, merge it.
;              */
;             if (((uptr_t) node + node->hn_size) == (uptr_t) node->hn_next) {
	ldd R2,z+0
	ldd R3,z+1
	movw R4,R30
	add R4,R2
	adc R5,R3
	ldd R2,z+2
	ldd R3,z+3
	cp R4,R2
	cpc R5,R3
	breq X20
	xjmp L26
X20:
X13:
;                 node->hn_size += node->hn_next->hn_size;
	ldd R26,z+2
	ldd R27,z+3
	ld R2,x+
	ld R3,x
	ldd R4,z+0
	ldd R5,z+1
	add R4,R2
	adc R5,R3
	std z+1,R5
	std z+0,R4
;                 node->hn_next = node->hn_next->hn_next;
	movw R24,R30
	adiw R24,2
	movw R30,R24
	ldd R26,z+0
	ldd R27,z+1
	adiw R26,2
	ld R2,x+
	ld R3,x
	std z+1,R3
	std z+0,R2
;             }
;             break;
	xjmp L26
L27:
;         }
; 
;         /*
;          * If we walked past our address, link us to the list.
;          */
;         if ((uptr_t) node > (uptr_t) fnode) {
	cp R20,R10
	cpc R21,R11
	brlo X21
	xjmp L31
X21:
X14:
;             *npp = fnode;
	movw R30,R22
	std z+1,R21
	std z+0,R20
; 
;             /*
;              * If a free node is following us, merge it.
;              */
;             if (((uptr_t) fnode + fnode->hn_size) == (uptr_t) node) {
	movw R30,R20
	ldd R2,z+0
	ldd R3,z+1
	movw R4,R30
	add R4,R2
	adc R5,R3
	cp R4,R10
	cpc R5,R11
	brne L33
X15:
;                 fnode->hn_size += node->hn_size;
	movw R30,R10
	ldd R2,z+0
	ldd R3,z+1
	movw R30,R20
	ldd R4,z+0
	ldd R5,z+1
	add R4,R2
	adc R5,R3
	std z+1,R5
	std z+0,R4
;                 fnode->hn_next = node->hn_next;
	movw R30,R10
	ldd R2,z+2
	ldd R3,z+3
	movw R30,R20
	std z+3,R3
	std z+2,R2
;             } else
	xjmp L26
L33:
;                 fnode->hn_next = node;
	movw R30,R20
	std z+3,R11
	std z+2,R10
;             break;
	xjmp L26
L31:
;         }
; 
;         /*
;          * If we are within a free node, somebody tried
;          * to free a block twice.
;          */
;         if (((uptr_t) node + node->hn_size) > (uptr_t) fnode) {
	movw R30,R10
	ldd R2,z+0
	ldd R3,z+1
	movw R4,R30
	add R4,R2
	adc R5,R3
	cp R20,R4
	cpc R21,R5
	brsh L35
X16:
; #ifdef NUTDEBUG
;             if (__heap_trf)
;                 fputs("\nTWICE\n", __heap_trs);
; #endif
;             //NutExitCritical();
;             return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L23
L35:
;         }
; 
;         npp = &node->hn_next;
	movw R22,R10
	subi R22,254  ; offset = 2
	sbci R23,255
;         node = node->hn_next;
	movw R30,R10
	ldd R10,z+2
	ldd R11,z+3
;     }
L25:
	tst R10
	breq X22
	xjmp L24
X22:
	tst R11
	breq X23
	xjmp L24
X23:
X17:
L26:
; 
;     /*
;      * If no link was found, put us at the end of the list
;      */
;     if (!node) {
	tst R10
	brne L37
	tst R11
	brne L37
X18:
;         fnode->hn_next = node;
	movw R30,R20
	std z+3,R11
	std z+2,R10
;         *npp = fnode;
	movw R30,R22
	std z+1,R21
	std z+0,R20
;     }
L37:
;     //NutExitCritical();
;     return 0;
	clr R16
	clr R17
L23:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
;           size -> R10,R11
;           addr -> R20,R21
	.even
_NutHeapAdd::
	xcall push_xgset300C
	movw R10,R18
	movw R20,R16
; }
; 
; /*!
;  * \brief
;  * Add a new memory region to the free heap.
;  *
;  * This function is automatically called by Nut/OS during
;  * initialization.
;  *
;  * Applications typically do not call this function.
;  *
;  * \param addr Start address of the memory region.
;  * \param size Number of bytes of the memory region.
;  */
; void NutHeapAdd(void *addr, size_t size)
; {
;     *((uptr_t *) addr) = size;
	movw R30,R20
	std z+1,R11
	std z+0,R10
;     NutHeapFree(((uptr_t *) addr) + 1);
	movw R16,R30
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _NutHeapFree
L39:
	.dbline 0 ; func end
	xjmp pop_xgset300C
	.even
_NutHeapAvailable::
; }
; 
; /*!
;  * \brief Return the number of bytes available.
;  *
;  * \return Number of bytes.
;  */
; size_t NutHeapAvailable(void)
; {
;     return available;
	lds R16,_available
	lds R17,_available+1
L40:
	.dbline 0 ; func end
	ret
; }
; 
; /*@}*/
