	.module msg.c
	.area text(rom, con, rel)
;            len -> R22
;            que -> R20,R21
;           bits -> R10
	.even
_NutMsgQCreate::
	xcall push_xgsetF00C
	mov R10,R16
; /*
;  * Copyright (C) 2001-2003 by Telogis.com. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  * This code was kindly provided by Ralph Mason.
;  *
;  */
; 
; /*
;  * $Log: msg.c,v $
;  * Revision 1.4  2005/01/21 16:49:44  freckle
;  * Seperated calls to NutEventPostAsync between Threads and IRQs
;  *
;  * Revision 1.3  2005/01/19 17:59:46  freckle
;  * Improved interrupt performance by reducing some critical section
;  *
;  * Revision 1.2  2004/03/16 16:48:45  haraldkipp
;  * Added Jan Dubiec's H8/300 port.
;  *
;  * Revision 1.1  2004/02/04 18:05:07  drsung
;  * First version of message queueing  implemented. Thanks to Ralph Mason, who provided this code.
;  * Still contains some debug functions.
;  *
;  */
;  
; #include <sys/heap.h>
; #include <sys/event.h>
; #include <sys/atom.h>
; #include <sys/thread.h>
; #include <sys/msg.h>
; #include <stddef.h> /* NULL definition */
; 
; 
; #define ASSERT(x)
; 
; struct _NUTMSGTMR {
;     NUTMSGQ *mt_que;
;     int mt_param;
;     void *mt_data;
;     HANDLE mt_handle;
;     NUTMSGTMR *mt_next;
;     u_char mt_flags;
; };
; 
; /*!
;  * \addtogroup xgMessageQue
;  */
; /*@{*/
; 
; /*!
;  * \brief global list of ques
;  */
; NUTMSGQ *nutMsgQue;
; 
; NUTMSGTMR *nutMsgFreeTimers;
; 
; /*!
;  * \brief Allocate a new message que
;  *
;  * \param bits size of the que in bits 
;  *
;  * \return Handle of the new que
;  *
;  * \note que size will be 2^bits
;  */
; NUTMSGQ *NutMsgQCreate(u_char bits)
; {
; 
;     NUTMSGQ *que;
;     u_char len = 1 << bits;
	ldi R16,1
	mov R17,R10
	xcall lsl8
	mov R22,R16
; 
;     ASSERT(bits < 7);
;     ASSERT(bits > 0);
; 
;     que = (NUTMSGQ *) (NutHeapAllocClear(sizeof(NUTMSGQ) + (sizeof(NUTMSG) * (len))));
	ldi R24,5
	mul R24,R22
	movw R16,R0
	subi R16,242  ; offset = 14
	sbci R17,255
	xcall _NutHeapAllocClear
	movw R20,R16
; 
;     if (!que)
	cpi R16,0
	cpc R16,R17
	brne L2
X0:
;         return que;
	xjmp L1
L2:
; 
;     que->mq_mask = len - 1;
	mov R24,R22
	subi R24,1
	movw R30,R20
	std z+8,R24
; 
;     /*Link into the Global list */
;     que->mq_next = nutMsgQue;
	lds R2,_nutMsgQue
	lds R3,_nutMsgQue+1
	std z+5,R3
	std z+4,R2
;     nutMsgQue = que;
	sts _nutMsgQue+1,R21
	sts _nutMsgQue,R20
; 
;     return que;
	movw R16,R30
L1:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
;            ret -> R10,R11
;           pCur -> R20,R21
;           data -> y+12
;          param -> R12,R13
;             id -> R14
	.even
_NutMsgQBroadcast::
	xcall push_xgset30FC
	movw R12,R18
	mov R14,R16
	sbiw R28,4
; }
; 
; /*!
;  * \brief Send a message to all message ques
;  *
;  * \param id the id of the sent message
;  * \param param the param of the sent message
;  * \param data the data of the sent message
;  *
;  * \return 0 if sent to all ques, < 0 if one or more ques were full
;  *
;  */
; int NutMsgQBroadcast(u_char id, int param, void *data)
; {
; 
;     NUTMSGQ *pCur = nutMsgQue;
	lds R20,_nutMsgQue
	lds R21,_nutMsgQue+1
;     int ret = 0;
	clr R10
	clr R11
	xjmp L6
L5:
; 
;     while (pCur) {
;         ret -= NutMsgQPost(pCur, id, param, data);
	ldd R0,y+12
	ldd R1,y+13
	std y+3,R1
	std y+2,R0
	std y+1,R13
	std y+0,R12
	mov R18,R14
	movw R16,R20
	xcall _NutMsgQPost
	sub R10,R16
	sbc R11,R17
;         pCur = pCur->mq_next;
	movw R30,R20
	ldd R20,z+4
	ldd R21,z+5
;     }
L6:
	cpi R20,0
	cpc R20,R21
	brne L5
X1:
; 
;     return ret;
	movw R16,R10
L4:
	.dbline 0 ; func end
	adiw R28,4
	xjmp pop_xgset30FC
;            cur -> R22,R23
;           data -> y+8
;          param -> y+6
;             id -> R10
;            que -> R20,R21
	.even
_NutMsgQPost::
	xcall push_xgsetF00C
	mov R10,R18
	movw R20,R16
; }
; 
; /*!
;  * \brief Send a message to a que and return immediately
;  *
;  * \param q the que to send to
;  * \param id the id of the sent message
;  * \param param the param of the sent message
;  * \param data the data of the sent message
;  *
;  * \return 0 if sent, < 0 if the que is full
;  *
;  */
; int NutMsgQPost(NUTMSGQ * que, u_char id, int param, void *data)
; {
;     NUTMSG *cur;
;     NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
; 
;     if (NutMsgQFull(que)) {
	movw R16,R20
	xcall _NutMsgQFull
	cpi R16,0
	cpc R16,R17
	breq L9
X2:
;         NutJumpOutCritical();
	pop R0
	out 0x3F, R0
	
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L8
L9:
;     }
; 
;     cur = que->mq_que + que->mq_write;
	movw R30,R20
	ldd R2,z+7
	ldi R24,5
	mul R24,R2
	movw R22,R0
	movw R24,R30
	adiw R24,9
	add R22,R24
	adc R23,R25
; 
;     cur->id = id;
	movw R30,R22
	std z+0,R10
;     cur->param = param;
	ldd R0,y+6
	ldd R1,y+7
	std z+2,R1
	std z+1,R0
;     cur->data = data;
	ldd R0,y+8
	ldd R1,y+9
	std z+4,R1
	std z+3,R0
; 
;     que->mq_write++;
	movw R24,R20
	adiw R24,7
	movw R30,R24
	ldd R24,z+0
	subi R24,255    ; addi 1
	std z+0,R24
;     que->mq_write &= que->mq_mask;
	movw R22,R20
	subi R22,249  ; offset = 7
	sbci R23,255
	movw R30,R20
	ldd R2,z+8
	movw R30,R22
	ldd R3,z+0
	and R3,R2
	std z+0,R3
; 
;     NutExitCritical();
	pop R0
	out 0x3F, R0
	
; 
;     NutEventPostAsync(&que->mq_wait);
	movw R16,R20
	xcall _NutEventPostAsync
;     
;     return 0;
	clr R16
	clr R17
L8:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
;           data -> y+10
;          param -> y+8
;             id -> R12
;            que -> R10,R11
	.even
_NutMsgQSend::
	xcall push_xgset003C
	mov R12,R18
	movw R10,R16
	sbiw R28,4
; }
; 
; /*!
;  * \brief Send a message to a que and yields so that 
;  * a waiting thread can act on the message. 
;  *
;  * The sending thread should have a lower priority than the receiver thread
;  *
;  * \param q the que to send to
;  * \param id the id of the sent message
;  * \param param the param of the sent message
;  * \param data the data of the sent message
;  *
;  * \return 0 if sent, < 0 if the que is full
;  *
;  */
; int NutMsgQSend(NUTMSGQ * que, u_char id, int param, void *data)
; {
;     if (NutMsgQPost(que, id, param, data) == 0) {
	ldd R0,y+10
	ldd R1,y+11
	std y+3,R1
	std y+2,R0
	ldd R0,y+8
	ldd R1,y+9
	std y+1,R1
	std y+0,R0
	mov R18,R12
	movw R16,R10
	xcall _NutMsgQPost
	cpi R16,0
	cpc R16,R17
	brne L12
X3:
;         NutThreadYield();
	xcall _NutThreadYield
;         return 0;
	clr R16
	clr R17
	xjmp L11
L12:
;     }
;     return -1;
	ldi R16,-1
	ldi R17,-1
L11:
	.dbline 0 ; func end
	adiw R28,4
	xjmp pop_xgset003C
;            que -> R16,R17
	.even
_NutMsgQFull::
; }
; 
; /*!
;  * \brief Checks the state of a que
;  *
;  * \return -1 if full
;  */
; int NutMsgQFull(NUTMSGQ * que)
; {
;     if (((que->mq_write + 1) & que->mq_mask) == que->mq_read) {
	movw R30,R16
	ldd R2,z+8
	ldd R24,z+7
	subi R24,255    ; addi 1
	and R24,R2
	ldd R2,z+6
	cp R24,R2
	brne L15
X4:
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L14
L15:
;     }
;     return 0;
	clr R16
	clr R17
L14:
	.dbline 0 ; func end
	ret
;          timer -> R20,R21
;            arg -> R10,R11
;           hndl -> R12,R13
	.even
_NutMsgQTimerCb:
	xcall push_xgset303C
	movw R10,R18
	movw R12,R16
	sbiw R28,5
; }
; 
; 
; static void NutMsgQTimerCb(HANDLE hndl, void *arg)
; {
;     NUTMSGTMR *timer = (NUTMSGTMR *) arg;
	movw R20,R10
; 
;     if (NutMsgQPost(timer->mt_que, MSG_TIMER, 0, timer)) {
	std y+3,R21
	std y+2,R20
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	ldi R18,254
	movw R30,R20
	ldd R16,z+0
	ldd R17,z+1
	xcall _NutMsgQPost
	cpi R16,0
	cpc R16,R17
	breq L18
X5:
;         /*
;          * If a oneshot is missed we need to restart it until
;          * It gets into the que otherwise we can not deallocate the NUTMSGTMR
;          * Also oneshots are important we expect it will go off
;          */
;         if (timer->mt_flags && TM_ONESHOT) {
	movw R30,R20
	ldd R2,z+10
	tst R2
	breq L19
X6:
;             timer->mt_handle = NutTimerStartTicks(1, NutMsgQTimerCb, timer, TM_ONESHOT);
	ldi R24,1
	std y+4,R24
	std y+3,R21
	std y+2,R20
	ldi R24,<PL_NutMsgQTimerCb
	ldi R25,>PL_NutMsgQTimerCb
	std y+1,R25
	std y+0,R24
	ldi R16,1
	ldi R17,0
	ldi R18,0
	ldi R19,0
	xcall _NutTimerStartTicks
	movw R30,R20
	std z+7,R17
	std z+6,R16
;         }
;     } else {
	xjmp L19
L18:
;         /*We can't kill it b/c it kills it's self */
;         if (timer->mt_flags && TM_ONESHOT)
	movw R30,R20
	ldd R2,z+10
	tst R2
	breq L22
X7:
;             timer->mt_handle = NULL;
	clr R2
	clr R3
	std z+7,R3
	std z+6,R2
L22:
;     }
L19:
L17:
	.dbline 0 ; func end
	adiw R28,5
	xjmp pop_xgset303C
;          timer -> R20,R21
;          flags -> R10
;           data -> y+17
;          param -> y+15
;             ms -> y+11
;            que -> R22,R23
	.even
_NutMsgQStartTimer::
	st -y,r19
	st -y,r18
	xcall push_xgsetF00C
	movw R22,R16
	sbiw R28,5
	ldd R10,y+19
; }
; 
; 
; /*!
;  * \brief Starts a periodic or one-shot timer on the given que
;  *
;  * \param que the que to send to
;  * \param ms timeout length of the timer
;  * \param id the id of the sent message
;  * \param param the param of the sent message
;  * \param data the data of the sent message
;  * \param flags 0 or TM_ONESHOT
;  *
;  * \return HANDLE of the new timer
;  *
;  */
; HANDLE NutMsgQStartTimer(NUTMSGQ * que, u_long ms, int param, void *data, u_char flags)
; {
;     NUTMSGTMR *timer = nutMsgFreeTimers;
	lds R20,_nutMsgFreeTimers
	lds R21,_nutMsgFreeTimers+1
; 
;     ASSERT(flags == TM_ONESHOT || flags == 0);
; 
;     if (timer != NULL) {
	cpi R20,0
	cpc R20,R21
	breq L25
X8:
;         nutMsgFreeTimers = timer->mt_next;
	movw R30,R20
	ldd R2,z+8
	ldd R3,z+9
	sts _nutMsgFreeTimers+1,R3
	sts _nutMsgFreeTimers,R2
;     } else {
	xjmp L26
L25:
;         timer = (NUTMSGTMR *) NutHeapAlloc(sizeof(NUTMSGTMR));
	ldi R16,11
	ldi R17,0
	xcall _NutHeapAlloc
	movw R20,R16
;     }
L26:
; 
;     timer->mt_que = que;
	movw R30,R20
	std z+1,R23
	std z+0,R22
;     timer->mt_data = data;
	ldd R0,y+17
	ldd R1,y+18
	std z+5,R1
	std z+4,R0
;     timer->mt_param = param;
	ldd R0,y+15
	ldd R1,y+16
	std z+3,R1
	std z+2,R0
;     timer->mt_flags = flags;
	std z+10,R10
;     timer->mt_handle = NutTimerStart(ms, NutMsgQTimerCb, timer, flags);
	std y+4,R10
	std y+3,R21
	std y+2,R20
	ldi R24,<PL_NutMsgQTimerCb
	ldi R25,>PL_NutMsgQTimerCb
	std y+1,R25
	std y+0,R24
	ldd R16,y+11
	ldd R17,y+12
	ldd R18,y+13
	ldd R19,y+14
	xcall _NutTimerStart
	movw R30,R20
	std z+7,R17
	std z+6,R16
; 
;     timer->mt_next = que->mq_timers;
	movw R30,R22
	ldd R2,z+2
	ldd R3,z+3
	movw R30,R20
	std z+9,R3
	std z+8,R2
;     que->mq_timers = timer;
	movw R30,R22
	std z+3,R21
	std z+2,R20
;     return (HANDLE) timer;
	movw R16,R20
L24:
	.dbline 0 ; func end
	adiw R28,5
	xcall pop_xgsetF00C
	adiw R28,2
	ret
;           tnpp -> R22,R23
;            tnp -> R20,R21
;         handle -> R18,R19
;            que -> R16,R17
	.even
_NutMsgQFreeTimer:
	xcall push_xgsetF000
; }
; 
; static void NutMsgQFreeTimer(NUTMSGQ * que, NUTMSGTMR * handle)
; {
;     NUTMSGTMR *tnp = que->mq_timers;
	movw R30,R16
	ldd R20,z+2
	ldd R21,z+3
;     NUTMSGTMR **tnpp = &que->mq_timers;
	movw R22,R30
	subi R22,254  ; offset = 2
	sbci R23,255
	xjmp L29
L28:
; 
;     while (tnp) {
;         if (tnp == handle) {
	cp R20,R18
	cpc R21,R19
	brne L31
X9:
;             *tnpp = tnp->mt_next;
	movw R30,R20
	ldd R2,z+8
	ldd R3,z+9
	movw R30,R22
	std z+1,R3
	std z+0,R2
;             tnp->mt_next = nutMsgFreeTimers;
	lds R2,_nutMsgFreeTimers
	lds R3,_nutMsgFreeTimers+1
	movw R30,R20
	std z+9,R3
	std z+8,R2
;             nutMsgFreeTimers = tnp;
	sts _nutMsgFreeTimers+1,R21
	sts _nutMsgFreeTimers,R20
;             return;
	xjmp L27
L31:
;         }
;         tnpp = &tnp->mt_next;
	movw R22,R20
	subi R22,248  ; offset = 8
	sbci R23,255
;         tnp = tnp->mt_next;
	movw R30,R20
	ldd R20,z+8
	ldd R21,z+9
;     }
L29:
	cpi R20,0
	cpc R20,R21
	brne L28
X10:
; 
;     ASSERT(0);                  /*Timer already freed */
L27:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
;            pos -> R10
;              t -> R22,R23
;            que -> R20,R21
;          timer -> R10,R11
	.even
_NutMsgQStopTimer::
	xcall push_xgsetF00C
	movw R10,R16
; }
; 
; /*!
;  * \brief Stops a timer
;  *
;  * \param timer HANDLE of the timer to stop
;  *
;  * \note You must not stop a one shot that has already expired
;  * otherwise it *could* have been reused and you will end up stopping
;  *  another timer
;  * 
;  */
; void NutMsgQStopTimer(HANDLE timer)
; {
;     NUTMSGTMR *t = (NUTMSGTMR *) timer;
	movw R22,R10
;     NUTMSGQ *que = t->mt_que;
	movw R30,R22
	ldd R20,z+0
	ldd R21,z+1
; 
;     /*
;      * We need to remove any message in the que from this timer
;      * If you stop it you don't want a message from it
;      */
;     NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
;     {
;         u_char pos = que->mq_read;
	movw R30,R20
	ldd R10,z+6
	xjmp L35
L34:
; 
;         while (pos != que->mq_write) {
;             if (que->mq_que[pos].id == MSG_TIMER && que->mq_que[pos].data == t) {
	ldi R24,5
	mul R24,R10
	movw R2,R0
	movw R24,R20
	adiw R24,9
	add R2,R24
	adc R3,R25
	movw R30,R2
	ldd R24,z+0
	cpi R24,254
	brne L37
X11:
	ldd R2,z+3
	ldd R3,z+4
	cp R22,R2
	cpc R23,R3
	brne L37
X12:
;                 que->mq_que[pos].id = MSG_NULL;
	ldi R24,5
	mul R24,R10
	movw R30,R0
	movw R24,R20
	adiw R24,9
	add R30,R24
	adc R31,R25
	ldi R24,255
	std z+0,R24
;             }
L37:
; 
;             pos = (pos + 1) & que->mq_mask;
	movw R30,R20
	ldd R2,z+8
	mov R24,R10
	subi R24,255    ; addi 1
	mov R10,R24
	and R10,R2
;         }
L35:
	movw R30,R20
	ldd R2,z+7
	cp R10,R2
	breq X15
	xjmp L34
X15:
X13:
;     }
; 
;     if (t->mt_handle)
	movw R30,R22
	ldd R2,z+6
	ldd R3,z+7
	tst R2
	brne X14
	tst R3
	breq L39
X14:
;         NutTimerStop(t->mt_handle);
	ldd R16,z+6
	ldd R17,z+7
	xcall _NutTimerStop
L39:
; 
;     NutExitCritical();
	pop R0
	out 0x3F, R0
	
; 
;     NutMsgQFreeTimer(que, t);
	movw R18,R22
	movw R16,R20
	xcall _NutMsgQFreeTimer
L33:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
;          timer -> R22,R23
;        timeout -> y+8
;            msg -> R10,R11
;            que -> R20,R21
	.even
_NutMsgQGetMessage::
	xcall push_xgsetF00C
	movw R10,R18
	movw R20,R16
	sbiw R28,2
; }
; 
; /*!
;  * \brief Gets the next message from the que
;  *
;  * \param que the que to wait on
;  * \param msg pointer to memory to return data to
;  * \param timeout how long to wait for a message
;  * 
;  * \return -1 on timeout, 0 if message retreived
;  */
; 
; int NutMsgQGetMessage(NUTMSGQ * que, NUTMSG * msg, u_long timeout)
; {
;     NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
; 
;     if (NutEventWait(&que->mq_wait, timeout)) {
	ldd R2,y+8
	ldd R3,y+9
	ldd R4,y+10
	ldd R5,y+11
	std y+0,R4
	std y+1,R5
	movw R18,R2
	movw R16,R20
	xcall _NutEventWait
	cpi R16,0
	cpc R16,R17
	breq L42
X16:
;         NutJumpOutCritical();
	pop R0
	out 0x3F, R0
	
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L41
L42:
;     }
;     /* Are there messages in the queue */
;     ASSERT(que->mq_read != que->mq_write);
; 
;     *msg = *(que->mq_que + que->mq_read);
	movw R30,R20
	ldd R2,z+6
	ldi R24,5
	mul R24,R2
	movw R2,R0
	movw R24,R30
	adiw R24,9
	add R2,R24
	adc R3,R25
	ldi R16,5
	ldi R17,0
	st -y,R11
	st -y,R10
	st -y,R3
	st -y,R2
	xcall asgnblk
; 
;     que->mq_read++;
	movw R24,R20
	adiw R24,6
	movw R30,R24
	ldd R24,z+0
	subi R24,255    ; addi 1
	std z+0,R24
;     que->mq_read &= que->mq_mask;
	movw R22,R20
	subi R22,250  ; offset = 6
	sbci R23,255
	movw R30,R20
	ldd R2,z+8
	movw R30,R22
	ldd R3,z+0
	and R3,R2
	std z+0,R3
; 
;     /* If more messages then we need to Post so we can get the next one */
;     if (que->mq_read != que->mq_write)
	movw R30,R20
	ldd R2,z+7
	ldd R3,z+6
	cp R3,R2
	breq L44
X17:
;         NutEventPostAsync(&que->mq_wait);
	movw R16,R30
	xcall _NutEventPostAsync
L44:
; 
;     NutExitCritical();
	pop R0
	out 0x3F, R0
	
; 
;     if (msg->id == MSG_TIMER) {
	movw R30,R10
	ldd R24,z+0
	cpi R24,254
	brne L46
X18:
;         NUTMSGTMR *timer = (NUTMSGTMR *) msg->data;
	ldd R22,z+3
	ldd R23,z+4
;         msg->data = timer->mt_data;
	movw R30,R22
	ldd R2,z+4
	ldd R3,z+5
	movw R30,R10
	std z+4,R3
	std z+3,R2
;         msg->param = timer->mt_param;
	movw R30,R22
	ldd R2,z+2
	ldd R3,z+3
	movw R30,R10
	std z+2,R3
	std z+1,R2
; 
;         if (timer->mt_flags & TM_ONESHOT) {
	movw R30,R22
	ldd R2,z+10
	sbrs R2,0
	rjmp L48
X19:
;             NutMsgQFreeTimer(que, timer);
	movw R18,R30
	movw R16,R20
	xcall _NutMsgQFreeTimer
;         }
L48:
;     }
L46:
; 
;     return 0;
	clr R16
	clr R17
L41:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgsetF00C
;            que -> R16,R17
	.even
_NutMsgQFlush::
; }
; 
; /*!
;  * \brief Removes all entries from a que
;  */
; void NutMsgQFlush(NUTMSGQ * que)
; {
;     NutEnterCritical();
	in R0, 0x3F
	cli
	push R0
	
; 
;     que->mq_read = que->mq_write;
	movw R30,R16
	ldd R2,z+7
	std z+6,R2
; 
;     /*
;        // You want to flush only when you are not waitin on it 
;        ASSERT( que->event_wait == SIGNALED || que->event_wait == 0 )
;      */
; 
;     que->mq_wait = 0;
	clr R2
	clr R3
	std z+1,R3
	std z+0,R2
;     NutExitCritical();
	pop R0
	out 0x3F, R0
	
L50:
	.dbline 0 ; func end
	ret
	.area bss(ram, con, rel)
_nutMsgFreeTimers::
	.blkb 2
_nutMsgQue::
	.blkb 2
; }
; 
; /*@}*/
	.area func_lit
PL_NutMsgQTimerCb:	.word `_NutMsgQTimerCb
