	.module auth.c
	.area data(ram, con, rel)
_authList::
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.area text(rom, con, rel)
;           auth -> R20,R21
;          login -> R10,R11
;        dirname -> R12,R13
	.even
_NutHttpAuthLookup:
	xcall push_xgset303C
	movw R10,R18
	movw R12,R16
; /*
;  * Copyright (C) 2001-2003 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  */
; 
; /*
;  * $Log: auth.c,v $
;  * Revision 1.1.1.1  2003/05/09 14:41:56  haraldkipp
;  * Initial using 3.2.1
;  *
;  * Revision 1.7  2003/02/04 18:17:31  harald
;  * Version 3 released
;  *
;  * Revision 1.6  2002/06/26 17:29:49  harald
;  * First pre-release with 2.4 stack
;  *
;  */
; 
; #include <string.h>
; #include <sys/heap.h>
; 
; #include "dencode.h"
; #include <pro/httpd.h>
; 
; /*!
;  * \addtogroup xgHTTPD
;  */
; /*@{*/
; 
; AUTHINFO *authList = 0;
; 
; /*!
;  * \brief Look up an authorization entry.
;  */
; static AUTHINFO *NutHttpAuthLookup(CONST char *dirname, CONST char *login)
; {
;     AUTHINFO *auth;
; 
;     for (auth = authList; auth; auth = auth->auth_next) {
	lds R20,_authList
	lds R21,_authList+1
	xjmp L5
L2:
;         if (dirname && strcmp(dirname, auth->auth_dirname))
	tst R12
	brne X0
	tst R13
	breq L6
X0:
	movw R30,R20
	ldd R18,z+2
	ldd R19,z+3
	movw R16,R12
	xcall _strcmp
	cpi R16,0
	cpc R16,R17
	breq L6
X1:
;             continue;
	xjmp L3
L6:
;         if (login && strcmp(login, auth->auth_login))
	tst R10
	brne X2
	tst R11
	breq L4
X2:
	movw R30,R20
	ldd R18,z+4
	ldd R19,z+5
	movw R16,R10
	xcall _strcmp
	cpi R16,0
	cpc R16,R17
	breq L4
X3:
;             continue;
;         break;
L3:
	movw R30,R20
	ldd R20,z+0
	ldd R21,z+1
L5:
	cpi R20,0
	cpc R20,R21
	brne L2
X4:
L4:
;     }
;     return auth;
	movw R16,R20
L1:
	.dbline 0 ; func end
	xjmp pop_xgset303C
;           auth -> R20,R21
;          login -> R10,R11
;        dirname -> R12,R13
	.even
_NutRegisterAuth::
	xcall push_xgset303C
	movw R10,R18
	movw R12,R16
; }
; 
; /*!
;  * \brief Register an authorization entry.
;  *
;  * Protect a specified directory from unauthorized access.
;  *
;  * \warning Directories not registered by this function are
;  *          accessible by anyone.
;  *
;  * \param dirname Name of the directory to protect.
;  * \param login   Required login to access this directory. This
;  *                string must contain a user name, followed by
;  *                a colon followed by an uncrypted password.
;  *
;  * \return 0 on success, -1 otherwise.
;  */
; int NutRegisterAuth(CONST char *dirname, CONST char *login)
; {
;     AUTHINFO *auth;
; 
;     if ((auth = NutHeapAlloc(sizeof(AUTHINFO))) == 0)
	ldi R16,6
	ldi R17,0
	xcall _NutHeapAlloc
	movw R20,R16
	cpi R20,0
	cpc R20,R21
	brne L11
X5:
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L10
L11:
;     auth->auth_next = authList;
	lds R2,_authList
	lds R3,_authList+1
	movw R30,R20
	std z+1,R3
	std z+0,R2
;     auth->auth_dirname = dirname;
	std z+3,R13
	std z+2,R12
;     auth->auth_login = login;
	std z+5,R11
	std z+4,R10
;     authList = auth;
	sts _authList+1,R21
	sts _authList,R20
; 
;     return 0;
	clr R16
	clr R17
L10:
	.dbline 0 ; func end
	xjmp pop_xgset303C
;             rc -> R20,R21
;          realm -> R22,R23
;             cp -> R10,R11
;            req -> R12,R13
	.even
_NutHttpAuthValidate::
	xcall push_xgsetF0FC
	movw R12,R16
	sbiw R28,2
; }
; 
; /*!
;  * \brief Validate an authorization request.
;  *
;  * \note This function is automatically called by the HTTP
;  *       library on incoming requests. Applications do not
;  *       need to call this function.
;  *
;  * \param req Request to be checked.
;  *
;  * \return 0, if access granted, -1 otherwise.
;  */
; int NutHttpAuthValidate(REQUEST * req)
; {
;     char *realm;
;     char *cp = 0;
;     int rc = -1;
	ldi R20,-1
	ldi R21,-1
; 
;     /*
;      * Get directory by chopping off filename.
;      */
;     realm = req->req_url;
	movw R30,R12
	ldd R22,z+6
	ldd R23,z+7
;     if ((cp = strrchr(realm, '/')) != 0)
	ldi R18,47
	ldi R19,0
	movw R16,R22
	xcall _strrchr
	movw R10,R16
	tst R10
	brne X6
	tst R11
	breq L14
X6:
;         *cp = 0;
	clr R2
	movw R30,R10
	std z+0,R2
	xjmp L15
L14:
;     else
;         realm = ".";
	ldi R22,<L16
	ldi R23,>L16
L15:
; 
;     /*
;      * Check if authorization required.
;      */
;     if (NutHttpAuthLookup(realm, 0)) {
	clr R18
	clr R19
	movw R16,R22
	xcall _NutHttpAuthLookup
	cpi R16,0
	cpc R16,R17
	brne X12
	xjmp L17
X12:
X7:
;         /*
;          * Check authorization.
;          */
;         if (req->req_auth) {
	movw R30,R12
	ldd R2,z+14
	ldd R3,z+15
	tst R2
	brne X8
	tst R3
	breq L18
X8:
;             /*
;              * Acceptint basic authorization only.
;              */
;             if (strncmp(req->req_auth, "Basic ", 6) == 0) {
	ldi R24,6
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<L23
	ldi R19,>L23
	ldd R16,z+14
	ldd R17,z+15
	xcall _strncmp
	movw R14,R16
	cpi R16,0
	cpc R16,R17
	brne L18
X9:
;                 NutDecodeBase64(req->req_auth + 6);
	movw R30,R12
	ldd R16,z+14
	ldd R17,z+15
	subi R16,250  ; offset = 6
	sbci R17,255
	xcall _NutDecodeBase64
;                 if (NutHttpAuthLookup(realm, req->req_auth + 6))
	movw R30,R12
	ldd R18,z+14
	ldd R19,z+15
	subi R18,250  ; offset = 6
	sbci R19,255
	movw R16,R22
	xcall _NutHttpAuthLookup
	movw R12,R16
	cpi R16,0
	cpc R16,R17
	breq L18
X10:
;                     rc = 0;
	clr R20
	clr R21
;             }
;         }
;     } else
	xjmp L18
L17:
;         rc = 0;
	clr R20
	clr R21
L18:
; 
;     if (cp)
	tst R10
	brne X11
	tst R11
	breq L26
X11:
;         *cp = '/';
	ldi R24,47
	movw R30,R10
	std z+0,R24
L26:
; 
;     return rc;
	movw R16,R20
L13:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgsetF0FC
	.area data(ram, con, rel)
L23:
	.blkb 7
	.area idata
	.byte 'B,'a,'s,'i,'c,32,0
	.area data(ram, con, rel)
L16:
	.blkb 2
	.area idata
	.byte 46,0
	.area data(ram, con, rel)
; }
; 
; /*@}*/
