	.module cgi.c
	.area data(ram, con, rel)
_cgiFunctionList::
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.area text(rom, con, rel)
;            cgi -> R20,R21
;           func -> R10,R11
;           name -> R12,R13
	.even
_NutRegisterCgi::
	xcall push_xgset303C
	movw R10,R18
	movw R12,R16
; /*
;  * Copyright (C) 2001-2003 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  */
; 
; /*
;  * $Log: cgi.c,v $
;  * Revision 1.1.1.1  2003/05/09 14:41:56  haraldkipp
;  * Initial using 3.2.1
;  *
;  * Revision 1.7  2003/02/04 18:17:31  harald
;  * Version 3 released
;  *
;  * Revision 1.6  2002/06/26 17:29:49  harald
;  * First pre-release with 2.4 stack
;  *
;  */
; 
; #include <string.h>
; #include <sys/heap.h>
; 
; #include <pro/httpd.h>
; 
; /*!
;  * \addtogroup xgHTTPD
;  */
; /*@{*/
; 
; CGIFUNCTION *volatile cgiFunctionList = 0;
; 
; /*!
;  * \brief Register a CGI function.
;  *
;  * \bug Duplicate names not checked.
;  *
;  * \param name Name of this CGI function.
;  * \param func The function to be called, if the
;  *             client requests the specified name.
;  *
;  * \return 0 on success, -1 otherwise.
;  */
; int NutRegisterCgi(char *name, int (*func) (FILE *, REQUEST *))
; {
;     CGIFUNCTION *cgi;
; 
;     if ((cgi = NutHeapAlloc(sizeof(CGIFUNCTION))) == 0)
	ldi R16,6
	ldi R17,0
	xcall _NutHeapAlloc
	movw R20,R16
	cpi R20,0
	cpc R20,R21
	brne L2
X0:
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L1
L2:
;     cgi->cgi_next = cgiFunctionList;
	lds R2,_cgiFunctionList
	lds R3,_cgiFunctionList+1
	movw R30,R20
	std z+1,R3
	std z+0,R2
;     cgi->cgi_name = name;
	std z+3,R13
	std z+2,R12
;     cgi->cgi_func = func;
	std z+5,R11
	std z+4,R10
;     cgiFunctionList = cgi;
	sts _cgiFunctionList+1,R21
	sts _cgiFunctionList,R20
; 
;     return 0;
	clr R16
	clr R17
L1:
	.dbline 0 ; func end
	xjmp pop_xgset303C
;            cgi -> R22,R23
;            req -> R20,R21
;         stream -> R10,R11
	.even
_NutCgiProcessRequest::
	xcall push_xgsetF03C
	movw R20,R18
	movw R10,R16
	sbiw R28,2
; }
; 
; /*!
;  * \brief Process an incoming CGI request.
;  *
;  * Applications do not need to call this function. It
;  * is automatically called by NutHttpProcessRequest().
;  *
;  * \param stream Stream of the socket connection, previously opened for 
;  *               binary read and write.
;  * \param req    Contains the HTTP request.
;  */
; void NutCgiProcessRequest(FILE * stream, REQUEST * req)
; {
;     CGIFUNCTION *cgi;
; 
;     if (req->req_method != METHOD_GET && req->req_method != METHOD_POST) {
	movw R30,R20
	ldd R2,z+0
	ldd R3,z+1
	movw R24,R2
	cpi R24,1
	ldi R26,0
	cpc R25,R26
	breq L5
X1:
	cpi R24,2
	ldi R26,0
	cpc R25,R26
	breq L5
X2:
;         NutHttpSendError(stream, req, 501);
	ldi R24,501
	ldi R25,1
	std y+1,R25
	std y+0,R24
	movw R18,R30
	movw R16,R10
	xcall _NutHttpSendError
;         return;
	xjmp L4
L5:
;     }
;     for (cgi = cgiFunctionList; cgi; cgi = cgi->cgi_next) {
	lds R22,_cgiFunctionList
	lds R23,_cgiFunctionList+1
	xjmp L10
L7:
;         if (strcasecmp(cgi->cgi_name, req->req_url + 8) == 0)
	movw R30,R20
	ldd R18,z+6
	ldd R19,z+7
	subi R18,248  ; offset = 8
	sbci R19,255
	movw R30,R22
	ldd R16,z+2
	ldd R17,z+3
	xcall _strcmp
	cpi R16,0
	cpc R16,R17
	brne L11
X3:
;             break;
	xjmp L9
L11:
;     }
L8:
	movw R30,R22
	ldd R22,z+0
	ldd R23,z+1
L10:
	cpi R22,0
	cpc R22,R23
	brne L7
X4:
L9:
;     if (cgi == 0)
	cpi R22,0
	cpc R22,R23
	brne L13
X5:
;         NutHttpSendError(stream, req, 404);
	ldi R24,404
	ldi R25,1
	std y+1,R25
	std y+0,R24
	movw R18,R20
	movw R16,R10
	xcall _NutHttpSendError
	xjmp L4
L13:
;     else if ((*cgi->cgi_func) (stream, req))
	movw R18,R20
	movw R16,R10
	movw R30,R22
	ldd R26,z+4
	ldd R27,z+5
	movw R30,R26
	xcall  xicall
	movw R12,R16
	cpi R16,0
	cpc R16,R17
	breq L4
X6:
;         NutHttpSendError(stream, req, 500);
	ldi R24,500
	ldi R25,1
	std y+1,R25
	std y+0,R24
	movw R18,R20
	movw R16,R10
	xcall _NutHttpSendError
;     return;
L4:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgsetF03C
; }
; 
; /*@}*/
