	.module dencode.c
	.area lit(rom, con, rel)
_base64dtab:
	.byte 255,255
	.byte 255,255
	.byte 255,255
	.byte 255,255
	.byte 255,255
	.byte 255,62
	.byte 255,255
	.byte 255,63
	.byte 52,53
	.byte 54,55
	.byte 56,57
	.byte 58,59
	.byte 60,61
	.byte 255,255
	.byte 255,255
	.byte 255,255
	.byte 255,0
	.byte 1,2
	.byte 3,4
	.byte 5,6
	.byte 7,8
	.byte 9,10
	.byte 11,12
	.byte 13,14
	.byte 15,16
	.byte 17,18
	.byte 19,20
	.byte 21,22
	.byte 23,24
	.byte 25,255
	.byte 255,255
	.byte 255,255
	.byte 255,26
	.byte 27,28
	.byte 29,30
	.byte 31,32
	.byte 33,34
	.byte 35,36
	.byte 37,38
	.byte 39,40
	.byte 41,42
	.byte 43,44
	.byte 45,46
	.byte 47,48
	.byte 49,50
	.byte 51,255
	.byte 255,255
	.byte 255,255
	.area text(rom, con, rel)
;             tp -> R10,R11
;           step -> R12
;           last -> R22
;           code -> R14
;             sp -> R20,R21
;            str -> y+12
	.even
_NutDecodeBase64::
	st -y,r17
	st -y,r16
	xcall push_xgsetF0FC
	sbiw R28,2
; /*
;  * Copyright (C) 2001-2003 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  */
; 
; /*
;  * $Log: dencode.c,v $
;  * Revision 1.5  2004/03/16 16:48:46  haraldkipp
;  * Added Jan Dubiec's H8/300 port.
;  *
;  * Revision 1.4  2004/01/16 10:27:55  drsung
;  * Another code size improvement.
;  *
;  * Revision 1.3  2003/11/27 08:46:41  drsung
;  * Code size improvement
;  *
;  * Revision 1.2  2003/11/27 08:30:54  drsung
;  * Bug fix
;  *
;  */
;  
; #include "dencode.h"
; 
; /* Base-64 decoding.  This represents binary data as printable ASCII
; ** characters.  Three 8-bit binary bytes are turned into four 6-bit
; ** values, like so:
; **
; **   [11111111]  [22222222]  [33333333]
; **
; **   [111111] [112222] [222233] [333333]
; **
; ** Then the 6-bit values are represented using the characters "A-Za-z0-9+/".
; */
; 
; /* Since base-64 encodes strings do not have any character above 127,
;  * we need just the first 128 bytes. Furthermore there is no char
;  * below 32, so we can save 32 additional bytes of flash.
;  */
; static prog_char base64dtab[96] = {
; /*
;     -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
;     -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
; */
;     -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 62, -1, -1, -1, 63,
;     52, 53, 54, 55, 56, 57, 58, 59, 60, 61, -1, -1, -1, -1, -1, -1,
;     -1,  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14,
;     15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, -1, -1, -1, -1, -1,
;     -1, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40,
;     41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, -1, -1, -1, -1, -1,
; /*
;     -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
;     -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
;     -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
;     -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
;     -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
;     -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
;     -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
;     -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 */
; };
; 
; /*
;  * Do base-64 decoding on a string. Ignore any non-base64 bytes.
;  * Return the actual number of bytes generated. The decoded size will
;  * be at most 3/4 the size of the encoded, and may be smaller if there
;  * are padding characters (blanks, newlines).
;  */
; char *NutDecodeBase64(u_char * str)
; {
;     /* bug fix from Damian Slee. */
;     char code;
;     char *sp;
;     char *tp;
;     char last = -1;
	ldi R22,255
;     char step = 0;
	clr R12
; 
;     for (tp = sp = str; *sp; ++sp) {
	ldd R20,y+12
	ldd R21,y+13
	movw R10,R20
	xjmp L5
L2:
;     	if (*sp < 32)
	movw R30,R20
	ldd R24,z+0
	cpi R24,32
	brsh L6
X0:
;     	    continue;
	xjmp L3
L6:
;         if ((code = PRG_RDB(&base64dtab[(int) *sp - 32])) == (char)-1)
	ldi R24,<_base64dtab-32
	ldi R25,>_base64dtab-32
	movw R30,R20
	ldd R30,z+0
	clr R31
	add R30,R24
	adc R31,R25
	lpm R2,Z
	mov R14,R2
	ldi R24,-1
	ldi R25,-1
	cp R14,R24
	brne L8
X1:
;             continue;
	xjmp L3
L8:
;         switch (step++) {
	mov R2,R12
	clr R3
	mov R24,R2
	subi R24,255    ; addi 1
	mov R12,R24
	std y+1,R3
	std y+0,R2
	movw R24,R2
	cpi R24,1
	ldi R30,0
	cpc R25,R30
	breq L14
X2:
	cpi R24,2
	ldi R30,0
	cpc R25,R30
	breq L15
X3:
	cpi R24,3
	ldi R30,0
	cpc R25,R30
	breq L16
X4:
	xjmp L11
L14:
;         case 1:
;             *tp++ = ((last << 2) | ((code & 0x30) >> 4));
	mov R24,R14
	andi R24,48
	swap R24
	andi R24,#0x0F
	mov R2,R22
	lsl R2
	lsl R2
	or R2,R24
	movw R30,R10
	st Z+,R2
	movw R10,R30
;             break;
	xjmp L12
L15:
;         case 2:
;             *tp++ = (((last & 0xf) << 4) | ((code & 0x3c) >> 2));
	mov R24,R14
	andi R24,60
	mov R2,R24
	lsr R2
	lsr R2
	mov R24,R22
	andi R24,15
	andi R24,#0x0F
	swap R24
	or R24,R2
	movw R30,R10
	st Z+,R24
	movw R10,R30
;             break;
	xjmp L12
L16:
;         case 3:
;             *tp++ = (((last & 0x03) << 6) | code);
	mov R24,R22
	andi R24,3
	lsl R24
	lsl R24
	lsl R24
	lsl R24
	lsl R24
	lsl R24
	or R24,R14
	movw R30,R10
	st Z+,R24
	movw R10,R30
;             step = 0;
	clr R12
;             break;
L11:
L12:
;         }
;         last = code;
	mov R22,R14
;     }
L3:
	subi R20,255  ; offset = 1
	sbci R21,255
L5:
	movw R30,R20
	ldd R2,z+0
	tst R2
	breq X6
	xjmp L2
X6:
X5:
;     *tp = 0;
	clr R2
	movw R30,R10
	std z+0,R2
;     return str;
	ldd R16,y+12
	ldd R17,y+13
L1:
	.dbline 0 ; func end
	adiw R28,2
	xcall pop_xgsetF0FC
	adiw R28,2
	ret
;              c -> R16
	.even
_NutDecodeHex::
; }
; 
; int NutDecodeHex(char c)
; {
;     if (c >= '0' && c <= '9')
	cpi R16,48
	brlo L18
X7:
	ldi R24,57
	cp R24,R16
	brlo L18
X8:
;         return c - '0';
	clr R17
	subi R16,48
	sbci R17,0
	xjmp L17
L18:
;     if (c >= 'a' && c <= 'f')
	cpi R16,97
	brlo L20
X9:
	ldi R24,102
	cp R24,R16
	brlo L20
X10:
;         return c - 'a' + 10;
	clr R17
	subi R16,97
	sbci R17,0
	subi R16,246  ; offset = 10
	sbci R17,255
	xjmp L17
L20:
;     if (c >= 'A' && c <= 'F')
	cpi R16,65
	brlo L22
X11:
	ldi R24,70
	cp R24,R16
	brlo L22
X12:
;         return c - 'A' + 10;
	clr R17
	subi R16,65
	sbci R17,0
	subi R16,246  ; offset = 10
	sbci R17,255
	xjmp L17
L22:
;     return -1;
	ldi R16,-1
	ldi R17,-1
L17:
	.dbline 0 ; func end
	ret
;            dst -> R12,R13
;             x2 -> R14,R15
;             x1 -> R10,R11
;           last -> R22
;            src -> R20,R21
;           path -> y+10
	.even
_NutDecodePath::
	st -y,r17
	st -y,r16
	xcall push_xgsetF0FC
; }
; 
; char *NutDecodePath(char *path)
; {
;     int x1;
;     int x2;
;     char *src = path;
	ldd R20,y+10
	ldd R21,y+11
;     char *dst = path;
	movw R12,R20
;     char last = *path;
	movw R30,R12
	ldd R22,z+0
; 
;     if (last != '/')
	cpi R22,47
	brne X24
	xjmp L28
X24:
X13:
;         return 0;
	clr R16
	clr R17
	xjmp L24
L27:
;     while (*++src) {
;         if (*src == '%' &&
	movw R30,R20
	ldd R24,z+0
	cpi R24,37
	brne L30
X14:
	ldd R16,z+1
	xcall _NutDecodeHex
	movw R10,R16
	cpi R16,0
	ldi R30,0
	cpc R17,R30
	brlt L30
X15:
	movw R30,R20
	ldd R16,z+2
	xcall _NutDecodeHex
	movw R14,R16
	cpi R16,0
	ldi R30,0
	cpc R17,R30
	brlt L30
X16:
;             (x1 = NutDecodeHex(*(src + 1))) >= 0 &&
;             (x2 = NutDecodeHex(*(src + 2))) >= 0) {
;             src += 2;
	subi R20,254  ; offset = 2
	sbci R21,255
;             if ((*src = x1 * 16 + x2) == 0)
	ldi R16,16
	ldi R17,0
	movw R18,R10
	xcall empy16s
	movw R2,R16
	add R2,R14
	adc R3,R15
	mov R14,R2
	movw R30,R20
	std z+0,R14
	tst R2
	brne L32
X17:
;                 break;
	xjmp L29
L32:
;         }
L30:
;         if (*src == '\\')
	movw R30,R20
	ldd R24,z+0
	cpi R24,92
	brne L34
X18:
;             *src = '/';
	ldi R24,47
	std z+0,R24
L34:
;         if ((last != '.' && last != '/') || (*src != '.' && *src != '/'))
	cpi R22,46
	breq L39
X19:
	cpi R22,47
	brne L38
X20:
L39:
	movw R30,R20
	ldd R14,z+0
	clr R15
	mov R24,R14
	cpi R24,46
	breq L36
X21:
	cpi R24,47
	breq L36
X22:
L38:
;             *dst++ = last = *src;
	movw R30,R20
	ldd R14,z+0
	mov R22,R14
	movw R30,R12
	st Z+,R14
	movw R12,R30
L36:
; 
;     }
L28:
	movw R24,R20
	adiw R24,1
	movw R14,R24
	movw R20,R24
	movw R30,R24
	ldd R2,z+0
	tst R2
	breq X25
	xjmp L27
X25:
X23:
L29:
;     *dst = 0;
	clr R2
	movw R30,R12
	std z+0,R2
; 
;     return path;
	ldd R16,y+10
	ldd R17,y+11
L24:
	.dbline 0 ; func end
	xcall pop_xgsetF0FC
	adiw R28,2
	ret
; }
