	.module ftpd.c
	.area lit(rom, con, rel)
_cmd_cwd_P:
	.byte 'C,'W,'D,0
_cmd_dele_P:
	.byte 'D,'E,'L,'E,0
_cmd_list_P:
	.byte 'L,'I,'S,'T,0
_cmd_mkd_P:
	.byte 'M,'K,'D,0
_cmd_xmkd_P:
	.byte 'X,'M,'K,'D,0
_cmd_nlst_P:
	.byte 'N,'L,'S,'T,0
_cmd_noop_P:
	.byte 'N,'O,'O,'P,0
_cmd_pass_P:
	.byte 'P,'A,'S,'S,0
_cmd_pasv_P:
	.byte 'P,'A,'S,'V,0
_cmd_port_P:
	.byte 'P,'O,'R,'T,0
_cmd_pwd_P:
	.byte 'P,'W,'D,0
_cmd_xpwd_P:
	.byte 'X,'P,'W,'D,0
_cmd_quit_P:
	.byte 'Q,'U,'I,'T,0
_cmd_retr_P:
	.byte 'R,'E,'T,'R,0
_cmd_rmd_P:
	.byte 'R,'M,'D,0
_cmd_xrmd_P:
	.byte 'X,'R,'M,'D,0
_cmd_stor_P:
	.byte 'S,'T,'O,'R,0
_cmd_syst_P:
	.byte 'S,'Y,'S,'T,0
_cmd_type_P:
	.byte 'T,'Y,'P,'E,0
_cmd_user_P:
	.byte 'U,'S,'E,'R,0
	.area data(ram, con, rel)
_mon_name:
	.blkw 1
	.area idata
	.word L2
	.area data(ram, con, rel)
	.area lit(rom, con, rel)
_rep_banner:
	.byte 50,50,48,32,'N,'u,'t,47,'O,'S,32,'F,'T,'P,32,37
	.byte 's,32,'r,'e,'a,'d,'y,32,'a,'t,32,37,46,51,'s,37
	.byte 51,'d,32,37,48,50,'d,58,37,48,50,'d,58,37,48,50
	.byte 'd,13,10,0
	.area text(rom, con, rel)
;           args -> y+4
;            cmd -> R18,R19
;           line -> R16,R17
	.even
_SplitCmdArg:
	xcall push_xgset300C
; /*
;  * Copyright (C) 2001-2005 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  */
; 
; /*!
;  * \file pro/ftpd.c
;  * \brief FTP server.
;  *
;  * \verbatim
;  *
;  * $Log: ftpd.c,v $
;  * Revision 1.3  2005/08/02 17:47:04  haraldkipp
;  * Major API documentation update.
;  *
;  * Revision 1.2  2005/02/07 18:57:51  haraldkipp
;  * ICCAVR compile errors fixed
;  *
;  * Revision 1.1  2005/02/05 20:45:38  haraldkipp
;  * First release.
;  *
;  *
;  * \endverbatim
;  */
; 
; #include <sys/version.h>
; 
; #include <sys/socket.h>
; #include <netinet/tcp.h>
; 
; #include <string.h>
; #include <stdio.h>
; #include <stdlib.h>
; #include <io.h>
; #include <fcntl.h>
; #include <sys/stat.h>
; #include <dirent.h>
; #include <unistd.h>
; 
; #include <pro/ftpd.h>
; 
; #ifdef FTPD_DEBUG
; #include <sys/heap.h>
; #endif
; 
; /*!
;  * \addtogroup xgFTPD
;  *
;  * Internet File Transfer Protocol Server.
;  */
; /*@{*/
; 
; /*!
;  * \name FTP Server Configuration
;  *
;  * The Nut/OS Configurator may be used to override the default values.
;  */
; /*@{*/
; 
; /*!
;  * \brief Default FTP root path.
;   *
;  * \showinitializer
; */
; #ifndef FTP_ROOTPATH
; #define FTP_ROOTPATH "PNUT:"
; #endif
; 
; /*!
;  * \brief Default data port.
;  *
;  * \showinitializer
;  */
; #ifndef FTP_DATA_PORT
; #define FTP_DATA_PORT   20
; #endif
; 
; /*@}*/
; 
; static char *ftp_root;
; static char *ftp_user;
; static char *ftp_pass;
; 
; /*
;  * On Harvard architectures constant strings are stored in ROM, 
;  * because RAM is usually a scarce resource on these platforms.
;  */
; static prog_char cmd_cwd_P[] = "CWD";
; static prog_char cmd_dele_P[] = "DELE";
; static prog_char cmd_list_P[] = "LIST";
; static prog_char cmd_mkd_P[] = "MKD";
; static prog_char cmd_xmkd_P[] = "XMKD";
; static prog_char cmd_nlst_P[] = "NLST";
; static prog_char cmd_noop_P[] = "NOOP";
; static prog_char cmd_pass_P[] = "PASS";
; static prog_char cmd_pasv_P[] = "PASV";
; static prog_char cmd_port_P[] = "PORT";
; static prog_char cmd_pwd_P[] = "PWD";
; static prog_char cmd_xpwd_P[] = "XPWD";
; static prog_char cmd_quit_P[] = "QUIT";
; static prog_char cmd_retr_P[] = "RETR";
; static prog_char cmd_rmd_P[] = "RMD";
; static prog_char cmd_xrmd_P[] = "XRMD";
; static prog_char cmd_stor_P[] = "STOR";
; static prog_char cmd_syst_P[] = "SYST";
; static prog_char cmd_type_P[] = "TYPE";
; static prog_char cmd_user_P[] = "USER";
; 
; static char *mon_name = "JanFebMarAprMayJunJulAugSepOctNovDec";
; 
; static prog_char rep_banner[] = "220 Nut/OS FTP %s ready at %.3s%3d %02d:%02d:%02d\r\n";
; 
; /*!
;  * \brief Break a string into a command and an argument string.
;  *
;  * \param line Pointer to the buffer containing the string. Note, that
;  *             its contents is not preserved.
;  * \param cmd  Receives a pointer to the command word in the given
;  *             string. The routine will convert all lower case letters
;  *             into upper case.
;  * \param args Receives a pointer to the list of arguments, if any.
;  *             Trailing carriage return or linefeed characters are
;  *             cut off.
;  */
; static void SplitCmdArg(u_char * line, u_char ** cmd, u_char ** args)
; {
	xjmp L5
L4:
;     /* Skip leading spaces. */
;     while (*line && *line <= ' ') {
;         line++;
	subi R16,255  ; offset = 1
	sbci R17,255
;     }
L5:
	movw R30,R16
	ldd R2,z+0
	clr R3
	tst R2
	breq L7
X0:
	ldi R24,32
	cp R24,R2
	brsh L4
X1:
L7:
; 
;     /* The first word is the command. Convert it to upper case. */
;     *cmd = line;
	movw R30,R18
	std z+1,R17
	std z+0,R16
	xjmp L9
L8:
;     while (*line > ' ') {
;         if (*line >= (u_char) 'a' && *line <= (u_char) 'z') {
	movw R30,R16
	ldd R2,z+0
	clr R3
	mov R24,R2
	cpi R24,97
	brlo L11
X2:
	ldi R24,122
	cp R24,R2
	brlo L11
X3:
;             *line -= (u_char) 'a' - 'A';
	ldd R24,z+0
	subi R24,32
	std z+0,R24
;         }
L11:
;         line++;
	subi R16,255  ; offset = 1
	sbci R17,255
;     }
L9:
	ldi R24,32
	movw R30,R16
	ldd R2,z+0
	cp R24,R2
	brlo L8
X4:
; 
;     /* Mark end of the command word. */
;     if (*line) {
	tst R2
	breq L16
X5:
;         *line++ = '\0';
	clr R2
	st Z+,R2
	movw R16,R30
;     }
	xjmp L16
L15:
; 
;     /* Skip spaces. */
;     while (*line && *line <= ' ') {
;         ++line;
	subi R16,255  ; offset = 1
	sbci R17,255
;     }
L16:
	movw R30,R16
	ldd R10,z+0
	clr R11
	tst R10
	breq L18
X6:
	ldi R24,32
	cp R24,R10
	brsh L15
X7:
L18:
; 
;     /* Arguments start here. */
;     *args = line;
	ldd R30,y+4
	ldd R31,y+5
	std z+1,R17
	std z+0,R16
	xjmp L20
L19:
;     while (*line && *line != '\r' && *line != '\n') {
;         line++;
	subi R16,255  ; offset = 1
	sbci R17,255
;     }
L20:
	movw R30,R16
	ldd R20,z+0
	clr R21
	tst R20
	breq L23
X8:
	cpi R20,13
	breq L23
X9:
	cpi R20,10
	brne L19
X10:
L23:
; 
;     /* Mark end of arguments. */
;     *line = 0;
	clr R2
	movw R30,R16
	std z+0,R2
L3:
	.dbline 0 ; func end
	xjmp pop_xgset300C
;             rc -> R10,R11
;           port -> R14,R15
;             ip -> y+12
;            arg -> y+10
	.even
_ParseIpPort:
	xcall push_arg4
	xcall push_xgsetF0FC
	ldd R14,y+14
	ldd R15,y+15
; }
; 
; /*!
;  * \brief Parses arguments of an FTP PORT command.
;  *
;  * FTP clients send a target port definition as a comma separated list
;  * of 6 ASCII byte values. The first four bytes specify an IP address
;  * and the remaining two a port number.
;  *
;  * \param arg  Pointer to the argument string.
;  * \param ip   Pointer to an unsigned long, which receives the IP
;  *             address in network byte order.
;  * \param port Pointer to an unsigned short, which receives the port
;  *             number in host byte order.
;  *
;  * \return The number of converted byte values. Should be 6.
;  */
; static int ParseIpPort(CONST u_char * arg, u_long * ip, u_short * port)
; {
;     int rc;
; 
;     *ip = 0;
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R30,y+12
	ldd R31,y+13
	std z+0,R20
	std z+1,R21
	std z+2,R22
	std z+3,R23
;     *port = 0;
	clr R2
	clr R3
	movw R30,R14
	std z+1,R3
	std z+0,R2
;     for (rc = 0; rc < 6; rc++) {
	clr R10
	clr R11
L25:
;         if (*arg < '0' || *arg > '9') {
	ldd R30,y+10
	ldd R31,y+11
	ldd R2,z+0
	clr R3
	mov R24,R2
	cpi R24,48
	brlo L31
X11:
	ldi R24,57
	cp R24,R2
	brsh L29
X12:
L31:
;             break;
	xjmp L27
L29:
;         }
;         if (rc < 4) {
	movw R24,R10
	cpi R24,4
	ldi R30,0
	cpc R25,R30
	brge L32
X13:
;             *ip >>= 8;
	ldi R24,8
	ldi R25,0
	ldd R30,y+12
	ldd R31,y+13
	ldd R16,z+0
	ldd R17,z+1
	ldd R18,z+2
	ldd R19,z+3
	st -y,R24
	xcall lsr32
	ldd R30,y+12
	ldd R31,y+13
	std z+0,R16
	std z+1,R17
	std z+2,R18
	std z+3,R19
;             *ip += atol(arg) << 24;
	ldd R16,y+10
	ldd R17,y+11
	xcall _atol
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsl32
	ldd R30,y+12
	ldd R31,y+13
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	add R2,R16
	adc R3,R17
	adc R4,R18
	adc R5,R19
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;         } else {
	xjmp L35
L32:
;             *port <<= 8;
	movw R30,R14
	ldd R2,z+0
	ldd R3,z+1
	mov R3,R2
	clr R2
	std z+1,R3
	std z+0,R2
;             *port += atoi(arg);
	ldd R16,y+10
	ldd R17,y+11
	xcall _atoi
	movw R30,R14
	ldd R2,z+0
	ldd R3,z+1
	add R2,R16
	adc R3,R17
	std z+1,R3
	std z+0,R2
;         }
	xjmp L35
L34:
;         while (*arg && *arg != ',') {
;             arg++;
	ldd R24,y+10
	ldd R25,y+11
	adiw R24,1
	std y+11,R25
	std y+10,R24
;         }
L35:
	ldd R30,y+10
	ldd R31,y+11
	ldd R12,z+0
	clr R13
	tst R12
	breq L37
X14:
	mov R24,R12
	cpi R24,44
	brne L34
X15:
L37:
;         if (*arg == ',') {
	ldd R30,y+10
	ldd R31,y+11
	ldd R24,z+0
	cpi R24,44
	brne L38
X16:
;             arg++;
	movw R24,R30
	adiw R24,1
	std y+11,R25
	std y+10,R24
;         }
L38:
;     }
L26:
	movw R24,R10
	adiw R24,1
	movw R10,R24
	cpi R24,6
	ldi R30,0
	cpc R25,R30
	brge X18
	xjmp L25
X18:
X17:
L27:
;     return rc;
	movw R16,R10
L24:
	.dbline 0 ; func end
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
	.area lit(rom, con, rel)
L41:
	.byte 37,'d,32,'O,'K,13,10,0
	.area text(rom, con, rel)
;           code -> R10,R11
;        session -> R20,R21
	.even
_NutFtpRespondOk::
	xcall push_xgset300C
	movw R10,R18
	movw R20,R16
	sbiw R28,2
; }
; 
; /*!
;  * \brief Send a positive response.
;  *
;  * \param session Pointer to an \ref FTPSESSION structure, obtained by a 
;  *                previous call to NutFtpOpenSession().
;  * \param code    Response code.
;  *
;  * \return -1 if the session ended. Otherwise 0 is returned.
;  */
; int NutFtpRespondOk(FTPSESSION * session, int code)
; {
;     static prog_char fmt_P[] = "%d OK\r\n";
; 
; #ifdef FTPD_DEBUG
;     printf("\n<'%d OK' ", code);
; #endif
;     fprintf_P(session->ftp_stream, fmt_P, code);
	std y+1,R11
	std y+0,R10
	ldi R18,<L41
	ldi R19,>L41
	movw R30,R20
	ldd R16,z+2
	ldd R17,z+3
	xcall _fprintf_P
;     fflush(session->ftp_stream);
	movw R30,R20
	ldd R16,z+2
	ldd R17,z+3
	xcall _fflush
; 
;     return 0;
	clr R16
	clr R17
L40:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgset300C
	.area lit(rom, con, rel)
L43:
	.byte 37,'d,32,'F,'a,'i,'l,'e,'d,13,10,0
	.area text(rom, con, rel)
;           code -> R10,R11
;        session -> R20,R21
	.even
_NutFtpRespondBad::
	xcall push_xgset300C
	movw R10,R18
	movw R20,R16
	sbiw R28,2
; }
; 
; /*!
;  * \brief Send a negative response.
;  *
;  * \param session Pointer to an \ref FTPSESSION structure, obtained by a 
;  *                previous call to NutFtpOpenSession().
;  * \param code    Response code.
;  *
;  * \return -1 if the session ended. Otherwise 0 is returned.
;  */
; int NutFtpRespondBad(FTPSESSION * session, int code)
; {
;     static prog_char fmt_P[] = "%d Failed\r\n";
; 
; #ifdef FTPD_DEBUG
;     printf("\n<'%d Failed' ", code);
; #endif
;     fprintf_P(session->ftp_stream, fmt_P, code);
	std y+1,R11
	std y+0,R10
	ldi R18,<L43
	ldi R19,>L43
	movw R30,R20
	ldd R16,z+2
	ldd R17,z+3
	xcall _fprintf_P
;     fflush(session->ftp_stream);
	movw R30,R20
	ldd R16,z+2
	ldd R17,z+3
	xcall _fflush
; 
;     return 0;
	clr R16
	clr R17
L42:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgset300C
	.area lit(rom, con, rel)
L45:
	.byte 49,53,48,32,'O,'p,'e,'n,'i,'n,'g,32,0
L46:
	.byte 'A,'S,'C,'I,'I,46,13,10,0
L47:
	.byte 'B,'I,'N,'A,'R,'Y,46,13,10,0
	.area text(rom, con, rel)
;         binary -> R10,R11
;        session -> R20,R21
	.even
_NutFtpSendMode::
	xcall push_xgsetF00C
	movw R10,R18
	movw R20,R16
; }
; 
; /*!
;  * \brief Send a response including the specified transfer mode.
;  *
;  * \param session Pointer to an \ref FTPSESSION structure, obtained by a 
;  *                previous call to NutFtpOpenSession().
;  * \param binary  0 indicates ASCII transfer mode.
;  *
;  * \return -1 if the session ended. Otherwise 0 is returned.
;  */
; int NutFtpSendMode(FTPSESSION * session, int binary)
; {
;     static prog_char intro_P[] = "150 Opening ";
;     static prog_char amode_P[] = "ASCII.\r\n";
;     static prog_char bmode_P[] = "BINARY.\r\n";
; 
; #ifdef FTPD_DEBUG
;     printf("\n<'150 Opening %s' ", binary ? "BINARY" : "ASCII");
; #endif
;     fputs_P(intro_P, session->ftp_stream);
	movw R30,R20
	ldd R18,z+2
	ldd R19,z+3
	ldi R16,<L45
	ldi R17,>L45
	xcall _fputs_P
;     fputs_P(binary ? bmode_P : amode_P, session->ftp_stream);
	movw R30,R20
	ldd R18,z+2
	ldd R19,z+3
	tst R10
	brne X19
	tst R11
	breq L48
X19:
	ldi R22,<L47
	ldi R23,>L47
	xjmp L49
L48:
	ldi R22,<L46
	ldi R23,>L46
L49:
	movw R16,R22
	xcall _fputs_P
;     fflush(session->ftp_stream);
	movw R30,R20
	ldd R16,z+2
	ldd R17,z+3
	xcall _fflush
; 
;     return 0;
	clr R16
	clr R17
L44:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
;           full -> R10,R11
;             cp -> R20,R21
;           path -> R22,R23
;           work -> R12,R13
;           root -> R14,R15
	.even
_CreateFullPathName::
	xcall push_xgsetF0FC
	movw R12,R18
	movw R14,R16
	ldd R22,y+10
	ldd R23,y+11
; }
; 
; /*!
;  * \brief Create an absolute path name.
;  *
;  * Combines an absolute directory path with a relative path name to a
;  * full absolute path name. The absolute directory is split into two
;  * parts, the root and the current work directory. The resulting path
;  * will never be above the specified root. 
;  *
;  * \param root Non-empty absolute root directory path including the 
;  *             device name, but without a trailing slash.
;  * \param work Absolute work directory path below root including a
;  *             leading, but without a trailing slash. This path is
;  *             ignored if the relative path starts with a slash.
;  * \param path Relative path name of a file or directory without any
;  *             trailing slash.
;  *
;  * \return Pointer to the resulting path name. The buffer for this name 
;  *         is allocated from heap memory. The caller is responsible for 
;  *         freeing it. In case of an error, a NULL pointer is returned.
;  */
; char *CreateFullPathName(char *root, char *work, char *path)
; {
;     char *full;
;     char *cp;
; 
;     if (root == 0 || work == 0 || path == 0) {
	tst R14
	brne X20
	tst R15
	breq L54
X20:
	tst R12
	brne X21
	tst R13
	breq L54
X21:
	cpi R22,0
	cpc R22,R23
	brne L51
X22:
L54:
;         return 0;
	clr R16
	clr R17
	xjmp L50
L51:
;     }
;     if ((full = malloc(strlen(root) + strlen(work) + strlen(path) + 1)) != 0) {
	movw R16,R14
	xcall _strlen
	movw R2,R16
	movw R16,R12
	push R2
	push R3
	xcall _strlen
	movw R4,R16
	movw R16,R22
	push R4
	push R5
	xcall _strlen
	pop R5
	pop R4
	pop R3
	pop R2
	movw R10,R16
	movw R16,R2
	add R16,R4
	adc R17,R5
	add R16,R10
	adc R17,R11
	subi R16,255  ; offset = 1
	sbci R17,255
	xcall _malloc_M
	movw R20,R16
	movw R10,R20
	cpi R16,0
	cpc R16,R17
	brne X37
	xjmp L55
X37:
X23:
;         cp = strcpy(full, root);
	movw R18,R14
	xcall _strcpy
	movw R14,R16
	movw R20,R14
;         cp += strlen(cp);
	xcall _strlen
	movw R14,R16
	add R20,R16
	adc R21,R17
; 
;         /* Ignore working directory if specified path is absolute. */
;         if (*path == '/') {
	movw R30,R22
	ldd R24,z+0
	cpi R24,47
	brne L57
X24:
;             work = cp;
	movw R12,R20
;         } else {
	xjmp L60
L57:
;             work = strcpy(cp, work);
	movw R18,R12
	movw R16,R20
	xcall _strcpy
	movw R14,R16
	movw R12,R14
;             cp += strlen(cp);
	movw R16,R20
	xcall _strlen
	movw R14,R16
	add R20,R16
	adc R21,R17
;         }
	xjmp L60
L59:
; 
;         while (*path) {
;             if (*path == '/') {
	movw R30,R22
	ldd R24,z+0
	cpi R24,47
	brne L62
X25:
;                 path++;
	subi R22,255  ; offset = 1
	sbci R23,255
;                 continue;
	xjmp L60
L62:
;             }
;             if (*path == '.') {
	movw R30,R22
	ldd R24,z+0
	cpi R24,46
	breq X38
	xjmp L64
X38:
X26:
;                 path++;
	subi R22,255  ; offset = 1
	sbci R23,255
;                 if (*path == '/' || *path == 0) {
	movw R30,R22
	ldd R14,z+0
	clr R15
	mov R24,R14
	cpi R24,47
	breq L68
X27:
	tst R24
	brne L66
X28:
L68:
;                     /* Skip references to the current directory. */
;                     continue;
	xjmp L60
L66:
;                 }
;                 if (*path == '.') {
	movw R30,R22
	ldd R24,z+0
	cpi R24,46
	brne L69
X29:
;                     path++;
	subi R22,255  ; offset = 1
	sbci R23,255
;                     if (*path == '/' || *path == 0) {
	movw R30,R22
	ldd R14,z+0
	clr R15
	mov R24,R14
	cpi R24,47
	breq L73
X30:
	tst R24
	brne L71
X31:
L73:
;                         /* Go up one level. */
;                         if ((cp = strrchr(work, '/')) == 0) {
	ldi R18,47
	ldi R19,0
	movw R16,R12
	xcall _strrchr
	movw R14,R16
	movw R20,R14
	cpi R16,0
	cpc R16,R17
	brne L74
X32:
;                             cp = work;
	movw R20,R12
;                         }
L74:
;                         *cp = 0;
	clr R2
	movw R30,R20
	std z+0,R2
;                         continue;
	xjmp L60
L71:
;                     }
;                     path--;
	subi R22,1
	sbci R23,0
;                 }
L69:
;                 path--;
	subi R22,1
	sbci R23,0
;             }
L64:
;             if (*(cp - 1) != '/') {
	movw R30,R20
	sbiw R30,1
	ldd R24,z+0
	cpi R24,47
	breq L79
X33:
;                 *cp++ = '/';
	ldi R24,47
	movw R30,R20
	st Z+,R24
	movw R20,R30
;             }
	xjmp L79
L78:
;             while (*path && *path != '/') {
;                 *cp++ = *path++;
	movw R30,R22
	movw R26,R20
	ld R0,Z+
	movw R22,R30
	st X+,R0
	movw R20,R26
;             }
L79:
	movw R30,R22
	ldd R14,z+0
	clr R15
	tst R14
	breq L81
X34:
	mov R24,R14
	cpi R24,47
	brne L78
X35:
L81:
;         }
L60:
	movw R30,R22
	ldd R2,z+0
	tst R2
	breq X39
	xjmp L59
X39:
X36:
;         *cp = 0;
	clr R2
	movw R30,R20
	std z+0,R2
;     }
L55:
;     return full;
	movw R16,R10
L50:
	.dbline 0 ; func end
	xjmp pop_xgsetF0FC
;             rc -> R12,R13
;           sock -> R10,R11
;        session -> R20,R21
	.even
_NutFtpDataConnect::
	xcall push_xgset30FC
	movw R20,R16
	sbiw R28,4
; }
; 
; /*!
;  * \brief Establish an FTP connection for data transfer.
;  *
;  * \param session Pointer to an \ref FTPSESSION structure, obtained by a 
;  *                previous call to NutFtpOpenSession().
;  *
;  * \return Socket descriptor of the newly created data connection or
;  *         0 if we were unable to establish the connection.
;  */
; TCPSOCKET *NutFtpDataConnect(FTPSESSION * session)
; {
;     TCPSOCKET *sock;
;     int rc;
; 
;     if ((sock = NutTcpCreateSocket()) != 0) {
	xcall _NutTcpCreateSocket
	movw R10,R16
	tst R10
	brne X40
	tst R11
	brne X44
	xjmp L83
X44:
X40:
; 
;         if (session->ftp_maxseg) {
	movw R30,R20
	ldd R2,z+12
	ldd R3,z+13
	tst R2
	brne X41
	tst R3
	breq L85
X41:
;             NutTcpSetSockOpt(sock, TCP_MAXSEG, &session->ftp_maxseg, sizeof(session->ftp_maxseg));
	ldi R24,2
	ldi R25,0
	std y+3,R25
	std y+2,R24
	movw R24,R30
	adiw R24,12
	std y+1,R25
	std y+0,R24
	ldi R18,2
	ldi R19,0
	xcall _NutTcpSetSockOpt
;         }
L85:
;         if (session->ftp_passive) {
	movw R30,R20
	ldd R2,z+16
	tst R2
	breq L87
X42:
;             rc = NutTcpAccept(sock, session->ftp_data_port);
	ldd R18,z+10
	ldd R19,z+11
	movw R16,R10
	xcall _NutTcpAccept
	movw R12,R16
;         } else {
	xjmp L88
L87:
;             rc = NutTcpConnect(sock, session->ftp_data_ip, session->ftp_data_port);
	movw R30,R20
	ldd R2,z+10
	ldd R3,z+11
	std y+3,R3
	std y+2,R2
	ldd R2,z+6
	ldd R3,z+7
	ldd R4,z+8
	ldd R5,z+9
	std y+0,R4
	std y+1,R5
	movw R18,R2
	movw R16,R10
	xcall _NutTcpConnect
	movw R14,R16
	movw R12,R14
;         }
L88:
;         if (rc) {
	tst R12
	brne X43
	tst R13
	breq L89
X43:
;             NutTcpCloseSocket(sock);
	movw R16,R10
	xcall _NutTcpCloseSocket
;             sock = 0;
	clr R10
	clr R11
;         }
L89:
;     }
L83:
;     return sock;
	movw R16,R10
L82:
	.dbline 0 ; func end
	adiw R28,4
	xjmp pop_xgset30FC
;            len -> R22,R23
;             cp -> R20,R21
;           path -> R10,R11
	.even
_NutRegisterFtpRoot::
	xcall push_xgsetF03C
	movw R10,R16
; }
; 
; /*!
;  * \brief Register the FTP server's root directory.
;  *
;  * Only one root directory is supported. Subsequent calls will
;  * override previous settings.
;  *
;  * \param path Path name of the root directory. Must include the
;  *             device name followed by a colon followed by an
;  *             absolute directory path. May be set to NULL for 
;  *             the default #FTP_ROOTPATH.
;  *
;  * \return 0 on success, -1 otherwise.
;  */
; int NutRegisterFtpRoot(CONST char *path)
; {
;     /* Reset path to default. */
;     if (path == NULL || *path == 0) {
	tst R10
	brne X45
	tst R11
	breq L94
X45:
	movw R30,R10
	ldd R2,z+0
	tst R2
	brne L92
X46:
L94:
;         /* Release previously allocate space. */
;         if (ftp_root) {
	lds R2,_ftp_root
	lds R3,_ftp_root+1
	tst R2
	brne X47
	tst R3
	breq L95
X47:
;             free(ftp_root);
	movw R16,R2
	xcall _free_M
;         }
L95:
;         if ((ftp_root = malloc(sizeof(FTP_ROOTPATH))) == 0) {
	ldi R16,6
	ldi R17,0
	xcall _malloc_M
	sts _ftp_root+1,R17
	sts _ftp_root,R16
	cpi R16,0
	cpc R16,R17
	brne L97
X48:
;             return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L91
L97:
;         }
;         strcpy(ftp_root, FTP_ROOTPATH);
	ldi R18,<L99
	ldi R19,>L99
	lds R16,_ftp_root
	lds R17,_ftp_root+1
	xcall _strcpy
;     }
	xjmp L93
L92:
; 
;     /* Set a specified path. */
;     else {
;         char *cp = strchr(path, ':');
	ldi R18,58
	ldi R19,0
	movw R16,R10
	xcall _strchr
	movw R20,R16
;         int len = strlen(path);
	movw R16,R10
	xcall _strlen
	movw R12,R16
	movw R22,R12
; 
;         /* Make sure that the path fulfills all requirements. */
;         if (len < 2 || cp == 0 || (*++cp && *cp != '/')) {
	cpi R16,2
	ldi R30,0
	cpc R17,R30
	brlt L103
X49:
	cpi R20,0
	cpc R20,R21
	breq L103
X50:
	movw R24,R20
	adiw R24,1
	movw R12,R24
	movw R20,R24
	movw R30,R24
	ldd R2,z+0
	tst R2
	breq L100
X51:
	ldd R24,z+0
	cpi R24,47
	breq L100
X52:
L103:
;             return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L91
L100:
;         }
; 
;         /* Allocate space for new path, but preserve the current one. */
;         if ((cp = malloc(len + 1)) == 0) {
	movw R16,R22
	subi R16,255  ; offset = 1
	sbci R17,255
	xcall _malloc_M
	movw R12,R16
	movw R20,R12
	cpi R16,0
	cpc R16,R17
	brne L104
X53:
;             return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L91
L104:
;         }
; 
;         /* Take over, releasing previously allocate space. */
;         strcpy(cp, path);
	movw R18,R10
	movw R16,R20
	xcall _strcpy
;         if (ftp_root) {
	lds R2,_ftp_root
	lds R3,_ftp_root+1
	tst R2
	brne X54
	tst R3
	breq L106
X54:
;             free(ftp_root);
	movw R16,R2
	xcall _free_M
;         }
L106:
;         ftp_root = cp;
	sts _ftp_root+1,R21
	sts _ftp_root,R20
; 
;         /* Chop off an optional trailing slash. */
;         cp = cp + strlen(cp) - 1;
	movw R16,R20
	xcall _strlen
	movw R10,R16
	movw R2,R10
	add R2,R20
	adc R3,R21
	movw R20,R2
	subi R20,1
	sbci R21,0
;         if (*cp == '/') {
	movw R30,R20
	ldd R24,z+0
	cpi R24,47
	brne L108
X55:
;             *cp = 0;
	clr R2
	std z+0,R2
;         }
L108:
;     }
L93:
;     return 0;
	clr R16
	clr R17
L91:
	.dbline 0 ; func end
	xjmp pop_xgsetF03C
;           pass -> R10,R11
;           user -> R12,R13
	.even
_NutRegisterFtpUser::
	xcall push_xgset303C
	movw R10,R18
	movw R12,R16
; }
; 
; /*!
;  * \brief Register an FTP user.
;  *
;  * Only one username/password pair is supported. Subsequent calls will
;  * override previous settings.
;  *
;  * \warning Not successfully registering any will make file systems 
;  *          accessible by anyone.
;  *
;  * \param user User's name.
;  * \param pass Uncrypted password for the specified user.
;  *
;  * \return 0 on success. -1 is returned on failures, in which case
;  *         no protection may be assumed.
;  */
; int NutRegisterFtpUser(CONST char *user, CONST char *pass)
; {
;     if (ftp_user) {
	lds R2,_ftp_user
	lds R3,_ftp_user+1
	tst R2
	brne X56
	tst R3
	breq L111
X56:
;         free(ftp_user);
	movw R16,R2
	xcall _free_M
;         ftp_user = 0;
	clr R2
	clr R3
	sts _ftp_user+1,R3
	sts _ftp_user,R2
;     }
L111:
;     if (user && *user) {
	tst R12
	brne X57
	tst R13
	breq L113
X57:
	movw R30,R12
	ldd R2,z+0
	tst R2
	breq L113
X58:
;         if ((ftp_user = malloc(strlen(user) + 1)) == 0) {
	movw R16,R30
	xcall _strlen
	subi R16,255  ; offset = 1
	sbci R17,255
	xcall _malloc_M
	sts _ftp_user+1,R17
	sts _ftp_user,R16
	cpi R16,0
	cpc R16,R17
	brne L115
X59:
;             return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L110
L115:
;         }
;         strcpy(ftp_user, user);
	movw R18,R12
	lds R16,_ftp_user
	lds R17,_ftp_user+1
	xcall _strcpy
;     }
L113:
;     if (ftp_pass) {
	lds R2,_ftp_pass
	lds R3,_ftp_pass+1
	tst R2
	brne X60
	tst R3
	breq L117
X60:
;         free(ftp_pass);
	movw R16,R2
	xcall _free_M
;         ftp_pass = 0;
	clr R2
	clr R3
	sts _ftp_pass+1,R3
	sts _ftp_pass,R2
;     }
L117:
;     if (pass && *pass) {
	tst R10
	brne X61
	tst R11
	breq L119
X61:
	movw R30,R10
	ldd R2,z+0
	tst R2
	breq L119
X62:
;         if ((ftp_pass = malloc(strlen(pass) + 1)) == 0) {
	movw R16,R30
	xcall _strlen
	movw R20,R16
	subi R16,255  ; offset = 1
	sbci R17,255
	xcall _malloc_M
	movw R12,R16
	sts _ftp_pass+1,R13
	sts _ftp_pass,R12
	cpi R16,0
	cpc R16,R17
	brne L121
X63:
;             return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L110
L121:
;         }
;         strcpy(ftp_pass, pass);
	movw R18,R10
	lds R16,_ftp_pass
	lds R17,_ftp_pass+1
	xcall _strcpy
;     }
L119:
;     return 0;
	clr R16
	clr R17
L110:
	.dbline 0 ; func end
	xjmp pop_xgset303C
;        session -> R20,R21
;           sock -> R22,R23
	.even
_NutFtpOpenSession::
	xcall push_xgsetF00C
	movw R22,R16
	sbiw R28,2
; }
; 
; 
; /*!
;  * \brief Open an FTP server session.
;  *
;  * \param sock Socket of an established TCP connection.
;  *
;  * \return Pointer to an \ref FTPSESSION structure, which can be used
;  *         in subsequent API calls. NULL is returned in case of any
;  *         error.
;  */
; FTPSESSION *NutFtpOpenSession(TCPSOCKET * sock)
; {
;     FTPSESSION *session;
; 
;     session = malloc(sizeof(FTPSESSION));
	ldi R16,17
	ldi R17,0
	xcall _malloc_M
	movw R20,R16
; 
;     if (session) {
	cpi R16,0
	cpc R16,R17
	brne X67
	xjmp L124
X67:
X64:
;         memset(session, 0, sizeof(FTPSESSION));
	ldi R24,17
	ldi R25,0
	std y+1,R25
	std y+0,R24
	clr R18
	clr R19
	xcall _memset
;         session->ftp_data_port = FTP_DATA_PORT;
	ldi R24,20
	ldi R25,0
	movw R30,R20
	std z+11,R25
	std z+10,R24
;         session->ftp_maxseg = sock->so_mss;
	movw R30,R22
	subi R30,174  ; addi 82
	sbci R31,255
	ldd R2,z+0
	ldd R3,z+1
	movw R30,R20
	std z+13,R3
	std z+12,R2
;         session->ftp_sock = sock;
	std z+1,R23
	std z+0,R22
; 
;         /* Set initial working directory. */
;         if ((session->ftp_cwd = malloc(2)) == 0) {
	ldi R16,2
	ldi R17,0
	xcall _malloc_M
	movw R30,R20
	std z+5,R17
	std z+4,R16
	cpi R16,0
	cpc R16,R17
	brne L126
X65:
;             free(session);
	movw R16,R30
	xcall _free_M
;             session = 0;
	clr R20
	clr R21
;         } else {
	xjmp L127
L126:
;             session->ftp_cwd[0] = '/';
	ldi R24,47
	movw R30,R20
	ldd R26,z+4
	ldd R27,z+5
	st x,R24
;             session->ftp_cwd[1] = 0;
	clr R2
	push R26
	push R27
	ldd R26,z+4
	ldd R27,z+5
	movw R30,R26
	pop R27
	pop R26
	std z+1,R2
; 
;             /*
;              * Open a stream and associate it with the socket, so 
;              * we can use standard I/O. Note, that socket streams
;              * currently do support text mode.
;              */
;             if ((session->ftp_stream = _fdopen((int) sock, "r+b")) == 0) {
	ldi R18,<L130
	ldi R19,>L130
	movw R16,R22
	xcall __fdopen
	movw R10,R16
	movw R30,R20
	std z+3,R11
	std z+2,R10
	cpi R16,0
	cpc R16,R17
	brne L128
X66:
;                 free(session->ftp_cwd);
	ldd R16,z+4
	ldd R17,z+5
	xcall _free_M
;                 free(session);
	movw R16,R20
	xcall _free_M
;                 session = 0;
	clr R20
	clr R21
;             }
L128:
;         }
L127:
;     }
L124:
;     return session;
	movw R16,R20
L123:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgsetF00C
;        session -> R20,R21
	.even
_NutFtpCloseSession::
	st -y,R20
	st -y,R21
	movw R20,R16
; }
; 
; /*!
;  * \brief Close an FTP server session.
;  *
;  * \param session Pointer to an \ref FTPSESSION structure, obtained by a 
;  *                previous call to NutFtpOpenSession().
;  */
; void NutFtpCloseSession(FTPSESSION * session)
; {
;     if (session) {
	cpi R20,0
	cpc R20,R21
	breq L132
X68:
;         /* Close the stream. */
;         fclose(session->ftp_stream);
	movw R30,R20
	ldd R16,z+2
	ldd R17,z+3
	xcall _fclose
;         if (session->ftp_cwd) {
	movw R30,R20
	ldd R2,z+4
	ldd R3,z+5
	tst R2
	brne X69
	tst R3
	breq L134
X69:
;             free(session->ftp_cwd);
	ldd R16,z+4
	ldd R17,z+5
	xcall _free_M
;         }
L134:
;         free(session);
	movw R16,R20
	xcall _free_M
;     }
L132:
L131:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
;             st -> y+0
;             cp -> R22,R23
;           path -> R10,R11
;        session -> R20,R21
	.even
_NutFtpProcessCwd::
	xcall push_xgsetF03C
	movw R10,R18
	movw R20,R16
	sbiw R28,13
; }
; 
; /*!
;  * \brief Process an FTP client's CWD command.
;  *
;  * \param session Pointer to an \ref FTPSESSION structure, obtained by a 
;  *                previous call to NutFtpOpenSession().
;  * \param path    Full absolute path name of the directory.
;  *
;  * \return 0 if the command has been processed or -1 if the
;  *         session has been aborted.
;  */
; int NutFtpProcessCwd(FTPSESSION * session, char *path)
; {
;     struct stat st;
;     char *cp;
; 
;     /*
;      * Check, if the path exists and if this is a directory. 
;      */
;     if (stat(path, &st) || st.st_mode == 0) {
	movw R18,R28
	movw R16,R10
	xcall _stat
	cpi R16,0
	cpc R16,R17
	brne L140
X70:
	ldd R2,y+2
	tst R2
	brne L137
X71:
L140:
;         return NutFtpRespondBad(session, 550);
	ldi R18,550
	ldi R19,2
	movw R16,R20
	xcall _NutFtpRespondBad
	xjmp L136
L137:
;     }
; 
;     /*
;      * Store the new working directory excluding our root part.
;      */
;     cp = path + strlen(ftp_root);
	lds R16,_ftp_root
	lds R17,_ftp_root+1
	xcall _strlen
	movw R12,R16
	movw R22,R12
	add R22,R10
	adc R23,R11
;     if (*cp == 0) {
	movw R30,R22
	ldd R2,z+0
	tst R2
	brne L141
X72:
;         cp = "/";
	ldi R22,<L143
	ldi R23,>L143
;     }
L141:
;     if (session->ftp_cwd) {
	movw R30,R20
	ldd R2,z+4
	ldd R3,z+5
	tst R2
	brne X73
	tst R3
	breq L144
X73:
;         free(session->ftp_cwd);
	ldd R16,z+4
	ldd R17,z+5
	xcall _free_M
;     }
L144:
;     if ((session->ftp_cwd = malloc(strlen(cp) + 1)) == 0) {
	movw R16,R22
	xcall _strlen
	subi R16,255  ; offset = 1
	sbci R17,255
	xcall _malloc_M
	movw R10,R16
	movw R30,R20
	std z+5,R11
	std z+4,R10
	cpi R16,0
	cpc R16,R17
	brne L146
X74:
;         return NutFtpRespondBad(session, 550);
	ldi R18,550
	ldi R19,2
	movw R16,R30
	xcall _NutFtpRespondBad
	movw R10,R16
	xjmp L136
L146:
;     }
;     strcpy(session->ftp_cwd, cp);
	movw R18,R22
	movw R30,R20
	ldd R16,z+4
	ldd R17,z+5
	xcall _strcpy
; 
;     return NutFtpRespondOk(session, 250);
	ldi R18,250
	ldi R19,0
	movw R16,R20
	xcall _NutFtpRespondOk
	movw R10,R16
L136:
	.dbline 0 ; func end
	adiw R28,13
	xjmp pop_xgsetF03C
;           path -> R12,R13
;        session -> R10,R11
	.even
_NutFtpProcessDelete::
	xcall push_xgset003C
	movw R12,R18
	movw R10,R16
; }
; 
; /*!
;  * \brief Process an FTP client's DELE command.
;  *
;  * Causes the specified file to be deleted.
;  *
;  * \param session Pointer to an \ref FTPSESSION structure, obtained by a 
;  *                previous call to NutFtpOpenSession().
;  * \param path    Full absolute path name of the file.
;  *
;  * \return 0 if the command has been processed or -1 if the
;  *         session has been aborted.
;  */
; int NutFtpProcessDelete(FTPSESSION * session, char *path)
; {
;     if (unlink(path)) {
	movw R16,R12
	xcall _unlink
	cpi R16,0
	cpc R16,R17
	breq L149
X75:
;         return NutFtpRespondBad(session, 550);
	ldi R18,550
	ldi R19,2
	movw R16,R10
	xcall _NutFtpRespondBad
	xjmp L148
L149:
;     }
;     return NutFtpRespondOk(session, 250);
	ldi R18,250
	ldi R19,0
	movw R16,R10
	xcall _NutFtpRespondOk
	movw R10,R16
L148:
	.dbline 0 ; func end
	xjmp pop_xgset003C
;              x -> R20,R21
;            got -> R22,R23
;            buf -> R10,R11
;            mss -> R12,R13
;           sock -> y+6
;             fh -> y+4
;             ec -> y+2
;           mode -> y+22
;           path -> y+20
;        session -> y+18
	.even
_NutFtpTransferFile::
	xcall push_arg4
	xcall push_xgsetF0FC
	sbiw R28,8
; }
; 
; /*!
;  * \brief Transfer a file to or from the FTP client.
;  *
;  * \param session Pointer to an \ref FTPSESSION structure, obtained by a 
;  *                previous call to NutFtpOpenSession().
;  * \param path    Full absolute path name of the file.
;  * \param mode    If set to zero, the server will accept the data 
;  *                transferred via the data connection and to store the 
;  *                data as a file. If the file exists, then its contents 
;  *                will be replaced by the data being transferred. A new 
;  *                file is created, if the file does not already exist.
;  *                If this parameter is not equal zero, then the server 
;  *                will transfer a copy of the specified file.
;  *
;  * \return 0 if the command has been processed or -1 if the
;  *         session has been aborted.
;  */
; int NutFtpTransferFile(FTPSESSION * session, char *path, int mode)
; {
;     TCPSOCKET *sock;
;     int ec = 550;
	ldi R24,550
	ldi R25,2
	std y+3,R25
	std y+2,R24
;     int fh;
; 
;     /* Open the file to send. */
;     if (mode) {
	ldd R0,y+22
	ldd R1,y+23
	tst R0
	brne X76
	tst R1
	breq L152
X76:
;         fh = _open(path, _O_BINARY | _O_RDONLY);
	ldi R18,32768
	ldi R19,128
	ldd R16,y+20
	ldd R17,y+21
	xcall __open
	std y+5,R17
	std y+4,R16
;     }
	xjmp L153
L152:
;     /* Open the file to receive. */
;     else {
;         fh = _open(path, _O_CREAT);
	ldi R18,256
	ldi R19,1
	ldd R16,y+20
	ldd R17,y+21
	xcall __open
	std y+5,R17
	std y+4,R16
;     }
L153:
; 
;     if (fh != -1) {
	ldd R24,y+4
	ldd R25,y+5
	cpi R24,255
	ldi R30,255
	cpc R25,R30
	brne X89
	xjmp L154
X89:
X77:
;         /* File status OK, opening data connection */
;         NutFtpSendMode(session, session->ftp_tran_mode);
	ldd R30,y+18
	ldd R31,y+19
	ldd R18,z+15
	clr R19
	movw R16,R30
	xcall _NutFtpSendMode
;         if ((sock = NutFtpDataConnect(session)) != 0) {
	ldd R16,y+18
	ldd R17,y+19
	xcall _NutFtpDataConnect
	movw R10,R16
	std y+7,R11
	std y+6,R10
	cpi R16,0
	cpc R16,R17
	brne X90
	xjmp L156
X90:
X78:
;             u_short mss = sock->so_mss;
	movw R30,R10
	subi R30,174  ; addi 82
	sbci R31,255
	ldd R12,z+0
	ldd R13,z+1
;             u_char *buf;
; 
;             if (mss < 256) {
	movw R24,R12
	cpi R24,0
	ldi R30,1
	cpc R25,R30
	brsh L158
X79:
;                 mss = 256;
	ldi R24,256
	ldi R25,1
	movw R12,R24
;             }
L158:
;             if ((buf = malloc(mss)) != 0) {
	movw R16,R12
	xcall _malloc_M
	movw R14,R16
	movw R10,R14
	cpi R16,0
	cpc R16,R17
	brne X91
	xjmp L160
X91:
X80:
;                 int got;
; 
;                 ec = 0;
	clr R0
	clr R1
	std y+3,R1
	std y+2,R0
; 
;                 /* Send a file. */
;                 if (mode) {
	ldd R0,y+22
	ldd R1,y+23
	tst R0
	brne X81
	tst R1
	breq L170
X81:
	xjmp L165
L164:
;                     while ((got = _read(fh, buf, mss)) > 0) {
;                         if (NutTcpSend(sock, buf, got) != got) {
	std y+1,R23
	std y+0,R22
	movw R18,R10
	ldd R16,y+6
	ldd R17,y+7
	xcall _NutTcpSend
	movw R14,R16
	cp R16,R22
	cpc R17,R23
	breq L167
X82:
;                             ec = 551;
	ldi R24,551
	ldi R25,2
	std y+3,R25
	std y+2,R24
;                             break;
	xjmp L163
L167:
;                         }
;                     }
L165:
	std y+1,R13
	std y+0,R12
	movw R18,R10
	ldd R16,y+4
	ldd R17,y+5
	xcall __read
	movw R14,R16
	movw R22,R14
	clr R2
	clr R3
	cp R2,R16
	cpc R3,R17
	brlt L164
X83:
;                 }
	xjmp L163
L169:
; 
;                 /* Receive a file. */
;                 else {
;                     while ((got = NutTcpReceive(sock, buf, mss)) > 0) {
;                         int x;
;                         if ((x = _write(fh, buf, got)) != got) {
	std y+1,R23
	std y+0,R22
	movw R18,R10
	ldd R16,y+4
	ldd R17,y+5
	xcall __write
	movw R14,R16
	movw R20,R14
	cp R16,R22
	cpc R17,R23
	breq L172
X84:
;                             ec = 552;
	ldi R24,552
	ldi R25,2
	std y+3,R25
	std y+2,R24
;                             break;
	xjmp L171
L172:
;                         }
;                     }
L170:
	std y+1,R13
	std y+0,R12
	movw R18,R10
	ldd R16,y+6
	ldd R17,y+7
	xcall _NutTcpReceive
	movw R14,R16
	movw R22,R14
	clr R2
	clr R3
	cp R2,R16
	cpc R3,R17
	brlt L169
X85:
L171:
;                 }
L163:
;                 free(buf);
	movw R16,R10
	xcall _free_M
;             }
L160:
;             NutTcpCloseSocket(sock);
	ldd R16,y+6
	ldd R17,y+7
	xcall _NutTcpCloseSocket
;         }
L156:
;         _close(fh);
	ldd R16,y+4
	ldd R17,y+5
	xcall __close
; 
;         /* Remove files received with an error. */
;         if (mode == 0 && ec) {
	ldd R0,y+22
	ldd R1,y+23
	tst R0
	brne L174
	tst R1
	brne L174
X86:
	ldd R0,y+2
	ldd R1,y+3
	tst R0
	brne X87
	tst R1
	breq L174
X87:
;             unlink(path);
	ldd R16,y+20
	ldd R17,y+21
	xcall _unlink
;         }
L174:
;     }
L154:
;     if (ec) {
	ldd R0,y+2
	ldd R1,y+3
	tst R0
	brne X88
	tst R1
	breq L176
X88:
;         return NutFtpRespondBad(session, ec);
	movw R18,R0
	ldd R16,y+18
	ldd R17,y+19
	xcall _NutFtpRespondBad
	movw R10,R16
	xjmp L151
L176:
;     }
;     return NutFtpRespondOk(session, 226);
	ldi R18,226
	ldi R19,0
	ldd R16,y+18
	ldd R17,y+19
	xcall _NutFtpRespondOk
	movw R10,R16
L151:
	.dbline 0 ; func end
	adiw R28,8
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
;           size -> y+17
;           sock -> R14,R15
;             st -> y+4
;            gmt -> R12,R13
;             fp -> R22,R23
;             ec -> y+23
;           name -> R20,R21
;            dir -> y+21
;          d_ent -> R10,R11
;           path -> y+37
;        session -> y+35
	.even
_NutFtpTransferDirectory::
	xcall push_arg4
	xcall push_xgsetF0FC
	sbiw R28,25
; }
; 
; /*!
;  * \brief Process an FTP client's LIST or NLST command.
;  *
;  * Causes a directory listing to be sent to the client.
;  *
;  * \param session Pointer to an \ref FTPSESSION structure, obtained by a 
;  *                previous call to NutFtpOpenSession().
;  * \param path    Full absolute path name of the directory.
;  *
;  * \return 0 if the command has been processed or -1 if the
;  *         session has been aborted.
;  */
; int NutFtpTransferDirectory(FTPSESSION * session, char *path)
; {
;     TCPSOCKET *sock;
;     FILE *fp;
; 
;     struct stat st;
;     DIR *dir;
;     struct dirent *d_ent;
;     tm *gmt;
;     u_long size;
;     int ec = 550;
	ldi R24,550
	ldi R25,2
	std y+24,R25
	std y+23,R24
;     char *name;
; 
;     dir = opendir(path);
	ldd R16,y+37
	ldd R17,y+38
	xcall _opendir
	std y+22,R17
	std y+21,R16
;     if (dir) {
	movw R0,R16
	cpi R16,0
	cpc R16,R17
	brne X102
	xjmp L179
X102:
X92:
;         NutFtpSendMode(session, 0);
	clr R18
	clr R19
	ldd R16,y+35
	ldd R17,y+36
	xcall _NutFtpSendMode
;         if ((sock = NutFtpDataConnect(session)) != 0) {
	ldd R16,y+35
	ldd R17,y+36
	xcall _NutFtpDataConnect
	movw R14,R16
	tst R14
	brne X93
	tst R15
	brne X103
	xjmp L181
X103:
X93:
;             if ((fp = _fdopen((int) sock, "r+b")) != 0) {
	ldi R18,<L130
	ldi R19,>L130
	xcall __fdopen
	movw R10,R16
	movw R22,R10
	cpi R16,0
	cpc R16,R17
	brne X104
	xjmp L183
X104:
X94:
;                 ec = 0;
	clr R0
	clr R1
	std y+24,R1
	std y+23,R0
	xjmp L186
L185:
;                 while ((d_ent = readdir(dir)) != 0) {
;                     if (d_ent->d_name[0] == 0) {
	movw R30,R10
	ldd R2,z+8
	tst R2
	brne L188
X95:
;                         break;
	xjmp L187
L188:
;                     }
;                     if (d_ent->d_name[0] == '.') {
	movw R30,R10
	ldd R24,z+8
	cpi R24,46
	brne L190
X96:
;                         continue;
	xjmp L186
L190:
;                     }
; 
;                     if ((name = malloc(strlen(path) + strlen(d_ent->d_name) + 2)) != 0) {
	ldd R16,y+37
	ldd R17,y+38
	xcall _strlen
	movw R20,R16
	movw R16,R10
	subi R16,248  ; offset = 8
	sbci R17,255
	xcall _strlen
	movw R12,R16
	movw R16,R20
	add R16,R12
	adc R17,R13
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _malloc_M
	movw R12,R16
	movw R20,R12
	cpi R16,0
	cpc R16,R17
	brne X105
	xjmp L192
X105:
X97:
;                         sprintf(name, "%s/%s", path, d_ent->d_name);
	movw R24,R10
	adiw R24,8
	std y+3,R25
	std y+2,R24
	ldd R0,y+37
	ldd R1,y+38
	std y+1,R1
	std y+0,R0
	ldi R18,<L194
	ldi R19,>L194
	xcall _sprintf_M
;                         if (stat(name, &st) == 0) {
	movw R18,R28
	subi R18,252  ; offset = 4
	sbci R19,255
	movw R16,R20
	xcall _stat
	movw R12,R16
	cpi R16,0
	cpc R16,R17
	breq X106
	xjmp L195
X106:
X98:
;                             if (st.st_mode) {
	ldd R2,y+6
	tst R2
	breq L197
X99:
;                                 fputc('d', fp);
	movw R18,R22
	ldi R16,100
	ldi R17,0
	xcall _fputc
;                                 size = 0;
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+17,R24
	std y+18,R25
	std y+19,R26
	std y+20,R27
;                             } else {
	xjmp L198
L197:
;                                 fputc('-', fp);
	movw R18,R22
	ldi R16,45
	ldi R17,0
	xcall _fputc
;                                 size = st.st_size;
	ldd R2,y+9
	ldd R3,y+10
	ldd R4,y+11
	ldd R5,y+12
	std y+17,R2
	std y+18,R3
	std y+19,R4
	std y+20,R5
;                             }
L198:
;                             fprintf(fp, "rw-rw-rw-  1 0 0 %6lu ", size);
	ldd R2,y+17
	ldd R3,y+18
	ldd R4,y+19
	ldd R5,y+20
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldi R18,<L201
	ldi R19,>L201
	movw R16,R22
	xcall _fprintf
;                             gmt = gmtime(&st.st_mtime);
	movw R16,R28
	subi R16,243  ; offset = 13
	sbci R17,255
	xcall _gmtime
	movw R12,R16
;                             //fprintf(fp, "%s %u %u ", mon_name[gmt->tm_mon], gmt->tm_mday, 1900 + gmt->tm_year);
;                             fprintf(fp, "%.3s %u ", mon_name + gmt->tm_mon * 3, gmt->tm_mday);
	movw R30,R12
	ldd R2,z+6
	ldd R3,z+7
	std y+3,R3
	std y+2,R2
	ldd R18,z+8
	ldd R19,z+9
	ldi R16,3
	ldi R17,0
	xcall empy16s
	movw R2,R16
	lds R4,_mon_name
	lds R5,_mon_name+1
	add R2,R4
	adc R3,R5
	std y+1,R3
	std y+0,R2
	ldi R18,<L203
	ldi R19,>L203
	movw R16,R22
	xcall _fprintf
;                             //fprintf(fp, "%02u:%02u:%02u ", gmt->tm_hour, gmt->tm_min, gmt->tm_sec);
;                             fprintf(fp, "%02u:%02u ", gmt->tm_hour, gmt->tm_min);
	movw R30,R12
	ldd R2,z+2
	ldd R3,z+3
	std y+3,R3
	std y+2,R2
	ldd R2,z+4
	ldd R3,z+5
	std y+1,R3
	std y+0,R2
	ldi R18,<L204
	ldi R19,>L204
	movw R16,R22
	xcall _fprintf
;                             fputs(d_ent->d_name, fp);
	movw R18,R22
	movw R16,R10
	subi R16,248  ; offset = 8
	sbci R17,255
	xcall _fputs
;                             fputs("\r\n", fp);
	movw R18,R22
	ldi R16,<L205
	ldi R17,>L205
	xcall _fputs
;                         }
L195:
;                         free(name);
	movw R16,R20
	xcall _free_M
;                     }
L192:
;                 }
L186:
	ldd R16,y+21
	ldd R17,y+22
	xcall _readdir
	movw R20,R16
	movw R10,R20
	cpi R16,0
	cpc R16,R17
	breq X107
	xjmp L185
X107:
X100:
L187:
;                 fclose(fp);
	movw R16,R22
	xcall _fclose
;             }
L183:
;             NutTcpCloseSocket(sock);
	movw R16,R14
	xcall _NutTcpCloseSocket
;         }
L181:
;         closedir(dir);
	ldd R16,y+21
	ldd R17,y+22
	xcall _closedir
;     }
L179:
;     if (ec) {
	ldd R0,y+23
	ldd R1,y+24
	tst R0
	brne X101
	tst R1
	breq L206
X101:
;         return NutFtpRespondBad(session, ec);
	movw R18,R0
	ldd R16,y+35
	ldd R17,y+36
	xcall _NutFtpRespondBad
	movw R12,R16
	xjmp L178
L206:
;     }
;     return NutFtpRespondOk(session, 226);
	ldi R18,226
	ldi R19,0
	ldd R16,y+35
	ldd R17,y+36
	xcall _NutFtpRespondOk
	movw R10,R16
L178:
	.dbline 0 ; func end
	adiw R28,25
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
;           path -> R12,R13
;        session -> R10,R11
	.even
_NutFtpProcessMkd::
	xcall push_xgset003C
	movw R12,R18
	movw R10,R16
; }
; 
; /*!
;  * \brief Process an FTP client's MKD command.
;  *
;  * Causes the specified directory to be created.
;  *
;  * \param session Pointer to an \ref FTPSESSION structure, obtained by a 
;  *                previous call to NutFtpOpenSession().
;  * \param path    Full absolute path name of the directory.
;  *
;  * \return 0 if the command has been processed or -1 if the
;  *         session has been aborted.
;  */
; int NutFtpProcessMkd(FTPSESSION * session, char *path)
; {
;     if (mkdir(path, 0777)) {
	ldi R18,511
	ldi R19,1
	movw R16,R12
	xcall _mkdir
	cpi R16,0
	cpc R16,R17
	breq L209
X108:
;         return NutFtpRespondBad(session, 550);
	ldi R18,550
	ldi R19,2
	movw R16,R10
	xcall _NutFtpRespondBad
	xjmp L208
L209:
;     }
;     return NutFtpRespondOk(session, 257);
	ldi R18,257
	ldi R19,1
	movw R16,R10
	xcall _NutFtpRespondOk
	movw R10,R16
L208:
	.dbline 0 ; func end
	xjmp pop_xgset003C
;           pass -> R10,R11
;        session -> R20,R21
	.even
_NutFtpProcessPass::
	xcall push_xgset300C
	movw R10,R18
	movw R20,R16
; }
; 
; /*!
;  * \brief Process an FTP client's PASS command.
;  *
;  * Only one login per session is accepted.
;  *
;  * \param session Pointer to an \ref FTPSESSION structure, obtained by a 
;  *                previous call to NutFtpOpenSession().
;  * \param pass    Password.
;  *
;  * \return 0 if the command has been processed or -1 if the
;  *         session has been aborted.
;  */
; int NutFtpProcessPass(FTPSESSION * session, char *pass)
; {
;     if (ftp_pass && *ftp_pass) {
	lds R2,_ftp_pass
	lds R3,_ftp_pass+1
	tst R2
	brne X109
	tst R3
	breq L212
X109:
	movw R30,R2
	ldd R2,z+0
	tst R2
	breq L212
X110:
;         if (session->ftp_login != 1 || strcmp(ftp_pass, pass)) {
	movw R30,R20
	ldd R24,z+14
	cpi R24,1
	brne L216
X111:
	movw R18,R10
	lds R16,_ftp_pass
	lds R17,_ftp_pass+1
	xcall _strcmp
	cpi R16,0
	cpc R16,R17
	breq L214
X112:
L216:
;             session->ftp_login = 0;
	clr R2
	movw R30,R20
	std z+14,R2
;             return NutFtpRespondBad(session, 550);
	ldi R18,550
	ldi R19,2
	movw R16,R30
	xcall _NutFtpRespondBad
	movw R10,R16
	xjmp L211
L214:
;         }
;     }
L212:
;     session->ftp_login = 2;
	ldi R24,2
	movw R30,R20
	std z+14,R24
;     return NutFtpRespondOk(session, 230);
	ldi R18,230
	ldi R19,0
	movw R16,R30
	xcall _NutFtpRespondOk
	movw R10,R16
L211:
	.dbline 0 ; func end
	xjmp pop_xgset300C
;           port -> R22,R23
;             ip -> y+12
;        session -> R20,R21
	.even
_NutFtpProcessPassiv::
	xcall push_xgsetF000
	movw R20,R16
	sbiw R28,16
; }
; 
; /*!
;  * \brief Process an FTP client's PASV command.
;  *
;  * This command requests the server to listen on a data port and to wait 
;  * for a connection rather than initiate one upon receipt of a transfer 
;  * command.
;  *
;  * \param session Pointer to an \ref FTPSESSION structure, obtained by a 
;  *                previous call to NutFtpOpenSession().
;  *
;  * \return 0 if the command has been processed or -1 if the
;  *         session has been aborted.
;  */
; int NutFtpProcessPassiv(FTPSESSION * session)
; {
;     u_long ip = session->ftp_sock->so_local_addr;
	movw R30,R20
	ldd R26,z+0
	ldd R27,z+1
	adiw R26,20
	ld R2,x+
	ld R3,x+
	ld R4,x+
	ld R5,x
	std y+12,R2
	std y+13,R3
	std y+14,R4
	std y+15,R5
;     u_short port = 20;
	ldi R22,20
	ldi R23,0
; 
;     fprintf(session->ftp_stream, "227 Passive (%u,%u,%u,%u,%u,%u).\r\n",        /* */
	mov R2,R22
	clr R3
	std y+11,R3
	std y+10,R2
	movw R2,R22
	mov R2,R3
	clr R3
	clr R3
	std y+9,R3
	std y+8,R2
	ldi R24,24
	ldi R25,0
	ldd R16,y+12
	ldd R17,y+13
	ldd R18,y+14
	ldd R19,y+15
	st -y,R24
	xcall lsr32
	mov R2,R16
	clr R3
	std y+7,R3
	std y+6,R2
	ldd R2,y+12
	ldd R3,y+13
	ldd R4,y+14
	ldd R5,y+15
	movw R2,R4
	clr R4
	clr R5
	clr R3
	std y+5,R3
	std y+4,R2
	ldi R24,8
	ldi R25,0
	ldd R16,y+12
	ldd R17,y+13
	ldd R18,y+14
	ldd R19,y+15
	st -y,R24
	xcall lsr32
	mov R2,R16
	clr R3
	std y+3,R3
	std y+2,R2
	ldd R2,y+12
	ldd R3,y+13
	ldd R4,y+14
	ldd R5,y+15
	clr R3
	std y+1,R3
	std y+0,R2
	ldi R18,<L218
	ldi R19,>L218
	movw R30,R20
	ldd R16,z+2
	ldd R17,z+3
	xcall _fprintf
;             (u_char) ip, (u_char) (ip >> 8), (u_char) (ip >> 16), (u_char) (ip >> 24),  /* */
;             (u_char) (port >> 8), (u_char) port);
;     fflush(session->ftp_stream);
	movw R30,R20
	ldd R16,z+2
	ldd R17,z+3
	xcall _fflush
;     session->ftp_passive = 1;
	ldi R24,1
	movw R30,R20
	std z+16,R24
; 
;     return 0;
	clr R16
	clr R17
L217:
	.dbline 0 ; func end
	adiw R28,16
	xjmp pop_xgsetF000
;           args -> R10,R11
;        session -> R20,R21
	.even
_NutFtpProcessPort::
	xcall push_xgset300C
	movw R10,R18
	movw R20,R16
	sbiw R28,2
; }
; 
; /*!
;  * \brief Process an FTP client's PORT command.
;  *
;  * \param session Pointer to an \ref FTPSESSION structure, obtained by a 
;  *                previous call to NutFtpOpenSession().
;  * \param args    Command argument, which is the concatenation of the
;  *                32-bit internet host address and a 16-bit TCP port 
;  *                address. This address information is broken into 8-bit 
;  *                fields and the value of each field is transmitted as 
;  *                a decimal number.
;  *
;  * \return 0 if the command has been processed or -1 if the
;  *         session has been aborted.
;  */
; int NutFtpProcessPort(FTPSESSION * session, char *args)
; {
;     if (ParseIpPort(args, &session->ftp_data_ip, &session->ftp_data_port) == 6) {
	movw R24,R20
	adiw R24,10
	std y+1,R25
	std y+0,R24
	movw R18,R20
	subi R18,250  ; offset = 6
	sbci R19,255
	movw R16,R10
	xcall _ParseIpPort
	cpi R16,6
	ldi R30,0
	cpc R17,R30
	brne L220
X113:
;         if (session->ftp_sock->so_remote_addr == session->ftp_data_ip) {
	movw R30,R20
	ldd R2,z+6
	ldd R3,z+7
	ldd R4,z+8
	ldd R5,z+9
	ldd R26,z+0
	ldd R27,z+1
	adiw R26,26
	ld R6,x+
	ld R7,x+
	ld R8,x+
	ld R9,x
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	brne L222
X114:
;             return NutFtpRespondOk(session, 200);
	ldi R18,200
	ldi R19,0
	movw R16,R30
	xcall _NutFtpRespondOk
	xjmp L219
L222:
;         }
;         return NutFtpRespondBad(session, 425);
	ldi R18,425
	ldi R19,1
	movw R16,R20
	xcall _NutFtpRespondBad
	movw R10,R16
	xjmp L219
L220:
;     }
;     return NutFtpRespondBad(session, 501);;
	ldi R18,501
	ldi R19,1
	movw R16,R20
	xcall _NutFtpRespondBad
	movw R10,R16
L219:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgset300C
;        session -> R20,R21
	.even
_NutFtpProcessPwd::
	st -y,R20
	st -y,R21
	movw R20,R16
	sbiw R28,2
; }
; 
; /*!
;  * \brief Process an FTP client's PWD command.
;  *
;  * Causes the name of the current working directory to be 
;  * returned in the reply.
;  *
;  * \param session Pointer to an \ref FTPSESSION structure, obtained by a 
;  *                previous call to NutFtpOpenSession().
;  *
;  * \return 0 if the command has been processed or -1 if the
;  *         session has been aborted.
;  */
; int NutFtpProcessPwd(FTPSESSION * session)
; {
; #ifdef FTPD_DEBUG
;     printf("\n<'257 \"%s\"' ", session->ftp_cwd);
; #endif
;     fprintf(session->ftp_stream, "257 \"%s\"\r\n", session->ftp_cwd);
	movw R30,R20
	ldd R2,z+4
	ldd R3,z+5
	std y+1,R3
	std y+0,R2
	ldi R18,<L225
	ldi R19,>L225
	ldd R16,z+2
	ldd R17,z+3
	xcall _fprintf
;     return 0;
	clr R16
	clr R17
L224:
	.dbline 0 ; func end
	adiw R28,2
	ld R21,y+
	ld R20,y+
	ret
;           path -> R12,R13
;        session -> R10,R11
	.even
_NutFtpProcessRmd::
	xcall push_xgset003C
	movw R12,R18
	movw R10,R16
; }
; 
; /*!
;  * \brief Process an FTP client's RMD command.
;  *
;  * Causes the specified directory to be removed.
;  *
;  * \param session Pointer to an \ref FTPSESSION structure, obtained by a 
;  *                previous call to NutFtpOpenSession().
;  * \param path    Full absolute path name of the directory.
;  *
;  * \return 0 if the command has been processed or -1 if the
;  *         session has been aborted.
;  */
; int NutFtpProcessRmd(FTPSESSION * session, char *path)
; {
;     if (rmdir(path)) {
	movw R16,R12
	xcall _rmdir
	cpi R16,0
	cpc R16,R17
	breq L227
X115:
;         return NutFtpRespondBad(session, 451);
	ldi R18,451
	ldi R19,1
	movw R16,R10
	xcall _NutFtpRespondBad
	xjmp L226
L227:
;     }
;     return NutFtpRespondOk(session, 257);
	ldi R18,257
	ldi R19,1
	movw R16,R10
	xcall _NutFtpRespondOk
	movw R10,R16
L226:
	.dbline 0 ; func end
	xjmp pop_xgset003C
;        session -> R20,R21
	.even
_NutFtpProcessSystem::
	st -y,R20
	st -y,R21
	movw R20,R16
; }
; 
; /*!
;  * \brief Process an FTP client's SYST command.
;  *
;  * \param session Pointer to an \ref FTPSESSION structure, obtained by a 
;  *                previous call to NutFtpOpenSession().
;  *
;  * \return 0 if the command has been processed or -1 if the
;  *         session has been aborted.
;  */
; int NutFtpProcessSystem(FTPSESSION * session)
; {
; #ifdef FTPD_DEBUG
;     printf("\n<'215 UNIX Type: L8' ");
; #endif
;     fputs("215 UNIX Type: L8\r\n", session->ftp_stream);
	movw R30,R20
	ldd R18,z+2
	ldd R19,z+3
	ldi R16,<L230
	ldi R17,>L230
	xcall _fputs
;     return 0;
	clr R16
	clr R17
L229:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
;       typecode -> R10,R11
;        session -> R20,R21
	.even
_NutFtpProcessType::
	xcall push_xgsetF00C
	movw R10,R18
	movw R20,R16
; }
; 
; /*!
;  * \brief Process an FTP client's TYPE command.
;  *
;  * The type is not fully checked. Any argument starting with
;  * the letters 'A' or 'a' will switch the transfer mode to
;  * ASCII. Otherwise binary mode is set.
;  *
;  * \param session  Pointer to an \ref FTPSESSION structure, obtained by a 
;  *                 previous call to NutFtpOpenSession().
;  * \param typecode Command arguments.
;  *
;  * \return 0 if the command has been processed or -1 if the
;  *         session has been aborted.
;  */
; int NutFtpProcessType(FTPSESSION * session, char *typecode)
; {
;     session->ftp_tran_mode = (*typecode != 'A') && (*typecode != 'a');
	movw R30,R10
	ldd R2,z+0
	clr R3
	mov R24,R2
	cpi R24,65
	breq L232
X116:
	cpi R24,97
	breq L232
X117:
	ldi R22,1
	ldi R23,0
	xjmp L233
L232:
	clr R22
	clr R23
L233:
	movw R30,R20
	std z+15,R22
;     return NutFtpRespondOk(session, 200);
	ldi R18,200
	ldi R19,0
	movw R16,R30
	xcall _NutFtpRespondOk
L231:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
;           user -> R10,R11
;        session -> R20,R21
	.even
_NutFtpProcessUser::
	xcall push_xgset300C
	movw R10,R18
	movw R20,R16
; }
; 
; /*!
;  * \brief Process an FTP client's USER command.
;  *
;  * Only one login per session is accepted.
;  *
;  * \param session Pointer to an \ref FTPSESSION structure, obtained by a 
;  *                previous call to NutFtpOpenSession().
;  * \param user    User name.
;  *
;  * \return 0 if the command has been processed or -1 if the
;  *         session has been aborted.
;  */
; int NutFtpProcessUser(FTPSESSION * session, char *user)
; {
;     if (ftp_user && *ftp_user) {
	lds R2,_ftp_user
	lds R3,_ftp_user+1
	tst R2
	brne X118
	tst R3
	breq L235
X118:
	movw R30,R2
	ldd R2,z+0
	tst R2
	breq L235
X119:
;         if (session->ftp_login && strcmp(ftp_user, user)) {
	movw R30,R20
	ldd R2,z+14
	tst R2
	breq L237
X120:
	movw R18,R10
	lds R16,_ftp_user
	lds R17,_ftp_user+1
	xcall _strcmp
	cpi R16,0
	cpc R16,R17
	breq L237
X121:
;             session->ftp_login = 0;
	clr R2
	movw R30,R20
	std z+14,R2
;             return NutFtpRespondBad(session, 550);
	ldi R18,550
	ldi R19,2
	movw R16,R30
	xcall _NutFtpRespondBad
	movw R10,R16
	xjmp L234
L237:
;         }
;     }
L235:
; 
;     /* Need a password too. */
;     if (ftp_pass && *ftp_pass) {
	lds R10,_ftp_pass
	lds R11,_ftp_pass+1
	tst R10
	brne X122
	tst R11
	breq L239
X122:
	movw R30,R10
	ldd R2,z+0
	tst R2
	breq L239
X123:
;         session->ftp_login = 1;
	ldi R24,1
	movw R30,R20
	std z+14,R24
;         return NutFtpRespondOk(session, 331);
	ldi R18,331
	ldi R19,1
	movw R16,R30
	xcall _NutFtpRespondOk
	movw R10,R16
	xjmp L234
L239:
;     }
; 
;     /* No password required. */
;     session->ftp_login = 2;
	ldi R24,2
	movw R30,R20
	std z+14,R24
;     return NutFtpRespondOk(session, 230);
	ldi R18,230
	ldi R19,0
	movw R16,R30
	xcall _NutFtpRespondOk
	movw R10,R16
L234:
	.dbline 0 ; func end
	xjmp pop_xgset300C
;           path -> R10,R11
;           args -> y+4
;             rc -> R20,R21
;            cmd -> y+2
;        request -> R10,R11
;        session -> R22,R23
	.even
_NutFtpProcessRequest::
	xcall push_xgsetF03C
	movw R10,R18
	movw R22,R16
	sbiw R28,6
; }
; 
; /*!
;  * \brief Process an FTP request.
;  *
;  * This routine implements the protocol interpreter of the FTP server.
;  *
;  * \param session Pointer to an \ref FTPSESSION structure, obtained by a 
;  *                previous call to NutFtpOpenSession().
;  * \return -1 if the session ended. Otherwise 0 is returned.
;  */
; int NutFtpProcessRequest(FTPSESSION * session, char *request)
; {
;     int rc = 0;
	clr R20
	clr R21
;     u_char *cmd;
;     u_char *args;
; 
;     /* Split the line into command and argument part. */
;     SplitCmdArg(request, &cmd, &args);
	movw R24,R28
	adiw R24,4
	std y+1,R25
	std y+0,R24
	movw R18,R28
	subi R18,254  ; offset = 2
	sbci R19,255
	movw R16,R10
	xcall _SplitCmdArg
; #ifdef FTPD_DEBUG
;     printf("\n>'%s %s' ", cmd, args);
; #endif
; 
;     /* QUIT - Terminate session. */
;     if (strcmp_P(cmd, cmd_quit_P) == 0) {
	ldd R18,y+2
	ldd R19,y+3
	ldi R16,<_cmd_quit_P
	ldi R17,>_cmd_quit_P
	xcall _cstrcmp
	cpi R16,0
	cpc R16,R17
	brne L242
X124:
;         NutFtpRespondOk(session, 221);
	ldi R18,221
	ldi R19,0
	movw R16,R22
	xcall _NutFtpRespondOk
;         rc = -1;
	ldi R20,-1
	ldi R21,-1
;     }
	xjmp L243
L242:
; 
;     /* USER <username> - Check user name. */
;     else if (strcmp_P(cmd, cmd_user_P) == 0) {
	ldd R18,y+2
	ldd R19,y+3
	ldi R16,<_cmd_user_P
	ldi R17,>_cmd_user_P
	xcall _cstrcmp
	cpi R16,0
	cpc R16,R17
	brne L244
X125:
;         rc = NutFtpProcessUser(session, args);
	ldd R18,y+4
	ldd R19,y+5
	movw R16,R22
	xcall _NutFtpProcessUser
	movw R10,R16
	movw R20,R10
;     }
	xjmp L245
L244:
; 
;     /* PASS <password> - Check user password. */
;     else if (strcmp_P(cmd, cmd_pass_P) == 0) {
	ldd R18,y+2
	ldd R19,y+3
	ldi R16,<_cmd_pass_P
	ldi R17,>_cmd_pass_P
	xcall _cstrcmp
	movw R10,R16
	cpi R16,0
	cpc R16,R17
	brne L246
X126:
;         rc = NutFtpProcessPass(session, args);
	ldd R18,y+4
	ldd R19,y+5
	movw R16,R22
	xcall _NutFtpProcessPass
	movw R10,R16
	movw R20,R10
;     } else if (strcmp_P(cmd, cmd_noop_P) == 0) {
	xjmp L247
L246:
	ldd R18,y+2
	ldd R19,y+3
	ldi R16,<_cmd_noop_P
	ldi R17,>_cmd_noop_P
	xcall _cstrcmp
	movw R10,R16
	cpi R16,0
	cpc R16,R17
	brne L248
X127:
;         NutFtpRespondOk(session, 200);
	ldi R18,200
	ldi R19,0
	movw R16,R22
	xcall _NutFtpRespondOk
;     }
	xjmp L249
L248:
;     /* Anything else requires a successful login. */
;     else if (session->ftp_login < 2) {
	movw R30,R22
	ldd R24,z+14
	cpi R24,2
	brsh L250
X128:
;         rc = NutFtpRespondBad(session, 530);
	ldi R18,530
	ldi R19,2
	movw R16,R30
	xcall _NutFtpRespondBad
	movw R10,R16
	movw R20,R10
;     }
	xjmp L251
L250:
; 
;     /* Valid login. */
;     else {
; 
;         /* PASV - Prepare passive transfer. */
;         if (strcmp_P(cmd, cmd_pasv_P) == 0) {
	ldd R18,y+2
	ldd R19,y+3
	ldi R16,<_cmd_pasv_P
	ldi R17,>_cmd_pasv_P
	xcall _cstrcmp
	movw R10,R16
	cpi R16,0
	cpc R16,R17
	brne L252
X129:
;             rc = NutFtpProcessPassiv(session);
	movw R16,R22
	xcall _NutFtpProcessPassiv
	movw R10,R16
	movw R20,R10
;         }
	xjmp L253
L252:
; 
;         /* PORT <host-port> - Set data connection. */
;         else if (strcmp_P(cmd, cmd_port_P) == 0) {
	ldd R18,y+2
	ldd R19,y+3
	ldi R16,<_cmd_port_P
	ldi R17,>_cmd_port_P
	xcall _cstrcmp
	movw R10,R16
	cpi R16,0
	cpc R16,R17
	brne L254
X130:
;             rc = NutFtpProcessPort(session, args);
	ldd R18,y+4
	ldd R19,y+5
	movw R16,R22
	xcall _NutFtpProcessPort
	movw R10,R16
	movw R20,R10
;         }
	xjmp L255
L254:
; 
;         /* [X]PWD - Send name of current working directory. */
;         else if (strcmp_P(cmd, cmd_pwd_P) == 0 || strcmp_P(cmd, cmd_xpwd_P) == 0) {
	ldd R18,y+2
	ldd R19,y+3
	ldi R16,<_cmd_pwd_P
	ldi R17,>_cmd_pwd_P
	xcall _cstrcmp
	movw R10,R16
	cpi R16,0
	cpc R16,R17
	breq L258
X131:
	ldd R18,y+2
	ldd R19,y+3
	ldi R16,<_cmd_xpwd_P
	ldi R17,>_cmd_xpwd_P
	xcall _cstrcmp
	movw R10,R16
	cpi R16,0
	cpc R16,R17
	brne L256
X132:
L258:
;             rc = NutFtpProcessPwd(session);
	movw R16,R22
	xcall _NutFtpProcessPwd
	movw R10,R16
	movw R20,R10
;         }
	xjmp L257
L256:
; 
;         /* SYST - Send system identifier. */
;         else if (strcmp_P(cmd, cmd_syst_P) == 0) {
	ldd R18,y+2
	ldd R19,y+3
	ldi R16,<_cmd_syst_P
	ldi R17,>_cmd_syst_P
	xcall _cstrcmp
	movw R10,R16
	cpi R16,0
	cpc R16,R17
	brne L259
X133:
;             rc = NutFtpProcessSystem(session);
	movw R16,R22
	xcall _NutFtpProcessSystem
	movw R10,R16
	movw R20,R10
;         }
	xjmp L260
L259:
; 
;         /* TYPE <type-code> - Receive transfer mode. */
;         else if (strcmp_P(cmd, cmd_type_P) == 0) {
	ldd R18,y+2
	ldd R19,y+3
	ldi R16,<_cmd_type_P
	ldi R17,>_cmd_type_P
	xcall _cstrcmp
	movw R10,R16
	cpi R16,0
	cpc R16,R17
	brne L261
X134:
;             rc = NutFtpProcessType(session, args);
	ldd R18,y+4
	ldd R19,y+5
	movw R16,R22
	xcall _NutFtpProcessType
	movw R10,R16
	movw R20,R10
;         }
	xjmp L262
L261:
; 
;         /* Commands with path name argument. */
;         else {
;             char *path;
; 
;             if ((path = CreateFullPathName(ftp_root, session->ftp_cwd, args)) == 0) {
	ldd R2,y+4
	ldd R3,y+5
	std y+1,R3
	std y+0,R2
	movw R30,R22
	ldd R18,z+4
	ldd R19,z+5
	lds R16,_ftp_root
	lds R17,_ftp_root+1
	xcall _CreateFullPathName
	movw R12,R16
	movw R10,R12
	cpi R16,0
	cpc R16,R17
	brne L263
X135:
;                 rc = NutFtpRespondBad(session, 451);
	ldi R18,451
	ldi R19,1
	movw R16,R22
	xcall _NutFtpRespondBad
	movw R12,R16
	movw R20,R12
;             }
	xjmp L264
L263:
; 
;             /* CWD <pathname> - Change working directory. */
;             else if (strcmp_P(cmd, cmd_cwd_P) == 0) {
	ldd R18,y+2
	ldd R19,y+3
	ldi R16,<_cmd_cwd_P
	ldi R17,>_cmd_cwd_P
	xcall _cstrcmp
	movw R12,R16
	cpi R16,0
	cpc R16,R17
	brne L265
X136:
;                 rc = NutFtpProcessCwd(session, path);
	movw R18,R10
	movw R16,R22
	xcall _NutFtpProcessCwd
	movw R12,R16
	movw R20,R12
;             }
	xjmp L266
L265:
; 
;             /* DELE <pathname> - Delete a file. */
;             else if (strcmp_P(cmd, cmd_dele_P) == 0) {
	ldd R18,y+2
	ldd R19,y+3
	ldi R16,<_cmd_dele_P
	ldi R17,>_cmd_dele_P
	xcall _cstrcmp
	movw R12,R16
	cpi R16,0
	cpc R16,R17
	brne L267
X137:
;                 rc = NutFtpProcessDelete(session, path);
	movw R18,R10
	movw R16,R22
	xcall _NutFtpProcessDelete
	movw R12,R16
	movw R20,R12
;             }
	xjmp L268
L267:
; 
;             /* LIST | NLST [<pathname>] - Send list of files in a directory. */
;             else if (strcmp_P(cmd, cmd_list_P) == 0 || strcmp_P(cmd, cmd_nlst_P) == 0) {
	ldd R18,y+2
	ldd R19,y+3
	ldi R16,<_cmd_list_P
	ldi R17,>_cmd_list_P
	xcall _cstrcmp
	movw R12,R16
	cpi R16,0
	cpc R16,R17
	breq L271
X138:
	ldd R18,y+2
	ldd R19,y+3
	ldi R16,<_cmd_nlst_P
	ldi R17,>_cmd_nlst_P
	xcall _cstrcmp
	movw R12,R16
	cpi R16,0
	cpc R16,R17
	brne L269
X139:
L271:
;                 rc = NutFtpTransferDirectory(session, path);
	movw R18,R10
	movw R16,R22
	xcall _NutFtpTransferDirectory
	movw R12,R16
	movw R20,R12
;             }
	xjmp L270
L269:
; 
;             /* MKD <pathname> - Make a directory. */
;             else if (strcmp_P(cmd, cmd_mkd_P) == 0 || strcmp_P(cmd, cmd_xmkd_P) == 0) {
	ldd R18,y+2
	ldd R19,y+3
	ldi R16,<_cmd_mkd_P
	ldi R17,>_cmd_mkd_P
	xcall _cstrcmp
	movw R12,R16
	cpi R16,0
	cpc R16,R17
	breq L274
X140:
	ldd R18,y+2
	ldd R19,y+3
	ldi R16,<_cmd_xmkd_P
	ldi R17,>_cmd_xmkd_P
	xcall _cstrcmp
	movw R12,R16
	cpi R16,0
	cpc R16,R17
	brne L272
X141:
L274:
;                 rc = NutFtpProcessMkd(session, path);
	movw R18,R10
	movw R16,R22
	xcall _NutFtpProcessMkd
	movw R12,R16
	movw R20,R12
;             }
	xjmp L273
L272:
; 
;             /* RETR <pathname> - Send a file to the client. */
;             else if (strcmp_P(cmd, cmd_retr_P) == 0) {
	ldd R18,y+2
	ldd R19,y+3
	ldi R16,<_cmd_retr_P
	ldi R17,>_cmd_retr_P
	xcall _cstrcmp
	movw R12,R16
	cpi R16,0
	cpc R16,R17
	brne L275
X142:
;                 rc = NutFtpTransferFile(session, path, 1);
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	movw R18,R10
	movw R16,R22
	xcall _NutFtpTransferFile
	movw R12,R16
	movw R20,R12
;             }
	xjmp L276
L275:
; 
;             /* RMD <pathname> - Remove a directory. */
;             else if (strcmp_P(cmd, cmd_rmd_P) == 0 || strcmp_P(cmd, cmd_xrmd_P) == 0) {
	ldd R18,y+2
	ldd R19,y+3
	ldi R16,<_cmd_rmd_P
	ldi R17,>_cmd_rmd_P
	xcall _cstrcmp
	movw R12,R16
	cpi R16,0
	cpc R16,R17
	breq L279
X143:
	ldd R18,y+2
	ldd R19,y+3
	ldi R16,<_cmd_xrmd_P
	ldi R17,>_cmd_xrmd_P
	xcall _cstrcmp
	movw R12,R16
	cpi R16,0
	cpc R16,R17
	brne L277
X144:
L279:
;                 rc = NutFtpProcessRmd(session, path);
	movw R18,R10
	movw R16,R22
	xcall _NutFtpProcessRmd
	movw R12,R16
	movw R20,R12
;             }
	xjmp L278
L277:
; 
;             /* STOR <pathname> - Receive a file from the client. */
;             else if (strcmp_P(cmd, cmd_stor_P) == 0) {
	ldd R18,y+2
	ldd R19,y+3
	ldi R16,<_cmd_stor_P
	ldi R17,>_cmd_stor_P
	xcall _cstrcmp
	movw R12,R16
	cpi R16,0
	cpc R16,R17
	brne L280
X145:
;                 rc = NutFtpTransferFile(session, path, 0);
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	movw R18,R10
	movw R16,R22
	xcall _NutFtpTransferFile
	movw R12,R16
	movw R20,R12
;             }
	xjmp L281
L280:
; 
;             /* Anything else is an unknown command. */
;             else {
;                 rc = NutFtpRespondBad(session, 502);
	ldi R18,502
	ldi R19,1
	movw R16,R22
	xcall _NutFtpRespondBad
	movw R12,R16
	movw R20,R12
;             }
L281:
L278:
L276:
L273:
L270:
L268:
L266:
L264:
; 
;             if (path) {
	tst R10
	brne X146
	tst R11
	breq L282
X146:
;                 free(path);
	movw R16,R10
	xcall _free_M
;             }
L282:
;         }
L262:
L260:
L257:
L255:
L253:
;     }
L251:
L249:
L247:
L245:
L243:
;     return rc;
	movw R16,R20
L241:
	.dbline 0 ; func end
	adiw R28,6
	xjmp pop_xgsetF03C
;            now -> y+12
;            tip -> R14,R15
;             rc -> R20,R21
;        session -> R22,R23
;             ch -> R12
;           buff -> R10,R11
;           sock -> R12,R13
	.even
_NutFtpServerSession::
	xcall push_xgsetF0FC
	movw R12,R16
	sbiw R28,16
; }
; 
; /*!
;  * \brief Process an FTP sever session.
;  *
;  * Processes FTP requests on an established connection with an FTP client.
;  * This routine completely implements an FTP server except TCP connect
;  * and disconnect.
;  *
;  * For file transfers, the same maximum segment size and timeouts as set 
;  * for this socket will be used for the data connection.
;  *
;  * \param sock Socket of an established TCP connection.
;  *
;  * \return 0 if the session ended successfully or -1 if the session
;  *         has been aborted.
;  */
; int NutFtpServerSession(TCPSOCKET * sock)
; {
;     int rc = 0;
	clr R20
	clr R21
;     FTPSESSION *session;
;     char *buff;
;     time_t now;
;     struct _tm *tip;
;     char ch;
; 
;     /* Set the root path if not yet done. */
;     if (NutRegisterFtpRoot(ftp_root)) {
	lds R16,_ftp_root
	lds R17,_ftp_root+1
	xcall _NutRegisterFtpRoot
	cpi R16,0
	cpc R16,R17
	breq L285
X147:
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L284
L285:
;     }
; 
;     /* Allocate the command line buffer. */
;     if ((buff = malloc(FTP_MAX_CMDBUF)) == 0) {
	ldi R16,128
	ldi R17,0
	xcall _malloc_M
	movw R10,R16
	tst R10
	brne L287
	tst R11
	brne L287
X148:
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L284
L287:
;     }
; 
;     /* Create a session structure and open a stream. */
;     if ((session = NutFtpOpenSession(sock)) == 0) {
	movw R16,R12
	xcall _NutFtpOpenSession
	movw R12,R16
	movw R22,R12
	cpi R16,0
	cpc R16,R17
	brne L289
X149:
;         free(buff);
	movw R16,R10
	xcall _free_M
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L284
L289:
;     }
; 
;     /* Send a welcome banner including system time. */
;     time(&now);
	movw R16,R28
	subi R16,244  ; offset = 12
	sbci R17,255
	xcall _time
;     tip = localtime(&now);
	movw R16,R28
	subi R16,244  ; offset = 12
	sbci R17,255
	xcall _localtime
	movw R12,R16
	movw R14,R12
; #ifdef FTPD_DEBUG
;     printf("\n<'");
;     printf_P(rep_banner, NutVersionString(), &mon_name[tip->tm_mon * 3],        /* */
;              tip->tm_mday, tip->tm_hour, tip->tm_min, tip->tm_sec);
; #endif
;     fprintf_P(session->ftp_stream, rep_banner, NutVersionString(),      /* */
	xcall _NutVersionString
	movw R12,R16
	movw R30,R14
	ldd R2,z+0
	ldd R3,z+1
	std y+11,R3
	std y+10,R2
	ldd R2,z+2
	ldd R3,z+3
	std y+9,R3
	std y+8,R2
	ldd R2,z+4
	ldd R3,z+5
	std y+7,R3
	std y+6,R2
	ldd R2,z+6
	ldd R3,z+7
	std y+5,R3
	std y+4,R2
	ldd R18,z+8
	ldd R19,z+9
	ldi R16,3
	ldi R17,0
	xcall empy16s
	movw R2,R16
	lds R4,_mon_name
	lds R5,_mon_name+1
	add R2,R4
	adc R3,R5
	std y+3,R3
	std y+2,R2
	std y+1,R13
	std y+0,R12
	ldi R18,<_rep_banner
	ldi R19,>_rep_banner
	movw R30,R22
	ldd R16,z+2
	ldd R17,z+3
	xcall _fprintf_P
	xjmp L292
L291:
;               &mon_name[tip->tm_mon * 3],       /* */
;               tip->tm_mday, tip->tm_hour, tip->tm_min, tip->tm_sec);
; 
;     /* 
;      * Loop for requests. 
;      */
;     while (rc == 0) {
; 
;         /* Flush any previous output and read a new command line. */
;         fflush(session->ftp_stream);
	movw R30,R22
	ldd R16,z+2
	ldd R17,z+3
	xcall _fflush
;         if (fgets(buff, FTP_MAX_CMDBUF, session->ftp_stream) == 0) {
	movw R30,R22
	ldd R2,z+2
	ldd R3,z+3
	std y+1,R3
	std y+0,R2
	ldi R18,128
	ldi R19,0
	movw R16,R10
	xcall _fgets
	movw R12,R16
	cpi R16,0
	cpc R16,R17
	brne L294
X150:
;             rc = -1;
	ldi R20,-1
	ldi R21,-1
;             break;
	xjmp L293
L294:
;         }
; 
;         /* Skip command lines, which are too long. */
;         if ((ch = *(buff + strlen(buff) - 1)) != '\n' && ch != '\r') {
	movw R16,R10
	xcall _strlen
	movw R12,R16
	movw R30,R12
	add R30,R10
	adc R31,R11
	sbiw R30,1
	ldd R14,z+0
	mov R12,R14
	mov R24,R14
	cpi R24,10
	brne X158
	xjmp L296
X158:
X151:
	cpi R24,13
	brne X159
	xjmp L296
X159:
X152:
L298:
;             do {
;                 if (fgets(buff, FTP_MAX_CMDBUF, session->ftp_stream) == 0) {
	movw R30,R22
	ldd R2,z+2
	ldd R3,z+3
	std y+1,R3
	std y+0,R2
	ldi R18,128
	ldi R19,0
	movw R16,R10
	xcall _fgets
	movw R14,R16
	cpi R16,0
	cpc R16,R17
	brne L301
X153:
;                     rc = -1;
	ldi R20,-1
	ldi R21,-1
;                     break;
	xjmp L300
L301:
;                 }
;             } while ((ch = *(buff + strlen(buff) - 1)) != '\n' && ch != '\r');
L299:
	movw R16,R10
	xcall _strlen
	movw R14,R16
	movw R30,R14
	add R30,R10
	adc R31,R11
	sbiw R30,1
	ldd R14,z+0
	mov R12,R14
	mov R24,R14
	cpi R24,10
	breq L303
X154:
	cpi R24,13
	brne L298
X155:
L303:
L300:
;             if (rc == 0) {
	cpi R20,0
	cpc R20,R21
	brne L297
X156:
;                 rc = NutFtpRespondBad(session, 500);
	ldi R18,500
	ldi R19,1
	movw R16,R22
	xcall _NutFtpRespondBad
	movw R12,R16
	movw R20,R12
;             }
;         }
	xjmp L297
L296:
; 
;         /* Process the request. */
;         else {
;             rc = NutFtpProcessRequest(session, buff);
	movw R18,R10
	movw R16,R22
	xcall _NutFtpProcessRequest
	movw R12,R16
	movw R20,R12
;         }
L297:
;     }
L292:
	cpi R20,0
	cpc R20,R21
	brne X160
	xjmp L291
X160:
X157:
L293:
; 
;     /* Cleanup and return. */
;     NutFtpCloseSession(session);
	movw R16,R22
	xcall _NutFtpCloseSession
;     free(buff);
	movw R16,R10
	xcall _free_M
;     return rc;
	movw R16,R20
L284:
	.dbline 0 ; func end
	adiw R28,16
	xjmp pop_xgsetF0FC
	.area bss(ram, con, rel)
_ftp_pass:
	.blkb 2
_ftp_user:
	.blkb 2
_ftp_root:
	.blkb 2
	.area data(ram, con, rel)
L230:
	.blkb 20
	.area idata
	.byte 50,49,53,32,'U,'N,'I,'X,32,'T,'y,'p,'e,58,32,'L
	.byte 56,13,10,0
	.area data(ram, con, rel)
L225:
	.blkb 11
	.area idata
	.byte 50,53,55,32,34,37,'s,34,13,10,0
	.area data(ram, con, rel)
L218:
	.blkb 35
	.area idata
	.byte 50,50,55,32,'P,'a,'s,'s,'i,'v,'e,32,40,37,'u,44
	.byte 37,'u,44,37,'u,44,37,'u,44,37,'u,44,37,'u,41,46
	.byte 13,10,0
	.area data(ram, con, rel)
L205:
	.blkb 3
	.area idata
	.byte 13,10,0
	.area data(ram, con, rel)
L204:
	.blkb 11
	.area idata
	.byte 37,48,50,'u,58,37,48,50,'u,32,0
	.area data(ram, con, rel)
L203:
	.blkb 9
	.area idata
	.byte 37,46,51,'s,32,37,'u,32,0
	.area data(ram, con, rel)
L201:
	.blkb 23
	.area idata
	.byte 'r,'w,45,'r,'w,45,'r,'w,45,32,32,49,32,48,32,48
	.byte 32,37,54,'l,'u,32,0
	.area data(ram, con, rel)
L194:
	.blkb 6
	.area idata
	.byte 37,'s,47,37,'s,0
	.area data(ram, con, rel)
L143:
	.blkb 2
	.area idata
	.byte 47,0
	.area data(ram, con, rel)
L130:
	.blkb 4
	.area idata
	.byte 'r,43,'b,0
	.area data(ram, con, rel)
L99:
	.blkb 6
	.area idata
	.byte 'P,'N,'U,'T,58,0
	.area data(ram, con, rel)
L2:
	.blkb 37
	.area idata
	.byte 'J,'a,'n,'F,'e,'b,'M,'a,'r,'A,'p,'r,'M,'a,'y,'J
	.byte 'u,'n,'J,'u,'l,'A,'u,'g,'S,'e,'p,'O,'c,'t,'N,'o
	.byte 'v,'D,'e,'c,0
	.area data(ram, con, rel)
; }
; 
; /*@}*/
