	.module resolv.c
	.area text(rom, con, rel)
;            val -> R18,R19
;             cp -> R16,R17
	.even
_AddShort:
; /*
;  * Copyright (C) 2001-2003 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  */
; 
; /*
;  * $Log: resolv.c,v $
;  * Revision 1.8.2.1  2006/02/02 14:11:38  haraldkipp
;  * Added required typecasts before left shift.
;  * Avoid memory alignment errors.
;  *
;  * Revision 1.8  2005/04/30 16:42:42  chaac
;  * Fixed bug in handling of NUTDEBUG. Added include for cfg/os.h. If NUTDEBUG
;  * is defined in NutConf, it will make effect where it is used.
;  *
;  * Revision 1.7  2004/10/14 16:43:07  drsung
;  * Fixed compiler warning "comparison between signed and unsigned"
;  *
;  * Revision 1.6  2004/07/28 19:23:15  drsung
;  * call to DumpDnsResource commented out.
;  *
;  * Revision 1.5  2004/04/15 18:38:58  drsung
;  * Bugfix if the DNS server sends more than one answer.
;  *
;  * Revision 1.4  2004/03/18 13:39:05  haraldkipp
;  * Deprecated header file replaced
;  *
;  * Revision 1.3  2004/02/28 20:14:38  drsung
;  * Merge from nut-3_4-release b/c of bugfixes.
;  *
;  * Revision 1.2.2.1  2004/02/28 19:15:07  drsung
;  * Memory leak fixed in CreateDnsQuestion.
;  * Thanks to Jean Pierre Gauthier.
;  *
;  * Revision 1.2  2003/07/20 18:25:40  haraldkipp
;  * Support secondary DNS.
;  *
;  * Revision 1.1.1.1  2003/05/09 14:41:59  haraldkipp
;  * Initial using 3.2.1
;  *
;  * Revision 1.5  2003/02/04 18:17:32  harald
;  * Version 3 released
;  *
;  * Revision 1.4  2002/06/26 17:29:50  harald
;  * First pre-release with 2.4 stack
;  *
;  */
; 
; #include <cfg/os.h>
; #include <string.h>
; 
; #include <sys/device.h>
; #include <sys/timer.h>
; #include <sys/heap.h>
; 
; #include <arpa/inet.h>
; #include <net/if_var.h>
; #include <sys/socket.h>
; 
; #ifdef NUTDEBUG
; #include <stdio.h>
; #endif
; 
; /*!
;  * \addtogroup xgDNS
;  */
; /*@{*/
; 
; typedef struct {
;     u_char *doc_hostname;
;     u_char *doc_domain;
;     u_long doc_ip1;
;     u_long doc_ip2;
; } DNSCONFIG;
; 
; static DNSCONFIG doc;
; 
; typedef struct {
;     u_short doh_id;
;     u_short doh_flags;
;     u_short doh_quests;
;     u_short doh_answers;
;     u_short doh_authrr;
;     u_short doh_addrr;
; } DNSHEADER;
; 
; typedef struct {
;     u_char *doq_name;
;     u_short doq_type;
;     u_short doq_class;
; } DNSQUESTION;
; 
; typedef struct {
;     u_char *dor_name;
;     u_short dor_type;
;     u_short dor_class;
;     u_long dor_ttl;
;     u_short dor_len;
;     u_char *dor_data;
; } DNSRESOURCE;
; 
; #ifdef NUTDEBUG
; void DumpDnsHeader(FILE * stream, DNSHEADER * doh)
; {
;     fprintf(stream,
;             "HEADER: id=%u flg=%04X #q=%u #an=%u #au=%u #ad=%u\r\n",
;             doh->doh_id, doh->doh_flags, doh->doh_quests, doh->doh_answers, doh->doh_authrr, doh->doh_addrr);
; }
; 
; void DumpDnsQuestion(FILE * stream, DNSQUESTION * doq)
; {
;     fprintf(stream, "QUESTION: name='%s' type=%u class=%u\r\n", doq->doq_name, doq->doq_type, doq->doq_class);
; }
; 
; void DumpDnsResource(FILE * stream, DNSRESOURCE * dor)
; {
;     u_short i;
; 
;     fprintf(stream, "RESOURCE: name='%s' type=%u class=%u ttl=%lu len=%u ",
;             dor->dor_name, dor->dor_type, dor->dor_class, dor->dor_ttl, dor->dor_len);
;     for (i = 0; i < dor->dor_len; i++)
;         fprintf(stream, "%02X ", dor->dor_data[i]);
;     fputc('\n', stream);
; }
; #endif
; 
; static u_short AddShort(u_char * cp, u_short val)
; {
;     *cp++ = (u_char) (val >> 8);
	movw R2,R18
	mov R2,R3
	clr R3
	movw R30,R16
	st Z+,R2
;     *cp++ = (u_char) val;
	st Z+,R18
; 
;     return 2;
	ldi R16,2
	ldi R17,0
L5:
	.dbline 0 ; func end
	ret
;             rc -> R20,R21
;            lcp -> R12,R13
;           name -> R10,R11
;             cp -> R22,R23
	.even
_AddName:
	xcall push_xgsetF0FC
	movw R10,R18
	movw R22,R16
; }
; 
; static u_short AddName(u_char * cp, CONST u_char * name)
; {
;     u_char *lcp;
;     u_short rc = strlen(name) + 2;
	movw R16,R10
	xcall _strlen
	movw R20,R16
	subi R20,254  ; offset = 2
	sbci R21,255
; 
;     lcp = cp++;
	movw R2,R22
	subi R22,255  ; offset = 1
	sbci R23,255
	movw R12,R2
;     *lcp = 0;
	clr R2
	movw R30,R12
	std z+0,R2
	xjmp L8
L7:
;     while (*name) {
;         if (*name == '.') {
	movw R30,R10
	ldd R24,z+0
	cpi R24,46
	brne L10
X0:
;             lcp = cp++;
	movw R14,R22
	subi R22,255  ; offset = 1
	sbci R23,255
	movw R12,R14
;             *lcp = 0;
	clr R2
	movw R30,R12
	std z+0,R2
;             name++;
	movw R24,R10
	adiw R24,1
	movw R10,R24
;         } else {
	xjmp L11
L10:
;             *cp++ = *name++;
	movw R30,R10
	movw R26,R22
	ld R0,Z+
	movw R10,R30
	st X+,R0
	movw R22,R26
;             (*lcp)++;
	movw R30,R12
	ldd R24,z+0
	subi R24,255    ; addi 1
	std z+0,R24
;         }
L11:
;     }
L8:
	movw R30,R10
	ldd R2,z+0
	tst R2
	breq X2
	xjmp L7
X2:
X1:
;     *cp = 0;
	clr R2
	movw R30,R22
	std z+0,R2
; 
;     return rc;
	movw R16,R20
L6:
	.dbline 0 ; func end
	xjmp pop_xgsetF0FC
;            val -> R18,R19
;             cp -> R16,R17
	.even
_ScanShort:
; }
; 
; static u_short ScanShort(u_char * cp, u_short * val)
; {
;     *val = (u_short)(*cp++) << 8;
	movw R30,R16
	ld R2,Z+
	movw R16,R30
	clr R3
	mov R3,R2
	clr R2
	movw R30,R18
	std z+1,R3
	std z+0,R2
;     *val |= *cp;
	movw R30,R16
	ldd R2,z+0
	clr R3
	movw R30,R18
	ldd R4,z+0
	ldd R5,z+1
	or R4,R2
	or R5,R3
	std z+1,R5
	std z+0,R4
; 
;     return 2;
	ldi R16,2
	ldi R17,0
L12:
	.dbline 0 ; func end
	ret
;            val -> R10,R11
;             cp -> R12,R13
	.even
_ScanLong:
	xcall push_xgset003C
	movw R10,R18
	movw R12,R16
; }
; 
; static u_short ScanLong(u_char * cp, u_long * val)
; {
;     *val = *cp++;
	movw R30,R12
	ld R2,Z+
	movw R12,R30
	clr R3
	clr R4
	clr R5
	movw R30,R10
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;     *val <<= 8;
	ldi R24,8
	ldi R25,0
	ldd R16,z+0
	ldd R17,z+1
	ldd R18,z+2
	ldd R19,z+3
	st -y,R24
	xcall lsl32
	movw R30,R10
	std z+0,R16
	std z+1,R17
	std z+2,R18
	std z+3,R19
;     *val |= *cp++;
	movw R30,R12
	ld R2,Z+
	movw R12,R30
	clr R3
	clr R4
	clr R5
	movw R30,R10
	ldd R6,z+0
	ldd R7,z+1
	ldd R8,z+2
	ldd R9,z+3
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	std z+0,R6
	std z+1,R7
	std z+2,R8
	std z+3,R9
;     *val <<= 8;
	ldi R24,8
	ldi R25,0
	ldd R16,z+0
	ldd R17,z+1
	ldd R18,z+2
	ldd R19,z+3
	st -y,R24
	xcall lsl32
	movw R30,R10
	std z+0,R16
	std z+1,R17
	std z+2,R18
	std z+3,R19
;     *val |= *cp++;
	movw R30,R12
	ld R2,Z+
	movw R12,R30
	clr R3
	clr R4
	clr R5
	movw R30,R10
	ldd R6,z+0
	ldd R7,z+1
	ldd R8,z+2
	ldd R9,z+3
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	std z+0,R6
	std z+1,R7
	std z+2,R8
	std z+3,R9
;     *val <<= 8;
	ldi R24,8
	ldi R25,0
	ldd R16,z+0
	ldd R17,z+1
	ldd R18,z+2
	ldd R19,z+3
	st -y,R24
	xcall lsl32
	movw R30,R10
	std z+0,R16
	std z+1,R17
	std z+2,R18
	std z+3,R19
;     *val |= *cp;
	movw R30,R12
	ldd R2,z+0
	clr R3
	clr R4
	clr R5
	movw R30,R10
	ldd R6,z+0
	ldd R7,z+1
	ldd R8,z+2
	ldd R9,z+3
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	std z+0,R6
	std z+1,R7
	std z+2,R8
	std z+3,R9
; 
;     return 4;
	ldi R16,4
	ldi R17,0
L13:
	.dbline 0 ; func end
	xjmp pop_xgset003C
;             rc -> R20,R21
;             np -> R10,R11
;            len -> R22
;            npp -> R10,R11
;             cp -> R12,R13
	.even
_ScanName:
	xcall push_xgsetF0FC
	movw R10,R18
	movw R12,R16
; }
; 
; static u_short ScanName(u_char * cp, u_char ** npp)
; {
;     u_char len;
;     u_short rc;
;     u_char *np;
; 
;     if (*npp) {
	movw R30,R10
	ldd R2,z+0
	ldd R3,z+1
	tst R2
	brne X3
	tst R3
	breq L15
X3:
;         NutHeapFree(*npp);
	ldd R16,z+0
	ldd R17,z+1
	xcall _NutHeapFree
;         *npp = 0;
	clr R2
	clr R3
	movw R30,R10
	std z+1,R3
	std z+0,R2
;     }
L15:
; 
;     if ((*cp & 0xC0) == 0xC0)
	movw R30,R12
	ldd R24,z+0
	andi R24,192
	cpi R24,192
	brne L17
X4:
;         return 2;
	ldi R16,2
	ldi R17,0
	xjmp L14
L17:
; 
;     rc = strlen(cp) + 1;
	movw R16,R12
	xcall _strlen
	movw R20,R16
	subi R20,255  ; offset = 1
	sbci R21,255
;     np = *npp = NutHeapAlloc(rc);
	movw R16,R20
	xcall _NutHeapAlloc
	movw R30,R10
	std z+1,R17
	std z+0,R16
	movw R10,R16
;     len = *cp++;
	movw R30,R12
	ld R22,Z+
	movw R12,R30
	xjmp L20
L22:
;     while (len) {
;         while (len--)
;             *np++ = *cp++;
	movw R30,R12
	movw R26,R10
	ld R0,Z+
	movw R12,R30
	st X+,R0
	movw R10,R26
L23:
	mov R14,R22
	clr R15
	subi R22,1
	tst R14
	brne L22
X5:
;         if ((len = *cp++) != 0)
	movw R30,R12
	ld R14,Z+
	movw R12,R30
	mov R22,R14
	tst R22
	breq L25
X6:
;             *np++ = '.';
	ldi R24,46
	movw R30,R10
	st Z+,R24
	movw R10,R30
L25:
;     }
L20:
	tst R22
	brne L23
X7:
;     *np = 0;
	clr R2
	movw R30,R10
	std z+0,R2
; 
;     return rc;
	movw R16,R20
L14:
	.dbline 0 ; func end
	xjmp pop_xgsetF0FC
;            len -> R10,R11
;            npp -> R12,R13
;             cp -> R14,R15
	.even
_ScanBinary:
	xcall push_xgset00FC
	movw R12,R18
	movw R14,R16
	sbiw R28,2
	ldd R10,y+8
	ldd R11,y+9
; }
; 
; static u_short ScanBinary(u_char * cp, u_char ** npp, u_short len)
; {
;     if (*npp)
	movw R30,R12
	ldd R2,z+0
	ldd R3,z+1
	tst R2
	brne X8
	tst R3
	breq L28
X8:
;         NutHeapFree(*npp);
	ldd R16,z+0
	ldd R17,z+1
	xcall _NutHeapFree
L28:
;     *npp = NutHeapAlloc(len);
	movw R16,R10
	xcall _NutHeapAlloc
	movw R30,R12
	std z+1,R17
	std z+0,R16
;     memcpy(*npp, cp, len);
	std y+1,R11
	std y+0,R10
	movw R18,R14
	xcall _memcpy
; 
;     return len;
	movw R16,R10
L27:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgset00FC
;             id -> R10,R11
;            doh -> R20,R21
	.even
_CreateDnsHeader:
	xcall push_xgset300C
	movw R10,R18
	movw R20,R16
; }
; 
; static DNSHEADER *CreateDnsHeader(DNSHEADER * doh, u_short id)
; {
;     if (doh == 0)
	cpi R20,0
	cpc R20,R21
	brne L31
X9:
;         doh = NutHeapAllocClear(sizeof(DNSHEADER));
	ldi R16,12
	ldi R17,0
	xcall _NutHeapAllocClear
	movw R20,R16
L31:
;     if (doh) {
	cpi R20,0
	cpc R20,R21
	breq L33
X10:
;         doh->doh_id = id;
	movw R30,R20
	std z+1,R11
	std z+0,R10
;         doh->doh_flags = 0x0100;
	ldi R24,256
	ldi R25,1
	std z+3,R25
	std z+2,R24
;         doh->doh_quests = 1;
	ldi R24,1
	ldi R25,0
	std z+5,R25
	std z+4,R24
;     }
L33:
;     return doh;
	movw R16,R20
L30:
	.dbline 0 ; func end
	xjmp pop_xgset300C
;            doh -> R10,R11
	.even
_ReleaseDnsHeader:
	st -y,R10
	st -y,R11
	movw R10,R16
; }
; 
; static void ReleaseDnsHeader(DNSHEADER * doh)
; {
;     if (doh)
	tst R10
	brne X11
	tst R11
	breq L36
X11:
;         NutHeapFree(doh);
	movw R16,R10
	xcall _NutHeapFree
L36:
L35:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
;             rc -> R10,R11
;            doh -> R20,R21
;            buf -> R12,R13
	.even
_EncodeDnsHeader:
	xcall push_xgset30FC
	movw R20,R18
	movw R12,R16
; }
; 
; static u_short EncodeDnsHeader(u_char * buf, DNSHEADER * doh)
; {
;     u_short rc;
; 
;     rc = AddShort(buf, doh->doh_id);
	movw R30,R20
	ldd R18,z+0
	ldd R19,z+1
	movw R16,R12
	xcall _AddShort
	movw R10,R16
;     rc += AddShort(buf + rc, doh->doh_flags);
	movw R30,R20
	ldd R18,z+2
	ldd R19,z+3
	add R16,R12
	adc R17,R13
	xcall _AddShort
	add R10,R16
	adc R11,R17
;     rc += AddShort(buf + rc, doh->doh_quests);
	movw R30,R20
	ldd R18,z+4
	ldd R19,z+5
	movw R16,R10
	add R16,R12
	adc R17,R13
	xcall _AddShort
	add R10,R16
	adc R11,R17
;     rc += AddShort(buf + rc, doh->doh_answers);
	movw R30,R20
	ldd R18,z+6
	ldd R19,z+7
	movw R16,R10
	add R16,R12
	adc R17,R13
	xcall _AddShort
	add R10,R16
	adc R11,R17
;     rc += AddShort(buf + rc, doh->doh_authrr);
	movw R30,R20
	ldd R18,z+8
	ldd R19,z+9
	movw R16,R10
	add R16,R12
	adc R17,R13
	xcall _AddShort
	movw R14,R16
	add R10,R16
	adc R11,R17
;     rc += AddShort(buf + rc, doh->doh_addrr);
	movw R30,R20
	ldd R18,z+10
	ldd R19,z+11
	movw R16,R10
	add R16,R12
	adc R17,R13
	xcall _AddShort
	movw R12,R16
	add R10,R16
	adc R11,R17
; 
;     return rc;
	movw R16,R10
L38:
	.dbline 0 ; func end
	xjmp pop_xgset30FC
;             rc -> R10,R11
;            buf -> R12,R13
;            doh -> R20,R21
	.even
_DecodeDnsHeader:
	xcall push_xgset30FC
	movw R12,R18
	movw R20,R16
; }
; 
; static u_short DecodeDnsHeader(DNSHEADER * doh, u_char * buf)
; {
;     u_short rc;
; 
;     rc = ScanShort(buf, &doh->doh_id);
	movw R18,R20
	movw R16,R12
	xcall _ScanShort
	movw R10,R16
;     rc += ScanShort(buf + rc, &doh->doh_flags);
	movw R18,R20
	subi R18,254  ; offset = 2
	sbci R19,255
	add R16,R12
	adc R17,R13
	xcall _ScanShort
	add R10,R16
	adc R11,R17
;     rc += ScanShort(buf + rc, &doh->doh_quests);
	movw R18,R20
	subi R18,252  ; offset = 4
	sbci R19,255
	movw R16,R10
	add R16,R12
	adc R17,R13
	xcall _ScanShort
	add R10,R16
	adc R11,R17
;     rc += ScanShort(buf + rc, &doh->doh_answers);
	movw R18,R20
	subi R18,250  ; offset = 6
	sbci R19,255
	movw R16,R10
	add R16,R12
	adc R17,R13
	xcall _ScanShort
	add R10,R16
	adc R11,R17
;     rc += ScanShort(buf + rc, &doh->doh_authrr);
	movw R18,R20
	subi R18,248  ; offset = 8
	sbci R19,255
	movw R16,R10
	add R16,R12
	adc R17,R13
	xcall _ScanShort
	movw R14,R16
	add R10,R16
	adc R11,R17
;     rc += ScanShort(buf + rc, &doh->doh_addrr);
	movw R18,R20
	subi R18,246  ; offset = 10
	sbci R19,255
	movw R16,R10
	add R16,R12
	adc R17,R13
	xcall _ScanShort
	movw R12,R16
	add R10,R16
	adc R11,R17
; 
;     return rc;
	movw R16,R10
L39:
	.dbline 0 ; func end
	xjmp pop_xgset30FC
;           type -> y+6
;           name -> R10,R11
;            doq -> R20,R21
	.even
_CreateDnsQuestion:
	xcall push_xgset303C
	movw R10,R18
	movw R20,R16
; }
; 
; static DNSQUESTION *CreateDnsQuestion(DNSQUESTION * doq, CONST u_char * name, u_short type)
; {
;     if (doq == 0)
	cpi R20,0
	cpc R20,R21
	brne L41
X12:
;         doq = NutHeapAllocClear(sizeof(DNSQUESTION));
	ldi R16,6
	ldi R17,0
	xcall _NutHeapAllocClear
	movw R20,R16
L41:
;     if (doq) {
	cpi R20,0
	cpc R20,R21
	breq L43
X13:
;         if (doq->doq_name)
	movw R30,R20
	ldd R2,z+0
	ldd R3,z+1
	tst R2
	brne X14
	tst R3
	breq L45
X14:
;             NutHeapFree(doq->doq_name);
	ldd R16,z+0
	ldd R17,z+1
	xcall _NutHeapFree
L45:
;         doq->doq_name = NutHeapAlloc(strlen(name) + 1);
	movw R16,R10
	xcall _strlen
	subi R16,255  ; offset = 1
	sbci R17,255
	xcall _NutHeapAlloc
	movw R12,R16
	movw R30,R20
	std z+1,R13
	std z+0,R12
;         strcpy(doq->doq_name, name);
	movw R18,R10
	xcall _strcpy
;         doq->doq_type = type;
	movw R30,R20
	ldd R0,y+6
	ldd R1,y+7
	std z+3,R1
	std z+2,R0
;         doq->doq_class = 1;
	ldi R24,1
	ldi R25,0
	std z+5,R25
	std z+4,R24
;     }
L43:
;     return doq;
	movw R16,R20
L40:
	.dbline 0 ; func end
	xjmp pop_xgset303C
;            doq -> R10,R11
	.even
_ReleaseDnsQuestion:
	st -y,R10
	st -y,R11
	movw R10,R16
; }
; 
; static void ReleaseDnsQuestion(DNSQUESTION * doq)
; {
;     if (doq) {
	tst R10
	brne X15
	tst R11
	breq L48
X15:
;         if (doq->doq_name)
	movw R30,R10
	ldd R2,z+0
	ldd R3,z+1
	tst R2
	brne X16
	tst R3
	breq L50
X16:
;             NutHeapFree(doq->doq_name);
	ldd R16,z+0
	ldd R17,z+1
	xcall _NutHeapFree
L50:
;         NutHeapFree(doq);
	movw R16,R10
	xcall _NutHeapFree
;     }
L48:
L47:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
;             rc -> R10,R11
;            doq -> R20,R21
;            buf -> R12,R13
	.even
_EncodeDnsQuestion:
	xcall push_xgset303C
	movw R20,R18
	movw R12,R16
; }
; 
; static u_short EncodeDnsQuestion(u_char * buf, DNSQUESTION * doq)
; {
;     u_short rc;
; 
;     rc = AddName(buf, doq->doq_name);
	movw R30,R20
	ldd R18,z+0
	ldd R19,z+1
	movw R16,R12
	xcall _AddName
	movw R10,R16
;     rc += AddShort(buf + rc, doq->doq_type);
	movw R30,R20
	ldd R18,z+2
	ldd R19,z+3
	add R16,R12
	adc R17,R13
	xcall _AddShort
	add R10,R16
	adc R11,R17
;     rc += AddShort(buf + rc, doq->doq_class);
	movw R30,R20
	ldd R18,z+4
	ldd R19,z+5
	movw R16,R10
	add R16,R12
	adc R17,R13
	xcall _AddShort
	movw R12,R16
	add R10,R16
	adc R11,R17
; 
;     return rc;
	movw R16,R10
L52:
	.dbline 0 ; func end
	xjmp pop_xgset303C
;             rc -> R10,R11
;            buf -> R12,R13
;            doq -> R20,R21
	.even
_DecodeDnsQuestion:
	xcall push_xgset303C
	movw R12,R18
	movw R20,R16
; }
; 
; static u_short DecodeDnsQuestion(DNSQUESTION * doq, u_char * buf)
; {
;     u_short rc;
; 
;     rc = ScanName(buf, &doq->doq_name);
	movw R18,R20
	movw R16,R12
	xcall _ScanName
	movw R10,R16
;     rc += ScanShort(buf + rc, &doq->doq_type);
	movw R18,R20
	subi R18,254  ; offset = 2
	sbci R19,255
	add R16,R12
	adc R17,R13
	xcall _ScanShort
	add R10,R16
	adc R11,R17
;     rc += ScanShort(buf + rc, &doq->doq_class);
	movw R18,R20
	subi R18,252  ; offset = 4
	sbci R19,255
	movw R16,R10
	add R16,R12
	adc R17,R13
	xcall _ScanShort
	movw R12,R16
	add R10,R16
	adc R11,R17
; 
;     return rc;
	movw R16,R10
L53:
	.dbline 0 ; func end
	xjmp pop_xgset303C
;            dor -> R10,R11
	.even
_CreateDnsResource:
	st -y,R10
	st -y,R11
	movw R10,R16
; }
; 
; static DNSRESOURCE *CreateDnsResource(DNSRESOURCE * dor)
; {
;     if (dor == 0)
	tst R10
	brne L55
	tst R11
	brne L55
X17:
;         dor = NutHeapAllocClear(sizeof(DNSRESOURCE));
	ldi R16,14
	ldi R17,0
	xcall _NutHeapAllocClear
	movw R10,R16
L55:
;     return dor;
	movw R16,R10
L54:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
;            dor -> R20,R21
	.even
_ReleaseDnsResource:
	st -y,R20
	st -y,R21
	movw R20,R16
; }
; 
; static void ReleaseDnsResource(DNSRESOURCE * dor)
; {
;     if (dor) {
	cpi R20,0
	cpc R20,R21
	breq L58
X18:
;         if (dor->dor_name)
	movw R30,R20
	ldd R2,z+0
	ldd R3,z+1
	tst R2
	brne X19
	tst R3
	breq L60
X19:
;             NutHeapFree(dor->dor_name);
	ldd R16,z+0
	ldd R17,z+1
	xcall _NutHeapFree
L60:
;         if (dor->dor_data)
	movw R30,R20
	ldd R2,z+12
	ldd R3,z+13
	tst R2
	brne X20
	tst R3
	breq L62
X20:
;             NutHeapFree(dor->dor_data);
	ldd R16,z+12
	ldd R17,z+13
	xcall _NutHeapFree
L62:
;         NutHeapFree(dor);
	movw R16,R20
	xcall _NutHeapFree
;     }
L58:
L57:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
;             rc -> R10,R11
;            buf -> R12,R13
;            dor -> R20,R21
	.even
_DecodeDnsResource:
	xcall push_xgset30FC
	movw R12,R18
	movw R20,R16
	sbiw R28,2
; }
; 
; static u_short DecodeDnsResource(DNSRESOURCE * dor, u_char * buf)
; {
;     u_short rc;
; 
;     rc = ScanName(buf, &dor->dor_name);
	movw R18,R20
	movw R16,R12
	xcall _ScanName
	movw R10,R16
;     rc += ScanShort(buf + rc, &dor->dor_type);
	movw R18,R20
	subi R18,254  ; offset = 2
	sbci R19,255
	add R16,R12
	adc R17,R13
	xcall _ScanShort
	add R10,R16
	adc R11,R17
;     rc += ScanShort(buf + rc, &dor->dor_class);
	movw R18,R20
	subi R18,252  ; offset = 4
	sbci R19,255
	movw R16,R10
	add R16,R12
	adc R17,R13
	xcall _ScanShort
	add R10,R16
	adc R11,R17
;     rc += ScanLong(buf + rc, &dor->dor_ttl);
	movw R18,R20
	subi R18,250  ; offset = 6
	sbci R19,255
	movw R16,R10
	add R16,R12
	adc R17,R13
	xcall _ScanLong
	add R10,R16
	adc R11,R17
;     rc += ScanShort(buf + rc, &dor->dor_len);
	movw R18,R20
	subi R18,246  ; offset = 10
	sbci R19,255
	movw R16,R10
	add R16,R12
	adc R17,R13
	xcall _ScanShort
	movw R14,R16
	add R10,R16
	adc R11,R17
;     rc += ScanBinary(buf + rc, &dor->dor_data, dor->dor_len);
	movw R30,R20
	ldd R2,z+10
	ldd R3,z+11
	std y+1,R3
	std y+0,R2
	movw R18,R30
	subi R18,244  ; offset = 12
	sbci R19,255
	movw R16,R10
	add R16,R12
	adc R17,R13
	xcall _ScanBinary
	movw R12,R16
	add R10,R16
	adc R11,R17
; 
;     return rc;
	movw R16,R10
L64:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgset30FC
;         sdnsip -> y+10
;         pdnsip -> y+6
;         domain -> R10,R11
;       hostname -> R12,R13
	.even
_NutDnsConfig2::
	xcall push_xgset303C
	movw R10,R18
	movw R12,R16
; }
; 
; /*!
;  * \brief Set DNS configuration.
;  *
;  * \param hostname DNS name of the local host.
;  * \param domain Name of the domain of the local host.
;  * \param pdnsip IP address of the primary DNS server.
;  * \param sdnsip IP address of the secondary DNS server.
;  */
; void NutDnsConfig2(u_char * hostname, u_char * domain, u_long pdnsip, u_long sdnsip)
; {
;     if (doc.doc_hostname) {
	lds R2,_doc
	lds R3,_doc+1
	tst R2
	brne X21
	tst R3
	breq L66
X21:
;         NutHeapFree(doc.doc_hostname);
	movw R16,R2
	xcall _NutHeapFree
;         doc.doc_hostname = 0;
	clr R2
	clr R3
	sts _doc+1,R3
	sts _doc,R2
;     }
L66:
;     if (doc.doc_domain) {
	lds R2,_doc+2
	lds R3,_doc+2+1
	tst R2
	brne X22
	tst R3
	breq L68
X22:
;         NutHeapFree(doc.doc_domain);
	movw R16,R2
	xcall _NutHeapFree
;         doc.doc_domain = 0;
	clr R2
	clr R3
	sts _doc+2+1,R3
	sts _doc+2,R2
;     }
L68:
;     if (hostname) {
	tst R12
	brne X23
	tst R13
	breq L73
X23:
;         doc.doc_hostname = NutHeapAlloc(strlen(hostname) + 1);
	movw R16,R12
	xcall _strlen
	subi R16,255  ; offset = 1
	sbci R17,255
	xcall _NutHeapAlloc
	sts _doc+1,R17
	sts _doc,R16
;         strcpy(doc.doc_hostname, hostname);
	movw R18,R12
	xcall _strcpy
;     }
L73:
;     if (domain) {
	tst R10
	brne X24
	tst R11
	breq L75
X24:
;         doc.doc_domain = NutHeapAlloc(strlen(domain) + 1);
	movw R16,R10
	xcall _strlen
	movw R20,R16
	subi R16,255  ; offset = 1
	sbci R17,255
	xcall _NutHeapAlloc
	movw R12,R16
	sts _doc+2+1,R13
	sts _doc+2,R12
;         strcpy(doc.doc_domain, domain);
	movw R18,R10
	xcall _strcpy
;     }
L75:
;     doc.doc_ip1 = pdnsip;
	ldd R2,y+6
	ldd R3,y+7
	ldd R4,y+8
	ldd R5,y+9
	sts _doc+4+1,R3
	sts _doc+4,R2
	sts _doc+4+2+1,R5
	sts _doc+4+2,R4
;     doc.doc_ip2 = sdnsip;
	ldd R2,y+10
	ldd R3,y+11
	ldd R4,y+12
	ldd R5,y+13
	sts _doc+8+1,R3
	sts _doc+8,R2
	sts _doc+8+2+1,R5
	sts _doc+8+2,R4
L65:
	.dbline 0 ; func end
	xjmp pop_xgset303C
;          dnsip -> y+12
;         domain -> R12,R13
;       hostname -> R10,R11
	.even
_NutDnsConfig::
	xcall push_xgset003C
	movw R12,R18
	movw R10,R16
	sbiw R28,8
; }
; 
; /*!
;  * \brief Sets DNS configuration.
;  *
;  * \deprecated New applications should use NutDnsConfig2().
;  *
;  * \param hostname DNS name of the local host.
;  * \param domain Name of the domain of the local host.
;  * \param dnsip IP address of the DNS server.
;  */
; void NutDnsConfig(u_char * hostname, u_char * domain, u_long dnsip)
; {
;     NutDnsConfig2(hostname, domain, dnsip, 0);
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+4,R24
	std y+5,R25
	std y+6,R26
	std y+7,R27
	ldd R2,y+12
	ldd R3,y+13
	ldd R4,y+14
	ldd R5,y+15
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	movw R18,R12
	movw R16,R10
	xcall _NutDnsConfig2
L81:
	.dbline 0 ; func end
	adiw R28,8
	xjmp pop_xgset003C
;       hostname -> R10,R11
	.even
_NutDnsGetHostByName::
	st -y,R10
	st -y,R11
	movw R10,R16
; }
; 
; /*!
;  * \brief Retrieves IP-address corresponding to a host name.
;  *
;  * This is a very simple implementation, which will not return
;  * any other resource information than the IP address.
;  *
;  * \param hostname Fully qualified domain name of the host.
;  *
;  * \return IP address, which is zero, if the name could not
;  *         be resolved.
;  */
; u_long NutDnsGetResource(CONST u_char * hostname, CONST u_short type);
; 
; u_long NutDnsGetHostByName(CONST u_char * hostname)
; {
;     return NutDnsGetResource(hostname, 1);
	ldi R18,1
	ldi R19,0
	movw R16,R10
	xcall _NutDnsGetResource
L82:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
;       hostname -> R10,R11
	.even
_NutDnsGetMxByDomain::
	st -y,R10
	st -y,R11
	movw R10,R16
; }
; 
; u_long NutDnsGetMxByDomain(CONST u_char * hostname)
; {
;     return NutDnsGetResource(hostname, 0x0F);
	ldi R18,15
	ldi R19,0
	movw R16,R10
	xcall _NutDnsGetResource
L83:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
;             ip -> y+16
;        retries -> y+32
;            doq -> y+30
;             id -> y+28
;          rport -> y+14
;          raddr -> y+10
;            dor -> y+26
;           sock -> y+24
;            doh -> y+22
;            pkt -> y+20
;            len -> R10,R11
;              n -> R12,R13
;           type -> y+46
;       hostname -> y+44
	.even
_NutDnsGetResource::
	xcall push_arg4
	xcall push_xgsetF0FC
	sbiw R28,34
; }
; 
; u_long NutDnsGetResource(CONST u_char * hostname, CONST u_short type)
; {
;     u_long ip = 0;
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	std y+16,R20
	std y+17,R21
	std y+18,R22
	std y+19,R23
;     u_char *pkt;
;     u_short len;
;     u_short id = 0;
	clr R0
	clr R1
	std y+29,R1
	std y+28,R0
;     UDPSOCKET *sock;
;     DNSHEADER *doh = 0;
	std y+23,R1
	std y+22,R0
;     DNSQUESTION *doq = 0;
	std y+31,R1
	std y+30,R0
;     DNSRESOURCE *dor = 0;
	std y+27,R1
	std y+26,R0
;     int n;
;     int retries;
;     u_long raddr;
;     u_short rport;
; 
;     /*
;      * We need a configured DNS address.
;      */
;     if (doc.doc_ip1 == 0 && doc.doc_ip2 == 0)
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	lds R4,_doc+4+2
	lds R5,_doc+4+2+1
	lds R2,_doc+4
	lds R3,_doc+4+1
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brne L85
X25:
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	lds R4,_doc+8+2
	lds R5,_doc+8+2+1
	lds R2,_doc+8
	lds R3,_doc+8+1
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brne L85
X26:
;         return 0;
	ldi R16,0
	ldi R17,0
	ldi R18,0
	ldi R19,0
	xjmp L84
L85:
; 
;     /*
;      * Create client socket and allocate
;      * a buffer for the UDP packet.
;      */
;     if ((sock = NutUdpCreateSocket(0)) == 0)
	clr R16
	clr R17
	xcall _NutUdpCreateSocket
	std y+25,R17
	std y+24,R16
	cpi R16,0
	cpc R16,R17
	brne L89
X27:
;         return 0;
	ldi R16,0
	ldi R17,0
	ldi R18,0
	ldi R19,0
	xjmp L84
L89:
;     pkt = NutHeapAlloc(512);
	ldi R16,512
	ldi R17,2
	xcall _NutHeapAlloc
	std y+21,R17
	std y+20,R16
; 
;     for (retries = 0; retries < 6; retries++) {
	clr R0
	clr R1
	std y+33,R1
	std y+32,R0
L91:
; 
;         /*
;          * Create standard header info structures.
;          */
;         doh = CreateDnsHeader(doh, ++id);
	ldd R24,y+28
	ldd R25,y+29
	adiw R24,1
	movw R10,R24
	std y+29,R11
	std y+28,R10
	movw R18,R24
	ldd R16,y+22
	ldd R17,y+23
	xcall _CreateDnsHeader
	movw R10,R16
	std y+23,R11
	std y+22,R10
;         doq = CreateDnsQuestion(doq, hostname, type);
	ldd R0,y+46
	ldd R1,y+47
	std y+1,R1
	std y+0,R0
	ldd R18,y+44
	ldd R19,y+45
	ldd R16,y+30
	ldd R17,y+31
	xcall _CreateDnsQuestion
	movw R10,R16
	std y+31,R11
	std y+30,R10
; 
; #ifdef NUTDEBUG
;         //DumpDnsHeader(doh);
;         //DumpDnsQuestion(doq);
; #endif
; 
;         /*
;          * Encode the header info into the packet buffer
;          * and send it to the DNS server.
;          */
;         len = EncodeDnsHeader(pkt, doh);
	ldd R18,y+22
	ldd R19,y+23
	ldd R16,y+20
	ldd R17,y+21
	xcall _EncodeDnsHeader
	movw R10,R16
;         len += EncodeDnsQuestion(pkt + len, doq);
	ldd R18,y+30
	ldd R19,y+31
	ldd R0,y+20
	ldd R1,y+21
	add R16,R0
	adc R17,R1
	xcall _EncodeDnsQuestion
	movw R12,R16
	add R10,R16
	adc R11,R17
; 
;         if ((retries & 1) == 0 || doc.doc_ip2 == 0) {
	ldd R0,y+32
	ldd R1,y+33
	sbrs R0,0
	rjmp L98
X28:
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	lds R4,_doc+8+2
	lds R5,_doc+8+2+1
	lds R2,_doc+8
	lds R3,_doc+8+1
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brne L95
X29:
L98:
;             if (NutUdpSendTo(sock, doc.doc_ip1, 53, pkt, len) < 0)
	std y+7,R11
	std y+6,R10
	ldd R0,y+20
	ldd R1,y+21
	std y+5,R1
	std y+4,R0
	ldi R24,53
	ldi R25,0
	std y+3,R25
	std y+2,R24
	lds R4,_doc+4+2
	lds R5,_doc+4+2+1
	lds R2,_doc+4
	lds R3,_doc+4+1
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldd R16,y+24
	ldd R17,y+25
	xcall _NutUdpSendTo
	movw R12,R16
	cpi R16,0
	ldi R30,0
	cpc R17,R30
	brge L96
X30:
;                 break;
	xjmp L93
L95:
;         } else {
;             if (NutUdpSendTo(sock, doc.doc_ip2, 53, pkt, len) < 0)
	std y+7,R11
	std y+6,R10
	ldd R0,y+20
	ldd R1,y+21
	std y+5,R1
	std y+4,R0
	ldi R24,53
	ldi R25,0
	std y+3,R25
	std y+2,R24
	lds R4,_doc+8+2
	lds R5,_doc+8+2+1
	lds R2,_doc+8
	lds R3,_doc+8+1
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldd R16,y+24
	ldd R17,y+25
	xcall _NutUdpSendTo
	movw R12,R16
	cpi R16,0
	ldi R30,0
	cpc R17,R30
	brge L102
X31:
;                 break;
	xjmp L93
L102:
;         }
L96:
; 
;         /*
;          * Loop until we receive a response with the
;          * expected id or until timeout.
;          */
;         for (;;) {
L105:
;             len = 0;
	clr R10
	clr R11
;             n = NutUdpReceiveFrom(sock, &raddr, &rport, pkt, 512, 1000);
	ldi R20,232
	ldi R21,3
	ldi R22,0
	ldi R23,0
	std y+6,R20
	std y+7,R21
	std y+8,R22
	std y+9,R23
	ldi R24,512
	ldi R25,2
	std y+5,R25
	std y+4,R24
	ldd R0,y+20
	ldd R1,y+21
	std y+3,R1
	std y+2,R0
	movw R24,R28
	adiw R24,14
	std y+1,R25
	std y+0,R24
	movw R18,R28
	subi R18,246  ; offset = 10
	sbci R19,255
	ldd R16,y+24
	ldd R17,y+25
	xcall _NutUdpReceiveFrom
	movw R12,R16
;             if (n <= 0)
	clr R2
	clr R3
	cp R2,R16
	cpc R3,R17
	brlt L109
X32:
;                 break;
	xjmp L107
L109:
;             if (n > 12) {
	ldi R24,12
	ldi R25,0
	cp R24,R12
	cpc R25,R13
	brge L105
X33:
;                 len = DecodeDnsHeader(doh, pkt);
	ldd R18,y+20
	ldd R19,y+21
	ldd R16,y+22
	ldd R17,y+23
	xcall _DecodeDnsHeader
	movw R14,R16
	movw R10,R14
; #ifdef NUTDEBUG
;                 //DumpDnsHeader(doh);
; #endif
;                 if (doh->doh_id == id)
	ldd R30,y+22
	ldd R31,y+23
	ldd R2,z+0
	ldd R3,z+1
	ldd R0,y+28
	ldd R1,y+29
	cp R2,R0
	cpc R3,R1
	breq X42
	xjmp L105
X42:
X34:
;                     break;
;             }
;         }
L107:
; 
;         /*
;          * Decode the answer.
;          */
;         if (len && doh->doh_quests == 1) {
	tst R10
	brne X35
	tst R11
	brne X43
	xjmp L115
X43:
X35:
	ldd R30,y+22
	ldd R31,y+23
	ldd R24,z+4
	ldd R25,z+5
	cpi R24,1
	ldi R30,0
	cpc R25,R30
	breq X44
	xjmp L115
X44:
X36:
;             len += DecodeDnsQuestion(doq, pkt + len);
	movw R18,R10
	ldd R0,y+20
	ldd R1,y+21
	add R18,R0
	adc R19,R1
	ldd R16,y+30
	ldd R17,y+31
	xcall _DecodeDnsQuestion
	movw R14,R16
	add R10,R16
	adc R11,R17
; #ifdef NUTDEBUG
;             //DumpDnsQuestion(doq);
; #endif
;             if (doh->doh_answers < 1)
	ldd R30,y+22
	ldd R31,y+23
	ldd R24,z+6
	ldd R25,z+7
	cpi R24,1
	ldi R30,0
	cpc R25,R30
	brsh L117
X37:
;                 break;
	xjmp L93
L117:
;             else {
;                 for (n = 1; n <= (int) doh->doh_answers; n++) {
	ldi R24,1
	ldi R25,0
	movw R12,R24
	xjmp L122
L119:
;                     dor = CreateDnsResource(dor);
	ldd R16,y+26
	ldd R17,y+27
	xcall _CreateDnsResource
	movw R14,R16
	std y+27,R15
	std y+26,R14
;                     len += DecodeDnsResource(dor, pkt + len);
	movw R18,R10
	ldd R0,y+20
	ldd R1,y+21
	add R18,R0
	adc R19,R1
	xcall _DecodeDnsResource
	movw R14,R16
	add R10,R16
	adc R11,R17
; #ifdef NUTDEBUG
;                     //DumpDnsResource(dor);
; #endif
;                     if (dor->dor_type == 1)
	ldd R30,y+26
	ldd R31,y+27
	ldd R24,z+2
	ldd R25,z+3
	cpi R24,1
	ldi R30,0
	cpc R25,R30
	brne L123
X38:
;                         break;
	xjmp L121
L123:
;                 }
L120:
	movw R24,R12
	adiw R24,1
	movw R12,R24
L122:
	ldd R30,y+22
	ldd R31,y+23
	ldd R2,z+6
	ldd R3,z+7
	cp R2,R12
	cpc R3,R13
	brge L119
X39:
L121:
;                 if (dor->dor_len == 4) {
	ldd R30,y+26
	ldd R31,y+27
	ldd R24,z+10
	ldd R25,z+11
	cpi R24,4
	ldi R26,0
	cpc R25,R26
	breq X45
	xjmp L125
X45:
X40:
;                     ip = *dor->dor_data;
	ldd R26,z+12
	ldd R27,z+13
	ld R2,x
	clr R3
	clr R4
	clr R5
	std y+16,R2
	std y+17,R3
	std y+18,R4
	std y+19,R5
;                     ip += (u_long)(*(dor->dor_data + 1)) << 8;
	ldi R24,8
	ldi R25,0
	ldd R30,y+26
	ldd R31,y+27
	push R26
	push R27
	ldd R26,z+12
	ldd R27,z+13
	movw R30,R26
	pop R27
	pop R26
	ldd R16,z+1
	clr R17
	clr R18
	clr R19
	st -y,R24
	xcall lsl32
	ldd R2,y+16
	ldd R3,y+17
	ldd R4,y+18
	ldd R5,y+19
	add R2,R16
	adc R3,R17
	adc R4,R18
	adc R5,R19
	std y+16,R2
	std y+17,R3
	std y+18,R4
	std y+19,R5
;                     ip += (u_long)(*(dor->dor_data + 2)) << 16;
	ldd R30,y+26
	ldd R31,y+27
	push R26
	push R27
	ldd R26,z+12
	ldd R27,z+13
	movw R30,R26
	pop R27
	pop R26
	ldd R2,z+2
	clr R3
	clr R4
	clr R5
	movw R4,R2
	clr R2
	clr R3
	ldd R6,y+16
	ldd R7,y+17
	ldd R8,y+18
	ldd R9,y+19
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	std y+16,R6
	std y+17,R7
	std y+18,R8
	std y+19,R9
;                     ip += (u_long)(*(dor->dor_data + 3)) << 24;
	ldi R24,24
	ldi R25,0
	ldd R30,y+26
	ldd R31,y+27
	push R26
	push R27
	ldd R26,z+12
	ldd R27,z+13
	movw R30,R26
	pop R27
	pop R26
	ldd R16,z+3
	clr R17
	clr R18
	clr R19
	st -y,R24
	xcall lsl32
	ldd R2,y+16
	ldd R3,y+17
	ldd R4,y+18
	ldd R5,y+19
	add R2,R16
	adc R3,R17
	adc R4,R18
	adc R5,R19
	std y+16,R2
	std y+17,R3
	std y+18,R4
	std y+19,R5
;                     break;
	xjmp L93
L125:
;                 }
;                 /* TBD: 18.3.2004 - for MX requests authoritative rrs should be skipped + additional rrs should be searched for IP address */
;             }
;         }
L115:
;     }
L92:
	ldd R24,y+32
	ldd R25,y+33
	adiw R24,1
	std y+33,R25
	std y+32,R24
	cpi R24,6
	ldi R30,0
	cpc R25,R30
	brge X46
	xjmp L91
X46:
X41:
L93:
; 
;     /*
;      * Clean up.
;      */
;     ReleaseDnsHeader(doh);
	ldd R16,y+22
	ldd R17,y+23
	xcall _ReleaseDnsHeader
;     ReleaseDnsQuestion(doq);
	ldd R16,y+30
	ldd R17,y+31
	xcall _ReleaseDnsQuestion
;     ReleaseDnsResource(dor);
	ldd R16,y+26
	ldd R17,y+27
	xcall _ReleaseDnsResource
; 
;     NutHeapFree(pkt);
	ldd R16,y+20
	ldd R17,y+21
	xcall _NutHeapFree
;     NutUdpDestroySocket(sock);
	ldd R16,y+24
	ldd R17,y+25
	xcall _NutUdpDestroySocket
; 
;     return ip;
	ldd R16,y+16
	ldd R17,y+17
	ldd R18,y+18
	ldd R19,y+19
L84:
	.dbline 0 ; func end
	adiw R28,34
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
	.area bss(ram, con, rel)
_doc:
	.blkb 12
; }
; 
; /*@}*/
