	.module sntp.c
	.area text(rom, con, rel)
;       interval -> y+12
;          retry -> R10,R11
;    server_addr -> y+8
;              t -> y+4
; cur_server_addr -> y+0
;            arg -> R12,R13
	.even
_SNTP_resync::
	xcall push_xgsetF03C
	movw R12,R16
	sbiw R28,16
; /*
;  * Copyright (C) 2001-2003 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  * Thanks to Lars H. Andersson, who submitted the first idea of this simple function
;  */
; 
; 
; /*!
;  * \file pro/sntp.c
;  * \brief Simple Network Time Protocol Client.
;  *
;  * \verbatim
;  *
;  * $Log: sntp.c,v $
;  * Revision 1.8  2005/08/03 11:46:59  olereinhardt
;  * Removed unneeded comment line to fix compile bug
;  *
;  * Revision 1.7  2005/08/02 17:47:04  haraldkipp
;  * Major API documentation update.
;  *
;  * Revision 1.6  2005/04/08 15:20:51  olereinhardt
;  * added <sys/types.h> (__APPLE__) and <netinet/in.h> (__linux__)
;  * for htons and simmilar.
;  *
;  * Revision 1.5  2005/04/05 17:44:57  haraldkipp
;  * Made stack space configurable.
;  *
;  * Revision 1.4  2003/11/26 12:55:35  drsung
;  * Portability issues ... again
;  *
;  * Revision 1.3  2003/11/26 11:16:44  haraldkipp
;  * Portability issues
;  *
;  * Revision 1.2  2003/11/24 21:01:42  drsung
;  * Now using UDP packet queue.
;  *
;  * Revision 1.1  2003/11/24 18:13:22  drsung
;  * first release
;  *
;  * \endverbatim
;  */
; 
; #include <cfg/sntp.h>
; 
; #include <pro/sntp.h>
; #include <sys/socket.h>
; #include <sys/heap.h>
; #include <string.h>
; #include "../crt/ctime.h"
; #include <stdio.h>
; #include <sys/thread.h>
; #include <sys/timer.h>
; #include <sys/types.h>
; #include <netinet/in.h>
; 
; /*!
;  * \addtogroup xgSntp
;  */
; /*@{*/
; 
; #ifndef NUT_THREAD_SNTPSTACK
; #define NUT_THREAD_SNTPSTACK    256
; #endif
; 
; typedef struct _sntpframe sntpframe;
; struct _sntpframe {
;     u_char mode;
;     u_char stratum;
;     u_char poll;
;     u_char precision;
;     u_long root_delay;
;     u_long root_dispersion;
;     u_long reference_identifier;
;     u_long reference_ts_sec;
;     u_long reference_ts_frac;
;     u_long originate_ts_sec;
;     u_long originate_ts_frac;
;     u_long receive_ts_sec;
;     u_long receive_ts_frac;
;     u_long transmit_ts_sec;
;     u_long transmit_ts_frac;
; };
; 
; 
; #define NTP_PORT	123
; #define SNTP_PORT NTP_PORT
; 
; struct SNTP_resync_args {
;     u_long server_addr;
;     u_long interval;
; };
; 
; THREAD(SNTP_resync, arg)
; {
;     u_long server_addr = ((struct SNTP_resync_args *) arg)->server_addr;
	movw R30,R12
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	std y+8,R2
	std y+9,R3
	std y+10,R4
	std y+11,R5
;     u_long interval = ((struct SNTP_resync_args *) arg)->interval;
	ldd R2,z+4
	ldd R3,z+5
	ldd R4,z+6
	ldd R5,z+7
	std y+12,R2
	std y+13,R3
	std y+14,R4
	std y+15,R5
;     u_long cur_server_addr = server_addr;
	ldd R2,y+8
	ldd R3,y+9
	ldd R4,y+10
	ldd R5,y+11
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
;     int retry = 0;
	clr R10
	clr R11
;     time_t t;
; 
;     NutHeapFree(arg);
	movw R16,R30
	xcall _NutHeapFree
; 
;     NutThreadSetPriority(63);
	ldi R16,63
	xcall _NutThreadSetPriority
;     for (;;) {
L2:
;         if (NutSNTPGetTime(&cur_server_addr, &t)) {     /* if any error retry */
	movw R18,R28
	subi R18,252  ; offset = 4
	sbci R19,255
	movw R16,R28
	xcall _NutSNTPGetTime
	cpi R16,0
	cpc R16,R17
	breq L6
X0:
;             if (cur_server_addr != server_addr && server_addr == 0xFFFFFFFF) {
	ldd R2,y+8
	ldd R3,y+9
	ldd R4,y+10
	ldd R5,y+11
	ldd R6,y+0
	ldd R7,y+1
	ldd R8,y+2
	ldd R9,y+3
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	breq L8
X1:
	ldi R20,255
	ldi R21,255
	ldi R22,255
	ldi R23,255
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brne L8
X2:
;                 cur_server_addr = server_addr;
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
;                 continue;
	xjmp L2
L8:
;             }
; 
;             if (retry++ >= 3) { /* if numer of retries >= 3 wait 30 secs before next retry sequence ... */
	movw R2,R10
	movw R24,R2
	adiw R24,1
	movw R10,R24
	movw R24,R2
	cpi R24,3
	ldi R30,0
	cpc R25,R30
	brlt L10
X3:
;                 retry = 0;
	clr R10
	clr R11
;                 NutSleep(30000);
	ldi R16,48
	ldi R17,117
	ldi R18,0
	ldi R19,0
	xcall _NutSleep
;             } else              /* ... else wait 5 secs for next retry */
	xjmp L2
L10:
;                 NutSleep(5000);
	ldi R16,136
	ldi R17,19
	ldi R18,0
	ldi R19,0
	xcall _NutSleep
;         } else {                /* no error */
	xjmp L2
L6:
;             stime(&t);          /* so set the time */
	movw R16,R28
	subi R16,252  ; offset = 4
	sbci R17,255
	xcall _stime
;             retry = 0;
	clr R10
	clr R11
;             NutSleep(interval); /* and wait the interval time */
	ldd R16,y+12
	ldd R17,y+13
	ldd R18,y+14
	ldd R19,y+15
	xcall _NutSleep
;         }
;     }
	xjmp L2
X4:
L1:
	.dbline 0 ; func end
	adiw R28,16
	xjmp pop_xgsetF03C
;            len -> R14,R15
;           port -> y+16
;        bufsize -> y+14
;         result -> R10,R11
;       rec_addr -> y+10
;           sock -> y+22
;           data -> R12,R13
;              t -> y+36
;     server_adr -> y+34
	.even
_NutSNTPGetTime::
	xcall push_arg4
	xcall push_xgsetF0FC
	sbiw R28,24
; }
; 
; int NutSNTPGetTime(u_long * server_adr, time_t * t)
; {
;     /*first check the pointers */
;     u_long rec_addr;
;     UDPSOCKET *sock = NULL;     /* the udp socket */
	clr R0
	clr R1
	std y+23,R1
	std y+22,R0
;     sntpframe *data;            /* we're using the heap to save stack space */
;     u_short port;               /* source port from incoming packet */
;     int len;
;     int result = -1;
	ldi R24,-1
	ldi R25,-1
	movw R10,R24
;     /* Set UDP input buffer to 256 bytes */
;     u_short bufsize = 256;
	ldi R24,256
	ldi R25,1
	std y+15,R25
	std y+14,R24
; 
; 
;     if (t == NULL)
	ldd R0,y+36
	ldd R1,y+37
	tst R0
	brne L13
	tst R1
	brne L13
X5:
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L12
L13:
;     if (server_adr == NULL)
	ldd R0,y+34
	ldd R1,y+35
	tst R0
	brne L15
	tst R1
	brne L15
X6:
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L12
L15:
; 
;     if ((data = NutHeapAllocClear(sizeof(*data))) == NULL)
	ldi R16,48
	ldi R17,0
	xcall _NutHeapAllocClear
	movw R12,R16
	tst R12
	brne L17
	tst R13
	brne L17
X7:
;         goto error;
	xjmp L19
L17:
; 
;     sock = NutUdpCreateSocket(0);       /* allocate new udp socket */
	clr R16
	clr R17
	xcall _NutUdpCreateSocket
	std y+23,R17
	std y+22,R16
;     if (sock == NULL)
	movw R0,R16
	cpi R16,0
	cpc R16,R17
	brne L20
X8:
;         goto error;
	xjmp L19
L20:
; 
;     NutUdpSetSockOpt(sock, SO_RCVBUF, &bufsize, sizeof(bufsize));
	ldi R24,2
	ldi R25,0
	std y+3,R25
	std y+2,R24
	movw R24,R28
	adiw R24,14
	std y+1,R25
	std y+0,R24
	ldi R18,4098
	ldi R19,16
	ldd R16,y+22
	ldd R17,y+23
	xcall _NutUdpSetSockOpt
; 
;     data->mode = 0x1B;          /* LI, VN and Mode bit fields (all in u_char mode); */
	ldi R24,27
	movw R30,R12
	std z+0,R24
;     if (NutUdpSendTo(sock, *server_adr, SNTP_PORT, data, sizeof(*data)))        /* Send packet to server */
	ldi R24,48
	ldi R25,0
	std y+7,R25
	std y+6,R24
	std y+5,R13
	std y+4,R12
	ldi R24,123
	std y+3,R25
	std y+2,R24
	ldd R30,y+34
	ldd R31,y+35
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldd R16,y+22
	ldd R17,y+23
	xcall _NutUdpSendTo
	movw R14,R16
	cpi R16,0
	cpc R16,R17
	breq L22
X9:
;         goto error;             /* on error return -1 */
	xjmp L19
L22:
L24:
;   retry:
;     rec_addr = 0;
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	std y+10,R20
	std y+11,R21
	std y+12,R22
	std y+13,R23
;     len = NutUdpReceiveFrom(sock, &rec_addr, &port, data, sizeof(*data), 5000); /* Receive packet with timeout of 5s */
	ldi R20,136
	ldi R21,19
	ldi R22,0
	ldi R23,0
	std y+6,R20
	std y+7,R21
	std y+8,R22
	std y+9,R23
	ldi R24,48
	ldi R25,0
	std y+5,R25
	std y+4,R24
	std y+3,R13
	std y+2,R12
	movw R24,R28
	adiw R24,16
	std y+1,R25
	std y+0,R24
	movw R18,R28
	subi R18,246  ; offset = 10
	sbci R19,255
	ldd R16,y+22
	ldd R17,y+23
	xcall _NutUdpReceiveFrom
	movw R14,R16
;     if (len <= 0) {
	clr R2
	clr R3
	cp R2,R16
	cpc R3,R17
	brlt L25
X10:
;         goto error;             /* error or timeout occured */
	xjmp L19
L25:
;     } 
; 
;     if (port != SNTP_PORT || (data->mode & 0xc0) == 0xc0)       /* if source port is not SNTP_PORT or server is not in sync return */
	ldd R24,y+16
	ldd R25,y+17
	cpi R24,123
	ldi R30,0
	cpc R25,R30
	brne L29
X11:
	movw R30,R12
	ldd R24,z+0
	andi R24,192
	cpi R24,192
	brne L27
X12:
L29:
;     {
;         if (*server_adr == 0xFFFFFFFF)
	ldi R20,255
	ldi R21,255
	ldi R22,255
	ldi R23,255
	ldd R30,y+34
	ldd R31,y+35
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	breq X16
	xjmp L19
X16:
X13:
;             goto retry;         /*  unusable packets will be just ignored. */
	xjmp L24
L27:
;         else
;             goto error;
;     }
; 
;     *t = ntohl(data->transmit_ts_sec) - (70 * 365 + _LEAP_YEAR_ADJUST) * _DAY_SEC;
	movw R30,R12
	ldd R2,z+40
	ldd R3,z+41
	ldd R4,z+42
	ldd R5,z+43
	std y+18,R2
	std y+19,R3
	std y+20,R4
	std y+21,R5
	ldi R20,0
	ldi R21,255
	ldi R22,0
	ldi R23,0
	ldd R16,y+18
	ldd R17,y+19
	ldd R18,y+20
	ldd R19,y+21
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R2,R16
	movw R4,R18
	ldi R20,255
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R16,y+18
	ldd R17,y+19
	ldd R18,y+20
	ldd R19,y+21
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R6,R16
	movw R8,R18
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	ldi R20,0
	ldi R21,0
	ldi R22,255
	ldi R23,0
	ldd R16,y+18
	ldd R17,y+19
	ldd R18,y+20
	ldd R19,y+21
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,255
	ldd R16,y+18
	ldd R17,y+19
	ldd R18,y+20
	ldd R19,y+21
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldi R20,128
	ldi R21,126
	ldi R22,170
	ldi R23,131
	sub R6,R20
	sbc R7,R21
	sbc R8,R22
	sbc R9,R23
	ldd R30,y+36
	ldd R31,y+37
	std z+0,R6
	std z+1,R7
	std z+2,R8
	std z+3,R9
;     *server_adr = rec_addr;
	ldd R2,y+10
	ldd R3,y+11
	ldd R4,y+12
	ldd R5,y+13
	ldd R30,y+34
	ldd R31,y+35
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;     result = 0;
	clr R10
	clr R11
L19:
;   error:
;     if (sock)
	ldd R0,y+22
	ldd R1,y+23
	tst R0
	brne X14
	tst R1
	breq L32
X14:
;         NutUdpDestroySocket(sock);
	movw R16,R0
	xcall _NutUdpDestroySocket
L32:
;     if (data)
	tst R12
	brne X15
	tst R13
	breq L34
X15:
;         NutHeapFree(data);
	movw R16,R12
	xcall _NutHeapFree
L34:
;     return result;
	movw R16,R10
L12:
	.dbline 0 ; func end
	adiw R28,24
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
;            arg -> R20,R21
;       interval -> y+10
;    server_addr -> y+6
	.even
_NutSNTPStartThread::
	xcall push_arg4
	st -y,R20
	st -y,R21
	sbiw R28,4
; }
; 
; int NutSNTPStartThread(u_long server_addr, u_long interval)
; {
;     struct SNTP_resync_args *arg = NutHeapAlloc(sizeof(struct SNTP_resync_args));
	ldi R16,8
	ldi R17,0
	xcall _NutHeapAlloc
	movw R20,R16
;     if (!arg)
	cpi R16,0
	cpc R16,R17
	brne L37
X17:
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L36
L37:
;     arg->server_addr = server_addr;
	ldd R2,y+6
	ldd R3,y+7
	ldd R4,y+8
	ldd R5,y+9
	movw R30,R20
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;     arg->interval = interval;
	ldd R2,y+10
	ldd R3,y+11
	ldd R4,y+12
	ldd R5,y+13
	std z+4,R2
	std z+5,R3
	std z+6,R4
	std z+7,R5
;     if (NutThreadCreate("sntpc", SNTP_resync, arg, NUT_THREAD_SNTPSTACK))
	ldi R24,256
	ldi R25,1
	std y+3,R25
	std y+2,R24
	std y+1,R21
	std y+0,R20
	ldi R18,<PL_SNTP_resync
	ldi R19,>PL_SNTP_resync
	ldi R16,<L41
	ldi R17,>L41
	xcall _NutThreadCreate
	cpi R16,0
	cpc R16,R17
	breq L39
X18:
;         return 0;
	clr R16
	clr R17
	xjmp L36
L39:
;     else {
;         NutHeapFree(arg);
	movw R16,R20
	xcall _NutHeapFree
;         return -1;
	ldi R16,-1
	ldi R17,-1
L36:
	.dbline 0 ; func end
	adiw R28,4
	ld R21,y+
	ld R20,y+
	adiw R28,4
	ret
	.area data(ram, con, rel)
L41:
	.blkb 6
	.area idata
	.byte 's,'n,'t,'p,'c,0
	.area data(ram, con, rel)
;     }
; }
; 
; /*@}*/
	.area func_lit
PL_SNTP_resync:	.word `_SNTP_resync
