	.module ssi.c
	.area text(rom, con, rel)
;             fd -> y+10
;           size -> y+8
;           data -> R12,R13
;              n -> R10,R11
;       file_len -> y+4
;       filename -> R10,R11
;         stream -> y+22
	.even
_NutSsiProcessFile:
	xcall push_arg4
	xcall push_xgsetF0FC
	movw R10,R18
	sbiw R28,12
; /*
;  * Copyright (C) 2001-2004 by Ole Reinhardt <ole.reinhardt@embedded-it.de>. 
;  * All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  */
;  
; /*
;  * $Log: ssi.c,v $
;  * Revision 1.1  2005/08/05 11:22:14  olereinhardt
;  * Added Server side include support. Initial checkin
;  *
;  */  
; 
; /*!
;  * \addtogroup xgHTTPD
;  */
; /*@{*/
; 
; #include <cfg/arch.h>
; 
; #include <io.h>
; #include <ctype.h>
; #include <stdio.h>
; #include <string.h>
; #include <stdlib.h>
; #include <sys/types.h>
; #include <unistd.h>
; #include <fcntl.h>
; 
; 
; #include <sys/heap.h>
; #include <sys/version.h>
; 
; #include <pro/httpd.h>
; #include <pro/ssi.h>
; #include "dencode.h"
; 
; #define BUFSIZE 512
; 
; #define MIN(a,b) (a<b?a:b)
; 
; #define SSI_TYPE_FILE    0x01
; #define SSI_TYPE_VIRTUAL 0x02
; #define SSI_TYPE_EXEC    0x03
; 
; 
; /*!
;  * \brief Send included file to the stream
;  *
;  * Load a file from filesystem and send ("include") it to the http-stream
;  *
;  * \param stream Stream of the socket connection, previously opened for 
;  *               binary read and write.
;  * \param filename Name of the included file. e.g."UROM:test.txt"
;  */
; 
; static void NutSsiProcessFile(FILE * stream, u_char *filename)
; {
;     int fd;
;     int n;
;     char *data;
;     int size;
;     long file_len;
; 
;     fd = _open(filename, _O_BINARY | _O_RDONLY);
	ldi R18,32768
	ldi R19,128
	movw R16,R10
	xcall __open
	std y+11,R17
	std y+10,R16
; 
;     if (fd == -1) {                     // No such file found... send a 404 string.
	cpi R16,255
	ldi R30,255
	cpc R17,R30
	brne L2
X0:
;         fprintf_P(stream, PSTR("404 Not found: %s\n"), filename);
	std y+1,R11
	std y+0,R10
	ldi R18,<L4
	ldi R19,>L4
	ldd R16,y+22
	ldd R17,y+23
	xcall _fprintf_P
;         return;
	xjmp L1
L2:
;     }
;     
;     file_len = _filelength(fd);
	ldd R16,y+10
	ldd R17,y+11
	xcall __filelength
	std y+4,R16
	std y+5,R17
	std y+6,R18
	std y+7,R19
;     
;     size = 512;
	ldi R24,512
	ldi R25,2
	std y+9,R25
	std y+8,R24
;     if ((data = NutHeapAlloc(size)) != 0) {
	movw R16,R24
	xcall _NutHeapAlloc
	movw R12,R16
	tst R12
	brne X1
	tst R13
	brne X5
	xjmp L5
X5:
X1:
	xjmp L8
L7:
;         while (file_len) {
;             if (file_len < 512L)
	ldi R20,0
	ldi R21,2
	ldi R22,0
	ldi R23,0
	ldd R2,y+4
	ldd R3,y+5
	ldd R4,y+6
	ldd R5,y+7
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brge L10
X2:
;                 size = (int) file_len;
	std y+9,R3
	std y+8,R2
L10:
; 
;             n = _read(fd, data, size);
	ldd R0,y+8
	ldd R1,y+9
	std y+1,R1
	std y+0,R0
	movw R18,R12
	ldd R16,y+10
	ldd R17,y+11
	xcall __read
	movw R10,R16
;             if (fwrite(data, 1, n, stream) == 0)
	ldd R0,y+22
	ldd R1,y+23
	std y+3,R1
	std y+2,R0
	std y+1,R11
	std y+0,R10
	ldi R18,1
	ldi R19,0
	movw R16,R12
	xcall _fwrite
	movw R14,R16
	cpi R16,0
	cpc R16,R17
	brne L12
X3:
;                 break;
	xjmp L9
L12:
;             file_len -= (long) n;
	movw R2,R10
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	ldd R6,y+4
	ldd R7,y+5
	ldd R8,y+6
	ldd R9,y+7
	sub R6,R2
	sbc R7,R3
	sbc R8,R4
	sbc R9,R5
	std y+4,R6
	std y+5,R7
	std y+6,R8
	std y+7,R9
;         }
L8:
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R2,y+4
	ldd R3,y+5
	ldd R4,y+6
	ldd R5,y+7
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	breq X6
	xjmp L7
X6:
X4:
L9:
;         NutHeapFree(data);
	movw R16,R12
	xcall _NutHeapFree
;     }
L5:
; 
;     _close(fd);
	ldd R16,y+10
	ldd R17,y+11
	xcall __close
L1:
	.dbline 0 ; func end
	adiw R28,12
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
;            req -> R20,R21
	.even
_DestroyRequestInfo:
	st -y,R20
	st -y,R21
	movw R20,R16
; }
; 
; static void DestroyRequestInfo(REQUEST * req)
; {
;     if (req->req_url)
	movw R30,R20
	ldd R2,z+6
	ldd R3,z+7
	tst R2
	brne X7
	tst R3
	breq L15
X7:
;         NutHeapFree(req->req_url);
	ldd R16,z+6
	ldd R17,z+7
	xcall _NutHeapFree
L15:
;     if (req->req_query)
	movw R30,R20
	ldd R2,z+8
	ldd R3,z+9
	tst R2
	brne X8
	tst R3
	breq L17
X8:
;         NutHeapFree(req->req_query);
	ldd R16,z+8
	ldd R17,z+9
	xcall _NutHeapFree
L17:
;     if (req->req_type)
	movw R30,R20
	ldd R2,z+10
	ldd R3,z+11
	tst R2
	brne X9
	tst R3
	breq L19
X9:
;         NutHeapFree(req->req_type);
	ldd R16,z+10
	ldd R17,z+11
	xcall _NutHeapFree
L19:
;     if (req->req_cookie)
	movw R30,R20
	ldd R2,z+12
	ldd R3,z+13
	tst R2
	brne X10
	tst R3
	breq L21
X10:
;         NutHeapFree(req->req_cookie);
	ldd R16,z+12
	ldd R17,z+13
	xcall _NutHeapFree
L21:
;     if (req->req_auth)
	movw R30,R20
	ldd R2,z+14
	ldd R3,z+15
	tst R2
	brne X11
	tst R3
	breq L23
X11:
;         NutHeapFree(req->req_auth);
	ldd R16,z+14
	ldd R17,z+15
	xcall _NutHeapFree
L23:
;     if (req->req_agent)
	movw R30,R20
	ldd R2,z+16
	ldd R3,z+17
	tst R2
	brne X12
	tst R3
	breq L25
X12:
;         NutHeapFree(req->req_agent);
	ldd R16,z+16
	ldd R17,z+17
	xcall _NutHeapFree
L25:
;     if (req->req_qptrs)
	movw R30,R20
	ldd R2,z+18
	ldd R3,z+19
	tst R2
	brne X13
	tst R3
	breq L27
X13:
;         NutHeapFree(req->req_qptrs);
	ldd R16,z+18
	ldd R17,z+19
	xcall _NutHeapFree
L27:
;     NutHeapFree(req);
	movw R16,R20
	xcall _NutHeapFree
L14:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
;           urll -> y+18
;          index -> R12,R13
;             cp -> R12,R13
;        handler -> y+16
;           size -> y+14
;           data -> R14,R15
;            req -> R10,R11
;              n -> R10,R11
;             fd -> y+12
;       file_len -> y+6
;       filename -> y+10
;       orig_req -> y+36
;      http_root -> y+34
;            url -> y+32
;         stream -> y+30
	.even
_NutSsiProcessVirtual:
	xcall push_arg4
	xcall push_xgsetF0FC
	sbiw R28,20
; }
; 
; /*!
;  * \brief Send a file or cgi with a path relativ to http-root
;  *
;  * Processes an included local url with a path relativ to http-root. This could also be a 
;  * cgi script. Nearly the same as NutHttpProcessFileRequest
;  *
;  * \param stream Stream of the socket connection, previously opened for 
;  *               binary read and write.
;  * \param url    URL of the file to be included e.g. "/include/test.js"
;  * \param http_root The root path of the http-deamon
;  * \param orig_req The http request struct of the top most http_request
;  */
; 
; static void NutSsiProcessVirtual(FILE * stream, u_char *url, u_char* http_root, REQUEST *orig_req)
; {
;     int fd;
;     int n;
;     char *data;
;     int size;
;     long file_len;
;     char *filename = NULL;
	clr R0
	clr R1
	std y+11,R1
	std y+10,R0
;     void (*handler)(FILE *stream, int fd, int file_len, u_char *http_root, REQUEST *req);
;     
;     
;     char *cp;
;     REQUEST * req;
; 
;     if (NutDecodePath(url) == 0) {
	ldd R16,y+32
	ldd R17,y+33
	xcall _NutDecodePath
	cpi R16,0
	cpc R16,R17
	brne L30
X14:
;         fprintf_P(stream, PSTR("400 Bead request\n"));
	ldi R18,<L32
	ldi R19,>L32
	ldd R16,y+30
	ldd R17,y+31
	xcall _fprintf_P
;         return;
	xjmp L29
L30:
;     }
;     
;     /*
;      * Process CGI.
;      */
;     if (strncasecmp(url, "cgi-bin/", 8) == 0) {
	ldi R24,8
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<L35
	ldi R19,>L35
	ldd R16,y+32
	ldd R17,y+33
	xcall _strncmp
	cpi R16,0
	cpc R16,R17
	breq X43
	xjmp L33
X43:
X15:
;         if ((req = NutHeapAllocClear(sizeof(REQUEST))) == 0) {
	ldi R16,22
	ldi R17,0
	xcall _NutHeapAllocClear
	movw R12,R16
	movw R10,R12
	cpi R16,0
	cpc R16,R17
	brne L36
X16:
;             fprintf_P(stream, PSTR("500 Internal error\n"));
	ldi R18,<L38
	ldi R19,>L38
	ldd R16,y+30
	ldd R17,y+31
	xcall _fprintf_P
;             return;
	xjmp L29
L36:
;         }
;         req->req_method = METHOD_GET;
	ldi R24,1
	ldi R25,0
	movw R30,R10
	std z+1,R25
	std z+0,R24
;         req->req_version = orig_req->req_version;
	ldd R30,y+36
	ldd R31,y+37
	ldd R2,z+2
	ldd R3,z+3
	movw R30,R10
	std z+3,R3
	std z+2,R2
;         req->req_length = 0;
	clr R2
	clr R3
	std z+5,R3
	std z+4,R2
;         
;         if (orig_req->req_agent != NULL) {
	ldd R30,y+36
	ldd R31,y+37
	ldd R2,z+16
	ldd R3,z+17
	tst R2
	brne X17
	tst R3
	breq L39
X17:
;             if ((req->req_agent = NutHeapAlloc((strlen(orig_req->req_agent) + 1))) == 0) {
	ldd R16,z+16
	ldd R17,z+17
	xcall _strlen
	subi R16,255  ; offset = 1
	sbci R17,255
	xcall _NutHeapAlloc
	movw R12,R16
	movw R30,R10
	std z+17,R13
	std z+16,R12
	cpi R16,0
	cpc R16,R17
	brne L41
X18:
;                 fprintf_P(stream, PSTR("500 Internal error\n"));
	ldi R18,<L38
	ldi R19,>L38
	ldd R16,y+30
	ldd R17,y+31
	xcall _fprintf_P
;                 DestroyRequestInfo(req);
	movw R16,R10
	xcall _DestroyRequestInfo
;                 return;
	xjmp L29
L41:
;             }
;             strcpy(req->req_agent, orig_req->req_agent);
	ldd R30,y+36
	ldd R31,y+37
	ldd R18,z+16
	ldd R19,z+17
	movw R30,R10
	ldd R16,z+16
	ldd R17,z+17
	xcall _strcpy
;         }
L39:
;         if (orig_req->req_cookie!= NULL) {
	ldd R30,y+36
	ldd R31,y+37
	ldd R2,z+12
	ldd R3,z+13
	tst R2
	brne X19
	tst R3
	breq L43
X19:
;             if ((req->req_cookie = NutHeapAlloc((strlen(orig_req->req_cookie) + 1))) == 0) {
	ldd R16,z+12
	ldd R17,z+13
	xcall _strlen
	subi R16,255  ; offset = 1
	sbci R17,255
	xcall _NutHeapAlloc
	movw R12,R16
	movw R30,R10
	std z+13,R13
	std z+12,R12
	cpi R16,0
	cpc R16,R17
	brne L45
X20:
;                 fprintf_P(stream, PSTR("500 Internal error\n"));
	ldi R18,<L38
	ldi R19,>L38
	ldd R16,y+30
	ldd R17,y+31
	xcall _fprintf_P
;                 DestroyRequestInfo(req);
	movw R16,R10
	xcall _DestroyRequestInfo
;                 return;
	xjmp L29
L45:
;             }
;             strcpy(req->req_cookie, orig_req->req_cookie);
	ldd R30,y+36
	ldd R31,y+37
	ldd R18,z+12
	ldd R19,z+13
	movw R30,R10
	ldd R16,z+12
	ldd R17,z+13
	xcall _strcpy
;         }
L43:
;         if ((cp = strchr(url, '?')) != 0) {
	ldi R18,63
	ldi R19,0
	ldd R16,y+32
	ldd R17,y+33
	xcall _strchr
	movw R14,R16
	movw R12,R14
	cpi R16,0
	cpc R16,R17
	breq L47
X21:
;             *cp++ = 0;
	clr R2
	movw R30,R12
	st Z+,R2
	movw R12,R30
;             if ((req->req_query = NutHeapAlloc(strlen(cp) + 1)) == 0) {
	movw R16,R30
	xcall _strlen
	subi R16,255  ; offset = 1
	sbci R17,255
	xcall _NutHeapAlloc
	movw R14,R16
	movw R30,R10
	std z+9,R15
	std z+8,R14
	cpi R16,0
	cpc R16,R17
	brne L49
X22:
;                 fprintf_P(stream, PSTR("500 Internal error\n"));
	ldi R18,<L38
	ldi R19,>L38
	ldd R16,y+30
	ldd R17,y+31
	xcall _fprintf_P
;                 DestroyRequestInfo(req);
	movw R16,R10
	xcall _DestroyRequestInfo
;                 return;
	xjmp L29
L49:
;             }
;             strcpy(req->req_query, cp);
	movw R18,R12
	movw R30,R10
	ldd R16,z+8
	ldd R17,z+9
	xcall _strcpy
;     
;             NutHttpProcessQueryString(req);
	movw R16,R10
	xcall _NutHttpProcessQueryString
;         }
L47:
;         if ((req->req_url = NutHeapAlloc(strlen(url) + 1)) == 0) {
	ldd R16,y+32
	ldd R17,y+33
	xcall _strlen
	subi R16,255  ; offset = 1
	sbci R17,255
	xcall _NutHeapAlloc
	movw R12,R16
	movw R30,R10
	std z+7,R13
	std z+6,R12
	cpi R16,0
	cpc R16,R17
	brne L51
X23:
;             fprintf_P(stream, PSTR("500 Internal error\n"));
	ldi R18,<L38
	ldi R19,>L38
	ldd R16,y+30
	ldd R17,y+31
	xcall _fprintf_P
;             DestroyRequestInfo(req);
	movw R16,R10
	xcall _DestroyRequestInfo
;             return;
	xjmp L29
L51:
;         }
;         strcpy(req->req_url, url);
	ldd R18,y+32
	ldd R19,y+33
	movw R30,R10
	ldd R16,z+6
	ldd R17,z+7
	xcall _strcpy
; 
;         NutCgiProcessRequest(stream, req);
	movw R18,R10
	ldd R16,y+30
	ldd R17,y+31
	xcall _NutCgiProcessRequest
;         DestroyRequestInfo(req);
	movw R16,R10
	xcall _DestroyRequestInfo
;         return;
	xjmp L29
L33:
;     }
;     
;     /*
;      * Process file.
;      */
;     if (http_root) {
	ldd R0,y+34
	ldd R1,y+35
	tst R0
	brne X24
	tst R1
	breq L53
X24:
;         filename = NutHeapAlloc(strlen(http_root) + strlen(url) + 1);
	movw R16,R0
	xcall _strlen
	movw R12,R16
	ldd R16,y+32
	ldd R17,y+33
	xcall _strlen
	movw R10,R16
	movw R16,R12
	add R16,R10
	adc R17,R11
	subi R16,255  ; offset = 1
	sbci R17,255
	xcall _NutHeapAlloc
	movw R10,R16
	std y+11,R11
	std y+10,R10
;         strcpy(filename, http_root);
	ldd R18,y+34
	ldd R19,y+35
	xcall _strcpy
;     } else {
	xjmp L54
L53:
;         filename = NutHeapAlloc(strlen(url) + 6);
	ldd R16,y+32
	ldd R17,y+33
	xcall _strlen
	subi R16,250  ; offset = 6
	sbci R17,255
	xcall _NutHeapAlloc
	movw R10,R16
	std y+11,R11
	std y+10,R10
;         strcpy(filename, "UROM:");
	ldi R18,<L55
	ldi R19,>L55
	xcall _strcpy
;     }
L54:
;     
;     strcat(filename, url);
	ldd R18,y+32
	ldd R19,y+33
	ldd R16,y+10
	ldd R17,y+11
	xcall _strcat
; 
;     handler = NutGetMimeHandler(filename);
	ldd R16,y+10
	ldd R17,y+11
	xcall _NutGetMimeHandler
	movw R10,R16
	std y+17,R11
	std y+16,R10
; 
;     fd = _open(filename, _O_BINARY | _O_RDONLY);
	ldi R18,32768
	ldi R19,128
	ldd R16,y+10
	ldd R17,y+11
	xcall __open
	movw R10,R16
	std y+13,R11
	std y+12,R10
;     NutHeapFree(filename);
	ldd R16,y+10
	ldd R17,y+11
	xcall _NutHeapFree
;     if (fd == -1) {                     // Search for index.html
	ldd R24,y+12
	ldd R25,y+13
	cpi R24,255
	ldi R30,255
	cpc R25,R30
	breq X44
	xjmp L56
X44:
X25:
;         u_char *index;
;         u_short urll;
; 
; 
;         urll = strlen(url);
	ldd R16,y+32
	ldd R17,y+33
	xcall _strlen
	movw R10,R16
	std y+19,R11
	std y+18,R10
;         if ((index = NutHeapAllocClear(urll + 12)) == 0) {
	subi R16,244  ; offset = 12
	sbci R17,255
	xcall _NutHeapAllocClear
	movw R10,R16
	movw R12,R10
	cpi R16,0
	cpc R16,R17
	brne L58
X26:
;             fprintf_P(stream, PSTR("500 Internal error\n"));
	ldi R18,<L38
	ldi R19,>L38
	ldd R16,y+30
	ldd R17,y+31
	xcall _fprintf_P
;             return;
	xjmp L29
L58:
;         }
;         if (urll)
	ldd R0,y+18
	ldd R1,y+19
	tst R0
	brne X27
	tst R1
	breq L60
X27:
;             strcpy(index, url);
	ldd R18,y+32
	ldd R19,y+33
	movw R16,R12
	xcall _strcpy
L60:
;         if (urll && index[urll - 1] != '/')
	ldd R0,y+18
	ldd R1,y+19
	tst R0
	brne X28
	tst R1
	breq L62
X28:
	movw R30,R0
	sbiw R30,1
	add R30,R12
	adc R31,R13
	ldd R24,z+0
	cpi R24,47
	breq L62
X29:
;             strcat(index, "/");
	ldi R18,<L64
	ldi R19,>L64
	movw R16,R12
	xcall _strcat
L62:
;         strcat(index, "index.html");
	ldi R18,<L65
	ldi R19,>L65
	movw R16,R12
	xcall _strcat
; 
;         if (http_root) {
	ldd R0,y+34
	ldd R1,y+35
	tst R0
	brne X30
	tst R1
	breq L66
X30:
;             filename = NutHeapAlloc(strlen(http_root) + strlen(index) + 1);
	movw R16,R0
	xcall _strlen
	movw R10,R16
	movw R16,R12
	xcall _strlen
	movw R14,R16
	movw R16,R10
	add R16,R14
	adc R17,R15
	subi R16,255  ; offset = 1
	sbci R17,255
	xcall _NutHeapAlloc
	movw R14,R16
	std y+11,R15
	std y+10,R14
;             strcpy(filename, http_root);
	ldd R18,y+34
	ldd R19,y+35
	xcall _strcpy
;         } else {
	xjmp L67
L66:
;             filename = NutHeapAlloc(strlen(index) + 6);
	movw R16,R12
	xcall _strlen
	subi R16,250  ; offset = 6
	sbci R17,255
	xcall _NutHeapAlloc
	movw R14,R16
	std y+11,R15
	std y+10,R14
;             strcpy(filename, "UROM:");
	ldi R18,<L55
	ldi R19,>L55
	xcall _strcpy
;         }
L67:
;         strcat(filename, index);
	movw R18,R12
	ldd R16,y+10
	ldd R17,y+11
	xcall _strcat
; 
;         NutHeapFree(index);
	movw R16,R12
	xcall _NutHeapFree
; 
;         handler = NutGetMimeHandler(filename);
	ldd R16,y+10
	ldd R17,y+11
	xcall _NutGetMimeHandler
	movw R14,R16
	std y+17,R15
	std y+16,R14
; 
;         fd = _open(filename, _O_BINARY | _O_RDONLY);
	ldi R18,32768
	ldi R19,128
	ldd R16,y+10
	ldd R17,y+11
	xcall __open
	movw R14,R16
	std y+13,R15
	std y+12,R14
;         NutHeapFree(filename);
	ldd R16,y+10
	ldd R17,y+11
	xcall _NutHeapFree
;         if (fd == -1) {                 // We have no index.html. But perhaps an index.shtml?
	ldd R24,y+12
	ldd R25,y+13
	cpi R24,255
	ldi R30,255
	cpc R25,R30
	breq X45
	xjmp L68
X45:
X31:
;             urll = strlen(url);
	ldd R16,y+32
	ldd R17,y+33
	xcall _strlen
	movw R14,R16
	std y+19,R15
	std y+18,R14
;             if ((index = NutHeapAllocClear(urll + 13)) == 0) {
	subi R16,243  ; offset = 13
	sbci R17,255
	xcall _NutHeapAllocClear
	movw R14,R16
	movw R12,R14
	cpi R16,0
	cpc R16,R17
	brne L70
X32:
;                 fprintf_P(stream, PSTR("500 Internal error\n"));
	ldi R18,<L38
	ldi R19,>L38
	ldd R16,y+30
	ldd R17,y+31
	xcall _fprintf_P
;                 return;
	xjmp L29
L70:
;             }
;             if (urll)
	ldd R0,y+18
	ldd R1,y+19
	tst R0
	brne X33
	tst R1
	breq L72
X33:
;                 strcpy(index, url);
	ldd R18,y+32
	ldd R19,y+33
	movw R16,R12
	xcall _strcpy
L72:
;             if (urll && index[urll - 1] != '/')
	ldd R0,y+18
	ldd R1,y+19
	tst R0
	brne X34
	tst R1
	breq L74
X34:
	movw R30,R0
	sbiw R30,1
	add R30,R12
	adc R31,R13
	ldd R24,z+0
	cpi R24,47
	breq L74
X35:
;                 strcat(index, "/");
	ldi R18,<L64
	ldi R19,>L64
	movw R16,R12
	xcall _strcat
L74:
;             strcat(index, "index.shtml");
	ldi R18,<L76
	ldi R19,>L76
	movw R16,R12
	xcall _strcat
;     
;             if (http_root) {
	ldd R0,y+34
	ldd R1,y+35
	tst R0
	brne X36
	tst R1
	breq L77
X36:
;                 filename = NutHeapAlloc(strlen(http_root) + strlen(index) + 1);
	movw R16,R0
	xcall _strlen
	movw R10,R16
	movw R16,R12
	xcall _strlen
	movw R14,R16
	movw R16,R10
	add R16,R14
	adc R17,R15
	subi R16,255  ; offset = 1
	sbci R17,255
	xcall _NutHeapAlloc
	movw R14,R16
	std y+11,R15
	std y+10,R14
;                 strcpy(filename, http_root);
	ldd R18,y+34
	ldd R19,y+35
	xcall _strcpy
;             } else {
	xjmp L78
L77:
;                 filename = NutHeapAlloc(strlen(index) + 6);
	movw R16,R12
	xcall _strlen
	subi R16,250  ; offset = 6
	sbci R17,255
	xcall _NutHeapAlloc
	movw R14,R16
	std y+11,R15
	std y+10,R14
;                 strcpy(filename, "UROM:");
	ldi R18,<L55
	ldi R19,>L55
	xcall _strcpy
;             }
L78:
;             strcat(filename, index);
	movw R18,R12
	ldd R16,y+10
	ldd R17,y+11
	xcall _strcat
;     
;             NutHeapFree(index);
	movw R16,R12
	xcall _NutHeapFree
; 
;             handler = NutGetMimeHandler(filename);
	ldd R16,y+10
	ldd R17,y+11
	xcall _NutGetMimeHandler
	movw R12,R16
	std y+17,R13
	std y+16,R12
; 
;             fd = _open(filename, _O_BINARY | _O_RDONLY);
	ldi R18,32768
	ldi R19,128
	ldd R16,y+10
	ldd R17,y+11
	xcall __open
	movw R12,R16
	std y+13,R13
	std y+12,R12
;             NutHeapFree(filename);
	ldd R16,y+10
	ldd R17,y+11
	xcall _NutHeapFree
;             if (fd == -1) {            // Non of both found... send a 404
	ldd R24,y+12
	ldd R25,y+13
	cpi R24,255
	ldi R30,255
	cpc R25,R30
	brne L79
X37:
;                 fprintf_P(stream, PSTR("404 Not found: %s\n"), filename);
	ldd R0,y+10
	ldd R1,y+11
	std y+1,R1
	std y+0,R0
	ldi R18,<L4
	ldi R19,>L4
	ldd R16,y+30
	ldd R17,y+31
	xcall _fprintf_P
;                 return;
	xjmp L29
L79:
;             }
;         }
L68:
;     }
L56:
;     
;     file_len = _filelength(fd);
	ldd R16,y+12
	ldd R17,y+13
	xcall __filelength
	std y+6,R16
	std y+7,R17
	std y+8,R18
	std y+9,R19
;     
;     if (handler == NULL) {
	ldd R0,y+16
	ldd R1,y+17
	tst R0
	breq X46
	xjmp L81
X46:
	tst R1
	breq X47
	xjmp L81
X47:
X38:
;         size = 512;                 // If we have not registered a mime handler handle default.
	ldi R24,512
	ldi R25,2
	std y+15,R25
	std y+14,R24
;         if ((data = NutHeapAlloc(size)) != 0) {
	movw R16,R24
	xcall _NutHeapAlloc
	movw R10,R16
	movw R14,R10
	cpi R16,0
	cpc R16,R17
	brne X48
	xjmp L82
X48:
X39:
	xjmp L86
L85:
;             while (file_len) {
;                 if (file_len < 512L)
	ldi R20,0
	ldi R21,2
	ldi R22,0
	ldi R23,0
	ldd R2,y+6
	ldd R3,y+7
	ldd R4,y+8
	ldd R5,y+9
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brge L88
X40:
;                     size = (int) file_len;
	std y+15,R3
	std y+14,R2
L88:
; 
;                 n = _read(fd, data, size);
	ldd R0,y+14
	ldd R1,y+15
	std y+1,R1
	std y+0,R0
	movw R18,R14
	ldd R16,y+12
	ldd R17,y+13
	xcall __read
	movw R10,R16
;                 if (fwrite(data, 1, n, stream) == 0)
	ldd R0,y+30
	ldd R1,y+31
	std y+3,R1
	std y+2,R0
	std y+1,R11
	std y+0,R10
	ldi R18,1
	ldi R19,0
	movw R16,R14
	xcall _fwrite
	movw R12,R16
	cpi R16,0
	cpc R16,R17
	brne L90
X41:
;                     break;
	xjmp L87
L90:
;                 file_len -= (long) n;
	movw R2,R10
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	ldd R6,y+6
	ldd R7,y+7
	ldd R8,y+8
	ldd R9,y+9
	sub R6,R2
	sbc R7,R3
	sbc R8,R4
	sbc R9,R5
	std y+6,R6
	std y+7,R7
	std y+8,R8
	std y+9,R9
;             }
L86:
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R2,y+6
	ldd R3,y+7
	ldd R4,y+8
	ldd R5,y+9
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	breq X49
	xjmp L85
X49:
X42:
L87:
;             NutHeapFree(data);
	movw R16,R14
	xcall _NutHeapFree
;         }
;     } else handler(stream, fd, file_len, http_root, orig_req);
	xjmp L82
L81:
	ldd R0,y+36
	ldd R1,y+37
	std y+5,R1
	std y+4,R0
	ldd R0,y+34
	ldd R1,y+35
	std y+3,R1
	std y+2,R0
	ldd R2,y+6
	ldd R3,y+7
	std y+1,R3
	std y+0,R2
	ldd R18,y+12
	ldd R19,y+13
	ldd R16,y+30
	ldd R17,y+31
	ldd R30,y+16
	ldd R31,y+17
	xcall  xicall
L82:
;     _close(fd);
	ldd R16,y+12
	ldd R17,y+13
	xcall __close
L29:
	.dbline 0 ; func end
	adiw R28,20
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
;            end -> y+0
;            pos -> R18,R19
;         buffer -> R16,R17
	.even
_NutSsiSkipWhitespace:
; }
; 
; /*!
;  * \brief Skip whitespaces in a string from the given position on
;  *
;  * Whitespaces are defined as \n \r \t and space. Pos will be set to the first charachter which is not a whitespace
;  *
;  * \param buffer String to work on
;  * \param pos    Start position of the search
;  * \param end    last position we should check for
;  * \return       Nothing. pos is set to the first character which is not a white space
;  */
; 
; 
; static void NutSsiSkipWhitespace(char *buffer, u_short *pos, u_short end)
; {
	xjmp L94
L93:
;     while ((*pos < end) && (
;            (buffer[*pos] == '\n') || (buffer[*pos] == '\r') ||
;            (buffer[*pos] == '\t') || (buffer[*pos] == ' ')))
;         (*pos) ++;
	movw R30,R18
	ldd R24,z+0
	ldd R25,z+1
	adiw R24,1
	std z+1,R25
	std z+0,R24
L94:
	movw R30,R18
	ldd R2,z+0
	ldd R3,z+1
	ldd R0,y+0
	ldd R1,y+1
	cp R2,R0
	cpc R3,R1
	brsh L96
X50:
	movw R30,R2
	add R30,R16
	adc R31,R17
	ldd R2,z+0
	clr R3
	mov R24,R2
	cpi R24,10
	breq L93
X51:
	cpi R24,13
	breq L93
X52:
	cpi R24,9
	breq L93
X53:
	cpi R24,32
	breq L93
X54:
L96:
L92:
	.dbline 0 ; func end
	ret
;       filename -> R12,R13
;           type -> R22
;            pos -> y+4
;            req -> R20,R21
;      http_root -> R14,R15
;            end -> R10,R11
;         buffer -> y+18
;         stream -> y+16
	.even
_NutSsiCheckForSsi:
	xcall push_arg4
	xcall push_xgsetF0FC
	sbiw R28,6
	ldd R10,y+20
	ldd R11,y+21
	ldd R14,y+22
	ldd R15,y+23
	ldd R20,y+24
	ldd R21,y+25
; }
; 
; /*!
;  * \brief Check if a comment is a ssi directive 
;  *
;  * Check if a comment is a ssi directive and replace the directive by the included data.
;  * Allowed diretives are:
;  * 
;  * <!--#include virtual="/news/news.htm" -->
;  * <!--#include file="UROM:/news/news.htm" -->
;  * <!--#exec cgi="/cgi-bin/counter.cgi" --> 
;  * 
;  * \param stream Stream of the socket connection, previously opened for 
;  *               binary read and write.
;  * \param buffer Current file buffer so search in. The buffer is set to the start of a html comment
;  * \param end    End position of the comment.
;  * \param http_root The root path of the http-deamon
;  * \param req    The http request struct of the top most http_request
;  */
; 
; static u_char NutSsiCheckForSsi(FILE *stream, char *buffer, u_short end, u_char* http_root, REQUEST *req)
; {
;     u_short pos = 4; // First character after comment start
	ldi R24,4
	ldi R25,0
	std y+5,R25
	std y+4,R24
;     u_char * filename;
;     u_char type;
; 
;     pos = 4;
	std y+5,R25
	std y+4,R24
;     NutSsiSkipWhitespace(buffer, &pos, end);        // Skip whitespaces after comment start
	std y+1,R11
	std y+0,R10
	movw R18,R28
	subi R18,252  ; offset = 4
	sbci R19,255
	ldd R16,y+18
	ldd R17,y+19
	xcall _NutSsiSkipWhitespace
;     if (pos == end) return 0;
	ldd R2,y+4
	ldd R3,y+5
	cp R2,R10
	cpc R3,R11
	brne L98
X55:
	clr R16
	xjmp L97
L98:
;     
;     if (strncasecmp(&buffer[pos], "#include", 8) == 0) { // Search include directive
	ldi R24,8
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<L102
	ldi R19,>L102
	ldd R16,y+4
	ldd R17,y+5
	ldd R0,y+18
	ldd R1,y+19
	add R16,R0
	adc R17,R1
	xcall _strncmp
	cpi R16,0
	cpc R16,R17
	brne L100
X56:
;         pos += 8;
	ldd R24,y+4
	ldd R25,y+5
	adiw R24,8
	std y+5,R25
	std y+4,R24
;         type = SSI_TYPE_VIRTUAL;
	ldi R22,2
;     } else 
	xjmp L101
L100:
;     if (strncasecmp(&buffer[pos], "#exec", 5) == 0) { // Search include or exec directive
	ldi R24,5
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<L105
	ldi R19,>L105
	ldd R16,y+4
	ldd R17,y+5
	ldd R0,y+18
	ldd R1,y+19
	add R16,R0
	adc R17,R1
	xcall _strncmp
	cpi R16,0
	cpc R16,R17
	brne L103
X57:
;         pos += 5;
	ldd R24,y+4
	ldd R25,y+5
	adiw R24,5
	std y+5,R25
	std y+4,R24
;         type = SSI_TYPE_EXEC;
	ldi R22,3
;     } else return 0;                                // No include or exec found. Skip the rest of this comment...
	xjmp L104
L103:
	clr R16
	xjmp L97
L104:
L101:
;     if (pos >= end) return 0;
	ldd R2,y+4
	ldd R3,y+5
	cp R2,R10
	cpc R3,R11
	brlo L106
X58:
	clr R16
	xjmp L97
L106:
; 
;     NutSsiSkipWhitespace(buffer, &pos, end);        // Skip whitespaces after #include directive
	std y+1,R11
	std y+0,R10
	movw R18,R28
	subi R18,252  ; offset = 4
	sbci R19,255
	ldd R16,y+18
	ldd R17,y+19
	xcall _NutSsiSkipWhitespace
;     if (pos == end) return 0;
	ldd R2,y+4
	ldd R3,y+5
	cp R2,R10
	cpc R3,R11
	brne L108
X59:
	clr R16
	xjmp L97
L108:
;     
;     if (type == SSI_TYPE_VIRTUAL) {
	cpi R22,2
	brne L110
X60:
;         if (strncasecmp(&buffer[pos], "virtual", 7) == 0) {  // Search virtual directive
	ldi R24,7
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<L114
	ldi R19,>L114
	ldd R16,y+4
	ldd R17,y+5
	ldd R0,y+18
	ldd R1,y+19
	add R16,R0
	adc R17,R1
	xcall _strncmp
	movw R12,R16
	cpi R16,0
	cpc R16,R17
	brne L112
X61:
;             pos += 7;
	ldd R24,y+4
	ldd R25,y+5
	adiw R24,7
	std y+5,R25
	std y+4,R24
;         } else                                      // No virtual found. Test for file...
	xjmp L111
L112:
;         if (strncasecmp(&buffer[pos], "file", 4) == 0) {  // Search file directive
	ldi R24,4
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<L117
	ldi R19,>L117
	ldd R16,y+4
	ldd R17,y+5
	ldd R0,y+18
	ldd R1,y+19
	add R16,R0
	adc R17,R1
	xcall _strncmp
	movw R12,R16
	cpi R16,0
	cpc R16,R17
	brne L115
X62:
;             pos += 4;
	ldd R24,y+4
	ldd R25,y+5
	adiw R24,4
	std y+5,R25
	std y+4,R24
;             type = SSI_TYPE_FILE;
	ldi R22,1
;         } else return 0;                            // No file found. Test for file...
	xjmp L111
L115:
	clr R16
	xjmp L97
L110:
;     } else {
;         if (strncasecmp(&buffer[pos], "cgi", 3) == 0) {  // Search cgi directive
	ldi R24,3
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<L120
	ldi R19,>L120
	ldd R16,y+4
	ldd R17,y+5
	ldd R0,y+18
	ldd R1,y+19
	add R16,R0
	adc R17,R1
	xcall _strncmp
	movw R12,R16
	cpi R16,0
	cpc R16,R17
	brne L118
X63:
;             pos += 3;
	ldd R24,y+4
	ldd R25,y+5
	adiw R24,3
	std y+5,R25
	std y+4,R24
;         } else return 0;                            // No cgi found. return...
	xjmp L119
L118:
	clr R16
	xjmp L97
L119:
;     }
L111:
;     if (pos >= end) return 0;
	ldd R2,y+4
	ldd R3,y+5
	cp R2,R10
	cpc R3,R11
	brlo L121
X64:
	clr R16
	xjmp L97
L121:
;     
;     NutSsiSkipWhitespace(buffer, &pos, end);        // Skip whitespaces after virtual, file or cgi directive
	std y+1,R11
	std y+0,R10
	movw R18,R28
	subi R18,252  ; offset = 4
	sbci R19,255
	ldd R16,y+18
	ldd R17,y+19
	xcall _NutSsiSkipWhitespace
;     if (pos == end) return 0;
	ldd R2,y+4
	ldd R3,y+5
	cp R2,R10
	cpc R3,R11
	brne L123
X65:
	clr R16
	xjmp L97
L123:
; 
;     if (buffer[pos] != '=') return 0;               // check for assertion
	ldd R30,y+4
	ldd R31,y+5
	ldd R0,y+18
	ldd R1,y+19
	add R30,R0
	adc R31,R1
	ldd R24,z+0
	cpi R24,61
	breq L125
X66:
	clr R16
	xjmp L97
L125:
;     pos ++; 
	ldd R24,y+4
	ldd R25,y+5
	adiw R24,1
	std y+5,R25
	std y+4,R24
; 
;     NutSsiSkipWhitespace(buffer, &pos, end);        // Skip whitespaces after assertion
	std y+1,R11
	std y+0,R10
	movw R18,R28
	subi R18,252  ; offset = 4
	sbci R19,255
	ldd R16,y+18
	ldd R17,y+19
	xcall _NutSsiSkipWhitespace
;     if (pos == end) return 0;    
	ldd R2,y+4
	ldd R3,y+5
	cp R2,R10
	cpc R3,R11
	brne L127
X67:
	clr R16
	xjmp L97
L127:
;     
;     if (buffer[pos] == '"') {                       // Search for filename and pass to output function
	ldd R30,y+4
	ldd R31,y+5
	ldd R0,y+18
	ldd R1,y+19
	add R30,R0
	adc R31,R1
	ldd R24,z+0
	cpi R24,34
	breq X75
	xjmp L129
X75:
X68:
;         pos ++;
	ldd R24,y+4
	ldd R25,y+5
	adiw R24,1
	std y+5,R25
	std y+4,R24
;         if (pos == end) return 0;
	cp R24,R10
	cpc R25,R11
	brne L131
X69:
	clr R16
	xjmp L97
L131:
;         filename = &buffer[pos];
	ldd R12,y+4
	ldd R13,y+5
	ldd R0,y+18
	ldd R1,y+19
	add R12,R0
	adc R13,R1
	xjmp L134
L133:
;         while (buffer[pos] != '"') {
;             pos ++;
	ldd R24,y+4
	ldd R25,y+5
	adiw R24,1
	std y+5,R25
	std y+4,R24
;             if (pos == end) return 0;
	cp R24,R10
	cpc R25,R11
	brne L136
X70:
	clr R16
	xjmp L97
L136:
;         }
L134:
	ldd R30,y+4
	ldd R31,y+5
	ldd R0,y+18
	ldd R1,y+19
	add R30,R0
	adc R31,R1
	ldd R24,z+0
	cpi R24,34
	brne L133
X71:
;         buffer[pos] = '\0';
	ldd R30,y+4
	ldd R31,y+5
	add R30,R0
	adc R31,R1
	clr R2
	std z+0,R2
;         switch (type) {
	clr R23
	cpi R22,1
	ldi R30,0
	cpc R23,R30
	breq L141
X72:
	cpi R22,2
	ldi R30,0
	cpc R23,R30
	breq L142
X73:
	cpi R22,3
	ldi R30,0
	cpc R23,R30
	breq L143
X74:
	xjmp L138
L141:
;             case SSI_TYPE_FILE:
;                 NutSsiProcessFile(stream, filename);
	movw R18,R12
	ldd R16,y+16
	ldd R17,y+17
	xcall _NutSsiProcessFile
;                 break;
	xjmp L139
L142:
;             case SSI_TYPE_VIRTUAL:
;                 NutSsiProcessVirtual(stream, filename, http_root, req);
	std y+3,R21
	std y+2,R20
	std y+1,R15
	std y+0,R14
	movw R18,R12
	ldd R16,y+16
	ldd R17,y+17
	xcall _NutSsiProcessVirtual
;                 break;
	xjmp L139
L143:
;             case SSI_TYPE_EXEC:
;                 NutSsiProcessVirtual(stream, filename, http_root, req);
	std y+3,R21
	std y+2,R20
	std y+1,R15
	std y+0,R14
	movw R18,R12
	ldd R16,y+16
	ldd R17,y+17
	xcall _NutSsiProcessVirtual
;                 break;
L138:
L139:
;         }
;     }
L129:
;     return 1;
	ldi R16,1
L97:
	.dbline 0 ; func end
	adiw R28,6
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
;          found -> R14
;     in_comment -> y+10
;          index -> R20,R21
;              n -> R22,R23
;           fpos -> R12,R13
;         buffer -> y+8
;       buffsize -> y+6
;            req -> y+29
;      http_root -> y+27
;       file_len -> y+25
;             fd -> y+23
;         stream -> y+21
	.even
_NutHttpProcessSHTML:
	xcall push_arg4
	xcall push_xgsetF0FC
	sbiw R28,11
; }
; 
; /*!
;  * \brief Check a file for html comments 
;  *
;  * Check a file for html comments and then call NutSsiCheckForSsi to seach a ssi directive
;  * Allowed diretives are:
;  * 
;  * <!--#include virtual="/news/news.htm" -->
;  * <!--#include file="UROM:/news/news.htm" -->
;  * <!--#exec cgi="/cgi-bin/counter.cgi" --> 
;  * 
;  * \param stream Stream of the socket connection, previously opened for 
;  *               binary read and write.
;  * \param fd     Filedescriptor pointing to a just opened file.
;  * \param file_len length of this file
;  * \param http_root The root path of the http-deamon
;  * \param req    The http request struct of the top most http_request
;  */
; 
; 
; static void NutHttpProcessSHTML(FILE * stream, int fd, int file_len, u_char* http_root, REQUEST *req)
; {
;     u_char * buffer;
;     u_char in_comment;
;     int buffsize;
;     int fpos;
;     int n;
;     u_char *index;
;     u_char found;
;     buffsize = MIN(BUFSIZE, file_len);
	ldi R24,512
	ldi R25,2
	ldd R0,y+25
	ldd R1,y+26
	cp R24,R0
	cpc R25,R1
	brge L145
X76:
	ldi R20,512
	ldi R21,2
	xjmp L146
L145:
	ldd R20,y+25
	ldd R21,y+26
L146:
	std y+7,R21
	std y+6,R20
;     buffer = NutHeapAlloc(buffsize+1);
	movw R16,R20
	subi R16,255  ; offset = 1
	sbci R17,255
	xcall _NutHeapAlloc
	std y+9,R17
	std y+8,R16
;     in_comment = 0;
	clr R0
	std y+10,R0
;     fpos = 0;
	clr R12
	clr R13
	xjmp L148
L147:
;     while (file_len != fpos) {
;         memset(buffer, 0, buffsize+1);
	ldd R24,y+6
	ldd R25,y+7
	adiw R24,1
	std y+1,R25
	std y+0,R24
	clr R18
	clr R19
	ldd R16,y+8
	ldd R17,y+9
	xcall _memset
;         n = _read(fd, buffer, MIN(buffsize, file_len-fpos));
	ldd R2,y+25
	ldd R3,y+26
	sub R2,R12
	sbc R3,R13
	ldd R0,y+6
	ldd R1,y+7
	cp R0,R2
	cpc R1,R3
	brge L150
X77:
	movw R10,R0
	xjmp L151
L150:
	ldd R10,y+25
	ldd R11,y+26
	sub R10,R12
	sbc R11,R13
L151:
	std y+1,R11
	std y+0,R10
	ldd R18,y+8
	ldd R19,y+9
	ldd R16,y+23
	ldd R17,y+24
	xcall __read
	movw R22,R16
;         
;         if (!in_comment) {        
	ldd R0,y+10
	tst R0
	breq X88
	xjmp L152
X88:
X78:
;             
;             index = strstr(buffer, "<!--");
	ldi R18,<L154
	ldi R19,>L154
	ldd R16,y+8
	ldd R17,y+9
	xcall _strstr
	movw R10,R16
	movw R20,R10
;             if (index == NULL) {                    // Nothing found. print next 412 characters, seek to next startpoint.
	cpi R16,0
	cpc R16,R17
	breq X89
	xjmp L155
X89:
X79:
;                 if (file_len > buffsize) {
	ldd R0,y+6
	ldd R1,y+7
	ldd R16,y+25
	ldd R17,y+26
	cp R0,R16
	cpc R1,R17
	brlt X90
	xjmp L157
X90:
X80:
;                     fwrite(buffer, 1, MIN(buffsize-100, n), stream);
	ldd R0,y+21
	ldd R1,y+22
	std y+3,R1
	std y+2,R0
	ldd R24,y+6
	ldd R25,y+7
	subi R24,100
	sbci R25,0
	cp R24,R22
	cpc R25,R23
	brge L159
X81:
	ldd R24,y+6
	ldd R25,y+7
	subi R24,100
	sbci R25,0
	movw R10,R24
	xjmp L160
L159:
	movw R10,R22
L160:
	std y+1,R11
	std y+0,R10
	ldi R18,1
	ldi R19,0
	ldd R16,y+8
	ldd R17,y+9
	xcall _fwrite
;                     fpos += MIN(buffsize-100, n);
	ldd R24,y+6
	ldd R25,y+7
	subi R24,100
	sbci R25,0
	cp R24,R22
	cpc R25,R23
	brge L161
X82:
	ldd R24,y+6
	ldd R25,y+7
	subi R24,100
	sbci R25,0
	movw R10,R24
	xjmp L162
L161:
	movw R10,R22
L162:
	add R12,R10
	adc R13,R11
;                     _seek(fd, fpos, SEEK_SET);
	clr R2
	clr R3
	std y+3,R3
	std y+2,R2
	movw R2,R12
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldd R16,y+23
	ldd R17,y+24
	xcall __seek
;                 } else {
	xjmp L153
L157:
;                     fwrite(buffer, 1, n, stream);
	ldd R0,y+21
	ldd R1,y+22
	std y+3,R1
	std y+2,R0
	std y+1,R23
	std y+0,R22
	ldi R18,1
	ldi R19,0
	ldd R16,y+8
	ldd R17,y+9
	xcall _fwrite
;                     fpos += n;
	add R12,R22
	adc R13,R23
;                 }
;                 
;             } else {
	xjmp L153
L155:
;                 found = (int)index - (int)buffer;   // We have found a comment initializer. Seek to the startpoint and print the beginning of the buffer.
	mov R14,R20
	ldd R0,y+8
	ldd R1,y+9
	sub R14,R0
	sbc R15,R1
;                 fwrite (buffer, 1, found, stream);
	ldd R0,y+21
	ldd R1,y+22
	std y+3,R1
	std y+2,R0
	mov R2,R14
	clr R3
	std y+1,R3
	std y+0,R2
	ldi R18,1
	ldi R19,0
	ldd R16,y+8
	ldd R17,y+9
	xcall _fwrite
;                 fpos += found;
	mov R2,R14
	clr R3
	add R12,R2
	adc R13,R3
;                 _seek(fd, fpos, SEEK_SET);
	clr R2
	std y+3,R3
	std y+2,R2
	movw R2,R12
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldd R16,y+23
	ldd R17,y+24
	xcall __seek
;                 in_comment = 1;
	clr R0
	inc R0
	std y+10,R0
;             }
;         } else {                                    // Ok, we assume we are "into" a comment.    
	xjmp L153
L152:
;             index = strstr(buffer, "-->");
	ldi R18,<L163
	ldi R19,>L163
	ldd R16,y+8
	ldd R17,y+9
	xcall _strstr
	movw R10,R16
	movw R20,R10
;             if (index == NULL) {                    // We have not found the end of the comment in the next 512 characters. Byepass this comment.
	cpi R16,0
	cpc R16,R17
	brne L164
X83:
;                 fwrite(buffer, 1, MIN(buffsize, n), stream);
	ldd R0,y+21
	ldd R1,y+22
	std y+3,R1
	std y+2,R0
	ldd R0,y+6
	ldd R1,y+7
	cp R0,R22
	cpc R1,R23
	brge L166
X84:
	movw R10,R0
	xjmp L167
L166:
	movw R10,R22
L167:
	std y+1,R11
	std y+0,R10
	ldi R18,1
	ldi R19,0
	ldd R16,y+8
	ldd R17,y+9
	xcall _fwrite
;                 fpos += MIN(buffsize, n);
	ldd R0,y+6
	ldd R1,y+7
	cp R0,R22
	cpc R1,R23
	brge L168
X85:
	movw R10,R0
	xjmp L169
L168:
	movw R10,R22
L169:
	add R12,R10
	adc R13,R11
;                 in_comment = 0;
	clr R0
	std y+10,R0
;             } else {                                // Ok. This seems to be a comment with maximum length of 512 bytes. We now search for ssi code.    
	xjmp L165
L164:
;                 found = (int)index - (int)buffer;
	mov R14,R20
	ldd R0,y+8
	ldd R1,y+9
	sub R14,R0
	sbc R15,R1
;                 if (!NutSsiCheckForSsi(stream, buffer, found, http_root, req)) {
	ldd R0,y+29
	ldd R1,y+30
	std y+5,R1
	std y+4,R0
	ldd R0,y+27
	ldd R1,y+28
	std y+3,R1
	std y+2,R0
	mov R2,R14
	clr R3
	std y+1,R3
	std y+0,R2
	ldd R18,y+8
	ldd R19,y+9
	ldd R16,y+21
	ldd R17,y+22
	xcall _NutSsiCheckForSsi
	mov R20,R16
	tst R16
	brne L170
X86:
;                     fwrite(buffer, 1, found+3, stream);
	ldd R0,y+21
	ldd R1,y+22
	std y+3,R1
	std y+2,R0
	mov R24,R14
	clr R25
	adiw R24,3
	std y+1,R25
	std y+0,R24
	ldi R18,1
	ldi R19,0
	ldd R16,y+8
	ldd R17,y+9
	xcall _fwrite
;                 }
L170:
;                 fpos += found+3;
	mov R24,R14
	clr R25
	adiw R24,3
	add R12,R24
	adc R13,R25
;                 _seek(fd, fpos, SEEK_SET);
	clr R2
	clr R3
	std y+3,R3
	std y+2,R2
	movw R2,R12
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldd R16,y+23
	ldd R17,y+24
	xcall __seek
;                 in_comment = 0;
	clr R0
	std y+10,R0
;             }
L165:
;         }
L153:
;     }
L148:
	ldd R0,y+25
	ldd R1,y+26
	cp R0,R12
	cpc R1,R13
	breq X91
	xjmp L147
X91:
X87:
;     
;     NutHeapFree(buffer);
	ldd R16,y+8
	ldd R17,y+9
	xcall _NutHeapFree
L144:
	.dbline 0 ; func end
	adiw R28,11
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
	.even
_NutRegisterSsi::
; }
; 
; /*!
;  * \brief Register SSI handler for shtml files.
;  * 
;  * shtml files may use the following ssi commands:
;  *
;  * <!--#include virtual="/news/news.htm" -->
;  * <!--#include file="UROM:/news/news.htm" -->
;  * <!--#exec cgi="/cgi-bin/counter.cgi" -->
;  */
; 
; void NutRegisterSsi(void)
; {
;     NutSetMimeHandler(".shtml", NutHttpProcessSHTML);
	ldi R18,<PL_NutHttpProcessSHTML
	ldi R19,>PL_NutHttpProcessSHTML
	ldi R16,<L173
	ldi R17,>L173
	xcall _NutSetMimeHandler
L172:
	.dbline 0 ; func end
	ret
	.area data(ram, con, rel)
L173:
	.blkb 7
	.area idata
	.byte 46,'s,'h,'t,'m,'l,0
	.area data(ram, con, rel)
L163:
	.blkb 4
	.area idata
	.byte 45,45,62,0
	.area data(ram, con, rel)
L154:
	.blkb 5
	.area idata
	.byte 60,33,45,45,0
	.area data(ram, con, rel)
L120:
	.blkb 4
	.area idata
	.byte 'c,'g,'i,0
	.area data(ram, con, rel)
L117:
	.blkb 5
	.area idata
	.byte 'f,'i,'l,'e,0
	.area data(ram, con, rel)
L114:
	.blkb 8
	.area idata
	.byte 'v,'i,'r,'t,'u,'a,'l,0
	.area data(ram, con, rel)
L105:
	.blkb 6
	.area idata
	.byte 35,'e,'x,'e,'c,0
	.area data(ram, con, rel)
L102:
	.blkb 9
	.area idata
	.byte 35,'i,'n,'c,'l,'u,'d,'e,0
	.area data(ram, con, rel)
L76:
	.blkb 12
	.area idata
	.byte 'i,'n,'d,'e,'x,46,'s,'h,'t,'m,'l,0
	.area data(ram, con, rel)
L65:
	.blkb 11
	.area idata
	.byte 'i,'n,'d,'e,'x,46,'h,'t,'m,'l,0
	.area data(ram, con, rel)
L64:
	.blkb 2
	.area idata
	.byte 47,0
	.area data(ram, con, rel)
L55:
	.blkb 6
	.area idata
	.byte 'U,'R,'O,'M,58,0
	.area data(ram, con, rel)
L38:
	.blkb 20
	.area idata
	.byte 53,48,48,32,'I,'n,'t,'e,'r,'n,'a,'l,32,'e,'r,'r
	.byte 'o,'r,10,0
	.area data(ram, con, rel)
L35:
	.blkb 9
	.area idata
	.byte 'c,'g,'i,45,'b,'i,'n,47,0
	.area data(ram, con, rel)
L32:
	.blkb 18
	.area idata
	.byte 52,48,48,32,'B,'e,'a,'d,32,'r,'e,'q,'u,'e,'s,'t
	.byte 10,0
	.area data(ram, con, rel)
L4:
	.blkb 19
	.area idata
	.byte 52,48,52,32,'N,'o,'t,32,'f,'o,'u,'n,'d,58,32,37
	.byte 's,10,0
	.area data(ram, con, rel)
; }
; 
; /*@}*/
	.area func_lit
PL_NutHttpProcessSHTML:	.word `_NutHttpProcessSHTML
