	.module syslog.c
	.area data(ram, con, rel)
_syslog_port:
	.blkb 2
	.area idata
	.word 514
	.area data(ram, con, rel)
_syslog_fac:
	.blkb 2
	.area idata
	.word 8
	.area data(ram, con, rel)
_syslog_mask:
	.blkb 2
	.area idata
	.word 255
	.area data(ram, con, rel)
_mon_name:
	.blkb 37
	.area idata
	.byte 'J,'a,'n,'F,'e,'b,'M,'a,'r,'A,'p,'r,'M,'a,'y,'J
	.byte 'u,'n,'J,'u,'l,'A,'u,'g,'S,'e,'p,'O,'c,'t,'N,'o
	.byte 'v,'D,'e,'c,0
	.area data(ram, con, rel)
	.area text(rom, con, rel)
;            now -> y+14
;            cnt -> R20,R21
;            tip -> R22,R23
;             ap -> y+26
;            fmt -> R10,R11
;            pri -> R20,R21
	.even
_vsyslog::
	xcall push_xgsetF03C
	movw R10,R18
	movw R20,R16
	sbiw R28,18
; /*
;  * Copyright (C) 2004 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  * -
;  * Portions Copyright (c) 1983, 1988, 1993
;  *      The Regents of the University of California.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the University nor the names of its contributors
;  *    may be used to endorse or promote products derived from this software
;  *    without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
;  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
;  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
;  * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
;  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
;  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
;  * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
;  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
;  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
;  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  */
; 
; /*!
;  * \file pro/syslog.c
;  * \brief Syslog Client
;  *
;  * \verbatim
;  *
;  * $Log: syslog.c,v $
;  * Revision 1.3  2005/08/02 17:47:04  haraldkipp
;  * Major API documentation update.
;  *
;  * Revision 1.2  2004/10/03 18:41:43  haraldkipp
;  * RAM saving calls added
;  *
;  * Revision 1.1  2004/09/19 11:18:45  haraldkipp
;  * Syslog client added
;  *
;  * \endverbatim
;  */
; 
; #include <cfg/syslog.h>
; #include <sys/confos.h>
; 
; #include <stdlib.h>
; #include <string.h>
; #include <stdio.h>
; #include <stdarg.h>
; #include <io.h>
; #include <time.h>
; 
; #include <sys/syslog.h>
; 
; #ifndef SYSLOG_PERROR_ONLY
; 
; #include <sys/socket.h>
; #include <arpa/inet.h>
; static UDPSOCKET *syslog_sock;
; 
; #endif                          /* SYSLOG_PERROR_ONLY */
; 
; /*!
;  * \addtogroup xgSyslog
;  */
; /*@{*/
; 
; #ifndef SYSLOG_MAXBUF
; /*!
;  * \brief Syslog message buffer size.
;  */
; #define SYSLOG_MAXBUF 256
; #endif
; 
; static u_short syslog_port = 514;
; static int syslog_fac = LOG_USER;
; static int syslog_mask = 0xFF;
; 
; static u_long syslog_server;
; static int syslog_stat;
; static size_t syslog_taglen;
; static char *syslog_tag;
; static char *syslog_buf;
; 
; static char mon_name[] = "JanFebMarAprMayJunJulAugSepOctNovDec";
; 
; 
; /*!
;  * \brief Print log message.
;  *
;  * Alternate form of syslog(), in which the arguments have already been captured
;  * using the variable-length argument facilities.
;  *
;  * \param pri Priority level of this message. See syslog().
;  * \param fmt Format string containing conversion specifications like printf.
;  * \param ap  List of arguments.
;  */
; void vsyslog(int pri, CONST char *fmt, va_list ap)
; {
;     time_t now;
;     struct _tm *tip;
;     size_t cnt;
; 
;     /* Remove invalid bits. */
;     pri &= LOG_PRIMASK | LOG_FACMASK;
	andi R21,3
; 
;     /* Check priority against setlog mask values. */
;     if ((LOG_MASK(LOG_PRI(pri)) & syslog_mask) == 0) {
	movw R18,R20
	andi R18,7
	andi R19,0
	ldi R16,1
	ldi R17,0
	xcall lsl16
	movw R2,R16
	lds R4,_syslog_mask
	lds R5,_syslog_mask+1
	and R2,R4
	and R3,R5
	tst R2
	brne L2
	tst R3
	brne L2
X0:
;         return;
	xjmp L1
L2:
;     }
; 
;     /* Open log if not done before. */
;     if (syslog_buf == 0) {
	lds R2,_syslog_buf
	lds R3,_syslog_buf+1
	tst R2
	brne L4
	tst R3
	brne L4
X1:
;         openlog(0, syslog_stat | LOG_NDELAY, syslog_fac);
	lds R2,_syslog_fac
	lds R3,_syslog_fac+1
	std y+1,R3
	std y+0,R2
	lds R18,_syslog_stat
	lds R19,_syslog_stat+1
	ori R18,8
	clr R16
	clr R17
	xcall _openlog
;     }
L4:
; 
;     /* Set default facility if none specified. */
;     if ((pri & LOG_FACMASK) == 0) {
	movw R24,R20
	andi R24,248
	andi R25,3
	cpi R24,0
	cpc R24,R25
	brne L6
X2:
;         pri |= syslog_fac;
	lds R2,_syslog_fac
	lds R3,_syslog_fac+1
	or R20,R2
	or R21,R3
;     }
L6:
; 
;     time(&now);
	movw R16,R28
	subi R16,242  ; offset = 14
	sbci R17,255
	xcall _time
;     tip = localtime(&now);
	movw R16,R28
	subi R16,242  ; offset = 14
	sbci R17,255
	xcall _localtime
	movw R22,R16
;     sprintf(syslog_buf, "<%d>%.3s%3d %02d:%02d:%02d %s ", pri, &mon_name[tip->tm_mon * 3],
	ldi R24,<_confos+3
	ldi R25,>_confos+3
	std y+13,R25
	std y+12,R24
	movw R30,R22
	ldd R2,z+0
	ldd R3,z+1
	std y+11,R3
	std y+10,R2
	ldd R2,z+2
	ldd R3,z+3
	std y+9,R3
	std y+8,R2
	ldd R2,z+4
	ldd R3,z+5
	std y+7,R3
	std y+6,R2
	ldd R2,z+6
	ldd R3,z+7
	std y+5,R3
	std y+4,R2
	ldd R18,z+8
	ldd R19,z+9
	ldi R16,3
	ldi R17,0
	xcall empy16s
	ldi R24,<_mon_name
	ldi R25,>_mon_name
	movw R2,R16
	add R2,R24
	adc R3,R25
	std y+3,R3
	std y+2,R2
	std y+1,R21
	std y+0,R20
	ldi R18,<L8
	ldi R19,>L8
	lds R16,_syslog_buf
	lds R17,_syslog_buf+1
	xcall _sprintf_M
;             tip->tm_mday, tip->tm_hour, tip->tm_min, tip->tm_sec, confos.hostname);
;     cnt = strlen(syslog_buf);
	lds R16,_syslog_buf
	lds R17,_syslog_buf+1
	xcall _strlen
	movw R20,R16
; 
;     if (syslog_taglen) {
	lds R2,_syslog_taglen
	lds R3,_syslog_taglen+1
	tst R2
	brne X3
	tst R3
	breq L10
X3:
;         cnt += syslog_taglen + 2;
	movw R24,R2
	adiw R24,2
	add R20,R24
	adc R21,R25
;         if (cnt >= SYSLOG_MAXBUF) {
	cpi R20,0
	ldi R30,1
	cpc R21,R30
	brlo L12
X4:
;             return;
	xjmp L1
L12:
;         }
;         strcat(syslog_buf, syslog_tag);
	lds R18,_syslog_tag
	lds R19,_syslog_tag+1
	lds R16,_syslog_buf
	lds R17,_syslog_buf+1
	xcall _strcat
;         strcat(syslog_buf, ": ");
	ldi R18,<L14
	ldi R19,>L14
	lds R16,_syslog_buf
	lds R17,_syslog_buf+1
	xcall _strcat
;     }
L10:
; 
;     /* Potentially dangerous. We need vsnprintf() */
;     if (cnt + strlen(fmt) >= SYSLOG_MAXBUF) {
	movw R16,R10
	xcall _strlen
	movw R12,R16
	movw R24,R20
	add R24,R16
	adc R25,R17
	cpi R24,0
	ldi R30,1
	cpc R25,R30
	brlo L15
X5:
;         return;
	xjmp L1
L15:
;     }
;     vsprintf(&syslog_buf[cnt], fmt, ap);
	ldd R0,y+26
	ldd R1,y+27
	std y+1,R1
	std y+0,R0
	movw R18,R10
	lds R2,_syslog_buf
	lds R3,_syslog_buf+1
	movw R16,R20
	add R16,R2
	adc R17,R3
	xcall _vsprintf
;     cnt = strlen(syslog_buf);
	lds R16,_syslog_buf
	lds R17,_syslog_buf+1
	xcall _strlen
	movw R10,R16
	movw R20,R10
; 
;     /* Output to stderr if requested */
;     if (syslog_stat & LOG_PERROR) {
	lds R2,_syslog_stat
	lds R3,_syslog_stat+1
	sbrs R2,5
	rjmp L17
X6:
;         _write(_fileno(stderr), syslog_buf, cnt);
	lds R16,___iob+4
	lds R17,___iob+4+1
	xcall __fileno
	std y+1,R21
	std y+0,R20
	lds R18,_syslog_buf
	lds R19,_syslog_buf+1
	xcall __write
;         _write(_fileno(stderr), "\n", 1);
	lds R16,___iob+4
	lds R17,___iob+4+1
	xcall __fileno
	movw R10,R16
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<L21
	ldi R19,>L21
	xcall __write
;     }
L17:
; #ifndef SYSLOG_PERROR_ONLY
;     /*
;      * Output the message to a remote logger.
;      */
;     if (syslog_server) {
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	lds R4,_syslog_server+2
	lds R5,_syslog_server+2+1
	lds R2,_syslog_server
	lds R3,_syslog_server+1
	cp R2,R24
	cpc R3,R25
	cpc R4,R26
	cpc R5,R27
	breq L22
X7:
;         NutUdpSendTo(syslog_sock, syslog_server, syslog_port, syslog_buf, cnt);
	std y+7,R21
	std y+6,R20
	lds R2,_syslog_buf
	lds R3,_syslog_buf+1
	std y+5,R3
	std y+4,R2
	lds R2,_syslog_port
	lds R3,_syslog_port+1
	std y+3,R3
	std y+2,R2
	lds R4,_syslog_server+2
	lds R5,_syslog_server+2+1
	lds R2,_syslog_server
	lds R3,_syslog_server+1
	std y+0,R4
	std y+1,R5
	movw R18,R2
	lds R16,_syslog_sock
	lds R17,_syslog_sock+1
	xcall _NutUdpSendTo
;     }
L22:
L1:
	.dbline 0 ; func end
	adiw R28,18
	xjmp pop_xgsetF03C
;             ap -> R10,R11
;            fmt -> y+6
;            pri -> y+4
	.even
_syslog::
	xcall push_arg4
	st -y,R10
	st -y,R11
	sbiw R28,2
; #endif
; }
; 
; /*!
;  * \brief Print log message.
;  *
;  * The message is tagged with priority.
;  *
;  * \param pri Priority level of this message, selected from the following
;  *            ordered list (high to low):
;  *            - LOG_EMERG   A panic condition.
;  *            - LOG_ALERT   A condition that should be corrected immediately.
;  *            - LOG_CRIT    Critical conditions, e.g., hard device errors.
;  *            - LOG_ERR     Errors.
;  *            - LOG_WARNING Warning messages.
;  *            - LOG_NOTICE  Conditions that are not error conditions, but should 
;  *                          possibly be handled specially.
;  *            - LOG_INFO    Informational messages.
;  *            - LOG_DEBUG   Messages that contain information normally of use only 
;  *                          when debugging a program.
;  * \param fmt Format string containing conversion specifications like printf.
;  */
; void syslog(int pri, CONST char *fmt, ...)
; {
;     va_list ap;
; 
;     va_start(ap, fmt);
	ldi R18,2
	ldi R19,0
	movw R16,R28
	subi R16,250  ; offset = 6
	sbci R17,255
	xcall __va_start
	movw R10,R16
;     vsyslog(pri, (char *) fmt, ap);
	std y+1,R11
	std y+0,R10
	ldd R18,y+6
	ldd R19,y+7
	ldd R16,y+4
	ldd R17,y+5
	xcall _vsyslog
;     va_end(ap);
L24:
	.dbline 0 ; func end
	adiw R28,2
	ld R11,y+
	ld R10,y+
	adiw R28,4
	ret
;            now -> y+14
;            cnt -> R20,R21
;            tip -> R22,R23
;             ap -> y+26
;            fmt -> R10,R11
;            pri -> R20,R21
	.even
_vsyslog_P::
	xcall push_xgsetF03C
	movw R10,R18
	movw R20,R16
	sbiw R28,18
; }
; 
; #ifdef __HARVARD_ARCH__
; /*!
;  * \brief Print log message.
;  *
;  * Alternate form of syslog(), in which the arguments have already been captured
;  * using the variable-length argument facilities.
;  *
;  * \param pri Priority level of this message. See syslog().
;  * \param fmt Format string containing conversion specifications like printf.
;  * \param ap  List of arguments.
;  */
; void vsyslog_P(int pri, PGM_P fmt, va_list ap)
; {
;     time_t now;
;     struct _tm *tip;
;     size_t cnt;
; 
;     /* Remove invalid bits. */
;     pri &= LOG_PRIMASK | LOG_FACMASK;
	andi R21,3
; 
;     /* Check priority against setlog mask values. */
;     if ((LOG_MASK(LOG_PRI(pri)) & syslog_mask) == 0) {
	movw R18,R20
	andi R18,7
	andi R19,0
	ldi R16,1
	ldi R17,0
	xcall lsl16
	movw R2,R16
	lds R4,_syslog_mask
	lds R5,_syslog_mask+1
	and R2,R4
	and R3,R5
	tst R2
	brne L26
	tst R3
	brne L26
X8:
;         return;
	xjmp L25
L26:
;     }
; 
;     /* Open log if not done before. */
;     if (syslog_buf == 0) {
	lds R2,_syslog_buf
	lds R3,_syslog_buf+1
	tst R2
	brne L28
	tst R3
	brne L28
X9:
;         openlog(0, syslog_stat | LOG_NDELAY, syslog_fac);
	lds R2,_syslog_fac
	lds R3,_syslog_fac+1
	std y+1,R3
	std y+0,R2
	lds R18,_syslog_stat
	lds R19,_syslog_stat+1
	ori R18,8
	clr R16
	clr R17
	xcall _openlog
;     }
L28:
; 
;     /* Set default facility if none specified. */
;     if ((pri & LOG_FACMASK) == 0) {
	movw R24,R20
	andi R24,248
	andi R25,3
	cpi R24,0
	cpc R24,R25
	brne L30
X10:
;         pri |= syslog_fac;
	lds R2,_syslog_fac
	lds R3,_syslog_fac+1
	or R20,R2
	or R21,R3
;     }
L30:
; 
;     time(&now);
	movw R16,R28
	subi R16,242  ; offset = 14
	sbci R17,255
	xcall _time
;     tip = localtime(&now);
	movw R16,R28
	subi R16,242  ; offset = 14
	sbci R17,255
	xcall _localtime
	movw R22,R16
;     sprintf(syslog_buf, "<%d>%.3s%3d %02d:%02d:%02d %s ", pri, &mon_name[tip->tm_mon * 3],
	ldi R24,<_confos+3
	ldi R25,>_confos+3
	std y+13,R25
	std y+12,R24
	movw R30,R22
	ldd R2,z+0
	ldd R3,z+1
	std y+11,R3
	std y+10,R2
	ldd R2,z+2
	ldd R3,z+3
	std y+9,R3
	std y+8,R2
	ldd R2,z+4
	ldd R3,z+5
	std y+7,R3
	std y+6,R2
	ldd R2,z+6
	ldd R3,z+7
	std y+5,R3
	std y+4,R2
	ldd R18,z+8
	ldd R19,z+9
	ldi R16,3
	ldi R17,0
	xcall empy16s
	ldi R24,<_mon_name
	ldi R25,>_mon_name
	movw R2,R16
	add R2,R24
	adc R3,R25
	std y+3,R3
	std y+2,R2
	std y+1,R21
	std y+0,R20
	ldi R18,<L8
	ldi R19,>L8
	lds R16,_syslog_buf
	lds R17,_syslog_buf+1
	xcall _sprintf_M
;             tip->tm_mday, tip->tm_hour, tip->tm_min, tip->tm_sec, confos.hostname);
;     cnt = strlen(syslog_buf);
	lds R16,_syslog_buf
	lds R17,_syslog_buf+1
	xcall _strlen
	movw R20,R16
; 
;     if (syslog_taglen) {
	lds R2,_syslog_taglen
	lds R3,_syslog_taglen+1
	tst R2
	brne X11
	tst R3
	breq L33
X11:
;         cnt += syslog_taglen + 2;
	movw R24,R2
	adiw R24,2
	add R20,R24
	adc R21,R25
;         if (cnt >= SYSLOG_MAXBUF) {
	cpi R20,0
	ldi R30,1
	cpc R21,R30
	brlo L35
X12:
;             return;
	xjmp L25
L35:
;         }
;         strcat(syslog_buf, syslog_tag);
	lds R18,_syslog_tag
	lds R19,_syslog_tag+1
	lds R16,_syslog_buf
	lds R17,_syslog_buf+1
	xcall _strcat
;         strcat(syslog_buf, ": ");
	ldi R18,<L14
	ldi R19,>L14
	lds R16,_syslog_buf
	lds R17,_syslog_buf+1
	xcall _strcat
;     }
L33:
; 
;     /* Potentially dangerous. We need vsnprintf() */
;     if (cnt + strlen_P(fmt) >= SYSLOG_MAXBUF) {
	movw R16,R10
	xcall _cstrlen
	movw R12,R16
	movw R24,R20
	add R24,R16
	adc R25,R17
	cpi R24,0
	ldi R30,1
	cpc R25,R30
	brlo L37
X13:
;         return;
	xjmp L25
L37:
;     }
;     vsprintf_P(&syslog_buf[cnt], fmt, ap);
	ldd R0,y+26
	ldd R1,y+27
	std y+1,R1
	std y+0,R0
	movw R18,R10
	lds R2,_syslog_buf
	lds R3,_syslog_buf+1
	movw R16,R20
	add R16,R2
	adc R17,R3
	xcall _vsprintf_P
;     cnt = strlen(syslog_buf);
	lds R16,_syslog_buf
	lds R17,_syslog_buf+1
	xcall _strlen
	movw R10,R16
	movw R20,R10
; 
;     /* Output to stderr if requested */
;     if (syslog_stat & LOG_PERROR) {
	lds R2,_syslog_stat
	lds R3,_syslog_stat+1
	sbrs R2,5
	rjmp L39
X14:
;         _write(_fileno(stderr), syslog_buf, cnt);
	lds R16,___iob+4
	lds R17,___iob+4+1
	xcall __fileno
	std y+1,R21
	std y+0,R20
	lds R18,_syslog_buf
	lds R19,_syslog_buf+1
	xcall __write
;         _write(_fileno(stderr), "\n", 1);
	lds R16,___iob+4
	lds R17,___iob+4+1
	xcall __fileno
	movw R10,R16
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<L21
	ldi R19,>L21
	xcall __write
;     }
L39:
; #ifndef SYSLOG_PERROR_ONLY
;     /*
;      * Output the message to a remote logger.
;      */
;     if (syslog_server) {
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	lds R4,_syslog_server+2
	lds R5,_syslog_server+2+1
	lds R2,_syslog_server
	lds R3,_syslog_server+1
	cp R2,R24
	cpc R3,R25
	cpc R4,R26
	cpc R5,R27
	breq L43
X15:
;         NutUdpSendTo(syslog_sock, syslog_server, syslog_port, syslog_buf, cnt);
	std y+7,R21
	std y+6,R20
	lds R2,_syslog_buf
	lds R3,_syslog_buf+1
	std y+5,R3
	std y+4,R2
	lds R2,_syslog_port
	lds R3,_syslog_port+1
	std y+3,R3
	std y+2,R2
	lds R4,_syslog_server+2
	lds R5,_syslog_server+2+1
	lds R2,_syslog_server
	lds R3,_syslog_server+1
	std y+0,R4
	std y+1,R5
	movw R18,R2
	lds R16,_syslog_sock
	lds R17,_syslog_sock+1
	xcall _NutUdpSendTo
;     }
L43:
L25:
	.dbline 0 ; func end
	adiw R28,18
	xjmp pop_xgsetF03C
;             ap -> R10,R11
;            fmt -> y+6
;            pri -> y+4
	.even
_syslog_P::
	xcall push_arg4
	st -y,R10
	st -y,R11
	sbiw R28,2
; #endif
; }
; 
; /*!
;  * \brief Print log message.
;  *
;  * The message is tagged with priority.
;  *
;  * \param pri Priority level of this message, selected from the following
;  *            ordered list (high to low):
;  *            - LOG_EMERG   A panic condition.
;  *            - LOG_ALERT   A condition that should be corrected immediately.
;  *            - LOG_CRIT    Critical conditions, e.g., hard device errors.
;  *            - LOG_ERR     Errors.
;  *            - LOG_WARNING Warning messages.
;  *            - LOG_NOTICE  Conditions that are not error conditions, but should 
;  *                          possibly be handled specially.
;  *            - LOG_INFO    Informational messages.
;  *            - LOG_DEBUG   Messages that contain information normally of use only 
;  *                          when debugging a program.
;  * \param fmt Format string containing conversion specifications like printf.
;  */
; void syslog_P(int pri, PGM_P fmt, ...)
; {
;     va_list ap;
; 
;     va_start(ap, fmt);
	ldi R18,2
	ldi R19,0
	movw R16,R28
	subi R16,250  ; offset = 6
	sbci R17,255
	xcall __va_start
	movw R10,R16
;     vsyslog_P(pri, fmt, ap);
	std y+1,R11
	std y+0,R10
	ldd R18,y+6
	ldd R19,y+7
	ldd R16,y+4
	ldd R17,y+5
	xcall _vsyslog_P
;     va_end(ap);
L45:
	.dbline 0 ; func end
	adiw R28,2
	ld R11,y+
	ld R10,y+
	adiw R28,4
	ret
;             rc -> R10,R11
;        logmask -> R16,R17
	.even
_setlogmask::
	st -y,R10
	st -y,R11
; }
; 
; #endif /* __HARVARD_ARCH__ */
; 
; /*!
;  * \brief Set the log priority mask level.
;  *
;  * Calls to syslog() with a priority not set are ignored. The default allows all 
;  * priorities to be logged.
;  *
;  * \param logmask New priority mask.
;  *
;  * \return Previous mask.
;  */
; int setlogmask(int logmask)
; {
;     int rc = syslog_mask;
	lds R10,_syslog_mask
	lds R11,_syslog_mask+1
; 
;     if (logmask) {
	cpi R16,0
	cpc R16,R17
	breq L47
X16:
;         syslog_mask = logmask;
	sts _syslog_mask+1,R17
	sts _syslog_mask,R16
;     }
L47:
;     return rc;
	movw R16,R10
L46:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
;             rc -> y+0
;           port -> R16,R17
;             ip -> y+4
	.even
_setlogserver::
	xcall push_arg4
	sbiw R28,4
	ldd R16,y+8
	ldd R17,y+9
; }
; 
; /*!
;  * \brief Set the log server's IP address.
;  *
;  * \param ip   IP address in network byte order. If 0, no messages will be sent out.
;  * \param port Port number. If 0, then standard port is used.
;  *
;  * \return Previous IP.
;  */
; u_long setlogserver(u_long ip, u_short port)
; {
;     u_long rc = syslog_server;
	lds R4,_syslog_server+2
	lds R5,_syslog_server+2+1
	lds R2,_syslog_server
	lds R3,_syslog_server+1
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
; 
;     syslog_server = ip;
	ldd R2,y+4
	ldd R3,y+5
	ldd R4,y+6
	ldd R5,y+7
	sts _syslog_server+1,R3
	sts _syslog_server,R2
	sts _syslog_server+2+1,R5
	sts _syslog_server+2,R4
;     if (port) {
	cpi R16,0
	cpc R16,R17
	breq L50
X17:
;         syslog_port = port;
	sts _syslog_port+1,R17
	sts _syslog_port,R16
;     }
L50:
;     return rc;
	ldd R16,y+0
	ldd R17,y+1
	ldd R18,y+2
	ldd R19,y+3
L49:
	.dbline 0 ; func end
	adiw R28,8
	ret
;         logfac -> y+4
;        logstat -> R12,R13
;          ident -> R10,R11
	.even
_openlog::
	xcall push_xgset003C
	movw R12,R18
	movw R10,R16
; }
; 
; /*!
;  * \brief Open logging for specialized processing.
;  *
;  * This function provides for more specialized processing of the messages sent by
;  * syslog() and vsyslog().
;  *
;  * \param ident   This string that will be prepended to every message.
;  * \param logstat A bit field specifying logging options, which is formed by
;  *                OR'ing one or more of the following values:
;  *                - LOG_CONS   Ignored but accepted for compatibility.
;  *                - LOG_NDELAY Ignored but accepted for compatibility.
;  *                - LOG_PERROR Additionally write the message to standard error output.
;  *                - LOG_PID    Ignored but accepted for compatibility.
;  * \param logfac  Encodes a default facility to be assigned to all messages that do not 
;  *                have an explicit facility encoded:
;  *                - LOG_AUTH     The authorization system:
;  *                - LOG_AUTHPRIV The same as LOG_AUTH.
;  *                - LOG_CRON     The cron daemon,
;  *                - LOG_DAEMON   System daemons, that are not provided for explicitly by 
;  *                               other facilities.
;  *                - LOG_FTP      The file transfer protocol daemon,
;  *                - LOG_KERN     Messages generated by the kernel. These should not be 
;  *                               generated by applications.
;  *                - LOG_LPR      The line printer spooling system.
;  *                - LOG_MAIL     The mail system.
;  *                - LOG_NEWS     The network news system.
;  *                - LOG_SYSLOG   Messages generated internally by syslog.
;  *                - LOG_USER     This is the default facility identifier if none is specified.
;  *                - LOG_UUCP     The UUCP system.
;  *                - LOG_LOCAL0..LOG_LOCAL7 Reserved for local use.
;  */
; void openlog(CONST char *ident, int logstat, int logfac)
; {
;     if (ident == 0) {
	tst R10
	brne L53
	tst R11
	brne L53
X18:
;         ident = syslog_tag;
	lds R10,_syslog_tag
	lds R11,_syslog_tag+1
;         syslog_taglen = 0;
	clr R2
	clr R3
	sts _syslog_taglen+1,R3
	sts _syslog_taglen,R2
;     }
L53:
; 
;     closelog();
	xcall _closelog
; 
;     syslog_stat = logstat;
	sts _syslog_stat+1,R13
	sts _syslog_stat,R12
;     syslog_fac = logfac;
	ldd R0,y+4
	ldd R1,y+5
	sts _syslog_fac+1,R1
	sts _syslog_fac,R0
;     if (ident && *ident) {
	tst R10
	brne X19
	tst R11
	breq L55
X19:
	movw R30,R10
	ldd R2,z+0
	tst R2
	breq L55
X20:
;         syslog_taglen = strlen(ident);
	movw R16,R30
	xcall _strlen
	sts _syslog_taglen+1,R17
	sts _syslog_taglen,R16
;         syslog_tag = malloc(syslog_taglen + 1);
	subi R16,255  ; offset = 1
	sbci R17,255
	xcall _malloc_M
	sts _syslog_tag+1,R17
	sts _syslog_tag,R16
;         strcpy(syslog_tag, ident);
	movw R18,R10
	xcall _strcpy
;     }
L55:
;     if (syslog_stat & LOG_NDELAY) {
	lds R2,_syslog_stat
	lds R3,_syslog_stat+1
	sbrs R2,3
	rjmp L57
X21:
;         if (syslog_buf == 0) {
	lds R2,_syslog_buf
	lds R3,_syslog_buf+1
	tst R2
	brne L59
	tst R3
	brne L59
X22:
;             syslog_buf = malloc(SYSLOG_MAXBUF);
	ldi R16,256
	ldi R17,1
	xcall _malloc_M
	movw R10,R16
	sts _syslog_buf+1,R11
	sts _syslog_buf,R10
;         }
L59:
; #ifndef SYSLOG_PERROR_ONLY
;         if (syslog_sock == 0) {
	lds R2,_syslog_sock
	lds R3,_syslog_sock+1
	tst R2
	brne L61
	tst R3
	brne L61
X23:
;             syslog_sock = NutUdpCreateSocket(514);
	ldi R16,514
	ldi R17,2
	xcall _NutUdpCreateSocket
	movw R10,R16
	sts _syslog_sock+1,R11
	sts _syslog_sock,R10
;         }
L61:
; #endif
;     }
L57:
L52:
	.dbline 0 ; func end
	xjmp pop_xgset003C
	.even
_closelog::
; }
; 
; /*!
;  * \brief Release system resources occupied by syslog().
;  */
; void closelog(void)
; {
;     if (syslog_buf) {
	lds R2,_syslog_buf
	lds R3,_syslog_buf+1
	tst R2
	brne X24
	tst R3
	breq L64
X24:
;         free(syslog_buf);
	movw R16,R2
	xcall _free_M
;         syslog_buf = 0;
	clr R2
	clr R3
	sts _syslog_buf+1,R3
	sts _syslog_buf,R2
;     }
L64:
;     if (syslog_taglen) {
	lds R2,_syslog_taglen
	lds R3,_syslog_taglen+1
	tst R2
	brne X25
	tst R3
	breq L66
X25:
;         free(syslog_tag);
	lds R16,_syslog_tag
	lds R17,_syslog_tag+1
	xcall _free_M
;         syslog_taglen = 0;
	clr R2
	clr R3
	sts _syslog_taglen+1,R3
	sts _syslog_taglen,R2
;     }
L66:
; #ifndef SYSLOG_PERROR_ONLY
;     if (syslog_sock) {
	lds R2,_syslog_sock
	lds R3,_syslog_sock+1
	tst R2
	brne X26
	tst R3
	breq L68
X26:
;         NutUdpDestroySocket(syslog_sock);
	movw R16,R2
	xcall _NutUdpDestroySocket
;         syslog_sock = 0;
	clr R2
	clr R3
	sts _syslog_sock+1,R3
	sts _syslog_sock,R2
;     }
L68:
L63:
	.dbline 0 ; func end
	ret
	.area bss(ram, con, rel)
_syslog_buf:
	.blkb 2
_syslog_tag:
	.blkb 2
_syslog_taglen:
	.blkb 2
_syslog_stat:
	.blkb 2
_syslog_server:
	.blkb 4
_syslog_sock:
	.blkb 2
	.area data(ram, con, rel)
L21:
	.blkb 2
	.area idata
	.byte 10,0
	.area data(ram, con, rel)
L14:
	.blkb 3
	.area idata
	.byte 58,32,0
	.area data(ram, con, rel)
L8:
	.blkb 31
	.area idata
	.byte 60,37,'d,62,37,46,51,'s,37,51,'d,32,37,48,50,'d
	.byte 58,37,48,50,'d,58,37,48,50,'d,32,37,'s,32,0
	.area data(ram, con, rel)
; #endif
; }
; 
; /*@}*/
; 
