	.module wins.c
	.area text(rom, con, rel)
;          rport -> y+14
;          raddr -> y+10
;           sock -> R12,R13
;              j -> R22,R23
;        encoded -> R10,R11
;            car -> R20
;              i -> R14,R15
;            pkt -> y+16
;         ipaddr -> y+30
;           name -> y+28
	.even
_NutWinsNameQuery::
	xcall push_arg4
	xcall push_xgsetF0FC
	sbiw R28,18
; 
; /*
;   * Copyright (C) 2004 by Jean Pierre Gauthier. All rights reserved.
;   *
;   * Redistribution and use in source and binary forms, with or without
;   * modification, are permitted provided that the following conditions
;   * are met:
;   *
;   * 1. Redistributions of source code must retain the above copyright
;   *    notice, this list of conditions and the following disclaimer.
;   * 2. Redistributions in binary form must reproduce the above copyright
;   *    notice, this list of conditions and the following disclaimer in the
;   *    documentation and/or other materials provided with the distribution.
;   * 3. Neither the name of the copyright holders nor the names of
;   *    contributors may be used to endorse or promote products derived
;   *    from this software without specific prior written permission.
;   *
;   * THIS SOFTWARE IS PROVIDED BY <YOUR NAME> AND CONTRIBUTORS
;   * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;   * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;   * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL <YOUR NAME>
;   * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;   * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;   * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;   * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;   * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;   * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;   * SUCH DAMAGE.
;   */
; 
; /* ********************************************************* */
; /* 
; Netbios WINS (RFC 1002) Name Query. 
; Only Query Request Client Routine sending/Positive Name Query Response receiving
; are implemented. 
; When the Netbios Name Query request UDP datagram is on the ethernet network, asking 
; "Who is 'name'?", NutWinsNameQuery answers with the specified 'ipaddr' Ethernut IP address. 
; Answer to Microsoft Windows/Internet Explorer calls by "http://name" command line
; (and even directly "name" as command line if "name" is not a shared folder). 
; 
; Launch for example :
; THREAD(wins_deamon, arg)
; {
; NutWinsNameQuery  (  "myboard", inet_addr(MYIP) ) ;
; } 
; */
; /* ********************************************************* */
; 
; #include <cfg/os.h>
; #include <string.h>
; 
; #include <sys/heap.h>
; #include <sys/socket.h>
; #include <sys/sock_var.h>
; #include <sys/types.h>
; #include <pro/wins.h>
; #include <netinet/in.h>
; #ifdef NUTDEBUG
; #include <stdio.h>
; #endif
; 
; extern int toupper(int);
; /* ********************************************************* */
; 
; /*!
;  * \addtogroup xgWins
;  */
; /*@{*/
; 
; typedef struct {
;     u_short id;
;     u_short flags;
;     u_short quests;
;     u_short answers;
;     u_short authrr;
;     u_short addrr;
;     u_char namelen;
;     u_char name[33];
;     u_short type;
;     u_short class;              /* end of request */
;     u_long ttl;
;     u_short len_rep;
;     u_char node_flags;
;     u_char node_type;
;     u_long ip_addr;             /* end of answer */
; } WINSHEADER;
; 
; 
; /* ********************************************************* */
; /* name : netbios label (15 chars max), ipaddr : network ordered IP address bytes */
; int NutWinsNameQuery(u_char * name, u_long ipaddr)
; {
;     WINSHEADER *pkt = NULL;
	clr R0
	clr R1
	std y+17,R1
	std y+16,R0
;     u_char *encoded = NULL;
	clr R10
	clr R11
;     UDPSOCKET *sock;
;     u_long raddr;
;     u_short rport;
;     u_char car;
;     int i, j;
;     if (strlen(name) > 15)
	ldd R16,y+28
	ldd R17,y+29
	xcall _strlen
	ldi R24,15
	ldi R25,0
	cp R24,R16
	cpc R25,R17
	brsh L3
X0:
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L2
L3:
;     if (((pkt = NutHeapAllocClear(sizeof(WINSHEADER))) == NULL) ||      /* */
	ldi R16,62
	ldi R17,0
	xcall _NutHeapAllocClear
	std y+17,R17
	std y+16,R16
	cpi R16,0
	cpc R16,R17
	breq L8
X1:
	ldi R16,33
	ldi R17,0
	xcall _NutHeapAllocClear
	movw R12,R16
	movw R10,R12
	cpi R16,0
	cpc R16,R17
	breq L8
X2:
	ldi R16,137
	ldi R17,0
	xcall _NutUdpCreateSocket
	movw R14,R16
	movw R12,R14
	cpi R16,0
	cpc R16,R17
	brne L5
X3:
L8:
;         ((encoded = NutHeapAllocClear(33)) == NULL) ||  /* */
;         ((sock = NutUdpCreateSocket(137)) == 0) /* NETBIOS UDP port */
;         ) {
;         if (pkt != NULL)
	ldd R0,y+16
	ldd R1,y+17
	tst R0
	brne X4
	tst R1
	breq L9
X4:
;             NutHeapFree(pkt);
	movw R16,R0
	xcall _NutHeapFree
L9:
;         if (encoded != NULL)
	tst R10
	brne X5
	tst R11
	breq L11
X5:
;             NutHeapFree(encoded);
	movw R16,R10
	xcall _NutHeapFree
L11:
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L2
L5:
;     }
;     j = 0;
	clr R22
	clr R23
;     for (i = 0; i < 16; i++) {  /* label  'compression' */
	clr R14
	clr R15
L13:
;         car = toupper(i < strlen(name) ? name[i] : ' ');
	ldd R16,y+28
	ldd R17,y+29
	xcall _strlen
	movw R20,R16
	cp R14,R16
	cpc R15,R17
	brsh L17
X6:
	movw R30,R14
	ldd R0,y+28
	ldd R1,y+29
	add R30,R0
	adc R31,R1
	ldd R20,z+0
	clr R21
	xjmp L18
L17:
	ldi R20,32
	ldi R21,0
L18:
	movw R16,R20
	xcall _toupper
	movw R20,R16
;         if (i == 15)
	movw R24,R14
	cpi R24,15
	ldi R30,0
	cpc R25,R30
	brne L19
X7:
;             car = 0;
	clr R20
L19:
;         encoded[j] = (car >> 4) + 'A';
	movw R30,R22
	add R30,R10
	adc R31,R11
	mov R24,R20
	swap R24
	andi R24,#0x0F
	subi R24,191    ; addi 65
	std z+0,R24
;         encoded[j + 1] = (car & 0xf) + 'A';
	movw R30,R22
	add R30,R10
	adc R31,R11
	mov R24,R20
	andi R24,15
	subi R24,191    ; addi 65
	std z+1,R24
;         j += 2;
	subi R22,254  ; offset = 2
	sbci R23,255
;     }
L14:
	movw R24,R14
	adiw R24,1
	movw R14,R24
	cpi R24,16
	ldi R30,0
	cpc R25,R30
	brge X16
	xjmp L13
X16:
X8:
;     encoded[j] = 0;
	movw R30,R22
	add R30,R10
	adc R31,R11
	clr R2
	std z+0,R2
;      /* printf("local compressed name=\n%s \n", encoded); */
;     for (;;) {                  /* infinite loop / Netbios deamon */
L21:
;         NutUdpReceiveFrom(sock, &raddr, &rport, pkt, sizeof(WINSHEADER), 0);
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+6,R24
	std y+7,R25
	std y+8,R26
	std y+9,R27
	ldi R24,62
	ldi R25,0
	std y+5,R25
	std y+4,R24
	ldd R0,y+16
	ldd R1,y+17
	std y+3,R1
	std y+2,R0
	movw R24,R28
	adiw R24,14
	std y+1,R25
	std y+0,R24
	movw R18,R28
	subi R18,246  ; offset = 10
	sbci R19,255
	movw R16,R12
	xcall _NutUdpReceiveFrom
;         /* RFC1002 Name Query Request verification */
;         if (((ntohs(pkt->flags) & 0xf800) != 0) ||      /* */
	ldd R30,y+16
	ldd R31,y+17
	ldd R22,z+2
	ldd R23,z+3
	movw R24,R22
	andi R24,0
	movw R2,R24
	mov R2,R3
	clr R3
	movw R24,R22
	andi R25,0
	mov R25,R24
	clr R24
	or R24,R2
	or R25,R3
	andi R24,0
	andi R25,248
	cpi R24,0
	cpc R24,R25
	breq X17
	xjmp L31
X17:
X9:
	ldd R22,z+4
	ldd R23,z+5
	movw R24,R22
	andi R24,0
	movw R2,R24
	mov R2,R3
	clr R3
	movw R24,R22
	andi R25,0
	mov R25,R24
	clr R24
	or R24,R2
	or R25,R3
	cpi R24,1
	ldi R26,0
	cpc R25,R26
	breq X18
	xjmp L31
X18:
X10:
	ldd R24,z+12
	cpi R24,32
	breq X19
	xjmp L31
X19:
X11:
	ldd R22,z+46
	ldd R23,z+47
	movw R24,R22
	andi R24,0
	movw R2,R24
	mov R2,R3
	clr R3
	movw R24,R22
	andi R25,0
	mov R25,R24
	clr R24
	or R24,R2
	or R25,R3
	cpi R24,32
	ldi R26,0
	cpc R25,R26
	brne L31
X12:
	ldd R22,z+48
	ldd R23,z+49
	movw R24,R22
	andi R24,0
	movw R2,R24
	mov R2,R3
	clr R3
	movw R24,R22
	andi R25,0
	mov R25,R24
	clr R24
	or R24,R2
	or R25,R3
	cpi R24,1
	ldi R26,0
	cpc R25,R26
	brne L31
X13:
	movw R18,R10
	movw R16,R30
	subi R16,243  ; offset = 13
	sbci R17,255
	xcall _strcmp
	movw R14,R16
	cpi R16,0
	cpc R16,R17
	breq L25
X14:
L31:
;             (ntohs(pkt->quests) != 1) ||        /* */
;             (pkt->namelen != 0x20) ||   /* */
;             (ntohs(pkt->type) != 32) || /* */
;             (ntohs(pkt->class) != 1) || /* */
;             (strcmp(pkt->name, encoded)))
;             continue;           /* bad request, try again */
	xjmp L21
L25:
;          /* printf("Name=%s recognized\r\n", name); */
;         /* build RFC1002 Positive Name Query Response */
;         pkt->flags = htons(0x8580);     /* Response flags */
	ldi R24,32901
	ldi R25,128
	ldd R30,y+16
	ldd R31,y+17
	std z+3,R25
	std z+2,R24
;         pkt->answers = htons(1);
	ldi R24,256
	ldi R25,1
	std z+7,R25
	std z+6,R24
;         pkt->ttl = htonl((u_long) 60);  /* 60 seconds validity */
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,60
	std z+50,R24
	std z+51,R25
	std z+52,R26
	std z+53,R27
;         pkt->len_rep = htons(6);
	ldi R24,1536
	ldi R25,6
	std z+55,R25
	std z+54,R24
;         pkt->node_flags = pkt->node_type = pkt->quests = 0;     /* B-type node, etc... */
	clr R2
	clr R3
	std z+5,R3
	std z+4,R2
	clr R14
	std z+57,R14
	std z+56,R14
;         pkt->ip_addr = ipaddr;  /* Returned IP Address, end of answer */
	ldd R2,y+30
	ldd R3,y+31
	ldd R4,y+32
	ldd R5,y+33
	std z+58,R2
	std z+59,R3
	std z+60,R4
	std z+61,R5
;         NutUdpSendTo(sock, raddr, 137, pkt, sizeof(WINSHEADER));        /* send to netbios port */
	ldi R24,62
	ldi R25,0
	std y+7,R25
	std y+6,R24
	movw R0,R30
	std y+5,R1
	std y+4,R0
	ldi R24,137
	std y+3,R25
	std y+2,R24
	ldd R2,y+10
	ldd R3,y+11
	ldd R4,y+12
	ldd R5,y+13
	std y+0,R4
	std y+1,R5
	movw R18,R2
	movw R16,R12
	xcall _NutUdpSendTo
;         memset(pkt, 0, sizeof(WINSHEADER));
	ldi R24,62
	ldi R25,0
	std y+1,R25
	std y+0,R24
	clr R18
	clr R19
	ldd R16,y+16
	ldd R17,y+17
	xcall _memset
;     }
	xjmp L21
X15:
L2:
	.dbline 0 ; func end
	adiw R28,18
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
; }
; 
; /*@}*/
