	.module dhcpc.c
	.area text(rom, con, rel)
;            len -> R20,R21
;            src -> R12,R13
;            dst -> R10,R11
	.even
_copy_str:
	xcall push_xgset303C
	movw R12,R18
	movw R10,R16
	sbiw R28,2
	ldd R20,y+8
	ldd R21,y+9
; /*
;  * Copyright (C) 2001-2005 by egnite Software GmbH. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY EGNITE SOFTWARE GMBH AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL EGNITE
;  * SOFTWARE GMBH OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.ethernut.de/
;  *
;  * -
;  * Portions Copyright (c) 1983, 1993 by
;  *  The Regents of the University of California.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the University nor the names of its contributors
;  *    may be used to endorse or promote products derived from this software
;  *    without specific prior written permission.
;  *
;  * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
;  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
;  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
;  * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
;  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
;  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
;  * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
;  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
;  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
;  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  * -
;  * Portions Copyright (c) 1993 by Digital Equipment Corporation.
;  *
;  * Permission to use, copy, modify, and distribute this software for any
;  * purpose with or without fee is hereby granted, provided that the above
;  * copyright notice and this permission notice appear in all copies, and that
;  * the name of Digital Equipment Corporation not be used in advertising or
;  * publicity pertaining to distribution of the document or software without
;  * specific, written prior permission.
;  * 
;  * THE SOFTWARE IS PROVIDED "AS IS" AND DIGITAL EQUIPMENT CORP. DISCLAIMS ALL
;  * WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES
;  * OF MERCHANTABILITY AND FITNESS.   IN NO EVENT SHALL DIGITAL EQUIPMENT
;  * CORPORATION BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
;  * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
;  * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
;  * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
;  * SOFTWARE.
;  */
; 
; /*!
;  * \file pro/dhcpc.c
;  * \brief DHCP client.
;  *
;  * \verbatim
;  *
;  * $Log: dhcpc.c,v $
;  * Revision 1.19.2.1  2006/02/02 14:09:40  haraldkipp
;  * Added required typecasts before left shift.
;  * BOOTP and DYNCFG structures must be packed.
;  * Fixed memory alignment bug, which retrieved wrong values from DHCP options.
;  *
;  * Revision 1.19  2005/08/02 17:47:04  haraldkipp
;  * Major API documentation update.
;  *
;  * Revision 1.18  2005/04/05 17:44:57  haraldkipp
;  * Made stack space configurable.
;  *
;  * Revision 1.17  2005/03/28 18:26:59  mrjones4u
;  * Fixed non-release bug in DCHP client
;  *
;  * Revision 1.16  2005/02/03 14:33:56  haraldkipp
;  * Several bug fixes and enhancements. The most important fix will
;  * avoid hanging, when Ethernut is reset while ICMP pings are
;  * received. A large number of changes make the client to follow
;  * RFC 2131 more closely, like maintaining renewal and rebind time.
;  * Two new API calls, NutDhcpStatus() and NutDhcpError(), allow
;  * to query the current status of the DHCP client. The previously
;  * introduced API call NutDhcpIsConfigured() has been marked
;  * deprecated. Another problem was with timeout, because the client
;  * continued negotiation with the server after the timeout time
;  * given in the API called elapsed. Now all internal timeouts are
;  * adjusted to the API timeout. Furthermore the previous version
;  * let the client continue on fatal errors like UDP receive or UDP
;  * broadcast failures. Now the client stops on such errors and
;  * informs the caller. Finally the documentation has been enhanced.
;  *
;  * Revision 1.15  2004/12/31 10:51:40  drsung
;  * Bugfixes from Michel Hendriks applied:
;  * Allocate empty dyncfg's to prevent freeing twice of domain/hostname
;  * Clear pointer after ReleaseDynCfg to prevent freeing twice
;  * Make sure SelectOffer is never called with 0 offers
;  * When falling back from rebooting to selecting, clear
;  * the received ip address so NutDhcpIfConfig does not
;  * assume it has been configured properly
;  *
;  * Revision 1.14  2004/04/15 07:16:47  drsung
;  * Now it works... :-/
;  *
;  * Revision 1.13  2004/04/15 07:11:50  drsung
;  * Added hostname support to NutDHCPDiscover
;  *
;  * Revision 1.12  2004/03/18 11:24:01  haraldkipp
;  * Deprecated functions removed
;  *
;  * Revision 1.11  2004/03/03 17:53:28  drsung
;  * Support for new field 'hostname' in structure confos added.
;  *
;  * Revision 1.10  2004/02/25 16:34:32  haraldkipp
;  * New API added to relinguish the DHCP lease. Collecting more
;  * than one offer is now disabled, if the application sets timeout
;  * below three times of MAX_DHCP_WAIT (5 seconds). The lease renewal
;  * will now start when 3/4 has elapsed, opposed to 1/2 used previously.
;  * Finally the DHCP thread will sleep as long as possible, while the
;  * previous version woke up every ten seconds.
;  *
;  * Revision 1.9  2004/02/02 18:54:43  drsung
;  * gateway ip address was not set, if static network configuration from EEPROM is used.
;  *
;  * Revision 1.8  2004/01/14 17:50:41  drsung
;  * Fix for Win2k DHCP server applied. Thanks to Damian Slee
;  *
;  * Revision 1.7  2003/11/03 16:22:59  haraldkipp
;  * Renewal disabled if lease time is set to zero
;  *
;  * Revision 1.6  2003/10/13 10:18:08  haraldkipp
;  * Using new seconds counter
;  *
;  * Revision 1.5  2003/08/07 09:09:08  haraldkipp
;  * Redesign to follow RFC 2131 more closely.
;  *
;  * Revision 1.4  2003/07/20 18:25:40  haraldkipp
;  * Support secondary DNS.
;  *
;  * Revision 1.3  2003/07/17 09:44:14  haraldkipp
;  * Removed default MAC address and let the caller have a second chance.
;  *
;  * Revision 1.2  2003/05/15 14:25:38  haraldkipp
;  * Some DHCP servers discard discover telegrams.
;  * Thanks to Tomohiro Haraikawa.
;  *
;  * Revision 1.1.1.1  2003/05/09 14:41:57  haraldkipp
;  * Initial using 3.2.1
;  *
;  * \endverbatim
;  */
; 
; #include <sys/thread.h>
; #include <sys/event.h>
; #include <sys/timer.h>
; #include <sys/confnet.h>
; #include <sys/confos.h>
; 
; #include <stdlib.h>
; #include <string.h>
; #include <time.h>
; 
; #include <arpa/inet.h>
; #include <netinet/in.h>
; #include <netdb.h>
; #include <net/route.h>
; #include <sys/socket.h>
; #include <pro/dhcp.h>
; 
; #ifdef NUTDEBUG
; #include <net/netdebug.h>
; #endif
; 
; #if 0
; /* Use for local debugging. */
; #define NUTDEBUG
; #include <stdio.h>
; #define __tcp_trs stdout
; static u_char __tcp_trf = 1;
; #endif
; 
; /*!
;  * \addtogroup xgDHCPC
;  */
; /*@{*/
; 
; /*!
;  * \name DHCP Client Configuration
;  *
;  * The Nut/OS Configurator may be used to override the default values.
;  */
; /*@{*/
; 
; /*!
;  * \brief UDP port of DHCP server.
;  *
;  * \showinitializer
;  */
; #ifndef DHCP_SERVERPORT
; #define DHCP_SERVERPORT      67
; #endif
; 
; /*!
;  * \brief UDP port of DHCP client.
;  *
;  * \showinitializer
;  */
; #ifndef DHCP_CLIENTPORT
; #define DHCP_CLIENTPORT      68
; #endif
; 
; /*!
;  * \brief Maximum DHCP message size we can accept.
;  *
;  * RFC 2131 demands, that a DHCP client must be prepared to receive DHCP 
;  * messages with an options field length of at least 312 octets. This
;  * implies that we must be able to accept messages of up to 576 octets.
;  *
;  * \showinitializer
;  */
; #ifndef MAX_DHCP_MSGSIZE
; #define MAX_DHCP_MSGSIZE    576
; #endif
; 
; /*!
;  * \brief Minimum DHCP message length.
;  *
;  * Used to maintain BOOTP compatibility of outgoing messages.
;  *
;  * \showinitializer
;  */
; #ifndef MIN_DHCP_MSGSIZE
; #define MIN_DHCP_MSGSIZE    300
; #endif
; 
; /*!
;  * \brief Maximum UDP buffer size used by the DHCP client.
;  *
;  * If this item is not equal zero, the DHCP client will use its value to 
;  * set #SO_RCVBUF by calling NutUdpSetSockOpt().
;  *
;  * If this item is set to zero, NutUdpSetSockOpt() is not called and the 
;  * UDP socket interface will buffer the last incoming datagram on the 
;  * #DHCP_CLIENTPORT socket port only. Any previously received datagram is 
;  * silently discarded. As long as one DHCP server is expected in the local
;  * network, this will be fine and save some heap memory while DHCP is
;  * active.
;  *
;  * \showinitializer
;  */
; #ifndef MAX_DHCP_BUFSIZE
; #define MAX_DHCP_BUFSIZE    1728
; #endif
; 
; /*!
;  * \brief Minimum number of milliseconds to wait for a response.
;  *
;  * If we receive no response from a DHCP server within this time, we 
;  * will double this value up to \ref MAX_DHCP_WAIT and repeat our 
;  * request up to \ref MAX_DCHP_RETRIES times before giving up.
;  *
;  * \showinitializer
;  */
; #ifndef MIN_DHCP_WAIT
; #define MIN_DHCP_WAIT       4000
; #endif
; 
; /*!
;  * \brief Maximum number of milliseconds to wait for a response.
;  *
;  * The timeout value for receiving server responses will be doubled
;  * on each retry but limited by this value.
;  *
;  * \showinitializer
;  */
; #ifndef MAX_DHCP_WAIT
; #define MAX_DHCP_WAIT       64000
; #endif
; 
; /*!
;  * \brief Maximum number of request retries.
;  *
;  * We will give up after resending this number of requests without 
;  * receiving a response.
;  *
;  * \showinitializer
;  */
; #ifndef MAX_DCHP_RETRIES
; #define MAX_DCHP_RETRIES    3
; #endif
; 
; /*!
;  * \brief Maximum number of release retries.
;  *
;  * RFC 2131 doesn't specify a server response to release messages from
;  * the client. If the message gets lost, then the lease isn't released.
;  *
;  * \showinitializer
;  */
; #ifndef MAX_DCHP_RELEASE_RETRIES
; #define MAX_DCHP_RELEASE_RETRIES    0
; #endif
; 
; /*!
;  * \brief Default lease time in seconds.
;  *
;  * This value is used if the server doesn't provide a lease time.
;  *
;  * \showinitializer
;  */
; #ifndef DHCP_DEFAULT_LEASE
; #define DHCP_DEFAULT_LEASE  43200
; #endif
; 
; /*!
;  * \brief Maximum sleep time in seconds.
;  *
;  * \showinitializer
;  */
; #ifndef MAX_DHCP_NAPTIME
; #define MAX_DHCP_NAPTIME    4294967
; #endif
; 
; /*!
;  * \brief Stack size of the DHCP client thread.
;  *
;  * \showinitializer
;  */
; #ifndef NUT_THREAD_DHCPSTACK
; #define NUT_THREAD_DHCPSTACK    512
; #endif
; 
; /*@}*/
; 
; /*!
;  * \name DHCP Message Types
;  *
;  * See RFC 2131.
;  */
; /*@{*/
; 
; /*! \brief Client broadcast to locate available servers.
;  */
; #define DHCP_DISCOVER   1
; 
; /*! \brief Server to client in response to DHCP_DISCOVER.
;  *
;  * Contains an offer of configuration parameters.
;  */
; #define DHCP_OFFER      2
; 
; /*! \brief Client message to servers.
;  *
;  * Used for 
;  * - requesting offered parameters from one server and implicitly declining offers from all others.
;  * - confirming correctness of previously allocated address after, e.g., system reboot.
;  * - extending the lease on a particular network address.
;  */
; #define DHCP_REQUEST    3
; 
; /*! \brief Client to server indicating network address is already in use.
;  *
;  * Not used by Nut/Net.
;  */
; #define DHCP_DECLINE    4
; 
; /*! \brief Server to client with configuration parameters.
;  *
;  * Contains committed network address.
;  */
; #define DHCP_ACK        5
; 
; /*! \brief Server to client indicating client's notion of network address is incorrect.
;  *
;  * May be caused by the client's move to new subnet or by expiration of the client's lease.
;  */
; #define DHCP_NAK        6
; 
; /*! \brief Client to server relinquishing network address and cancelling remaining lease.
;  */
; #define DHCP_RELEASE    7
; 
; /*! \brief Client to server, asking only for local configuration parameters.
;  *
;  * Used, if the client already has externally configured network address.
;  */
; #define DHCP_INFORM     8
; 
; /*@}*/
; 
; 
; /*!
;  * \name DHCP Options
;  *
;  * Nut/Net recognizes a subset of options defined in RFC 2132.
;  */
; /*@{*/
; 
; /*!
;  * \brief DHCP pad option.
;  *
;  * The pad option can be used to cause subsequent fields to align on 
;  * word boundaries.
;  */
; #define DHCPOPT_PAD          0
; 
; /*!
;  * \brief DHCP subnet mask option.
;  */
; #define DHCPOPT_NETMASK      1
; 
; /*!
;  * \brief DHCP router option.
;  */
; #define DHCPOPT_GATEWAY      3
; 
; /*!
;  * \brief DHCP domain name server option.
;  */
; #define DHCPOPT_DNS          6
; 
; /*!
;  * \brief DHCP host name option.
;  */
; #define DHCPOPT_HOSTNAME     12
; 
; /*!
;  * \brief DHCP domain name option.
;  */
; #define DHCPOPT_DOMAIN       15
; 
; /*!
;  * \brief DHCP broadcast address option.
;  */
; #define DHCPOPT_BROADCAST    28
; 
; /*!
;  * \brief DHCP requested IP address option.
;  */
; #define DHCPOPT_REQESTIP     50
; 
; /*!
;  * \brief DHCP IP address lease time option.
;  */
; #define DHCPOPT_LEASETIME    51
; 
; /*!
;  * \brief DHCP message type option.
;  */
; #define DHCPOPT_MSGTYPE      53
; 
; /*!
;  * \brief DHCP server identifier option.
;  */
; #define DHCPOPT_SID          54
; 
; /*!
;  * \brief DHCP parameter request list option.
;  */
; #define DHCPOPT_PARAMREQUEST 55
; 
; /*!
;  * \brief Maximum DHCP message size option.
;  */
; #define DHCPOPT_MAXMSGSIZE   57
; 
; /*!
;  * \brief DHCP renewal time option.
;  */
; #define DHCPOPT_RENEWALTIME  58
; 
; /*!
;  * \brief DHCP rebinding time option.
;  */
; #define DHCPOPT_REBINDTIME   59
; 
; /*!
;  * \brief DHCP end option.
;  */
; #define DHCPOPT_END          255
; 
; /*@}*/
; 
; /*!
;  * \brief BOOTP message structure type.
;  */
; typedef struct __attribute__ ((packed)) bootp BOOTP;
; 
; /*!
;  * \brief BOOTP message structure.
;  */
; struct __attribute__ ((packed)) bootp {
;     u_char bp_op;               /*!< \brief Packet opcode type: 1=request, 2=reply */
;     u_char bp_htype;            /*!< \brief Hardware address type: 1=Ethernet */
;     u_char bp_hlen;             /*!< \brief Hardware address length: 6 for Ethernet */
;     u_char bp_hops;             /*!< \brief Gateway hops */
;     u_long bp_xid;              /*!< \brief Transaction ID */
;     u_short bp_secs;            /*!< \brief Seconds since boot began */
;     u_short bp_flags;           /*!< \brief RFC1532 broadcast, etc. */
;     u_long bp_ciaddr;           /*!< \brief Client IP address */
;     u_long bp_yiaddr;           /*!< \brief 'Your' IP address */
;     u_long bp_siaddr;           /*!< \brief Server IP address */
;     u_long bp_giaddr;           /*!< \brief Gateway IP address */
;     u_char bp_chaddr[16];       /*!< \brief Client hardware address */
;     char bp_sname[64];          /*!< \brief Server host name */
;     char bp_file[128];          /*!< \brief Boot file name */
;     u_char bp_options[312];     /*!< \brief Vendor-specific area */
; };
; 
; /*!
;  * \brief Dynamic configuration structure type.
;  */
; typedef struct __attribute__ ((packed)) dyn_cfg DYNCFG;
; 
; /*!
;  * \brief Dynamic configuration structure.
;  */
; struct __attribute__ ((packed)) dyn_cfg {
;     u_char dyn_msgtyp;          /*!< \brief DHCP message type */
;     u_long dyn_yiaddr;          /*!< \brief Offered IP address. */
;     u_long dyn_netmask;         /*!< \brief Local IP netmask. */
;     u_long dyn_broadcast;       /*!< \brief Local IP broadcast address. */
;     u_long dyn_gateway;         /*!< \brief Default gate IP address. */
;     u_long dyn_pdns;            /*!< \brief Primary DNS IP address. */
;     u_long dyn_sdns;            /*!< \brief Secondary DNS IP address. */
;     u_long dyn_sid;             /*!< \brief Server identifier. */
;     u_long dyn_renewalTime;     /*!< \brief Renewal time in seconds. */
;     u_long dyn_rebindTime;      /*!< \brief Rebind time in seconds. */
;     u_long dyn_leaseTime;       /*!< \brief Offered lease time in seconds. */
;     u_char *dyn_hostname;       /*!< \brief Local hostname. */
;     u_char *dyn_domain;         /*!< \brief Name of local domain. */
; };
; 
; /*!
;  * \brief Current configuration.
;  *
;  * This structure is filled by parsing offer or acknowledge messages from
;  * the server.
;  */
; static DYNCFG *dhcpConfig;
; 
; /*! 
;  * \brief Client thread identifier.
;  *
;  * Used to determine if the client thread is running. Zero indicates that
;  * it is not.
;  */
; static HANDLE dhcpThread;
; 
; /*!
;  * \brief Current state of the DHCP client state machine.
;  */
; static u_char dhcpState;
; 
; /*!
;  * \brief Latest DHCP error code.
;  */
; static int dhcpError;
; 
; /*!
;  * \brief DHCP wake up queue.
;  *
;  * The DHCP state machine can be woken up by posting to this queue.
;  */
; static HANDLE dhcpWake;
; 
; /*!
;  * \brief DHCP waiting queue.
;  *
;  * Application threads wait on this queue until DHCP success or failure.
;  */
; static HANDLE dhcpDone;
; 
; /*!
;  * \brief Maximum number of milliseconds to wait on \ref dhcpDone.
;  *
;  * Specified by the application when calling the DHCP client API.
;  */
; static u_long dhcpApiTimeout;
; 
; /*!
;  * \brief Time at which the application started to wait.
;  *
;  * Used in conjunction with \ref dhcpApiTimeout to limit the maximum 
;  * wait time for server responses.
;  */
; static u_long dhcpApiStart;
; 
; /*!
;  * \brief DHCP device.
;  *
;  * The ARM port doesn't provide parameter passing to thread routines.
;  * Thus we use a global variable to store the NUTDEVICE pointer.
;  */
; #ifdef __arm__
; static NUTDEVICE *dhcpDev;
; #endif
; 
; /*!
;  * \brief Dynamic string copy.
;  *
;  * \param dst Points to a string pointer. If the pointer is not NULL, it
;  *            is assumed that it points to a previously allocated buffer
;  *            and this buffer will be released first. Then a new buffer
;  *            will be allocated and the source string will be copied to
;  *            this buffer.
;  * \param src The source string. No delimiter required.
;  * \param len Length of the source string.
;  */
; static void copy_str(u_char ** dst, void *src, int len)
; {
;     if (*dst) {
	movw R30,R10
	ldd R2,z+0
	ldd R3,z+1
	tst R2
	brne X0
	tst R3
	breq L2
X0:
;         free(*dst);
	ldd R16,z+0
	ldd R17,z+1
	xcall _free_M
;     }
L2:
;     if ((*dst = malloc(len + 1)) != 0) {
	movw R16,R20
	subi R16,255  ; offset = 1
	sbci R17,255
	xcall _malloc_M
	movw R30,R10
	std z+1,R17
	std z+0,R16
	cpi R16,0
	cpc R16,R17
	breq L4
X1:
;         if (len) {
	cpi R20,0
	cpc R20,R21
	breq L6
X2:
;             memcpy(*dst, src, len);
	std y+1,R21
	std y+0,R20
	movw R18,R12
	xcall _memcpy
;         }
L6:
;         *(*dst + len) = 0;
	movw R30,R10
	ldd R2,z+0
	ldd R3,z+1
	movw R30,R20
	add R30,R2
	adc R31,R3
	clr R2
	std z+0,R2
;     }
L4:
L1:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgset303C
;         dyncfg -> R20,R21
	.even
_ReleaseDynCfg:
	st -y,R20
	st -y,R21
	movw R20,R16
; }
; 
; /*!
;  * \brief Release DYNCFG structure.
;  *
;  * Frees all memory occupied by a \ref DYNCFG structure.
;  *
;  * \param dyncfg This structure will be released.
;  */
; static void ReleaseDynCfg(DYNCFG * dyncfg)
; {
;     if (dyncfg) {
	cpi R20,0
	cpc R20,R21
	breq L9
X3:
;         if (dyncfg->dyn_hostname) {
	movw R30,R20
	ldd R2,z+41
	ldd R3,z+42
	tst R2
	brne X4
	tst R3
	breq L11
X4:
;             free(dyncfg->dyn_hostname);
	ldd R16,z+41
	ldd R17,z+42
	xcall _free_M
;         }
L11:
;         if (dyncfg->dyn_domain) {
	movw R30,R20
	ldd R2,z+43
	ldd R3,z+44
	tst R2
	brne X5
	tst R3
	breq L13
X5:
;             free(dyncfg->dyn_domain);
	ldd R16,z+43
	ldd R17,z+44
	xcall _free_M
;         }
L13:
;         free(dyncfg);
	movw R16,R20
	xcall _free_M
;     }
L9:
L8:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
;           lval -> y+2
;             ol -> R10
;           cfgp -> y+8
;           left -> R14,R15
;             op -> y+6
;            len -> R10,R11
;             bp -> R12,R13
	.even
_ParseReply:
	xcall push_xgsetF0FC
	movw R10,R18
	movw R12,R16
	sbiw R28,10
; }
; 
; /*!
;  * \brief Parse a DHCP reply message.
;  *
;  * \param bp  Pointer to the reply message. The caller must make sure,
;  *            that this contains a valid BOOTP reply header with at
;  *            least five bytes in the options field.
;  * \param len Number of valid bytes in the reply message.
;  *
;  * \return Pointer to config structure. Must be released by the caller.
;  *         NULL is returned in case of parsing errors.
;  */
; static DYNCFG *ParseReply(BOOTP *bp, int len)
; {
;     u_char *op;
;     int left;
;     DYNCFG *cfgp;
; 
;     /* Allocate and initialize a new structure. */
;     if ((cfgp = malloc(sizeof(DYNCFG))) == 0) {
	ldi R16,45
	ldi R17,0
	xcall _malloc_M
	std y+9,R17
	std y+8,R16
	cpi R16,0
	cpc R16,R17
	brne L16
X6:
;         return 0;
	clr R16
	clr R17
	xjmp L15
L16:
;     }
;     memset(cfgp, 0, sizeof(DYNCFG));
	ldi R24,45
	ldi R25,0
	std y+1,R25
	std y+0,R24
	clr R18
	clr R19
	ldd R16,y+8
	ldd R17,y+9
	xcall _memset
;     cfgp->dyn_leaseTime = DHCP_DEFAULT_LEASE;
	ldi R20,192
	ldi R21,168
	ldi R22,0
	ldi R23,0
	ldd R30,y+8
	ldd R31,y+9
	std z+37,R20
	std z+38,R21
	std z+39,R22
	std z+40,R23
; 
;     /* Set the assigned IP address. */
;     memcpy(&cfgp->dyn_yiaddr, &bp->bp_yiaddr, 4);
	ldi R24,4
	ldi R25,0
	std y+1,R25
	std y+0,R24
	movw R18,R12
	subi R18,240  ; offset = 16
	sbci R19,255
	movw R16,R30
	subi R16,255  ; offset = 1
	sbci R17,255
	xcall _memcpy
; 
;     /* 
;      * Parse options until an end option is found or until we reached
;      * the end of the message.
;      */
;     op = bp->bp_options + 4;
	movw R24,R12
	subi R24,16  ; offset = 240
	sbci R25,255
	std y+7,R25
	std y+6,R24
;     left = len - (sizeof(*bp) - sizeof(bp->bp_options)) - 4;
	movw R24,R10
	subi R24,236
	sbci R25,0
	sbiw R24,4
	movw R14,R24
	xjmp L19
L18:
;     while (*op != DHCPOPT_END && left > 0) {
;         u_char ol;
; 
; #ifdef NUTDEBUG
;         if (__tcp_trf) {
;             fprintf(__tcp_trs, "[DHCP-Opt-%u]", *op);
;         }
; #endif
;         /* Pad option is used for boundary alignment. */
;         if (*op == DHCPOPT_PAD) {
	ldd R30,y+6
	ldd R31,y+7
	ldd R2,z+0
	tst R2
	brne L21
X7:
;             op++;
	movw R24,R30
	adiw R24,1
	std y+7,R25
	std y+6,R24
;             left--;
	movw R24,R14
	sbiw R24,1
	movw R14,R24
;             continue;
	xjmp L19
L21:
;         }
; 
;         /* Reject if option length exceeds total length. */
;         if ((ol = *(op + 1)) > left) {
	ldd R30,y+6
	ldd R31,y+7
	ldd R2,z+1
	mov R10,R2
	clr R3
	cp R14,R2
	cpc R15,R3
	brge L23
X8:
;             break;
	xjmp L20
L23:
;         }
; 
;         /* Type of this message. */
;         if (*op == DHCPOPT_MSGTYPE) {
	ldd R30,y+6
	ldd R31,y+7
	ldd R24,z+0
	cpi R24,53
	brne L25
X9:
;             if (ol != 1) {
	mov R24,R10
	cpi R24,1
	breq L27
X10:
;                 break;
	xjmp L20
L27:
;             }
;             cfgp->dyn_msgtyp = *(op + 2);
	ldd R30,y+6
	ldd R31,y+7
	ldd R2,z+2
	ldd R30,y+8
	ldd R31,y+9
	std z+0,R2
;         }
	xjmp L26
L25:
;         /* Our host name. May or may not include the domain. */
;         else if (*op == DHCPOPT_HOSTNAME) {
	ldd R30,y+6
	ldd R31,y+7
	ldd R24,z+0
	cpi R24,12
	brne L29
X11:
;             copy_str(&cfgp->dyn_hostname, op + 2, ol);
	mov R2,R10
	clr R3
	std y+1,R3
	std y+0,R2
	movw R18,R30
	subi R18,254  ; offset = 2
	sbci R19,255
	ldd R16,y+8
	ldd R17,y+9
	subi R16,215  ; offset = 41
	sbci R17,255
	xcall _copy_str
;         }
	xjmp L30
L29:
;         /* Name of the domain we are in. */
;         else if (*op == DHCPOPT_DOMAIN) {
	ldd R30,y+6
	ldd R31,y+7
	ldd R24,z+0
	cpi R24,15
	brne L31
X12:
;             copy_str(&cfgp->dyn_domain, op + 2, ol);
	mov R2,R10
	clr R3
	std y+1,R3
	std y+0,R2
	movw R18,R30
	subi R18,254  ; offset = 2
	sbci R19,255
	ldd R16,y+8
	ldd R17,y+9
	subi R16,213  ; offset = 43
	sbci R17,255
	xcall _copy_str
;         }
	xjmp L32
L31:
; 
;         /* All remaining options require at least 4 octets. */
;         else if (ol >= 4) {
	mov R24,R10
	cpi R24,4
	brsh X31
	xjmp L33
X31:
X13:
;             /* Preset most often used long value. */
;             u_long lval = *(op + 2);
	ldd R30,y+6
	ldd R31,y+7
	ldd R2,z+2
	clr R3
	clr R4
	clr R5
	std y+2,R2
	std y+3,R3
	std y+4,R4
	std y+5,R5
;             lval += (u_long)(*(op + 3)) << 8;
	ldi R24,8
	ldi R25,0
	ldd R30,y+6
	ldd R31,y+7
	ldd R16,z+3
	clr R17
	clr R18
	clr R19
	st -y,R24
	xcall lsl32
	ldd R2,y+2
	ldd R3,y+3
	ldd R4,y+4
	ldd R5,y+5
	add R2,R16
	adc R3,R17
	adc R4,R18
	adc R5,R19
	std y+2,R2
	std y+3,R3
	std y+4,R4
	std y+5,R5
;             lval += (u_long)(*(op + 4)) << 16;
	ldd R30,y+6
	ldd R31,y+7
	ldd R2,z+4
	clr R3
	clr R4
	clr R5
	movw R4,R2
	clr R2
	clr R3
	ldd R6,y+2
	ldd R7,y+3
	ldd R8,y+4
	ldd R9,y+5
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	std y+2,R6
	std y+3,R7
	std y+4,R8
	std y+5,R9
;             lval += (u_long)(*(op + 5)) << 24;
	ldi R24,24
	ldi R25,0
	ldd R30,y+6
	ldd R31,y+7
	ldd R16,z+5
	clr R17
	clr R18
	clr R19
	st -y,R24
	xcall lsl32
	ldd R2,y+2
	ldd R3,y+3
	ldd R4,y+4
	ldd R5,y+5
	add R2,R16
	adc R3,R17
	adc R4,R18
	adc R5,R19
	std y+2,R2
	std y+3,R3
	std y+4,R4
	std y+5,R5
; 
;             /* Our IP network mask. */
;             if (*op == DHCPOPT_NETMASK) {
	ldd R30,y+6
	ldd R31,y+7
	ldd R24,z+0
	cpi R24,1
	brne L35
X14:
;                 cfgp->dyn_netmask = lval;
	ldd R2,y+2
	ldd R3,y+3
	ldd R4,y+4
	ldd R5,y+5
	ldd R30,y+8
	ldd R31,y+9
	std z+5,R2
	std z+6,R3
	std z+7,R4
	std z+8,R5
;             }
	xjmp L36
L35:
;             /* Our IP broadcast address. */
;             else if (*op == DHCPOPT_BROADCAST) {
	ldd R30,y+6
	ldd R31,y+7
	ldd R24,z+0
	cpi R24,28
	brne L37
X15:
;                 cfgp->dyn_broadcast = lval;
	ldd R2,y+2
	ldd R3,y+3
	ldd R4,y+4
	ldd R5,y+5
	ldd R30,y+8
	ldd R31,y+9
	std z+9,R2
	std z+10,R3
	std z+11,R4
	std z+12,R5
;             }
	xjmp L38
L37:
;             /* Our IP default gate. More than one gateway may be 
;                specified. We take the fist one only and ignore the 
;                rest. */
;             else if (*op == DHCPOPT_GATEWAY) {
	ldd R30,y+6
	ldd R31,y+7
	ldd R24,z+0
	cpi R24,3
	brne L39
X16:
;                 cfgp->dyn_gateway = lval;
	ldd R2,y+2
	ldd R3,y+3
	ldd R4,y+4
	ldd R5,y+5
	ldd R30,y+8
	ldd R31,y+9
	std z+13,R2
	std z+14,R3
	std z+15,R4
	std z+16,R5
;             }
	xjmp L40
L39:
;             /* Our DNS server. Updated by Jelle Martijn Kok to 
;                support a secondary DNS. */
;             else if (*op == DHCPOPT_DNS) {
	ldd R30,y+6
	ldd R31,y+7
	ldd R24,z+0
	cpi R24,6
	breq X32
	xjmp L41
X32:
X17:
;                 cfgp->dyn_pdns = lval;
	ldd R2,y+2
	ldd R3,y+3
	ldd R4,y+4
	ldd R5,y+5
	ldd R30,y+8
	ldd R31,y+9
	std z+17,R2
	std z+18,R3
	std z+19,R4
	std z+20,R5
;                 if (ol >= 8) {
	mov R24,R10
	cpi R24,8
	brsh X33
	xjmp L42
X33:
X18:
;                     cfgp->dyn_sdns = *(op + 6);
	ldd R30,y+6
	ldd R31,y+7
	ldd R2,z+6
	clr R3
	clr R4
	clr R5
	ldd R30,y+8
	ldd R31,y+9
	std z+21,R2
	std z+22,R3
	std z+23,R4
	std z+24,R5
;                     cfgp->dyn_sdns += (u_long)(*(op + 7)) << 8;
	movw R24,R30
	adiw R24,21
	movw R12,R24
	ldi R24,8
	ldi R25,0
	ldd R30,y+6
	ldd R31,y+7
	ldd R16,z+7
	clr R17
	clr R18
	clr R19
	st -y,R24
	xcall lsl32
	movw R30,R12
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	add R2,R16
	adc R3,R17
	adc R4,R18
	adc R5,R19
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;                     cfgp->dyn_sdns += (u_long)(*(op + 8)) << 16;
	ldd R24,y+8
	ldd R25,y+9
	adiw R24,21
	ldd R30,y+6
	ldd R31,y+7
	ldd R2,z+8
	clr R3
	clr R4
	clr R5
	movw R4,R2
	clr R2
	clr R3
	movw R30,R24
	ldd R6,z+0
	ldd R7,z+1
	ldd R8,z+2
	ldd R9,z+3
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	std z+0,R6
	std z+1,R7
	std z+2,R8
	std z+3,R9
;                     cfgp->dyn_sdns += (u_long)(*(op + 9)) << 24;
	ldd R24,y+8
	ldd R25,y+9
	adiw R24,21
	movw R12,R24
	ldi R24,24
	ldi R25,0
	ldd R30,y+6
	ldd R31,y+7
	ldd R16,z+9
	clr R17
	clr R18
	clr R19
	st -y,R24
	xcall lsl32
	movw R30,R12
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	add R2,R16
	adc R3,R17
	adc R4,R18
	adc R5,R19
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
;                 }
;             }
	xjmp L42
L41:
;             /* Server identifier. */
;             else if (*op == DHCPOPT_SID) {
	ldd R30,y+6
	ldd R31,y+7
	ldd R24,z+0
	cpi R24,54
	brne L45
X19:
;                 cfgp->dyn_sid = lval;
	ldd R2,y+2
	ldd R3,y+3
	ldd R4,y+4
	ldd R5,y+5
	ldd R30,y+8
	ldd R31,y+9
	std z+25,R2
	std z+26,R3
	std z+27,R4
	std z+28,R5
;             }
	xjmp L46
L45:
;             /* Renewal time. */
;             else if (*op == DHCPOPT_RENEWALTIME) {
	ldd R30,y+6
	ldd R31,y+7
	ldd R24,z+0
	cpi R24,58
	breq X34
	xjmp L47
X34:
X20:
;                 cfgp->dyn_renewalTime = ntohl(lval);
	ldi R20,0
	ldi R21,255
	ldi R22,0
	ldi R23,0
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R2,R16
	movw R4,R18
	ldi R20,255
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R6,R16
	movw R8,R18
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	ldi R20,0
	ldi R21,0
	ldi R22,255
	ldi R23,0
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,255
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldd R30,y+8
	ldd R31,y+9
	std z+29,R6
	std z+30,R7
	std z+31,R8
	std z+32,R9
;             }
	xjmp L48
L47:
;             /* Rebinding time. */
;             else if (*op == DHCPOPT_REBINDTIME) {
	ldd R30,y+6
	ldd R31,y+7
	ldd R24,z+0
	cpi R24,59
	breq X35
	xjmp L49
X35:
X21:
;                 cfgp->dyn_rebindTime = ntohl(lval);
	ldi R20,0
	ldi R21,255
	ldi R22,0
	ldi R23,0
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R2,R16
	movw R4,R18
	ldi R20,255
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R6,R16
	movw R8,R18
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	ldi R20,0
	ldi R21,0
	ldi R22,255
	ldi R23,0
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,255
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldd R30,y+8
	ldd R31,y+9
	std z+33,R6
	std z+34,R7
	std z+35,R8
	std z+36,R9
;             }
	xjmp L50
L49:
;             /* Total lease time granted. */
;             else if (*op == DHCPOPT_LEASETIME) {
	ldd R30,y+6
	ldd R31,y+7
	ldd R24,z+0
	cpi R24,51
	breq X36
	xjmp L51
X36:
X22:
;                 cfgp->dyn_leaseTime = ntohl(lval);
	ldi R20,0
	ldi R21,255
	ldi R22,0
	ldi R23,0
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R2,R16
	movw R4,R18
	ldi R20,255
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsl32
	movw R6,R16
	movw R8,R18
	or R6,R2
	or R7,R3
	or R8,R4
	or R9,R5
	ldi R20,0
	ldi R21,0
	ldi R22,255
	ldi R23,0
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,8
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,255
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	and R16,R20
	and R17,R21
	and R18,R22
	and R19,R23
	ldi R24,24
	ldi R25,0
	st -y,R24
	xcall lsr32
	or R6,R16
	or R7,R17
	or R8,R18
	or R9,R19
	ldd R30,y+8
	ldd R31,y+9
	std z+37,R6
	std z+38,R7
	std z+39,R8
	std z+40,R9
;             }
L51:
L50:
L48:
L46:
L42:
L40:
L38:
L36:
;         }
L33:
L32:
L30:
L26:
;         op += ol + 2;
	mov R24,R10
	clr R25
	ldd R0,y+6
	ldd R1,y+7
	add R24,R0
	adc R25,R1
	adiw R24,2
	std y+7,R25
	std y+6,R24
;         left -= ol + 2;
	mov R24,R10
	clr R25
	adiw R24,2
	sub R14,R24
	sbc R15,R25
;     }
L19:
	ldd R30,y+6
	ldd R31,y+7
	ldd R24,z+0
	cpi R24,255
	breq L53
X23:
	clr R2
	clr R3
	cp R2,R14
	cpc R3,R15
	brge X37
	xjmp L18
X37:
X24:
L53:
L20:
; 
;     /*
;      * Discard this configuration if parsing stopped before reaching 
;      * the end option or if we didn't receive an expected message type.
;      */
;     if (*op != DHCPOPT_END ||   /* */
	ldd R30,y+6
	ldd R31,y+7
	ldd R24,z+0
	cpi R24,255
	brne L56
X25:
	ldd R30,y+8
	ldd R31,y+9
	ldd R12,z+0
	clr R13
	mov R24,R12
	cpi R24,2
	breq L54
X26:
	cpi R24,5
	breq L54
X27:
	cpi R24,6
	breq L54
X28:
L56:
;         (cfgp->dyn_msgtyp != DHCP_OFFER &&      /* */
;          cfgp->dyn_msgtyp != DHCP_ACK &&        /* */
;          cfgp->dyn_msgtyp != DHCP_NAK)) {
; #ifdef NUTDEBUG
;         if (__tcp_trf) {
;             fprintf(__tcp_trs, "[DHCP-Parse Error]");
;         }
; #endif
;         ReleaseDynCfg(cfgp);
	ldd R16,y+8
	ldd R17,y+9
	xcall _ReleaseDynCfg
;         return 0;
	clr R16
	clr R17
	xjmp L15
L54:
;     }
; 
;     /* Calculate renewal and rebind times. */
;     if (cfgp->dyn_renewalTime == 0) {
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R30,y+8
	ldd R31,y+9
	ldd R2,z+29
	ldd R3,z+30
	ldd R4,z+31
	ldd R5,z+32
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brne L57
X29:
;         cfgp->dyn_renewalTime = cfgp->dyn_leaseTime / 2;
	ldd R2,z+37
	ldd R3,z+38
	ldd R4,z+39
	ldd R5,z+40
	lsr R5
	ror R4
	ror R3
	ror R2
	std z+29,R2
	std z+30,R3
	std z+31,R4
	std z+32,R5
;     }
L57:
;     if (cfgp->dyn_rebindTime == 0) {
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R30,y+8
	ldd R31,y+9
	ldd R2,z+33
	ldd R3,z+34
	ldd R4,z+35
	ldd R5,z+36
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brne L59
X30:
;         cfgp->dyn_rebindTime = cfgp->dyn_renewalTime +  /* */
	ldd R2,z+29
	ldd R3,z+30
	ldd R4,z+31
	ldd R5,z+32
	std y+2,R2
	std y+3,R3
	std y+4,R4
	std y+5,R5
	ldi R24,2
	ldi R25,0
	ldd R16,y+2
	ldd R17,y+3
	ldd R18,y+4
	ldd R19,y+5
	st -y,R24
	xcall lsr32
	ldd R2,y+2
	ldd R3,y+3
	ldd R4,y+4
	ldd R5,y+5
	lsr R5
	ror R4
	ror R3
	ror R2
	ldd R6,y+2
	ldd R7,y+3
	ldd R8,y+4
	ldd R9,y+5
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	add R6,R16
	adc R7,R17
	adc R8,R18
	adc R9,R19
	ldd R30,y+8
	ldd R31,y+9
	std z+33,R6
	std z+34,R7
	std z+35,R8
	std z+36,R9
;             cfgp->dyn_renewalTime / 2 + /* */
;             cfgp->dyn_renewalTime / 4;
;     }
L59:
;     return cfgp;
	ldd R16,y+8
	ldd R17,y+9
L15:
	.dbline 0 ; func end
	adiw R28,10
	xjmp pop_xgsetF0FC
;            len -> R10
;             ov -> y+8
;             ot -> R14
;             op -> R12,R13
	.even
_DhcpAddOption:
	xcall push_xgset00FC
	mov R14,R18
	movw R12,R16
	sbiw R28,2
	ldd R10,y+10
; }
; 
; /*!
;  * \brief Add variable length option.
;  *
;  * \param op  Pointer into the option buffer.
;  * \param ot  Option type.
;  * \param ov  Pointer to buffer to copy from.
;  * \param len Number of octets to copy.
;  *
;  * \return Total number of octets added, include type and length.
;  */
; static size_t DhcpAddOption(u_char * op, u_char ot, void *ov, u_char len)
; {
;     *op++ = ot;
	movw R30,R12
	st Z+,R14
;     *op++ = len;
	st Z+,R10
	movw R12,R30
;     memcpy(op, ov, len);
	mov R2,R10
	clr R3
	std y+1,R3
	std y+0,R2
	ldd R18,y+8
	ldd R19,y+9
	movw R16,R30
	xcall _memcpy
; 
;     return 2 + len;
	mov R16,R10
	clr R17
	subi R16,254  ; offset = 2
	sbci R17,255
L61:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgset00FC
;             ov -> y+0
;             ot -> R18
;             op -> R16,R17
	.even
_DhcpAddByteOption:
; }
; 
; /*!
;  * \brief Add single octet option.
;  *
;  * \param op Pointer into the option buffer.
;  * \param ot Option type.
;  * \param ov Option value.
;  *
;  * \return Total number of octets added, include type and length.
;  */
; static size_t DhcpAddByteOption(u_char * op, u_char ot, u_char ov)
; {
;     *op++ = ot;
	movw R30,R16
	st Z+,R18
;     *op++ = 1;
	ldi R24,1
	st Z+,R24
;     *op++ = ov;
	ldd R0,y+0
	st Z+,R0
; 
;     return 3;
	ldi R16,3
	ldi R17,0
L62:
	.dbline 0 ; func end
	ret
;             ov -> y+6
;             ot -> R12
;             op -> R10,R11
	.even
_DhcpAddShortOption:
	xcall push_xgset003C
	mov R12,R18
	movw R10,R16
	sbiw R28,2
; }
; 
; /*!
;  * \brief Add double octet option.
;  *
;  * \param op Pointer into the option buffer.
;  * \param ot Option type.
;  * \param ov Option value in host byte order. Will be converted to network
;  *           byte order.
;  *
;  * \return Total number of octets added, include type and length.
;  */
; static size_t DhcpAddShortOption(u_char * op, u_char ot, u_short ov)
; {
;     *op++ = ot;
	movw R30,R10
	st Z+,R12
;     *op++ = 2;
	ldi R24,2
	st Z+,R24
	movw R10,R30
;     ov = htons(ov);
	ldd R24,y+6
	ldd R25,y+7
	andi R24,0
	movw R2,R24
	mov R2,R3
	clr R3
	ldd R24,y+6
	ldd R25,y+7
	andi R25,0
	mov R25,R24
	clr R24
	or R24,R2
	or R25,R3
	std y+7,R25
	std y+6,R24
;     memcpy(op, &ov, 2);
	ldi R24,2
	ldi R25,0
	std y+1,R25
	std y+0,R24
	movw R18,R28
	subi R18,250  ; offset = 6
	sbci R19,255
	movw R16,R30
	xcall _memcpy
; 
;     return 4;
	ldi R16,4
	ldi R17,0
L63:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgset003C
;             op -> R16,R17
	.even
_DhcpAddParmReqOption:
; }
; 
; /*!
;  * \brief Add parameter request option.
;  *
;  * RFC 2131 demands to use the same parameter request in discover and
;  * request messages.
;  *
;  * \param op Pointer into the option buffer.
;  * \param ot Option type.
;  * \param ov Option value in host byte order.
;  *
;  * \return Total number of octets added, include type and length.
;  */
; static size_t DhcpAddParmReqOption(u_char * op)
; {
;     *op++ = DHCPOPT_PARAMREQUEST;
	ldi R24,55
	movw R30,R16
	st Z+,R24
;     *op++ = 3;                  /* Adjust when adding more options! */
	ldi R24,3
	st Z+,R24
;     *op++ = DHCPOPT_NETMASK;    /* Typically sent by default, but play safe. */
	ldi R24,1
	st Z+,R24
;     *op++ = DHCPOPT_GATEWAY;    /* We want a default gateway. */
	ldi R24,3
	st Z+,R24
;     *op++ = DHCPOPT_DNS;        /* We want the DNS' IP. */
	ldi R24,6
	st Z+,R24
;     return 5;                   /* Adjust when adding more options! */
	ldi R16,5
	ldi R17,0
L64:
	.dbline 0 ; func end
	ret
;             op -> R20,R21
;           secs -> R22,R23
;         ciaddr -> y+12
;            xid -> y+8
;         msgtyp -> R10
;             bp -> R20,R21
	.even
_DhcpPrepHeader:
	xcall push_xgsetF00C
	mov R10,R18
	movw R20,R16
	sbiw R28,2
	ldd R22,y+16
	ldd R23,y+17
; }
; 
; /*!
;  * \brief Prepare a BOOTP request message header.
;  *
;  * A BOOTP header will be initialized at the specified buffer address
;  * and the routine will add the DHCP magic cookie (RFC 1497) and an
;  * additional option containing the specified DHCP message type.
;  *
;  * All other fields are cleared to zero.
;  *
;  * \param bp     Pointer to the buffer to initialize.
;  * \param msgtyp DHCP message type, either \ref DHCP_DISCOVER, 
;  *               \ref DHCP_REQUEST or \ref DHCP_RELEASE.
;  * \param xid    Random transaction identifier.
;  * \param ciaddr Our IP address. Should be set to zero unless we are in
;  *               BOUND, RENEW or REBINDING state and can respond to ARP 
;  *               requests.
;  * \param secs   Seconds elapsed, since we began address acquisition or 
;  *               renewal.
;  *
;  * \return Total number of octets added.
;  */
; static u_int DhcpPrepHeader(BOOTP *bp, u_char msgtyp, u_long xid, u_long ciaddr, u_short secs)
; {
;     u_char *op;
; 
;     memset(bp, 0, sizeof(*bp));
	ldi R24,548
	ldi R25,2
	std y+1,R25
	std y+0,R24
	clr R18
	clr R19
	movw R16,R20
	xcall _memset
;     /* Clients send bootp requests (op code 1) only. */
;     bp->bp_op = 1;
	ldi R24,1
	movw R30,R20
	std z+0,R24
;     /* Ethernet addresses are type 1 with 6 octets. */
;     bp->bp_htype = 1;
	std z+1,R24
;     bp->bp_hlen = 6;
	ldi R24,6
	std z+2,R24
;     memcpy(bp->bp_chaddr, confnet.cdn_mac, 6);
	clr R25
	std y+1,R25
	std y+0,R24
	ldi R18,<_confnet+10
	ldi R19,>_confnet+10
	movw R16,R30
	subi R16,228  ; offset = 28
	sbci R17,255
	xcall _memcpy
;     /* Transaction identifier. */
;     bp->bp_xid = xid;
	ldd R2,y+8
	ldd R3,y+9
	ldd R4,y+10
	ldd R5,y+11
	movw R30,R20
	std z+4,R2
	std z+5,R3
	std z+6,R4
	std z+7,R5
;     /* Seconds elapsed since address acquisition. */
;     bp->bp_secs = htons(secs);
	movw R24,R22
	andi R24,0
	movw R2,R24
	mov R2,R3
	clr R3
	movw R24,R22
	andi R25,0
	movw R4,R24
	mov R5,R4
	clr R4
	or R4,R2
	or R5,R3
	std z+9,R5
	std z+8,R4
; 
; #ifdef DHCP_BROADCAST_FLAG
;     /*
;      * We do not need the broadcast flag, because our stack accepts IP 
;      * messages to any destination if no local address has been assigned,
;      * However, we continue supporting this compile time option.
;      */
;     bp->bp_flags = htons(0x8000);
; #endif
; 
;     bp->bp_ciaddr = ciaddr;
	ldd R2,y+12
	ldd R3,y+13
	ldd R4,y+14
	ldd R5,y+15
	std z+12,R2
	std z+13,R3
	std z+14,R4
	std z+15,R5
; 
;     /* Add the DHCP magic cookie according to RFC 1497. */
;     op = bp->bp_options;
	subi R20,20  ; offset = 236
	sbci R21,255
;     *op++ = 0x63;
	ldi R24,99
	movw R30,R20
	st Z+,R24
;     *op++ = 0x82;
	ldi R24,130
	st Z+,R24
;     *op++ = 0x53;
	ldi R24,83
	st Z+,R24
;     *op++ = 0x63;
	ldi R24,99
	st Z+,R24
	movw R20,R30
; 
;     /* Add the DHCP message type option. */
;     return DhcpAddByteOption(op, DHCPOPT_MSGTYPE, msgtyp) + 4;
	std y+0,R10
	ldi R18,53
	movw R16,R30
	xcall _DhcpAddByteOption
	subi R16,252  ; offset = 4
	sbci R17,255
L65:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgsetF00C
;            len -> R22,R23
;             bp -> R20,R21
;           addr -> y+14
;           sock -> R10,R11
	.even
_DhcpSendMessage:
	st -y,r19
	st -y,r18
	xcall push_xgsetF00C
	movw R10,R16
	sbiw R28,8
	ldd R20,y+18
	ldd R21,y+19
	ldd R22,y+20
	ldd R23,y+21
; }
; 
; /*!
;  * \brief Send a DHCP message to the server.
;  *
;  * This routine will also add an end of option identifier and take care,
;  * that the message length will not fall below the minimum expected by 
;  * BOOTP.
;  *
;  * \param sock Socket descriptor. This pointer must have been 
;  *             retrieved by calling NutUdpCreateSocket().
;  * \param addr Destination IP addres.
;  * \param bp   Pointer to a buffer to be used for transmission.
;  *             Must contain a fully initialized header and option
;  *             fields.
;  * \param len  Total number of DHCP option octets.
;  *
;  * \return 0 on success. On errors -1 is returned and \ref dhcpError will
;  *         be set to \ref DHCPERR_TRANSMIT.
;  */
; static int DhcpSendMessage(UDPSOCKET * sock, u_long addr, BOOTP *bp, size_t len)
; {
;     /* Add 'end of options'. */
;     bp->bp_options[len++] = DHCPOPT_END;
	movw R2,R22
	subi R22,255  ; offset = 1
	sbci R23,255
	movw R24,R20
	subi R24,20  ; offset = 236
	sbci R25,255
	movw R30,R2
	add R30,R24
	adc R31,R25
	ldi R24,255
	std z+0,R24
; 
;     /* Maintain a BOOTP compatible minimum packet size of 300 octets. 
;        Thanks to Tomohiro Haraikawa. */
;     if ((len += sizeof(BOOTP) - sizeof(bp->bp_options)) < MIN_DHCP_MSGSIZE) {
	movw R24,R22
	subi R24,20  ; offset = 236
	sbci R25,255
	movw R22,R24
	cpi R22,44
	ldi R30,1
	cpc R23,R30
	brsh L68
X38:
;         len = MIN_DHCP_MSGSIZE;
	ldi R22,300
	ldi R23,1
;     }
L68:
; #ifdef NUTDEBUG
;     if (__tcp_trf) {
;         fprintf(__tcp_trs, "[DHCP-Send to %s]", inet_ntoa(addr));
;     }
; #endif
;     if (NutUdpSendTo(sock, addr, DHCP_SERVERPORT, bp, len) < 0) {
	std y+7,R23
	std y+6,R22
	std y+5,R21
	std y+4,R20
	ldi R24,67
	ldi R25,0
	std y+3,R25
	std y+2,R24
	ldd R2,y+14
	ldd R3,y+15
	ldd R4,y+16
	ldd R5,y+17
	std y+0,R4
	std y+1,R5
	movw R18,R2
	movw R16,R10
	xcall _NutUdpSendTo
	movw R20,R16
	cpi R16,0
	ldi R30,0
	cpc R17,R30
	brge L70
X39:
;         dhcpError = DHCPERR_TRANSMIT;
	ldi R24,19
	ldi R25,0
	sts _dhcpError+1,R25
	sts _dhcpError,R24
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L67
L70:
;     }
;     return 0;
	clr R16
	clr R17
L67:
	.dbline 0 ; func end
	adiw R28,8
	xcall pop_xgsetF00C
	adiw R28,2
	ret
;           addr -> y+20
;           port -> y+18
;           etim -> y+14
;             rc -> R10,R11
;           wtim -> y+10
;            tmo -> y+40
;             bp -> R12,R13
;            xid -> y+34
;           sock -> R14,R15
	.even
_DhcpRecvMessage:
	st -y,r19
	st -y,r18
	xcall push_xgsetF0FC
	movw R14,R16
	sbiw R28,24
	ldd R12,y+38
	ldd R13,y+39
; }
; 
; /*!
;  * \brief Receive a DHCP reply from the server.
;  *
;  * \param sock Socket descriptor. 
;  * \param xid  Expected transaction identifier. Incoming messages with a
;  *             different identifier are silently discarded.
;  * \param bp   Pointer to the receive buffer.
;  * \param tmo  Maximum number of milliseconds to wait for a valid message.
;  *
;  * \return The number of bytes received, if successful. The return
;  *         value -1 indicates an error, in which case dhcpError is
;  *         set to an error code. On timeout 0 is returned.
;  */
; static int DhcpRecvMessage(UDPSOCKET * sock, u_long xid, BOOTP *bp, u_long tmo)
; {
;     int rc;
;     u_short port;
;     u_long addr;
;     u_long etim;
;     u_long wtim;
; 
;     /* Set our start time. */
;     etim = NutGetMillis();
	xcall _NutGetMillis
	std y+14,R16
	std y+15,R17
	std y+16,R18
	std y+17,R19
;     /* Set the initial receive timeout. */
;     wtim = tmo;
	ldd R2,y+40
	ldd R3,y+41
	ldd R4,y+42
	ldd R5,y+43
	std y+10,R2
	std y+11,R3
	std y+12,R4
	std y+13,R5
;     for (;;) {
L73:
;         rc = NutUdpReceiveFrom(sock, &addr, &port, bp, sizeof(BOOTP), wtim);
	ldd R2,y+10
	ldd R3,y+11
	ldd R4,y+12
	ldd R5,y+13
	std y+6,R2
	std y+7,R3
	std y+8,R4
	std y+9,R5
	ldi R24,548
	ldi R25,2
	std y+5,R25
	std y+4,R24
	std y+3,R13
	std y+2,R12
	movw R24,R28
	adiw R24,18
	std y+1,R25
	std y+0,R24
	movw R18,R28
	subi R18,236  ; offset = 20
	sbci R19,255
	movw R16,R14
	xcall _NutUdpReceiveFrom
	movw R10,R16
; #ifdef NUTDEBUG
;         if (__tcp_trf) {
;             if (rc > 0) {
;                 fprintf(__tcp_trs, "[DHCP-Recv from %s]", inet_ntoa(addr));
;             } else if (rc < 0) {
;                 fprintf(__tcp_trs, "[DHCP-Recv Error]");
;             } else {
;                 fprintf(__tcp_trs, "[DHCP-Recv Timeout %lu]", tmo);
;             }
;         }
; #endif
;         /* Immediately return on receive errors and timeouts. */
;         if (rc <= 0) {
	clr R2
	clr R3
	cp R2,R16
	cpc R3,R17
	brlt L77
X40:
;             if (rc < 0) {
	cpi R16,0
	ldi R30,0
	cpc R17,R30
	brlt X46
	xjmp L75
X46:
X41:
;                 dhcpError = DHCPERR_RECEIVE;
	ldi R24,20
	ldi R25,0
	sts _dhcpError+1,R25
	sts _dhcpError,R24
;             }
;             break;
	xjmp L75
L77:
;         }
;         /* The message must at least include the BOOTP header plus five 
;            bytes of options (magic and end). We are quite liberal here. */
;         if (rc > sizeof(BOOTP) - sizeof(bp->bp_options) + 5) {
	ldi R24,241
	ldi R25,0
	cp R24,R10
	cpc R25,R11
	brsh L81
X42:
;             /* The message must be a BOOTP reply with the expected XID. */
;             if (bp->bp_op == 2 && bp->bp_xid == xid) {
	movw R30,R12
	ldd R24,z+0
	cpi R24,2
	brne L83
X43:
	ldd R2,y+34
	ldd R3,y+35
	ldd R4,y+36
	ldd R5,y+37
	ldd R6,z+4
	ldd R7,z+5
	ldd R8,z+6
	ldd R9,z+7
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	brne L83
X44:
;                 /* Message is acceptable. */
;                 break;
	xjmp L75
L83:
;             }
;         }
L81:
;         /* Calculate the remaining timeout for not getting trapped here 
;            on a busy network, which regularly broadcasts DHCP messages. */
;         wtim = NutGetMillis() - etim;
	xcall _NutGetMillis
	ldd R2,y+14
	ldd R3,y+15
	ldd R4,y+16
	ldd R5,y+17
	movw R6,R16
	movw R8,R18
	sub R6,R2
	sbc R7,R3
	sbc R8,R4
	sbc R9,R5
	std y+10,R6
	std y+11,R7
	std y+12,R8
	std y+13,R9
;         if (wtim >= tmo - 250) {
	ldi R20,250
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R2,y+40
	ldd R3,y+41
	ldd R4,y+42
	ldd R5,y+43
	sub R2,R20
	sbc R3,R21
	sbc R4,R22
	sbc R5,R23
	ldd R6,y+10
	ldd R7,y+11
	ldd R8,y+12
	ldd R9,y+13
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	brlo L85
X45:
;             /* Less than 250 ms left, return timeout. */
;             rc = 0;
	clr R10
	clr R11
;             break;
	xjmp L75
L85:
;         }
;         wtim = tmo - wtim;
	ldd R2,y+10
	ldd R3,y+11
	ldd R4,y+12
	ldd R5,y+13
	ldd R6,y+40
	ldd R7,y+41
	ldd R8,y+42
	ldd R9,y+43
	sub R6,R2
	sbc R7,R3
	sbc R8,R4
	sbc R9,R5
	std y+10,R6
	std y+11,R7
	std y+12,R8
	std y+13,R9
;     }
	xjmp L73
L75:
;     return rc;
	movw R16,R10
L72:
	.dbline 0 ; func end
	adiw R28,24
	xcall pop_xgsetF0FC
	adiw R28,2
	ret
;            len -> R14,R15
;             op -> R22,R23
;         optlen -> R12,R13
;           secs -> y+28
;          raddr -> y+24
;            xid -> y+20
;             bp -> R20,R21
;           sock -> R10,R11
	.even
_DhcpBroadcastDiscover:
	xcall push_xgsetF0FC
	movw R20,R18
	movw R10,R16
	sbiw R28,10
; }
; 
; /*!
;  * \brief Broadcast a DHCP discover message.
;  *
;  * \param sock  Socket descriptor. This pointer must have been retrieved 
;  *              by calling NutUdpCreateSocket().
;  * \param bp    Pointer to a buffer to be used for transmission. No specific 
;  *              initialization required.
;  * \param xid   Random transaction identifier.
;  * \param raddr Requested IP address. Optional.
;  * \param secs  Seconds elapsed since start of address acquisition. Related
;  *              requests must use the same value.
;  *
;  * \return 0 on success, -1 if send failed.
;  */
; static int DhcpBroadcastDiscover(UDPSOCKET * sock, BOOTP *bp, u_long xid, u_long raddr, u_short secs)
; {
;     size_t optlen;
;     int len;
;     u_char *op = bp->bp_options;
	movw R22,R20
	subi R22,20  ; offset = 236
	sbci R23,255
; 
;     optlen = DhcpPrepHeader(bp, DHCP_DISCOVER, xid, 0, secs);
	ldd R0,y+28
	ldd R1,y+29
	std y+9,R1
	std y+8,R0
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+4,R24
	std y+5,R25
	std y+6,R26
	std y+7,R27
	ldd R2,y+20
	ldd R3,y+21
	ldd R4,y+22
	ldd R5,y+23
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldi R18,1
	movw R16,R20
	xcall _DhcpPrepHeader
	movw R12,R16
; 
;     /* Request a specific IP if one had been assigned previously. */
;     if (raddr) {
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	ldd R2,y+24
	ldd R3,y+25
	ldd R4,y+26
	ldd R5,y+27
	cp R2,R24
	cpc R3,R25
	cpc R4,R26
	cpc R5,R27
	breq L88
X47:
;         optlen += DhcpAddOption(op + optlen, DHCPOPT_REQESTIP, &raddr, sizeof(raddr));
	ldi R24,4
	std y+2,R24
	movw R24,R28
	adiw R24,24
	std y+1,R25
	std y+0,R24
	ldi R18,50
	add R16,R22
	adc R17,R23
	xcall _DhcpAddOption
	add R12,R16
	adc R13,R17
;     }
L88:
; 
;     optlen += DhcpAddParmReqOption(op + optlen);
	movw R16,R12
	add R16,R22
	adc R17,R23
	xcall _DhcpAddParmReqOption
	add R12,R16
	adc R13,R17
; 
;     /* Pass host name if specified in confos structure.  
;      * Win2k DHCP server can register this as dynamic DNS entry.
;      * Also viewing DHCP lease table shows something sensible.
;      */
;     len = strlen(confos.hostname);
	ldi R16,<_confos+3
	ldi R17,>_confos+3
	xcall _strlen
	movw R14,R16
;     if (len > 0) {
	clr R2
	clr R3
	cp R2,R16
	cpc R3,R17
	brge L91
X48:
;         optlen += DhcpAddOption(op + optlen, DHCPOPT_HOSTNAME, confos.hostname, len);
	std y+2,R14
	ldi R24,<_confos+3
	ldi R25,>_confos+3
	std y+1,R25
	std y+0,R24
	ldi R18,12
	movw R16,R12
	add R16,R22
	adc R17,R23
	xcall _DhcpAddOption
	add R12,R16
	adc R13,R17
;     }
L91:
; 
;     /* Request a maximum message size. */
;     optlen += DhcpAddShortOption(op + optlen, DHCPOPT_MAXMSGSIZE, MAX_DHCP_MSGSIZE);
	ldi R24,576
	ldi R25,2
	std y+1,R25
	std y+0,R24
	ldi R18,57
	movw R16,R12
	add R16,R22
	adc R17,R23
	xcall _DhcpAddShortOption
	movw R14,R16
	add R12,R16
	adc R13,R17
; 
;     return DhcpSendMessage(sock, INADDR_BROADCAST, bp, optlen);
	std y+5,R13
	std y+4,R12
	std y+3,R21
	std y+2,R20
	ldi R24,255
	ldi R25,255
	ldi R26,255
	ldi R27,255
	std y+0,R26
	std y+1,R27
	movw R18,R24
	movw R16,R10
	xcall _DhcpSendMessage
	movw R10,R16
L87:
	.dbline 0 ; func end
	adiw R28,10
	xjmp pop_xgsetF0FC
;            len -> R14,R15
;             op -> R22,R23
;         optlen -> R12,R13
;           secs -> y+42
;            sid -> y+38
;          raddr -> y+34
;          caddr -> y+30
;            xid -> y+26
;             bp -> R20,R21
;          daddr -> y+20
;           sock -> R10,R11
	.even
_DhcpSendRequest:
	st -y,r19
	st -y,r18
	xcall push_xgsetF0FC
	movw R10,R16
	sbiw R28,10
	ldd R20,y+24
	ldd R21,y+25
; }
; 
; 
; /*!
;  * \brief Send a DHCP request message.
;  *
;  * \param sock  Socket descriptor. This pointer must have been retrieved by 
;  *              calling NutUdpCreateSocket().
;  * \param daddr IP address of the DHCP server or \ref INADDR_BROADCAST.
;  * \param bp    Pointer to a buffer to be used for transmission.
;  * \param xid   Random transaction identifier.
;  * \param caddr Our IP address. Should be set only if we are able to respond 
;  *              to ARP requests. Otherwise must be set to 0.
;  * \param raddr Requested IP address. Required.
;  * \param sid   Server identifier. If this request is not an offer response, 
;  *              then set it to zero.
;  * \param secs  Seconds elapsed since start of address acquisition. If this
;  *              request is sent in reponse to an offer, the same value must
;  *              be used.
;  *
;  * \return 0 on success, -1 if send failed.
;  */
; static int DhcpSendRequest(UDPSOCKET * sock, u_long daddr, BOOTP *bp, u_long xid,        /* */
;                            u_long caddr, u_long raddr, u_long sid, u_short secs)
; {
;     size_t optlen;
;     int len;
;     u_char *op = bp->bp_options;
	movw R22,R20
	subi R22,20  ; offset = 236
	sbci R23,255
; 
;     /* Initialize the BOOTP header. */
;     optlen = DhcpPrepHeader(bp, DHCP_REQUEST, xid, caddr, secs);
	ldd R0,y+42
	ldd R1,y+43
	std y+9,R1
	std y+8,R0
	ldd R2,y+30
	ldd R3,y+31
	ldd R4,y+32
	ldd R5,y+33
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
	ldd R2,y+26
	ldd R3,y+27
	ldd R4,y+28
	ldd R5,y+29
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldi R18,3
	movw R16,R20
	xcall _DhcpPrepHeader
	movw R12,R16
; 
;     /* Add specified options. */
;     if (raddr) {
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	ldd R2,y+34
	ldd R3,y+35
	ldd R4,y+36
	ldd R5,y+37
	cp R2,R24
	cpc R3,R25
	cpc R4,R26
	cpc R5,R27
	breq L95
X49:
;         optlen += DhcpAddOption(op + optlen, DHCPOPT_REQESTIP, &raddr, sizeof(raddr));
	ldi R24,4
	std y+2,R24
	movw R24,R28
	adiw R24,34
	std y+1,R25
	std y+0,R24
	ldi R18,50
	add R16,R22
	adc R17,R23
	xcall _DhcpAddOption
	add R12,R16
	adc R13,R17
;     }
L95:
;     if (sid) {
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	ldd R2,y+38
	ldd R3,y+39
	ldd R4,y+40
	ldd R5,y+41
	cp R2,R24
	cpc R3,R25
	cpc R4,R26
	cpc R5,R27
	breq L97
X50:
;         optlen += DhcpAddOption(op + optlen, DHCPOPT_SID, &sid, sizeof(sid));
	ldi R24,4
	std y+2,R24
	movw R24,R28
	adiw R24,38
	std y+1,R25
	std y+0,R24
	ldi R18,54
	movw R16,R12
	add R16,R22
	adc R17,R23
	xcall _DhcpAddOption
	add R12,R16
	adc R13,R17
;     }
L97:
;     optlen += DhcpAddParmReqOption(op + optlen);
	movw R16,R12
	add R16,R22
	adc R17,R23
	xcall _DhcpAddParmReqOption
	add R12,R16
	adc R13,R17
; 
;     /* Pass host name if specified in confos structure.  */
;     /* viewing DHCP lease table shows something sensible. */
;     len = strlen(confos.hostname);
	ldi R16,<_confos+3
	ldi R17,>_confos+3
	xcall _strlen
	movw R14,R16
;     if (len > 0) {
	clr R2
	clr R3
	cp R2,R16
	cpc R3,R17
	brge L100
X51:
;         optlen += DhcpAddOption(op + optlen, DHCPOPT_HOSTNAME, confos.hostname, len);
	std y+2,R14
	ldi R24,<_confos+3
	ldi R25,>_confos+3
	std y+1,R25
	std y+0,R24
	ldi R18,12
	movw R16,R12
	add R16,R22
	adc R17,R23
	xcall _DhcpAddOption
	movw R14,R16
	add R12,R16
	adc R13,R17
;     }
L100:
; 
;     return DhcpSendMessage(sock, daddr, bp, optlen);
	std y+5,R13
	std y+4,R12
	std y+3,R21
	std y+2,R20
	ldd R2,y+20
	ldd R3,y+21
	ldd R4,y+22
	ldd R5,y+23
	std y+0,R4
	std y+1,R5
	movw R18,R2
	movw R16,R10
	xcall _DhcpSendMessage
	movw R10,R16
L94:
	.dbline 0 ; func end
	adiw R28,10
	xcall pop_xgsetF0FC
	adiw R28,2
	ret
;           secs -> y+42
;            sid -> y+38
;          raddr -> y+34
;          caddr -> y+30
;            xid -> y+26
;             bp -> R12,R13
;           sock -> R10,R11
	.even
_DhcpBroadcastRequest:
	xcall push_xgset003C
	movw R12,R18
	movw R10,R16
	sbiw R28,22
; }
; 
; /*!
;  * \brief Broadcast a DHCP request message.
;  *
;  * \param sock  Socket descriptor. This pointer must have been retrieved by 
;  *              calling NutUdpCreateSocket().
;  * \param bp    Pointer to a buffer to be used for transmission.
;  * \param xid   Random transaction identifier.
;  * \param caddr Our IP address. Should be set only if we are able to respond 
;  *              to ARP requests. Otherwise must be set to 0.
;  * \param raddr Requested IP address. Required.
;  * \param sid   Server identifier. If this request is not an offer response, 
;  *              then set it to zero.
;  * \param secs  Seconds elapsed since start of address acquisition. If this
;  *              request is sent in reponse to an offer, the same value must
;  *              be used.
;  *
;  * \return 0 on success, -1 if send failed.
;  */
; static int DhcpBroadcastRequest(UDPSOCKET * sock, BOOTP *bp, u_long xid, /* */
;                                 u_long caddr, u_long raddr, u_long sid, u_short secs)
; {
;     return DhcpSendRequest(sock, INADDR_BROADCAST, bp, xid, caddr, raddr, sid, secs);
	ldd R0,y+42
	ldd R1,y+43
	std y+21,R1
	std y+20,R0
	ldd R2,y+38
	ldd R3,y+39
	ldd R4,y+40
	ldd R5,y+41
	std y+16,R2
	std y+17,R3
	std y+18,R4
	std y+19,R5
	ldd R2,y+34
	ldd R3,y+35
	ldd R4,y+36
	ldd R5,y+37
	std y+12,R2
	std y+13,R3
	std y+14,R4
	std y+15,R5
	ldd R2,y+30
	ldd R3,y+31
	ldd R4,y+32
	ldd R5,y+33
	std y+8,R2
	std y+9,R3
	std y+10,R4
	std y+11,R5
	ldd R2,y+26
	ldd R3,y+27
	ldd R4,y+28
	ldd R5,y+29
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
	std y+3,R13
	std y+2,R12
	ldi R24,255
	ldi R25,255
	ldi R26,255
	ldi R27,255
	std y+0,R26
	std y+1,R27
	movw R18,R24
	movw R16,R10
	xcall _DhcpSendRequest
L103:
	.dbline 0 ; func end
	adiw R28,22
	xjmp pop_xgset003C
;             op -> R22,R23
;         optlen -> R12,R13
;            sid -> y+32
;          caddr -> y+28
;            xid -> y+24
;             bp -> R20,R21
;          daddr -> y+18
;           sock -> R10,R11
	.even
_DhcpSendRelease:
	st -y,r19
	st -y,r18
	xcall push_xgsetF03C
	movw R10,R16
	sbiw R28,10
	ldd R20,y+22
	ldd R21,y+23
; }
; 
; /*!
;  * \brief Relinguish our DHCP lease.
;  *
;  * \param sock  Socket descriptor. This pointer must have been retrieved by 
;  *              calling NutUdpCreateSocket().
;  * \param daddr IP address of the DHCP server.
;  * \param bp    Pointer to a buffer to be used for transmission.
;  * \param xid   Random transaction identifier.
;  * \param caddr Our IP address. Should be set only if we are able to respond 
;  *              to ARP requests. Otherwise must be set to 0.
;  * \param sid   Server identifier. If this request is not an offer response, 
;  *              then set it to zero.
;  *
;  * \return 0 on success, -1 if send failed.
;  */
; static int DhcpSendRelease(UDPSOCKET * sock, u_long daddr, BOOTP *bp, u_long xid, u_long caddr, u_long sid)
; {
;     size_t optlen;
;     u_char *op = bp->bp_options;
	movw R22,R20
	subi R22,20  ; offset = 236
	sbci R23,255
; 
;     /* Prepare BOOTP header. 'secs' is set to zero. */
;     optlen = DhcpPrepHeader(bp, DHCP_RELEASE, xid, caddr, 0);
	clr R2
	clr R3
	std y+9,R3
	std y+8,R2
	ldd R2,y+28
	ldd R3,y+29
	ldd R4,y+30
	ldd R5,y+31
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
	ldd R2,y+24
	ldd R3,y+25
	ldd R4,y+26
	ldd R5,y+27
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldi R18,7
	movw R16,R20
	xcall _DhcpPrepHeader
	movw R12,R16
; 
;     /* Optionally add server identifier. */
;     if (sid) {
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	ldd R2,y+32
	ldd R3,y+33
	ldd R4,y+34
	ldd R5,y+35
	cp R2,R24
	cpc R3,R25
	cpc R4,R26
	cpc R5,R27
	breq L105
X52:
;         optlen += DhcpAddOption(op + optlen, DHCPOPT_SID, &sid, sizeof(sid));
	ldi R24,4
	std y+2,R24
	movw R24,R28
	adiw R24,32
	std y+1,R25
	std y+0,R24
	ldi R18,54
	add R16,R22
	adc R17,R23
	xcall _DhcpAddOption
	add R12,R16
	adc R13,R17
;     }
L105:
;     return DhcpSendMessage(sock, daddr, bp, optlen);
	std y+5,R13
	std y+4,R12
	std y+3,R21
	std y+2,R20
	ldd R2,y+18
	ldd R3,y+19
	ldd R4,y+20
	ldd R5,y+21
	std y+0,R4
	std y+1,R5
	movw R18,R2
	movw R16,R10
	xcall _DhcpSendMessage
	movw R10,R16
L104:
	.dbline 0 ; func end
	adiw R28,10
	xcall pop_xgsetF03C
	adiw R28,2
	ret
;            len -> R14,R15
;             op -> R22,R23
;         optlen -> R12,R13
;          caddr -> y+30
;            xid -> y+26
;             bp -> R20,R21
;          daddr -> y+20
;           sock -> R10,R11
	.even
_DhcpSendInform:
	st -y,r19
	st -y,r18
	xcall push_xgsetF0FC
	movw R10,R16
	sbiw R28,10
	ldd R20,y+24
	ldd R21,y+25
; }
; 
; /*!
;  * \brief Inform DHCP about an externally allocated address.
;  *
;  * \param sock  Socket descriptor. This pointer must have been retrieved by 
;  *              calling NutUdpCreateSocket().
;  * \param daddr IP address of the DHCP server or INADDR_BROADCAST.
;  * \param bp    Pointer to a buffer to be used for transmission.
;  * \param xid   Random transaction identifier.
;  * \param caddr Our IP address. Required.
;  *
;  * \return 0 on success, -1 if send failed.
;  */
; static int DhcpSendInform(UDPSOCKET * sock, u_long daddr, BOOTP *bp, u_long xid, u_long caddr)
; {
;     size_t optlen;
;     size_t len;
;     u_char *op = bp->bp_options;
	movw R22,R20
	subi R22,20  ; offset = 236
	sbci R23,255
; 
;     /* Prepare BOOTP header. 'secs' is set to zero. */
;     optlen = DhcpPrepHeader(bp, DHCP_INFORM, xid, caddr, 0);
	clr R2
	clr R3
	std y+9,R3
	std y+8,R2
	ldd R2,y+30
	ldd R3,y+31
	ldd R4,y+32
	ldd R5,y+33
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
	ldd R2,y+26
	ldd R3,y+27
	ldd R4,y+28
	ldd R5,y+29
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldi R18,8
	movw R16,R20
	xcall _DhcpPrepHeader
	movw R12,R16
; 
;     /* Additional options we want. */
;     optlen += DhcpAddParmReqOption(op + optlen);
	add R16,R22
	adc R17,R23
	xcall _DhcpAddParmReqOption
	add R12,R16
	adc R13,R17
; 
;     /* Add our configured host name. */
;     len = strlen(confos.hostname);
	ldi R16,<_confos+3
	ldi R17,>_confos+3
	xcall _strlen
	movw R14,R16
;     if (len > 0) {
	cpi R16,0
	cpc R16,R17
	breq L109
X53:
;         optlen += DhcpAddOption(op + optlen, DHCPOPT_HOSTNAME, confos.hostname, len);
	std y+2,R14
	ldi R24,<_confos+3
	ldi R25,>_confos+3
	std y+1,R25
	std y+0,R24
	ldi R18,12
	movw R16,R12
	add R16,R22
	adc R17,R23
	xcall _DhcpAddOption
	add R12,R16
	adc R13,R17
;     }
L109:
; 
;     /* We should provide the maximum message size. */
;     optlen += DhcpAddShortOption(op + optlen, DHCPOPT_MAXMSGSIZE, MAX_DHCP_MSGSIZE);
	ldi R24,576
	ldi R25,2
	std y+1,R25
	std y+0,R24
	ldi R18,57
	movw R16,R12
	add R16,R22
	adc R17,R23
	xcall _DhcpAddShortOption
	movw R14,R16
	add R12,R16
	adc R13,R17
; 
;     return DhcpSendMessage(sock, daddr, bp, optlen);
	std y+5,R13
	std y+4,R12
	std y+3,R21
	std y+2,R20
	ldd R2,y+20
	ldd R3,y+21
	ldd R4,y+22
	ldd R5,y+23
	std y+0,R4
	std y+1,R5
	movw R18,R2
	movw R16,R10
	xcall _DhcpSendMessage
	movw R10,R16
L107:
	.dbline 0 ; func end
	adiw R28,10
	xcall pop_xgsetF0FC
	adiw R28,2
	ret
;          offer -> R12,R13
;            len -> y+8
;             bp -> R12,R13
;         dyncfg -> R10,R11
	.even
_CheckOffer:
	xcall push_xgsetF03C
	movw R12,R18
	movw R10,R16
; }
; 
; 
; /*!
;  * \brief Check a new offer.
;  *
;  * \param dyncfg Current configuration, may be NULL.
;  * \param ip     DHCP server IP address.
;  * \param bp     DHCP offer message.
;  * \param len    DHCP message length.
;  *
;  * \return Updated configuration.
;  */
; static DYNCFG *CheckOffer(DYNCFG * dyncfg, BOOTP *bp, size_t len)
; {
;     DYNCFG *offer;
; 
;     /* Parse the new offer. If it's invalid, return the current 
;        configuration. */
;     if ((offer = ParseReply(bp, len)) == 0) {
	ldd R18,y+8
	ldd R19,y+9
	movw R16,R12
	xcall _ParseReply
	movw R12,R16
	tst R12
	brne L113
	tst R13
	brne L113
X54:
;         return dyncfg;
	movw R16,R10
	xjmp L112
L113:
;     }
; 
;     /* Discard anything which is not an offer. */
;     if (offer->dyn_msgtyp != DHCP_OFFER) {
	movw R30,R12
	ldd R24,z+0
	cpi R24,2
	breq L115
X55:
;         ReleaseDynCfg(offer);
	movw R16,R30
	xcall _ReleaseDynCfg
;         return dyncfg;
	movw R16,R10
	xjmp L112
L115:
;     }
; 
;     /* First offer, take it. */
;     if (dyncfg == 0) {
	tst R10
	brne L117
	tst R11
	brne L117
X56:
;         dyncfg = offer;
	movw R10,R12
;     }
	xjmp L118
L117:
; 
;     /* 
;      * Check if the new offer is better than the current configuration:
;      */
;     else {
;         /* If we remember a previously allocated IP which isn't in the
;            current configuration but in the new offer, then let's take 
;            the new one. */
;         if (confnet.cdn_ip_addr & confnet.cdn_ip_mask) {
	lds R4,_confnet+20+2
	lds R5,_confnet+20+2+1
	lds R2,_confnet+20
	lds R3,_confnet+20+1
	lds R8,_confnet+16+2
	lds R9,_confnet+16+2+1
	lds R6,_confnet+16
	lds R7,_confnet+16+1
	and R6,R2
	and R7,R3
	and R8,R4
	and R9,R5
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	cp R6,R20
	cpc R7,R21
	cpc R8,R22
	cpc R9,R23
	breq L119
X57:
;             if (dyncfg->dyn_yiaddr != confnet.cdn_ip_addr &&    /* */
	lds R4,_confnet+16+2
	lds R5,_confnet+16+2+1
	lds R2,_confnet+16
	lds R3,_confnet+16+1
	movw R30,R10
	ldd R6,z+1
	ldd R7,z+2
	ldd R8,z+3
	ldd R9,z+4
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	breq L120
X58:
	movw R30,R12
	ldd R6,z+1
	ldd R7,z+2
	ldd R8,z+3
	ldd R9,z+4
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	brne L120
X59:
;                 offer->dyn_yiaddr == confnet.cdn_ip_addr) {
;                 ReleaseDynCfg(dyncfg);
	movw R16,R10
	xcall _ReleaseDynCfg
;                 dyncfg = offer;
	movw R10,R12
;             }
;         }
	xjmp L120
L119:
;         /* In the second place prefer long lease times. */
;         else if (offer->dyn_leaseTime > dyncfg->dyn_leaseTime) {
	movw R30,R10
	ldd R2,z+37
	ldd R3,z+38
	ldd R4,z+39
	ldd R5,z+40
	movw R30,R12
	ldd R6,z+37
	ldd R7,z+38
	ldd R8,z+39
	ldd R9,z+40
	cp R2,R6
	cpc R3,R7
	cpc R4,R8
	cpc R5,R9
	brsh L127
X60:
;             ReleaseDynCfg(dyncfg);
	movw R16,R10
	xcall _ReleaseDynCfg
;             dyncfg = offer;
	movw R10,R12
;         }
	xjmp L128
L127:
;         /* The new one deosn't offer anything interesting. Discard it. */
;         else {
;             ReleaseDynCfg(offer);
	movw R16,R12
	xcall _ReleaseDynCfg
;         }
L128:
L120:
;     }
L118:
;     return dyncfg;
	movw R16,R10
L112:
	.dbline 0 ; func end
	xjmp pop_xgsetF03C
;         max_ms -> y+50
;             tt -> y+50
;        napTime -> y+46
;      leaseTime -> y+42
;        aqsTime -> y+38
;        last_ip -> y+34
;           secs -> y+67
;      server_ip -> y+30
;              n -> R10,R11
;            nif -> y+65
;          reply -> y+63
;           sock -> y+61
;             bp -> y+59
;            tmo -> y+26
;            xid -> y+22
;        retries -> y+58
;            arg -> R10,R11
	.even
_NutDhcpClient::
	xcall push_xgsetF0FC
	movw R10,R16
	sbiw R28,63
	sbiw R28,6  ; offset = 69
; }
; 
; /*! \fn NutDhcpClient(void *arg)
;  * \brief DHCP client thread.
;  *
;  * This thread implements a DHCP state machine and is automatically started
;  * when calling NutDhcpIfConfig() or NutDhcpInform().
;  *
;  * \bug We are not able to shutdown our interface, which may cause problems
;  *      if out original DHCP server dies.
;  *
;  * \todo We are using a bunch of global variables, which must be associated
;  *       to a specific interfase if we want to support more than one
;  *       Ethernet port.
;  */
; THREAD(NutDhcpClient, arg)
; {
;     DYNCFG *reply = 0;
	clr R0
	clr R1
	movw R30,R28
	adiw R30,63
	std z+1,R1
	std z+0,R0
;     UDPSOCKET *sock = 0;
	std y+62,R1
	std y+61,R0
;     BOOTP *bp = 0;
	std y+60,R1
	std y+59,R0
;     int n;
;     u_long xid;
;     IFNET *nif;
;     u_short secs = 0;
	movw R30,R28
	subi R30,189  ; addi 67
	sbci R31,255
	std z+1,R1
	std z+0,R0
;     u_long aqsTime = NutGetSeconds();
	xcall _NutGetSeconds
	std y+38,R16
	std y+39,R17
	std y+40,R18
	std y+41,R19
;     u_long leaseTime = 0;
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	std y+42,R20
	std y+43,R21
	std y+44,R22
	std y+45,R23
;     u_long napTime;
;     ureg_t retries;
;     u_long tmo = MIN_DHCP_WAIT;
	ldi R20,160
	ldi R21,15
	ldi R22,0
	ldi R23,0
	std y+26,R20
	std y+27,R21
	std y+28,R22
	std y+29,R23
;     u_long last_ip = confnet.cdn_ip_addr;
	lds R4,_confnet+16+2
	lds R5,_confnet+16+2+1
	lds R2,_confnet+16
	lds R3,_confnet+16+1
	std y+34,R2
	std y+35,R3
	std y+36,R4
	std y+37,R5
;     u_long server_ip;
; 
;     /*
;      * Hack alert: Our ARM port doesn't allow parameter
;      * passing to threads.
;      */
; #ifdef __arm__
;     nif = dhcpDev->dev_icb;
; #else
;     nif = ((NUTDEVICE *) arg)->dev_icb;
	movw R30,R10
	ldd R2,z+15
	ldd R3,z+16
	movw R30,R28
	subi R30,191  ; addi 65
	sbci R31,255
	std z+1,R3
	std z+0,R2
; #endif
; 
;     /* 
;      * Generate a random transaction identifier based on our MAC 
;      * address with the least significant byte of the MAC address 
;      * becoming the most significant byte of the identifier. This 
;      * should give a sufficient unique value when several Ethernuts 
;      * are started concurrently. 
;      */
;     xid = 0;
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	std y+22,R20
	std y+23,R21
	std y+24,R22
	std y+25,R23
;     for (retries = 0; retries < sizeof(xid); retries++) {
	clr R0
	std y+58,R0
	xjmp L134
L131:
;         xid <<= 8;
	ldi R24,8
	ldi R25,0
	ldd R16,y+22
	ldd R17,y+23
	ldd R18,y+24
	ldd R19,y+25
	st -y,R24
	xcall lsl32
	std y+22,R16
	std y+23,R17
	std y+24,R18
	std y+25,R19
;         xid += nif->if_mac[5 - retries];
	ldd R2,y+58
	clr R3
	ldi R30,5
	ldi R31,0
	sub R30,R2
	sbc R31,R3
	movw R26,R28
	subi R26,191  ; addi 65
	sbci R27,255
	ld R24,x+
	ld R25,x
	adiw R24,1
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	clr R3
	clr R4
	clr R5
	ldd R6,y+22
	ldd R7,y+23
	ldd R8,y+24
	ldd R9,y+25
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	std y+22,R6
	std y+23,R7
	std y+24,R8
	std y+25,R9
;     }
L132:
	ldd R0,y+58
	inc R0
	std y+58,R0
L134:
	ldd R24,y+58
	cpi R24,4
	brlo L131
X61:
;     retries = 0;
	clr R0
	std y+58,R0
; 
;     for (;;) {
L135:
; #ifdef NUTDEBUG
;         if (__tcp_trf) {
;             fprintf(__tcp_trs, "\n[%u.DHCP-", retries + 1);
;             switch (dhcpState) {
;             case DHCPST_INIT:
;                 fprintf(__tcp_trs, "INIT]");
;                 break;
;             case DHCPST_SELECTING:
;                 fprintf(__tcp_trs, "SELECTING]");
;                 break;
;             case DHCPST_REQUESTING:
;                 fprintf(__tcp_trs, "REQUESTING]");
;                 break;
;             case DHCPST_REBOOTING:
;                 fprintf(__tcp_trs, "REBOOTING %s]", inet_ntoa(last_ip));
;                 break;
;             case DHCPST_BOUND:
;                 fprintf(__tcp_trs, "BOUND %lu]", NutGetSeconds() - leaseTime);
;                 break;
;             case DHCPST_RENEWING:
;                 fprintf(__tcp_trs, "RENEWING %lu]", NutGetSeconds() - leaseTime);
;                 break;
;             case DHCPST_REBINDING:
;                 fprintf(__tcp_trs, "REBINDING %lu]", NutGetSeconds() - leaseTime);
;                 break;
;             case DHCPST_INFORMING:
;                 fprintf(__tcp_trs, "INFORMING]");
;                 break;
;             case DHCPST_RELEASING:
;                 fprintf(__tcp_trs, "RELEASING]");
;                 break;
;             case DHCPST_IDLE:
;                 if (dhcpError) {
;                     fprintf(__tcp_trs, "ERROR %u]", dhcpError);
;                 } else {
;                     fprintf(__tcp_trs, "IDLE]");
;                 }
;                 break;
;             default:
;                 fprintf(__tcp_trs, "UNKNOWN %u]", dhcpState);
;                 break;
;             }
;         }
; #endif
; 
;         /*
;          * Setup some values based on the number of retry attempts.
;          */
;         server_ip = INADDR_BROADCAST;   /* Broadcasting is default. */
	ldi R20,255
	ldi R21,255
	ldi R22,255
	ldi R23,255
	std y+30,R20
	std y+31,R21
	std y+32,R22
	std y+33,R23
;         if (retries) {
	ldd R0,y+58
	tst R0
	breq L139
X62:
;             /* Double our timeout on each retry. */
;             tmo += tmo;
	ldd R2,y+26
	ldd R3,y+27
	ldd R4,y+28
	ldd R5,y+29
	movw R6,R2
	movw R8,R4
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	std y+26,R6
	std y+27,R7
	std y+28,R8
	std y+29,R9
;             if (tmo > MAX_DHCP_WAIT) {
	ldi R20,0
	ldi R21,250
	ldi R22,0
	ldi R23,0
	ldd R2,y+26
	ldd R3,y+27
	ldd R4,y+28
	ldd R5,y+29
	cp R20,R2
	cpc R21,R3
	cpc R22,R4
	cpc R23,R5
	brlo X156
	xjmp L140
X156:
X63:
;                 tmo = MAX_DHCP_WAIT;
	ldi R20,0
	ldi R21,250
	ldi R22,0
	ldi R23,0
	std y+26,R20
	std y+27,R21
	std y+28,R22
	std y+29,R23
;             }
;         } else {
	xjmp L140
L139:
;             /* Start with minimum timeout first. */
;             tmo = MIN_DHCP_WAIT;
	ldi R20,160
	ldi R21,15
	ldi R22,0
	ldi R23,0
	std y+26,R20
	std y+27,R21
	std y+28,R22
	std y+29,R23
;             /* Use a new xid for the first message in each state except 
;              * when requesting, where we should continue using the xid 
;              * from the offer message we received.
;              */
;             if (dhcpState != DHCPST_REQUESTING) {
	lds R24,_dhcpState
	cpi R24,3
	breq L143
X64:
;                 xid++;
	ldi R20,1
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R2,y+22
	ldd R3,y+23
	ldd R4,y+24
	ldd R5,y+25
	add R2,R20
	adc R3,R21
	adc R4,R22
	adc R5,R23
	std y+22,R2
	std y+23,R3
	std y+24,R4
	std y+25,R5
;             }
L143:
; 
;             /* If we know the server's IP, try to unicast on the first 
;                attempt. */
;             if (dhcpConfig && dhcpConfig->dyn_sid) {
	lds R2,_dhcpConfig
	lds R3,_dhcpConfig+1
	tst R2
	brne X65
	tst R3
	breq L145
X65:
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	movw R30,R2
	ldd R2,z+25
	ldd R3,z+26
	ldd R4,z+27
	ldd R5,z+28
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	breq L145
X66:
;                 server_ip = dhcpConfig->dyn_sid;
	ldd R2,z+25
	ldd R3,z+26
	ldd R4,z+27
	ldd R5,z+28
	std y+30,R2
	std y+31,R3
	std y+32,R4
	std y+33,R5
;             }
L145:
;         }
L140:
; 
;         /*
;          * Keep track of the API timeout.
;          */
;         if (dhcpState != DHCPST_IDLE && dhcpApiTimeout != NUT_WAIT_INFINITE) {
	lds R2,_dhcpState
	tst R2
	brne X157
	xjmp L147
X157:
X67:
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	lds R4,_dhcpApiTimeout+2
	lds R5,_dhcpApiTimeout+2+1
	lds R2,_dhcpApiTimeout
	lds R3,_dhcpApiTimeout+1
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brne X158
	xjmp L147
X158:
X68:
;             u_long tt = NutGetMillis() - dhcpApiStart;
	xcall _NutGetMillis
	lds R4,_dhcpApiStart+2
	lds R5,_dhcpApiStart+2+1
	lds R2,_dhcpApiStart
	lds R3,_dhcpApiStart+1
	movw R6,R16
	movw R8,R18
	sub R6,R2
	sbc R7,R3
	sbc R8,R4
	sbc R9,R5
	std y+50,R6
	std y+51,R7
	std y+52,R8
	std y+53,R9
; 
;             if (dhcpApiTimeout <= tt) {
	ldd R2,y+50
	ldd R3,y+51
	ldd R4,y+52
	ldd R5,y+53
	lds R8,_dhcpApiTimeout+2
	lds R9,_dhcpApiTimeout+2+1
	lds R6,_dhcpApiTimeout
	lds R7,_dhcpApiTimeout+1
	cp R2,R6
	cpc R3,R7
	cpc R4,R8
	cpc R5,R9
	brlo L149
X69:
;                 dhcpError = DHCPERR_TIMEOUT;
	ldi R24,1
	ldi R25,0
	sts _dhcpError+1,R25
	sts _dhcpError,R24
;                 dhcpState = DHCPST_IDLE;
	clr R2
	sts _dhcpState,R2
;                 continue;
	xjmp L135
L149:
;             }
;             if ((tt = dhcpApiTimeout - tt) < tmo) {
	ldd R2,y+50
	ldd R3,y+51
	ldd R4,y+52
	ldd R5,y+53
	lds R8,_dhcpApiTimeout+2
	lds R9,_dhcpApiTimeout+2+1
	lds R6,_dhcpApiTimeout
	lds R7,_dhcpApiTimeout+1
	sub R6,R2
	sbc R7,R3
	sbc R8,R4
	sbc R9,R5
	std y+54,R6
	std y+55,R7
	std y+56,R8
	std y+57,R9
	ldd R2,y+54
	ldd R3,y+55
	ldd R4,y+56
	ldd R5,y+57
	std y+50,R2
	std y+51,R3
	std y+52,R4
	std y+53,R5
	ldd R2,y+26
	ldd R3,y+27
	ldd R4,y+28
	ldd R5,y+29
	ldd R6,y+54
	ldd R7,y+55
	ldd R8,y+56
	ldd R9,y+57
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	brsh L151
X70:
;                 tmo = tt;
	ldd R2,y+50
	ldd R3,y+51
	ldd R4,y+52
	ldd R5,y+53
	std y+26,R2
	std y+27,R3
	std y+28,R4
	std y+29,R5
;             }
L151:
;         }
L147:
; 
;         /*
;          * Keep track of acquisition time.
;          */
;         if (dhcpState == DHCPST_SELECTING || dhcpState == DHCPST_RENEWING || dhcpState == DHCPST_REBINDING) {
	lds R2,_dhcpState
	mov R24,R2
	cpi R24,2
	breq L156
X71:
	cpi R24,6
	breq L156
X72:
	cpi R24,7
	breq X159
	xjmp L153
X159:
X73:
L156:
;             /* For retries make sure that secs doesn't overflow. */
;             if (retries) {
	ldd R0,y+58
	tst R0
	breq L157
X74:
;                 if (NutGetSeconds() - aqsTime > 0xffffUL) {
	xcall _NutGetSeconds
	ldd R2,y+38
	ldd R3,y+39
	ldd R4,y+40
	ldd R5,y+41
	movw R6,R16
	movw R8,R18
	sub R6,R2
	sbc R7,R3
	sbc R8,R4
	sbc R9,R5
	ldi R20,255
	ldi R21,255
	ldi R22,0
	ldi R23,0
	cp R20,R6
	cpc R21,R7
	cpc R22,R8
	cpc R23,R9
	brsh L159
X75:
;                     secs = 0xffff;
	ldi R24,65535
	ldi R25,255
	movw R30,R28
	subi R30,189  ; addi 67
	sbci R31,255
	std z+1,R25
	std z+0,R24
;                 } else {
	xjmp L158
L159:
;                     secs = (u_short) (NutGetSeconds() - aqsTime);
	xcall _NutGetSeconds
	ldd R2,y+38
	ldd R3,y+39
	movw R4,R16
	sub R4,R2
	sbc R5,R3
	movw R30,R28
	subi R30,189  ; addi 67
	sbci R31,255
	std z+1,R5
	std z+0,R4
;                 }
;             }
	xjmp L158
L157:
;             /* For first transmissions make sure that secs is zero. */
;             else {
;                 aqsTime = NutGetSeconds();
	xcall _NutGetSeconds
	std y+38,R16
	std y+39,R17
	std y+40,R18
	std y+41,R19
;                 secs = 0;
	clr R0
	clr R1
	movw R30,R28
	subi R30,189  ; addi 67
	sbci R31,255
	std z+1,R1
	std z+0,R0
;             }
L158:
;         }
L153:
; 
;         /*
;          * Release UDP socket and buffer in states with long inactive time.
;          */
;         if (dhcpState == DHCPST_BOUND || dhcpState == DHCPST_IDLE) {
	lds R10,_dhcpState
	mov R24,R10
	cpi R24,5
	breq L163
X76:
	tst R24
	brne L161
X77:
L163:
;             if (sock) {
	ldd R0,y+61
	ldd R1,y+62
	tst R0
	brne X78
	tst R1
	breq L164
X78:
;                 NutUdpDestroySocket(sock);
	movw R16,R0
	xcall _NutUdpDestroySocket
;                 sock = 0;
	clr R0
	clr R1
	std y+62,R1
	std y+61,R0
;             }
L164:
;             if (bp) {
	ldd R0,y+59
	ldd R1,y+60
	tst R0
	brne X79
	tst R1
	brne X160
	xjmp L162
X160:
X79:
;                 free(bp);
	movw R16,R0
	xcall _free_M
;                 bp = 0;
	clr R0
	clr R1
	std y+60,R1
	std y+59,R0
;             }
;         }
	xjmp L162
L161:
; 
;         /*
;          * In all other states we need the socket and the buffer.
;          */
;         else {
;             /*
;              * Check if something else configured our interface.
;              */
;             if (dhcpConfig == 0 && nif->if_local_ip) {
	lds R2,_dhcpConfig
	lds R3,_dhcpConfig+1
	tst R2
	brne L168
	tst R3
	brne L168
X80:
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	movw R26,R28
	subi R26,191  ; addi 65
	sbci R27,255
	ld R30,x+
	ld R31,x
	ldd R2,z+7
	ldd R3,z+8
	ldd R4,z+9
	ldd R5,z+10
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	breq L168
X81:
;                 /* If we need additional configuration, we can sent
;                    a DHCP Inform message here. */
;                 dhcpState = DHCPST_IDLE;
	clr R2
	sts _dhcpState,R2
;                 continue;
	xjmp L135
L168:
;             }
; 
;             if (sock == 0 || bp == 0) {
	ldd R0,y+61
	ldd R1,y+62
	tst R0
	brne X82
	tst R1
	breq L172
X82:
	ldd R0,y+59
	ldd R1,y+60
	tst R0
	breq X161
	xjmp L170
X161:
	tst R1
	breq X162
	xjmp L170
X162:
X83:
L172:
;                 if (sock == 0) {
	ldd R0,y+61
	ldd R1,y+62
	tst R0
	brne L173
	tst R1
	brne L173
X84:
;                     sock = NutUdpCreateSocket(DHCP_CLIENTPORT);
	ldi R16,68
	ldi R17,0
	xcall _NutUdpCreateSocket
	movw R10,R16
	std y+62,R11
	std y+61,R10
;                 }
L173:
;                 if (bp == 0) {
	ldd R0,y+59
	ldd R1,y+60
	tst R0
	brne L175
	tst R1
	brne L175
X85:
;                     bp = malloc(sizeof(BOOTP));
	ldi R16,548
	ldi R17,2
	xcall _malloc_M
	movw R10,R16
	std y+60,R11
	std y+59,R10
;                 }
L175:
;                 if (sock == 0 || bp == 0) {
	ldd R0,y+61
	ldd R1,y+62
	tst R0
	brne X86
	tst R1
	breq L179
X86:
	ldd R0,y+59
	ldd R1,y+60
	tst R0
	brne L177
	tst R1
	brne L177
X87:
L179:
;                     /* Looks like we are out of memory. */
;                     dhcpError = DHCPERR_SYSTEM;
	ldi R24,18
	ldi R25,0
	sts _dhcpError+1,R25
	sts _dhcpError,R24
;                     dhcpState = DHCPST_IDLE;
	clr R2
	sts _dhcpState,R2
;                     /* At this point either socket or buffer may be allocated. 
;                        Thus we need to jump back to the top of our state loop
;                        to release it. */
;                     continue;
	xjmp L135
L177:
;                 }
; #if MAX_DHCP_BUFSIZE
;                 {
;                     u_short max_ms = MAX_DHCP_BUFSIZE;
	ldi R24,1728
	ldi R25,6
	std y+51,R25
	std y+50,R24
;                     NutUdpSetSockOpt(sock, SO_RCVBUF, &max_ms, sizeof(max_ms));
	ldi R24,2
	ldi R25,0
	std y+3,R25
	std y+2,R24
	movw R24,R28
	adiw R24,50
	std y+1,R25
	std y+0,R24
	ldi R18,4098
	ldi R19,16
	ldd R16,y+61
	ldd R17,y+62
	xcall _NutUdpSetSockOpt
;                 }
; #endif
;             }
L170:
;         }
L162:
; 
;         /*
;          * (Re)Start.
;          */
;         if (dhcpState == DHCPST_INIT) {
	lds R24,_dhcpState
	cpi R24,1
	brne L180
X88:
;             /* Clear the retry counter. */
;             retries = 0;
	clr R0
	std y+58,R0
;             /* Use a new XID on each attempt. */
;             xid++;
	ldi R20,1
	ldi R21,0
	ldi R22,0
	ldi R23,0
	ldd R2,y+22
	ldd R3,y+23
	ldd R4,y+24
	ldd R5,y+25
	add R2,R20
	adc R3,R21
	adc R4,R22
	adc R5,R23
	std y+22,R2
	std y+23,R3
	std y+24,R4
	std y+25,R5
;             /* Determine whether this is an initial boot or a reboot. */
;             if ((last_ip & confnet.cdn_ip_mask) == 0) {
	lds R4,_confnet+20+2
	lds R5,_confnet+20+2+1
	lds R2,_confnet+20
	lds R3,_confnet+20+1
	ldd R6,y+34
	ldd R7,y+35
	ldd R8,y+36
	ldd R9,y+37
	and R6,R2
	and R7,R3
	and R8,R4
	and R9,R5
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	cp R6,R20
	cpc R7,R21
	cpc R8,R22
	cpc R9,R23
	brne L182
X89:
;                 /* No previous IP, start from ground up. */
;                 dhcpState = DHCPST_SELECTING;
	ldi R24,2
	sts _dhcpState,R24
;             } else {
	xjmp L181
L182:
;                 /* We got a previously allocated IP configuration from
;                  * non-volatile configuration memory. Try to re-use it. */
;                 dhcpState = DHCPST_REBOOTING;
	ldi R24,4
	sts _dhcpState,R24
;             }
;         }
	xjmp L181
L180:
; 
;         /*
;          * Broadcast discover and collect incoming offers.
;          */
;         else if (dhcpState == DHCPST_SELECTING) {
	lds R24,_dhcpState
	cpi R24,2
	breq X163
	xjmp L185
X163:
X90:
;             if (retries++ > MAX_DCHP_RETRIES) {
	ldd R10,y+58
	clr R11
	mov R24,R10
	subi R24,255    ; addi 1
	std y+58,R24
	ldi R24,3
	cp R24,R10
	brsh L187
X91:
;                 /* Too many retries while discovering DHCP. Give up. */
;                 dhcpError = DHCPERR_TIMEOUT;
	ldi R24,1
	ldi R25,0
	sts _dhcpError+1,R25
	sts _dhcpError,R24
;                 dhcpState = DHCPST_IDLE;
	clr R2
	sts _dhcpState,R2
;             }
	xjmp L186
L187:
;             /* Send the discovering broadcast. */
;             else if (DhcpBroadcastDiscover(sock, bp, xid, last_ip, secs) < 0) {
	movw R30,R28
	subi R30,189  ; addi 67
	sbci R31,255
	ldd R0,z+0
	ldd R1,z+1
	std y+9,R1
	std y+8,R0
	ldd R2,y+34
	ldd R3,y+35
	ldd R4,y+36
	ldd R5,y+37
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
	ldd R2,y+22
	ldd R3,y+23
	ldd R4,y+24
	ldd R5,y+25
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldd R18,y+59
	ldd R19,y+60
	ldd R16,y+61
	ldd R17,y+62
	xcall _DhcpBroadcastDiscover
	movw R10,R16
	cpi R16,0
	ldi R30,0
	cpc R17,R30
	brge L192
X92:
;                 /* Fatal transmit error on broadcast. */
;                 dhcpState = DHCPST_IDLE;
	clr R2
	sts _dhcpState,R2
;             } else {
	xjmp L186
L191:
;                 /* Collect incoming offers. */
;                 while ((n = DhcpRecvMessage(sock, xid, bp, tmo)) > 0) {
;                     /* Check if this is a valid offer. */
;                     if ((dhcpConfig = CheckOffer(dhcpConfig, bp, n)) != 0) {
	std y+1,R11
	std y+0,R10
	ldd R18,y+59
	ldd R19,y+60
	lds R16,_dhcpConfig
	lds R17,_dhcpConfig+1
	xcall _CheckOffer
	movw R12,R16
	sts _dhcpConfig+1,R13
	sts _dhcpConfig,R12
	cpi R16,0
	cpc R16,R17
	breq L194
X93:
;                         /* If the callers timeout is low, do not collect
;                            more than one. Thanks to Jelle Kok. */
;                         if (dhcpApiTimeout < MIN_DHCP_WAIT * 3) {
	ldi R20,224
	ldi R21,46
	ldi R22,0
	ldi R23,0
	lds R4,_dhcpApiTimeout+2
	lds R5,_dhcpApiTimeout+2+1
	lds R2,_dhcpApiTimeout
	lds R3,_dhcpApiTimeout+1
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	brsh L196
X94:
;                             break;
	xjmp L193
L196:
;                         }
;                         /* Switch to lowest timeout after we received
;                            a first response. */
;                         tmo = MIN_DHCP_WAIT;
	ldi R20,160
	ldi R21,15
	ldi R22,0
	ldi R23,0
	std y+26,R20
	std y+27,R21
	std y+28,R22
	std y+29,R23
;                     }
L194:
;                 }
L192:
	ldd R2,y+26
	ldd R3,y+27
	ldd R4,y+28
	ldd R5,y+29
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
	ldd R0,y+59
	ldd R1,y+60
	std y+3,R1
	std y+2,R0
	ldd R2,y+22
	ldd R3,y+23
	ldd R4,y+24
	ldd R5,y+25
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldd R16,y+61
	ldd R17,y+62
	xcall _DhcpRecvMessage
	movw R12,R16
	movw R10,R12
	clr R2
	clr R3
	cp R2,R16
	cpc R3,R17
	brge X164
	xjmp L191
X164:
X95:
L193:
;                 /* Change to ERROR state on fatal receive errors. */
;                 if (n < 0) {
	movw R24,R10
	cpi R24,0
	ldi R30,0
	cpc R25,R30
	brge L198
X96:
;                     dhcpState = DHCPST_IDLE;
	clr R2
	sts _dhcpState,R2
;                 }
	xjmp L186
L198:
;                 /* Change to REQUESTING state if we got a valid offer.
;                    Otherwise we stay in SELECTING state. */
;                 else if (dhcpConfig) {
	lds R2,_dhcpConfig
	lds R3,_dhcpConfig+1
	tst R2
	brne X97
	tst R3
	brne X165
	xjmp L186
X165:
X97:
;                     retries = 0;
	clr R0
	std y+58,R0
;                     dhcpState = DHCPST_REQUESTING;
	ldi R24,3
	sts _dhcpState,R24
;                 }
;             }
;         }
	xjmp L186
L185:
; 
;         /*
;          * Send request and wait for an acknowledge.
;          */
;         else if (dhcpState == DHCPST_REQUESTING) {
	lds R24,_dhcpState
	cpi R24,3
	breq X166
	xjmp L202
X166:
X98:
;             if (retries++ > MAX_DCHP_RETRIES) {
	ldd R12,y+58
	clr R13
	mov R24,R12
	subi R24,255    ; addi 1
	std y+58,R24
	ldi R24,3
	cp R24,R12
	brsh L204
X99:
;                 /* Too many retries with this server, fall back to discovery. */
;                 dhcpState = DHCPST_INIT;
	ldi R24,1
	sts _dhcpState,R24
;             }
	xjmp L203
L204:
;             /* Request an offered configuration. According to RFC 2131 this
;                has to be broadcasted. */
;             else if (DhcpBroadcastRequest(sock, bp, xid, 0, dhcpConfig->dyn_yiaddr, dhcpConfig->dyn_sid, secs) < 0) {
	movw R30,R28
	subi R30,189  ; addi 67
	sbci R31,255
	ldd R0,z+0
	ldd R1,z+1
	std y+17,R1
	std y+16,R0
	lds R12,_dhcpConfig
	lds R13,_dhcpConfig+1
	movw R30,R12
	ldd R2,z+25
	ldd R3,z+26
	ldd R4,z+27
	ldd R5,z+28
	std y+12,R2
	std y+13,R3
	std y+14,R4
	std y+15,R5
	ldd R2,z+1
	ldd R3,z+2
	ldd R4,z+3
	ldd R5,z+4
	std y+8,R2
	std y+9,R3
	std y+10,R4
	std y+11,R5
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	std y+4,R20
	std y+5,R21
	std y+6,R22
	std y+7,R23
	ldd R2,y+22
	ldd R3,y+23
	ldd R4,y+24
	ldd R5,y+25
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldd R18,y+59
	ldd R19,y+60
	ldd R16,y+61
	ldd R17,y+62
	xcall _DhcpBroadcastRequest
	movw R12,R16
	cpi R16,0
	ldi R30,0
	cpc R17,R30
	brge L206
X100:
;                 /* Fatal transmit error on broadcast. Give up. */
;                 dhcpState = DHCPST_IDLE;
	clr R2
	sts _dhcpState,R2
;             } else if ((n = DhcpRecvMessage(sock, xid, bp, tmo)) < 0) {
	xjmp L203
L206:
	ldd R2,y+26
	ldd R3,y+27
	ldd R4,y+28
	ldd R5,y+29
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
	ldd R0,y+59
	ldd R1,y+60
	std y+3,R1
	std y+2,R0
	ldd R2,y+22
	ldd R3,y+23
	ldd R4,y+24
	ldd R5,y+25
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldd R16,y+61
	ldd R17,y+62
	xcall _DhcpRecvMessage
	movw R12,R16
	movw R10,R12
	cpi R16,0
	ldi R30,0
	cpc R17,R30
	brge L208
X101:
;                 /* Fatal receive error. */
;                 dhcpState = DHCPST_IDLE;
	clr R2
	sts _dhcpState,R2
;             } else if (n > 0 && (reply = ParseReply(bp, n)) != 0) {
	xjmp L203
L208:
	clr R2
	clr R3
	cp R2,R10
	cpc R3,R11
	brlt X167
	xjmp L203
X167:
X102:
	movw R18,R10
	ldd R16,y+59
	ldd R17,y+60
	xcall _ParseReply
	movw R12,R16
	movw R30,R28
	adiw R30,63
	std z+1,R13
	std z+0,R12
	cpi R16,0
	cpc R16,R17
	brne X168
	xjmp L203
X168:
X103:
;                 /* The server accepted our request. We are bound. */
;                 if (reply->dyn_msgtyp == DHCP_ACK) {
	movw R30,R12
	ldd R24,z+0
	cpi R24,5
	brne L212
X104:
;                     ReleaseDynCfg(dhcpConfig);
	lds R16,_dhcpConfig
	lds R17,_dhcpConfig+1
	xcall _ReleaseDynCfg
;                     dhcpConfig = reply;
	movw R30,R28
	adiw R30,63
	ldd R0,z+0
	ldd R1,z+1
	sts _dhcpConfig+1,R1
	sts _dhcpConfig,R0
;                     reply = 0;
	clr R0
	clr R1
	movw R30,R28
	adiw R30,63
	std z+1,R1
	std z+0,R0
;                     leaseTime = aqsTime;
	ldd R2,y+38
	ldd R3,y+39
	ldd R4,y+40
	ldd R5,y+41
	std y+42,R2
	std y+43,R3
	std y+44,R4
	std y+45,R5
;                     dhcpState = DHCPST_BOUND;
	ldi R24,5
	sts _dhcpState,R24
;                 }
	xjmp L203
L212:
;                 /* The server declines a previously offered configuration. 
;                    Restart discovery. */
;                 else if (reply->dyn_msgtyp == DHCP_NAK) {
	movw R26,R28
	adiw R26,63
	ld R30,x+
	ld R31,x
	ldd R24,z+0
	cpi R24,6
	breq X169
	xjmp L203
X169:
X105:
;                     dhcpState = DHCPST_INIT;
	ldi R24,1
	sts _dhcpState,R24
;                 }
;             }
;         }
	xjmp L203
L202:
; 
;         /*
;          * Reusing a previously allocated network address after reboot.
;          */
;         else if (dhcpState == DHCPST_REBOOTING) {
	lds R24,_dhcpState
	cpi R24,4
	breq X170
	xjmp L216
X170:
X106:
;             if (++retries > MAX_DCHP_RETRIES) {
	ldd R24,y+58
	subi R24,255    ; addi 1
	mov R12,R24
	std y+58,R12
	ldi R24,3
	cp R24,R12
	brsh L218
X107:
;                 /* Too many retries, fall back to discovery. */
;                 last_ip = 0;
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	std y+34,R20
	std y+35,R21
	std y+36,R22
	std y+37,R23
;                 dhcpState = DHCPST_INIT;
	ldi R24,1
	sts _dhcpState,R24
;             }
	xjmp L217
L218:
;             /* Broadcast a request for our previous configuration. */
;             else if (DhcpBroadcastRequest(sock, bp, xid, 0, last_ip, 0, secs) < 0) {
	movw R30,R28
	subi R30,189  ; addi 67
	sbci R31,255
	ldd R0,z+0
	ldd R1,z+1
	std y+17,R1
	std y+16,R0
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	std y+12,R20
	std y+13,R21
	std y+14,R22
	std y+15,R23
	ldd R2,y+34
	ldd R3,y+35
	ldd R4,y+36
	ldd R5,y+37
	std y+8,R2
	std y+9,R3
	std y+10,R4
	std y+11,R5
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	std y+4,R20
	std y+5,R21
	std y+6,R22
	std y+7,R23
	ldd R2,y+22
	ldd R3,y+23
	ldd R4,y+24
	ldd R5,y+25
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldd R18,y+59
	ldd R19,y+60
	ldd R16,y+61
	ldd R17,y+62
	xcall _DhcpBroadcastRequest
	movw R12,R16
	cpi R16,0
	ldi R30,0
	cpc R17,R30
	brge L220
X108:
;                 /* Fatal transmit error on broadcast. Give up. */
;                 dhcpState = DHCPST_IDLE;
	clr R2
	sts _dhcpState,R2
;             } else if ((n = DhcpRecvMessage(sock, xid, bp, tmo)) < 0) {
	xjmp L217
L220:
	ldd R2,y+26
	ldd R3,y+27
	ldd R4,y+28
	ldd R5,y+29
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
	ldd R0,y+59
	ldd R1,y+60
	std y+3,R1
	std y+2,R0
	ldd R2,y+22
	ldd R3,y+23
	ldd R4,y+24
	ldd R5,y+25
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldd R16,y+61
	ldd R17,y+62
	xcall _DhcpRecvMessage
	movw R12,R16
	movw R10,R12
	cpi R16,0
	ldi R30,0
	cpc R17,R30
	brge L222
X109:
;                 /* Fatal receive error. */
;                 dhcpState = DHCPST_IDLE;
	clr R2
	sts _dhcpState,R2
;             } else if (n > 0 && (reply = ParseReply(bp, n)) != 0) {
	xjmp L217
L222:
	clr R2
	clr R3
	cp R2,R10
	cpc R3,R11
	brlt X171
	xjmp L217
X171:
X110:
	movw R18,R10
	ldd R16,y+59
	ldd R17,y+60
	xcall _ParseReply
	movw R12,R16
	movw R30,R28
	adiw R30,63
	std z+1,R13
	std z+0,R12
	cpi R16,0
	cpc R16,R17
	brne X172
	xjmp L217
X172:
X111:
;                 if (reply->dyn_msgtyp == DHCP_ACK) {
	movw R30,R12
	ldd R24,z+0
	cpi R24,5
	brne L226
X112:
;                     ReleaseDynCfg(dhcpConfig);
	lds R16,_dhcpConfig
	lds R17,_dhcpConfig+1
	xcall _ReleaseDynCfg
;                     dhcpConfig = reply;
	movw R30,R28
	adiw R30,63
	ldd R0,z+0
	ldd R1,z+1
	sts _dhcpConfig+1,R1
	sts _dhcpConfig,R0
;                     reply = 0;
	clr R0
	clr R1
	movw R30,R28
	adiw R30,63
	std z+1,R1
	std z+0,R0
;                     leaseTime = aqsTime;
	ldd R2,y+38
	ldd R3,y+39
	ldd R4,y+40
	ldd R5,y+41
	std y+42,R2
	std y+43,R3
	std y+44,R4
	std y+45,R5
;                     dhcpState = DHCPST_BOUND;
	ldi R24,5
	sts _dhcpState,R24
;                 } else if (reply->dyn_msgtyp == DHCP_NAK) {
	xjmp L217
L226:
	movw R26,R28
	adiw R26,63
	ld R30,x+
	ld R31,x
	ldd R24,z+0
	cpi R24,6
	breq X173
	xjmp L217
X173:
X113:
;                     /* Either our previous address had been allocated by
;                        someone else or we changed the network. Remove the
;                        previous address and restart. */
;                     last_ip = 0;
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	std y+34,R20
	std y+35,R21
	std y+36,R22
	std y+37,R23
;                     dhcpState = DHCPST_INIT;
	ldi R24,1
	sts _dhcpState,R24
;                 }
;             }
;         }
	xjmp L217
L216:
; 
;         /*
;          * Maintain lease time.
;          */
;         else if (dhcpState == DHCPST_BOUND) {
	lds R24,_dhcpState
	cpi R24,5
	breq X174
	xjmp L230
X174:
X114:
;             retries = 0;
	clr R0
	std y+58,R0
;             NutEventBroadcast(&dhcpDone);
	ldi R16,<_dhcpDone
	ldi R17,>_dhcpDone
	xcall _NutEventBroadcast
;             if (dhcpConfig->dyn_renewalTime <= NutGetSeconds() - leaseTime) {
	xcall _NutGetSeconds
	ldd R2,y+42
	ldd R3,y+43
	ldd R4,y+44
	ldd R5,y+45
	movw R6,R16
	movw R8,R18
	sub R6,R2
	sbc R7,R3
	sbc R8,R4
	sbc R9,R5
	lds R30,_dhcpConfig
	lds R31,_dhcpConfig+1
	ldd R2,z+29
	ldd R3,z+30
	ldd R4,z+31
	ldd R5,z+32
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	brlo L232
X115:
;                 dhcpState = DHCPST_RENEWING;
	ldi R24,6
	sts _dhcpState,R24
;             } else {
	xjmp L231
L232:
;                 /* Calculate the remaining lease time and take a nap. */
;                 napTime = dhcpConfig->dyn_renewalTime - (NutGetSeconds() - leaseTime);
	xcall _NutGetSeconds
	ldd R2,y+42
	ldd R3,y+43
	ldd R4,y+44
	ldd R5,y+45
	movw R6,R16
	movw R8,R18
	sub R6,R2
	sbc R7,R3
	sbc R8,R4
	sbc R9,R5
	lds R30,_dhcpConfig
	lds R31,_dhcpConfig+1
	ldd R2,z+29
	ldd R3,z+30
	ldd R4,z+31
	ldd R5,z+32
	sub R2,R6
	sbc R3,R7
	sbc R4,R8
	sbc R5,R9
	std y+46,R2
	std y+47,R3
	std y+48,R4
	std y+49,R5
;                 if (napTime > MAX_DHCP_NAPTIME) {
	ldi R20,55
	ldi R21,137
	ldi R22,65
	ldi R23,0
	ldd R2,y+46
	ldd R3,y+47
	ldd R4,y+48
	ldd R5,y+49
	cp R20,R2
	cpc R21,R3
	cpc R22,R4
	cpc R23,R5
	brsh L234
X116:
;                     napTime = MAX_DHCP_NAPTIME;
	ldi R20,55
	ldi R21,137
	ldi R22,65
	ldi R23,0
	std y+46,R20
	std y+47,R21
	std y+48,R22
	std y+49,R23
;                 }
L234:
;                 NutEventWait(&dhcpWake, napTime * 1000UL);
	ldd R2,y+46
	ldd R3,y+47
	ldd R4,y+48
	ldd R5,y+49
	ldi R20,232
	ldi R21,3
	ldi R22,0
	ldi R23,0
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	movw R16,R20
	movw R18,R22
	xcall empy32u
	std y+0,R18
	std y+1,R19
	movw R18,R16
	ldi R16,<_dhcpWake
	ldi R17,>_dhcpWake
	xcall _NutEventWait
;             }
;         }
	xjmp L231
L230:
; 
;         /*
;          * Waiting for an acknowledge of our renewal request.
;          */
;         else if (dhcpState == DHCPST_RENEWING) {
	lds R24,_dhcpState
	cpi R24,6
	breq X175
	xjmp L236
X175:
X117:
;             retries++;
	ldd R0,y+58
	inc R0
	std y+58,R0
;             if (tmo / 1000 > dhcpConfig->dyn_rebindTime - (NutGetSeconds() - leaseTime)) {
	xcall _NutGetSeconds
	ldd R2,y+42
	ldd R3,y+43
	ldd R4,y+44
	ldd R5,y+45
	movw R6,R16
	movw R8,R18
	sub R6,R2
	sbc R7,R3
	sbc R8,R4
	sbc R9,R5
	lds R30,_dhcpConfig
	lds R31,_dhcpConfig+1
	ldd R2,z+33
	ldd R3,z+34
	ldd R4,z+35
	ldd R5,z+36
	sub R2,R6
	sbc R3,R7
	sbc R4,R8
	sbc R5,R9
	ldi R20,232
	ldi R21,3
	ldi R22,0
	ldi R23,0
	ldd R16,y+26
	ldd R17,y+27
	ldd R18,y+28
	ldd R19,y+29
	st -y,R23
	st -y,R22
	st -y,R21
	st -y,R20
	xcall div32u
	cp R2,R16
	cpc R3,R17
	cpc R4,R18
	cpc R5,R19
	brsh L238
X118:
;                 tmo = dhcpConfig->dyn_rebindTime - (NutGetSeconds() - leaseTime) * 1000;
	xcall _NutGetSeconds
	ldd R2,y+42
	ldd R3,y+43
	ldd R4,y+44
	ldd R5,y+45
	movw R6,R16
	movw R8,R18
	sub R6,R2
	sbc R7,R3
	sbc R8,R4
	sbc R9,R5
	ldi R20,232
	ldi R21,3
	ldi R22,0
	ldi R23,0
	st -y,R9
	st -y,R8
	st -y,R7
	st -y,R6
	movw R16,R20
	movw R18,R22
	xcall empy32u
	lds R30,_dhcpConfig
	lds R31,_dhcpConfig+1
	ldd R2,z+33
	ldd R3,z+34
	ldd R4,z+35
	ldd R5,z+36
	sub R2,R16
	sbc R3,R17
	sbc R4,R18
	sbc R5,R19
	std y+26,R2
	std y+27,R3
	std y+28,R4
	std y+29,R5
;             }
L238:
;             if (dhcpConfig->dyn_rebindTime <= NutGetSeconds() - leaseTime) {
	xcall _NutGetSeconds
	ldd R2,y+42
	ldd R3,y+43
	ldd R4,y+44
	ldd R5,y+45
	movw R6,R16
	movw R8,R18
	sub R6,R2
	sbc R7,R3
	sbc R8,R4
	sbc R9,R5
	lds R30,_dhcpConfig
	lds R31,_dhcpConfig+1
	ldd R2,z+33
	ldd R3,z+34
	ldd R4,z+35
	ldd R5,z+36
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	brlo L240
X119:
;                 retries = 0;
	clr R0
	std y+58,R0
;                 dhcpState = DHCPST_REBINDING;
	ldi R24,7
	sts _dhcpState,R24
;             }
	xjmp L237
L240:
;             /* Send a request to our leasing server. We must not include
;                the server identifier. */
;             else if (DhcpSendRequest(sock, dhcpConfig->dyn_sid, bp, xid, dhcpConfig->dyn_yiaddr, dhcpConfig->dyn_yiaddr, 0, secs) <
	movw R30,R28
	subi R30,189  ; addi 67
	sbci R31,255
	ldd R0,z+0
	ldd R1,z+1
	std y+21,R1
	std y+20,R0
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	std y+16,R20
	std y+17,R21
	std y+18,R22
	std y+19,R23
	lds R12,_dhcpConfig
	lds R13,_dhcpConfig+1
	movw R30,R12
	ldd R2,z+1
	ldd R3,z+2
	ldd R4,z+3
	ldd R5,z+4
	std y+50,R2
	std y+51,R3
	std y+52,R4
	std y+53,R5
	ldd R2,y+50
	ldd R3,y+51
	ldd R4,y+52
	ldd R5,y+53
	std y+12,R2
	std y+13,R3
	std y+14,R4
	std y+15,R5
	std y+8,R2
	std y+9,R3
	std y+10,R4
	std y+11,R5
	ldd R2,y+22
	ldd R3,y+23
	ldd R4,y+24
	ldd R5,y+25
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
	ldd R0,y+59
	ldd R1,y+60
	std y+3,R1
	std y+2,R0
	ldd R2,z+25
	ldd R3,z+26
	ldd R4,z+27
	ldd R5,z+28
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldd R16,y+61
	ldd R17,y+62
	xcall _DhcpSendRequest
	movw R12,R16
	cpi R16,0
	ldi R30,0
	cpc R17,R30
	brge L242
X120:
;                      0) {
;                 /* Unicast transmit error. */
;                 retries = 0;
	clr R0
	std y+58,R0
;                 dhcpState = DHCPST_REBINDING;
	ldi R24,7
	sts _dhcpState,R24
;             } else if ((n = DhcpRecvMessage(sock, xid, bp, tmo)) < 0) {
	xjmp L237
L242:
	ldd R2,y+26
	ldd R3,y+27
	ldd R4,y+28
	ldd R5,y+29
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
	ldd R0,y+59
	ldd R1,y+60
	std y+3,R1
	std y+2,R0
	ldd R2,y+22
	ldd R3,y+23
	ldd R4,y+24
	ldd R5,y+25
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldd R16,y+61
	ldd R17,y+62
	xcall _DhcpRecvMessage
	movw R12,R16
	movw R10,R12
	cpi R16,0
	ldi R30,0
	cpc R17,R30
	brge L244
X121:
;                 /* Fatal receive error. */
;                 dhcpState = DHCPST_IDLE;
	clr R2
	sts _dhcpState,R2
;             } else if (n > 0 && (reply = ParseReply(bp, n)) != 0) {
	xjmp L237
L244:
	clr R2
	clr R3
	cp R2,R10
	cpc R3,R11
	brlt X176
	xjmp L237
X176:
X122:
	movw R18,R10
	ldd R16,y+59
	ldd R17,y+60
	xcall _ParseReply
	movw R12,R16
	movw R30,R28
	adiw R30,63
	std z+1,R13
	std z+0,R12
	cpi R16,0
	cpc R16,R17
	brne X177
	xjmp L237
X177:
X123:
;                 if (reply->dyn_msgtyp == DHCP_ACK) {
	movw R30,R12
	ldd R24,z+0
	cpi R24,5
	brne L248
X124:
;                     /* Got an acknowledge, return to bound state. */
;                     ReleaseDynCfg(dhcpConfig);
	lds R16,_dhcpConfig
	lds R17,_dhcpConfig+1
	xcall _ReleaseDynCfg
;                     dhcpConfig = reply;
	movw R30,R28
	adiw R30,63
	ldd R0,z+0
	ldd R1,z+1
	sts _dhcpConfig+1,R1
	sts _dhcpConfig,R0
;                     reply = 0;
	clr R0
	clr R1
	movw R30,R28
	adiw R30,63
	std z+1,R1
	std z+0,R0
;                     leaseTime = aqsTime;
	ldd R2,y+38
	ldd R3,y+39
	ldd R4,y+40
	ldd R5,y+41
	std y+42,R2
	std y+43,R3
	std y+44,R4
	std y+45,R5
;                     dhcpState = DHCPST_BOUND;
	ldi R24,5
	sts _dhcpState,R24
;                 } else if (reply->dyn_msgtyp == DHCP_NAK) {
	xjmp L237
L248:
	movw R26,R28
	adiw R26,63
	ld R30,x+
	ld R31,x
	ldd R24,z+0
	cpi R24,6
	breq X178
	xjmp L237
X178:
X125:
;                     /* Unexpected NAK. */
;                     retries = 0;
	clr R0
	std y+58,R0
;                     dhcpState = DHCPST_REBINDING;
	ldi R24,7
	sts _dhcpState,R24
;                 }
;             }
;         }
	xjmp L237
L236:
; 
;         /*
;          * Waiting for an acknowledge of our rebind request.
;          */
;         else if (dhcpState == DHCPST_REBINDING) {
	lds R24,_dhcpState
	cpi R24,7
	breq X179
	xjmp L252
X179:
X126:
;             retries++;
	ldd R0,y+58
	inc R0
	std y+58,R0
;             if (tmo > dhcpConfig->dyn_rebindTime - (NutGetSeconds() - leaseTime)) {
	xcall _NutGetSeconds
	ldd R2,y+42
	ldd R3,y+43
	ldd R4,y+44
	ldd R5,y+45
	movw R6,R16
	movw R8,R18
	sub R6,R2
	sbc R7,R3
	sbc R8,R4
	sbc R9,R5
	lds R30,_dhcpConfig
	lds R31,_dhcpConfig+1
	ldd R2,z+33
	ldd R3,z+34
	ldd R4,z+35
	ldd R5,z+36
	sub R2,R6
	sbc R3,R7
	sbc R4,R8
	sbc R5,R9
	ldd R6,y+26
	ldd R7,y+27
	ldd R8,y+28
	ldd R9,y+29
	cp R2,R6
	cpc R3,R7
	cpc R4,R8
	cpc R5,R9
	brsh L254
X127:
;                 tmo = dhcpConfig->dyn_rebindTime - NutGetSeconds() - leaseTime;
	xcall _NutGetSeconds
	lds R30,_dhcpConfig
	lds R31,_dhcpConfig+1
	ldd R2,z+33
	ldd R3,z+34
	ldd R4,z+35
	ldd R5,z+36
	sub R2,R16
	sbc R3,R17
	sbc R4,R18
	sbc R5,R19
	ldd R6,y+42
	ldd R7,y+43
	ldd R8,y+44
	ldd R9,y+45
	sub R2,R6
	sbc R3,R7
	sbc R4,R8
	sbc R5,R9
	std y+26,R2
	std y+27,R3
	std y+28,R4
	std y+29,R5
;             }
L254:
;             if (dhcpConfig->dyn_rebindTime <= NutGetSeconds() - leaseTime) {
	xcall _NutGetSeconds
	ldd R2,y+42
	ldd R3,y+43
	ldd R4,y+44
	ldd R5,y+45
	movw R6,R16
	movw R8,R18
	sub R6,R2
	sbc R7,R3
	sbc R8,R4
	sbc R9,R5
	lds R30,_dhcpConfig
	lds R31,_dhcpConfig+1
	ldd R2,z+33
	ldd R3,z+34
	ldd R4,z+35
	ldd R5,z+36
	cp R6,R2
	cpc R7,R3
	cpc R8,R4
	cpc R9,R5
	brlo L256
X128:
;                 retries = 0;
	clr R0
	std y+58,R0
;                 dhcpState = DHCPST_REBINDING;
	ldi R24,7
	sts _dhcpState,R24
;             }
	xjmp L253
L256:
;             /* Broadcast a request for our previous configuration. We 
;                must not include a server identifier. */
;             else if (DhcpBroadcastRequest(sock, bp, xid, dhcpConfig->dyn_yiaddr, dhcpConfig->dyn_yiaddr, 0, secs) < 0) {
	movw R30,R28
	subi R30,189  ; addi 67
	sbci R31,255
	ldd R0,z+0
	ldd R1,z+1
	std y+17,R1
	std y+16,R0
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	std y+12,R20
	std y+13,R21
	std y+14,R22
	std y+15,R23
	lds R30,_dhcpConfig
	lds R31,_dhcpConfig+1
	ldd R2,z+1
	ldd R3,z+2
	ldd R4,z+3
	ldd R5,z+4
	std y+50,R2
	std y+51,R3
	std y+52,R4
	std y+53,R5
	ldd R2,y+50
	ldd R3,y+51
	ldd R4,y+52
	ldd R5,y+53
	std y+8,R2
	std y+9,R3
	std y+10,R4
	std y+11,R5
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
	ldd R2,y+22
	ldd R3,y+23
	ldd R4,y+24
	ldd R5,y+25
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldd R18,y+59
	ldd R19,y+60
	ldd R16,y+61
	ldd R17,y+62
	xcall _DhcpBroadcastRequest
	movw R12,R16
	cpi R16,0
	ldi R30,0
	cpc R17,R30
	brge L258
X129:
;                 /* Fatal transmit error on broadcast. Give up. */
;                 dhcpState = DHCPST_IDLE;
	clr R2
	sts _dhcpState,R2
;             } else if ((n = DhcpRecvMessage(sock, xid, bp, tmo)) < 0) {
	xjmp L253
L258:
	ldd R2,y+26
	ldd R3,y+27
	ldd R4,y+28
	ldd R5,y+29
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
	ldd R0,y+59
	ldd R1,y+60
	std y+3,R1
	std y+2,R0
	ldd R2,y+22
	ldd R3,y+23
	ldd R4,y+24
	ldd R5,y+25
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldd R16,y+61
	ldd R17,y+62
	xcall _DhcpRecvMessage
	movw R12,R16
	movw R10,R12
	cpi R16,0
	ldi R30,0
	cpc R17,R30
	brge L260
X130:
;                 /* Fatal receive error. */
;                 dhcpState = DHCPST_IDLE;
	clr R2
	sts _dhcpState,R2
;             } else if (n > 0 && (reply = ParseReply(bp, n)) != 0) {
	xjmp L253
L260:
	clr R2
	clr R3
	cp R2,R10
	cpc R3,R11
	brlt X180
	xjmp L253
X180:
X131:
	movw R18,R10
	ldd R16,y+59
	ldd R17,y+60
	xcall _ParseReply
	movw R12,R16
	movw R30,R28
	adiw R30,63
	std z+1,R13
	std z+0,R12
	cpi R16,0
	cpc R16,R17
	brne X181
	xjmp L253
X181:
X132:
;                 if (reply->dyn_msgtyp == DHCP_ACK) {
	movw R30,R12
	ldd R24,z+0
	cpi R24,5
	brne L264
X133:
;                     /* Got an acknowledge, return to bound state. */
;                     ReleaseDynCfg(dhcpConfig);
	lds R16,_dhcpConfig
	lds R17,_dhcpConfig+1
	xcall _ReleaseDynCfg
;                     dhcpConfig = reply;
	movw R30,R28
	adiw R30,63
	ldd R0,z+0
	ldd R1,z+1
	sts _dhcpConfig+1,R1
	sts _dhcpConfig,R0
;                     reply = 0;
	clr R0
	clr R1
	movw R30,R28
	adiw R30,63
	std z+1,R1
	std z+0,R0
;                     leaseTime = aqsTime;
	ldd R2,y+38
	ldd R3,y+39
	ldd R4,y+40
	ldd R5,y+41
	std y+42,R2
	std y+43,R3
	std y+44,R4
	std y+45,R5
;                     dhcpState = DHCPST_BOUND;
	ldi R24,5
	sts _dhcpState,R24
;                 } else if (reply->dyn_msgtyp == DHCP_NAK) {
	xjmp L253
L264:
	movw R26,R28
	adiw R26,63
	ld R30,x+
	ld R31,x
	ldd R24,z+0
	cpi R24,6
	breq X182
	xjmp L253
X182:
X134:
;                     /*
;                      * We have a problem here if the last DHCP server died. 
;                      * If a backup server exists, it may probe our IP address
;                      * using ARP or ICMP. Our interface is up and responding,
;                      * so the backup server may think that the IP address
;                      * is in use and respond with NAK. Without shutting
;                      * down our interface (not yet implemented) we are stuck.
;                      * We switch to discovery state, but the problem remains.
;                      */
;                     dhcpState = DHCPST_INIT;
	ldi R24,1
	sts _dhcpState,R24
;                 }
;             }
;         }
	xjmp L253
L252:
; 
;         /*
;          * Send an inform and wait for its (optional) echo.
;          */
;         else if (dhcpState == DHCPST_INFORMING) {
	lds R24,_dhcpState
	cpi R24,8
	breq X183
	xjmp L268
X183:
X135:
;             if (retries++ > MAX_DCHP_RETRIES) {
	ldd R12,y+58
	clr R13
	mov R24,R12
	subi R24,255    ; addi 1
	std y+58,R24
	ldi R24,3
	cp R24,R12
	brsh L270
X136:
;                 dhcpState = DHCPST_IDLE;
	clr R2
	sts _dhcpState,R2
;             } else if (DhcpSendInform(sock, server_ip, bp, xid, nif->if_local_ip) < 0) {
	xjmp L269
L270:
	movw R26,R28
	subi R26,191  ; addi 65
	sbci R27,255
	ld R30,x+
	ld R31,x
	ldd R2,z+7
	ldd R3,z+8
	ldd R4,z+9
	ldd R5,z+10
	std y+8,R2
	std y+9,R3
	std y+10,R4
	std y+11,R5
	ldd R2,y+22
	ldd R3,y+23
	ldd R4,y+24
	ldd R5,y+25
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
	ldd R0,y+59
	ldd R1,y+60
	std y+3,R1
	std y+2,R0
	ldd R2,y+30
	ldd R3,y+31
	ldd R4,y+32
	ldd R5,y+33
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldd R16,y+61
	ldd R17,y+62
	xcall _DhcpSendInform
	movw R12,R16
	cpi R16,0
	ldi R30,0
	cpc R17,R30
	brge L272
X137:
;                 if (server_ip == INADDR_BROADCAST) {
	ldi R20,255
	ldi R21,255
	ldi R22,255
	ldi R23,255
	ldd R2,y+30
	ldd R3,y+31
	ldd R4,y+32
	ldd R5,y+33
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	breq X184
	xjmp L269
X184:
X138:
;                     dhcpState = DHCPST_IDLE;
	clr R2
	sts _dhcpState,R2
;                 }
;             } else if ((n = DhcpRecvMessage(sock, xid, bp, tmo)) != 0) {
	xjmp L269
L272:
	ldd R2,y+26
	ldd R3,y+27
	ldd R4,y+28
	ldd R5,y+29
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
	ldd R0,y+59
	ldd R1,y+60
	std y+3,R1
	std y+2,R0
	ldd R2,y+22
	ldd R3,y+23
	ldd R4,y+24
	ldd R5,y+25
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldd R16,y+61
	ldd R17,y+62
	xcall _DhcpRecvMessage
	movw R12,R16
	movw R10,R12
	cpi R16,0
	cpc R16,R17
	brne X185
	xjmp L269
X185:
X139:
;                 if (n > 0 &&    /* No receive error. */
	clr R2
	clr R3
	cp R2,R16
	cpc R3,R17
	brge L278
X140:
	movw R18,R10
	ldd R16,y+59
	ldd R17,y+60
	xcall _ParseReply
	movw R12,R16
	movw R30,R28
	adiw R30,63
	std z+1,R13
	std z+0,R12
	cpi R16,0
	cpc R16,R17
	breq L278
X141:
	movw R30,R12
	ldd R24,z+0
	cpi R24,5
	brne L278
X142:
;                     (reply = ParseReply(bp, n)) != 0 && /* No parser error. */
;                     reply->dyn_msgtyp == DHCP_ACK) {    /* Acknowledged. */
;                     /* Take over this configuration. */
;                     ReleaseDynCfg(dhcpConfig);
	lds R16,_dhcpConfig
	lds R17,_dhcpConfig+1
	xcall _ReleaseDynCfg
;                     dhcpConfig = reply;
	movw R30,R28
	adiw R30,63
	ldd R0,z+0
	ldd R1,z+1
	sts _dhcpConfig+1,R1
	sts _dhcpConfig,R0
;                     reply = 0;
	clr R0
	clr R1
	movw R30,R28
	adiw R30,63
	std z+1,R1
	std z+0,R0
;                 }
L278:
;                 dhcpState = DHCPST_IDLE;
	clr R2
	sts _dhcpState,R2
;             }
;         }
	xjmp L269
L268:
; 
;         /*
;          * Send a release and wait for its (optional) echo.
;          */
;         else if (dhcpState == DHCPST_RELEASING) {
	lds R24,_dhcpState
	cpi R24,9
	breq X186
	xjmp L280
X186:
X143:
;             if (dhcpConfig == 0 ||      /* Not configured. */
	lds R12,_dhcpConfig
	lds R13,_dhcpConfig+1
	tst R12
	brne X144
	tst R13
	brne X187
	xjmp L285
X187:
X144:
	ldd R14,y+58
	clr R15
	mov R24,R14
	subi R24,255    ; addi 1
	std y+58,R24
	ldi R24,0
	cp R24,R14
	brlo L285
X145:
	movw R30,R12
	ldd R2,z+25
	ldd R3,z+26
	ldd R4,z+27
	ldd R5,z+28
	std y+12,R2
	std y+13,R3
	std y+14,R4
	std y+15,R5
	ldd R2,z+1
	ldd R3,z+2
	ldd R4,z+3
	ldd R5,z+4
	std y+8,R2
	std y+9,R3
	std y+10,R4
	std y+11,R5
	ldd R2,y+22
	ldd R3,y+23
	ldd R4,y+24
	ldd R5,y+25
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
	ldd R0,y+59
	ldd R1,y+60
	std y+3,R1
	std y+2,R0
	ldd R2,y+30
	ldd R3,y+31
	ldd R4,y+32
	ldd R5,y+33
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldd R16,y+61
	ldd R17,y+62
	xcall _DhcpSendRelease
	movw R12,R16
	cpi R16,0
	ldi R30,0
	cpc R17,R30
	brge L282
X146:
L285:
;                 retries++ > MAX_DCHP_RELEASE_RETRIES || /* Too many retries. */
;                 DhcpSendRelease(sock, server_ip, bp, xid, dhcpConfig->dyn_yiaddr, dhcpConfig->dyn_sid) < 0) {
;                 if (server_ip == INADDR_BROADCAST) {
	ldi R20,255
	ldi R21,255
	ldi R22,255
	ldi R23,255
	ldd R2,y+30
	ldd R3,y+31
	ldd R4,y+32
	ldd R5,y+33
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	breq X188
	xjmp L281
X188:
X147:
;                     dhcpState = DHCPST_IDLE;
	clr R2
	sts _dhcpState,R2
;                 }
;             } else if ((n = DhcpRecvMessage(sock, xid, bp, tmo)) < 0) {
	xjmp L281
L282:
	ldd R2,y+26
	ldd R3,y+27
	ldd R4,y+28
	ldd R5,y+29
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
	ldd R0,y+59
	ldd R1,y+60
	std y+3,R1
	std y+2,R0
	ldd R2,y+22
	ldd R3,y+23
	ldd R4,y+24
	ldd R5,y+25
	std y+0,R4
	std y+1,R5
	movw R18,R2
	ldd R16,y+61
	ldd R17,y+62
	xcall _DhcpRecvMessage
	movw R12,R16
	movw R10,R12
	cpi R16,0
	ldi R30,0
	cpc R17,R30
	brge L288
X148:
;                 /* Fatal receive error. */
;                 dhcpState = DHCPST_IDLE;
	clr R2
	sts _dhcpState,R2
;             } else if (n > 0 && (reply = ParseReply(bp, n)) != 0) {
	xjmp L281
L288:
	clr R2
	clr R3
	cp R2,R10
	cpc R3,R11
	brlt X189
	xjmp L281
X189:
X149:
	movw R18,R10
	ldd R16,y+59
	ldd R17,y+60
	xcall _ParseReply
	movw R10,R16
	movw R30,R28
	adiw R30,63
	std z+1,R11
	std z+0,R10
	cpi R16,0
	cpc R16,R17
	brne X190
	xjmp L281
X190:
X150:
;                 if (reply->dyn_msgtyp == DHCP_ACK) {
	movw R30,R10
	ldd R24,z+0
	cpi R24,5
	brne L292
X151:
;                     dhcpState = DHCPST_IDLE;
	clr R2
	sts _dhcpState,R2
;                 } else if (reply->dyn_msgtyp == DHCP_NAK) {
	xjmp L281
L292:
	movw R26,R28
	adiw R26,63
	ld R30,x+
	ld R31,x
	ldd R24,z+0
	cpi R24,6
	brne L281
X152:
;                     dhcpState = DHCPST_IDLE;
	clr R2
	sts _dhcpState,R2
;                 }
;             }
;         }
	xjmp L281
L280:
; 
;         /*
;          * We are done somehow. Either a fatal error occured or we 
;          * reached the specified timeout time or our lease has been
;          * release or something else configured our interface.
;          * Release all resources and wait for a new API call to
;          * wake us up.
;          */
;         else if (dhcpState == DHCPST_IDLE) {
	lds R2,_dhcpState
	tst R2
	brne L296
X153:
;             ReleaseDynCfg(dhcpConfig);
	lds R16,_dhcpConfig
	lds R17,_dhcpConfig+1
	xcall _ReleaseDynCfg
;             dhcpConfig = 0;
	clr R2
	clr R3
	sts _dhcpConfig+1,R3
	sts _dhcpConfig,R2
;             retries = 0;
	clr R0
	std y+58,R0
;             NutEventBroadcast(&dhcpDone);
	ldi R16,<_dhcpDone
	ldi R17,>_dhcpDone
	xcall _NutEventBroadcast
;             NutEventWait(&dhcpWake, NUT_WAIT_INFINITE);
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	std y+0,R22
	std y+1,R23
	movw R18,R20
	ldi R16,<_dhcpWake
	ldi R17,>_dhcpWake
	xcall _NutEventWait
;         }
L296:
L281:
L269:
L253:
L237:
L231:
L217:
L203:
L186:
L181:
; 
;         /* Release any received reply. */
;         if (reply) {
	movw R30,R28
	adiw R30,63
	ldd R0,z+0
	ldd R1,z+1
	tst R0
	brne X154
	tst R1
	brne X191
	xjmp L135
X191:
X154:
;             ReleaseDynCfg(reply);
	movw R16,R0
	xcall _ReleaseDynCfg
;             reply = 0;
	clr R0
	clr R1
	movw R30,R28
	adiw R30,63
	std z+1,R1
	std z+0,R0
;         }
;     }
	xjmp L135
X155:
L129:
	.dbline 0 ; func end
	adiw R28,63
	adiw R28,6  ; offset = 69
	xjmp pop_xgsetF0FC
;            nif -> R12,R13
;            dev -> R20,R21
;        timeout -> y+10
;          state -> R10
;           name -> R12,R13
	.even
_DhcpKick:
	xcall push_xgset303C
	mov R10,R18
	movw R12,R16
	sbiw R28,4
; }
; 
; /*!
;  * \brief Activate the DHCP client thread.
;  *
;  * Start the DHCP thread if not running or wake it up. Pass the caller's 
;  * timeout to the thread and wait an infinite time. We rely on the thread 
;  * to wake us up on timeout.
;  *
;  * \param name    Name of the registered Ethernet device.
;  * \param state   State to start with.
;  * \param timeout Maximum number of milliseconds to wait. To disable 
;  *                timeout, set this parameter to \ref NUT_WAIT_INFINITE.
;  *                This value must be larger than 3 times of \ref MIN_DHCP_WAIT
;  *                to enable collection of offers from multiple servers.
;  */
; static int DhcpKick(CONST char *name, u_char state, u_long timeout)
; {
;     NUTDEVICE *dev;
;     IFNET *nif;
; 
;     /* Lookup the Ethernet device. */
;     if ((dev = NutDeviceLookup(name)) == 0 ||   /* No device */
	movw R16,R12
	xcall _NutDeviceLookup
	movw R20,R16
	cpi R20,0
	cpc R20,R21
	breq L305
X192:
	movw R30,R20
	ldd R24,z+11
	cpi R24,3
	brne L305
X193:
	ldd R2,z+15
	ldd R3,z+16
	movw R12,R2
	tst R12
	brne X194
	tst R13
	breq L305
X194:
	movw R30,R2
	ldd R24,z+0
	cpi R24,6
	breq L301
X195:
L305:
;         dev->dev_type != IFTYP_NET ||   /* Wrong type */
;         (nif = dev->dev_icb) == 0 ||    /* No netif */
;         nif->if_type != IFT_ETHER) {    /* Wrong if type */
;         dhcpError = DHCPERR_BADDEV;
	ldi R24,17
	ldi R25,0
	sts _dhcpError+1,R25
	sts _dhcpError,R24
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L300
L301:
;     }
; 
;     /* Initialize timeout checking. */
;     dhcpApiStart = NutGetMillis();
	xcall _NutGetMillis
	sts _dhcpApiStart+1,R17
	sts _dhcpApiStart,R16
	sts _dhcpApiStart+2+1,R19
	sts _dhcpApiStart+2,R18
;     dhcpApiTimeout = timeout;
	ldd R2,y+10
	ldd R3,y+11
	ldd R4,y+12
	ldd R5,y+13
	sts _dhcpApiTimeout+1,R3
	sts _dhcpApiTimeout,R2
	sts _dhcpApiTimeout+2+1,R5
	sts _dhcpApiTimeout+2,R4
; 
;     dhcpState = state;
	sts _dhcpState,R10
;     if (dhcpThread == 0) {
	lds R2,_dhcpThread
	lds R3,_dhcpThread+1
	tst R2
	brne L306
	tst R3
	brne L306
X196:
; #ifdef __arm__
;         dhcpDev = dev;
; #endif
;         dhcpThread = NutThreadCreate("dhcpc", NutDhcpClient, dev, NUT_THREAD_DHCPSTACK);
	ldi R24,512
	ldi R25,2
	std y+3,R25
	std y+2,R24
	std y+1,R21
	std y+0,R20
	ldi R18,<PL_NutDhcpClient
	ldi R19,>PL_NutDhcpClient
	ldi R16,<L308
	ldi R17,>L308
	xcall _NutThreadCreate
	movw R10,R16
	sts _dhcpThread+1,R11
	sts _dhcpThread,R10
;     }
L306:
;     NutEventPost(&dhcpWake);
	ldi R16,<_dhcpWake
	ldi R17,>_dhcpWake
	xcall _NutEventPost
;     NutEventWait(&dhcpDone, NUT_WAIT_INFINITE);
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+0,R26
	std y+1,R27
	movw R18,R24
	ldi R16,<_dhcpDone
	ldi R17,>_dhcpDone
	xcall _NutEventWait
; 
;     return 0;
	clr R16
	clr R17
L300:
	.dbline 0 ; func end
	adiw R28,4
	xjmp pop_xgset303C
;           macF -> y+18
;           mac0 -> y+12
;            dev -> R14,R15
;            nif -> R12,R13
;        timeout -> y+38
;            mac -> y+36
;           name -> y+34
	.even
_NutDhcpIfConfig::
	xcall push_arg4
	xcall push_xgsetF0FC
	sbiw R28,24
; }
; 
; /*!
;  * \brief Automatically configure an Ethernet network interface.
;  *
;  * If no MAC address is specified, this routine will try to read a 
;  * previously stored configuration from the EEPROM. If this retrieves 
;  * a fixed IP configuration, then the network interface will be 
;  * immediately configured with these values by calling NutNetIfConfig(). 
;  * If no valid IP configuration has been read, then this routine will 
;  * start the DHCP client thread and wait upto a given number of 
;  * milliseconds for an acknowledged configuration from a DHCP server.
;  *
;  * If a MAC address has been specified, this routine will not read the 
;  * EEPROM configuration. If the application has set the global 
;  * \ref CONFNET structure to a valid IP configuration before calling 
;  * this function, then the network interface will be immediately 
;  * configured with these values by calling NutNetIfConfig(). Otherwise 
;  * the DHCP client thread will be started and this routine will wait 
;  * upto a given number of milliseconds for an acknowledged configuration 
;  * from a DHCP server.
;  *
;  * \param name    Name of the registered Ethernet device.
;  * \param mac     MAC address of the destination. Set NULL to use the 
;  *                configuration stored in the EEPROM.
;  * \param timeout Maximum number of milliseconds to wait. To disable 
;  *                timeout, set this parameter to \ref NUT_WAIT_INFINITE.
;  *                Otherwise the value must be larger than 3 times of 
;  *                \ref MIN_DHCP_WAIT to enable collection of offers 
;  *                from multiple servers.
;  *
;  * \return 0 if the interface had been successfully configured. In most
;  *         cases this information is sufficient, because the application
;  *         will not care whether the configuration had been provided by
;  *         a DHCP server or EEPROM values. However, if EEPROM values had
;  *         been used, then no DNS servers had been set. The application
;  *         can call NutDhcpStatus() to check the DHCP bound state. -1 is
;  *         returned if the interface configuration failed. In this case
;  *         NutDhcpError() can be called to get a more specific error
;  *         code.
;  */
; int NutDhcpIfConfig(CONST char *name, u_char * mac, u_long timeout)
; {
;     u_char mac0[6];
;     u_char macF[6];
;     NUTDEVICE *dev;
;     IFNET *nif;
; 
;     /*
;      * Lookup the Ethernet device.
;      */
;     if ((dev = NutDeviceLookup(name)) == 0 ||   /* No device */
	ldd R16,y+34
	ldd R17,y+35
	xcall _NutDeviceLookup
	movw R14,R16
	tst R14
	brne X197
	tst R15
	breq L314
X197:
	movw R30,R14
	ldd R24,z+11
	cpi R24,3
	brne L314
X198:
	ldd R2,z+15
	ldd R3,z+16
	movw R12,R2
	tst R12
	brne X199
	tst R13
	breq L314
X199:
	movw R30,R2
	ldd R24,z+0
	cpi R24,6
	breq L310
X200:
L314:
;         dev->dev_type != IFTYP_NET ||   /* Wrong type */
;         (nif = dev->dev_icb) == 0 ||    /* No netif */
;         nif->if_type != IFT_ETHER) {    /* Wrong if type */
;         dhcpError = DHCPERR_BADDEV;
	ldi R24,17
	ldi R25,0
	sts _dhcpError+1,R25
	sts _dhcpError,R24
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L309
L310:
;     }
; 
;     /*
;      * We determine whether the interface is enabled by checking
;      * the MAC address. This is so bloody brain dead.
;      */
;     memset(mac0, 0x00, sizeof(mac0));   /* Uses more code but less RAM... */
	ldi R24,6
	ldi R25,0
	std y+1,R25
	std y+0,R24
	clr R18
	clr R19
	movw R16,R28
	subi R16,244  ; offset = 12
	sbci R17,255
	xcall _memset
;     memset(macF, 0xFF, sizeof(macF));   /* ...than init in declaration.   */
	ldi R24,6
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,255
	ldi R19,0
	movw R16,R28
	subi R16,238  ; offset = 18
	sbci R17,255
	xcall _memset
;     if (memcmp(nif->if_mac, mac0, 6) == 0 || memcmp(nif->if_mac, macF, 6) == 0) {
	ldi R24,6
	ldi R25,0
	std y+1,R25
	std y+0,R24
	movw R18,R28
	subi R18,244  ; offset = 12
	sbci R19,255
	movw R16,R12
	subi R16,255  ; offset = 1
	sbci R17,255
	xcall _memcmp
	movw R10,R16
	cpi R16,0
	cpc R16,R17
	breq L317
X201:
	ldi R24,6
	ldi R25,0
	std y+1,R25
	std y+0,R24
	movw R18,R28
	subi R18,238  ; offset = 18
	sbci R19,255
	movw R16,R12
	subi R16,255  ; offset = 1
	sbci R17,255
	xcall _memcmp
	movw R10,R16
	cpi R16,0
	cpc R16,R17
	brne L315
X202:
L317:
;         /*
;          * If the caller specified a MAC address, we use it and
;          * overwrite the configuration.
;          */
;         if (mac) {
	ldd R0,y+36
	ldd R1,y+37
	tst R0
	brne X203
	tst R1
	breq L318
X203:
;             memcpy(confnet.cdn_mac, mac, sizeof(confnet.cdn_mac));
	ldi R24,6
	ldi R25,0
	std y+1,R25
	std y+0,R24
	movw R18,R0
	ldi R16,<_confnet+10
	ldi R17,>_confnet+10
	xcall _memcpy
;         }
	xjmp L319
L318:
; 
;         /*
;          * If no MAC address has been specified, read the configuration 
;          * from EEPROM. If this fails, we do not continue any further,
;          * but let the caller know that something is wrong. He may call
;          * us again with a valid MAC address.
;          */
;         else if (NutNetLoadConfig(name)) {
	ldd R16,y+34
	ldd R17,y+35
	xcall _NutNetLoadConfig
	movw R10,R16
	cpi R16,0
	cpc R16,R17
	breq L322
X204:
;             dhcpError = DHCPERR_NOMAC;
	ldi R24,2
	ldi R25,0
	sts _dhcpError+1,R25
	sts _dhcpError,R24
;             return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L309
L322:
L319:
;         }
; 
;         /*
;          * Copy the MAC address to the interface structure. This will
;          * magically brain dead enable the interface.
;          */
;         memcpy(nif->if_mac, confnet.cdn_mac, 6);
	ldi R24,6
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<_confnet+10
	ldi R19,>_confnet+10
	movw R16,R12
	subi R16,255  ; offset = 1
	sbci R17,255
	xcall _memcpy
;         NutSleep(500);
	ldi R16,244
	ldi R17,1
	ldi R18,0
	ldi R19,0
	xcall _NutSleep
;     }
L315:
; 
;     /*
;      * If the EEPROM contains a fixed network configuration, we skip DHCP.
;      */
;     if ((confnet.cdn_cip_addr & confnet.cdn_ip_mask) != 0) {
	lds R4,_confnet+20+2
	lds R5,_confnet+20+2+1
	lds R2,_confnet+20
	lds R3,_confnet+20+1
	lds R8,_confnet+28+2
	lds R9,_confnet+28+2+1
	lds R6,_confnet+28
	lds R7,_confnet+28+1
	and R6,R2
	and R7,R3
	and R8,R4
	and R9,R5
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	cp R6,R20
	cpc R7,R21
	cpc R8,R22
	cpc R9,R23
	breq L325
X205:
;         confnet.cdn_ip_addr = confnet.cdn_cip_addr;
	lds R4,_confnet+28+2
	lds R5,_confnet+28+2+1
	lds R2,_confnet+28
	lds R3,_confnet+28+1
	sts _confnet+16+1,R3
	sts _confnet+16,R2
	sts _confnet+16+2+1,R5
	sts _confnet+16+2,R4
;         NutNetIfConfig2(name, confnet.cdn_mac, confnet.cdn_ip_addr, confnet.cdn_ip_mask, confnet.cdn_gateway);
	lds R4,_confnet+24+2
	lds R5,_confnet+24+2+1
	lds R2,_confnet+24
	lds R3,_confnet+24+1
	std y+8,R2
	std y+9,R3
	std y+10,R4
	std y+11,R5
	lds R4,_confnet+20+2
	lds R5,_confnet+20+2+1
	lds R2,_confnet+20
	lds R3,_confnet+20+1
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
	lds R4,_confnet+16+2
	lds R5,_confnet+16+2+1
	lds R2,_confnet+16
	lds R3,_confnet+16+1
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldi R18,<_confnet+10
	ldi R19,>_confnet+10
	ldd R16,y+34
	ldd R17,y+35
	xcall _NutNetIfConfig2
;         return 0;
	clr R16
	clr R17
	xjmp L309
L325:
;     }
; 
;     /*
;      * Start the DHCP thread if not running or wake it up. Pass the caller's 
;      * timeout to the thread and wait an infinite time. We rely on the thread 
;      * to wake us up on timeout.
;      */
;     if (DhcpKick(name, DHCPST_INIT, timeout) == 0) {
	ldd R2,y+38
	ldd R3,y+39
	ldd R4,y+40
	ldd R5,y+41
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldi R18,1
	ldd R16,y+34
	ldd R17,y+35
	xcall _DhcpKick
	movw R10,R16
	cpi R16,0
	cpc R16,R17
	breq X210
	xjmp L335
X210:
X206:
;         /*
;          * The thread finished its task. If it reached the bound state, then
;          * we got a valid configuration from DHCP.
;          */
;         if (dhcpState == DHCPST_BOUND) {
	lds R24,_dhcpState
	cpi R24,5
	breq X211
	xjmp L337
X211:
X207:
; #ifdef NUTDEBUG
;             if (__tcp_trf) {
;                 fprintf(__tcp_trs, "[DHCP-Config %s]", inet_ntoa(dhcpConfig->dyn_yiaddr));
;             }
; #endif
;             NutNetIfSetup(dev, dhcpConfig->dyn_yiaddr, dhcpConfig->dyn_netmask, dhcpConfig->dyn_gateway);
	lds R10,_dhcpConfig
	lds R11,_dhcpConfig+1
	movw R30,R10
	ldd R2,z+13
	ldd R3,z+14
	ldd R4,z+15
	ldd R5,z+16
	std y+6,R2
	std y+7,R3
	std y+8,R4
	std y+9,R5
	ldd R2,z+5
	ldd R3,z+6
	ldd R4,z+7
	ldd R5,z+8
	std y+2,R2
	std y+3,R3
	std y+4,R4
	std y+5,R5
	ldd R2,z+1
	ldd R3,z+2
	ldd R4,z+3
	ldd R5,z+4
	std y+0,R4
	std y+1,R5
	movw R18,R2
	movw R16,R14
	xcall _NutNetIfSetup
;             NutDnsConfig2(0, 0, dhcpConfig->dyn_pdns, dhcpConfig->dyn_sdns);
	lds R14,_dhcpConfig
	lds R15,_dhcpConfig+1
	movw R30,R14
	ldd R2,z+21
	ldd R3,z+22
	ldd R4,z+23
	ldd R5,z+24
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
	ldd R2,z+17
	ldd R3,z+18
	ldd R4,z+19
	ldd R5,z+20
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	clr R18
	clr R19
	clr R16
	clr R17
	xcall _NutDnsConfig2
;             return 0;
	clr R16
	clr R17
	xjmp L309
L337:
;         }
; 
;         /*
;          * Our interface has been configured externally, possibly by auto 
;          * ARP or a similar function implemented by the application.
;          */
;         if (nif->if_local_ip) {
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	movw R30,R12
	ldd R2,z+7
	ldd R3,z+8
	ldd R4,z+9
	ldd R5,z+10
	cp R2,R20
	cpc R3,R21
	cpc R4,R22
	cpc R5,R23
	breq L339
X208:
; #ifdef NUTDEBUG
;             if (__tcp_trf) {
;                 fprintf(__tcp_trs, "[DHCP-External %s]", inet_ntoa(nif->if_local_ip));
;             }
; #endif
;             return 0;
	clr R16
	clr R17
	xjmp L309
L339:
;         }
; 
;         /*
;          * DHCP failed. In case we remember a previously allocated address, 
;          * then let's use it.
;          */
;         if ((confnet.cdn_ip_addr & confnet.cdn_ip_mask) != 0) {
	lds R4,_confnet+20+2
	lds R5,_confnet+20+2+1
	lds R2,_confnet+20
	lds R3,_confnet+20+1
	lds R8,_confnet+16+2
	lds R9,_confnet+16+2+1
	lds R6,_confnet+16
	lds R7,_confnet+16+1
	and R6,R2
	and R7,R3
	and R8,R4
	and R9,R5
	ldi R20,0
	ldi R21,0
	ldi R22,0
	ldi R23,0
	cp R6,R20
	cpc R7,R21
	cpc R8,R22
	cpc R9,R23
	breq L341
X209:
; #ifdef NUTDEBUG
;             if (__tcp_trf) {
;                 fprintf(__tcp_trs, "[DHCP-Reusing %s]", inet_ntoa(confnet.cdn_ip_addr));
;             }
; #endif
;             NutNetIfConfig2(name, confnet.cdn_mac, confnet.cdn_ip_addr, confnet.cdn_ip_mask, confnet.cdn_gateway);
	lds R4,_confnet+24+2
	lds R5,_confnet+24+2+1
	lds R2,_confnet+24
	lds R3,_confnet+24+1
	std y+8,R2
	std y+9,R3
	std y+10,R4
	std y+11,R5
	lds R4,_confnet+20+2
	lds R5,_confnet+20+2+1
	lds R2,_confnet+20
	lds R3,_confnet+20+1
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
	lds R4,_confnet+16+2
	lds R5,_confnet+16+2+1
	lds R2,_confnet+16
	lds R3,_confnet+16+1
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldi R18,<_confnet+10
	ldi R19,>_confnet+10
	ldd R16,y+34
	ldd R17,y+35
	xcall _NutNetIfConfig2
;             return 0;
	clr R16
	clr R17
	xjmp L309
L341:
;         }
;     }
L335:
;     return -1;
	ldi R16,-1
	ldi R17,-1
L309:
	.dbline 0 ; func end
	adiw R28,24
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
;        timeout -> y+6
;           name -> R10,R11
	.even
_NutDhcpRelease::
	st -y,r19
	st -y,r18
	st -y,R10
	st -y,R11
	movw R10,R16
	sbiw R28,4
; }
; 
; /*!
;  * \brief Relinguish our DHCP lease.
;  *
;  * This function may be called by the application if we are moving
;  * to another network. It helps the DHCP server to tidy up his
;  * allocation table, but is not a required DHCP function.
;  *
;  * Upon return, the system should be shut down within 20 seconds.
;  *
;  * The client must reside in state \ref DHCPST_BOUND.
;  *
;  * \param name    Name of the registered Ethernet device, currently ignored.
;  * \param timeout Maximum number of milliseconds to wait.
;  *
;  * \return 0 on success or -1 in case of an error.
;  */
; int NutDhcpRelease(CONST char *name, u_long timeout)
; {
;     /* Check the state. */
;     if (dhcpState != DHCPST_BOUND) {
	lds R24,_dhcpState
	cpi R24,5
	breq L350
X212:
;         dhcpError = DHCPERR_STATE;
	ldi R24,3
	ldi R25,0
	sts _dhcpError+1,R25
	sts _dhcpError,R24
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L349
L350:
;     }
; 
;     /* Action! */
;     return DhcpKick(name, DHCPST_RELEASING, timeout);
	ldd R2,y+6
	ldd R3,y+7
	ldd R4,y+8
	ldd R5,y+9
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldi R18,9
	movw R16,R10
	xcall _DhcpKick
L349:
	.dbline 0 ; func end
	adiw R28,4
	ld R11,y+
	ld R10,y+
	adiw R28,2
	ret
;        timeout -> y+6
;           name -> R10,R11
	.even
_NutDhcpInform::
	st -y,r19
	st -y,r18
	st -y,R10
	st -y,R11
	movw R10,R16
	sbiw R28,4
; }
; 
; /*!
;  * \brief Inform DHCP about an allocated address.
;  *
;  * The client must reside in state \ref DHCPST_IDLE.
;  *
;  * \param name    Name of the registered Ethernet device, currently ignored.
;  * \param timeout Maximum number of milliseconds to wait.
;  *
;  * \return 0 on success or -1 in case of an error.
;  */
; int NutDhcpInform(CONST char *name, u_long timeout)
; {
;     /* Check the state. */
;     if (dhcpState != DHCPST_IDLE) {
	lds R2,_dhcpState
	tst R2
	breq L353
X213:
;         dhcpError = DHCPERR_STATE;
	ldi R24,3
	ldi R25,0
	sts _dhcpError+1,R25
	sts _dhcpError,R24
;         return -1;
	ldi R16,-1
	ldi R17,-1
	xjmp L352
L353:
;     }
; 
;     /* Action! */
;     return DhcpKick(name, DHCPST_INFORMING, timeout);
	ldd R2,y+6
	ldd R3,y+7
	ldd R4,y+8
	ldd R5,y+9
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldi R18,8
	movw R16,R10
	xcall _DhcpKick
L352:
	.dbline 0 ; func end
	adiw R28,4
	ld R11,y+
	ld R10,y+
	adiw R28,2
	ret
;           name -> R16,R17
	.even
_NutDhcpStatus::
; }
; 
; /*!
;  * \brief Return DHCP client status.
;  *
;  * \param name Name of the registered Ethernet device, currently ignored.
;  *
;  * \return DHCP status code, which may be any of the following:
;  *         - \ref DHCPST_INIT
;  *         - \ref DHCPST_SELECTING
;  *         - \ref DHCPST_REQUESTING
;  *         - \ref DHCPST_REBOOTING
;  *         - \ref DHCPST_BOUND
;  *         - \ref DHCPST_RENEWING
;  *         - \ref DHCPST_REBINDING
;  *         - \ref DHCPST_INFORMING
;  *         - \ref DHCPST_RELEASING
;  *         - \ref DHCPST_IDLE
;  */
; int NutDhcpStatus(CONST char *name)
; {
;     return dhcpState;
	lds R16,_dhcpState
	clr R17
L355:
	.dbline 0 ; func end
	ret
;             rc -> R10,R11
;           name -> R16,R17
	.even
_NutDhcpError::
	st -y,R10
	st -y,R11
; }
; 
; /*!
;  * \brief Return DHCP error code.
;  *
;  * Possible error codes are
;  *
;  *         - \ref DHCPERR_TIMEOUT
;  *         - \ref DHCPERR_NOMAC
;  *         - \ref DHCPERR_BADDEV
;  *         - \ref DHCPERR_SYSTEM
;  *         - \ref DHCPERR_TRANSMIT
;  *         - \ref DHCPERR_RECEIVE
;  *
;  * The error will be cleared upon return.
;  *
;  * \param name Name of the registered Ethernet device, currently ignored.
;  *
;  * \return DHCP error code or 0 if no error occured.
;  */
; int NutDhcpError(CONST char *name)
; {
;     int rc = dhcpError;
	lds R10,_dhcpError
	lds R11,_dhcpError+1
;     dhcpError = 0;
	clr R2
	clr R3
	sts _dhcpError+1,R3
	sts _dhcpError,R2
;     return rc;
	movw R16,R10
L356:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
	.even
_NutDhcpIsConfigured::
; }
; 
; /*!
;  * \brief Check if DHCP has configured our interface 
;  *
;  * \deprecated Applications should use NutDhcpStatus().
;  *
;  * \return 0 if DHCP is in bound state.
;  */
; int NutDhcpIsConfigured(void)
; {
;     return (dhcpState == DHCPST_BOUND);
	lds R24,_dhcpState
	cpi R24,5
	brne L358
X214:
	ldi R16,1
	ldi R17,0
	xjmp L359
L358:
	clr R16
	clr R17
L359:
L357:
	.dbline 0 ; func end
	ret
	.area bss(ram, con, rel)
_dhcpApiStart:
	.blkb 4
_dhcpApiTimeout:
	.blkb 4
_dhcpDone:
	.blkb 2
_dhcpWake:
	.blkb 2
_dhcpError:
	.blkb 2
_dhcpState:
	.blkb 1
_dhcpThread:
	.blkb 2
_dhcpConfig:
	.blkb 2
	.area data(ram, con, rel)
L308:
	.blkb 6
	.area idata
	.byte 'd,'h,'c,'p,'c,0
	.area data(ram, con, rel)
; }
; 
; /*@}*/
	.area func_lit
PL_NutDhcpClient:	.word `_NutDhcpClient
